PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132.
DO IF ($casenum=1).
   PRINT /'Macro !MAR V2014.05.26 loaded.'
         /'Execute !MAR HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !MAR ( NumST=!CHAREND('/')
              /DATA=!CHAREND('/')!DEFAULT('RAW') 
              /STAT=!CHAREND('/')!DEFAULT('OR') 
            /METHOD=!CHAREND('/')!DEFAULT('FEM')
                /CL=!CHAREND('/')!DEFAULT('95')
              /Zero=!CHAREND('/')!DEFAULT('N')  
               /SCL=!CHAREND('/')!DEFAULT(1)
              /PROP=!CHAREND('/')
               /CUM=!CHAREND('/')
               /VAR=!CHAREND('/')
             /GRAPH=!CHAREND('/')
             /PRINT=!CHAREND('/')
               /NST=!CHAREND('/')
              /KEEP=!CHAREND('/')!DEFAULT(1) 
              /HELP=!CHAREND('/')!DEFAULT(1)).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132.
!LET !VERSION=!QUOTE('2014.05.26').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
   PRINT //'Macro !MAR V' !VERSION ' (c)JM.Domenech'.
END IF.

!IF (!HELP<>1) !THEN.
*  Print HELP.
   DO IF ($casenum=1).
      PRINT /'****************************************************************************************'
            /'* META-ANALYSIS: OR,RR,RD,IR,ID,B,MD COMBINED                                          *'
            /'* Created 05.13.2000 Last revised ' !VERSION                                          '*'88
            /'* (c) JM.Domenech                                                                      *'
            /'* Programmer: R.Sesma                                                                  *'
            /'*                                                                                      *'
            /'* Vancouver reference:                                                                 *'
            /'* Domenech JM. Macro !MAR for SPSS Statistics.                                         *'
            /'*    Meta-Analysis OR, RR, RD, IR, ID, B & MD Combined [computer program].             *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.'        '*'88
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                             *'
            /'*                                                                                      *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                                        *'
            /'* !MAR NumSt= Number of studies in the Meta-Analysis                                   *'
            /'*    [/DATA]= Type of data matrix:                                                     *'
            /'*             RAW - Raw data;  default                                                 *'
            /'*                   Variable names for RAW Data matrix:                                *'
            /'*                   STUDY : Study name              (String;  <=8 characters)          *'
            /'*                    RANK : Study rank (i.e. year)  (Numeric; F6.1)                    *'
            /'*                      A1 : Cases Exposed                                              *'
            /'*                     {B1 : NonCases Exposed    (If STAT= OR, RR or RD)                *'
            /'*                   or T1}: Person-time Exposed     (If STAT= IR or ID)                *'
            /'*                      A0 : Cases UnExposed                                            *'
            /'*                     {B0 : NonCases UnExposed  (If STAT= OR, RR or RD)                *'
            /'*                   or T0}: Person-time UnExposed   (If STAT= IR or ID)                *'
            /'*                   [PROP]: Proportion of Exposure/Response                            *'
            /'*             SCI - Summary Statistic with Confidence Interval                         *'
            /'*                   Variable names for SCI Data matrix:                                *'
            /'*                   STUDY : Study name              (String;  <=8 characters)          *'
            /'*                    RANK : Study rank (i.e. year)  (Numeric; F6.1)                    *'
            /'*                    {ODR : Odds Ratio                                                 *'
            /'*                   or RR : Relative Risk                                              *'
            /'*                   or IR : Rate Ratio                                                 *'
            /'*                   or RD : Risk difference                                            *'
            /'*                   or ID : Rate difference                                            *'
            /'*                    or B : Slope                                                      *'
            /'*                   or MD}: Mean difference                                            *'
            /'*                      LO : Lower bound of Risk measure CI                             *'
            /'*                      UP : Upper bound of Risk measure CI                             *'
            /'*                    [SCL]: Summary Confidence interval level(%); by default:95        *'
            /'*                      [N]: Study size (needed for some procedures and plots)          *'
            /'*                   [PROP]: Proportion of Exposure/Response                            *'
            /'*             SSE - Summary Statistic with Standard Error                              *'
            /'*                   Variable names for SSE Data matrix:                                *'
            /'*                   STUDY : Study name              (String;  <=8 characters)          *'
            /'*                    RANK : Study rank (i.e. year)  (Numeric; F6.1)                    *'
            /'*                    {ODR : Odds Ratio                                                 *'
            /'*                   or RR : Relative Risk                                              *'
            /'*                   or IR : Rate Ratio                                                 *'
            /'*                   or RD : Risk difference                                            *'
            /'*                   or ID : Rate difference                                            *'
            /'*                    or B : Slope                                                      *'
            /'*                   or MD}: Mean difference                                            *'
            /'*                      SE : Standard error of Risk measure: SE(lnOR);                  *'
            /'*                           SE(lnRR); SE(lnIR); SE(RD); SE(ID); SE(b) ; SE(MD)         *'
            /'*                      [N]: Study size (needed for some procedures and plots)          *'
            /'*                   [PROP]: Proportion of Exposure/Response                            *'
            /'* *** Parameters only for RAW Data matrix *********************************            *'
            /'*    [/Zero]= Continuity correction for cells with zero events                         *'
            /'*                  N (None)                             by default: N                  *'
            /'*                  C (Constant, add k=0.5 to each cell)                                *'
            /'*                  P (Proportional, add k1= N1/N and k0=N0/N)                          *'
            /'*             E(ORw) (Empirical, add k1= ORw*N1/(N0 + ORw*N1)                          *'
            /'*                                and k0= N0/(N0 + ORw*N1)                              *'
            /'* *** Parameters only for SCI Data matrix *********************************            *'
            /'*     [/SCL] Data Matrix includes SCL variable containing                              *'
            /'*             the CI level(%) for each study;     by default: CI level= 95%            *'
            /'* *** Parameters for ALL Data matrix **************************************            *'
            /'*    [/STAT]= Risk Measure:      Odds Ratio: OR (default)                              *'
            /'*                             Relative Risk: RR                                        *'
            /'*                                Rate Ratio: IR                                        *'
            /'*                           Risk difference: RD                                        *'
            /'*                           Rate difference: ID                                        *'
            /'*                                     Slope:  B                                        *'
            /'*                           Mean difference: MD                                        *'
            /'*  [/METHOD]= Method of weighting of the combined statistic included in Influence      *'
            /'*              Analysis, Cumulative meta-analysis, bias and in some Plots:             *'
            /'*                  FEM  IoV Fixed Effects Model (default)                              *'
            /'*                  REM  IoV Random Effects Model                                       *'
            /'*                   MH  Mantel-Haenszel method    (available for data type RAW)        *'
            /"*                 Peto  Peto's odds ratio method  (available for data type RAW)        *"
            /'*                NOTE: The macro computes weighted statistic for each method.          *'
            /'*       [/CL]= Confidence level(%) of CI weighted statistic; by default:95 (50<CL<100) *'
            /'*     [/PROP]= Compute proportion of Exposure/Response:                                *'
            /'*                 Data  PROP variable is included in data matrix                       *'
            /'*                 Expo  Exposure in Total sample (N1/N or T1/T) (RAW data is required) *'
            /'*                ExCtr  Exposure in Controls (B1/M0)            (RAW data is required) *'
            /'*                 Resp  Response in Total sample (M1/N or M1/T) (RAW data is required) *'
            /'*                ReUex  Response in UnExposed (A0/N0 or A0/T0)  (RAW data is required) *'
            /'*    [/PRINT]= List of printing options:                                               *'
            /'*               Tables  Print Crosstab tables (Only for RAW data)                      *'
            /'*                Influ  Print Influence Analysis                                       *'
            /'*                 W[pt] Print studies weights in pt for graphical representations      *'
            /'*                       pt is the minimum marker size      by default: pt=5            *'
            /"*                       Is needed for editing markers of Forest and l'Abb graph       *"
            /'*                 Begg  Print Begg publication bias      (parameter METHOD is needed)  *'
            /'*                Egger  Print Egger publication bias                                   *'
            /'*               Macask  Print Macaskill publication bias                               *'
            /'*                       (variables PROP and N are needed)                              *'
            /'*             NUS.Pcut  Print Number of Unpublished Studies.                           *'
            /'*                       Pcut is the maximum of the smallest p-values (Pcut<1)          *'
            /'*     [/CUM]= Print Cumulative meta-analysis.            (parameter METHOD is needed)  *'
            /'*                 Rank  Studies are accumulated according to the RANK order            *'
            /'*                 Prop  Studies are accumulated according to the PROP order            *'
            /'*                       (parameter PROP is required for CUM=Prop)                      *'
            /'*   [/GRAPH]= Graphics list:                                                           *'
            /'*                  Cum  Cumulative meta-analysis                                       *'
            /'*                       (Parameters METHOD, CUM & RANK variable are needed)            *'
            /'*             Interval  Interval plot (sorted by SE)     (parameter METHOD is needed)  *'
            /'*               Forest  Forest plot        (parameters PRINT=W and METHOD are needed)  *'
            /'*                 Hist  Weighted Histogram                                             *'
            /'*               Radial  Radial plot        (parameter METHOD is needed)                *'
            /"*                 Abbe  l'Abb plot        (parameter PRINT=W & RAW data are needed)   *"
            /'*              IntPlot  Interval plot                                                  *'
            /'*                 Galb  Radial plot for assessing heterogeneity                        *'
            /'*                 Tree  Funnel or Christmas tree plot for assessing bias               *'
            /'*                       (variable N is needed for SCI or SSE matrix data type)         *'
            /'*             WARNING: All these graphics must be edited                               *'
            /'*     [/KEEP] Create a dataset named Data_MAR with the macro results.                  *'
            /'*             If not present, no dataset is created.                                   *'
            /'*     [/VAR]= Additional variable list to save in the Data_MAR dataset.                *'
            /'*             Variables not used by the macro, available for later computations.       *'
            /'*     [/NST]= Name of the meta-analysis                (<=120 characters)              *'
            /'*             This label must be enclosed in a set of apostrophes                      *'
            /'*     [/HELP] Print Macro call arguments and Samples of calls                          *'
            /'*                                                                                      *'
            /'* Note 1: Parameters enclosed in Square Brackets [ ] are optional.                     *'
            /'*                                                                                      *'
            /'* For running this Macro the active data file must be one of the following:            *'
            /'* DATA MATRIX Type RAW (Raw data):                                                     *'
            /'*  STUDY      RANK  A1  B1  A0  B0  <- Variable names                                  *'
            /'*  Vandenb1   1998  71 168 157 134  <- Data                                            *'
            /'*  Allebeck   1999  22  96  56  54                                                     *'
            /'*  ........ ...... ... ... ... ...                                                     *'
            /'*                                                                                      *'
            /'* DATA MATRIX Type SCI (Statistic & confidence interval). Example for STAT=OR:         *'
            /'*  STUDY      RANK  ODR   LO   UP SCL   N PROP <- Variable names (SCL, N & PROP are    *'
            /'*  Vandenb1 1998,0 0,40 0,22 0,72  95 129 .237 <- Data                     optional)   *'
            /'*  Allebeck 1998,1 0,70 0,40 1,24  95 472 .159                                         *'
            /'*  ........ ...... .... .... ....  .. ... ....                                         *'
            /'*                                                                                      *'
            /'* DATA MATRIX Type SSE (Statistic & standard error). Example for STAT=B:               *'
            /'*  STUDY    RANK         B     SE    N     <- Variable names (N is optional)           *'
            /'*  Vatten          -0,1030 0,0287  278     <- Data                                     *'
            /'*  Tornberg        -0,0513 0,0241  311                                                 *'
            /'*  ........ ...... ....... ......  ...                                                 *'
            /'*                                                                                      *'
            /'* WARNING: Macro works with ALL cases (filtered and non-filtered cases).               *'
            /'*          For working with a set of studies you must use SELECT IF procedure          *'
            /'*          in order to create a new data file containing only selected studies.        *'
            /'*                                                                                      *'
            /'* Samples of calls:                                                                    *'
            /'*  !MAR HELP.                                                                          *'
            /'*  !MAR NST="Anticonceptivos orales y adenocarcinoma de cuello uterino"                *'
            /'*      /NumSt=3 /DATA=SCI /SCL /STAT=OR /METHOD=REM /CL=95 /PROP=Data                  *'
            /'*      /PRINT=Influ W6 Macask /CUM=Prop /GRAPH=Cum Forest Tree.                        *'
            /'*  !MAR NumSt=9 /DATA=RAW /Zero=E(2.1078) /STAT=RR /METHOD=MH /CL=95 /PROP=Resp        *' 
            /'*      /PRINT=Influ W Macask NUS.06 /GRAPH=Abbe Tree /KEEP /VAR=Quality Smoke.         *'
            /'*  !MAR NumSt=11 /DATA=SCI /STAT=OR /CL=95 /SCL /PRINT=W NUS.1 /CUM=Rank               *'
            /"*      /GRAPH=Cum Tree /NST='Cocaine08'.                                               *"
            /'*  !MAR NumSt=8 /DATA=SSE /STAT=RR /METHOD=REM /CL=95 /GRAPH= Tree Interval.           *'
            /'****************************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.   
*  Testing the parameters.
   !LET !ERROR=0.
*  Param !NumST can't be !NULL.
   !IF (!NumST=!NULL) !THEN.
      !LET !ERROR=1.
   !IFEND.
*  Test parameters DATA, STAT, METHOD, PROP, CUM, Zero: correct values.
   !LET !DATAU=!UPCASE(!DATA).
   !LET !STATU=!UPCASE(!STAT).
   !LET !METHODU=!UPCASE(!METHOD).
   !LET !ZeroU=!UPCASE(!Zero).
   !LET !PROPU=!UPCASE(!PROP).
   !LET !CUMU=!UPCASE(!CUM).
   !IF (!DATAU<>'RAW' !AND !DATAU<>'SCI' !AND !DATAU<>'SSE') !THEN.
      !LET !ERROR=2.
      !LET !ErrorP='DATA'.
   !IFEND.
   !IF (!STATU<>'OR' !AND !STATU<>'RR' !AND !STATU<>'IR' !AND !STATU<>'RD' !AND !STATU<>'ID' !AND !STATU<>'B' !AND !STATU<>'MD') !THEN.
      !LET !ERROR=2.
      !LET !ErrorP='STAT'.
   !IFEND.
   !IF (!METHODU<>'FEM' !AND !METHODU<>'REM' !AND !METHODU<>'MH' !AND !METHODU<>'PETO') !THEN.
      !LET !ERROR=2.
      !LET !ErrorP='METHOD'.
   !IFEND.
   !IF (!PROPU<>!NULL !AND !PROPU<>'DATA' !AND !PROPU<>'EXPO' !AND !PROPU<>'EXCTR' !AND !PROPU<>'RESP' !AND !PROPU<>'REUEX') !THEN.
      !LET !ERROR=2.
      !LET !ErrorP='PROP'.
   !IFEND.
   !IF (!CUMU<>!NULL !AND !CUMU<>'RANK' !AND !CUMU<>'PROP') !THEN.
      !LET !ERROR=2.
      !LET !ErrorP='CUM'.
   !IFEND.
   !IF (!ZeroU<>'N' !AND !ZeroU<>'C' !AND !ZeroU<>'P' !AND !SUBSTR(!ZeroU,1,1)<>'E') !THEN.
      !LET !ERROR=2.
      !LET !ErrorP='Zero'.
   !IFEND.
*  For METHOD=MH 2x2 table with STAT=OR,RR,IR is needed.
   !IF (!ERROR=0 !AND !METHODU='MH' !AND (!DATAU<>'RAW' !OR (!STATU<>'OR' !AND !STATU<>'RR' !AND !STATU<>'IR'))) !THEN.
      !LET !ERROR=3.
   !IFEND.
*  For METHOD=PETO 2x2 table with STAT=OR is needed.
   !IF (!ERROR=0 !AND !METHODU='PETO' !AND (!DATAU<>'RAW' !OR !STATU<>'OR')) !THEN.
      !LET !ERROR=4.
   !IFEND.
*  For STAT=B or MD Summary Statistics (DATA=SCI or SSE) is needed.
   !IF (!ERROR=0 !AND (!STATU='B' !OR !STATU='MD') !AND (!DATAU<>'SCI' !AND !DATAU<>'SSE')) !THEN.
      !LET !ERROR=5.
   !IFEND.
*  For PROP=EXPO, EXCTR, RES 2x2 table (DATA=RAW) is needed.
   !IF (!ERROR=0 !AND !DATAU<>'RAW' !AND (!PROPU='EXPO' !OR !PROPU='EXCTR' !OR !PROPU='RESP' !OR !PROPU='REUEX')) !THEN.
      !LET !ERROR=6.
   !IFEND.
*  PROP=EXCTR is incompatible with STAT=IR, RD.
   !IF (!ERROR=0 !AND !PROPU='EXCTR' !AND (!STATU='IR' !OR !STATU='ID')) !THEN.
      !LET !ERROR=7.
   !IFEND.
*  CUM=PROP requires PROP parameter.
   !IF (!ERROR=0 !AND !CUMU='PROP' !AND !PROP=!NULL) !THEN.
      !LET !ERROR=8.
   !IFEND.
*  Check PRINT values.
   !IF (!ERROR=0 !AND !PRINT<>!NULL) !THEN.
      !LET !PRINTU=!UPCASE(!PRINT).
      !DO !I !IN (!PRINTU).
         !LET !PrintW=!SUBSTR(!I,1,1).
         !IF (!LENGTH(!I)>=3) !THEN.
            !LET !PrintNUS=!SUBSTR(!I,1,3).
         !IFEND.
         !IF (!I<>'TABLES' !AND !I<>'INFLU' !AND !I<>'BEGG' !AND !I<>'EGGER' !AND !I<>'MACASK' !AND !PrintW<>'W' !AND !PrintNUS<>'NUS') !THEN.
            !LET !ERROR=9.
            !LET !ErrorP='PRINT'.
            !LET !ErrorV=!I.
         !IFEND.
      !DOEND.
   !IFEND.
*  Check GRAPH values.
   !IF (!ERROR=0 !AND !GRAPH<>!NULL) !THEN.
      !LET !GRAPHU=!UPCASE(!GRAPH).
      !DO !I !IN (!GRAPHU).
         !IF (!I<>'CUM' !AND !I<>'INTERVAL' !AND !I<>'FOREST' !AND !I<>'HIST' !AND !I<>'RADIAL' !AND !I<>'ABBE' !AND !I<>'INTHET' !AND !I<>'INTPLOT' !AND !I<>'GALB' !AND !I<>'TREE') !THEN.
            !LET !ERROR=9.
            !LET !ErrorP='GRAPH'.
            !LET !ErrorV=!I.
         !IFEND.
      !DOEND.
   !IFEND.
   
!IF (!ERROR<>0) !THEN.
   !IF (!ERROR=1) !THEN.
      DO IF ($CASENUM=1).
         PRINT /'ERROR: Missing parameter'.
      END IF.
   !IFEND.
   !IF (!ERROR=2) !THEN.
      DO IF ($CASENUM=1).
         PRINT /'ERROR: Parameter ' !QUOTE(!ErrorP) ' with wrong values. See the HELP.'.
      END IF.
   !IFEND.
   !IF (!ERROR=3) !THEN.
      DO IF ($CASENUM=1).
         PRINT /'ERROR: For METHOD=MH, Raw Data and STAT=OR, RR or IR is needed.'.
      END IF.
   !IFEND.
   !IF (!ERROR=4) !THEN.
      DO IF ($CASENUM=1).
         PRINT /'ERROR: For METHOD=PETO, Raw Data and STAT=OR is needed.'.
      END IF.
   !IFEND.
   !IF (!ERROR=5) !THEN.
      DO IF ($CASENUM=1).
         PRINT /'ERROR: For STAT=B or MD, Summary Statistics (DATA=SCI or SSE) is needed.'.
      END IF.
   !IFEND.
   !IF (!ERROR=6) !THEN.
      DO IF ($CASENUM=1).
         PRINT /'ERROR: For PROP=Expo or ExCtr or Resp, Raw Data is needed.'.
      END IF.
   !IFEND.
   !IF (!ERROR=7) !THEN.
      DO IF ($CASENUM=1).
         PRINT /'ERROR: PROP=ExCtr is incompatible with STAT=IR or STAT=ID.'.
      END IF.
   !IFEND.
   !IF (!ERROR=8) !THEN.
      DO IF ($CASENUM=1).
         PRINT /'ERROR: For CUM=Prop, PROP parameter is needed.'.
      END IF.
   !IFEND.
   !IF (!ERROR=9) !THEN.
      DO IF ($CASENUM=1).
         PRINT /'ERROR: Value ' !QUOTE(!ErrorV) ' is not valid for parameter ' !QUOTE(!ErrorP) '.'.
      END IF.
   !IFEND.
!ELSE.
*  Make a copy of the original data to work with.
   DATASET NAME Original.
   DATASET COPY Data_MAR.
   DATASET ACTIVATE Data_MAR WINDOW=ASIS.

   !LET !COUNT=!NumST.                 /*Number of studies.

   COMPUTE @ERROR=0.

*  Get @TYPE from !DATA.
   COMPUTE @TYPE =0.
   !IF (!DATAU='RAW') !THEN.
      COMPUTE @TYPE = 1.               /*@TYPE = 1 for 2x2 table (individual data).
   !ELSE.
      !IF (!DATAU='SSE') !THEN.
         COMPUTE @TYPE = 2.            /*@TYPE = 2 for aggregated data + SE.
      !ELSE.
         !IF (!DATAU='SCI') !THEN.
            COMPUTE @TYPE = 3.         /*@TYPE = 3 for aggregated data + CI.
         !IFEND.
      !IFEND.
   !IFEND.
      
*  Get @STAT from !STAT.
   COMPUTE @STAT =0.
   !IF (!STATU='OR') !THEN.
      COMPUTE @STAT = 1.                  /*@STAT = 1 for OR.
   !ELSE.
      !IF (!STATU='RR') !THEN.
         COMPUTE @STAT = 2.               /*@STAT = 2 for RR.
      !ELSE.
         !IF (!STATU='IR') !THEN.
            COMPUTE @STAT = 3.            /*@STAT = 3 for IR.
         !ELSE.
            !IF (!STATU='RD') !THEN.
               COMPUTE @STAT = 4.         /*@STAT = 4 for RD.
            !ELSE.
               !IF (!STATU='ID') !THEN.
                  COMPUTE @STAT = 5.      /*@STAT = 5 for ID.
               !ELSE.
                  !IF (!STATU='B' !OR !STATU='MD') !THEN.
                     COMPUTE @STAT = 6.   /*@STAT = 6 for B or MD.
                  !IFEND.                  
               !IFEND.
            !IFEND.
         !IFEND.
      !IFEND.
   !IFEND.

*  Get @METHOD from !METHOD.
   COMPUTE @METHOD = 0.
   !IF (!METHODU='FEM') !THEN.
      COMPUTE @METHOD = 1.                /*@METHOD = 1 for FEM.
   !ELSE.
      !IF (!METHODU='REM') !THEN.
         COMPUTE @METHOD = 2.             /*@METHOD = 2 for REM.
      !ELSE.
         !IF (!METHODU='MH') !THEN.
            COMPUTE @METHOD = 3.          /*@METHOD = 3 for MH.
         !ELSE.
            !IF (!METHODU='PETO') !THEN.
               COMPUTE @METHOD = 4.       /*@METHOD = 4 for PETO.
            !IFEND.
         !IFEND.
      !IFEND.
   !IFEND.

*  Get !TABLES, !INFLU, !WEIGHT (and @PT), !BEGG, !EGGER, !MACASK, !NUS (and @Pcut) from !PRINT.
   !LET !TABLES=0.
   !LET !INFLU=0.
   !LET !WEIGHT=!NULL.
   !LET !BEGG=!NULL.
   !LET !EGGER=!NULL.
   !LET !MACASK=!NULL.
   !LET !NUS=!NULL.
   COMPUTE @PT=$SYSMIS.
   !IF (!PRINT<>!NULL) !THEN.
      !LET !PRINTU=!UPCASE(!PRINT).
      !DO !I !IN (!PRINTU).
         !IF (!I='TABLES') !THEN.
*           Print 2x2 tables (only for DATA=RAW).
            !LET !TABLES=1.
         !ELSE.
            !IF (!I='INFLU') !THEN.
*              Print Influence Analysis.
               !LET !INFLU=1.
            !ELSE.
               !IF (!I='BEGG') !THEN.
*                 Print Begg publication bias.
                  !LET !BEGG=1.
               !ELSE.
                  !IF (!I='EGGER') !THEN.
*                     Print Egger publication bias.
                     !LET !EGGER=1.
                  !ELSE.
                     !IF (!I='MACASK') !THEN.
*                       Print Macaskill publication bias.
                        !LET !MACASK=1.
                     !ELSE.
                        !LET !PT=!SUBSTR(!I,1,1).
                        !IF (!PT='W') !THEN.
*                          Print table with weights - read the size provided.
                           !LET !WEIGHT=1.
                           !IF (!LENGTH(!I)<>1) !THEN.
                              !LET !PT=!SUBSTR(!I,2).
                              COMPUTE @PT=!PT.
                              DO IF (SYSMIS(@PT)).
                                 COMPUTE @ERROR=1.
                              ELSE.
                                 IF (@PT<=0 OR MOD(@PT,1)<>0) @ERROR=1.    /*Check size provided.
                              END IF.
                           !ELSE.
                              COMPUTE @PT=5.    /*Default weight.
                           !IFEND.
                        !ELSE.
                           !IF (!SUBSTR(!I,1,3)='NUS') !THEN.
*                             Print number of unpublished studies - read Pcut provided.
                              !LET !NUS=1.
                              !LET !Pcut=!SUBSTR(!I,4).
                              COMPUTE @Pcut0=!Pcut.
                              DO IF (SYSMIS(@Pcut0)).
                                 COMPUTE @ERROR=1.
                              ELSE.
                                 IF (@Pcut0<=0 OR @Pcut0>0.50) @ERROR=1.    /*Check Pcut provided.
                              END IF.
                           !IFEND.
                        !IFEND.
                     !IFEND.
                  !IFEND.
               !IFEND.
            !IFEND.
         !IFEND.
      !DOEND.
   !IFEND.
*  If ABBE or FOREST plot asked, always print the sizes table.
   !LET !GRAPHU=!UPCASE(!GRAPH).
   !IF (!WEIGHT=!NULL) !THEN.
      !DO !I !IN (!GRAPHU).
         !IF (!UNQUOTE(!I)='FOREST' !OR !UNQUOTE(!I)='ABBE') !THEN.
            !LET !WEIGHT=1.
            COMPUTE @PT=5.
         !IFEND.
      !DOEND.
   !IFEND.
*  Get PrintCUM, VarCUM, FormatCUM values.
   !LET !PrintCUM=!NULL.
   !IF (!CUM<>!NULL) !THEN.
      !LET !PrintCUM=1.
      !IF (!CUMU='RANK') !THEN.
         !LET !VarCUM='RANK'.
         !LET !FormatCUM='F6.1'.
      !IFEND.
      !IF (!CUMU='PROP') !THEN.
         !LET !VarCUM='PROP'.
         !LET !FormatCUM='F6.5'.
      !IFEND.
   !IFEND.
   
*  Get @Zero (and @ORw) from !Zero.
   COMPUTE @Zero=0.
   COMPUTE @ORw=$SYSMIS.
   !IF (!ZeroU<>'N') !THEN.
      !IF (!ZeroU='C') !THEN.
         COMPUTE @Zero=1.           /*Constant Zero correction.
      !ELSE.
         !IF (!ZeroU='P') !THEN.
            COMPUTE @Zero=2.        /*Proportional Zero correction.
         !ELSE.
            !IF (!SUBSTR(!ZeroU,1,1)='E') !THEN.   /*Empirical Zero correction: read the ORw provided.
               COMPUTE @Zero=3.
               !IF (!SUBSTR(!ZeroU,2,1)='(') !THEN.
                  !LET !ORw=!SUBSTR(!ZeroU,3).
                  !LET !LEN=!LENGTH(!ORw).
                  !LET !SUB=!NULL.
                  !DO !I=1 !TO !LEN.
                     !IF (!I<>!LEN) !THEN.
                        !LET !SUB=!CONCAT(!SUB,' ').
                     !IFEND.
                  !DOEND.
                  !LET !SUB=!LENGTH(!SUB).
                  !LET !ORw=!SUBSTR(!ORw,1,!SUB).
                  COMPUTE @ORw=!ORw.
                  DO IF (SYSMIS(@ORw)).
                     COMPUTE @ERROR=1.
                  ELSE.
                     IF (@ORw<=0) @ERROR=1.    /*Check ORw provided.
                  END IF.
               !ELSE.
                  COMPUTE @ERROR=1.
               !IFEND.
            !IFEND.               
         !IFEND.
      !IFEND.
   !IFEND.

*  Check parameter CL.
   COMPUTE @CL=$SYSMIS.                   
   COMPUTE @CL=!CL.
   DO IF SYSMIS(@CL).
      COMPUTE @ERROR=1.
   ELSE.
      IF (@CL<=50 OR @CL>=100) @ERROR=1.
   END IF.

   DO IF (@ERROR=1 AND $CASENUM=1).
      PRINT /'ERROR: Parameter(s) with wrong values'.
   END IF.

*  Check NumSt parameter and SELECT the number of studies.
   COMPUTE @1=1.
   COMPUTE @NumSt=!NumSt.
   COMPUTE @Seq=$casenum.
   AGGREGATE /OUTFILE=* MODE=ADDVARIABLES OVERWRITE=YES /BREAK=@1 /@NumStmax=MAX(@Seq).
   SELECT IF (@Seq<=!NumSt).
   EXECUTE.
   TEMPORARY.
   N 1.
   DO IF (@NumStMax>@NumSt).
      PRINT //'**********************************************************************'.
      PRINT  /'WARNING: The number of studies on the data file is ' @NumStMax(F2.0) '.'.
      PRINT  /'         The value of the !NumSt parameter is lower, ' !QUOTE(!NumSt) '.'.
      PRINT  /'         Only the first ' !QUOTE(!NumSt) ' studies have been used for the calculations.'.
      PRINT  /'**********************************************************************'.
      PRINT  /''.
   ELSE IF (@NumStMax<@NumSt).
      PRINT //'**********************************************************************'.
      PRINT  /'WARNING: The number of studies on the data file is ' @NumStMax(F2.0) '.'.
      PRINT  /'         The value of the !NumSt parameter is greater, ' !QUOTE(!NumSt) '.'.
      PRINT  /'         Some of the results may be wrong.'.
      PRINT  /'**********************************************************************'.
      PRINT  /''.
   END IF.
   EXECUTE.
   
***PRINT header and NST if available.
   DO IF (@ERROR=0).
      DO IF ($CASENUM=1).
         PRINT /'META-ANALYSIS: OR,RR,RD,IR,ID,B,MD COMBINED'.
         !IF (!NST !NE !NULL) !THEN .
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.            
         !IFEND.
         PRINT /''.
      END IF.
      COMPUTE @Z=IDF.NORMAL((!CL+100)/200,0,1).
      COMPUTE @1=1.

      COMPUTE NumESMHi=$SYSMIS.
      COMPUTE DenESMHi=$SYSMIS.
      COMPUTE NumSEi=$SYSMIS.
      COMPUTE DenSE1i=$SYSMIS.
      COMPUTE DenSE2i=$SYSMIS.
      COMPUTE Si=$SYSMIS.
      COMPUTE Ri=$SYSMIS.
      COMPUTE PRi=$SYSMIS.
      COMPUTE PSQRi=$SYSMIS.
      COMPUTE QSi=$SYSMIS.
      COMPUTE SUMOEi=$SYSMIS.
      COMPUTE SUMVi=$SYSMIS.
      COMPUTE WMH=$SYSMIS.
      COMPUTE ORp=$SYSMIS.
      COMPUTE V=$SYSMIS.
      COMPUTE LOp=$SYSMIS.
      COMPUTE UPp=$SYSMIS.


      STRING @EStitle (A2) @TITLE (A12) @SEtitle (A8) @TDec (A1).        /*Compute title.
      IF (@STAT=1) @EStitle='OR'.
      IF (@STAT=2) @EStitle='RR'.
      IF (@STAT=3) @EStitle='IR'.
      IF (@STAT=4) @EStitle='RD'.
      IF (@STAT=5) @EStitle='ID'.
      IF (@STAT=6) @EStitle=' B'.
      !IF (!STATU='MD') !THEN.
         COMPUTE @EStitle='MD'.
      !IFEND.
      COMPUTE @TITLE = CONCAT(@EStitle,' (SE_ln',@EStitle,')').
      COMPUTE @SEtitle = CONCAT('SE(ln',@EStitle,')').
      IF (@STAT>3) @TITLE = CONCAT(@EStitle,' (SE)').
      IF (@STAT>3) @SEtitle = '     SE '.

      !IF (!STATU='RD' !OR !STATU='ID') !THEN.
         !LET !FORMAT='F10.8'.
         !LET !FORMAT2= 'F12.10'.
      !ELSE.
         !LET !FORMAT='F10.4'.
         !LET !FORMAT2= 'F12.4'.
      !IFEND.
   END IF.
   
   !IF (!DATAU='RAW') !THEN.             /*2x2 table data.
*     Add the GLOBAL data using AGGREGATE + ADD FILES.
      !IF (!STATU='IR' !OR !STATU='ID') !THEN.
         COMPUTE B1=$SYSMIS.
         COMPUTE B0=$SYSMIS.
      !ELSE.
         COMPUTE T1=$SYSMIS.
         COMPUTE T0=$SYSMIS.
      !IFEND.
      COMPUTE A1o= A1.                 /*Original parameters for print.
      COMPUTE A0o= A0.
      COMPUTE B1o= B1.
      COMPUTE B0o= B0.

      COMPUTE @WARNDEC=0.              /*Detect decimal values.
      IF (MOD(A1,1)<>0 OR MOD(A0,1)<>0 OR MOD(B1,1)<>0 OR MOD(B0,1)<>0) @WARNDEC=1.

      COMPUTE @K1=0.          /*Zero correction (except for IR, ID statistics).
      COMPUTE @K0=0.
      COMPUTE N1=A1+B1.
      COMPUTE N0=A0+B0.
      COMPUTE N =N1+N0.
      DO IF (@Zero=1).
         COMPUTE @K1=0.5.          /*Constant correction: K1=K0=0,5.
         COMPUTE @K0=0.5.
      ELSE IF (@Zero=2).
         COMPUTE @K1=N1/N.         /*Proportional correction: K1=N1/N,K0=N0/N.
         COMPUTE @K0=N0/N.
      ELSE IF (@Zero=3).
         COMPUTE @K1=@ORw*N1/(N0+@ORw*N1).     /*Empirical correction: K1=ORw*N1/(N0 + ORw*N1),K0=N0/(N0 + ORw*N1).
         COMPUTE @K0=N0/(N0+@ORw*N1).
      END IF.
      DO IF (ANY(@STAT,1,2,4) AND @ZERO>0 AND (A1=0 OR A0=0 OR B1=0 OR B0=0)).
         COMPUTE A1=A1+@K1.
         COMPUTE B1=B1+@K1.
         COMPUTE A0=A0+@K0.
         COMPUTE B0=B0+@K0.
         COMPUTE @WARNZERO=1.
      END IF.

      DATASET DECLARE @967N WINDOW=HIDDEN.
      AGGREGATE  /OUTFILE='@967N' /PRESORTED /BREAK=@1
        /A1=SUM(A1) /A0=SUM(A0) /B1=SUM(B1) /B0=SUM(B0) /T1=SUM(T1) /T0=SUM(T0) /COUNT=N 
        /@ERROR=LAST(@ERROR) /@TYPE=LAST(@TYPE) /@STAT=LAST(@STAT) /@METHOD=LAST(@METHOD) 
        /@PT=LAST(@PT) /@Zero=LAST(@Zero) /@ORw=LAST(@ORw) /@Z=LAST(@Z) /lastSTUDY=LAST(STUDY) 
        /A1o=SUM(A1o) /A0o=SUM(A0o) /B1o=SUM(B1o) /B0o=SUM(B0o) /WARNZERO=MAX(@WARNZERO) /WARNDEC=MAX(@WARNDEC).
      ADD FILES /FILE=* /FILE='@967N'
       /IN=@GLOBAL
       /DROP=COUNT lastSTUDY WARNZERO.
      MATCH FILES /FILE=*
        /TABLE='@967N'
        /BY  @1.
      EXECUTE.
      IF (@GLOBAL=1) STUDY='GLOBAL'.
      DATASET CLOSE @967N.
      EXECUTE.

      DO IF (@ERROR=0).
         DO IF (ANY(@STAT,1,2,4)).
            COMPUTE N1=A1+B1.       /*Compute N1,N0,N,M1,M0 from A1,B1,A0,B0 (STAT=OR,RR,RD).
            COMPUTE N0=A0+B0.
            COMPUTE M1=A1+A0.
            COMPUTE M0=B1+B0.
            COMPUTE N =N1+N0.
            COMPUTE N1o=A1o+B1o.       /*Originals parameters for print.
            COMPUTE N0o=A0o+B0o.
            COMPUTE M1o=A1o+A0o.
            COMPUTE M0o=B1o+B0o.
            COMPUTE No =N1o+N0o.
         ELSE.
            COMPUTE I1=A1/T1.       /*Compute T1,T0,T,M1 from A1,T1,A0,T0 (STAT=IR,ID).
            COMPUTE I0=A0/T0.
            COMPUTE T=T1+T0.
            COMPUTE M1=A1+A0.
         END IF.

*        Compute statistic ES, SE and p; M-H weights for STAT=OR,RR,IR.
         DO IF (@STAT=1).                 /*STAT=OR,Odds ratio.
            COMPUTE ES=(A1/B1)/(A0/B0).
            COMPUTE SE=SQR(1/A1+1/B1+1/A0+1/B0).
            COMPUTE WMH=A0*B1/N.
         ELSE IF (@STAT=2).               /*STAT=RR,Relative Risk.
            COMPUTE ES=(A1/N1)/(A0/N0).
            COMPUTE SE=SQR(1/A1-1/N1+1/A0-1/N0).
            COMPUTE WMH=A0*N1/N.
         ELSE IF (@STAT=3).               /*STAT=IR,Rate Ratio.
            COMPUTE ES=(A1/T1)/(A0/T0).
            COMPUTE SE=SQR(1/A1+1/A0).
            COMPUTE WMH=A0*T1/T.
         ELSE IF (@STAT=4).               /*STAT=RD,Risk difference.
            COMPUTE #R1=A1/N1.
            COMPUTE #R0=A0/N0.
            COMPUTE ES=#R1-#R0.
            COMPUTE SE=SQR(#R1*(1-#R1)/N1 + #R0*(1-#R0)/N0).
         ELSE IF (@STAT=5).               /*STAT=ID,Rate difference.
            COMPUTE ES=(A1/T1)-(A0/T0).
            COMPUTE SE=SQR(A1/T1**2+A0/T0**2).
         END IF.

         DO IF (@STAT<4).              /*Compute bounds for the statistic.
            COMPUTE LO=ES*EXP(-@Z*SE).
            COMPUTE UP=ES*EXP(@Z*SE).
         ELSE.
            COMPUTE LO=ES-@Z*SE.
            COMPUTE UP=ES+@Z*SE.
         END IF.

         DO IF (ANY(@STAT,1,2,4)).     /*MH Chi-Square and signification (p).
            COMPUTE #Chi2= (N-1)*((A1*N-N1*M1)**2)/(M1*M0*N1*N0) .
         ELSE.
            COMPUTE #Chi2= ((A1*T-T1*M1)**2)/(M1*T1*T0) .
         END IF.
         COMPUTE p= (1- CDF.CHISQ(ABS(#Chi2),1)).

         DO IF (@STAT=1).        /*PETO results (always for STAT=OR and 2x2 tables).
            COMPUTE E = M1*N1/N.                      /*Number of expected cases.
            COMPUTE V = E*((N0*M0)/(N*(N-1))).        /*Peto Variance.
            COMPUTE ORp = EXP((A1-E)/V).              /*Peto OR.
            COMPUTE SEp = SQRT(1/V).                  /*Standard Error = SQRT(Variance).
            COMPUTE LOp=ORp*EXP(-@Z*SEp).             /*CI.
            COMPUTE UPp=ORp*EXP(@Z*SEp).
            COMPUTE pPeto = 2*(1 - CDFNORM(ABS(LN(ORp)/SEp))).   /*Signification (p).
************PETO COMBINED: summatories for estimation.
            COMPUTE SUMOEi = (A1-E).
            COMPUTE SUMVi = V.
         END IF.

*********MH COMBINED: summatories for estimation and CI.
         DO IF (@STAT=1).
            COMPUTE NumESMHi = A1*B0/N.
            COMPUTE DenESMHi = A0*B1/N.
            COMPUTE Si=(A0*B1)/N.
            COMPUTE Ri=(A1*B0)/N.
            COMPUTE PRi=((A1+B0)/N)*Ri.
            COMPUTE PSQRi=(A1+B0)/N*Si + (1-((A1+B0)/N))*Ri.
            COMPUTE QSi=(1-((A1+B0)/N))*Si.
         ELSE IF (@STAT=2).
            COMPUTE NumESMHi = A1*N0/N.
            COMPUTE DenESMHi = A0*N1/N.                     
            COMPUTE NumSEi = (M1*N1*N0/(N**2) - A1*A0/N).
            COMPUTE DenSE1i= A1*N0/N.
            COMPUTE DenSE2i= A0*N1/N.
         ELSE IF (@STAT=3).
            COMPUTE NumESMHi = A1*T0/T.
            COMPUTE DenESMHi = A0*T1/T.
            COMPUTE NumSEi = (M1*T1*T0/(T**2) - A1*A0/T).
            COMPUTE DenSE1i= A1*T0/T.
            COMPUTE DenSE2i= A0*T1/T.
         END IF.

*********PRINT 2X2 TABLE: A1,A0,B1/T1,B0/T0,N1/I1,N0/I0,M1,M0,N,ES,SE,p tables for each stratum.
         COMPUTE @TDec=' '.
         !IF (!TABLES=1) !THEN.
            DO IF (ANY(@STAT,1,2,4)).
               IF ((MOD(A1o,1)<>0 OR MOD(A0o,1)<>0 OR MOD(B1o,1)<>0 OR MOD(B0o,1)<>0)) @TDec='.'.
               DO IF (@STAT=1).     /*For STAT=OR, include Peto results on the output.
                  DO IF ($CASENUM=1).
                     DO IF (WARNZERO=1 AND @ZERO>0).
                        PRINT /'                   |           |           |           |     OR*   |  OR_peto* |'.
                     ELSE.
                        PRINT /'                   |           |           |           |     OR    |  OR_peto  |'.
                     END IF.
                     PRINT /'STUDY              | UnExposed |  Exposed  |    TOTAL  |  (SE_lnOR)| (SE_lnORp)|'.
                     PRINT /'===================+===========+===========+===========+===========+===========+'.
                  END IF.
                  DO IF (@GLOBAL=0).
                     PRINT /STUDY(A8)    'Cases |'14 A0o(T23,F8) @TDec '|'32 A1o (T34,F8) @TDec '|'44 M1o(T46,F8) @TDec '|'56  ES(T57,F10.4) '|'68 ORp(T69,F10.4) '|'80.
                     PRINT /RANK(F6.1) 'NonCases |'11 B0o(T23,F8) @TDec '|'32 B1o (T34,F8) @TDec '|'44 M0o(T46,F8) @TDec '|'56 '('60 SE(T61,F6.4) ')|('67 SEp(T70,F9.4) ')|'79.
                     PRINT /'-------------------+-----------+-----------+-----------+' '|'68 '|'80.
                     PRINT /'             TOTAL |' N0o(T23,F8) @TDec '|'32 N1o(T34,F8) @TDec '|'44 No(T46,F8) @TDec '| p= '56 p(T60,F7.5) '| p='68 pPeto(T72,F7.5) '|'80.
                     PRINT  /'===================+===========+===========+===========+-----------+-----------+'.
                  ELSE.
                     PRINT /'GLOBAL       Cases |' A0o(T23,F8) @TDec '|'32 A1o (T34,F8) @TDec '|'44 M1o(T46,F8) @TDec '|'56  ES(T57,F10.4) '|'68 ORp(T69,F10.4) '|'80.
                     PRINT /'          NonCases |' B0o(T23,F8) @TDec '|'32 B1o (T34,F8) @TDec '|'44 M0o(T46,F8) @TDec '|'56 '('60 SE(T61,F6.4) ')|('67 SEp(T70,F9.4) ')|'79.
                     PRINT /'-------------------+-----------+-----------+-----------+' '|'68 '|'80.
                     PRINT /'             TOTAL |' N0o(T23,F8) @TDec '|'32 N1o(T34,F8) @TDec '|'44 No(T46,F8) @TDec '| p= '56 p(T60,F7.5) '| p='68 pPeto(T72,F7.5) '|'80.
                     PRINT /'===================+===========+===========+===========+===========+===========+'.
                  END IF.
               ELSE.
                  DO IF ($CASENUM=1).
                     DO IF (WARNZERO=1 AND @ZERO>0).
                        COMPUTE @TITLE = CONCAT(@EStitle,'*(SE_ln',@EStitle,')').
                        IF (@STAT>3) @TITLE = CONCAT(@EStitle,'* (SE)').
                     END IF.
                     PRINT /'STUDY              | UnExposed |  Exposed  |    TOTAL  | ' @TITLE(A12) '|'70.
                     PRINT /'===================+===========+===========+===========+=============+'.
                  END IF.
                  DO IF (@GLOBAL=0).
                     PRINT /STUDY(A8)    'Cases |'14 A0o(T23,F8) @TDec '|'32 A1o (T34,F8) @TDec '|'44 M1o(T46,F8) @TDec '|'56  ES(T58,!FORMAT)  '|'70.
                     PRINT /RANK(F6.1) 'NonCases |'11 B0o(T23,F8) @TDec '|'32 B1o (T34,F8) @TDec '|'44 M0o(T46,F8) @TDec '|(' SE(T58,!FORMAT) ')|'69.
                     PRINT /'-------------------+-----------+-----------+-----------+' '|'70 .
                     PRINT /'             TOTAL |' N0o(T23,F8) @TDec '|'32 N1o(T34,F8) @TDec '|'44 No(T46,F8) @TDec '| p= '56 p(T61,F7.5) '|'70 .
                     PRINT /'===================+===========+===========+===========+-------------+'.
                  ELSE.
                     PRINT /'GLOBAL       Cases |' A0o(T23,F8) @TDec '|'32 A1o (T34,F8) @TDec '|'44 M1o(T46,F8) @TDec '|'56  ES(T58,!FORMAT)  '|'70.
                     PRINT /'          NonCases |' B0o(T23,F8) @TDec '|'32 B1o (T34,F8) @TDec '|'44 M0o(T46,F8) @TDec '|(' SE(T58,!FORMAT) ')|'69.
                     PRINT /'-------------------+-----------+-----------+-----------+' '|'70 .
                     PRINT /'             TOTAL |' N0o(T23,F8) @TDec '|'32 N1o(T34,F8) @TDec '|'44 No(T46,F8) @TDec '| p= '56 p(T61,F7.5) '|'70 .
                     PRINT /'===================+===========+===========+===========+=============+'.
                  END IF.
               END IF.
***************PRINT WARNINGs.
               DO IF ($CASENUM=COUNT+1).
*                 Decimal values.
                  DO IF (WARNDEC=1).
                     PRINT/'(.)WARNING: Number of cases with decimal values'.
                     PRINT/'            The values are printed rounded.'.
                  END IF.
*                 Zero correction.
                  DO IF (WARNZERO=1 AND @ZERO>0).
                     DO IF (@ZERO=1).
                        PRINT /'(*)Computed with a constant continuity correction (k=0.5)'.
                     ELSE IF (@ZERO=2).
                        PRINT /'(*)Computed with a proportional continuity correction'.
                     ELSE IF (@ZERO=3).
                        PRINT /'(*)Computed with an empirical continuity correction (ORw= ' !QUOTE(!ORw) ')'.
                     END IF.
                     PRINT /'   for studies with zero events.'.
                  END IF.
               END IF.
            ELSE.
               IF (MOD(A1,1)<>0 OR MOD(A0,1)<>0 OR MOD(T1,1)<>0 OR MOD(T0,1)<>0) @TDec='.'.
               COMPUTE It=M1/T.
               DO IF ($CASENUM=1).
                  PRINT /'STUDY              | UnExposed |  Exposed  |    TOTAL  | ' @TITLE(A12) '|'70.
                  PRINT /'===================+===========+===========+===========+=============+'.
               END IF.
               DO IF (@GLOBAL=0).
                  PRINT /STUDY(A8)      'Cases |'14 A0(T23,F8) @TDec '|'32 A1 (T34,F8) @TDec '|'44 M1(T46,F8) @TDec '|'56  ES(T58,!FORMAT)  '|'70.
                  PRINT /RANK(F6.1) 'Person-time |'8  T0(T23,F8) @TDec '|'32 T1 (T34,F8) @TDec '|'44 T (T46,F8) @TDec '|(' SE(T58,!FORMAT) ')|'69.
                  PRINT /'-------------------+-----------+-----------+-----------+' '|'70 .
                  PRINT /'    Incidence Rate |' I0(T23,F9.8) @TDec '|'32 I1(T34,F9.8) @TDec '|'44 It(T46,F9.8) @TDec '| p= '56 p(T61,F7.5) '|'70 .
                  PRINT  /'===================+===========+===========+===========+-------------+'.
               ELSE.
                  PRINT /'GLOBAL       Cases |' A0(T23,F8) @TDec '|'32 A1 (T34,F8) @TDec '|'44 M1(T46,F8) @TDec '|'56  ES(T58,!FORMAT)  '|'70.
                  PRINT /'       Person-time |' T0(T23,F8) @TDec '|'32 T1 (T34,F8) @TDec '|'44 T (T46,F8) @TDec '|(' SE(T58,!FORMAT) ')|'69.
                  PRINT /'-------------------+-----------+-----------+-----------+' '|'70 .
                  PRINT /'    Incidence Rate |' I0(T23,F9.8) @TDec '|'32 I1(T34,F9.8) @TDec '|'44 It(T46,F9.8) @TDec '| p= '56 p(T61,F7.5) '|'70 .
                  PRINT  /'===================+===========+===========+===========+=============+'.
               END IF.
            END IF.
         !IFEND.
      END IF.
      COMPUTE SCL = $SYSMIS.        /*Compatibility.
   !ELSE.
******Summary statistics (aggregated data).
      COMPUTE WARNZERO=0.
      !IF (!STATU='OR') !THEN.
         !LET !VARNAME='ODR'.
      !ELSE.
         !LET !VARNAME=!STATU.
      !IFEND.
      COMPUTE ES=!VARNAME.    /*Compute ES variable from the data provided.
*     Compute SCL variable when doesn't exists.
      !IF (!DATAU='SSE') !THEN.
         COMPUTE SCL=!CL.
      !ELSE.
         !IF (!SCL=1) !THEN.
            COMPUTE SCL=95.
         !IFEND.
      !IFEND.
      COMPUTE @2Z=2*IDF.NORMAL((SCL+100)/200,0,1).
      COMPUTE @GLOBAL=0.
      EXECUTE.

      !IF (!DATAU='SSE') !THEN.
*        Summary statistics + SE: compute CI.
         DO IF (@STAT<4).
            COMPUTE LO=ES*EXP(-@Z*SE).
            COMPUTE UP=ES*EXP(@Z*SE).
         ELSE.
            COMPUTE LO= ES - @Z*SE.
            COMPUTE UP= ES + @Z*SE.
         END IF.
      !ELSE.
*        Summary statistics + CI: compute SE.
         DO IF (@STAT<4).
            COMPUTE SE=((ln(UP)-ln(LO))/@2Z).
         ELSE.
            COMPUTE SE=((UP-LO)/@2Z).
         END IF.
      !IFEND.

*     Add variable COUNT.
      AGGREGATE  /OUTFILE=* MODE=ADDVARIABLES OVERWRITE=YES /PRESORTED
        /BREAK=@1 /COUNT=N.
   !IFEND.
   
   DO IF (@ERROR=0).
      COMPUTE LNES = LN(ES).
      IF (@STAT>3) LNES=ES.

******IOV model - Fixed effects.
      COMPUTE WIV=1/(SE**2).        /*IoV Weight.
      COMPUTE WIV2=WIV**2.
      COMPUTE NESIVi=WIV*LNES.    /*Numerator of weighted statistic.
   END IF.

   TEMPORARY.
   SELECT IF (@GLOBAL=0).
   DATASET DECLARE @967W WINDOW=HIDDEN.
   AGGREGATE /OUTFILE='@967W' /MISSING=COLUMNWISE /PRESORTED
     /BREAK=@1
     /NumESMH=SUM(NumESMHi) /DenESMH=SUM(DenESMHi) /R=SUM(Ri) /S=SUM(Si) /PR=SUM(PRi) /QS=SUM(QSi) /PSQR=SUM(PSQRi) 
     /NumSE=SUM(NumSEi) /DenSE1=SUM(DenSE1i) /DenSE2=SUM(DenSE2i) /SUMOE=SUM(SUMOEi) /SUMV=SUM(SUMVi) 
     /NESIV=SUM(NESIVi) /SWIV=SUM(WIV) /SWIV2=SUM(WIV2) /SWMH=SUM(WMH).
   MATCH FILES /FILE=*
     /TABLE='@967W'
     /BY  @1.
   EXECUTE.
   DATASET CLOSE @967W.
   
   DO IF (@ERROR=0).
******MH COMBINED.
      COMPUTE ESMH=NumESMH/DenESMH.       /*Estimation of the statistic.
      DO IF (@STAT=1).                    /*SE.
         COMPUTE SEMH = SQR(PR/(2*(R**2)) + PSQR/(2*R*S) + QS/(2*(S**2))).
      ELSE IF (@STAT=2 OR @STAT=3).
         COMPUTE SEMH = SQR(NumSE/(DenSE1*DenSE2)).
      END IF.
      COMPUTE loESMH= ESMH*EXP(-@Z*SEMH). /*CI.
      COMPUTE upESMH= ESMH*EXP(@Z*SEMH).
      COMPUTE pESMH = 2*(1-CDFNORM(ABS(LN(ESMH)/SEMH))).    /*Significance.
      COMPUTE QMHi=((LNES-LN(ESMH))**2)/(SE**2).          /*Homogeneity Q Test (MH).

******PETO COMBINED.
      COMPUTE Qpetoi = $SYSMIS.
      DO IF (@STAT=1).
         COMPUTE ORpeto=EXP(SUMOE/SUMV).       /*Estimation of the OR Peto.
         COMPUTE SEpeto=SQR(1/SUMV).           /*SE.
         COMPUTE loORpeto= ORpeto*EXP(-@Z*SEpeto). /*CI.
         COMPUTE upORpeto= ORpeto*EXP(@Z*SEpeto).
         COMPUTE pORpeto = 2*(1-CDFNORM(ABS(LN(ORpeto)/SEpeto))).    /*Significance.
         COMPUTE Qpetoi=((LN(ORp)-LN(ORpeto))**2)*V.      /*Homogeneity Q Test (Peto).
      END IF.

******IoV - FEM COMBINED.
      COMPUTE LNESIV = NESIV/SWIV.        /*Weigthed statistic.
      COMPUTE ESIV = EXP(LNESIV).
      IF (@STAT>3) ESIV=LNESIV.
      COMPUTE SEIV = SQR(1/SWIV).         /*SE.
      DO IF (@STAT<4).                    /*CI.
         COMPUTE loESIV = ESIV*EXP(-@Z*SEIV).
         COMPUTE upESIV = ESIV*EXP(@Z*SEIV).
      ELSE.
         COMPUTE loESIV = ESIV - @Z*SEIV.
         COMPUTE upESIV = ESIV + @Z*SEIV.
      END IF.
      COMPUTE pESIV = 2*(1-CDFNORM(ABS(LNESIV/SEIV))).    /*Significance.
      COMPUTE QIVi=WIV*(LNES - LNESIV)**2.     /*Homogeneity Q Test.
   END IF.

   TEMPORARY.
   SELECT IF (@GLOBAL=0).
   DATASET DECLARE @967Q WINDOW=HIDDEN.
   AGGREGATE  /OUTFILE='@967Q' /MISSING=COLUMNWISE /PRESORTED
     /BREAK=@1
     /QMH=SUM(QMHi) /Qpeto=SUM(Qpetoi) /QIV=SUM(QIVi).
   MATCH FILES /FILE=* /TABLE='@967Q' /BY  @1.
   EXECUTE.
   DATASET CLOSE @967Q.
   
   DO IF (@ERROR=0).
      COMPUTE pQMH=(1-CDF.CHISQ(ABS(QMH),COUNT-1)).
      COMPUTE pQpeto=(1-CDF.CHISQ(ABS(Qpeto),COUNT-1)).

******IoV - FEM.
      COMPUTE pQIV= (1- CDF.CHISQ(ABS(QIV),COUNT-1)).
*     Heterogeneity Measures.
      COMPUTE #k=COUNT.
*     Relative excess.
      COMPUTE H=SQRT(QIV/(#k-1)).
      COMPUTE SElnH=0.
      DO IF (QIV>#k).
         COMPUTE SElnH=(LN(QIV)-LN(#k-1))/(2*(SQR(2*QIV) - SQR(2*#k-3))).
      ELSE.
         IF (#k>2) SElnH=SQR((1/(2*(#k-2))) * (1-1/(3*(#k-2)**2))).
      END IF.
      COMPUTE loH=H*EXP(-@Z*SELNH).
      COMPUTE upH=H*EXP(@Z*SELNH).
*     % of Variance that is due heterogeneity between studies: I2 Statistic.
      COMPUTE I2=100*(H**2-1)/H**2.
      IF (I2<0) I2=0.
      COMPUTE loI2=100*(loH**2-1)/loH**2.
      IF (loI2<1) loI2=0.
      COMPUTE upI2=100*(upH**2-1)/upH**2.
      IF (upI2<1) upI2=0.

******Variance between studies (Tau2) for IOV model .
      COMPUTE Tau2=MAX(0,(QIV-#k+1)/(SWIV-SWIV2/SWIV)).

******IOV model - Random effects.
      COMPUTE WIVr=1/((SE**2)+Tau2).        /*Weight.
      COMPUTE WIV2r=WIVr**2.
      COMPUTE NESIVri=WIVr*LNES.          /*Numerator of weighted statistic (Random effects).
   END IF.

   TEMPORARY.
   SELECT IF (@GLOBAL=0).
   DATASET DECLARE @967R WINDOW=HIDDEN.
   AGGREGATE  /OUTFILE='@967R' /MISSING=COLUMNWISE /PRESORTED
     /BREAK=@1
     /SWIVr=SUM(WIVr) /SWIV2r=SUM(WIV2r) /NESIVr=SUM(NESIVri).
   MATCH FILES /FILE=* /TABLE='@967R' /BY  @1.
   EXECUTE.
   DATASET CLOSE @967R.

   DO IF (@ERROR=0).   
      COMPUTE LNESIVr = NESIVr / SWIVr.        /*Weigthed statistic (Random effects).
      COMPUTE ESIVr = EXP(LNESIVr).
      IF (@STAT>3) ESIVr=LNESIVr.
      COMPUTE SEIVr = SQR(1/SWIVr).          /*Standard error (Random effects).
      DO IF (@STAT<4).                       /*CI (Random effects).
         COMPUTE loESIVr = ESIVr*EXP(-@Z*SEIVr).
         COMPUTE upESIVr = ESIVr*EXP(@Z*SEIVr).
      ELSE.
         COMPUTE loESIVr = ESIVr - @Z*SEIVr.
         COMPUTE upESIVr = ESIVr + @Z*SEIVr.
      END IF.
      COMPUTE pESIVr = 2*(1-CDFNORM(ABS(LNESIVr/SEIVr))).    /*Significance.
      COMPUTE QIVri=WIVr*(LNES - LNESIVr)**2.        /*Homogeneity Q Test.
   END IF.

   TEMPORARY.
   SELECT IF (@GLOBAL=0).
   DATASET DECLARE @967Qr WINDOW=HIDDEN.
   AGGREGATE  /OUTFILE='@967Qr' /MISSING=COLUMNWISE /PRESORTED
     /BREAK=@1
     /QIVr=SUM(QIVri).
   MATCH FILES /FILE=* /TABLE='@967Qr' /BY  @1.
   EXECUTE.
   DATASET CLOSE @967Qr.

   DO IF (@ERROR=0).   
******IoV - REM.
      COMPUTE pQIVr= (1- CDF.CHISQ(ABS(QIVr),COUNT-1)).
*     Heterogeneity Measures.
      COMPUTE #k=COUNT.
*     Relative excess.
      COMPUTE Hr=SQRT(QIVr/(#k-1)).         
      COMPUTE SElnHr=0.
      DO IF (QIVr>#k).
         COMPUTE SElnHr=(LN(QIVr)-LN(#k-1))/(2*(SQR(2*QIVr) - SQR(2*#k-3))).
      ELSE.
         IF (#k>2) SElnHr=SQR((1/(2*(#k-2))) * (1-1/(3*(#k-2)**2))).
      END IF.
      COMPUTE loHr=Hr*EXP(-@Z*SELNHr).
      COMPUTE upHr=Hr*EXP(@Z*SELNHr).
*     % of Variance that is due heterogeneity between studies: I2 Statistic.
      COMPUTE I2r=100*(Hr**2-1)/Hr**2.
      IF (I2r<0) I2r=0.
      COMPUTE loI2r=100*(loHr**2-1)/loHr**2.
      IF (loI2r<1) loI2r=0.
      COMPUTE upI2r=100*(upHr**2-1)/upHr**2.
      IF (upI2r<1) upI2r=0.
   END IF.

   DO IF (@ERROR=0).
      COMPUTE rWMH = (WMH/SWMH)*100.
      COMPUTE rWP = (V/SUMV)*100.
      COMPUTE rWIV = (WIV/SWIV)*100.
      COMPUTE rWIVr = (WIVr/SWIVr)*100.
      !IF (!DATAU='RAW' !AND !TABLES=1) !THEN.
         DO IF ($CASENUM=1).
            PRINT SPACE.
         END IF.
      !IFEND.
      STRING #TZero(A1).
      COMPUTE #TZero = ' '.
      IF (WARNZERO=1 AND @ZERO>0) #TZero='*'.
      DO IF (@TYPE=1 AND @STAT=1).
*        2x2 tables: Print statistic, CI and relative weights for stratum and GLOBAL: Peto & Mh & FixEff & RanEff.
         DO IF ($CASENUM=1).
            PRINT /'---------------+----------+--------------------+-------------------------------+'.
            PRINT /'               |          | ' @CL(F2) '% Conf. Interval |        Relative WEIGHTS       |'.
            DO IF (@METHOD=4).      /*Print PETO results.
               PRINT /'STUDY    RANK  |  OR_peto' #TZero(A1) '|    Lower     Upper |  Peto     MH   IV_FEM  IV_REM |'.
            ELSE.
               PRINT /'STUDY    RANK  |    OR' #TZero(A1) '   |    Lower     Upper |  Peto     MH   IV_FEM  IV_REM |'.
            END IF.
            PRINT /'---------------+----------+--------------------+-------+-------+-------+-------+'.
         END IF.
         DO IF (@GLOBAL=0).
            DO IF (@METHOD=4).      /*Print PETO results.
               PRINT /STUDY(A8) ' ' RANK(F6.1) '|'16 ORp(T17,F9.4) '|'27 LOp(T28,F9.4) UPp(T38,F9.4) '|'48 rWP(T50,PCT5.1) '|'56 rWMH(T58,PCT5.1) '|'64 rWIV(T66,PCT5.1) '|'72 rWIVr(T74,PCT5.1) '|'80.
            ELSE.
               PRINT /STUDY(A8) ' ' RANK(F6.1) '|'16 ES(T17,F9.4) '|'27 LO(T28,F9.4) UP(T38,F9.4) '|'48 rWP(T50,PCT5.1) '|'56 rWMH(T58,PCT5.1) '|'64 rWIV(T66,PCT5.1) '|'72 rWIVr(T74,PCT5.1) '|'80.
            END IF.
         ELSE.
            PRINT /'---------------+----------+--------------------+-------+-------+-------+-------+'.
            DO IF (@METHOD=4).      /*Print PETO results.
               PRINT /'GLOBAL         |' ORp(T17,F9.4) '|'27 LOp(T28,F9.4) UPp(T38,F9.4) ' |  100% |  100% |  100% |  100% |'.
            ELSE.
               PRINT /'GLOBAL         |' ES (T17,F9.4) '|'27 LO(T28,F9.4) UP(T38,F9.4) ' |  100% |  100% |  100% |  100% |'.
            END IF.
            PRINT /'---------------+----------+--------------------+-------+-------+-------+-------+'.
            PRINT /'                         TOTAL Weights(rounded)|' SUMV(T49,F7) '|' SWMH(F7) '|' SWIV(F7) '|' SWIVr(F7) '|'.
            PRINT /'-----------------------------------------------+-------+-------+-------+-------+'.
         END IF.
      ELSE IF (@TYPE=1 AND (@STAT=2 OR @STAT=3)).
*        2x2 tables: Print statistic, CI and relative weights for stratum and GLOBAL: Mh & FixEff & RanEff.
         DO IF ($CASENUM=1).
            PRINT /'----------------+------------+-------------------------+-----------------------+'.
            PRINT /'                |            | ' @CL(F2) '% Confidence Interval |   Relative WEIGHTS    |'.
            PRINT /'STUDY    RANK   |' @EStitle(T22,A2) #TZero(A1) '     |      Lower        Upper |   MH   IV_FEM  IV_REM |'.
            PRINT /'----------------+------------+-------------------------+-------+-------+-------+'.
         END IF.
         DO IF (@GLOBAL=0).
            PRINT /STUDY(A8) ' ' RANK(F6.1) '|'17 ES(T19,!FORMAT) '|'30 LO(T32,!FORMAT) UP(T45,!FORMAT) '|'56 rWMH(T58,PCT5.1) '|'64 rWIV(T66,PCT5.1) '|'72 rWIVr(T74,PCT5.1) '|'80.
         ELSE.
            PRINT  /'----------------+------------+-------------------------+-------+-------+-------+'.
            PRINT  /'GLOBAL          |' ES (T19,!FORMAT) '|'30 LO(T32,!FORMAT) UP(T45,!FORMAT) ' |  100% |  100% |  100% |'.
            PRINT  /'----------------+------------+-------------------------+-------+-------+-------+'.
            PRINT  /'                                 TOTAL Weights(rounded)|' SWMH(F7) '|' SWIV(F7) '|' SWIVr(F7) '|'.
            PRINT  /'-------------------------------------------------------+-------+-------+-------+'.
         END IF.
      ELSE IF (@TYPE=1 AND @STAT>3).
*        2x2 tables: Print statistic, CI and relative weights for stratum and GLOBAL: FixEff & RanEff for STAT=RD,ID.
         DO IF ($CASENUM=1).
            PRINT /'----------------+------------+-------------------------+-----------------------+'.
            PRINT /'                |            | ' @CL(F2) '% Confidence Interval |  Relative IoV Weights |'.
            PRINT /'STUDY    RANK   |' @EStitle(T22,A2) #TZero(A1) '     |      Lower        Upper | Fixed Eff  Random Eff |'.
            PRINT /'----------------+------------+-------------------------+-----------+-----------+'.
         END IF.
         DO IF (@GLOBAL=0).
            PRINT /STUDY(A8) ' ' RANK(F6.1) '|'17 ES(T19,!FORMAT) '|'30 LO(T32,!FORMAT) UP(T45,!FORMAT) '|'56 rWIV(T62,PCT5.1) '|'68 rWIVr(T74,PCT5.1) '|'80.
         ELSE.
            PRINT /'----------------+------------+-------------------------+-----------+-----------+'.
            PRINT /'GLOBAL          | ' ES(T19,!FORMAT) '|'30 LO(T32,!FORMAT) UP(T45,!FORMAT) ' |      100% |      100% |'.
            PRINT /'----------------+------------+-------------------------+-----------+-----------+'.
            PRINT /'                                 TOTAL Weights(rounded)|' SWIV(T57,F11) '|' SWIVr(T69,F11) '|'.
            PRINT /'----------------+------------+-------------------------+-----------+-----------+'.
         END IF.
      ELSE IF (@TYPE>1).
*        Summary parameters: Print statistic, CI and relative weights for study: FixEff & RanEff.
         DO IF ($CASENUM=1).
            PRINT /'----------------+------------+----------------------+--+-----------------------+'.
            PRINT /'                |            |  Confidence Interval |  |  Relative IoV Weights |'.
            PRINT /'STUDY    RANK   |' @EStitle(T23,A2) '     |     Lower      Upper |CL| Fixed Eff  Random Eff |'.
            PRINT /'----------------+------------+----------------------+--+-----------+-----------+'.
         END IF.
         PRINT /STUDY(A8) RANK(T10,F6.1) '|'17 ES(T19,!FORMAT) '|'30 LO(T31,!FORMAT) UP(T42,!FORMAT) '|'53 SCL(F2) '|'56 rWIV(T62,PCT5.1) '|'68 rWIVr(T74,PCT5.1) '|'80.
         DO IF ($CASENUM=COUNT).
            PRINT /'----------------+------------+----------------------+--+-----------+-----------+'.
            PRINT /'                                                  TOTAL|      100% |      100% |'.
            PRINT /'                                                       +-----------+-----------+'.
            PRINT /'                                 TOTAL Weights(rounded)|' SWIV(T57,F11) '|' SWIVr(T69,F11) '|' .
            PRINT /'-------------------------------------------------------+-----------+-----------+'.
         END IF.
      END IF.
      DO IF (@TYPE=1 AND WARNZERO=1 AND @ZERO>0 AND $CASENUM=COUNT+1).
         DO IF (@ZERO=1).
            PRINT /'(*)Computed with a constant continuity correction (k=0.5)'.
         ELSE IF (@ZERO=2).
            PRINT /'(*)Computed with a proportional continuity correction'.
         ELSE IF (@ZERO=3).
            PRINT /'(*)Computed with an empirical continuity correction (ORw= ' !QUOTE(!ORw) ')'.
         END IF.
         PRINT /'   for studies with zero events.'.
      END IF.
   END IF.
   EXECUTE.

   DO IF (@ERROR=0).
      DO IF ($CASENUM=1).
         PRINT//'------------------------+--------------+----------+----------------------------+'.
         PRINT /'                        |              |          |    ' @CL(F2) '% Confidence Interval |'.
         PRINT /'                        |  Estimation  |  Signif. |         Lower        Upper |'.
         PRINT /'------------------------+--------------+----------+----------------------------+'.

         DO IF (@TYPE=1 AND @STAT<4).
*           2x2 tables + STAT=OR,RR,IR: print Peto & MH combined results.
            DO IF (@STAT=1).        /*For STAT=OR, print PETO estimation.
               PRINT /'PETO COMBINED:       OR |' ORpeto(T27,F12.4) '|'40 pORpeto(T43,F7.6) '|'51 loORpeto(T54,F12.4) upORpeto(T67,F12.4) '|'80.
               DO IF (ORpeto<1).
                  COMPUTE #INV=1/ORpeto.
                  COMPUTE #INVLO=1/upORpeto.
                  COMPUTE #INVUP=1/loORpeto.
                  PRINT /  '1/OR'20 '|'25 #INV(T27,F12.4) '|'40 '|'51 #INVLO(T54,F12.4) #INVUP(T67,F12.4) '|'80.
               END IF.
               PRINT /     'SE(lnOR)|'17  SEpeto(T27,F12.4) '|'40 '|'51 '|'80.
               PRINT /' Homogeneity Chi-Square |' Qpeto(T27,F12.4) '|'40 pQpeto(T43,F7.6) '|'51 '|'80.
               PRINT /'------------------------+--------------+----------+----------------------------+'.
            END IF.
      
            PRINT /'M-H COMBINED:' @EStitle(T22,A2) '|'25 ESMH(T27,F12.4) '|'40 pESMH(T43,F7.6) '|'51 loESMH(T54,F12.4) upESMH(T67,F12.4) '|'80.
            DO IF (ESMH<1).
               COMPUTE #INV=1/ESMH.
               COMPUTE #INVLO=1/upESMH.
               COMPUTE #INVUP=1/loESMH.
               PRINT /  '1/'20 @EStitle(T22,A2) '|'25 #INV(T27,F12.4) '|'40 '|'51 #INVLO(T54,F12.4) #INVUP(T67,F12.4) '|'80.
            END IF.
            PRINT /     'SE(ln'17  @EStitle(T22,A2) ')|'  SEMH(T27,F12.4) '|'40 '|'51 '|'80.
            PRINT /' Homogeneity Chi-Square |' QMH(T27,F12.4) '|'40 pQMH(T43,F7.6) '|'51 '|'80.
            PRINT /'------------------------+--------------+----------+----------------------------+'.
         END IF.

*********Print IOV model - Fixed effects results.
         DO IF (NOT SYSMIS(ESIV)).
            DO IF (Tau2=0).
*              If Tau2=0, there are no random effects.
               PRINT /'FIXED & RANDOM EFFECTS: |              |          |                            |'.
            ELSE.
               PRINT /'FIXED EFFECTS MODEL:    |              |          |                            |'.
            END IF.
            PRINT /'        IoV Weighted ' @EStitle(A2) '|'25 ESIV(T27,!FORMAT2) '|'40 pESIV(T43,F7.6) '|'51 loESIV(T54,!FORMAT2) upESIV(T67,!FORMAT2) '|'80.
            DO IF (ESIV<1 AND @STAT<4).
               COMPUTE #INV=1/ESIV.
               COMPUTE #INVLO=1/upESIV.
               COMPUTE #INVUP=1/loESIV.
               PRINT /  '1/'20 @EStitle(T22,A2) '|'25 #INV(T27,!FORMAT2) '|'40 '|'51 #INVLO(T54,!FORMAT2) #INVUP(T67,!FORMAT2) '|'80.
            END IF.
            PRINT / @SEtitle(T17,A8) '|'25 SEIV(T27,!FORMAT2) '|'40 '|'51 '|'80.
            COMPUTE #k=COUNT-1.
            PRINT /'Heterogeneity Measures: |' '|'40 '|'51  '|'80.
            DO IF(#k<3 AND #k>=QIV).
               PRINT /' Relative excess      H |' H (T27,F12.4)  '|'40  '|'51  '|'80.
               PRINT /' Pct. of variation  I^2 |' I2(T27,F12.4)  '|'40  '|'51  '|'80.
            ELSE.
               PRINT /' Relative excess      H |' H (T27,F12.4)  '|'40  '|'51  loH(T54,F12.4)  upH(T67,F12.4) '|'80.
               PRINT /'                 SE(lnH)|' SELNH(T27,F12.4)   '|'40  '|'51  '|'80.
               PRINT /' Pct. of variation  I^2 |' I2(T27,F12.4)  '|'40  '|'51  loI2(T54,F12.4) upI2(T67,F12.4) '|'80.
            END IF.
            PRINT /' due to heterogeneity   |' '|'40 '|'51  '|'80.
            PRINT /' Homogeneity Chi-Square |' QIV (T27,F12.4) '|'40 pQIV(T42,F8.6) '|'51 '|'80.
            PRINT /'VAR between stud. Tau^2 |' Tau2(T27,F12.10) '|'40  '|'51 '|'80.
            PRINT /'------------------------+--------------+----------+----------------------------+'.

************Print IOV model - Random effects results (only if Tau2>0).
            DO IF (Tau2>0).
               PRINT /'RANDOM EFFECTS MODEL:   |              |          |                            |'.
               PRINT /'        IoV Weighted ' @EStitle(A2) '|'25 ESIVr(T27,!FORMAT2) '|'40 pESIVr(T43,F7.6) '|'51 loESIVr(T54,!FORMAT2) upESIVr(T67,!FORMAT2) '|'80.
                  DO IF (ESIVr<1 AND @STAT<4).
                     COMPUTE #INV=1/ESIVr.
                     COMPUTE #INVLO=1/upESIVr.
                     COMPUTE #INVUP=1/loESIVr.
                     PRINT /  '1/'20 @EStitle(T22,A2) '|'25 #INV(T27,!FORMAT2) '|'40 '|'51 #INVLO(T54,!FORMAT2) #INVUP(T67,!FORMAT2) '|'80.
                  END IF.
               PRINT / @SEtitle(T17,A8) '|'25 SEIVr(T27,!FORMAT2) '|'40 '|'51 '|'80.
               PRINT /'Heterogeneity Measures: |' '|'40 '|'51  '|'80.
               DO IF(#k<3 AND #k>=QIVr).
                  PRINT /' Relative excess      H |' Hr (T27,F12.4)  '|'40  '|'51  '|'80.
                  PRINT /' Pct. of variation  I^2 |' I2r(T27,F12.4)  '|'40  '|'51  '|'80.
               ELSE.
                  PRINT /' Relative excess      H |' Hr (T27,F12.4)  '|'40  '|'51  loHr(T54,F12.4)  upHr(T67,F12.4) '|'80.
                  PRINT /'                 SE(lnH)|' SELNHr(T27,F12.4)   '|'40  '|'51  '|'80.
                  PRINT /' Pct. of variation  I^2 |' I2r(T27,F12.4)  '|'40  '|'51  loI2r(T54,F12.4) upI2r(T67,F12.4) '|'80.
               END IF.
               PRINT /' due to heterogeneity   |' '|'40 '|'51  '|'80.
               PRINT /' Homogeneity Chi-Square |' QIVr (T27,F12.4) '|'40 pQIVr(T42,F8.6) '|'51 '|'80.
               PRINT /'------------------------+--------------+----------+----------------------------+'.
            END IF.
         ELSE.
            PRINT /'IOV METHOD: Non-estimable'.
         END IF.
      END IF.
   END IF.
   EXECUTE.

   SELECT IF (@GLOBAL<>1).       /*Delete the GLOBAL row.
   EXECUTE.

***INFLUENCE ANALYSIS.
   !IF (!INFLU=1) !THEN.
      DO IF ($CASENUM=1 AND @ERROR=0).              /*Print table header.
         DO IF (@METHOD=1 OR @METHOD=2).            /*IOV - FEM method (and REM, by default).
            DO IF (NOT SYSMIS(ESIV)).
               DO IF (@METHOD=2).
                  PRINT//'INFLUENCE ANALYSIS*'.    /*IOV - REM method: note.
               ELSE.
                  PRINT//'INFLUENCE ANALYSIS'.
               END IF.
               PRINT /'---------+-----------------------------------------------------------+---------+'.
               PRINT /'         | IoV Fixed Effect Model estimation if the study is deleted | Relative|'.
               PRINT /'STUDY    |           '@CL(F2)'% Confidence Interval     '@EStitle(A2)'w   Heterogeneity | Weights |'.
               PRINT /'deleted  |       '@EStitle(A2)'w      Lower        Upper | change |  I^2     P   | IoV FEM |'.
               PRINT /'---------+-----------------------------------+--------+--------------+---------+'.
            END IF.
         ELSE IF (@METHOD=3).
            PRINT//'INFLUENCE ANALYSIS'.
            PRINT /'---------+--------------------------------------------+---------+'.
            PRINT /'         |    MH estimation if the study is deleted   | Relative|'.
            PRINT /'STUDY    |           '@CL(F2)'% Confidence Interval     '@EStitle(A2)'w  | Weights |'.
            PRINT /'deleted  |      '@EStitle(A2)'w       Lower        Upper | change |    MH   |'.
            PRINT /'---------+-----------------------------------+--------+---------+'.
         ELSE IF (@METHOD=4).
            PRINT//'INFLUENCE ANALYSIS'.
            PRINT /'---------+--------------------------------------------+---------+'.
            PRINT /'         |  PETO estimation if the study is deleted   | Relative|'.
            PRINT /'STUDY    |           '@CL(F2)'% Confidence Interval     '@EStitle(A2)'w  | Weights |'.
            PRINT /'deleted  |      '@EStitle(A2)'w       Lower        Upper | change |   PETO  |'.
            PRINT /'---------+-----------------------------------+--------+---------+'.
         END IF.
      END IF.
      EXECUTE.
   !IFEND.
   
   SET RESULTS OFF  ERRORS OFF..
   CREATE @I=CSUM(@1).           /*Create the sequence variable.
   SET RESULTS ON  ERRORS ON.
   STRING @STUDY (A8).
   !DO !I = 1 !TO !COUNT.        /*Loop to process the influence analysis.
      !IF (!I=!COUNT) !THEN.
         COMPUTE @STUDY=STUDY.
      !ELSE.
         !LET !LAG=!LENGTH(!SUBSTR(!BLANKS(!COUNT),!LENGTH(!CONCAT(!BLANKS(!I),' ')))).
         COMPUTE @STUDY=LAG(STUDY,!LAG).          /*@STUDY: for each LOOP has the name of the study in the last row.
      !IFEND.
      EXECUTE.

      !IF (!METHODU='FEM' !OR !METHODU='REM') !THEN.      /*Influence analysis: IOV - FEM (or REM, which is not calculated).
         !LET !SWIVia=!CONCAT('SWIVia',!I).      /*Summatories parameters.
         !LET !NESIVia=!CONCAT('NESIVia',!I).
         !LET !Qia=!CONCAT('Qia',!I).

         !IF (!I=!COUNT) !THEN.
            COMPUTE @Wia=rWIV.
         !ELSE.
            COMPUTE @Wia=LAG(rWIV,!LAG).          /*@Wia: for each LOOP has the weight of the study in the last row.
         !IFEND.

*        Summatories for the Weighted statistic & SE.
         TEMPORARY.
         DO IF (@I=!I).       /*Exclude study i from the influence analysis calculations.
            DO REPEAT VAR = WIV NESIVi.
               COMPUTE VAR=0.
            END REPEAT.
         END IF.
         AGGREGATE  /OUTFILE=* MODE=ADDVARIABLES /MISSING=COLUMNWISE /PRESORTED
           /BREAK=@1
           /!SWIVia=SUM(WIV) /!NESIVia=SUM(NESIVi).

         COMPUTE LNESia = !NESIVia / !SWIVia.
         COMPUTE #SEia = SQR(1/!SWIVia).          /*Standard error.
         COMPUTE ESia = EXP(LNESia).              /*Weigthed statistic.
         IF (@STAT>3) ESia=LNESia.
         DO IF (@STAT<4).                         /*CI.
            COMPUTE loESia = ESia*EXP(-@Z*#SEia).
            COMPUTE upESia = ESia*EXP(@Z*#SEia).
         ELSE.
            COMPUTE loESia = ESia - @Z*#SEia.
            COMPUTE upESia = ESia + @Z*#SEia.
         END IF.
         COMPUTE pctCHia=100*(ESia-ESIV)/ESIV.       /*Percentage of change of the statistic.

*        Summatories for the homogeneity Q Test.
         COMPUTE @Qia=WIV*(LNES - LNESia)**2.
         TEMPORARY.
         DO IF (@I=!I).       /*Exclude study i from the influence analysis calculations.
            COMPUTE @Qia=0.
         END IF.
         AGGREGATE  /OUTFILE=* MODE=ADDVARIABLES /MISSING=COLUMNWISE /PRESORTED
           /BREAK=@1
           /!Qia=SUM(@Qia).

         COMPUTE pQia= (1- CDF.CHISQ(ABS(!Qia),COUNT-2)).      /*Homogeneity Q test.
         COMPUTE #Hi=SQRT(!Qia/(COUNT-2)).
         COMPUTE I2ia=100*(#Hi**2-1)/#Hi**2.       /*I2 Statistic.
         IF (I2ia<0) I2ia=0.

         !IF (!INFLU=1) !THEN.
            DO IF ($CASENUM=!COUNT AND @ERROR=0).
               DO IF (NOT SYSMIS(ESIV)).
                  DO IF (@STAT<4 OR @STAT=6).
                     PRINT /@STUDY(A8) '|'10 ESia(T11,F10.4) loESia(T22,F10.4) ' to' upESia(F10.4) '|'46 pctChia(F6.1) '%' '|'55 I2ia(F5.1)'%' pQia(T64,F5.4) '|'70 @Wia(T74,PCT5.1)  '|'80.
                  ELSE.
                     PRINT /@STUDY(A8) '|'10 ESia(T12,F9.7)  loESia(T23,F9.7) ' to ' upESia(F9.7)  '|'46 pctChia(F6.1) '%' '|'55 I2ia(F5.1)'%' pQia(T64,F5.4) '|'70 @Wia(T74,PCT5.1)  '|'80.
                  END IF.
               END IF.
            END IF.
            EXECUTE.
         !IFEND.
      !IFEND.

      !IF (!METHODU='MH') !THEN.          /*Influence analysis: MH.
         !LET !NumESMHia=!CONCAT('NumESMHia',!I).      /*Summatories parameters.
         !LET !DenESMHia=!CONCAT('DenESMHia',!I).
         !LET !Ria=!CONCAT('Ria',!I).
         !LET !Sia=!CONCAT('Sia',!I).
         !LET !PRia=!CONCAT('PRia',!I).
         !LET !QSia=!CONCAT('QSia',!I).
         !LET !PSQRia=!CONCAT('PSQRia',!I).
         !LET !NumSEia=!CONCAT('NumSEia',!I).
         !LET !DenSE1ia=!CONCAT('DenSE1ia',!I).
         !LET !DenSE2ia=!CONCAT('DenSE2ia',!I).

         !IF (!I=!COUNT) !THEN.
            COMPUTE @Wia=rWMH.
         !ELSE.
            COMPUTE @Wia=LAG(rWMH,!LAG).          /*@Wia: for each LOOP has the weight of the study in the last row.
         !IFEND.

*        Summatories.
         TEMPORARY.
         DO IF (@I=!I).       /*Exclude study i from the influence analysis calculations.
            DO REPEAT VAR = NumESMHi DenESMHi Ri Si PRi QSi PSQRi NumSEi DenSE1i DenSE2i.
               COMPUTE VAR=0.
            END REPEAT.
         END IF.
         AGGREGATE  /OUTFILE=* MODE=ADDVARIABLES /MISSING=COLUMNWISE /PRESORTED
           /BREAK=@1
           /!NumESMHia=SUM(NumESMHi) /!DenESMHia=SUM(DenESMHi) /!Ria=SUM(Ri) /!Sia=SUM(Si) /!PRia=SUM(PRi) /!QSia=SUM(QSi) /!PSQRia=SUM(PSQRi) 
           /!NumSEia=SUM(NumSEi) /!DenSE1ia=SUM(DenSE1i) /!DenSE2ia=SUM(DenSE2i).

         COMPUTE ESia=!NumESMHia/!DenESMHia.     /*Weighted statistic.
         DO IF (@STAT=1).                        /*SE.
            COMPUTE #SEia = SQR(!PRia/(2*(!Ria**2)) + !PSQRia/(2*!Ria*!Sia) + !QSia/(2*(!Sia**2))).
         ELSE IF (@STAT=2 OR @STAT=3).
            COMPUTE #SEia = SQR(!NumSEia/(!DenSE1ia*!DenSE2ia)).
         END IF.
         COMPUTE loESia= ESia*EXP(-@Z*#SEia).     /*CI.
         COMPUTE upESia= ESia*EXP(@Z*#SEia).
         COMPUTE pctChia=100*(ESia-ESMH)/ESMH.   /*Percentage of change of the statistic.

         !IF (!INFLU=1) !THEN.
            DO IF ($CASENUM=!COUNT AND @ERROR=0).
               PRINT /@STUDY(A8) '|'10 ESia(T11,F10.4) loESia(T22,F10.4) ' to' upESia(F10.4) '|'46 pctChia(F6.1) '%' '|'55 @Wia(T59,PCT5.1) '|'65.
            END IF.
            EXECUTE.
         !IFEND.
      !IFEND.

      !IF (!METHODU='PETO') !THEN.          /*Influence analysis: PETO.
         !LET !SUMOEia=!CONCAT('SUMOEia',!I).      /*Summatories parameters.
         !LET !SUMVia=!CONCAT('SUMVia',!I).

         !IF (!I=!COUNT) !THEN.
            COMPUTE @Wia=rWP.
         !ELSE.
            COMPUTE @Wia=LAG(rWP,!LAG).          /*@Wia: for each LOOP has the weight of the study in the last row.
         !IFEND.

*        Summatories.
         TEMPORARY.
         DO IF (@I=!I).       /*Exclude study i from the influence analysis calculations.
            DO REPEAT VAR = SUMOEi SUMVi.
               COMPUTE VAR=0.
            END REPEAT.
         END IF.
         AGGREGATE  /OUTFILE=* MODE=ADDVARIABLES /MISSING=COLUMNWISE /PRESORTED
           /BREAK=@1
           /!SUMOEia=SUM(SUMOEi) /!SUMVia=SUM(SUMVi) .

         COMPUTE ESia=EXP(!SUMOEia/!SUMVia).       /*Weighted statistic.
         COMPUTE #SEia=SQR(1/!SUMVia).             /*SE.
         COMPUTE loESia= ESia*EXP(-@Z*#SEia).      /*CI.
         COMPUTE upESia= ESia*EXP(@Z*#SEia).
         COMPUTE pctChia=100*(ESia-ORpeto)/ORpeto. /*Percentage of change of the statistic.

         !IF (!INFLU=1) !THEN.
            DO IF ($CASENUM=!COUNT AND @ERROR=0).
               PRINT /@STUDY(A8) '|'10 ESia(T11,F10.4) loESia(T22,F10.4) ' to' upESia(F10.4) '|'46 pctChia(F6.1) '%' '|'55 @Wia(T59,PCT5.1) '|'65.
            END IF.
            EXECUTE.
         !IFEND.
      !IFEND.
   !DOEND.

   !IF (!INFLU=1) !THEN.
      DO IF ($CASENUM=1 AND @ERROR=0).              /*Print table end.
         DO IF (@METHOD=1 OR @METHOD=2).            /*IOV - FEM method (and REM, by default).
            DO IF (NOT SYSMIS(ESIV)).
               PRINT /'---------+-----------------------------------+--------+--------------+---------+'.
               DO IF (@STAT<4).
                  PRINT /'    NONE |' ESIV(T11,F10.4) loESIV(T22,F10.4) ' to' upESIV(F10.4) '|'46 ' .0%'50  '|'55 I2(F5.1) '%  '  pQIV(F5.4) '|'70  '100% |'75 .
               ELSE.
                  PRINT /'    NONE |' ESIV(T12,F9.7)  loESIV(T23,F9.7) ' to ' upESIV(F9.7)  '|'46 ' .0%'50  '|'55 I2(F5.1) '%  '  pQIV(F5.4) '|'70  '100% |'75 .
               END IF.
               PRINT /'---------+-----------------------------------+--------+--------------+---------+'.
               DO IF (@METHOD=2).
                  PRINT /'(*)Not yet available for Random Effect Model.'.
                  PRINT /'   You can perform it suppressing one study and rerunning the macro.'.
               END IF.
            END IF.
         ELSE IF (@METHOD=3).
            PRINT /'---------+-----------------------------------+--------+---------+'.
            PRINT /'    NONE |' ESMH(T11,F10.4) loESMH(T22,F10.4) ' to' upESMH(F10.4) '|'46 ' .0%'50  '|'55 '100% |'60 .
            PRINT /'---------+-----------------------------------+--------+---------+'.
         ELSE IF (@METHOD=4).
            PRINT /'---------+-----------------------------------+--------+---------+'.
            PRINT /'    NONE |' ORpeto(T11,F10.4) loORpeto(T22,F10.4) ' to' upORpeto(F10.4) '|'46 ' .0%'50  '|'55 '100% |'60 .
            PRINT /'---------+-----------------------------------+--------+---------+'.
         END IF.
      END IF.
      EXECUTE.
   !IFEND.

*  Compute variable Prop if needed.
   !IF (!PROPU='EXPO' !OR !PROPU='EXCTR' !OR !PROPU='RESP' !OR !PROPU='REUEX') !THEN.
      !IF (!PROPU='EXPO') !THEN.
         COMPUTE Prop = N1/N.
         IF (@STAT=3) Prop = T1/T.
      !IFEND.
      !IF (!PROPU='EXCTR') !THEN.
         COMPUTE Prop = B1/M0.            
      !IFEND.
      !IF (!PROPU='RESP') !THEN.
         COMPUTE Prop = M1/N.
         IF (@STAT=3) Prop = M1/T.
      !IFEND.
      !IF (!PROPU='REUEX') !THEN.
         COMPUTE Prop = A0/N0.
         IF (@STAT=3) Prop = A0/T0.
      !IFEND.
   !IFEND.

***CUMULATIVE ANALYSIS.
   !IF (!PrintCUM=1) !THEN.
      COMPUTE @SORT=$CASENUM.
      SORT CASES BY !VarCUM.           /*Order the studies by the VarCUM (RANK or PROP) variable.
      SET RESULTS OFF  ERRORS OFF.
      CREATE @I=CSUM(@1).           /*Create the sequence variable.
      SET RESULTS ON  ERRORS ON.
      !IF (!METHODU='FEM' !OR !METHODU='REM') !THEN.      /*Cumulative analysis: IoV - FEM.
         SET RESULTS OFF  ERRORS OFF.
         CREATE NESIVc=CSUM(NESIVi) /SWIVc=CSUM(WIV).    /*Cumulative SUM for cumulative analysis.
         SET RESULTS ON ERRORS ON.
         
         COMPUTE ESc=NESIVc/SWIVc.                 /*Estimation of the statistic.
         IF (@STAT<4) ESc=EXP(ESc).
         COMPUTE #SEIVc = SQR(1/SWIVc).            /*SE.
         DO IF (@STAT<4).
            COMPUTE loESc= ESc*EXP(-@Z*#SEIVc).    /*CI.
            COMPUTE upESc= ESc*EXP(@Z*#SEIVc).
         ELSE.
            COMPUTE loESc= ESc - @Z*#SEIVc.
            COMPUTE upESc= ESc + @Z*#SEIVc.
         END IF.
      !IFEND.

      !IF (!METHODU='MH') !THEN.      /*Cumulative analysis: MH.
         SET RESULTS OFF ERRORS OFF.    /*Cumulative SUM for cumulative analysis.
         CREATE NumESMHc=CSUM(NumESMHi) /DenESMHc=CSUM(DenESMHi) 
               /Rc=CSUM(Ri) /Sc=CSUM(Si) /PRc=CSUM(PRi) /QSc=CSUM(QSi) /PSQRc=CSUM(PSQRi) 
               /NumSEc=CSUM(NumSEi) /DenSE1c=CSUM(DenSE1i) /DenSE2c=CSUM(DenSE2i).
         SET RESULTS ON ERRORS ON.

         COMPUTE ESc=NumESMHc/DenESMHc.         /*Estimation of the statistic.
         DO IF (@STAT=1).                       /*SE.
            COMPUTE #SEMHc = SQR(PRc/(2*(Rc**2)) + PSQRc/(2*Rc*Sc) + QSc/(2*(Sc**2))).
         ELSE IF (@STAT=2 OR @STAT=3).
            COMPUTE #SEMHc = SQR(NumSEc/(DenSE1c*DenSE2c)).
         END IF.
         COMPUTE loESc= ESc*EXP(-@Z*#SEMHc).    /*CI.
         COMPUTE upESc= ESc*EXP(@Z*#SEMHc).
      !IFEND.

      !IF (!METHODU='PETO') !THEN.      /*Cumulative analysis: PETO.
         SET RESULTS OFF ERRORS OFF.
         CREATE SUMOEc=CSUM(SUMOEi) /SUMVc=CSUM(SUMVi).    /*Cumulative SUM for cumulative analysis.
         SET RESULTS ON ERRORS ON.

         COMPUTE ESc=EXP(SUMOEc/SUMVc).       /*Estimation of the statistic.
         COMPUTE #SEPc=SQR(1/SUMVc).          /*SE.
         COMPUTE loESc= ESc*EXP(-@Z*#SEPc).   /*CI.
         COMPUTE upESc= ESc*EXP(@Z*#SEPc).
      !IFEND.

******Print CUMULATIVE META-ANALYSIS except METHOD=REM.
      !IF (!METHODU<>'REM') !THEN.
         DO IF (@ERROR=0).
            DO IF (NOT SYSMIS(ESIV) OR @METHOD>2).
               DO IF ($CASENUM=1).
                  PRINT//'-----------------------------+----------- CUMULATIVE META-ANALYSIS ------------+'.
                  DO IF (@METHOD=1).
                     PRINT /'                             |       IoV estimation: Fixed effects model       |'.
                  ELSE IF (@METHOD=3).
                     PRINT /'                             |           Mantel-Haenszel estimation            |'.
                  ELSE IF (@METHOD=4).
                     PRINT /'                             |                  Peto estimation                |'.
                  END IF.
                  PRINT /'                             |Number of|            |  ' @CL(F2) '% Confidence Interval |'.
                  PRINT /'STUDY    ' !QUOTE(!VarCUM) '|'17  @EStitle(T23,A2) '| studies |'30 @EStitle(T47,A2) '    |       Lower        Upper |'.
                  PRINT /'----------------+------------+---------+------------+--------------------------+'.
               END IF.
               
               DO IF ($CASENUM=1).
                  DO IF (@METHOD=4).
                     PRINT /STUDY(A8) !VarCUM(T10,!FormatCUM) '|'17 ORp(T19,!FORMAT) '|'30 @I(T36,F3) '|'40 ORp(T42,!FORMAT) '|'53 LOp(T56,!FORMAT) UPp(T69,!FORMAT) '|'80.
                  ELSE.
                     PRINT /STUDY(A8) !VarCUM(T10,!FormatCUM) '|'17 ES(T19,!FORMAT) '|'30 @I(T36,F3) '|'40 ES(T42,!FORMAT) '|'53 LO(T56,!FORMAT) UP(T69,!FORMAT) '|'80.
                  END IF.
               ELSE.
                  DO IF (@METHOD=4).
                     PRINT /STUDY(A8) !VarCUM(T10,!FormatCUM) '|'17 ORp(T19,!FORMAT) '|'30 @I(T36,F3) '|'40 ESc(T42,!FORMAT) '|'53 loESc(T56,!FORMAT) upESc(T69,!FORMAT) '|'80.
                  ELSE.
                     PRINT /STUDY(A8) !VarCUM(T10,!FormatCUM) '|'17 ES(T19,!FORMAT) '|'30 @I(T36,F3) '|'40 ESc(T42,!FORMAT) '|'53 loESc(T56,!FORMAT) upESc(T69,!FORMAT) '|'80.
                  END IF.
               END IF.

               DO IF ($CASENUM=COUNT).
                  PRINT /'----------------+------------+---------+------------+--------------------------+'.
               END IF.
            END IF.
         END IF.
      !IFEND.
      EXECUTE.

      !IF (!METHODU='REM') !THEN.      /*Cumulative analysis: IoV - REM.
         DO IF (@ERROR=0).
            DO IF (NOT SYSMIS(ESIV)).
               DO IF ($CASENUM=1).
                  PRINT//'-----------------------------+----------- CUMULATIVE META-ANALYSIS ------------+'.
                  PRINT /'                             |       IoV estimation: Random effects model      |'.
                  PRINT /'                             |Number of|            |  ' @CL(F2) '% Confidence Interval |'.
                  PRINT /'STUDY    ' !QUOTE(!VarCUM) '|'17  @EStitle(T23,A2) '| studies |'30 @EStitle(T47,A2) '    |       Lower        Upper |'.
                  PRINT /'----------------+------------+---------+------------+--------------------------+'.
               END IF.
            END IF.
         END IF.
         EXECUTE.

         COMPUTE EScrg = $SYSMIS.
         COMPUTE loEScrg = $SYSMIS.
         COMPUTE upEScrg = $SYSMIS.
         !DO !I = 1 !TO !COUNT.
            !LET !tempESc = !CONCAT('tempESc',!I).
            !LET !Qc = !CONCAT('Qc',!I).
            !LET !SWIVc = !CONCAT('SWIVc',!I).
            !LET !SWIV2c = !CONCAT('SWIV2c',!I).
            !LET !NESIVc = !CONCAT('NESIVc',!I).
            !LET !DESIVc = !CONCAT('DESIVc',!I).

            TEMPORARY.              /*Use the previously computed IoV - REM result.
            SELECT IF (@I=!I).
            DATASET DECLARE @967CUMi WINDOW=HIDDEN.
            AGGREGATE  /OUTFILE='@967CUMi' /PRESORTED
              /BREAK=@1
              /!tempESc=FIRST(ESc).
            MATCH FILES /FILE=* /TABLE='@967CUMi' /BY  @1.
            IF (@STAT<4) !tempESc=LN(!tempESc).
            EXECUTE.
            DATASET CLOSE @967CUMi.

            TEMPORARY.              /*Summatories: compute Qc for each loop and get Tau2.
            SELECT IF (@I<=!I).
            COMPUTE Qci=WIV*(LNES-!tempESc)**2.
            AGGREGATE  /OUTFILE=* MODE=ADDVARIABLES /MISSING=COLUMNWISE /PRESORTED
              /BREAK=@1
              /!Qc=SUM(Qci) /!SWIVc=SUM(WIV) /!SWIV2c=SUM(WIV2).
            COMPUTE Tau2C=0.
            IF (!SWIVc-!SWIV2c/!SWIVc)<> 0 Tau2c=MAX(0,(!Qc-!I+1)/(!SWIVc-!SWIV2c/!SWIVc)).
            
            TEMPORARY.              /*With Tau2, compute the summatories for the weighted statistic.
            SELECT IF (@I<=!I).
            COMPUTE WIVci=1/(SE**2+Tau2c).
            COMPUTE NESIVci=WIVci*LNES. 
            AGGREGATE  /OUTFILE=* MODE=ADDVARIABLES /MISSING=COLUMNWISE /PRESORTED
              /BREAK=@1
              /!NESIVc=SUM(NESIVci) /!DESIVc=SUM(WIVci).

            COMPUTE #LNESIVc = !NESIVc / !DESIVc.
            COMPUTE EScr = EXP(#LNESIVc).           /*Weighted statistic.
            IF (@STAT>3) EScr=#LNESIVc.
            COMPUTE #SEIVc = SQR(1/!DESIVc).        /*Standard error.
            DO IF (@STAT<4).                        /*CI.
               COMPUTE loEScr = EScr*EXP(-@Z*#SEIVc).
               COMPUTE upEScr = EScr*EXP(@Z*#SEIVc).
            ELSE.
               COMPUTE loEScr = EScr - @Z*#SEIVc.
               COMPUTE upEScr = EScr + @Z*#SEIVc.
            END IF.

*           Graph variables.
            IF (@I=!I) EScrg = EScr.
            IF (@I=!I) loEScrg = loEScr.
            IF (@I=!I) upEScrg = upEScr.
            
            DO IF (@ERROR=0 AND @I=!I).
               !IF (!I=1) !THEN.
                  PRINT /STUDY(A8) !VarCUM(T10,!FormatCUM) '|'17 ES(T19,!FORMAT) '|'30 @I(T36,F3) '|'40 ES(T42,!FORMAT) '|'53 LO(T56,!FORMAT) UP(T69,!FORMAT) '|'80.
               !ELSE.
                  PRINT /STUDY(A8) !VarCUM(T10,!FormatCUM) '|'17 ES(T19,!FORMAT) '|'30 @I(T36,F3) '|'40 EScr(T42,!FORMAT) '|'53 loEScr(T56,!FORMAT) upEScr(T69,!FORMAT) '|'80.
               !IFEND.
            END IF.
            EXECUTE.
         !DOEND.

         DO IF (@ERROR=0).
            DO IF (NOT SYSMIS(ESIV)).
               DO IF ($CASENUM=COUNT).
                  PRINT /'----------------+------------+---------+------------+--------------------------+'.
               END IF.
            END IF.
         END IF.
      !IFEND.
      SORT CASES BY @SORT.
   !IFEND.

***SIZE (PRINT=W[pt]).
   !IF (!WEIGHT=1) !THEN.
*     Find the minimal weights.
      AGGREGATE  /OUTFILE=* MODE=ADDVARIABLES /PRESORTED
        /BREAK=@1
        /WPmin=MIN(V) /WMHmin=MIN(WMH) /WIVmin=MIN(WIV) /WIVrmin=MIN(WIVr).
*     Compute SIZEs for each weights.
      COMPUTE SIZEP = (SQR(V)*@PT) / SQR(WPmin).
      COMPUTE SIZEMH = (SQR(WMH)*@PT) / SQR(WMHmin).
      COMPUTE SIZEIV = (SQR(WIV)*@PT) / SQR(WIVmin).
      COMPUTE SIZEIVr = (SQR(WIVr)*@PT) / SQR(WIVrmin).

*     Print results.
      DO IF (@ERROR=0).
         DO IF ($CASENUM=1).
            PRINT//'Studies weights in pt for graphical representations'.
            PRINT /'Minimum font size: S=' @PT(F2) ' pt.'.
            DO IF (@TYPE=1 AND @STAT=1).
               PRINT /'----------------+----------+---------------------------------------------------+'.
               PRINT /'                |          |               Relative Weights                    |'.
               PRINT /'                |          |     Peto   |      MH    |   IV_FEM   |   IV_REM   |'.
               PRINT /'STUDY    RANK   |    OR    |   W   S(pt)|   W   S(pt)|   W   S(pt)|   W   S(pt)|'.
               PRINT /'----------------+----------+------------+------------+------------+------------+'.
            ELSE IF (@TYPE=1 AND (@STAT=2 OR @STAT=3)).
               PRINT /'----------------+----------+-----------------------------------------+'.
               PRINT /'                |          | Relative MH |   Relative IoV Weights    |'.
               PRINT /'                |          |    Weights  | Fixed Effect|Random Effect|'.
               PRINT /'STUDY    RANK   |' @EStitle(T22,A2)  '    |   W    S(pt)|   W    S(pt)|   W    S(pt)|'.
               PRINT /'----------------+----------+-------------+-------------+-------------+'.
            ELSE.
               PRINT /'----------------+----------+---------------------------+'.
               PRINT /'                |          |   Relative IoV Weights    |'.
               PRINT /'                |          | Fixed Effect|Random Effect|'.
               PRINT /'STUDY    RANK   |' @EStitle(T22,A2)  '    |   W    S(pt)|   W    S(pt)|'.
               PRINT /'----------------+----------+-------------+-------------+'.
            END IF.
         END IF.

         DO IF (@TYPE=1 AND @STAT=1).
            DO IF (@METHOD=4).
               PRINT /STUDY(A8) RANK(T10,F6.1) '|'17 ORp(T19,F8.4) '|'28 rWP(T30,PCT5.1) SIZEP(T36,F4) '|'41 rWMH(T43,PCT5.1) SIZEMH(T49,F4) '|'54 rWIV(T56,PCT5.1) SIZEIV(T62,F4) '|'67 rWIVr(T69,PCT5.1) SIZEIVr(T75,F4) '|'80.
            ELSE.
               PRINT /STUDY(A8) RANK(T10,F6.1) '|'17 ES(T19,F8.4)  '|'28 rWP(T30,PCT5.1) SIZEP(T36,F4) '|'41 rWMH(T43,PCT5.1) SIZEMH(T49,F4) '|'54 rWIV(T56,PCT5.1) SIZEIV(T62,F4) '|'67 rWIVr(T69,PCT5.1) SIZEIVr(T75,F4) '|'80.
            END IF.
         ELSE IF (@TYPE=1 AND (@STAT=2 OR @STAT=3)).
            PRINT /STUDY(A8) RANK(T10,F6.1) '|'17 ES(T19,F8.4) '|'28 rWMH(T30,PCT5.1) SIZEMH(T36,F5) '|'42 rWIV(T44,PCT5.1) SIZEIV(T50,F5) '|'56 rWIVr(T58,PCT5.1) SIZEIVr(T64,F5) '|'70.
         ELSE.
            PRINT /STUDY(A8) RANK(T10,F6.1) '|'17 ES(T19,F8.4) '|'28 rWIV(T30,PCT5.1) SIZEIV(T36,F5) '|'42 rWIVr(T44,PCT5.1) SIZEIVr(T50,F5) '|'56.
         END IF.

         DO IF ($CASENUM=COUNT).
            DO IF (@TYPE=1 AND @STAT=1).
               PRINT /'---------------------------+------------+------------+------------+------------+'.
               PRINT /'                      TOTAL|  100%      |  100%      |  100%      |  100%      |'.
               PRINT /'---------------------------+------------+------------+------------+------------+'.
            ELSE IF (@TYPE=1 AND (@STAT=2 OR @STAT=3)).
               PRINT /'---------------------------+-------------+-------------+-------------+'.
               PRINT /'                      TOTAL|  100%       |  100%       |  100%       |'.
               PRINT /'---------------------------+-------------+-------------+-------------+'.
            ELSE.
               PRINT /'---------------------------+-------------+-------------+'.
               PRINT /'                      TOTAL|  100%       |  100%       |'.
               PRINT /'---------------------------+-------------+-------------+'.
            END IF.
         END IF.
      END IF.
      EXECUTE.
   !IFEND.

   !LET !AuxVars=''
   !LET !ParamN=''.
***Print BEGG, EGGER publication bias (PRINT=BEGG, EGGER).
   !IF (!BEGG=1 !OR !EGGER=1) !THEN.
      !IF (!STATU='OR' !OR !STATU='RR' !OR !STATU='IR') !THEN.
*        Those results only make sense with STAT=OR,RR,IR.
*        Get the name of the estimated statistic according to the METHOD.
         !IF (!METHODU='FEM') !THEN.
            !LET !ESp = 'ESIV'.
            !LET !SEp = 'SEIV'.
         !IFEND.
         !IF (!METHODU='REM') !THEN.
            !LET !ESp = 'ESIVr'.
            !LET !SEp = 'SEIVr'.
         !IFEND.
         !IF (!METHODU='MH') !THEN.
            !LET !ESp = 'ESMH'.
            !LET !SEp = 'SEMH'.
         !IFEND.
         !IF (!METHODU='PETO') !THEN.
            !LET !ESp = 'ORpeto'.
            !LET !SEp = 'SEpeto'.
         !IFEND.
*        Get the name of study data according to METHOD and DATA.
         !LET !ESi=!CONCAT('ln',!STATU).
         !IF (!DATAU='RAW') !THEN.
            COMPUTE !ESi=LN(ES).
            !LET !SEi = 'SE'.
            !IF (!METHODU='PETO') !THEN.
               COMPUTE !ESi = LN(ORp).
               !LET !SEi = 'SEp'.
            !IFEND.
         !ELSE.
            COMPUTE !ESi=LNES.
            !LET !SEi = 'SE'.
         !IFEND.
         
         !IF (!BEGG=1) !THEN.
*           Compute Begg T, VT results and print NONPAR CORR table.
            TEMPORARY.
            N 1.
            PRINT //'BEGG PUBLICATION BIAS'.
            EXECUTE.
            COMPUTE VT= (!SEi**2) - (!SEp**2).
            COMPUTE T = (!ESi - LN(!Esp))/SQRT(VT).
            OMS /SELECT ALL /EXCEPTIF COMMANDS=['Non Par Corr'] SUBTYPES=['Correlations'] /DESTINATION VIEWER=NO.
            NONPAR CORR VARIABLES= T WITH VT n /PRINT=KENDALL.
            OMSEND.
            !IF (!TYPE<>'RAW') !THEN.
               !LET !ParamN='N'.
            !IFEND.
            !LET !AuxVars = !CONCAT(!AuxVars,' ','VT T').
         !IFEND.
         !IF (!EGGER=1) !THEN.
*           Compute Egger Y, E results and print REGRESSION table.
            TEMPORARY.
            N 1.
            PRINT //'EGGER PUBLICATION BIAS'.
            EXECUTE.
            COMPUTE Y= !ESi / !SEi.
            COMPUTE E = 1 / !SEi.
            VARIABLE LABELS Y !QUOTE(!CONCAT('ln', !STATU, ' / SE')) /E 'Precision'.
            PRESERVE.
            SET TVARS=LABELS.
            OMS /SELECT ALL /EXCEPTIF COMMANDS=['Regression'] SUBTYPES=['Coefficients'] /DESTINATION VIEWER=NO.
            REGRESSION STATISTICS COEFF CI /DEPENDENT Y /METHOD=ENTER E.
            OMSEND.
            RESTORE.
            !LET !AuxVars = !CONCAT(!AuxVars,' ','Y E').
         !IFEND.
      !IFEND.
   !IFEND.

***Print Macaskill publication bias (PRINT=MACASK).
   !IF (!MACASK=1) !THEN.
*     Compute WProp (if possible) and print REGRESSION table(s) for Macaskill publication bias.
      !LET !ESm=!CONCAT('ln',!STATU).
      !IF (!DATAU='RAW') !THEN.
         COMPUTE !ESm=LN(ES).
      !ELSE.
         COMPUTE !ESm=LNES.
      !IFEND.
      TEMPORARY.
      N 1.
      PRINT //'MACASKILL PUBLICATION BIAS'.
      EXECUTE.
      PRESERVE.
      SET TVARS=LABELS.
      OMS /SELECT ALL /EXCEPTIF COMMANDS=['Regression'] SUBTYPES=['Coefficients'] /DESTINATION VIEWER=NO.
      COMPUTE WProp= N*Prop*(1-Prop).
      VARIABLE LABELS !ESm !QUOTE(!CONCAT('ln',!STATU)).
      REGRESSION REGWGT=Wprop /STATISTICS COEFF CI /DEPENDENT !ESm /METHOD=ENTER N.
      COMPUTE rN= 1/N.
      FORMATS rN (F6.5).
      VARIABLE LABELS rN '1/N'.
      REGRESSION REGWGT=Wprop /STATISTICS COEFF CI /DEPENDENT !ESm /METHOD=ENTER rN.
      OMSEND.
      RESTORE.
      !IF (!TYPE<>'RAW') !THEN.
         !LET !ParamN='N'.
      !IFEND.
      !LET !AuxVars = !CONCAT(!AuxVars,' ','Wprop').
   !IFEND.
   
***Print Number of Unpublished Studies (PRINT=NUS).
   !IF (!NUS=1) !THEN.
      !IF (!STATU='OR' !OR !STATU='RR' !OR !STATU='IR') !THEN.
*        Those results only make sense with STAT=OR,RR,IR.
         !LET !pNUS = 'p'.
         !IF (!DATAU='RAW') !THEN.
*           If DATA=RAW, the significance p is already computed.
            !IF (!METHODU='PETO') !THEN.
               !LET !pNUS = 'pPETO'.
            !IFEND.
         !ELSE.
*           For summary parameters, compute p significance from statistic and standard error.
            COMPUTE !pNUS = 2*(1-CDFNORM(ABS(LNES/SE))).
         !IFEND.
         !IF (!DATAU='RAW') !THEN.
            DO IF (ANY(@STAT,1,2,4)).     /*MH Chi-Square and signification (p).
               COMPUTE z= SQRT((N-1)*((A1*N-N1*M1)**2)/(M1*M0*N1*N0)) .
            ELSE.
               COMPUTE z= SQRT(((A1*T-T1*M1)**2)/(M1*T1*T0)) .
            END IF.
         !ELSE.
            COMPUTE z= LNES/SE.
         !IFEND.
         !LET !AuxVars = !CONCAT(!AuxVars,' ',!pNUS,' z').
*        Order by p (keep previous order on @SORT).
         COMPUTE @SORT = $CASENUM.
         SORT CASES BY !pNUS.
*        Use AGGREGATE to compute Pmax and M.
         COMPUTE @U=1.
         COMPUTE RP=$CASENUM.
         AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /BREAK=@U /@Mnus = FLT(!pNUS !Pcut) 
            /@Pmax = MAX(!pNUS) /@Pmin = MIN(!pNUS) /@Knus=N /SUMz=SUM(z).
         COMPUTE @Mnus=@Mnus*@Knus.
         COMPUTE @Pcut0 = $SYSMIS.
         COMPUTE F = (SUMz**2)/2.706 - @Knus.
         COMPUTE F = TRUNC(F+1).
         IF (RP = @Mnus) @Pcut0 = !pNUS.
         AGGREGATE  /OUTFILE=* MODE=ADDVARIABLES OVERWRITE=YES /BREAK=@U /@Pcut = MAX(@Pcut0).
         FORMATS !pNUS @Pmax @Pmin @Pcut(F5.4) RP @Knus @Mnus(F2) F(F7.0).

*        Compute and print results: do it with N 1.         
         TEMPORARY.
         N 1.
         PRINT //'PUBLICATION BIAS'.
*        Print Rosenthal method.
         PRINT // 'RESISTANCE FOR FUTURE NULL RESULTS (ROSENTHAL model)'.
         PRINT  / 'Number of additional non-significant studies that is necessary'.
         PRINT  / 'to add a significant meta-analysis for becoming non-significant .......' F.
         EXECUTE.

*        Print p for each study, sorted: use data of the table.
         DO IF ($CASENUM=1).
            PRINT // 'GLESER-OLKIN Models'.
            PRINT  /'---------+----+--------+'.
            PRINT  /'Study    | RP |    P   |'.
            PRINT  /'---------+----+--------+'.
         END IF.
         EXECUTE.
         PRINT  /STUDY(A8) '|'10 RP(T12,F2) '|'15 !Pnus(T18,F5.4) '|'24.
         EXECUTE.
         DO IF ($CASENUM=1).
            PRINT  /'---------+----+--------+'.
         END IF.
         EXECUTE.

         TEMPORARY.
         N 1.
         DO IF (@Mnus > 0).
*            Gleser-Olkin model.
             COMPUTE #Ngo = TRUNC((@Knus-1)/@Pmax - @Knus).
             COMPUTE #NgoG= TRUNC((@Mnus-1)/@Pcut - @Knus).
*            Gleser-Olkin model: lower bound of the CI.
             COMPUTE #Q = $SYSMIS.
             COMPUTE #Qg= $SYSMIS. 
             LOOP #I=0 TO 999.
*               Simple model.
                COMPUTE #F = (#I+1)*@Pmax/(@Knus*(1-@Pmax)).
                COMPUTE #IDF = IDF.F((100-!CL)/100, 2*@Knus, 2*(#I+1)).
                IF (SYSMIS(#Q) AND #IDF < #F) #Q = #I.
*               Generalized simple model.
                COMPUTE #F= (#I+1)*@Pcut/(@Mnus*(1-@Pcut)).
                COMPUTE #IDF= IDF.F((100-!CL)/100, 2*@Mnus, 2*(#I+1)).
                IF (SYSMIS(#Qg) AND #IDF < #F) #Qg = #I.
                DO IF ((NOT SYSMIS(#Q)) AND (NOT SYSMIS(#Qg))).
                   BREAK.
                END IF.
             END LOOP.
             COMPUTE #NL = #Q.
             COMPUTE #NLg= #Qg - @Knus + @Mnus.
         END IF.
         COMPUTE #Pcut0 = !PCUT.

*        PRINT table with results.         
         PRINT  / 'Number of reported studies..............: ' @Knus. 
         PRINT  / 'Largest reported p-value................: ' @Pmax.
         PRINT  / 'Smallest reported p-value...............: ' @Pmin.
         PRINT  / 'P cut for select smallest p-values......: ' #Pcut0 (F3.2). 
         PRINT  / 'Number of studies with smallest p-values: ' @Mnus. 
         PRINT  / 'Maximum of the smallest p-values........: ' @Pcut. 
         DO IF (@Mnus > 0).
             PRINT  / '+---------------------+-----------------------------+'.
             PRINT  / '|                     |NUMBER OF UNPUBLISHED STUDIES|'.
             PRINT  / '|                     |              | Generalized  |'.
             PRINT  / '|                     | Simple model | Simple model |'.
             PRINT  / '+---------------------+--------------+--------------+'.
             PRINT  / '| Unbiased Estimation |'#Ngo(T24,F9)'|'38 #NgoG(T39,F9) '|'53.
             DO IF (#NgoG >= 0). 
                PRINT /'|  '!QUOTE(!CL)'% CI Lower bound |'#NL(F9.0)'     |'#NLg(F9.0)'     |'.
             ELSE.
                PRINT /'|  '!QUOTE(!CL)'% CI Lower bound |'#NL(F9.0)'     |  unestimable |'.
             END IF.
             PRINT  / '+---------------------+--------------+--------------+'.
         ELSE.
             PRINT / 'NUMBER OF UNPUBLISHED STUDIES = Not estimable'.
         END IF.
         EXECUTE.
      !IFEND.
   !IFEND.
   
***Generate GRAPHICS.
   !IF (!GRAPHU<>!NULL) !THEN.
      DO IF ($CASENUM=1).
         PRINT /'GRAPH = ' !QUOTE(!GRAPHU).
      END IF.
      COMPUTE @ORDER=$CASENUM.      /*Variable to restore original order.
*     Add combined results to the data.
      !IF (!METHODU='PETO') !THEN.
         !LET !AGG='/ES=LAST(ORpeto) /LO=LAST(loORpeto) /UP=LAST(upORpeto) /SE=LAST(SEpeto)'.
      !IFEND.
      !IF (!METHODU='MH') !THEN.
         !LET !AGG='/ES=LAST(ESMH) /LO=LAST(loESMH) /UP=LAST(upESMH) /SE=LAST(SEMH)'.
      !IFEND.
      !IF (!METHODU='FEM') !THEN.
         !LET !AGG='/ES=LAST(ESIV) /LO=LAST(loESIV) /UP=LAST(upESIV) /SE=LAST(SEIV)'.
      !IFEND.
      !IF (!METHODU='REM') !THEN.
         !LET !AGG='/ES=LAST(ESIVr) /LO=LAST(loESIVr) /UP=LAST(upESIVr) /SE=LAST(SEIVr)'.
      !IFEND.
      DATASET DECLARE @967COMB WINDOW=HIDDEN.
      AGGREGATE  /OUTFILE='@967COMB' /PRESORTED
        /BREAK=@1
        !AGG.
      ADD FILES /FILE=* /FILE='@967COMB' /IN=@COMB.
      IF (@COMB=1) STUDY='COMBINED'.
      EXECUTE.
      DATASET CLOSE @967COMB.
      !IF (!STATU='OR') !THEN.
         !LET !NAME='ODR'.
      !ELSE.
         !LET !NAME=!STATU.
      !IFEND.
      COMPUTE !NAME=ES.
      !DO !I !IN (!GRAPHU).
         !IF (!UNQUOTE(!I)='INTERVAL') !THEN.      /*Interval or Forest Plot.
            SORT CASES BY @COMB(D) SE(A).       /*Order cases for the Plot.
            TEMPORARY.
            !IF (!STATU='OR' !OR !STATU='RR' !OR !STATU='IR') !THEN.
               COMPUTE !NAME=100000*!NAME.      /*Logarithmic Plot.
               COMPUTE LO=100000*LO.
               COMPUTE UP=100000*UP.
            !IFEND.
            VAR LABELS !NAME !QUOTE(!NAME) STUDY 'Study'.
            GRAPH HILO(SIMPLE)=VALUE(LO UP !NAME) BY STUDY /TITLE='Interval Plot'.
            !IF (!STATU='OR' !OR !STATU='RR' !OR !STATU='IR') !THEN.
               TEMPORARY.
               N 1.
               PRINT /'NOTE: The ' !QUOTE(!STATU) ' values in the graph have been multiplied by 100000.'.
               EXECUTE.
            !IFEND.
            SORT CASES BY @ORDER.      /*Restore previous order.
         !IFEND.

         !IF (!UNQUOTE(!I)='FOREST') !THEN.        /*Forest Plot.
            SORT CASES BY @COMB(D) SE(A).       /*Order cases for the Plot.
            TEMPORARY.
            !IF (!STATU='OR' !OR !STATU='RR' !OR !STATU='IR') !THEN.
               COMPUTE !NAME=100000*!NAME.      /*Logarithmic Plot.
               COMPUTE LO=100000*LO.
               COMPUTE UP=100000*UP.
            !IFEND.
            VAR LABELS !NAME !QUOTE(!NAME) STUDY 'Study'.            
            GRAPH HILO(SIMPLE)=VALUE(LO UP !NAME) BY STUDY /TITLE='Forest Plot'.
            !IF (!STATU='OR' !OR !STATU='RR' !OR !STATU='IR') !THEN.
               TEMPORARY.
               N 1.
               PRINT /'NOTE: The ' !QUOTE(!STATU) ' values in the graph have been multiplied by 100000.'.
               EXECUTE.
            !IFEND.
            SORT CASES BY @ORDER.      /*Restore previous order.
         !IFEND.

         !IF (!UNQUOTE(!I)='CUM') !THEN.           /*Cumulative Plot.
            !IF (!PrintCUM=1) !THEN.     /*Cumulative analysis must exist for a CUM graph.
               SORT CASES BY !VarCUM.       /*Order cases for the Plot.
               TEMPORARY.
               SELECT IF (@COMB<>1).
               !IF (!METHODU='REM') !THEN.
                  COMPUTE !NAME=EScrg.
                  VARIABLE LABELS loEScrg 'Lower Bound' upEScrg 'Upper Bound' !VarCUM !QUOTE(!VarCUM).
                  GRAPH HILO(SIMPLE)=VALUE(loEScrg upEScrg !NAME) BY !VarCUM /TITLE='Cumulative Plot'.
               !ELSE.
                  COMPUTE !NAME=ESc.
                  VARIABLE LABELS loESc 'Lower Bound' upESc 'Upper Bound' !VarCUM !QUOTE(!VarCUM).
                  GRAPH HILO(SIMPLE)=VALUE(loESc upESc !NAME) BY !VarCUM /TITLE='Cumulative Plot'.
               !IFEND.
               SORT CASES BY @ORDER.      /*Restore previous order.
            !ELSE.
               DO IF ($casenum=1).
                  PRINT SPACE.
                  PRINT /'The Cumulative plot needs the cumulative analysis (CUM parameter).'.
               END IF.
               EXECUTE.
            !IFEND.
         !IFEND.

         !IF (!UNQUOTE(!I)='HIST') !THEN.          /*Histogram (weighted).
            TEMPORARY.
            SELECT IF (@COMB<>1).
            !IF (!METHODU='MH') !THEN.
               WEIGHT BY Wmh.
            !IFEND.
            !IF (!METHODU='FEM') !THEN.
               WEIGHT BY WIV.
            !IFEND.
            !IF (!METHODU='REM') !THEN.
               WEIGHT BY WIVr.
            !IFEND.
            !IF (!METHODU='PETO') !THEN.
               WEIGHT BY V.
            !IFEND.
            GRAPH HISTOGRAM=!NAME /TITLE='Histogram (weighted)'.
         !IFEND.

         !IF (!UNQUOTE(!I)='RADIAL') !THEN.        /*Radial Plot.
            TEMPORARY.
            COMPUTE X= LN(!NAME)/SE.
            COMPUTE Y= 1/SE.
            VAR LABELS X !QUOTE(!CONCAT('ln',!NAME,' / SE')) Y '1 / SE'.
            GRAPH SCATTERPLOT(BIVAR)=X WITH Y /TITLE='Radial Plot'.
         !IFEND.

         !IF (!UNQUOTE(!I)='ABBE') !THEN.          /*De l'Abb Plot.
            TEMPORARY.
            SELECT IF (@COMB<>1).
            COMPUTE X=(A0/N0)*100.
            COMPUTE Y=(A1/N1)*100.
            FORMATS X Y (F4.1).
            VARIABLE LABELS X 'Px' Y 'Py'.
            GRAPH SCATTERPLOT(BIVAR)=X WITH Y /TITLE="l'Abb Plot".
         !IFEND.

         !IF (!UNQUOTE(!I)='INTHET' !OR !UNQUOTE(!I)='INTPLOT') !THEN.       /*Interval Plot.
            TEMPORARY.
            SELECT IF (@COMB<>1).
            !IF (!STATU='OR' !OR !STATU='RR' !OR !STATU='IR') !THEN.
               COMPUTE !NAME=100000*!NAME.      /*Logarithmic Plot.
               COMPUTE LO=100000*LO.
               COMPUTE UP=100000*UP.
            !IFEND.
            VAR LABELS !NAME !QUOTE(!NAME) STUDY 'Study'.
            GRAPH HILO(SIMPLE)=VALUE(LO UP !NAME) BY STUDY /TITLE='Interval Plot'.
            !IF (!STATU='OR' !OR !STATU='RR' !OR !STATU='IR') !THEN.
               TEMPORARY.
               N 1.
               PRINT /'NOTE: The ' !QUOTE(!STATU) ' values in the graph have been multiplied by 100000.'.
               EXECUTE.
            !IFEND.
         !IFEND.

         !IF (!UNQUOTE(!I)='GALB') !THEN.          /*Galbraith Plot.
            TEMPORARY.
            SELECT IF (@COMB<>1).
            COMPUTE X= LN(!NAME)/SE.
            COMPUTE Y= 1/SE.
            VAR LABELS X !QUOTE(!CONCAT('ln',!NAME,' / SE')) Y '1 / SE'.
            GRAPH SCATTERPLOT(BIVAR)=Y WITH X BY Study(NAME) /TITLE='Galbraith (radial) Plot'.
         !IFEND.

         !IF (!UNQUOTE(!I)='TREE') !THEN.          /*Christmas tree Plot.
            !IF (!TYPE<>'RAW') !THEN.
               !LET !ParamN='N'.
            !IFEND.
            TEMPORARY.
            SELECT IF (@COMB<>1).
            COMPUTE !NAME= 100000*!NAME.            
            GRAPH SCATTERPLOT(BIVAR)=!NAME WITH N /TITLE='Christmas tree Plot'.
         !IFEND.
      !DOEND.
      SELECT IF (@COMB<>1).   /*Delete the COMBINED row.
   !IFEND.

***BUILD final results matrix.
   !IF (!KEEP<>1) !THEN.
      !LET !FORMATS=!NULL.
      !IF (!DATAU='RAW') !THEN.
         !IF (!STATU='IR' !OR !STATU='ID') !THEN.
            !LET !KEEPV='STUDY RANK A1 T1 I1 A0 T0 I0 ES SE LO UP '.
         !ELSE.
            !LET !KEEPV='STUDY RANK A1 B1 N1 A0 B0 N0 N ES SE LO UP '.
         !IFEND.
         !LET !RENAME1='ES '.
         !IF (!STATU='OR') !THEN.
            !LET !RENAME2='ODR '.
         !ELSE.
            !LET !RENAME2=!CONCAT(!STATU,' ').
         !IFEND.
         !IF (!STATU='OR') !THEN.
            !LET !KEEPV=!CONCAT(!KEEPV,'ORp SEp LOp UPp SUMVi ').
            !LET !RENAME1=!CONCAT(!RENAME1,'ORp SEp LOp UPp SUMVi ').
            !LET !RENAME2=!CONCAT(!RENAME2,'ORpeto SE_lnORp LO_ORp UP_ORp Wp ').
         !IFEND. 
         !IF (!STATU='OR' !OR !STATU='RR' !OR !STATU='IR') !THEN.
            !LET !KEEPV=!CONCAT(!KEEPV,'Wmh ').
         !IFEND.
         !LET !KEEPV=!CONCAT(!KEEPV,'WIV WIVr ').
         !LET !RENAME1=!CONCAT(!RENAME1,'WIV WIVr').
         !LET !RENAME2=!CONCAT(!RENAME2,'WivF WivR').
   
         !IF (!STATU='IR' !OR !STATU='ID') !THEN.
            !LET !FORMATS='I1 I0(F9.8) '.
         !ELSE.
            !LET !FORMATS='N1 N0 N(F8) '.
         !IFEND.
         !IF (!STATU='OR') !THEN.
            !LET !FORMATS=!CONCAT(!FORMATS, 'ES SE LO UP ORp SEp LOp UPp(F9.4)').
         !ELSE.
            !LET !FORMATS=!CONCAT(!FORMATS, 'ES SE LO UP (', !FORMAT, ')').
         !IFEND.
      !ELSE.
         !LET !KEEPV=!CONCAT('STUDY RANK ', !VARNAME, ' SE LO UP ',!ParamN, ' SCL WIV WIVr ').
         !LET !RENAME1='WIV WIVr '.
         !LET !RENAME2='WivF WivR '.
         !LET !FORMATS=!CONCAT(!VARNAME, ' SE LO UP (', !FORMAT, ')').
      !IFEND.
      !IF (!PROPU<>!NULL) !THEN.
         !LET !KEEPV=!CONCAT(!KEEPV, ' Prop').
         !LET !FORMATS=!CONCAT(!FORMATS, ' Prop (F5.4)').
      !IFEND.
      !IF (!VAR<>!NULL) !THEN.
         !LET !KEEPV=!CONCAT(!KEEPV,' ',!VAR).
      !IFEND.
      !IF (!DATAU='RAW' !AND !STATU<>'IR' !AND !STATU<>'ID' !AND !ZEROU<>'N') !THEN.
         !IF (!ZEROU='C') !THEN.
            !LET !FORMATS=!CONCAT(!FORMATS, ' A1 B1 N1 A0 B0 N0 (F5.1)').
         !ELSE.
            !LET !FORMATS=!CONCAT(!FORMATS, ' A1 B1 N1 A0 B0 N0 (F9.4)').
         !IFEND.
      !IFEND.
      !IF (!AuxVars<>!NULL) !THEN.
         *Save auxiliary variables to replicate PRINT results.
         !LET !KEEPV=!CONCAT(!KEEPV,' ',!AuxVars).
      !IFEND.
      FORMATS !FORMATS.
   
   *  Rename an keep the interesting variables.
      MATCH FILES /FILE=* /KEEP=!KEEPV.
      EXECUTE.
      RENAME VARIABLES (!RENAME1=!RENAME2).
      EXECUTE.
   !IFEND.
   DATASET ACTIVATE Original WINDOW = FRONT.

   !IF (!KEEP=1) !THEN.
      DATASET CLOSE Data_MAR.       /*Close the temporary dataset.
   !IFEND.
!IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
