PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !STD V2012.05.09 loaded.'
         /'Execute !STD HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !STD(TYPE = !CHAREND('/')
             /A1 = !CHAREND('/') /N1 = !CHAREND('/') /T1 = !CHAREND('/') /StdPop = !CHAREND('/')
             /A0 = !CHAREND('/') /N0 = !CHAREND('/') /T0 = !CHAREND('/') 
            /STR = !CHAREND('/') /StrLabel = !CHAREND('/')
          /SPLIT = !CHAREND('/') /SplitLabel = !CHAREND('/')
            /ICS = !CHAREND('/') /RCS = !CHAREND('/')
        /STDSIZE = !CHAREND('/') !DEFAULT('OBS')
         /FACTOR = !CHAREND('/') !DEFAULT(1)
          /PRINT = !CHAREND('/') !DEFAULT('TABLE')
             /CL = !CHAREND('/') !DEFAULT('95')
            /NST = !CHAREND('/')
           /HELP = !CHAREND('/') !DEFAULT(1)).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2012.05.09').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
   PRINT /'Macro !STD V' !VERSION ' (c)JM.Domenech'.
END IF.
!IF (!HELP<>1) !THEN.
*  Impresin de la documentacin.
   DO IF ($casenum=1).
   PRINT /'********************************************************************************'
         /'* DIRECT AND INDIRECT STANDARDIZATION                                          *'
         /'* Created 1999.11.08 Last revised ' !VERSION                                  '*'80
         /'* (c) JM.Domenech                                                              *'
         /'* Programmer: R.Sesma                                                          *'
         /'*                                                                              *'
         /'* Vancouver reference:                                                         *'
         /'* Domenech JM. Macro !STD for SPSS Statistics.                                 *'
         /'*    Direct and Indirect Standardization [computer program].                   *'
         /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'80
         /'*    Available from: http://www.metodo.uab.cat/macros.htm.                     *'
         /'*                                                                              *'
         /'* Macro Call (tested for SPSS 18.0 and higher):                                *'
         /'* !DSR  Type = Type of Standardization                                         *'
         /'*              D - Direct Standardization (rates and ratios)                   *'
         /'*              I - Indirect Standardization (rates)                            *' 
         /'*         A1 = Variable name with the list of cases in Group 1 by Stratum      *'
         /'*       {/T1 = Variable name with the list of person-time in Group 1 by Stratum*'
         /'*     or /N1}= Variable name with the list of population  in Group 1 by Stratum*'
         /'*     StdPop = Variable name with the values of the Standard Population        *'
         /'*   [StdSize]= Standard Population Size                                        *'
         /'*              Obs: Size of the Observed Population (default)                  *'
         /'*              Std: Size of the Standard Population                            *'
         /'*    [Factor]= Multiplying factor for Risk/Rates values. By default, FACTOR=1  *'
         /'*              Possible values are powers of 10: 1 10 100 1000 10000 ....      *'
         /'*        Str = Variable name with Stratum values                               *'
         /'*  [StrLabel]= Variable name with Stratum labels                               *'
         /'*     [Split]= Variable name with Split values                                 *'
         /'*[SplitLabel]= Variable name with Split labels                                 *'
         /'*     [Print]= TABLE - Print Stratum tables; default                           *'
         /'*              NOTABLE - Do NOT print Stratum tables                           *'
         /'*       [/CL]= Confidence level (%); by default: 95        (50 <= CL < 100)    *'
         /'*      [/NST]= Name of the study (Label)                                       *'
         /'*       [HELP] Print Macro call arguments and Samples of calls                 *'
         /'*------------------------------------------------------------------------------*'
         /'* Parameters for records an additional Group                                   *'
         /'*         A0 = Variable name with the list of cases in Group 0 by Stratum      *'
         /'*       {/T0 = Variable name with the list of person-time in Group 0 by Stratum*'
         /'*     or /N0}= Variable name with the list of population  in Group 0 by Stratum*'
         /'*------------------------------------------------------------------------------*'
         /'* Parameters for compute Comparative Mortality Figure                          *'
         /'*     [{/ICS = Crude rate in STANDARD POPULATION               (ICS > 0)       *'
         /'*   or /RCS}]= Crude risk in STANDARD POPULATION               (0 < RCS < 1)   *'
         /'*------------------------------------------------------------------------------*'
         /'* Notes: Parameters enclosed in Square Brackets [ ] are optional               *'
         /'*        Parameters enclosed in Braces { } indicate a choice between elements  *'
         /'*        Parameters /T1, /T0 and /ICS records RATE DATA.                       *'
         /'*        Parameters /N1, /N0 and /RCS records RISK DATA.                       *'
         /'*WARNING:The macro does not verify variable names. Wrong variable names will   *'
         /'*        produce unexpected results.                                           *'
         /'*        A new dataset is created, but not saved. This dataset contains        *'
         /'*        the macro results in SPSS format.                                     *'
         /'*                                                                              *'
         /'* Samples of calls:                                                            *'
         /'* !STD HELP.                                                                   *'
         /'* !STD Type=D /A1=TbcVar /N1=PobVar /A0=TbcMuj /N0=PobMuj /StdPop=Europea      *'
         /'*    /Str=GrEdad /Split=Ao /Factor= 100000 /CL=95 /NST="Tuberculosis".        *'
         /'* !STD Type=D /A1=CancSolt /T1=PobSolt /A0=CancCas /T0=PobCas /StdPop=Std      *'
         /'*    /StdSize=Std /Str=GrEdad /ICS=0.000536371 /CL=95 /NST="Mortalidad cncer".*'
         /'********************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Test parameters.
   !LET !TypeU = !UPCASE(!Type).
   !IF ((!Type = !NULL) !OR ((!TypeU<>'D') !AND (!TypeU<>'I'))) !THEN.
      TEMPORARY.
      N 1.
      !IF (!Type = !NULL) !THEN.
         PRINT /'ERROR: Missing parameter TYPE. See the HELP.'.
      !IFEND.
      !IF ((!TypeU<>'D') !AND (!TypeU<>'I')) !THEN.
         PRINT /'ERROR: Parameter TYPE with wrong values. See the HELP.'.
      !IFEND.
      EXECUTE.
   !ELSE.
      !IF (!TypeU='D') !THEN.
         !LET !ERROR = 0.
*        Missing Parameters A1, T1 or N1, StdPop or STR.
         !IF (!A1=!NULL !OR (!T1=!NULL !AND !N1=!NULL) !OR !StdPop=!NULL !OR !STR=!NULL) !THEN.
            !LET !ERROR = 1.
         !IFEND.
*        Missing parameter T0 or N0.
         !IF (!A0<>!NULL !AND (!T0=!NULL !AND !N0=!NULL)) !THEN.
            !LET !ERROR = 2.
         !IFEND.
*        Missing parameter A0.
         !IF (!A0=!NULL !AND (!T0<>!NULL !OR !N0<>!NULL)) !THEN.
            !LET !ERROR = 3.
         !IFEND.
*        Too much parameters T1 or N1.
         !IF (!T1<>!NULL !AND !N1<>!NULL) !THEN.
            !LET !ERROR = 4.
         !IFEND.
*        Too much parameters T0 or N0.
         !IF (!T0<>!NULL !AND !N0<>!NULL) !THEN.
            !LET !ERROR = 5.
         !IFEND.
*        StdSize.
         !LET !Size = !UPCASE(!StdSize).
         !IF (!Size<>'OBS' !AND !Size<>'STD') !THEN.
            !LET !ERROR = 6.
         !IFEND.
*        PRINT.
         !LET !PrintU = !UPCASE(!Print).
         !IF (!PrintU<>'NOTABLE' !AND !PrintU<>'TABLE') !THEN.
            !LET !ERROR = 7.
         !IFEND.
      
         
         !IF (!ERROR<>0) !THEN.
            TEMPORARY.
            N 1.
            !IF (!ERROR = 1) !THEN.
               PRINT /'ERROR: Parameter A1, T1/N1, StdPop or STR missing. See the HELP.'.
            !IFEND.
            !IF (!ERROR = 2) !THEN.
               PRINT /'ERROR: Parameter T0 or N0 missing. See the HELP.'.
            !IFEND.
            !IF (!ERROR = 3) !THEN.
               PRINT /'ERROR: Parameter A0 missing. See the HELP.'.
            !IFEND.
            !IF (!ERROR = 4) !THEN.
               PRINT /'ERROR: Too much parameters. T1 and N1 parameters are incompatible. See the HELP.'.
            !IFEND.
            !IF (!ERROR = 5) !THEN.
               PRINT /'ERROR: Too much parameters. T0 and N0 parameters are incompatible. See the HELP.'.
            !IFEND.
            !IF (!ERROR = 6) !THEN.
               PRINT /'ERROR: Parameter StdSize with wrong value. See the HELP.'.
            !IFEND.
            !IF (!ERROR = 7) !THEN.
               PRINT /'ERROR: Parameter PRINT with wrong value. See the HELP.'.
            !IFEND.
            EXECUTE.
         !ELSE.
*           Copy dataset.
            OMS /SELECT ALL /IF COMMANDS = ["Dataset Copy" "Dataset Name"] /DESTINATION VIEWER = NO.
            DATASET NAME @original.
            DATASET COPY @ResultsStdD WINDOW=MINIMIZED.
            DATASET ACTIVATE @ResultsStdD WINDOW=ASIS.
            OMSEND.
      
*           Type of estimation.
            !IF (!T1<>!NULL) !THEN.
               !LET !TypeD = 'RATE'
               !LET !Mesure='Rate'.
               !LET !Denom='Person-time'.
               COMPUTE Pop1 = !T1.
               !LET !Pop1 = !T1.
            !IFEND.
            !IF (!N1<>!NULL) !THEN.
               !LET !TypeD = 'RISK'
               !LET !Mesure='Risk'.
               !LET !Denom=' Population'.
               COMPUTE Pop1 = !N1.
               !LET !Pop1 = !N1.
            !IFEND.
      
*           Type of estimation.
            !LET !Group0 = 0.
            !IF (!A0<>!NULL) !THEN.
               !LET !Group0 = 1.
               !IF (!TypeD='RISK') !THEN.
                  COMPUTE Pop0 = !N0.
                  !LET !Pop0 = !N0.
               !ELSE.
                  COMPUTE Pop0 = !T0.
                  !LET !Pop0 = !T0.
               !IFEND.
            !IFEND.
      
*           Split Variable values.
            !IF (!Split <> !NULL) !THEN.
               COMPUTE @Break = !Split.
               STRING @Split2 (A18).
               !IF (!SplitLabel = !NULL) !THEN.
                  COMPUTE @Split2 = CONCAT(!QUOTE(!Split),"= ",STRING(!Split,F4),"*").
               !ELSE.
                  COMPUTE @Split2 = CONCAT(!QUOTE(!Split),"= ",!SplitLabel,"*").
               !IFEND.
               !IF (!Group0=1) !THEN.
                  STRING @Split1 (A119).
                  COMPUTE @Split1 = REPLACE(RPAD(RTRIM(@Split2),119,"-"),"*"," ").
               !ELSE.
                  STRING @Split1 (A62).
                  COMPUTE @Split1 = REPLACE(RPAD(RTRIM(@Split2),62,"-"),"*"," ").
               !IFEND.
               
               *SORT CASES BY !Split(A) !STR(A).
            !ELSE.
               COMPUTE @Break = 1.
               *SORT CASES BY !STR(A).
            !IFEND.
            EXECUTE.
      
*           CMF: ICS or RCS values not null.
            !LET !CMF = !NULL.
            !IF (!ICS <> !NULL) !THEN.
               !LET !CMF = !ICS.
            !IFEND.
            !IF (!RCS <> !NULL) !THEN.
               !LET !CMF = !RCS.
            !IFEND.
            
            COMPUTE @Z=IDF.NORMAL((!CL+100)/200,0,1).
            COMPUTE @U = 1.
*           Compute Pop1, StdPop totals.
            AGGREGATE  /OUTFILE=* MODE=ADDVARIABLES  /PRESORTED  /BREAK=@Break
              /Pop1_total=SUM(Pop1) /StdPop_total=SUM(!StdPop) /NSec = N.
*           Compute Sec variable.
            SPLIT FILE BY @Break.
            PRESERVE.
            SET RESULTS OFF  ERRORS OFF.
            CREATE Sec = CSUM(@U).
            RESTORE.
            SPLIT FILE OFF.
      
*           Compute StdPop1 from the Standard Population !StdPop.
            !IF (!Size = 'OBS') !THEN.
               COMPUTE @StdPop = !StdPop/StdPop_total.
               COMPUTE StdPop1 = @StdPop * (Pop1_total).
            !IFEND.
            !IF (!Size = 'STD') !THEN.
               COMPUTE StdPop1 = !StdPop.
            !IFEND.
            EXECUTE.
         
            COMPUTE R1 = (!A1/Pop1) .        /*Rate for stratum.
            COMPUTE E1 = StdPop1 * R1.       /*Expected in group A1.
            !IF (!TypeD='RISK') !THEN.       /*SE for group A1.
               COMPUTE @NUMSE1=(StdPop1**2*R1/Pop1).
            !ELSE.
               COMPUTE @NUMSE1=(StdPop1**2*R1*(1-R1)/Pop1).
            !IFEND.
            
*           Summatories: AGGREGATE.
            AGGREGATE  /OUTFILE=* MODE=ADDVARIABLES  /PRESORTED  /BREAK=@Break
              /A1_total=SUM(!A1) /E1_total=SUM(E1) /NUMSE1=SUM(@NUMSE1) /StdPop1_total = SUM(StdPop1).
*           Crude and adjusted estimation.
            COMPUTE CR1= A1_total/Pop1_total.
            COMPUTE DS1= E1_total/StdPop1_total.
*           SE and Confidence Interval of DSR, Cochran, 1977.
            COMPUTE SE_DS1=SQRT(NUMSE1/(StdPop1_total**2)).
            COMPUTE lbDS1= DS1 - @Z*SE_DS1.
            COMPUTE ubDS1= DS1 + @Z*SE_DS1.
            VARIABLE LABELS CR1 !CONCAT('Crude ',!Mesure,' (Group 1)') /DS1 'Direct Standardized (Group 1)' 
                           /lbDS1 'Direct Standardized - CI lower bound (Group 1)' /ubDS1 'Direct Standardized - CI upper bound (Group 1)'.
            FORMATS CR1 (F10.5) DS1 lbDS1 ubDS1 (F12.7).
         
*           CMF and bounds: computing only if CMF is giving.
            !IF (!CMF<>!NULL) !THEN
               COMPUTE CMF1=DS1/!CMF.
               COMPUTE lbCMF1=lbDS1/!CMF.
               COMPUTE ubCMF1=ubDS1/!CMF.
               VARIABLE LABELS CMF1 'CMF (Group 1)' /lbCMF1 'CMF - CI lower bound (Group 1)' /ubCMF1 'CMF - CI upper bound (Group 1)'.
               FORMATS CMF1 lbCMF1 ubCMF1 (F10.5).
            !IFEND.
            
            !IF (!Group0 = 1) !THEN.
*              Compute Pop0 total.
               AGGREGATE  /OUTFILE=* MODE=ADDVARIABLES  /PRESORTED  /BREAK=@Break /Pop0_total=SUM(Pop0).
*              Compute StdPop0 from the Standard population StdPop.
               !IF (!Size = 'OBS') !THEN.
                  COMPUTE StdPop0 = @StdPop * (Pop0_total).
               !IFEND.
               !IF (!Size = 'STD') !THEN.
                  COMPUTE StdPop0 = !StdPop.
               !IFEND.
               EXECUTE.
               COMPUTE R0 = (!A0/Pop0).        /*Rate for stratum.
               COMPUTE E0 = StdPop0 * R0.      /*Expected in group A0.
*              SE for group A0.
               !IF (!TypeD='RATE') !THEN.
                  COMPUTE @NUMSE0=(StdPop0**2*R0/Pop0).
               !ELSE.
                  COMPUTE @NUMSE0=(StdPop0**2*R0*(1-R0)/Pop0).
               !IFEND.
               EXECUTE.
            
*              Summatories: AGGREGATE.
               AGGREGATE  /OUTFILE=* MODE=ADDVARIABLES  /PRESORTED  /BREAK=@Break
                 /A0_total=SUM(!A0) /E0_total=SUM(E0) /NUMSE0=SUM(@NUMSE0) /StdPop0_total = SUM(StdPop0).
*              Crude and adjusted estimation.
               COMPUTE CR0=A0_total/Pop0_total.
               COMPUTE DS0= E0_total/StdPop0_total.
*              SE and Confidence Interval of DSR.
               COMPUTE SE_DS0=SQRT(NUMSE0/(StdPop0_total**2)).
               COMPUTE lbDS0= DS0 - @Z*SE_DS0.
               COMPUTE ubDS0= DS0 + @Z*SE_DS0.
               VARIABLE LABELS CR0 !CONCAT('Crude ',!Mesure,' (Group 0)') /DS0 'Direct Standardized (Group 0)' 
                              /lbDS0 'Direct Standardized - CI lower bound (Group 0)' /ubDS0 'Direct Standardized - CI upper bound (Group 0)'.
               FORMATS CR0 (F10.5) DS0 lbDS0 ubDS0 (F12.7).
      
*              CMF and bounds: computing only if ICS is giving.
               !IF (!CMF<>!NULL) !THEN
                  COMPUTE CMF0=DS0/!CMF.
                  COMPUTE lbCMF0=lbDS0/!CMF.
                  COMPUTE ubCMF0=ubDS0/!CMF.
                  VARIABLE LABELS CMF0 'CMF (Group 0)' /lbCMF0 'CMF - CI lower bound (Group 0)' /ubCMF0 'CMF - CI upper bound (Group 0)'.
                  FORMATS CMF0 lbCMF0 ubCMF0 (F10.5).
               !IFEND.
               
*              Difference Rate and Rate Ratio, Crude and Standardized.
               COMPUTE CRR=CR1/CR0.
               COMPUTE CRD=CR1-CR0.
               COMPUTE SRR=DS1/DS0.
               COMPUTE SRD=DS1-DS0.
         
*              SE of SRR.
               COMPUTE lnSeSRR=SQRT((SE_DS1/DS1)**2+(SE_DS0/DS0)**2).
               COMPUTE lbSRR= SRR*EXP(-@Z*lnSeSRR).
               COMPUTE ubSRR= SRR*EXP(@Z*lnSeSRR).
         
               DO IF (SRR<1).
                  COMPUTE ISRR=1/SRR.
                  COMPUTE IlbSRR=1/ubSRR.
                  COMPUTE IubSRR=1/lbSRR.
               END IF.
      
*              SE of SRR.
               COMPUTE SeSRD=SQRT(SE_DS1**2+SE_DS0**2).
               COMPUTE lbSRD= SRD-@Z*SeSRD.
               COMPUTE ubSRD= SRD+@Z*SeSRD.
      
               VARIABLE LABELS CRD !CONCAT('Crude ',!Mesure,' Difference') /SRD !CONCAT('Standardized ',!Mesure,' Difference') 
                              /lbSRD !CONCAT('Standardized ',!Mesure,' Difference - CI lower bound') /ubSRD !CONCAT('Standardized ',!Mesure,' Difference - CI upper bound')
                              /CRR !CONCAT('Crude ',!Mesure,' Ratio') /SRR !CONCAT('Standardized ',!Mesure,' Ratio') 
                              /lbSRR !CONCAT('Standardized ',!Mesure,' Ratio - CI lower bound') /ubSRR !CONCAT('Standardized ',!Mesure,' Ratio - CI upper bound').
               FORMATS CRD SRD lbSRD ubSRD CRR SRR lbSRR ubSRR (F12.7).
            !IFEND.

*           Print Header.
            TEMPORARY.
            N 1.
            PRINT /'DIRECT STANDARDIZATION'/.
            !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
               STRING #NST (A131).
               COMPUTE #NST = CONCAT('STUDY: ',!NST).
               PRINT /#NST.
            !IFEND.
            PRINT /'GROUP 1: ' !QUOTE(!Pop1).
            !IF (!Group0 = 1) !THEN.
               PRINT /'GROUP 0: ' !QUOTE(!Pop0).
            !IFEND.
            EXECUTE.
      
            !IF (!FACTOR<>1) !THEN.
               DO REPEAT Var = R1 CR1 DS1 lbDS1 ubDS1.
                  COMPUTE Var = Var * !FACTOR.
               END REPEAT.
               !IF (!Group0 = 1) !THEN.
                  DO REPEAT Var = R0 CR0 DS0 lbDS0 ubDS0 CRD SRD lbSRD ubSRD.
                     COMPUTE Var = Var * !FACTOR.
                  END REPEAT.
               !IFEND.         
               EXECUTE.
      
               !LET !MesureP = !CONCAT(!Mesure,'(*)').
               !LET !MesureP2 = !CONCAT(!Mesure,'(*)').
               !LET !RD = !CONCAT(!Mesure,' Difference(*)').
               !LET !CMFP = 'CMF(*)'.
            !ELSE.
               !LET !MesureP = !CONCAT('   ',!Mesure).
               !LET !MesureP2 = !Mesure.
               !LET !RD = !CONCAT('  ',!Mesure,' Difference').
               !LET !CMFP = 'CMF'.
            !IFEND.
         
*           Print of GROUPs. 
            !IF (!PrintU = 'TABLE') !THEN.
               STRING @Str (A7).
               !IF (!StrLabel = !NULL) !THEN.
                  COMPUTE @Str = STRING(!Str,F7).
               !ELSE.
                  COMPUTE @Str = !StrLabel.
               !IFEND.
               !IF (!Group0 = 0) !THEN.
*                 Print GROUP1 only.
                  DO IF (Sec = 1).
                     !IF (!Split<>!NULL) !THEN.
                        PRINT // @Split1(A62).
                     !ELSE.
                        PRINT /' '.
                     !IFEND.
                     PRINT / 'GROUP 1 --------- Observed -------------   Standard   Expected'.
                     PRINT / 'Stratum   Cases ' !QUOTE(!Denom) '      ' !QUOTE(!MesureP)' Population      Cases'.
                     PRINT / '--------------------------------------------------------------'.
                  END IF.
                  PRINT / @STR(T1,A7) !A1(T9,F7) Pop1(T19,F9) R1(T29,F12.7) StdPop1(T42,F10) E1(T53,F10.2).
                  DO IF (Sec = NSec).
                     PRINT / '--------------------------------------------------------------'.
                     PRINT / 'TOTAL:' A1_total (T9,F7) Pop1_total (T19,F9) CR1(T29,F12.7) StdPop1_total(T42,F10) E1_total(T53,F10.2).
                  END IF.
                  EXECUTE.
               !IFEND.
               !IF (!Group0 = 1) !THEN.
*                 Print GROUP1, GROUP0.
                  DO IF (Sec = 1).
                     !IF (!Split<>!NULL) !THEN.
                        PRINT // @Split1(A119).
                     !ELSE.
                        PRINT /' '.
                     !IFEND.
                     PRINT / 'GROUP 1 --------- Observed -------------   Standard   Expected  GROUP 0 -- Observed -------------   Standard   Expected'.
                     PRINT / 'Stratum   Cases ' !QUOTE(!Denom) '      ' !QUOTE(!MesureP)' Population      Cases    Cases ' !QUOTE(!Denom) '       ' !QUOTE(!MesureP) ' Population      Cases'.
                     PRINT / '--------------------------------------------------------------  -------------------------------------------------------'.
                  END IF.
                  PRINT / @STR(T1,A7) !A1(T9,F7) Pop1(T19,F9) R1(T29,F12.7) StdPop1(T42,F10) E1(T53,F10.2) !A0(T65,F7) Pop0(T75,F9) R0(T86,F12.7) StdPop0(T99,F10) E0(T110,F10.2).
                  DO IF (Sec = NSec).
                     PRINT / '--------------------------------------------------------------  -------------------------------------------------------'.
                     PRINT / 'TOTAL:' A1_total(T9,F7) Pop1_total(T19,F9) CR1(T29,F12.7) StdPop1_total(T42,F10) E1_total(T53,F10.2) A0_total (T65,F7) Pop0_total (T75,F9) CR0(T86,F12.7) StdPop0_total(T99,F10) E0_total(T110,F10.2).
                  END IF.
                  EXECUTE.
               !IFEND.
               EXECUTE.
            !IFEND.
      
*           SELECT ONLY the first row of each split group.
            SELECT IF (Sec = 1).
            EXECUTE.
            
*           Print of Estimates.
            !IF (!Split<>!NULL) !THEN.
               STRING @Split3 (A18).
               !IF (!SplitLabel = !NULL) !THEN.
                  COMPUTE @Split3 = LTRIM(STRING(!Split,F18)).
               !ELSE.
                  COMPUTE @Split3 = !SplitLabel.
               !IFEND.
            !IFEND.
            DO IF (Sec=1).
               PRINT //!QUOTE(!Split)    '|   Crude      |   Direct Standardized'19.
               PRINT  /@Split3(A18)      '|   Estimate   |   Estimate   |   ' !QUOTE(!CL)'% Confidence Interval'.
               PRINT  /'------------------+--------------+--------------+--------------------------'.
            END IF.
            PRINT /!QUOTE(!MesureP2) 'Group 1 |'11 CR1(T21,F12.7) '|'34 DS1(T36,F12.7) '|'49 lbDS1(T51,F12.7) ubDS1(T64,F12.7).
            !IF (!Group0=1) !THEN.
               PRINT /'Group 0 |'11 CR0(T21,F12.7) '|'34 DS0(T36,F12.7) '|'49 lbDS0(T51,F12.7) ubDS0(T64,F12.7).
            !IFEND.
            !IF (!CMF<>!NULL) !THEN.
               PRINT /!QUOTE(!CMFP) 'Group 1 |'11 CMF1(T21,F12.7) '|'34 '|'49 lbCMF1(T51,F12.7) ubCMF1(T64,F12.7).
               !IF (!Group0=1) !THEN.
                  PRINT /'Group 0 |'11 CMF0(T21,F12.7) '|'34 '|'49 lbCMF0(T51,F12.7) ubCMF0(T64,F12.7).
               !IFEND.
            !IFEND.
            !IF (!Group0=1) !THEN.
               PRINT /'------------------+--------------+--------------+--------------------------'.
               PRINT /!QUOTE(!RD) '|'19 CRD(T21,F12.7) '|'34 SRD(T36,F12.7) '|'49 lbSRD(T51,F12.7) ubSRD(T64,F12.7).
               PRINT /'       Risk Ratio |' CRR(T21,F10.5) '|'34 SRR(T36,F10.5) '|'49 lbSRR(T51,F10.5) ubSRR(T64,F10.5).
            !IFEND.
            PRINT /'------------------+--------------+--------------+--------------------------'.
            EXECUTE.
            
            !IF (!FACTOR<>1) !THEN.
               TEMPORARY.
               N 1.
               PRINT /'(*) per ' !QUOTE(!FACTOR).
               EXECUTE.
            !IFEND.
      
*           Save only the interesting variables.
            !IF (!Split <> !NULL) !THEN.
               !LET !SaveVars = !CONCAT(!Split,' CR1 DS1 lbDS1 ubDS1').
            !ELSE.
               !LET !SaveVars = 'CR1 DS1 lbDS1 ubDS1'.
            !IFEND.
            !IF (!CMF <> !NULL) !THEN.
               !LET !SaveVars = !CONCAT(!SaveVars,' CMF1 lbCMF1 ubCMF1').
            !IFEND.
            !IF (!Group0 = 1) !THEN.
               !LET !SaveVars = !CONCAT(!SaveVars,' CR0 DS0 lbDS0 ubDS0').
               !IF (!CMF <> !NULL) !THEN.
                  !LET !SaveVars = !CONCAT(!SaveVars,' CMF0 lbCMF0 ubCMF0').
               !IFEND.
               !LET !SaveVars = !CONCAT(!SaveVars,' CRD SRD lbSRD ubSRD CRR SRR lbSRR ubSRR').
            !IFEND.
            MATCH FILES /FILE=* /KEEP =!SaveVars.
            EXECUTE.
            
            DATASET ACTIVATE @original.   /*Return focus to the original dataset.
         !IFEND.
      !ELSE.
         TEMPORARY.
         N 1.
         PRINT /'Indirect Standardization not yet available.'.
         EXECUTE.
      !IFEND.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
