PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
  PRINT /'Macro !AGREE V2011.07.29 loaded.'
        /'Execute !AGREE HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !AGREE (X  =!CHAREND('/') 
              /Y  =!CHAREND('/') 
              /N  =!CHAREND('/')
              /CL =!CHAREND('/') !DEFAULT ('95')
          /METHOD =!CHAREND('/') !DEFAULT ('BO')
            /LIST =!CHAREND('/') !DEFAULT (1)
             /NST =!CHAREND('/')
            /HELP =!CHAREND('/') !DEFAULT(1)).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2011.07.29').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
   PRINT /'Macro !AGREE V' !VERSION ' (c)JM.Domenech & R.Granero'.
END IF.
!IF (!HELP<>1) !THEN.
*  Impresin de la documentacin.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* AGREEMENT: PASSING-BABLOK & BLAND-ALTMAN METHODS                           *'
            /'* Created 1998.09.24 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech & R.Granero                                                *'
            /'* Programmers: A.Bonillo & R.Sesma                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM, Granero R. Macro !AGREE for SPSS Statistics.                  *'
            /'*    Passing-Bablok & Bland-Altman methods [computer program].               *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* !AGREE X= Name of variable with method X (Reference)  (in SPSS format)     *'
            /'*       /Y= Name of variable with method Y              (in SPSS format)     *'
            /'*       /N= Number of Cases                             (integer >= 2)       *'
            /'*    [/CL]= Confidence level(%);  by default:95         (50 <= CL < 100)     *'
            /'*[/METHOD]= PB (Passing-Bablok estimation of regression line)                *'
            /'*           BA (Bland-Altman comparison of two measurements methods)         *'
            /'*           BO (Passing-Bablock & Bland-Altman methods)                      *'
            /'*           by default: BO                                                   *'
            /'*  [/LIST]= Name of variable with identifier of cases;  by default: $casenum *'
            /'*           List input data (the report include X-Y changes)                 *'
            /'*   [/NST]= Name of the study (Label)                                        *'
            /'*   [/HELP] Print Macro call arguments and Samples of calls                  *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
            /'*                                                                            *'
            /'* Samples of calls:                                                          *'
            /'*  !AGREE HELP.                                                              *'
            /'*  !AGREE X=Manual /Y=Instrum /N=40 /LIST /CL=90 /METHOD=PB.                 *'
            /'*  !AGREE X=Manual /Y=Instrum /N=80 /LIST=Sample /NST="Name of the Study".   *'
            /'*                                                                            *'
            /'* WARNING! The macro provides wrong results if your data are filtered.       *'
            /'* To work with a set of cases you must use SELECT IF procedure in order      *'
            /'* to create a new data file containing only selected cases.                  *'
            /'******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Test parametros.
   !LET !ERROR=0.
   !LET !METHODU=!UPCASE(!METHOD).
   !IF (!X=!NULL !OR !Y=!NULL !OR !N=!NULL) !THEN.
      !LET !ERROR=1.
   !ELSE.
      !IF (!METHODU<>PB !AND !METHODU<>BA !AND !METHODU<>BO) !THEN.
         !LET !ERROR=2.
      !IFEND.
   !IFEND.
   !IF (!ERROR<>0) !THEN.
      TEMPORARY.
      N 1.
      !IF (!ERROR=1) !THEN.
         PRINT /'ERROR: Missing parameter X, Y or N. See the HELP.'.
      !IFEND.
      !IF (!ERROR=2) !THEN.
         PRINT /'ERROR: Parameter METHOD with wrong values'.
      !IFEND.
      EXECUTE.
   !ELSE.
*     Clculos y impresin de resultados.
      TEMPORARY.
      N 1.
      !IF (!NST !NE !NULL) !THEN .	   /*Imprimimos NST (si se proporciona).
         STRING #NST (A132).
         COMPUTE #NST = CONCAT('STUDY: ',!NST).
         PRINT /#NST /.
      !IFEND.
*     Warning sobre manipulacin de datos.
      PRINT /'******************************************************************************'.
      PRINT /'*  WARNING! The macro provides wrong results if your data are filtered.      *'.
      PRINT /'*  To work with a set of cases you must use SELECT IF procedure in order     *'.
      PRINT /'*  to create a new data file containing only selected cases.                 *'.
      PRINT /'******************************************************************************'.
      EXECUTE.

*     Creamos un dataset temporal con las variables !X !Y.
      DATASET NAME @96578original.
      DATASET COPY @96578temp WINDOW=HIDDEN.
      DATASET ACTIVATE @96578temp WINDOW = ASIS.
      !IF (!LIST=1 !OR !LIST=!NULL) !THEN.
         MATCH FILES FILE=* /RENAME=(!X !Y = @X @Y) /KEEP=@X @Y.
      !ELSE.
         MATCH FILES FILE=* /RENAME=(!X !Y !LIST= @X @Y @Identifier) /KEEP=@X @Y @Identifier.
      !IFEND.
      SELECT IF NOT(MISSING(@X) OR MISSING(@Y)).   /*Eliminacin de los registros que contengan missing en X o en Y.
      EXECUTE.
      !IF (!LIST=!NULL) !THEN.
         COMPUTE @Identifier = $casenum.
      !IFEND.
      EXECUTE.         
         
*     Creamos las variables comunes a los clculos PB y BA.         
      COMPUTE @U=1.                    /*Vector Unidad.
      COMPUTE @casenum = $casenum.     /*Vector con el casenum.
      RANK @U /N into @N /print=NO.    /*Creamos una variable que contiene la N de casos vlidos.         
*     Media de X y de Y.
      AGGREGATE /OUTFILE =* MODE= ADDVARIABLES /BREAK = @U
         /@MEANY = MEAN(@Y) /@MEANX = MEAN(@X).
*     Resta Y - X.
      COMPUTE @Y_X=@Y-@X.
      VARIABLE LABELS @y_x 'Y minus X'. 
*     Suma del producto de las desviaciones respecto a la media de X, Y; desviacin estndar de X,Y; media y sd de Y-X.
      COMPUTE @CXYi=(@X-@MEANX)*(@Y-@MEANY).
      AGGREGATE /OUTFILE =* MODE= ADDVARIABLES /BREAK = @U 
         /@CXY = SUM(@CXYi) /@varx = SD(@x) /@vary = SD(@y) /@mnXY = MEAN(@y_x) /@sdXY = SD(@y_x).

      !IF (!METHODU=PB !OR !METHODU=BO) !THEN.
*        Clculos Passing-Bablock.
*********1 PARTE: CLCULO DE LA CONSTANTE, LA PENDIENTE Y SUS LMITES DEL IC.
*        Algoritmo clave: calcula el numerador y el denominador de todas las pendientes posibles, M.
*        Las M=-1 y las 0/0 no participan en el clculo de la B y las pasamos a SYSMIS.
         DATASET COPY @96578PB WINDOW=HIDDEN.
         DATASET ACTIVATE @96578PB WINDOW = ASIS.
         !DO !I = 1 !TO !N.
            ADD FILES FILE=* /FILE=@96578temp.
         !DOEND.
         EXECUTE.
         SELECT IF ($casenum <= ((@N * @N) - @N)).    /*Eliminamos los registros de ms.
         EXECUTE.
         SORT CASES BY @casenum(A).
         COMPUTE @NUM = $SYSMIS.
         IF ($casenum = 1) @NUM = @N + @casenum.
         IF (@casenum <> LAG(@casenum)) @NUM = @N + @casenum.
         IF (@casenum = LAG(@casenum)) @NUM = LAG(@NUM) + @N.
         EXECUTE.

         SORT CASES BY @NUM.
         LOOP #A = 1 TO @N.
            COMPUTE @Llag=$CASENUM/#A.
            IF (MOD(@Llag,1)<>0) @Llag=1+TRUNC(@Llag).
         END LOOP.
         !DO !I = 1 !TO !N.
            DO IF (@Llag=!I AND (@Llag=LAG(@Llag,!I))).
               COMPUTE @M=(@Y-LAG(@Y,!I))/(@X-LAG(@X,!I) ).
            END IF.
         !DOEND.
         EXECUTE.
         SELECT IF (@M<>-1 AND @M<>0 AND NOT(MISSING(@M)) ).
         
*        Ordenamos los casos para hallar los registros que contengan la B y los lmites del IC de la misma.
         SORT CASES BY @M.

*        Creamos una variable, K, que contiene el nmero de M<-1, variable que
         posteriormente se utiliza para ponderar el clculo de la B
         Creamos la variable NM que indica el nmero de pendientes que han sido
         calculadas.
         COMPUTE @K0=(@M<-1).
         AGGREGATE /OUTFILE =* MODE= ADDVARIABLES /BREAK = @U 
            /@K = SUM(@K0) /@NM = N.

*        El mdulo de NM entre 2 nos permite identificar si NM es par o impar.
         COMPUTE #MODNM=MOD(@NM,2).

         DO IF(#MODNM=0).                 /*Si NM es par la mediana es igual a la.
            COMPUTE @NB=(@NM/2)+@K.          /*media de los dos registros centrales.
            COMPUTE #BB=(@M+LAG(@M,1))/2.   /*de la distribucin de M ordenada.
         ELSE.
            COMPUTE @NB=(@NM+1)/2+@K.        /*Si NM es impar la mediana es igual al.
            COMPUTE #BB=@M.                /*registro central de la distribucin.
         END IF.

*        Hallamos los registros que contienen los lmites inferior, M1B, y superior,
         M2B, del IC de la pendiente; puesto que hemos calculado el nmero de casos
         vlidos, n, utilizamos esta variable en el clculo y no el parmetro evitando
         as errores por registros missings.
         COMPUTE #Z=IDF.NORMAL((!CL+100)/200,0,1).
         COMPUTE #C=#Z*SQRT(@N*(@N-1)*(2*@N+5)/18).
         COMPUTE #M1B=RND((@NM-#C)/2).
         COMPUTE #M2B=@NM-#M1B+1.

*        Este algoritmo permite crear las 3 variables que contienen la B y los 2 lmites.
*        Sin embargo, stas variables no son constantes para todos los registros: la creacin
         de una variable desde una scratch asigna a 0 los registros anteriores al
         que contiene valor vlido.
         COMPUTE #PAR=(#MODNM=0).
         IF ($CASENUM = @NB+#PAR) #B=#BB.
         COMPUTE @B=#B.
         IF ($CASENUM =#M1B+@K) #LIB=@M.
         COMPUTE @LIB=#LIB.
         IF ($CASENUM =#M2B+@K) #LSB=@M.
         COMPUTE @LSB=#LSB.

*        Seleccionando el ltimo caso aseguramos que ste contiene valores vlidos.
         DATASET COPY @96578bb WINDOW=HIDDEN.
         DATASET ACTIVATE @96578bb WINDOW=ASIS.
         COMPUTE @casenum2 = $CASENUM.
         EXECUTE.
         SELECT IF (@casenum2=@NM).
         MATCH FILES FILE=* /KEEP=@U @LIB @B @LSB.
         EXECUTE.

*        Recuperamos el archivo de trabajo original.
         DATASET ACTIVATE @96578temp WINDOW = ASIS.
*        Aadimos los lmites del IC de la B y la B.
         MATCH FILES /FILE=* /TABLE =@96578bb /BY @U.
         EXECUTE.
         DATASET CLOSE @96578PB. 
         DATASET CLOSE @96578bb.

*        Creamos la variables cuyas medianas sern la A y su IC.
         COMPUTE @LIA0=@Y-(@LIB*@X).
         COMPUTE   @A0=@Y-(@B  *@X).
         COMPUTE @LSA0=@Y-(@LSB*@X).
         AGGREGATE /OUTFILE =* MODE= ADDVARIABLES /BREAK = @U 
            /@LIA = MEDIAN(@LIA0) /@A = MEDIAN(@A0) /@LSA = MEDIAN(@LSA0).

*        Clculo de los lmites del intervalo de confianza en funcin del sentido de A y B;
         si intervienen guarismos con valores negativos es necesario invertir el dibujo de 
         las rectas. 
         DO IF (@LIA>@LSA).
            COMPUTE #X=@LSA.
            COMPUTE @LSA=@LIA.
            COMPUTE @LIA=#X.
         END IF.
         DO IF (@LIB>@LSB).
            COMPUTE #X=@LSB.
            COMPUTE @LSB=@LIB.
            COMPUTE @LIB=#X.
         END IF.
         EXECUTE.

*********2 PARTE: REPRESENTACIN GRFICA.
*        Grfico de Regresin de Passing-Bablok.
*        Representa la nube de puntos para editarla y dibujar la recta estimada con PB.
         VARIABLE LABELS @X !QUOTE(!X) /@Y !QUOTE(!Y).
         GRAPH /SCATTERPLOT(BIVAR)=@X WITH @Y
            /MISSING=VARIABLEWISE   
            /TITLE= 'Passing-Bablok Regression line'.

*********3 PARTE: TEST DE LINEALIDAD, CUSUM.
*        Creacin de la variable D (distancia de cada punto vs la proyeccin de la recta).
         COMPUTE @D=(@Y+1/@B*@X-@A)/(sqrt(1+1/@B**2)).
         SORT CASES BY @D.

*        Creacin de las variables Lys y Lyi, que valen 1 si el punto se sita sobre o bajo
         la recta, y missing si se sita sobre ella.
         COMPUTE @LYS=(@Y > @A+@B*@X).
         COMPUTE @LYI=(@Y < @A+@B*@X).

*        Calculamos la suma de las dos variables anteriores cuya razn ser R.
         AGGREGATE /OUTFILE =* MODE= ADDVARIABLES /BREAK = @U 
            /@SUMLYS = SUM(@LYS) /@SUMLYI = SUM(@LYI).

*        Clculo de la variable R en funcin de la situacin del punto vs la recta.
         COMPUTE @R=0.
         IF (@Y > @A+@B*@X) @R=SQRT(@SUMLYS/@SUMLYI).
         IF (@Y < @A+@B*@X) @R=-SQRT(@SUMLYI/@SUMLYS).

*        Calculamos la cantidad de puntos consecutivos que se hallan bajo-sobre la recta;
         el absoluto del mximo de este clculo es CUSUM.
         COMPUTE @CUSUM0=SUM(@R,LAG(@CUSUM0)).
         EXECUTE.
         COMPUTE @CUSUM0=ABS(@CUSUM0).
         AGGREGATE /OUTFILE =* MODE= ADDVARIABLES /BREAK = @U 
            /@CUSUM = MAX(@CUSUM0).

*********4 PARTE:IMPRESIN DE LOS NDICES CALCULADOS.
*        Creacin de las variables descriptivas de X e Y (mnima, mxima...).
         COMPUTE @Y_X_PCT=100*@Y_X/@X.
         AGGREGATE /OUTFILE =* MODE= ADDVARIABLES /BREAK = @U 
            /@mdY = MEDIAN(@Y) /@mdX  = MEDIAN(@X) /@mdXYPCT  = MEDIAN(@y_x_pct) /@mdXY = MEDIAN(@y_x)
            /@mnY = MEAN(@Y)   /@mnX  = MEAN(@X)   /@mnXYPCT  = MEAN(@y_x_pct)   /@miXY = MIN(@y_x)
            /@miY = MIN(@Y)    /@miX  = MIN(@X)    /@miXYPCT  = MIN(@y_x_pct)    /@maXY = MAX(@y_x)
            /@maY = MAX(@Y)    /@maX  = MAX(@X)    /@maXYPCT  = MAX(@y_x_pct)
            /@sdY = SD(@Y)     /@sdX  = SD(@X)     /@sdXYPCT  = SD(@y_x_pct).

*        Impresin de ndices.
         TEMPORARY.
         N 1.
*        Clculo del nmero de casos con datos missing.
         COMPUTE #nMisDat = !N - @N.
         PRINT /"PASSING-BABLOK ESTIMATION OF REGRESSION LINE".
         PRINT / ' X: ' !QUOTE(!X).
         PRINT / ' Y: ' !QUOTE(!Y).
         PRINT //'STATISTICS             X            Y         Y-X   100*(Y-X)/X'.
         PRINT /" Median"    @mdX(T13,F12.4) @mdY(T26,F12.4) @mdXY(T38,F12.4) @mdXYPCT(T51,F12.1)"%" .
         PRINT /" Mean"      @mnX(T13,F12.4) @mnY(T26,F12.4) @mnXY(T38,F12.4) @mnXYPCT(T51,F12.1)"%" .
         PRINT /" Minimum"   @miX(T13,F12.4) @miY(T26,F12.4) @miXY(T38,F12.4) @miXYPCT(T51,F12.1)"%" .
         PRINT /" Maximum"   @maX(T13,F12.4) @maY(T26,F12.4) @maXY(T38,F12.4) @maXYPCT(T51,F12.1)"%" .
         PRINT /" Std. Dev." @sdX(T13,F12.4) @sdY(T26,F12.4) @sdXY(T38,F12.4) @sdXYPCT(T51,F12.1)"%" .
         PRINT /"Valid cases:" @N(F4)"    Missing cases:" #nMisDat(F3) .

         PRINT FORMATS ALL (F12.6).
         PRINT//"PASSING-BABLOK REGRESSION LINE (Y = A + B*X):".
         PRINT /" A =" @A "  ( "!QUOTE(!CL)"%CI: " @LIA "   to " @LSA " )".
         PRINT /" B =" @B "  ( "!QUOTE(!CL)"%CI: " @LIB "   to " @LSB " )".

*        Impresin del Test de linealidad.
         DO IF (@CUSUM > 1.63*sqrt(@SUMLYS+1)).
            PRINT//"LINEARITY TEST (CUSUM Test for deviation from linearity):   p < 0.01".
         ELSE IF (@CUSUM <= 1.63*sqrt(@SUMLYS+1) and @CUSUM > 1.36*sqrt(@SUMLYS+1)).
            PRINT//"LINEARITY TEST (CUSUM Test for deviation from linearity):   p < 0.05".
         ELSE IF (@CUSUM <= 1.36*sqrt(@SUMLYS+1) and @CUSUM > 1.22*sqrt(@SUMLYS+1)).
            PRINT//"LINEARITY TEST (CUSUM Test for deviation from linearity):   p < 0.10".
         ELSE IF (@CUSUM <= 1.22*sqrt(@SUMLYS+1) and @CUSUM > 1.07*sqrt(@SUMLYS+1)).
            PRINT//"LINEARITY TEST (CUSUM Test for deviation from linearity):   p < 0.20".
         ELSE IF (@CUSUM <= 1.07*sqrt(@SUMLYS+1)).
            PRINT//"LINEARITY TEST (CUSUM Test for deviation from linearity):   p > 0.20". 
         END IF.
         EXECUTE.
      !IFEND.

*     Clculo de: Lin, L,(1989) A concordance correlation coefficient to evaluate reproductivity,Biometrics, 45:255-268.
      COMPUTE @CXY=@CXY/(@N-1).
      COMPUTE @varx=(@varx)**2.
      COMPUTE @vary=(@vary)**2.
      COMPUTE @lin=2*@CXY/(@varx + @vary + (@MEANX-@MEANY)**2).
      TEMPORARY.
      N 1.
      PRINT   //"Lin's Concordance Correlation coeff. of Absolute Agreement =" @lin(F8.5).
      EXECUTE.

*     Impresin del INPUT DATA si METHOD=PB,BO y LIST.
      !IF (!LIST<>1 !AND (!METHOD=PB !OR !METHOD=BO)) !THEN.
         SORT CASES BY @casenum(A).
         DO IF ($casenum=1).
            PRINT //'INPUT DATA'.            
            PRINT /'Identifier' 'X'19   'Y'32     'Y-X'44   '(Y-X) in % of X'52 .
         END IF.
         PRINT /@Identifier(F8) @X(T12,F12.4) @Y(T25,F12.4) @y_x(T38,F12.4) @y_x_pct(T55,F5.1).
      !IFEND.
      EXECUTE.

      !IF (!METHODU=BA !OR !METHODU=BO) !THEN.
*        Clculo del intervalo de acuerdo de Bland-Altman.
         COMPUTE #p = (!CL+100)/200.
         COMPUTE @IABA_l= @mnXY - IDF.NORMAL(#p,0,1)*@sdXY.
         COMPUTE @IABA_u= @mnXY + IDF.NORMAL(#p,0,1)*@sdXY.

*        Calculamos el nmero de casos por encima y por debajo del lmite.
         COMPUTE @NOVER = (@y_x > @IABA_u ).
         COMPUTE @NUNDER = (@y_x < @IABA_l ).
         AGGREGATE /OUTFILE =* MODE= ADDVARIABLES /BREAK = @U 
            /@SOVER = SUM(@NOVER) /@SUNDER = SUM(@NUNDER).

*        Calculamos los porcentajes.
         COMPUTE @OVER = (@SOVER/@N)*100.
         COMPUTE @UNDER = (@SUNDER/@N)*100.
         EXECUTE.

*        Impresin de los ndices.
         TEMPORARY.
         N 1.
         COMPUTE #Missing = !N - @N.
         PRINT   //"Bland-Altman Interval of Agreement".
         PRINT    /"--------------------------------------------------------------------".
         PRINT    /"    Mean of Y-X=" @mnXY(F12.6) " ( "!QUOTE(!CL)"% AI:"@IABA_l(F12.6)"  to"@IABA_u(F12.6) " )".
         PRINT    /"        Cases over limit=" @SOVER(F3) " (" @Over(F5.2) '%)'.
         PRINT    /"       Cases under limit=" @SUNDER(F3)" (" @Under(F5.2)'%)'.
         PRINT    /"--------------------------------------------------------------------".
         PRINT    /"Valid cases= " @N(F3) "     Missing cases= " #Missing(F3).
         EXECUTE.

*        Creamos la semisuma y representamos el grfico.
         COMPUTE @y_x2= (@Y+@Y)/2.
         VARIABLE LABELS @y_x2 '(X+Y)/2'.
         GRAPH /SCATTERPLOT(BIVAR)=@y_x2 WITH @y_x
            /TITLE= 'Bland-Altman Agreement'.

*        Prueba de normalidad de las diferencias.
         OMS /SELECT ALL /IF COMMANDS = ["Explore"]
              SUBTYPES = ["Case Processing Summary" "Descriptives" "Extreme Values" "M Estimators" "Notes" 
                          "Percentiles" "Test of Homogeneity of Variance" "Warnings"]
             /DESTINATION   VIEWER = NO.
         EXAMINE VARIABLES=@y_x /PLOT NPPLOT /STATISTICS NONE.
         OMSEND.
      !IFEND.
      
*     Restauramos los datos originales y cerramos los datasets temporales.
      DATASET ACTIVATE @96578original WINDOW = FRONT.
      DATASET CLOSE @96578temp.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.