PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
  PRINT /'Macro !KAPPA V2015.04.17 loaded.'
        /'Execute !KAPPA HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !KAPPA ( VarR1=!CHAREND('/') /VarR2=!CHAREND('/') 
               /LABEL=!CHAREND('/') /K=!CHAREND('/')
               /CASES=!CHAREND('/') 
                  /CL=!CHAREND('/')!DEFAULT('95')
                /PrCI=!CHAREND('/')!DEFAULT('W')
               /ORDER=!CHAREND('/')!DEFAULT('Y')
                 /NST=!CHAREND('/') 
                /HELP=!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132.
!LET !VERSION=!QUOTE('2015.04.17').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
!LET !WINDOW='HIDDEN'.
DO IF ($casenum=1).
   PRINT //'Macro !KAPPA V' !VERSION ' (c)JM.Domenech & R.Granero'.
END IF.
!IF (!HELP<>1) !THEN
*  Print HELP.
   DO IF ($casenum=1).
      PRINT /'*******************************************************************************'
            /'* WEIGHTED KAPPA                                                              *'
            /'* Created 2000.05.19 Last revised ' !VERSION                                 '*'79
            /'* (c) JM.Domenech & R.Granero                                                 *'
            /'* Programmers: A.Bonillo & R.Sesma                                            *'
            /'*                                                                             *'
            /'* Vancouver reference:                                                        *'
            /'* Domenech JM, Granero R. Macro !KAPPA for SPSS Statistics.                   *'
            /'*    Weighted Kappa [computer program].                                       *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autonoma de Barcelona; ' !YEAR '.' '*'79
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                    *'
            /'*                                                                             *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                               *'
            /'* Parameter for PRINTING MACRO DOCUMENTATION ---------------------------------*'
            /'*  !KAPPA HELP.                                                               *'
            /'*                                                                             *'
            /'* Parameters for INDIVIDUAL DATA ---------------------------------------------*'
            /'*  !KAPPA VarR1 = Variable with results of rater 1                            *'
            /'*         VarR2 = Variable with results of rater 2                            *'
            /'*            {K = Number of rating categories          (integer >= 2)         *'
            /'*      or LABEL}= Labels of rating categories          (<= 4 characters)      *'
            /'*                 Maximum number of rating categories is 10                   *'
            /'*                                                                             *'
            /'* Parameters for AGGREGATED DATA ---------------------------------------------*'
            /'*  !KAPPA LABEL = Labels of rating categories          (<= 4 characters)      *'
            /'*                 Maximum number of rating categories is 10                   *'
            /'*        /CASES = List (by rows) of cases in each cell (integer >= 0)         *'
            /'*                                                                             *'
            /'* Parameters for BOTH TYPES OF DATA ------------------------------------------*'
            /'*       [/ORDER]= Ordered categories?                                         *'
            /'*                 Y  Yes (default)                                            *'
            /'*                 N  No                                                       *'
            /'*          [/CL]= Confidence level(%);   by default:95 (50 =< CL < 100)       *'
            /'*        [/PrCI]= Method for compute CI of proportions:                       *'
            /'*                 W  Wilson                            by default: W          *'
            /'*                 E  Exact (Clopper-Pearson)                                  *'
            /'*                 A  Asymptotic                                               *'
            /'*         [/NST]= Name of the study (Label)                                   *'
            /'*                                                                             *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional               *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements  *'
            /'*                                                                             *'
            /'* Samples of calls:                   +-----------+-------------------------+ *'
            /'*  !KAPPA HELP.                       |           |RATING 2                 | *'
            /'*  !KAPPA LABEL= "I" "II" "III" "IV"  |           |  1  |  2  |  ...  |  K  | *'
            /'*        /CASES= 15    5     3    1   +-----------+-----+-----+-------+-----+ *'
            /'*                 5   15     6    2   |RATING 1  1| N11 | N12 |  ...  | N1K | *'
            /'*                 3    6    15    3   |          2| N21 | N22 |  ...  | N2K | *'
            /'*                 1    2     3   15   |          .| ... | ... |  ...  | ... | *'
            /'*           /CL=95 /NST="Study Name". |          K| NK1 | NK2 |  ...  | NKK | *'
            /'*  !KAPPA VarR1= R1 /VarR2=R2 /K=4.   +-----------+-----+-----+-------+-----+ *'
            /'*******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE. 
   DATASET NAME @original.

*  Test coherent parameters.
   !LET !ERROR=0.
   !IF (!CASES=!NULL) !THEN.
      !IF (!VarR1=!NULL !OR !VarR2=!NULL) !THEN.
         !LET !ERROR=1.
      !ELSE.
         !IF (!Label=!NULL !AND !K=!NULL) !THEN.
            !LET !ERROR=2.
         !ELSE.
            !IF (!Label<>!NULL !AND !K<>!NULL) !THEN.
               !LET !ERROR=3.
            !ELSE.
               !IF (!CASES<>!NULL) !THEN.
                  !LET !ERROR=4.
               !IFEND.
            !IFEND.
         !IFEND.
      !IFEND.
   !ELSE.
      !IF (!Label=!NULL) !THEN.
         !LET !ERROR=5.
      !ELSE.
         !IF (!K<>!NULL !OR !VarR1<>!NULL !OR !VarR2<>!NULL) !THEN.
            !LET !ERROR=6.
         !IFEND.
      !IFEND.
   !IFEND.
*  Test parameter PRINT.
   !LET !OrderU=!UPCASE(!ORDER).
   !IF (!ERROR=0 !AND !OrderU<>'Y' !AND !OrderU<>'N') !THEN.
      !LET !ERROR=7.
   !IFEND.
*  Test parameter PrCI.
   !LET !PrCIU=!UPCASE(!PrCI).
   !IF (!ERROR=0 !AND !PrCIU<>'W' !AND !PrCIU<>'E' !AND !PrCIU<>'A') !THEN.
      !LET !ERROR=8.
   !IFEND.
*  If necessary, print error messages.
   TEMPORARY.
   N 1.
   !IF (!ERROR=1) !THEN.
      PRINT /'ERROR: Parameter(s) VarR1 or VarR2 missing. See the HELP.'.
   !IFEND.
   !IF (!ERROR=2) !THEN.
      PRINT /'ERROR: Parameter Label or K missing. See the HELP.'.
   !IFEND.
   !IF (!ERROR=3) !THEN.
      PRINT /'ERROR: Too much parameters.'.
      PRINT /'       Parameter K and parameter Label are incompatible. See the HELP.'.
   !IFEND.
   !IF (!ERROR=4) !THEN.
      PRINT /'ERROR: Too much parameters. Parameter CASES is incompatible'.
      PRINT /'       with parameters VarR1, VarR2. See the HELP.'.
   !IFEND.
   !IF (!ERROR=5) !THEN.
      PRINT /'ERROR: Parameter Label missing. See the HELP.'.
   !IFEND.
   !IF (!ERROR=6) !THEN.
      PRINT /'ERROR: Too much parameters. Parameter(s) K, VarR1 or VarR2 are '.
      PRINT /'       incompatible with parameter CASES. See the HELP.'.
   !IFEND.
   !IF (!ERROR=7) !THEN.
      PRINT /'ERROR: Parameter ORDER with wrong value. See the HELP.'.
   !IFEND.
   !IF (!ERROR=8) !THEN.
      PRINT /'ERROR: Parameter PrCI with wrong value. See the HELP.'.
   !IFEND.
   EXECUTE.
   
   !IF (!ERROR=0) !THEN.
******Number of categories.
      !IF (!K<>!NULL) !THEN.
         !LET !NCat=!K.
      !ELSE.
         !LET !NCat=''.
         !DO !I !IN (!Label).
            !LET !NCat=!CONCAT(!NCat,' ').
         !DOEND.
         !LET !NCat=!LENGTH(!NCat).
      !IFEND.
*     Variables generated by the CROSSTABS / CASES parameter.
      !LET !Vars=''.
      !DO !I=1 !TO !NCat.
         !LET !Vars=!CONCAT(!Vars,'@',!I,' ').
      !DOEND.
      
      !IF (!VarR1<>!NULL !AND !VarR2<>!NULL) !THEN.   
*********INDIVIDUAL DATA: get the data from the table vars using CROSSTABS.
*        Make a copy of the original dataset to work.
         DATASET COPY @work WINDOW=!WINDOW.
         DATASET ACTIVATE @work.

*********AUTORECODE: the variables have categories 1,2,3,etc.
         PRESERVE.
         SET ERRORS = NONE RESULTS = NONE MESSAGES = NONE PRINTBACK = NONE.
         AUTORECODE VARIABLES=!VarR1 !VarR2 /INTO @VR_1 @VR_2 /GROUP.
         *AUTORECODE VARIABLES=!VarR2 /INTO @VR_2.
         RESTORE.

*********CROSSTABS + OMS: get the data.
         PRESERVE.
         SET TNUMBERS=VALUES OLANG=ENGLISH.
         OMS /SELECT ALL /IF COMMANDS = ["Crosstabs"] /DESTINATION  VIEWER = NO.
         DATASET DECLARE @DATA WINDON=!WINDOW.
         OMS /SELECT TABLES /IF COMMANDS = ["Crosstabs"] SUBTYPES = ["Crosstabulation"]
             /DESTINATION FORMAT = SAV NUMBERED = Num OUTFILE = @DATA.
         DATASET DECLARE @CASES WINDON=!WINDOW.
         OMS /SELECT TABLES /IF COMMANDS = ["Crosstabs"] SUBTYPES = ["Case Processing Summary"]
             /DESTINATION FORMAT = SAV NUMBERED = Num OUTFILE = @CASES.
         OMS /SELECT ALL /IF COMMANDS = ["Crosstabs"] /DESTINATION  VIEWER = NO.
         CROSSTABS VARIABLES=@VR_1 @VR_2 (1,!NCat) /TABLES=@VR_1 BY @VR_2 
           /CELLS= COUNT TOTAL /COUNT ASIS .
         OMSEND.
         RESTORE.
*********GET VarR1 categories and VALUE LABELS.
         PRESERVE.
         SET TNUMBERS=BOTH OLANG=ENGLISH.
         DATASET DECLARE @Labels WINDOW=!WINDOW.
         OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION   VIEWER = NO.
         OMS /SELECT TABLES /IF COMMANDS = ["Frequencies"]  SUBTYPES = ["Frequencies"]
          /DESTINATION FORMAT = SAV NUMBERED = Num  OUTFILE = @Labels.
         OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION   VIEWER = NO.
         FREQUENCIES  VARIABLES=!VarR1 /ORDER=  ANALYSIS .
         OMSEND.
         RESTORE.

*********Close @work dataset.
         DATASET CLOSE @work.

         DATASET ACTIVATE @DATA.
         !LET !Keep=!CONCAT('Cat ',!Vars,'Total').
         SELECT IF (Var3='Count' OR SYSMIS(Var2)).
         MATCH FILES FILE=* /RENAME=(Var2=Cat) /KEEP=!Keep.
      !ELSE.
*********AGGREGATED DATA: build @DATA dataset from Cases, Label parameters.
         DATASET COPY @DATA WINDOW=!WINDOW.
         DATASET ACTIVATE @DATA.
         SPLIT FILE OFF.
         WEIGHT OFF.
         N 1.
         COMPUTE U=1.
         MATCH FILES FILE=* /KEEP=U.
*        Create the @Descrip variables with the labels and the Cat variables with the categories.
         !LET !COUNT=''.
         !DO !I !IN (!Label).
            !LET !COUNT=!CONCAT(!COUNT,' ').
            !LET !VarName = !CONCAT('@Descrip',!LENGTH(!COUNT)).
            STRING !VarName(A5).
            COMPUTE !VarName = !I.
            COMPUTE !CONCAT('Cat',!LENGTH(!COUNT)) = !LENGTH(!COUNT).
         !DOEND.
*        Add the @1 -> @COUNT variables.
         !LET !Col = ' '.
         !LET !Row = ' '.
         !LET !NumCases=''.
         !DO !I !IN (!CASES).
            !LET !VarName = !CONCAT('@',!LENGTH(!Row),!LENGTH(!Col)).
            COMPUTE !VarName = !I.
            !IF (!LENGTH(!Row)=!LENGTH(!COUNT)) !THEN.
               !LET !Row = ' '.
               !LET !Col = !CONCAT(!Col,' ').
            !ELSE.
               !LET !Row = !CONCAT(!Row,' ').
            !IFEND.
            !LET !NumCases=!CONCAT(!NumCases,' ').
         !DOEND.
         !LET !NumCases=!LENGTH(!NumCases).
*        Add the TOTAL, PCT row.
         !LET !Temp = !COUNT.
         !LET !COUNT = !LENGTH(!COUNT).
         !DO !I=1 !TO 2.
            !LET !Temp = !CONCAT(!Temp,' ').
            STRING !CONCAT('@Descrip',!LENGTH(!Temp)) (A5).
            !IF (!I=1) !THEN.
               COMPUTE !CONCAT('@Descrip',!LENGTH(!Temp)) = 'TOTAL'.
            !ELSE.
               COMPUTE !CONCAT('@Descrip',!LENGTH(!Temp)) = '  PCT'.
            !IFEND.
            COMPUTE !CONCAT('Cat',!LENGTH(!Temp)) = $SYSMIS.
            !DO !J=1 !TO !COUNT.
               COMPUTE !CONCAT('@',!J,!LENGTH(!Temp)) = $SYSMIS.
            !DOEND.
         !DOEND.
*        Create the !Make variables for the VARSTOCASES.
         !LET !Temp = !LENGTH(!Temp).
         !LET !MakeCat = '  /MAKE Cat FROM Cat1'.
         !LET !MakeDescrip = '  /MAKE @Descrip FROM @Descrip1'.
         !DO !I=2 !TO !Temp.
            !LET !MakeCat = !CONCAT(!MakeCat,' Cat',!I).
            !LET !MakeDescrip = !CONCAT(!MakeDescrip,' @Descrip',!I).
         !DOEND.
         !LET !MAKE = !CONCAT(!MakeCat,!MakeDescrip).
         !DO !J=1 !TO !COUNT.
            !LET !MAKE = !CONCAT(!MAKE,'  /MAKE @',!J,' FROM').
            !DO !I=1 !TO !Temp.
               !LET !MAKE = !CONCAT(!MAKE,' @',!J,!I).
            !DOEND.
         !DOEND.
*        Use VARSTOCASES to create @DATA.
         OMS /SELECT ALL /IF COMMANDS = ["Variables to Cases"] /DESTINATION   VIEWER = NO.
         VARSTOCASES !MAKE  /KEEP=  /NULL=KEEP.
         OMSEND.
*********Prepare @DATA dataset for the computations.
*        Align @Descrip to the right.
         IF (NOT SYSMIS(Cat)) @Descrip = LPAD(RTRIM(@Descrip),5).
*        Compute Total variable with Row Totals.
         COMPUTE Total = SUM(@1 To !CONCAT('@',!COUNT)).
*        Compute TotalC variables with Column Totals.
         COMPUTE @U=1.
         !LET !Aggr=' /N=SUM(Total)'.
         !DO !I=1 !TO !COUNT.
            !LET !Aggr = !CONCAT(!Aggr,' /TotalC',!I,' = SUM(@',!I,')').
         !DOEND.
         AGGREGATE OUTFILE=* MODE=ADDVARIABLES /BREAK=@U !Aggr.
*        Add the column totals in the 'TOTAL' row.
         !DO !I=1 !TO !COUNT.
            IF (@Descrip='TOTAL') !CONCAT('@',!I) = !CONCAT('TotalC',!I).
         !DOEND.
         IF (@Descrip='TOTAL') Total = N.
         EXECUTE.
*        Add the column percentages in the '  PCT' row.
         !DO !I=1 !TO !COUNT.
            IF (@Descrip='  PCT') !CONCAT('@',!I) = (!CONCAT('TotalC',!I)/N)*100.
         !DOEND.
         IF (@Descrip='  PCT') Total = 100.
         COMPUTE @NumCases=!NumCases.
         EXECUTE.
      !IFEND.

      COMPUTE @Match = $casenum.
      COMPUTE @NCat=!NCat.
      COMPUTE @Last=(@Match=(@NCat+2)).
      COMPUTE @U=1.

      !IF (!VarR1<>!NULL !AND !VarR2<>!NULL) !THEN.   
*        Add N (total number of cases) as a variable; add the TotalCn variables (column totals).
         TEMPORARY.
         SELECT IF (@Last<>1).
         !LET !Aggr=' /N = LAST(Total)'.
         !DO !I=1 !TO !NCat.
            !LET !Aggr = !CONCAT(!Aggr,' /TotalC',!I,' = LAST(@',!I,')').
         !DOEND.
         AGGREGATE  /OUTFILE=*  MODE=ADDVARIABLES  /BREAK=@U  !Aggr.
      !IFEND.   

*     Find out if there's only one cell with data: Const=1.
      !DO !I=1 !TO !NCat.
         IF (NOT SYSMIS(Cat)) !CONCAT('@Const',!I) = (!CONCAT('@',!I) = N).
      !DOEND.
      COMPUTE @Const=SUM(@Const1 TO !CONCAT('@Const',!NCat)).
      AGGREGATE  /OUTFILE=*  MODE=ADDVARIABLES  /BREAK=@U  /Const=SUM(@Const).

******Test numeric parameters.
      COMPUTE @ErrType = 0.
      !IF (!CASES<>!NULL) !THEN.
         !DO !I=1 !TO !NCat.
            !LET !VarName=!CONCAT('@',!I).
            DO IF (SYSMIS(!VarName)).
               COMPUTE @ErrType=1.
            ELSE.
               IF (NOT SYSMIS(Cat) AND (MOD(!VarName,1)<>0 OR !VarName < 0)) @ErrType=1.
            END IF.
         !DOEND.
      !IFEND.
      COMPUTE @CL=!CL.
      DO IF SYSMIS(@CL).
         COMPUTE @ErrType=2.
      ELSE.
         IF (@CL<50 OR @CL>=100) @ErrType=2.
      END IF.
      IF (@NCat>10) @ErrType=3.
      !IF (!CASES<>!NULL) !THEN.
         IF (@NCat<>SQR(@NumCases)) @ErrType=4.
      !IFEND.
      AGGREGATE  /OUTFILE=*  MODE=ADDVARIABLES  /BREAK=@U  /ErrType=MAX(@ErrType).
      COMPUTE ERROR=ErrType>0.
      EXECUTE.
      
*     Print heading and study title.
      DO IF (ErrType=1 AND $casenum=1).
         PRINT /'ERROR: Parameter CASES with wrong values. See the HELP.'.
      ELSE IF (ErrType=2 AND $casenum=1).
         PRINT /'ERROR: Parameter CL with wrong values. See the HELP.'.
      ELSE IF (ErrType=3 AND $casenum=1).
         PRINT /'ERROR: The maximum number of categories is 10. See the HELP.'.
      ELSE IF (ErrType=4 AND $casenum=1).
         PRINT /'ERROR: The number of categories is incoherent with the number of CASES. See the HELP.'.
      ELSE.
         DO IF ($casenum=1 AND ERROR=0).
            PRINT /'WEIGHTED KAPPA'.
            !IF (!NST !NE !NULL) !THEN .
               STRING #NST (A131).
               COMPUTE #NST = CONCAT('STUDY: ',!NST).
               PRINT /#NST.
            !IFEND.
         END IF.
      END IF.
      EXECUTE.

      !IF (!VarR1<>!NULL !AND !VarR2<>!NULL) !THEN.
         DATASET COPY @ERROR WINDOW=!WINDOW.
         DATASET ACTIVATE @ERROR.
         N 1.
         EXECUTE.
         MATCH FILES FILE=* /KEEP=@U ERROR.
         EXECUTE.
*********Print Rating 1, Rating2 variable names and values and labels.
         DATASET ACTIVATE @Labels.
         SELECT IF (NOT SYSMIS(CumulativePercent)).
         COMPUTE Cat=$casenum.
         COMPUTE @U=1.
         AGGREGATE  /OUTFILE=*  MODE=ADDVARIABLES  /BREAK=@U  /@N=N.
         COMPUTE @NCat = !NCat.
         COMPUTE @VoidCat= (@N<@NCat).
         STRING @Val (A5) @Label (A50).
         COMPUTE @Val = LPAD(SUBSTR(Var2,1,INDEX(Var2,' ')-1),5).
         COMPUTE @Label = SUBSTR(Var2,INDEX(Var2,' ')+1).
         MATCH FILES FILE=* /TABLE=@ERROR /BY @U.
         EXECUTE.

         DO IF (ERROR=0).
            DO IF ($casenum=1).
               PRINT //'RATING 1 variable: ' !QUOTE(!VarR1).
               PRINT  /'RATING 2 variable: ' !QUOTE(!VarR2).
               !IF (!Label=!NULL) !THEN.
                  DO IF (@VoidCat=0).
                     PRINT  /'   Value   Label'.
                  END IF.
               !IFEND.
            END IF.
            !IF (!Label=!NULL) !THEN.
               DO IF (@VoidCat=0).
                  PRINT /'   ' @Val(A5) '   ' @Label(A50).
               END IF.
            !IFEND.
         END IF.
         MATCH FILES FILE=* /KEEP=Cat @Val @VoidCat.
         EXECUTE.

*        Case Processing Summary.
         DATASET ACTIVATE @CASES.
         COMPUTE @U=1.
         MATCH FILES FILE=* /TABLE=@ERROR /BY @U.
         EXECUTE.
         DO IF (ERROR=0).
            PRINT //'Valid cases=' Valid_N(F6) ' (' Valid_Percent(PCT6.1) ')'.
            PRINT  /'Total cases=' Total_N(F6).
         END IF.
         EXECUTE.
         DATASET CLOSE @CASES.
         DATASET CLOSE @ERROR.
      !IFEND.

      !IF (!VarR1<>!NULL !AND !VarR2<>!NULL) !THEN.
*        Add to @DATA the info from @Labels dataset.
         DATASET ACTIVATE @DATA.
         IF (SYSMIS(Cat)) Cat=99.
         MATCH FILES FILE=* /TABLE=@Labels /BY Cat.
         IF (Cat=99) Cat=$SYSMIS.
         EXECUTE.
         DATASET CLOSE @Labels.
         AGGREGATE  /OUTFILE=*  MODE=ADDVARIABLES  /BREAK=@U  /VoidCat=MAX(@VoidCat).
         EXECUTE.
*        Build @Descrip variable with the labels of the categories.
         STRING @Descrip(A5).
         COMPUTE @Descrip=' '.
         !IF (!Label<>!NULL) !THEN.
*           If parameter Label is present, use the values provided.
            !LET !COUNT=''.
            !DO !I !IN (!Label).
               !LET !COUNT = !CONCAT(!COUNT,' ').
               !LET !Temp = !LENGTH(!COUNT).
               IF (Cat = !Temp) @Descrip = !I.
            !DOEND.
         !ELSE.
            DO IF (VoidCat=1).
*              If there are void categories, use sequential labels.
               COMPUTE @Descrip=LPAD(RTRIM(LTRIM(STRING(Cat,F5))),5).
            ELSE.
*              The labels are the values.
               COMPUTE @Descrip=@Val.
            END IF.    
         !IFEND.
         IF (SYSMIS(Cat) AND @Last=0) @Descrip='TOTAL'.
         IF (SYSMIS(Cat) AND @Last=1) @Descrip='  PCT'.
         EXECUTE.
      !IFEND.

*     Compute the row percentages.
      COMPUTE @PCT= (Total/N)*100.
      COMPUTE @P =(@CL+100)/200.
      COMPUTE @Z =IDF.NORMAL(@P,0,1).
      EXECUTE.
*     CI compute method (PrCI): W (Wilson) = 1 - default; E (Exact) = 2; A (Asymptotic) = 3.
      COMPUTE @PrCI=0.
      IF (!QUOTE(!PrCIU)='W') @PrCI=1.
      IF (!QUOTE(!PrCIU)='E') @PrCI=2.
      IF (!QUOTE(!PrCIU)='A') @PrCI=3.
      STRING @CItype (A8).
      IF (!QUOTE(!PrCIU)='W') @CItype = '(Wilson)'.
      IF (!QUOTE(!PrCIU)='E') @CItype = ' (Exact)'.
      IF (!QUOTE(!PrCIU)='A') @CItype = ' (Asymp)'.

******Compute of weights: unweighted, lineal and quadratic; terms of ObsAgr and Expected summatories.
      !LET !SumU='@ObsAgrU1'.
      !LET !SumL='@ObsAgrL1'.
      !LET !SumQ='@ObsAgrQ1'.
      !LET !SumEU='@ExpectedU1'.
      !LET !SumEL='@ExpectedL1'.
      !LET !SumEQ='@ExpectedQ1'.
      !DO !I=1 !TO !NCat.
         COMPUTE !CONCAT('Wu',!I) = (Cat=!I).
         COMPUTE !CONCAT('Wl',!I) = 1- (ABS(Cat-!I)/(@NCat-1)).
         COMPUTE !CONCAT('Wq',!I) = 1- (ABS(Cat-!I)/(@NCat-1))**2.
         COMPUTE !CONCAT('@ObsAgrU',!I) = !CONCAT('Wu',!I)*!CONCAT('@',!I)/N.
         COMPUTE !CONCAT('@ObsAgrL',!I) = !CONCAT('Wl',!I)*!CONCAT('@',!I)/N.
         COMPUTE !CONCAT('@ObsAgrQ',!I) = !CONCAT('Wq',!I)*!CONCAT('@',!I)/N.
         COMPUTE !CONCAT('@ExpectedU',!I) = (Total/N)*(!CONCAT('TotalC',!I)/N)*!CONCAT('Wu',!I).
         COMPUTE !CONCAT('@ExpectedL',!I) = (Total/N)*(!CONCAT('TotalC',!I)/N)*!CONCAT('Wl',!I).
         COMPUTE !CONCAT('@ExpectedQ',!I) = (Total/N)*(!CONCAT('TotalC',!I)/N)*!CONCAT('Wq',!I).
         !IF (!I<>1) !THEN.
            !LET !SumU = !CONCAT(!SumU,',@ObsAgrU',!I).
            !LET !SumL = !CONCAT(!SumL,',@ObsAgrL',!I).
            !LET !SumQ = !CONCAT(!SumQ,',@ObsAgrQ',!I).
            !LET !SumEU = !CONCAT(!SumEU,',@ExpectedU',!I).
            !LET !SumEL = !CONCAT(!SumEL,',@ExpectedL',!I).
            !LET !SumEQ = !CONCAT(!SumEQ,',@ExpectedQ',!I).
         !IFEND.
      !DOEND.
      COMPUTE @ObsAgrU = SUM(!SumU).
      COMPUTE @ObsAgrL = SUM(!SumL).
      COMPUTE @ObsAgrQ = SUM(!SumQ).
      COMPUTE @ExpectedU = SUM(!SumEU).
      COMPUTE @ExpectedL = SUM(!SumEL).
      COMPUTE @ExpectedQ = SUM(!SumEQ).

*     Compute of WJ (Sum Wijp+i) WI (Sum Wijp+j) summatories (lin and quad).
      !LET !Aggr=''.
      !DO !I=1 !TO !NCat.
         COMPUTE !CONCAT('@WIu',!I) = !CONCAT('Wu',!I)/N*Total.
         COMPUTE !CONCAT('@WJu',!I) = !CONCAT('Wu',!I)/N*!CONCAT('TotalC',!I).
         COMPUTE !CONCAT('@WIl',!I) = !CONCAT('Wl',!I)/N*Total.
         COMPUTE !CONCAT('@WJl',!I) = !CONCAT('Wl',!I)/N*!CONCAT('TotalC',!I).
         COMPUTE !CONCAT('@WIq',!I) = !CONCAT('Wq',!I)/N*Total.
         COMPUTE !CONCAT('@WJq',!I) = !CONCAT('Wq',!I)/N*!CONCAT('TotalC',!I).
         !LET !Aggr=!CONCAT(!Aggr,' /WIu',!I,' = SUM(@WIu',!I,')',' /WIl',!I,' = SUM(@WIl',!I,')',' /WIq',!I,' = SUM(@WIq',!I,')').
      !DOEND.
******Compute of Observed Agreements (unw, lin, quad), Expected (lin and quad), WI (lin and quad), WJ (lin and quad).
      !LET !Aggr = !CONCAT(' /ObsAgrU=SUM(@ObsAgrU) /ObsAgrL=SUM(@ObsAgrL) /ObsAgrQ=SUM(@ObsAgrQ) /ExpectedU=SUM(@ExpectedU) /ExpectedL=SUM(@ExpectedL) /ExpectedQ=SUM(@ExpectedQ)',!Aggr).
      AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /BREAK=@U !Aggr.
      !LET !SUMU='@WJu1'.
      !LET !SUML='@WJl1'.
      !LET !SUMQ='@WJq1'.
      !DO !I=2 !TO !NCat.
         !LET !SUMU = !CONCAT(!SUMU,',@WJu',!I).
         !LET !SUML = !CONCAT(!SUML,',@WJl',!I).
         !LET !SUMQ = !CONCAT(!SUMQ,',@WJq',!I).
      !DOEND.
      COMPUTE WJu = SUM(!SUMU).
      COMPUTE WJl = SUM(!SUML).
      COMPUTE WJq = SUM(!SUMQ).

*     Compute Standars Errors: Standard Errors 0 & 1 (lin and quad). 
      !LET !SUMSE0u='@SE0u1'.
      !LET !SUMSE0l='@SE0l1'.
      !LET !SUMSE0q='@SE0q1'.
      !LET !SUMSE1u='@SE1u1'.
      !LET !SUMSE1l='@SE1l1'.
      !LET !SUMSE1q='@SE1q1'.
      !DO !I=1 !TO !NCat.
         COMPUTE !CONCAT('@SE0u',!I) = (Total/N)*(!CONCAT('TotalC',!I)/N)*(!CONCAT('Wu',!I) - (!CONCAT('WIu',!I)+WJu))**2.
         COMPUTE !CONCAT('@SE0l',!I) = (Total/N)*(!CONCAT('TotalC',!I)/N)*(!CONCAT('Wl',!I) - (!CONCAT('WIl',!I)+WJl))**2.
         COMPUTE !CONCAT('@SE0q',!I) = (Total/N)*(!CONCAT('TotalC',!I)/N)*(!CONCAT('Wq',!I) - (!CONCAT('WIq',!I)+WJq))**2.
         COMPUTE !CONCAT('@SE1u',!I) = (!CONCAT('@',!I)/N)*(!CONCAT('Wu',!I)*(1-ExpectedU) - (!CONCAT('WIu',!I)+WJu)*(1-ObsAgrU))**2.
         COMPUTE !CONCAT('@SE1l',!I) = (!CONCAT('@',!I)/N)*(!CONCAT('Wl',!I)*(1-ExpectedL) - (!CONCAT('WIl',!I)+WJl)*(1-ObsAgrL))**2.
         COMPUTE !CONCAT('@SE1q',!I) = (!CONCAT('@',!I)/N)*(!CONCAT('Wq',!I)*(1-ExpectedQ) - (!CONCAT('WIq',!I)+WJq)*(1-ObsAgrQ))**2.
         !IF (!I<>1) !THEN.
            !LET !SUMSE0u = !CONCAT(!SUMSE0u,',@SE0u',!I).
            !LET !SUMSE0l = !CONCAT(!SUMSE0l,',@SE0l',!I).
            !LET !SUMSE0q = !CONCAT(!SUMSE0q,',@SE0q',!I).
            !LET !SUMSE1u = !CONCAT(!SUMSE1u,',@SE1u',!I).
            !LET !SUMSE1l = !CONCAT(!SUMSE1l,',@SE1l',!I).
            !LET !SUMSE1q = !CONCAT(!SUMSE1q,',@SE1q',!I).
         !IFEND.
      !DOEND.
      COMPUTE @SE0u = SUM(!SUMSE0u).
      COMPUTE @SE0l = SUM(!SUMSE0l).
      COMPUTE @SE0q = SUM(!SUMSE0q).
      COMPUTE @SE1u = SUM(!SUMSE1u).
      COMPUTE @SE1l = SUM(!SUMSE1l).
      COMPUTE @SE1q = SUM(!SUMSE1q).
      AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /BREAK=@U /SE0u=SUM(@SE0u) /SE0l=SUM(@SE0l) /SE0q=SUM(@SE0q) /SE1u=SUM(@SE1u) /SE1l=SUM(@SE1l) /SE1q=SUM(@SE1q).
            
******Compute of Kappa Unweighted.
      COMPUTE KappaU = (ObsAgrU - ExpectedU)/(1 - ExpectedU).
*     Kappa Unweighted Confidence Interval.
      COMPUTE SEKappaU=SQR((SE1u - (ObsAgrU*ExpectedU-2*ExpectedU+ObsAgrU)**2)/(N*(1-ExpectedU)**4)).
      COMPUTE lbKappaU = KappaU - @Z*SEKappaU.
      COMPUTE ubKappaU = KappaU + @Z*SEKappaU.
      COMPUTE SE0u = SQR((SE0u-ExpectedU**2)/(N*(1-ExpectedU)**2)).
      COMPUTE pKappaU =2*(1-CDFNORM(ABS(KappaU/SE0u))).

******Compute of Kappa Lineal.
      COMPUTE KappaL = (ObsAgrL - ExpectedL)/(1 - ExpectedL).
*     Kappa Lineal Confidence Interval.
      COMPUTE SEKappaL=SQR((SE1l - (ObsAgrL*ExpectedL-2*ExpectedL+ObsAgrL)**2)/(N*(1-ExpectedL)**4)).
      COMPUTE lbKappaL=KappaL-@Z*SEKappaL. 
      COMPUTE ubKappaL=KappaL+@Z*SEKappaL.
      COMPUTE SE0l = SQR((SE0l-ExpectedL**2)/(N*(1-ExpectedL)**2)).
      COMPUTE pKappaL =2*(1-CDFNORM(ABS(KappaL/SE0l))).

******Compute of Kappa Quadratic.
      COMPUTE KappaQ = (ObsAgrQ - ExpectedQ)/(1 - ExpectedQ).
*     Kappa Quadratic Confidence Interval.
      COMPUTE SEKappaQ=SQR((SE1q - (ObsAgrQ*ExpectedQ-2*ExpectedQ+ObsAgrQ)**2)/(N*(1-ExpectedQ)**4)).
      COMPUTE lbKappaQ=KappaQ-@Z*SEKappaQ. 
      COMPUTE ubKappaQ=KappaQ+@Z*SEKappaQ. 
      COMPUTE SE0q = SQR((SE0q-ExpectedQ**2)/(N*(1-ExpectedQ)**2)).
      COMPUTE pKappaQ =2*(1-CDFNORM(ABS(KappaQ/SE0q))).

      COMPUTE @NCases=@NCat**2.
      COMPUTE @WARNING=0.
*     Partial 2x2 tables.
      STRING @CatRest(A4) @cK(A1).
      NUMERIC #WA1 #WA0 #WB1 #WB0 #WM1 #WN1 #WM0 #WN0.
      DO IF (@NCases>4).
*        Build the @A1, @M1, @N1 variables.
         COMPUTE @M1=Total.
         COMPUTE @A1=$SYSMIS.
         COMPUTE @N1=$SYSMIS.
         !DO !I=1 !TO !NCat.
            IF (Cat=!I) @A1 = !CONCAT('@',!I).
            IF (Cat=!I) @N1 = !CONCAT('TotalC',!I).
         !DOEND.
         COMPUTE @M0=N-@M1.
         COMPUTE @N0=N-@N1.
         COMPUTE @A0=@N1-@A1.
         COMPUTE @B1=@M1-@A1.
         COMPUTE @B0=@N0-@B1.

*        Compute of Kappa's.
         COMPUTE @ObsAgr=100*(@A1+@B0)/N.
*        Weights.
         DO REPEAT Weight=#WA1 #WA0 #WB1 #WB0 #WM1 #WN1 #WM0 #WN0 /A=@A1 @A0 @B1 @B0 @M1 @N1 @M0 @N0.
            COMPUTE Weight= A/N.
         END REPEAT.
         COMPUTE #KPE=#WM1*#WN1+#WM0*#WN0.
         COMPUTE #KP0=#WA1+#WB0.
*        Kappa.
         COMPUTE @Kappa=(#KP0-#KPE)/(1-#KPE).
         COMPUTE @SE0Kappa = SQR(#KPE+#KPE**2-#WM1*#WN1*(#WM1+#WN1)-#WM0*#WN0*(#WM0+#WN0) )/((1-#KPE)*SQR(N)).
         COMPUTE @pKappa =2*(1-CDFNORM(ABS(@Kappa/@SE0Kappa))).
         COMPUTE #SEA=#WA1* (1-(#WM1+#WN1)*(1-@Kappa))**2 + #WB0* (1-(#WM0+#WN0)*(1-@Kappa))**2 .
         COMPUTE #SEB=(1-@Kappa)**2*(#WB1*(#WM0+#WN1)**2+#WA0*(#WM1+#WN0)**2).
         COMPUTE #SEC=(@Kappa-#KPE*(1-@Kappa))**2.
         COMPUTE @SEKappa=SQR(#SEA+#SEB-#SEC)/((1-#KPE)*SQR(N)).
         COMPUTE @lbKappa=@Kappa-@Z*@SEKappa. 
         COMPUTE @ubKappa=@Kappa+@Z*@SEKappa. 
         COMPUTE @cK=' '.
         IF (@lbKappa<0 OR @ubKappa>1) @cK='*'.
         IF (@lbKappa<0 OR @ubKappa>1) @WARNING=1.
      END IF.

*     Compute positive, negative and global agreement for 2x2 table (and bounds).
      NUMERIC POP PON POG lbPOP ubPOP lbPON ubPON lbPOG ubPOG.
      STRING cPOP cPON cPOG (A1).
      TEMPORARY.
      SELECT IF (NOT SYSMIS(Cat)).
      AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /BREAK=@U /N11=FIRST(@1) /N12=LAST(@1) /N21=FIRST(@2) /N22=LAST(@2).
      DO IF (@NCases=4).
         COMPUTE #POPn=2*N11.
         COMPUTE #POPd=2*N11+N21+N12.
         COMPUTE #PONn=2*N22.
         COMPUTE #PONd=2*N22+N21+N12.
         COMPUTE #POGn=N11+N22.
         COMPUTE #POGd=SUM(N11,N12,N21,N22).
         DO REPEAT P=  POP PON POG
                  /A=  #POPn  #PONn  #POGn /@N=  #POPd  #PONd  #POGd
                  /lbP=lbPOP lbPON lbPOG /ubP=ubPOP ubPON ubPOG
                  /cP =cPOP  cPON  cPOG.
            COMPUTE P = 100*(A/@N).
            COMPUTE cP=' '.
            DO IF (@PrCI=1).      /*Wilson bounds.
               COMPUTE #WA = 2*ABS(A) + @Z**2.
               COMPUTE #WB = @Z * SQRT(@Z**2 + 4*ABS(A)*(@N-ABS(A))/(@N)).
               COMPUTE #WC = 2*(@N + @Z**2).
               DO IF (A > 0).
                  COMPUTE lbP= 100*(#WA-#WB)/#WC.
                  COMPUTE ubP= 100*(#WA+#WB)/#WC.
               ELSE.
                  COMPUTE ubP= -100*(#WA-#WB)/#WC.
                  COMPUTE lbP= -100*(#WA+#WB)/#WC.
               END IF.
            ELSE IF (@PrCI=2).    /*Exact bounds.
               DO IF (A >= 0).
                  COMPUTE lbP= 0.
                  COMPUTE ubP= 100.
                  IF (A > 0) lbP= 100*(A/(A+(@N-A+1)*IDF.F(@P,2*(@N-A+1),2*A))).
                  IF (@N > A) ubP= 100*((A+1)/((A+1)+((@N-A)/IDF.F(@P,2*(A+1),2*(@N-A))))).
               ELSE.
                  COMPUTE lbP= -100.
                  COMPUTE ubP= -100*(ABS(A)/(ABS(A)+(@N-ABS(A)+1)*IDF.F(@P,2*(@N-ABS(A)+1),2*ABS(A)))).
                  IF (@N > ABS(A)) lbP= -100*((ABS(A)+1)/((ABS(A)+1)+((@N-ABS(A))/IDF.F(@P,2*(ABS(A)+1),2*(@N-ABS(A)))))).
               END IF.
            ELSE IF (@PrCI=3).    /*Asymptotic bounds.
               COMPUTE #SE= SQR(ABS(P)*(100-ABS(P))/@N).
               COMPUTE ubP = P + @Z*#SE.
               COMPUTE lbP = P - @Z*#SE.
               DO IF (ubP>100 OR lbP<0).
                  COMPUTE cP='*'.
                  COMPUTE @WARNING=1.
               END IF.
            END IF.
         END REPEAT .
         COMPUTE KAPPMin= (POG/100 - 1)/(POG/100 + 1).      /*Lantz & Nebenzahl (1996) for 2x2 table only.
         COMPUTE KAPPMax= (POG/100)**2/((1-POG/100)**2 + 1).
         COMPUTE KAPPSim= 2*POG/100 - 1.
      END IF.

******Disagreement.
*     Weights Lineal and Quadratic; number of disagreements.
      !DO !I=1 !TO !NCat.
         COMPUTE !CONCAT('WD',!I) = (Cat<>!I).
         COMPUTE !CONCAT('WDl',!I) = ABS(Cat-!I).
         COMPUTE !CONCAT('WDq',!I) = (Cat-!I)**2.
      !DOEND.
      !DO !I=1 !TO !NCat.
         COMPUTE !CONCAT('@ND',!I) = !CONCAT('@',!I)*!CONCAT('WD',!I).
      !DOEND.
      !DO !I=1 !TO !NCat.
         COMPUTE !CONCAT('@NDl',!I) = !CONCAT('@',!I)*!CONCAT('WDl',!I).
      !DOEND.
      !DO !I=1 !TO !NCat.
         COMPUTE !CONCAT('@NDq',!I) = !CONCAT('@',!I)*!CONCAT('WDq',!I).
      !DOEND.
*     Compute number of categories - 1.
      !LET !NCat_1=''.
      !DO !I=1 !TO !NCat.
         !IF (!I<>!NCat) !THEN.
            !LET !NCat_1 = !CONCAT(!NCat_1,' ').
         !IFEND.
      !DOEND.
      !LET !NCat_1=!LENGTH(!NCat_1).
*     Compute number of subjects with RATING2>RATING1.
      COMPUTE @ND21=$SYSMIS.
      !LET !temp='  '.
      !DO !I=1 !TO !NCat_1.
         !IF (!I<>!NCat_1) !THEN.
            IF (Cat=!I) @ND21 = SUM(!CONCAT('@ND',!LENGTH(!temp)) TO !CONCAT('@ND',!NCat)).
            IF (Cat=!I) @NDl21 = SUM(!CONCAT('@NDl',!LENGTH(!temp)) TO !CONCAT('@NDl',!NCat)).
            IF (Cat=!I) @NDq21 = SUM(!CONCAT('@NDq',!LENGTH(!temp)) TO !CONCAT('@NDq',!NCat)).
         !ELSE.
            IF (Cat=!I) @ND21 = !CONCAT('@ND',!NCat).
            IF (Cat=!I) @NDl21 = !CONCAT('@NDl',!NCat).
            IF (Cat=!I) @NDq21 = !CONCAT('@NDq',!NCat).
         !IFEND.
         !LET !temp=!CONCAT(!temp,' ').
      !DOEND.
*     Compute number of subjects with RATING1>RATING2.
      COMPUTE @ND12=$SYSMIS.
      !LET !temp='  '.
      !DO !I=2 !TO !NCat.
         !IF (!I<>2) !THEN.
            IF (Cat=!I) @ND12 = SUM(@ND1 TO !CONCAT('@ND',!LENGTH(!temp))).
            IF (Cat=!I) @NDl12 = SUM(@NDl1 TO !CONCAT('@NDl',!LENGTH(!temp))).
            IF (Cat=!I) @NDq12 = SUM(@NDq1 TO !CONCAT('@NDq',!LENGTH(!temp))).
         !ELSE.
            IF (Cat=!I) @ND12 = @ND1.
            IF (Cat=!I) @NDl12 = @NDl1.
            IF (Cat=!I) @NDq12 = @NDq1.
         !IFEND.
         !LET !temp=!CONCAT(!temp,' ').
      !DOEND.
      AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /BREAK=@U /ND12=SUM(@ND12) /NDl12=SUM(@NDl12) /NDq12=SUM(@NDq12) /ND21=SUM(@ND21) /NDl21=SUM(@NDl21) /NDq21=SUM(@NDq21).

*     Disagreement.
      COMPUTE ND = ND21+ND12.                    /*Total number of disagreement cases.
      COMPUTE N21l = (NDl21/(NDl21+NDl12))*ND.   /*Weighted number of subjects with RATING2>RATING1 (Lineal).
      COMPUTE N12l = (NDl12/(NDl21+NDl12))*ND.   /*Weighted number of subjects with RATING1>RATING2 (Lineal).
      COMPUTE N21q = (NDq21/(NDq21+NDq12))*ND.   /*Weighted number of subjects with RATING2>RATING1 (Quadratic).
      COMPUTE N12q = (NDq12/(NDq21+NDq12))*ND.   /*Weighted number of subjects with RATING1>RATING2 (Quadratic).

*     Compute of Observed Disagreements and Bias.
      NUMERIC UD12 UD21 uBIAS LD12 LD21 lBIAS QD12 QD21 qBIAS lbUB ubUB lbLB ubLB lbQB ubQB.
      DO REPEAT N21=ND21 N21l N21q /N12=ND12 N12l N12q
               /D21=UD21 LD21 QD21 /D12=UD12 LD12 QD12
              /BIAS=uBIAS lBIAS qBIAS /lbB=lbUB lbLB lbQB /ubB=ubUB ubLB ubQB.
         COMPUTE D21=(N21/N).         /*Observed Disagreements.
         COMPUTE D12=(N12/N).
         COMPUTE BIAS=D12-D21.         /*Bias.
         COMPUTE #lPI=(N21)/(N21+(N12+1)*IDF.F(@P,2*(N12+1),2*N21)).  /*Exact bounds (Bias).
         COMPUTE #uPI=(N21+1)/((N21+1)+N12/IDF.F(@P,2*(N21+1),2*N12)).
         COMPUTE lbB=((2*#lPI-1)*ND/N)*100.
         COMPUTE ubB=((2*#uPI-1)*ND/N)*100.
         
         COMPUTE D21=D21*100.
         COMPUTE D12=D12*100.
         COMPUTE BIAS=BIAS*100.
      END REPEAT.
      COMPUTE UD=UD12+UD21.

*     McNemar Bias and exact Test.
      COMPUTE MCND=(ND21-ND12)/(ND21+ND12).
      IF(ND12 LT ND21) pMCND=2*CDF.BINOM(ND12,ND12+ND21,0.5).
      IF(ND12 GE ND21) pMCND=2*CDF.BINOM(ND21,ND12+ND21,0.5).
      IF(ND12 EQ ND21) pMCND=1.

******Print results: CROSSTABS.
      STRING @Title (A9).
      COMPUTE @Title = '          '.
      IF ($CASENUM=1) @Title = 'RATING 1 '.
*     Create the @Descrip1 - @DescripN variables from the @Descrip variable.
      !LET !Aggr=''.
      !DO !I=1 !TO !NCat.
         STRING !CONCAT('@Descrip',!I) (A5).
         IF (Cat=!I) !CONCAT('@Descrip',!I) = @Descrip.
         !LET !Aggr= !CONCAT(!Aggr,' /Descrip',!I,' = MAX(',!CONCAT('@Descrip',!I),')').
      !DOEND.
      AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /BREAK=@U !Aggr.
*     Build the !Title variable with the names of the Descrip variables for print.
      !LET !Title = ''.
      !LET !PCT = ''.
      !DO !I=1 !TO !NCat.
         COMPUTE !CONCAT('Descrip',!I) = LPAD(RTRIM(!CONCAT('Descrip',!I)),5).
         !LET !Title= !CONCAT(!Title,'Descrip',!I,'(A6)').
         !LET !PCT= !CONCAT(!PCT,' @',!I,'(PCT6.1)').
      !DOEND.
*     Print CROSSTABS table.
      COMPUTE @Descrip = LPAD(RTRIM(@Descrip),5).
      !LET !TABLE =''.
      !DO !I=1 !TO !NCat.
         !LET !TABLE =!CONCAT(!TABLE,'------').
      !DOEND.
      DO IF (ERROR=0).
         DO IF ($CASENUM=1).
            PRINT //'                RATING 2'.
            PRINT  /'               | ' !Title  ' | TOTAL |'.
            PRINT  /'---------------+'!QUOTE(!TABLE)'--+-------+'.
         END IF.
         DO IF (NOT SYSMIS(Cat)).
            PRINT /@Title(A9) @Descrip(A5) ' | ' !Vars (!NCat(F5,1X))   ' |' Total (F6) ' |'.
         END IF.
         DO IF (@Descrip='TOTAL').
            DO IF (ERROR=0).
               PRINT  /'---------------+'!QUOTE(!TABLE)'--+-------+'.
               PRINT /@Title(A9) @Descrip(A5) ' | ' !Vars (!NCat(F5,1X))   ' |' Total (F6) ' |'.
            END IF.
         END IF.
      END IF.
      EXECUTE.
*     WARNING for null categories.
      !IF (!Label=!NULL) !THEN.
         DO IF (ERROR=0).
            DO IF (VoidCat=1).
               DO IF ($casenum=1).
                  PRINT  /'WARNING: There are categories with no data in the table.'.
                  PRINT  /'         The variables have been autorecoded.'.
               END IF.
            END IF.
         END IF.
      !IFEND.
      EXECUTE.

*     Print results: KAPPA for nxn tables.
      STRING cU cL cQ (A1).
      DO IF (Const=0).
         DO REPEAT l=lbKappaU lbKappaL lbKappaQ /u=ubKappaU ubKappaL ubKappaQ /c=cU cL cQ.
            COMPUTE c=' '.
            IF (l<-1 OR u>1) c='*'.
            IF (l<-1 OR u>1) @WARNING=1.
         END REPEAT.
         DO IF (@NCases>4).
            COMPUTE ObsAgrU = ObsAgrU*100.
            COMPUTE ObsAgrL = ObsAgrL*100.
            COMPUTE ObsAgrQ = ObsAgrQ*100.
            DO IF ($casenum=1).
               DO IF (ERROR=0).
                  PRINT //'------------+---------+-------+---------------+-------+----------------'.
                  PRINT  /'            | Observed|       | Standard Error|   p   | '!QUOTE(!CL)'% Asymptotic'.
                  PRINT  /'     Weight |Agreement| Kappa |   SE0 |   SE1 | value | Conf. Interval '.
                  PRINT  /'------------+---------+-------+-------+-------+-------+----------------'.
                  PRINT  /' UnWeighted |  ' ObsAgrU (F5.2)'% |' KappaU (F6.4) ' |' SE0u(F6.4) ' |' SEKappaU(F6.4) ' |' pKappaU (F6.4) ' |' lbKappaU (F6.4)' to ' ubKappaU(F6.4)  cU.
                  !IF (!OrderU='Y') !THEN.
                     PRINT  /'     Lineal |  ' ObsAgrL (F5.2)'% |' KappaL (F6.4) ' |' SE0l(F6.4) ' |' SEKappaL(F6.4) ' |' pKappaL (F6.4) ' |' lbKappaL (F6.4)' to ' ubKappaL(F6.4)  cL.
                     PRINT  /'  Quadratic |  ' ObsAgrQ (F5.2)'% |' KappaQ (F6.4) ' |' SE0q(F6.4) ' |' SEKappaQ(F6.4) ' |' pKappaQ (F6.4) ' |' lbKappaQ (F6.4)' to ' ubKappaQ(F6.4)  cQ.
                  !IFEND.
                  PRINT  /'------------+---------+-------+-------+-------+-------+----------------'.
               END IF.
            END IF.
*           Print results: Partial 2x2 tables.
            !IF (!OrderU='N') !THEN.
               COMPUTE @CatRest=SUBSTR(@Descrip,2).
               DO IF (ERROR=0).
                  DO IF ($casenum=1).
                     PRINT /' Categories:|         |       |       |       |       |'.
                  END IF.
                  DO IF (NOT SYSMIS(Cat)).
                     PRINT /@CatRest(A5) '- Rest |  '  @ObsAgr (F5.2)'% |' @Kappa (F6.4) ' |' @SE0Kappa(F6.4) ' |' @SEKappa (F6.4) ' |' @pKappa (F6.4) ' |' @lbKappa (F6.4) ' to ' @ubKappa (F6.4) @cK.
                  END IF.
                  DO IF (@Descrip='  PCT').
                     DO IF (ERROR=0).
                        PRINT /'------------+---------+-------+-------+-------+-------+----------------'.
                     END IF.
                  END IF.
               END IF.
            !IFEND.
         ELSE.
*           Print results: Kappa for 2x2 table.
            DO IF ($casenum=1).
               DO IF (ERROR=0).
                  PRINT //'-------+---------------+-------+----------------'.
                  PRINT  /'       | Standard Error|   p   | '!QUOTE(!CL)'% Asymptotic'.
                  PRINT  /' Kappa |   SE0 |   SE1 | value | Conf. Interval '.
                  PRINT  /'-------+-------+-------+-------+----------------'.
                  PRINT  / KappaU (F6.4) ' |' SE0u(F6.4) ' |' SEKappaU(F6.4) ' |' pKappaU (F6.4) ' |' lbKappaU (F6.4)' to ' ubKappaU(F6.4)  cU.
                  PRINT  /'-------+-------+-------+-------+----------------'.

                  PRINT //'----------------------+----------+-----------------------------'.
                  PRINT  /'                      | Estimate |   '!QUOTE(!CL)'% Confidence Interval'.
                  PRINT  /'----------------------+----------+-----------------------------'.
                  PRINT  /'Specific Agreement (+)|' PON(F8.2)'% |' lbPON(F7.2)'%  to' ubPON(F7.2) '% ' @CItype(A8) cPON(A1).
                  PRINT  /'Specific Agreement (-)|' POP(F8.2)'% |' lbPOP(F7.2)'%  to' ubPOP(F7.2) '% ' @CItype(A8) cPOP(A1).
                  PRINT  /'----------------------+----------+-----------------------------'. 
                  PRINT  /'     Global Agreement |'  POG(F8.2)'% |' lbPOG(F7.2)'%  to' ubPOG(F7.2) '% ' @CItype(A8) cPOG(A1).
                  PRINT  /'        kappa minimum |   ' KAPPMin(F6.4) ' |' . 
                  PRINT  /'        kappa minimum |   ' KAPPMax(F6.4) ' |' . 
                  PRINT  /'----------------------+----------+-----------------------------'. 

*                 Bias.
                  COMPUTE #M = (N12+N21)/2.
                  COMPUTE #M1 = N11+#M.
                  COMPUTE #N1 = N11+#M.
                  COMPUTE #M2 = N22+#M.
                  COMPUTE #N2 = N22+#M.
                  COMPUTE #PO = (N11+N22)/N.
                  COMPUTE #PE = ((#M1*#M1)/N + (#M2*#N2)/N)/N.
                  COMPUTE BAK = (#PO-#PE)/(1-#PE).
                  COMPUTE OAp = 100*(2*N22 + N21 + N12)/(2*N).
                  COMPUTE OAn = 100*(2*N11 + N21 + N12)/(2*N).
                  COMPUTE PI = OAp - OAn.
                  COMPUTE PABAK = 2*#PO - 1.
                  
                  PRINT//'Observed Disagreement |    Bias  | Bias adjusted kappa'.
                  PRINT /'        X-Y+     X+Y- |   Index  |   BAK'.
                  PRINT /'----------------------+----------+----------------------------'.  
                  PRINT /'     ' UD12(F6.2) '%  ' UD21(F6.2) '% |' uBIAS(F8.2) '% | ' BAK(F5.4).
                  PRINT /'----------------------+----------+----------------------------'. 
                  PRINT /'   Observed Agreement |Prevalence| Prev. & Bias adjusted kappa'.
                  PRINT /'         (+)      (-) |   Index  | PABAK'.
                  PRINT /'----------------------+----------+----------------------------'. 
                  PRINT /'     ' OAp(F6.2) '%  ' OAn(F6.2) '% |' PI(F8.2) '% | ' PABAK(F5.4).
                  PRINT /'----------------------+----------+----------------------------'. 
               END IF.
            END IF.
         END IF.
      END IF.
      EXECUTE.

******DISABLED.
*     Print results: Bias.   
*      DO IF (Const=0).
*         !IF (!PRINTU='ALL') !THEN.
*            DO IF (ERROR=0).
*               DO IF (@NCases>4).
*                  DO IF ($casenum=1).
*                     PRINT//'           Observed Disagreement |        |'.
*                     PRINT /'           Total Ra2<Ra1 Ra2>Ra1 |  Bias  | ' !QUOTE(!CL) '% Confidence Interval'.
*                     PRINT /'---------------------------------+--------+-------------------------'.
*                     PRINT /'UnWeighted' UD(F5.1)'%  ' UD12(F5.1)'%  ' UD21(F5.1)'% |' uBIAS(F6.1) '% | ' lbUB(F5.1) '% to ' ubUB(F5.1) '% (Exact)'.
*                     PRINT /'    Lineal' UD(F5.1)'%  ' LD12(F5.1)'%  ' LD21(F5.1)'% |' lBIAS(F6.1) '% | ' lbLB(F5.1) '% to ' ubLB(F5.1) '% (Exact)'.
*                     PRINT /' Quadratic' UD(F5.1)'%  ' QD12(F5.1)'%  ' QD21(F5.1)'% |' qBIAS(F6.1) '% | ' lbQB(F5.1) '% to ' ubQB(F5.1) '% (Exact)'.
*                     PRINT /'                         McNemar | ' MCND(F6.2) ' | P Value: ' pMCND(F7.5) ' (Exact)'.
*                     PRINT /'---------------------------------+--------+-------------------------'.
*                  END IF.
*            END IF.
*         !IFEND.
*      END IF.
*      EXECUTE.

*     Print WARNINGS.
      AGGREGATE OUTFILE=* MODE=ADDVARIABLES /BREAK=@U /WARNING=MAX(@WARNING).
      TEMPORARY.
      N 1.
      DO IF (Const=1).
         DO IF (ERROR=0).
            !IF (!VarR1<>!NULL !AND !VarR2<>!NULL) !THEN.
               PRINT //'WARNING: No statistics are computed because ' !QUOTE(!VarR1) ' and ' !QUOTE(!VarR2) ' are constants.'.
            !ELSE.
               PRINT //'WARNING: No statistics are computed because the ratings are constants.'.
            !IFEND.
         END IF.
      ELSE.
         DO IF (ERROR=0).
            DO IF (WARNING=1).
               PRINT /'(*)Out of range.'.
            END IF.
         END IF.
      END IF.
      EXECUTE.
      
*     Restore original dataset and close temporary dataset @DATA.
      DATASET ACTIVATE @original.
      DATASET CLOSE @DATA.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
