PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
  PRINT /'Macro !STCOR V2012.02.13 loaded.'
        /'Execute !STCOR HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !STCOR ( LEXPO =!CHAREND('/') 
              /VarExp =!CHAREND('/') /VarRes =!CHAREND('/') /VarStr =!CHAREND('/') 
             /STRATUM =!CHAREND('/') /A =!CHAREND('/') /B =!CHAREND('/') /N =!CHAREND('/') 
                  /ST=!CHAREND('/')!DEFAULT('CO') 
                  /CL=!CHAREND('/')!DEFAULT(95) 
                  /RC=!CHAREND('/')!DEFAULT('F')
                /Zero=!CHAREND('/')!DEFAULT('N')
                 /NST=!CHAREND('/')
                /HELP=!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2012.02.13').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
!LET !WINDOW='HIDDEN'.
!LET !LEXPOMAX=11.
DO IF ($casenum=1).
   PRINT //'Macro !STCOR V' !VERSION ' (c)JM.Domenech'.
END IF.
!IF (!HELP<>1) !THEN.
*  Print HELP.
   DO IF ($casenum=1).
      PRINT /'*********************************************************************************'
            /'* STRATIFIED TREND TEST (Cumulative data)                                       *'
            /'* Created 2005.03.09 Last revised ' !VERSION                                   '*'81
            /'* (c) JM.Domenech                                                               *'
            /'* Programmers: A.Bonillo & R.Sesma                                              *'
            /'*                                                                               *'
            /'* Vancouver reference:                                                          *'
            /'* Domenech JM. Macro !STCOR for SPSS Statistics.                                *'
            /'*    Stratified Trend Test (Cumulative data) [computer program].                *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'81
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                      *'
            /'*                                                                               *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                                 *'
            /'* Parameter for PRINTING MACRO DOCUMENTATION -----------------------------------*'
            /'*  !STCOR HELP.                                                                 *'
            /'*                                                                               *'
            /'* Parameters for INDIVIDUAL DATA -----------------------------------------------*'
            /'*  !STCOR VarExp(LEXPO)= Exposure variable and Levels of exposure (LEXPO >= 0)  *'
            /'*                        The maximum number of levels is ' !QUOTE(!LEXPOMAX)   '*'81
            /'*       /VarRes[(ValNonCase ValCase)]= Response variable and values for         *'
            /'*                                   NonCase, Case. By default: ValNonCase= 0    *'
            /'*                                                                 ValCase= 1    *'
            /'*        /VarStr= Stratum variable                                              *'
            /'*                                                                               *'
            /'* Parameters for AGGREGATED DATA -----------------------------------------------*'
            /'* !STCOR STRATUM= List of Stratum labels(up to 8 characters) (in SPSS format)   *'
            /'*         /LEXPO= Levels of exposure (LEXPO >= 0 )                              *'
            /'*                 The maximum number of levels is ' !QUOTE(!LEXPOMAX)          '*'81
            /'*             /A= List of Exposed Cases Stratum 1    (A >= 0)                   *' 
            /'*                 List of Exposed Cases Stratum 2                               *' 
            /'*                 ...............................                               *' 
            /'*          { /B = List of Exposed NonCases Stratum 1 (B >= 0)                   *' 
            /'*                 List of Exposed NonCases Stratum 2                            *' 
            /'*                 ..................................                            *' 
            /'*         or /N}= List of Exposed TOTAL Stratum 1    (N >= A and > 0)           *' 
            /'*                 List of Exposed TOTAL Stratum 2                               *' 
            /'*                 ................................                              *' 
            /'*                                                                               *'
            /'* Parameters for BOTH TYPES OF DATA --------------------------------------------*'
            /'*          [/ST]= Study type: CO or CO(RR) or CO(OR) (Cohort)   by default: CO  *'
            /'*                             CS or CS(PR) or CS(OR) (Cross-Sectional)          *'
            /'*                             CC (Case-Control)                                 *'
            /'*                 Note: (RR) (PR) (OR) specify the required statistic           *'
            /'*                 by default: RR for CO study, PR for CS study, OR for CC study *'
            /'*         [ /RC]= Reference category: F(First)     by default: F                *'
            /'*                                     L(Last)                                   *'
            /'*                                     P(Previous)                               *'
            /'*                                     S(Subsequent)                             *' 
            /'*         [ /CL]= Confidence level(%)  by default: 95  (CL >=50 and < 100)      *'
            /'*               = SE for printing Standard Error instead of Confidence Interval *'
            /'*        [/Zero]= Continuity correction for cells with zero events:             *'
            /'*                 N (None)                            by default: N             *'
            /'*                 C (Constant, add k=0.5 to each cell)                          *'
            /'*                 P (Proportional: add k1=N1/N and k0=N0/N) for CO & CS studies *'
            /'*                                  add k1=M1/N and k0=M0/N) for CC studies      *'
            /'*                 R (Reciprocal: add k1=1/N0 and k0=1/N1) for CO & CS studies   *'
            /'*                                add k1=1/M0 and k0=1/M1) for CC studies        *'
            /'*         [/NST]= Name of the study (Label)                                     *'
            /'*         [/HELP] Print Macro call arguments and Samples of calls               *' 
            /'*                                                                               *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                 *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements    *'
            /'*                                                                               *'
            /'* Samples of calls:                    +---+--------+--------------------+-----+*' 
            /'* !STCOR HELP.                         |   |        |  Level of Exposure |TOTAL|*' 
            /'* !STCOR VarExp=Tabaco(1 2 3 4)        |STR|        |  0 |  1 | ... |  J |     |*' 
            /'* /VarRes=Apgar(0 1) /VarStr=Edad.     +---+--------+----+----+-----+----+-----+*' 
            /'* !STCOR STRATUM= "Males" "Females"    | 1 |Cases   | A01| A11| ... | AJ1|  M11|*' 
            /'*       /LEXPO=   0   1   2  3.5   4   |   |NonCases| B01| B11| ... | BJ1|  M01|*' 
            /'*           /A=  86  23  24   56  11   |   |   TOTAL| N01| N11| ... | NJ1|  N+1|*' 
            /'*                95  31  32   60  15   +---+--------+----+----+-----+----+-----+*' 
            /'*           /N= 219  71  40   67  16   | 2 |Cases   | A02| A12| ... | AJ2|  M12|*' 
            /'*               201  66  51   90  15   |   |NonCases| B02| B12| ... | BJ2|  M02|*' 
            /'*           /ST=CS(OR) /RC=F /CL=95    |   |   TOTAL| N02| N12| ... | NJ2|  N+2|*' 
            /'*         /Zero=P /NST="Study name".   +---+--------+----+----+-----+----+-----+*' 
            /'*********************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Test coherent parameters.
   !LET !ERROR=0.
   !IF (!VarExp=!NULL !AND !VarRes=!NULL !AND !VarStr=!NULL !AND !A=!NULL !AND !STRATUM=!NULL !AND !LEXPO=!NULL) !THEN.
*     VarExp,VarRes,VarStr,A,STRATUM,LEXPO missing.
      !LET !ERROR=1.
      !LET !ErrorText='VarExp,VarRes,VarStr or A,STRATUM,LEXPO'.
   !IFEND.
   !IF (!ERROR=0 !AND ((!VarExp<>!NULL !OR !VarRes<>!NULL !OR !VarStr<>!NULL) !AND 
       (!STRATUM<>!NULL !OR !A<>!NULL !OR !B<>!NULL !OR !N<>!NULL !OR !STRATUM<>!NULL !OR !LEXPO<>!NULL))) !THEN.
*     Error: too much parameters.
      !LET !ERROR=2.
   !IFEND.
   !IF (!VarExp<>!NULL !OR !VarRes<>!NULL !OR !VarStr<>!NULL) !THEN.
      !IF (!ERROR=0 !AND (!VarExp=!NULL !OR !VarRes=!NULL !OR !VarStr=!NULL)) !THEN.
*        VarExp, VarResp or VarStrat missing.
         !LET !ERROR=1.
         !LET !ErrorText='VarExp, VarRes or VarStr'.
      !IFEND.
      !IF (!ERROR=0 !AND !Index(!VarExp,'(')=0) !THEN.
*        LEXPO missing.
         !LET !ERROR=1.
         !LET !ErrorText='LEXPO'.
      !IFEND.
   !ELSE.
      !IF (!ERROR=0 !AND !STRATUM=!NULL) !THEN.
*        STRATUM missing.
         !LET !ERROR=1.
         !LET !ErrorText='STRATUM'.
      !IFEND.  
      !IF (!ERROR=0 !AND !LEXPO=!NULL) !THEN.
*        LEXPO missing.
         !LET !ERROR=1.
         !LET !ErrorText='LEXPO'.
      !IFEND.
      !IF (!ERROR=0 !AND !A=!NULL) !THEN.
*        A missing.
         !LET !ERROR=1.
         !LET !ErrorText='A'.
      !IFEND.
      !IF (!ERROR=0 !AND !N=!NULL !AND !B=!NULL) !THEN.
*        N,B mising.
         !LET !ERROR=1.
         !LET !ErrorText='B or N'.
      !IFEND.
      !IF (!ERROR=0 !AND !B<>!NULL !AND !N<>!NULL) !THEN.
*        Error: too much parameters.
         !LET !ERROR=4.
      !IFEND.
   !IFEND.
*  Test parameter ST.
   !LET !STU=!UPCASE(!ST).
   !IF (!ERROR=0 !AND !STU<>'CO' !AND !STU<>'CC' !AND !STU<>'CS' !AND !STU<>'CO(OR)' !AND 
                      !STU<>'CO(RR)' !AND !STU<>'CS(OR)' !AND !STU<>'CS(PR)') !THEN.
      !LET !ERROR=3.
      !LET !ErrorText='ST'.
   !IFEND.
*  Test parameter RC.
   !LET !RCU=!UPCASE(!RC).
   !IF (!ERROR=0 !AND !RCU<>'F' !AND !RCU<>'L' !AND !RCU<>'P' !AND !RCU<>'S') !THEN.
      !LET !ERROR=3.
      !LET !ErrorText='RC'.
   !IFEND.
*  Test parameter Zero.
   !LET !ZeroU=!UPCASE(!Zero).
   !IF (!ERROR=0 !AND !ZeroU<>'N' !AND !ZeroU<>'C' !AND !ZeroU<>'P' !AND !ZeroU<>'R') !THEN.
      !LET !ERROR=3.
      !LET !ErrorText='Zero'.
   !IFEND.
*  If necessary, print error messages.
   TEMPORARY.
   N 1.
   !IF (!ERROR=1) !THEN.
      PRINT /'ERROR: Parameter(s) ' !QUOTE(!ErrorText) ' missing. See the HELP.'.
   !IFEND.
   !IF (!ERROR=2) !THEN.
      PRINT /'ERROR: Too much parameters. Individual Data parameters are incompatible with'.
      PRINT /'       Aggregated Data parameters. See the HELP.'.
   !IFEND.
   !IF (!ERROR=3) !THEN.
      PRINT /'ERROR: Parameter ' !QUOTE(!ErrorText) ' with wrong values. See the HELP.'.
   !IFEND.
   !IF (!ERROR=4) !THEN.
      PRINT /'ERROR: Too much parameters. Parameter B is incompatible with parameter N. See the HELP.'.
   !IFEND.
   EXECUTE.

   !IF (!ERROR=0) !THEN.
******CREATE @DATA DATASET.
*     Name the original dataset to restore and copy to the @work dataset.
*     WARNING: that overrides any existent dataset named @original.
      OMS /SELECT ALL /IF COMMANDS = ["Dataset Copy" "Dataset Name"] /DESTINATION   VIEWER = NO.
      DATASET NAME @original.
      OMSEND.

      !IF (!VarRes<>!NULL !AND !VarExp<>!NULL !AND !VarStr<>!NULL) !THEN.
*********INDIVIDUAL DATA: Create the @DATA dataset from the CROSSTABS.
*        VarExp contains the name and the Levels of the Exposure variable: VExp(LEXPO).
         !LET !Pos=!Index(!VarExp,'(').
*        Get the name of the variable.
         !LET !VExp=!SubStr(!VarExp,1,!Length(!SubStr(!Blanks(!Pos),2))).
*        Get LEXPO list.
         !LET !Values=!SubStr(!VarExp,!Length(!Concat(!Blanks(!Pos),' '))).
         !LET !Levels=!SubStr(!Values,1,!Length(!SubStr(!Blanks(!Length(!Values)),2))).
         
*        VarRes contains the name and the values of the Response variable: VResp(ValNonCase ValCase).
         !LET !Pos=!Index(!VarRes,'(').
         !IF (!Pos<>0) !THEN.
*           Get the name of the variable.
            !LET !VResp=!SubStr(!VarRes,1,!Length(!SubStr(!Blanks(!Pos),2))).
*           Read the values.
            !LET !Values=!SubStr(!VarRes,!Length(!Concat(!Blanks(!Pos),' '))).
            !LET !Values=!SubStr(!Values,1,!Length(!SubStr(!Blanks(!Length(!Values)),2))).
            !LET !COUNT=1.
            !DO !Val !IN (!Values).
               !IF (!COUNT=1) !THEN !LET !ValNonCase=!Val !IFEND.
               !IF (!COUNT=2) !THEN !LET !ValCase=!Val !IFEND.
               !LET !COUNT = !Length(!Concat(!Blanks(!COUNT),' ')).
            !DOEND.
         !ELSE.
*           VarRes contains only the name of the Response variable; ValNonCase and ValCase by default (0 1).
            !LET !VResp=!VarRes.
            !LET !ValCase=1.
            !LET !ValNonCase=0.
         !IFEND.

         DATASET COPY @9675work WINDOW=!WINDOW.
         DATASET ACTIVATE @9675work.

*        AUTORECODE, RECODE of the Exposure, Response variables to @Exp, @Resp variables.
         PRESERVE.
         SET ERRORS = NONE RESULTS = NONE MESSAGES = NONE PRINTBACK = NONE.
         AUTORECODE VARIABLES=!VExp /INTO @9675Exp.
         RESTORE.
         RECODE !VResp (MISSING=SYSMIS) (!ValCase=1) (!ValNonCase=0) (ELSE=SYSMIS) INTO @9675Resp.
         FORMATS @9675Exp @9675Resp (F1).
         EXECUTE.

*        Compute the CROSSTABS - Use OMS to redirect output tables to the @DATA, @CASE datasets.
         PRESERVE.
         SET OLANG=ENGLISH TNUMBERS=VALUES.
         DATASET DECLARE @9675DATA WINDOW=!WINDOW.
         OMS /SELECT ALL /IF COMMANDS = ["Crosstabs"] /DESTINATION VIEWER = NO.
         OMS /SELECT TABLES /IF COMMANDS = ["Crosstabs"] SUBTYPES = ["Crosstabulation"]
             /DESTINATION FORMAT = SAV NUMBERED = Num OUTFILE = @9675DATA .
         DATASET DECLARE @9675CASES WINDOW=!WINDOW.
         OMS /SELECT TABLES /IF COMMANDS = ["Crosstabs"]  SUBTYPES = ["Case Processing Summary"]
             /DESTINATION FORMAT = SAV NUMBERED = Num OUTFILE = @9675CASES.
         OMS /SELECT ALL /IF COMMANDS = ["Crosstabs"] /DESTINATION VIEWER = NO.
         CROSSTABS @9675Resp BY @9675Exp BY !VarStr /FORMAT DVALUE /COUNT=ASIS.
         OMSEND.
         RESTORE.

*********FREQUENCIES - Get the Number of Stratum.
         PRESERVE.
         SET TNUMBERS=VALUES OLANG=ENGLISH.
         DATASET DECLARE @9675NumStr WINDOW=!WINDOW.
         OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION   VIEWER = NO.
         OMS /SELECT TABLES /IF COMMANDS = ["Frequencies"]  SUBTYPES = ["Frequencies"]
             /DESTINATION FORMAT = SAV NUMBERED = Num  OUTFILE = @9675NumStr.
         OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION   VIEWER = NO.
         FREQUENCIES  VARIABLES=!VarStr /ORDER=ANALYSIS /FORMAT=DVALUE.
         OMSEND.
         RESTORE.
*        The @NumStr dataset has one row and one variable NStr with the number of stratum.
         DATASET ACTIVATE @9675NumStr WINDOW=ASIS.
         SELECT IF (NOT SYSMIS(CumulativePercent)).
         AGGREGATE  /OUTFILE=* MODE=ADDVARIABLES  /BREAK=Num  /NStr=N.
         MATCH FILES FILE=* /KEEP=Num NStr.
         N 1.
         EXECUTE.

*        DATA: data to compute results.
         DATASET ACTIVATE @9675DATA WINDOW=ASIS.
         COMPUTE @NumStr = 1.
         DO IF ($CASENUM>1).
            IF (Var1 = LAG(Var1)) @NumStr = LAG(@NumStr).
            IF (Var1 <> LAG(Var1)) @NumStr = LAG(@NumStr) + 1.
         END IF.
         EXECUTE.
         MATCH FILES FILE=* /TABLE='@9675NumStr' /BY=Num.
         SELECT IF (@NumStr <= NStr).
         MATCH FILES FILE=* /DROP=@NumStr NStr.
         EXECUTE.
         
*        Activate the @work dataset and close the @NumStr temporary dataset.
         DATASET ACTIVATE @9675work WINDOW=ASIS.
         DATASET CLOSE @9675NumStr.

*        Get the VarRes variable labels using FREQUENCIES + OMS.
         PRESERVE.
         SET OLANG=ENGLISH TNUMBERS=BOTH.
         OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION VIEWER = NO.
         DATASET DECLARE @9675DESCRIP WINDOW=!WINDOW.
         OMS /SELECT TABLES /IF COMMANDS = ["Frequencies"]  SUBTYPES = ["Frequencies"]
             /DESTINATION FORMAT = SAV NUMBERED = Num OUTFILE = @9675DESCRIP.
         OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION VIEWER = NO.
         FREQUENCIES !VResp.
         OMSEND.
         RESTORE.
*        Get the VarStr variable labels using FREQUENCIES + OMS.
         PRESERVE.
         SET OLANG=ENGLISH TNUMBERS=LABELS.
         OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION VIEWER = NO.
         DATASET DECLARE @9675StrNames WINDOW=!WINDOW.
         OMS /SELECT TABLES /IF COMMANDS = ["Frequencies"]  SUBTYPES = ["Frequencies"]
             /DESTINATION FORMAT = SAV NUMBERED = Num OUTFILE = @9675StrNames.
         OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION VIEWER = NO.
         FREQUENCIES !VarStr /FORMAT=DVALUE.
         OMSEND.
         RESTORE.
         
*        COUNT= Number of Levels of Exposure .
         !LET !COUNT=''.
         !LET !Rename_old=''.
         !DO !I !IN(!Levels).
            !LET !COUNT = !CONCAT(!COUNT,' ').
            !LET !Rename_old= !CONCAT(!Rename_old,' @',!LENGTH(!COUNT)).
         !DOEND.
         !LET !COUNT=!LENGTH(!COUNT).
*        Prepare variables to create data.         
         !LET !Anames=''.
         !LET !Bnames=''.
         !LET !Nnames=''.
         !LET !Bcreate=''.
         !LET !Ncreate=''.
         !DO !I=1 !TO !COUNT.
            !LET !Anames= !CONCAT(!Anames,' A',!I).
            !LET !Bnames= !CONCAT(!Bnames,' B',!I).
            !LET !Nnames= !CONCAT(!Nnames,' N',!I).
            !LET !Bcreate= !CONCAT(!Bcreate,' /B',!I,'=LEAD(A',!I,' 1)').
            !LET !Ncreate= !CONCAT(!Ncreate,' /N',!I,'=LEAD(A',!I,' 2)').
         !DOEND.
         !LET !Rename_old= !CONCAT('Var1 ',!Rename_old,' Total').
         !LET !Rename_new= !CONCAT('@Str',!Anames,' M1').

*        Close @work dataset.
         DATASET ACTIVATE @9675DATA.
         DATASET CLOSE @9675work.

*        Keep interesting variables and rename.
         MATCH FILES FILE=* /RENAME=(!Rename_old = !Rename_new) /KEEP= !Rename_new.
         EXECUTE.

*        Use CREATE to compute B, N from A.
         COMPUTE @U=1.
         SPLIT FILE BY @Str.
         OMS /SELECT ALL /IF COMMANDS = ["Create"] /DESTINATION VIEWER=NO.
         CREATE !Bcreate !Ncreate /M0=LEAD(M1,1) /N=LEAD(M1,2) /Sec=CSUM(@U).
         OMSEND.
         SPLIT FILE OFF.
         SELECT IF (Sec=1).
         EXECUTE.

*********GET VarResp VALUE LABELS.
*        Only the Var2=@Descrip is interesting.
*        Erase the Total row.
         DATASET ACTIVATE @9675Descrip.
         MATCH FILES FILE=* /RENAME=(Var2=@Descrip) /KEEP=Num @Descrip.
         SELECT IF (@Descrip<>'Total').
         EXECUTE.
*        Declare string variables.
*        Get the Val, Descrip info from @Descrip (by default, F8 and A50 formats are suposed).
         STRING Descrip(A50).
         DO IF (Num=1).
            COMPUTE @Pos = INDEX(@Descrip,' ').
            COMPUTE Val=NUMBER(SUBSTR(@Descrip,1,@Pos-1),F8).         
            COMPUTE Descrip=SUBSTR(@Descrip,@Pos+1).
*           If there are no value labels defined, the descrip is the value.
            DO IF (LENGTH(LTRIM(Descrip))=0).
               COMPUTE Descrip=@Descrip.
            END IF.
         ELSE.
            COMPUTE Descrip=@Descrip.
         END IF.
*        Add the ValCase, ValNonCase info.
         COMPUTE ValCase = !ValCase.
         COMPUTE ValNonCase = !ValNonCase.
         EXECUTE.

         DATASET ACTIVATE @9675DATA.
      !ELSE. 
*********AGGREGATED DATA: Create the @DATA dataset from the A1,A0,N1,N0,B1,B0 parameters.
*        Create @DATA: copy the active dataset, and keep only the first row.
         DATASET COPY @9675DATA WINDOW=!WINDOW.
         DATASET ACTIVATE @9675DATA.
         SPLIT FILE OFF.
         WEIGHT OFF.
         N 1.
         COMPUTE U=1.
         MATCH FILES FILE=* /KEEP=U.
*        Compute Number of Stratums.
         !LET !NStr=''.
         !DO !I !IN(!STRATUM).
            !LET !NStr=!CONCAT(!NStr,' ').
            !LET !VAR=!CONCAT('Study',!LENGTH(!NStr)).
            !LET !FORMAT=!CONCAT('A',!LENGTH(!I)).
            STRING !VAR (!FORMAT).
            COMPUTE !VAR=!I.
         !DOEND.
         !LET !NStr=!LENGTH(!NStr).
*        Compute Number of Levels and Number of Levels + 1.
         !LET !COUNT=''.
         !DO !I !IN(!LEXPO).
            !LET !COUNT=!CONCAT(!COUNT,' ').
         !DOEND.
         !LET !NLev1=!LENGTH(!CONCAT(!COUNT,' ')).
         !LET !COUNT=!LENGTH(!COUNT).
*        Create A11 TO A1NStr, A21 TO A2NStr,... vars with A data.
         !LET !T1=' '.
         !LET !T2=' '.
         !DO !I !IN (!A).
            COMPUTE !CONCAT('A',!LENGTH(!T1),!LENGTH(!T2)) = $SYSMIS.
            COMPUTE !CONCAT('A',!LENGTH(!T1),!LENGTH(!T2)) = !I.
            !LET !T1=!CONCAT(!T1,' ').
            !IF (!LENGTH(!T1)=!NLev1) !THEN.
               !LET !T1=' '.
               !LET !T2=!CONCAT(!T2,' ').
            !IFEND.
         !DOEND.
         !LET !T1=' '.
         !LET !T2=' '.
         !LET !BoN='B'.
         !LET !BoNp=!B.
         !IF (!N<>!NULL) !THEN.
            !LET !BoN='N'.
            !LET !BoNp=!N.
         !IFEND.
*        Create B or N vars with B or N data.
         !DO !I !IN (!BoNp).
            COMPUTE !CONCAT(!BoN,!LENGTH(!T1),!LENGTH(!T2)) = $SYSMIS.
            COMPUTE !CONCAT(!BoN,!LENGTH(!T1),!LENGTH(!T2)) = !I.
            !LET !T1=!CONCAT(!T1,' ').
            !IF (!LENGTH(!T1)=!NLev1) !THEN.
               !LET !T1=' '.
               !LET !T2=!CONCAT(!T2,' ').
            !IFEND.
         !DOEND.
         EXECUTE.
         
*        Create parameters for VARSTOCASES.
         !LET !MAKEA=''.
         !LET !MAKEBoN=''.
         !DO !I=1 !TO !COUNT.
            !LET !MAKEA=!CONCAT(!MAKEA,' /MAKE A',!I,' FROM').
            !LET !MAKEBoN=!CONCAT(!MAKEBoN,' /MAKE ',!BoN,!I,' FROM').
            !DO !J=1 !TO !NStr.
               !LET !MAKEA=!CONCAT(!MAKEA,' A',!I,!J).
               !LET !MAKEBoN=!CONCAT(!MAKEBoN,' ',!BoN,!I,!J).
            !DOEND.
         !DOEND.
         !LET !MAKEStudy =' /MAKE Study FROM'.
         !DO !J=1 !TO !NStr.
            !LET !MAKEStudy=!CONCAT(!MAKEStudy,' Study',!J).
          !DOEND.
         !LET !MAKE=!CONCAT(!MAKEStudy,!MAKEA,!MAKEBoN).
         
*        Use VARSTOCASES to create one row for each stratum on @DATA.
         OMS /SELECT ALL /IF COMMANDS = ["Variables to Cases"] /DESTINATION   VIEWER = NO.
         VARSTOCASES /ID = id !MAKE /KEEP = /NULL = KEEP.
         OMSEND.

*        Create B or N variable.
         !DO !I=1 !TO !COUNT.
            !IF (!N<>!NULL) !THEN.
               COMPUTE !CONCAT('B',!I)=!CONCAT('N',!I)-!CONCAT('A',!I).
            !ELSE.
               COMPUTE !CONCAT('N',!I)=!CONCAT('A',!I)+!CONCAT('B',!I).
            !IFEND.
         !DOEND.
         
*        Create M1, M0, N variables.
         COMPUTE M1 = SUM(A1 to !CONCAT('A',!COUNT)).
         COMPUTE M0 = SUM(B1 to !CONCAT('B',!COUNT)).
         COMPUTE N  = SUM(N1 to !CONCAT('N',!COUNT)).
         
         COMPUTE @U=1.
         !LET !Levels= !LEXPO.
         !LET !Anames=''.
         !LET !Bnames=''.
         !LET !Nnames=''.
         !DO !I=1 !TO !COUNT.
            !LET !Anames= !CONCAT(!Anames,' A',!I).
            !LET !Bnames= !CONCAT(!Bnames,' B',!I).
            !LET !Nnames= !CONCAT(!Nnames,' N',!I).
         !DOEND.
      !IFEND.

*     Compute Str variable with the Stratum's sequence.
      STRING Str(A8).
      COMPUTE Str = CONCAT('Str',STRING($casenum,F1)).
      EXECUTE.
      
*     Add OVERALL results: use AGGREGATE to compute the summatories on a temporary @OVERALL dataset and ADD FILES to add the data.
      !LET !Aggr=' /M1 = SUM(M1) /M0 = SUM(M0) /N = SUM(N) '.
      !DO !I=1 !TO !COUNT.
         !LET !Aggr= !CONCAT(!Aggr,' /A',!I,'=SUM(A',!I,')',' /B',!I,'=SUM(B',!I,')',' /N',!I,'=SUM(N',!I,')').
      !DOEND.
      DATASET DECLARE @9675OVERALL WINDOW=!WINDOW.
      AGGREGATE /OUTFILE='@9675OVERALL' /BREAK=@U !Aggr.
      ADD FILES /FILE=* /FILE='@9675OVERALL' /IN=@OVERALL.
      EXECUTE.
      DATASET CLOSE @9675OVERALL.
      IF (@OVERALL=1) Str='OVERALL'.

*     Compute LEXPO variables.
      !LET !COUNT=''.
      !LET !LEXPOnames = ''.
      !DO !I !IN(!Levels).
         !LET !COUNT = !CONCAT(!COUNT,' ').
         COMPUTE !CONCAT('LEXPO',!LENGTH(!COUNT)) = $SYSMIS.
         COMPUTE !CONCAT('LEXPO',!LENGTH(!COUNT)) = !I.
         !LET !LEXPOnames = !CONCAT(!LEXPOnames,' ',!CONCAT('LEXPO',!LENGTH(!COUNT))).
      !DOEND.
      !LET !COUNT=!LENGTH(!COUNT).
      !LET !LEXPOn=!CONCAT('LEXPO',!COUNT).
      COMPUTE NLevels=!COUNT.
      COMPUTE NLevelsMax=!LEXPOMAX.

*     Confidence level.
      COMPUTE @CL=$SYSMIS.
      !IF (!UPCASE(!CL)='SE') !THEN.
         COMPUTE @CL = 95.
      !ELSE.
         COMPUTE @CL = !CL.
      !IFEND.

******TEST NUMERIC PARAMETERS (and decimals): A B N @CL.
      COMPUTE @ERROR=0.
      COMPUTE @ERRtype=0.
      DO REPEAT A=!Anames /B=!Bnames /N=!Nnames /LEXPO=!LEXPOnames.
         DO IF (@ERROR=0).
            DO IF SYSMIS(A).
               COMPUTE @ERRtype=1.
            ELSE IF SYSMIS(B).
               COMPUTE @ERRtype=2.
            ELSE IF SYSMIS(N).
               COMPUTE @ERRtype=3.
            ELSE IF SYSMIS(LEXPO).
               COMPUTE @ERRtype=4.
            ELSE.
               DO IF (A<0).
                  COMPUTE @ERRtype=1.
               ELSE IF (B<0).
                  COMPUTE @ERRtype=2.
               ELSE IF (N<0 OR N<A).
                  COMPUTE @ERRtype=3.
               ELSE IF (LEXPO<0).
                  COMPUTE @ERRtype=4.
               END IF.
            END IF.
            IF (@ERRtype>0) @ERROR=1.
         END IF.
      END REPEAT.
      DO IF (@ERROR=0).
         DO IF SYSMIS(@CL).
            COMPUTE @ERROR=1.
         ELSE.
            IF (@CL<50 OR @CL>=100) @ERROR=1.
         END IF.
         IF (@ERROR=1) @ERRtype = 5.
      END IF.
      IF (Nlevels>NLevelsMax) @ERROR=2.
      AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /BREAK=@U /ERROR=MAX(@ERROR) /ERRtype=MAX(@ERRtype).

      !IF (!A<>!NULL) !THEN.
*        For AGGREGATED DATA call, correct ERRtype to display the correct error message.
         !IF (!B=!NULL) !THEN.
            IF (ERRtype=2) ERRtype=3.
         !ELSE.
            IF (ERRtype=3) ERRtype=2.
         !IFEND.
      !IFEND.
      DO IF (ERROR=1 AND ERRtype=1 AND $casenum=1).
         PRINT /'ERROR: Parameter A with wrong values. See the HELP.'.
      ELSE IF (ERROR=1 AND ERRtype=2 AND $casenum=1).
         PRINT /'ERROR: Parameter B with wrong values. See the HELP.'.
      ELSE IF (ERROR=1 AND ERRtype=3 AND $casenum=1).
         PRINT /'ERROR: Parameter N with wrong values. See the HELP.'.
      ELSE IF (ERROR=1 AND ERRtype=4 AND $casenum=1).
         PRINT /'ERROR: Parameter LEXPO with wrong values. See the HELP.'.
      ELSE IF (ERROR=1 AND ERRtype=5 AND $casenum=1).
         PRINT /'ERROR: Parameter CL with wrong values. See the HELP.'.
      ELSE IF (ERROR=2 AND $casenum=1).
         PRINT /'ERROR: The number of levels of exposure is greater than ' !QUOTE(!LEXPOMAX).
      ELSE.
*        Print header.
         DO IF ($casenum=1).
            PRINT /'STRATIFIED TREND TEST (Cumulative data)'.
            !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
               STRING #NST (A131).
               COMPUTE #NST = CONCAT('STUDY: ',!NST).
               PRINT /#NST.
            !IFEND.
         END IF.
      END IF.
      EXECUTE.

*     Print Value Labels and Case Processing Summary (Individual Data).
      !IF (!VarRes<>!NULL !AND !VarExp<>!NULL !AND !VarStr<>!NULL) !THEN.
*        Create the @ERROR dataset with the ERROR info.
         DATASET COPY @9675ERROR WINDOW=!WINDOW.
         DATASET ACTIVATE @9675ERROR.
         N 1.
         COMPUTE @U=1.
         MATCH FILES FILE=* /KEEP=@U ERROR.
         DATASET ACTIVATE @9675Descrip.
*        Add @ERROR variable with the error information.
         COMPUTE @U=1.
         MATCH FILES FILE=* /TABLE=@9675ERROR /BY @U 
            /KEEP=Num Val Descrip ValNonCase ValCase ERROR.
         EXECUTE.

*        EXPOSURE variable, unexposed and exposed values.
         DO IF ($casenum=1 AND ERROR=0).
            PRINT //'EXPOSURE variable: ' !QUOTE(!VExp).
         END IF.
         EXECUTE.
   
*        RESPONSE variable, NonCases and Cases values.
         DO IF ($casenum=1 AND ERROR=0).
            PRINT //'RESPONSE variable: ' !QUOTE(!VResp).
         END IF.
         EXECUTE.
         DO IF (Val=ValNonCase AND Num=1 AND ERROR=0).
            PRINT /'         NonCases: ' Descrip.
         END IF.
         EXECUTE.
         DO IF (Val=ValCase AND Num=1 AND ERROR=0).
            PRINT /'            Cases: ' Descrip.
         END IF.
         EXECUTE.

*        STRATUM variable.
         DATASET ACTIVATE @9675StrNames.
*        Add @ERROR variable with the error information.
         COMPUTE @U=1.
         SELECT IF (NOT SYSMIS(CumulativePercent)).
         MATCH FILES FILE=* /TABLE=@9675ERROR /BY @U 
            /KEEP=Num Var2 ERROR.
         EXECUTE.
         DO IF ($casenum=1 AND ERROR=0).
            PRINT //' STRATUM variable: ' !QUOTE(!VarStr) .
         END IF.
         EXECUTE.
         STRING @Str (A4).
         COMPUTE @Str=CONCAT('Str',STRING($casenum,F1)).
         DO IF (ERROR=0).
            PRINT /     @Str(T14,A4) ': ' Var2.
         END IF.
         EXECUTE.

*        Case Processing Summary.
         DATASET ACTIVATE @9675CASES.
         COMPUTE @U=1.
         MATCH FILES FILE=* /TABLE=@9675ERROR /BY @U 
            /KEEP=Valid_N Valid_Percent Total_N ERROR.
         EXECUTE.
         DO IF (ERROR=0).
            PRINT //'Valid cases=' Valid_N(F6) '(' Valid_Percent(PCT6.1) ')'.
            PRINT  /'Total cases=' Total_N(F6).
         END IF.
         EXECUTE.
   
         DATASET ACTIVATE @9675DATA.
         DATASET CLOSE @9675Descrip.
         DATASET CLOSE @9675CASES.
         DATASET CLOSE @9675ERROR.
         DATASET CLOSE @9675StrNames.
      !ELSE.
*        STRATUM variable.
         DO IF ($casenum=1 AND ERROR=0).
            PRINT //'STRATUM ' Str(T9,A4) ': ' Study.
         END IF.
         EXECUTE.
         DO IF (ERROR=0 AND @OVERALL=0 AND $casenum>1).
            PRINT  /           Str(T9,A4) ': ' Study.
         END IF.
         EXECUTE.
      !IFEND.

      DO IF (@ERROR=0).
*        CI compute method (PrCI): W (Wilson) = 1 - default; E (Exact) = 2; A (Asymptotic) = 3.
         COMPUTE @PrCI=0.
         IF (!QUOTE(!PrCIU)='W') @PrCI=1.
         IF (!QUOTE(!PrCIU)='E') @PrCI=2.
         IF (!QUOTE(!PrCIU)='A') @PrCI=3.
*        @RefType= 1 - RC=F; 2 - RC=L; 3 - RC=P; 4 - RC=S;
         COMPUTE @RefType=0.
         IF (!QUOTE(!RCU)='F') @RefType = 1.
         IF (!QUOTE(!RCU)='L') @RefType = 2.
         IF (!QUOTE(!RCU)='P') @RefType = 3.
         IF (!QUOTE(!RCU)='S') @RefType = 4.
*        Type of continuity correction: 1 - Constant; 2 - Proportional; 3 - Reciprocal.
         COMPUTE @ZERO=0.
         IF (!QUOTE(!ZeroU)='C') @ZERO=1.
         IF (!QUOTE(!ZeroU)='P') @ZERO=2.
         IF (!QUOTE(!ZeroU)='R') @ZERO=3.
*        CC=1 -> ST=CC.
         COMPUTE @CC=0.
         IF (!QUOTE(!STU)='CC') @CC=1.
*        Odds results.
         COMPUTE @odds=0.
         IF (!QUOTE(!STU)='CO(OR)' OR !QUOTE(!STU)='CS(OR)') @odds = 1.

         COMPUTE @P = (@CL+100)/200.
         COMPUTE @Z=IDF.NORMAL(@P,0,1).
         
*        Create the 'reference' A, B.
         !LET !Arefn =!CONCAT('Aref' ,!COUNT).
         !LET !Brefn =!CONCAT('Bref' ,!COUNT).
         !LET !An =!CONCAT('A' ,!COUNT).
         !LET !Bn =!CONCAT('B' ,!COUNT).
         !LET !Nn =!CONCAT('N' ,!COUNT).
         NUMERIC Aref1 to !Arefn Bref1 to !Brefn.
         COMPUTE #Aprev = $SYSMIS.
         COMPUTE #Bprev = $SYSMIS.
         DO REPEAT A=A1 to !An /B=B1 to !Bn /Aref=Aref1 to !Arefn /Bref=Bref1 to !Brefn /Anext=A2 to !An A1 /Bnext=B2 to !Bn B1.
            IF (@RefType=1) Aref=A1.
            IF (@RefType=1) Bref=B1.
            IF (@RefType=2) Aref=!An.
            IF (@RefType=2) Bref=!Bn.
            IF (@RefType=3) Aref=#Aprev.
            IF (@RefType=3) Bref=#Bprev.
            IF (@RefType=4) Aref=Anext.
            IF (@RefType=4) Bref=Bnext.
            COMPUTE #Aprev = A.
            COMPUTE #Bprev = B.
         END REPEAT.
         IF (@RefType=4) !Arefn = $SYSMIS.
         IF (@RefType=4) !Brefn = $SYSMIS.

*        Compute Risk, Odds and summatories for trend test.
         !LET !Rn =!CONCAT('R' ,!COUNT).
         !LET !RRn =!CONCAT('RR' ,!COUNT).
         !LET !lbRRn =!CONCAT('lbRR' ,!COUNT).
         !LET !ubRRn =!CONCAT('ubRR' ,!COUNT).
         !LET !SElnRRn =!CONCAT('SElnRR' ,!COUNT).
         !LET !iRRn =!CONCAT('iRR' ,!COUNT).
         !LET !ilbRRn =!CONCAT('ilbRR' ,!COUNT).
         !LET !iubRRn =!CONCAT('iubRR' ,!COUNT).
         !LET !On =!CONCAT('O' ,!COUNT).
         !LET !ORn =!CONCAT('OR' ,!COUNT).
         !LET !lbORn =!CONCAT('lbOR' ,!COUNT).
         !LET !ubORn =!CONCAT('ubOR' ,!COUNT).
         !LET !iORn =!CONCAT('iOR' ,!COUNT).
         !LET !ilbORn =!CONCAT('ilbOR' ,!COUNT).
         !LET !iubORn =!CONCAT('iubOR' ,!COUNT).
         !LET !iubORn =!CONCAT('iubOR' ,!COUNT).
         !LET !SElnORn =!CONCAT('SElnOR' ,!COUNT).
         !LET !NStMHn =!CONCAT('@NStMH' ,!COUNT).
         !LET !DStMHn =!CONCAT('@DStMH' ,!COUNT).
         !LET !NStMHKn =!CONCAT('@NStMHK' ,!COUNT).
         !LET !DStMHKn =!CONCAT('@DStMHK' ,!COUNT).
         !LET !PRMHn =!CONCAT('@PRMH' ,!COUNT).
         !LET !PSMHn =!CONCAT('@PSMH' ,!COUNT).
         !LET !QRMHn =!CONCAT('@QRMH' ,!COUNT).
         !LET !QSMHn =!CONCAT('@QSMH' ,!COUNT).
         !LET !NUMVMHn =!CONCAT('@NUMVMH' ,!COUNT).
         !LET !Zeron =!CONCAT('@TZero' ,!COUNT).
         !LET !ZeroCorn =!CONCAT('@ZeroCor' ,!COUNT).
         !LET !ZeroTn =!CONCAT('ZeroT' ,!COUNT).
         !LET !A1n =!CONCAT('A1', !COUNT).
         !LET !A0n =!CONCAT('A0', !COUNT).
         !LET !B1n =!CONCAT('B1', !COUNT).
         !LET !B0n =!CONCAT('B0', !COUNT).
         COMPUTE @WarnZero= 0.
         COMPUTE @invRR=0.
         COMPUTE @invOR=0.
         COMPUTE @SA=0.
         COMPUTE @SS=0.
         COMPUTE @S2=0.
         STRING @TZero1 to !Zeron(A1) ZeroT1 to !ZeroTn(A1).
         NUMERIC R1 to !Rn RR1 to !RRn lbRR1 to !lbRRn ubRR1 to !ubRRn SElnRR1 to !SElnRRn iRR1 to !iRRn ilbRR1 to !ilbRRn iubRR1 to !iubRRn
                 O1 to !On OR1 to !ORn lbOR1 to !lbORn ubOR1 to !ubORn SElnOR1 to !SElnORn iOR1 to !iORn ilbOR1 to !ilbORn iubOR1 to !iubORn 
                 @NStMH1 to !NStMHn @DStMH1 to !DStMHn @PRMH1 to !PRMHn @PSMH1 to !PSMHn @QRMH1 to !QRMHn @QSMH1 to !QSMHn @NUMVMH1 to !NUMVMHn
                 @NStMHK1 to !NStMHKn @DStMHK1 to !DStMHKn @ZeroCor1 to !ZeroCorn A11 to !A1n A01 to !A0n B11 to !B1n B01 to !B0n.
         DO REPEAT LEXPO=LEXPO1 to !LEXPOn /A=A1 to !An /B=B1 to !Bn /Aref=Aref1 to !Arefn /Bref=Bref1 to !Brefn /N=N1 to !Nn 
                     /A1=A11 to !A1n /B1=B11 to !B1n /A0=A01 to !A0n /B0=B01 to !B0n 
                      /R=R1 to !Rn /O=O1 to !On /Tzero=@TZero1 to !Zeron
                     /RR=RR1 to !RRn /lbRR=lbRR1 to !lbRRn /ubRR=ubRR1 to !ubRRn /SElnRR=SElnRR1 to !SElnRRn
                    /iRR=iRR1 to !iRRn /ilbRR=ilbRR1 to !ilbRRn /iubRR=iubRR1 to !iubRRn
                    /ORn=OR1 to !ORn /lbOR=lbOR1 to !lbORn /ubOR=ubOR1 to !ubORn /SElnOR=SElnOR1 to !SElnORn
                    /iOR=iOR1 to !iORn /ilbOR=ilbOR1 to !ilbORn /iubOR=iubOR1 to !iubORn
                  /NStMH=@NStMH1 to !NStMHn /DStMH=@DStMH1 to !DStMHn /PRMH=@PRMH1 to !PRMHn /PSMH=@PSMH1 to !PSMHn 
                   /QSMH=@QSMH1 to !QSMHn /QRMH=@QRMH1 to !QRMHn /DSMH=@QSMH1 to !QSMHn /NUMVMH=@NUMVMH1 to !NUMVMHn
                 /NStMHK=@NStMHK1 to !NStMHKn /DStMHK=@DStMHK1 to !DStMHKn /ZeroCor=@ZeroCor1 to !ZeroCorn.

*           Trend test.
            COMPUTE @SA=@SA+LEXPO*A. 
            COMPUTE @SS=@SS+LEXPO*N.
            COMPUTE @S2=@S2+LEXPO**2*N.

*           A1,B1,A0,B0 for each level.
            COMPUTE A1= A.
            COMPUTE B1= B.
            COMPUTE A0= Aref.
            COMPUTE B0= Bref.
            COMPUTE #M1=A0+A1.
            COMPUTE #M0=B0+B1.
            COMPUTE #N1=A1+B1.
            COMPUTE #N0=A0+B0.
            COMPUTE #N=#N0+#N1.

*           Continuity correction.
            COMPUTE ZeroCor= 0.
            DO IF (@ZERO>0 AND (A1=0 OR B1=0 OR A0=0 OR B0=0)).
               COMPUTE @WarnZero= 1.
               COMPUTE ZeroCor= 1.
               
               IF (@ZERO=1) @K1=0.5.
               IF (@ZERO=1) @K0=0.5.
               IF (@ZERO=2 AND @CC=0) @K1=#N1/#N.
               IF (@ZERO=2 AND @CC=0) @K0=#N0/#N.
               IF (@ZERO=2 AND @CC=1) @K1=#M1/#N.
               IF (@ZERO=2 AND @CC=1) @K0=#M0/#N.
               IF (@ZERO=3 AND @CC=0) @K1=1/#N0.
               IF (@ZERO=3 AND @CC=0) @K0=1/#N1.
               IF (@ZERO=3 AND @CC=1) @K1=1/#M0.
               IF (@ZERO=3 AND @CC=1) @K0=1/#M1.

               DO IF (@CC=0).
                  COMPUTE A1=A1+@K1.
                  COMPUTE B1=B1+@K1.
                  COMPUTE A0=A0+@K0.
                  COMPUTE B0=B0+@K0.
               ELSE IF (@CC=1).
                  COMPUTE A1=A1+@K1.
                  COMPUTE A0=A0+@K1.
                  COMPUTE B1=B1+@K0.
                  COMPUTE B0=B0+@K0.
               END IF.
            END IF.
            COMPUTE #M1=A0+A1.
            COMPUTE #M0=B0+B1.
            COMPUTE #N1=A1+B1.
            COMPUTE #N0=A0+B0.
            COMPUTE #N=#N0+#N1.

*           RISK.
            COMPUTE #N1=(A1+B1).
            COMPUTE R = A1/#N1.
*           RR: RISK RATIO of each exposure vs the reference category.
            COMPUTE #N0=(A0+B0).
            COMPUTE RR=R/(A0/#N0).
*           Risk ratio CI.
            COMPUTE SElnRR = SQR(1/A0-1/#N0+1/A1-1/#N1).
            COMPUTE lbRR= EXP(LN(RR)-(@Z*SElnRR)).
            COMPUTE ubRR= EXP(LN(RR)+(@Z*SElnRR)).
*           Inverse values.
            COMPUTE iRR=1/RR.
            COMPUTE ilbRR= 1/ubRR.
            COMPUTE iubRR= 1/lbRR.
            IF (RR < 1 AND @OVERALL=1) @invRR = 1.
            
*           ODDS.
            COMPUTE O=A1/B1.
*           OR: ODDS RATIO of each exposure vs the reference category.
            COMPUTE ORn=O/(A0/B0).
*           Odds ratio CI.
            COMPUTE SElnOR=SQR(1/A0+1/B0+1/A1+1/B1).
            COMPUTE lbOR= EXP(LN(ORn)-(@Z*SElnOR)).
            COMPUTE ubOR= EXP(LN(ORn)+(@Z*SElnOR)).
*           Inverse values.
            COMPUTE iOR=1/ORn.
            COMPUTE ilbOR= 1/ubOR.
            COMPUTE iubOR= 1/lbOR.
            IF (ORn < 1 AND @OVERALL=1) @invOR = 1.
            
************Mantel-Haenszel combined results: sumatories terms (the zero correction applies to all results).
            DO IF (@OVERALL=0).
               DO IF (@CC=1 or @odds=1).
*                 Sumatory for OR results.
                  COMPUTE #PMHi=(A1+B0)/#N.
                  COMPUTE NStMH = (A1*B0)/#N.
                  COMPUTE DStMH = (A0*B1)/#N.
*                 Sumatory for OR Bounds.
                  COMPUTE PRMH = NStMH*#PMHi.
                  COMPUTE PSMH = DStMH*#PMHi.
                  COMPUTE QRMH = (1-#PMHi)*NStMH.
                  COMPUTE QSMH = (1-#PMHi)*DStMH.
               ELSE.
*                 Sumatory for RR results.
                  COMPUTE NStMH = (A1*#N0)/#N.
                  COMPUTE DStMH = (A0*#N1)/#N.
*                 Sumatory for RR Bounds.
                  COMPUTE NUMVMH=((A1+A0)*#N1*#N0-A1*A0*#N) / #N**2.
               END IF.
            END IF.
         END REPEAT.

*        Corrections.
         DO IF ANY(@RefType,1,3).
            COMPUTE ubRR1 = $SYSMIS.
            COMPUTE lbRR1 = $SYSMIS.
            COMPUTE SElnRR1 = $SYSMIS.
            COMPUTE iubRR1 = $SYSMIS.
            COMPUTE ilbRR1 = $SYSMIS.
            COMPUTE ubOR1 = $SYSMIS.
            COMPUTE lbOR1 = $SYSMIS.
            COMPUTE SElnOR1 = $SYSMIS.
            COMPUTE iubOR1 = $SYSMIS.
            COMPUTE ilbOR1 = $SYSMIS.
         ELSE IF ANY(@RefType,2,4).
            COMPUTE !ubRRn = $SYSMIS.
            COMPUTE !lbRRn = $SYSMIS.
            COMPUTE !SElnRRn = $SYSMIS.
            COMPUTE !iubRRn = $SYSMIS.
            COMPUTE !ilbRRn = $SYSMIS.
            COMPUTE !ubORn = $SYSMIS.
            COMPUTE !lbORn = $SYSMIS.
            COMPUTE !SElnORn = $SYSMIS.
            COMPUTE !iubORn = $SYSMIS.
            COMPUTE !ilbORn = $SYSMIS.
         END IF.

*        Total RISK & CI.
         COMPUTE RT=M1/N.
*        Total ODDS.
         COMPUTE OT=M1/M0.

*        Computing Q, EQ and VQ.
         DO IF (@OVERALL=0).
            COMPUTE @Q = @SA.
            COMPUTE @EQ=(M1/N)*@SS.
            COMPUTE @VQ=(M1*M0)/((N**2)*(N-1)) * (N*@S2-@SS**2 ).
         END IF.
         
*        Trend test and signification.
         COMPUTE @SS=@SS/N.
         COMPUTE @SLS2=0.
         DO REPEAT LEXPO=LEXPO1 to !LEXPOn /N=N1 to !Nn.
            COMPUTE @SLS2=@SLS2+N*(LEXPO-@SS)**2.
         END REPEAT.
         COMPUTE X=(@SA-M1*@SS)/ SQRT(M1*M0*@SLS2/(N**2-N)).
         COMPUTE P=2*(1-cdfnorm(ABS(X))).
         COMPUTE XC= (X/ABS(X))*(ABS(@SA-M1*@SS)-0.5)/SQRT(M1*M0*@SLS2/(N**2-N)).
         IF (ABS(@SA-M1*@SS)<0.5) XC=0.
         COMPUTE PC= 2*(1-CDFNORM(ABS(XC))).
         DO IF (@OVERALL=0).
            COMPUTE @X2 = X**2.
            COMPUTE @X2c = Xc**2.
         END IF.
         
*        Detect decimal parameters.
         COMPUTE @WarnDec= 0.
         !LET !Decn = !CONCAT('@Dec',!COUNT).
         STRING @Dec1 to !Decn @Dec (A1).
         DO REPEAT A=A1 to !An /B=B1 to !Bn /Dec=@Dec1 to !Decn.
            COMPUTE Dec=' '.
            DO IF (MOD(A,1)<>0 OR MOD(B,1)<>0).
               COMPUTE @WarnDec=1.
               COMPUTE Dec='.'.
            END IF.
         END REPEAT.
         COMPUTE @Dec=' '.
         IF (@WarnDec=1) @Dec='.'.
      END IF.

*     Macro variables for the Adjusted M-H summatories.
      !LET !NStMH=''.
      !LET !DStMH=''.
      !LET !NStMHK=''.
      !LET !DStMHK=''.
      !LET !PRMH=''.
      !LET !PSMH=''.
      !LET !QRMH=''.
      !LET !QSMH=''.
      !LET !NUMVMH=''.
      !LET !ZeroCor=''.
      !DO !I=1 !TO !COUNT.
         !LET !NStMH =!CONCAT(!NStMH,' /NStMH',!I,'=SUM(@NStMH',!I,')').
         !LET !DStMH =!CONCAT(!DStMH,' /DStMH',!I,'=SUM(@DStMH',!I,')').
         !LET !NStMHK =!CONCAT(!NStMHK,' /NStMHK',!I,'=SUM(@NStMHK',!I,')').
         !LET !DStMHK =!CONCAT(!DStMHK,' /DStMHK',!I,'=SUM(@DStMHK',!I,')').
         !LET !PRMH =!CONCAT(!PRMH,' /PRMH',!I,'=SUM(@PRMH',!I,')').
         !LET !PSMH =!CONCAT(!PSMH,' /PSMH',!I,'=SUM(@PSMH',!I,')').
         !LET !QRMH =!CONCAT(!QRMH,' /QRMH',!I,'=SUM(@QRMH',!I,')').
         !LET !QSMH =!CONCAT(!QSMH,' /QSMH',!I,'=SUM(@QSMH',!I,')').
         !LET !NUMVMH =!CONCAT(!NUMVMH,' /NUMVMH',!I,'=SUM(@NUMVMH',!I,')').
         !LET !ZeroCor =!CONCAT(!ZeroCor,' /ZeroCor',!I,'=MAX(@ZeroCor',!I,')').
      !DOEND.
      !LET !Aggr=!CONCAT(!NStMH,' ',!DStMH,' ',!PRMH,' ',!PSMH,' ',!QRMH,' ',!QSMH,' ',!NUMVMH,' ',!NStMHK,' ',!DStMHK,' ',!ZeroCor).
      AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /BREAK=@U /NStr=N
        /WarnZERO=MAX(@WarnZERO) /WarnDEC=MAX(@WarnDEC) /invRR=MAX(@invRR) /invOR=MAX(@invOR) 
        /Q=SUM(@Q) /EQs=SUM(@EQ) /VQ=SUM(@VQ) /X2=SUM(@X2) /X2c=SUM(@X2c) !Aggr.
      
      DO IF (@ERROR=0).
         COMPUTE NStr=NStr-1.
*********Mantel-Haenszel combined results.
         COMPUTE @iStMH=0.
         !LET !StMHn=!CONCAT('StMH',!COUNT).
         !LET !SEStMHn=!CONCAT('SEStMH',!COUNT).
         !LET !ubStMHn=!CONCAT('ubStMH',!COUNT).
         !LET !lbStMHn=!CONCAT('lbStMH',!COUNT).
         !LET !iStMHn=!CONCAT('iStMH',!COUNT).
         !LET !iSEStMHn=!CONCAT('iSEStMH',!COUNT).
         !LET !iubStMHn=!CONCAT('iubStMH',!COUNT).
         !LET !ilbStMHn=!CONCAT('ilbStMH',!COUNT).
         !LET !NStMHn=!CONCAT('NStMH',!COUNT).
         !LET !DStMHn=!CONCAT('DStMH',!COUNT).
         !LET !PRMHn=!CONCAT('PRMH',!COUNT).
         !LET !PSMHn=!CONCAT('PSMH',!COUNT).
         !LET !QRMHn=!CONCAT('QRMH',!COUNT).
         !LET !QSMHn=!CONCAT('QSMH',!COUNT).
         !LET !NUMVMHn=!CONCAT('NUMVMH',!COUNT).
         NUMERIC StMH1 to !StMHn SEStMH1 to !SEStMHn lbStMH1 to !lbStMHn ubStMH1 to !ubStMHn
                 iStMH1 to !iStMHn iSEStMH1 to !iSEStMHn ilbStMH1 to !ilbStMHn iubStMH1 to !iubStMHn.
         DO REPEAT StMH=StMH1 to !StMHn /NStMH=NStMH1 to !NStMHn /DStMH=DStMH1 to !DStMHn 
                /SEStMH=SEStMH1 to !SEStMHn /ubStMH=ubStMH1 to !ubStMHn /lbStMH=lbStMH1 to !lbStMHn
                 /iStMH=iStMH1 to !iStMHn /iubStMH=iubStMH1 to !iubStMHn /ilbStMH=ilbStMH1 to !ilbStMHn
                 /PRMH=PRMH1 to !PRMHn /PSMH=PSMH1 to !PSMHn /QRMH=QRMH1 to !QRMHn /QSMH=QSMH1 to !QSMHn /NUMVMH=NUMVMH1 to !NUMVMHn.
            COMPUTE StMH=NStMH/DStMH.
            DO IF (@CC=1 or @odds=1).
               COMPUTE SEStMH = SQR(PRMH/(2*NStMH**2) + (PSMH+QRMH)/(2*NStMH*DStMH) + QSMH/(2*DStMH**2)).
            ELSE.
               COMPUTE SEStMH = SQRT(NUMVMH/(NstMH*DStMH)).
            END IF.
            COMPUTE ubStMH=StMH*EXP(+@Z*SEStMH).
            COMPUTE lbStMH=StMH*EXP(-@Z*SEStMH).
            COMPUTE iStMH=1/StMH.
            COMPUTE ilbStMH=1/ubStMH.
            COMPUTE iubStMH=1/lbStMH.
         END REPEAT.
*        Corrections.
         DO IF ANY(@RefType,1,3).
            IF (@RefType=3) StMH1 = $SYSMIS.
            COMPUTE ubStMH1 = $SYSMIS.
            COMPUTE lbStMH1 = $SYSMIS.
            COMPUTE SEStMH1 = $SYSMIS.
            COMPUTE iubStMH1 = $SYSMIS.
            COMPUTE ilbStMH1 = $SYSMIS.
         ELSE IF ANY(@RefType,2,4).
            IF (@RefType=4) !StMHn = $SYSMIS.
            COMPUTE !ubStMHn = $SYSMIS.
            COMPUTE !lbStMHn = $SYSMIS.
            COMPUTE !SEStMHn = $SYSMIS.
            COMPUTE !iubStMHn = $SYSMIS.
            COMPUTE !ilbStMHn = $SYSMIS.
         END IF.
         DO REPEAT StMH=StMH1 to !StMHn.
            IF (StMH < 1) @iStMH=1.
         END REPEAT.
*        Homogeneity Chi-square: Wald & Breslow-Day.
         !LET !Chin=!CONCAT('@Chi',!COUNT).
         !LET !ChiBDn=!CONCAT('@ChiBD',!COUNT).
         NUMERIC @Chi1 to !Chin @ChiBD1 to !ChiBDn.
         DO REPEAT Chi=@Chi1 to !Chin /StMH=StMH1 to !StMHn 
                   /RR=RR1 to !RRn /SElnRR=SElnRR1 to !SElnRRn 
                  /ORn=OR1 to !ORn /SElnOR=SElnOR1 to !SElnORn
                /ChiBD=@ChiBD1 to !ChiBDn /A1=A11 to !A1n /B1=B11 to !B1n /A0=A01 to !A0n /B0=B01 to !B0n.
            DO IF (@OVERALL=0).
               DO IF (@CC=1 or @odds=1).
*                 Wald.
                  COMPUTE Chi = (LN(ORn) - LN(StMH))**2/(SElnOR**2).

*                 Breslow & Day.
                  COMPUTE ChiBD=$SYSMIS.
                  COMPUTE #M1=A0+A1.
                  COMPUTE #M0=B0+B1.
                  COMPUTE #N1=A1+B1.
                  COMPUTE #N0=A0+B0.
*                 Use formula 4:11 (Breslow & Day, pag 130) to find Ai (using the previously computed M-H estimation of OR).
                  COMPUTE #a = (1 - StMH).      /*Compute the terms of the quadratic equation of Ai (Ai=x, given ax2 + bx + c = 0).
                  COMPUTE #b = (#N0 + StMH*#N1 + #M1*(StMH - 1 )).
                  COMPUTE #c = -StMH*#N1*#M1.
*                 To find Ai, solve the quadratic equation: x = (-b +/- SQR(b^2 - 4ac))/2a.
                  COMPUTE Aiplus = (-#b + SQR((#b**2)-(4*#a*#c)))/(2*#a).       /*Root using the +.
                  COMPUTE Biplus = #N1 - Aiplus.               /*Find the A,B,C,D quantities of 4:10 (Breslow & Day, pag 130) for Ai+.
                  COMPUTE Ciplus = #M1 - Aiplus.
                  COMPUTE Diplus = #N0 - #M1 + Aiplus.
                  COMPUTE Aiminus = (-#b - SQR((#b**2)-(4*#a*#c)))/(2*#a).       /*Root using the -.
                  COMPUTE Biminus = #N1 - Aiminus.               /*Find the A,B,C,D quantities of 4:10 (Breslow & Day, pag 130) for Ai-.
                  COMPUTE Ciminus = #M1 - Aiminus.
                  COMPUTE Diminus = #N0 - #M1 + Aiminus.
*                 Only one root Ai+, Ai- is correct: A,B,C,D must be all positive.
*                 To compute the Variance use the formula 4:13 (Breslow & Day, pag 130) with the correct A,B,C,D.
                  DO IF (Aiplus > 0 AND Biplus > 0 AND Ciplus > 0 AND Diplus > 0).
                     COMPUTE ABDi = Aiplus.
                     COMPUTE VARBDi = 1/(1/Aiplus + 1/Biplus + 1/Ciplus + 1/Diplus).
                  ELSE IF (Aiminus > 0 AND Biminus > 0 AND Ciminus > 0 AND Diminus > 0).
                     COMPUTE ABDi = Aiminus.
                     COMPUTE VARBDi = 1/(1/Aiminus + 1/Biminus + 1/Ciminus + 1/Diminus).
                  END IF.
*                 Use formula 4:30 (Breslow & Day, pag 142) to find the homogeneity statistic with the found Ai,VARi.
                  COMPUTE ChiBD = (A1 - ABDi)**2/VARBDi.
               ELSE.
                  COMPUTE Chi = (LN(RR) - LN(StMH))**2/(SElnRR**2).
               END IF.
            END IF.
         END REPEAT.
      END IF.
*     Summatories for Homogeneity Chi-Square (Wald).
      !LET !AggrChi=''.
      !LET !AggrChiBD=''.
      !DO !I=1 !TO !COUNT.
         !LET !AggrChi =!CONCAT(!AggrChi,' /Chi',!I,'=SUM(@Chi',!I,')').
         !LET !AggrChiBD =!CONCAT(!AggrChiBD,' /ChiBD',!I,'=SUM(@ChiBD',!I,')').
      !DOEND.
*     Temporary select the non overall results.
      TEMPORARY.
      SELECT IF (@OVERALL=0).
      AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /MISSING=COLUMNWISE /BREAK=@U !AggrChi !AggrChiBD.
      
      DO IF (ERROR=0).
         !LET !pChin=!CONCAT('pChi',!COUNT).
         !LET !Chin=!CONCAT('Chi',!COUNT).
         !LET !pChiBDn=!CONCAT('pChiBD',!COUNT).
         !LET !ChiBDn=!CONCAT('ChiBD',!COUNT).
         NUMERIC pChi1 to !pChin pChiBD1 to !pChiBDn.
         DO REPEAT pChi=pChi1 to !pChin /Chi=Chi1 to !Chin
                /pChiBD=pChiBD1 to !pChiBDn /ChiBD=ChiBD1 to !ChiBDn.
            COMPUTE pChi = (1- CDF.CHISQ(ABS(Chi),NStr-1)).
            COMPUTE pChiBD= (1- CDF.CHISQ(ABS(ChiBD),NStr-1)).
         END REPEAT.
*        Corrections.
         DO IF ANY(@RefType,1,3).
            COMPUTE Chi1 = $SYSMIS.
            COMPUTE pChi1 = $SYSMIS.
            COMPUTE ChiBD1 = $SYSMIS.
            COMPUTE pChiBD1 = $SYSMIS.
         ELSE IF ANY(@RefType,2,4).
            COMPUTE !Chin = $SYSMIS.
            COMPUTE !pChin = $SYSMIS.
            COMPUTE !ChiBDn = $SYSMIS.
            COMPUTE !pChiBDn = $SYSMIS.
         END IF.

*        Test for Trend  Z.
         COMPUTE XO =(Q-EQs)/SQRT(VQ).
         COMPUTE XOc=(XO/ABS(XO))*(ABS(Q-EQs)-0.5)/SQRT(VQ).
         COMPUTE pXO = 2*(1-cdfnorm(ABS(XO))).
         COMPUTE pXOc= 2*(1-cdfnorm(ABS(XOC))).
*        Homogeneity of linear trends: Chi.
         COMPUTE X2 = X2 - XO**2.
         COMPUTE dfX2=Nstr-1.
         COMPUTE pX2 =(1- CDF.CHISQ(ABS(X2),dfX2)).
*         COMPUTE X2c= X2c- XOc**2.
*         IF (X2c < 0) X2c=0.
*         COMPUTE pX2c=(1- CDF.CHISQ(ABS(X2c),dfX2)).
         
*        Auxiliary macro variables to print.
         !LET !Aprint=''.
         !LET !Bprint=''.
         !LET !Nprint=''.
         !LET !Rprint=''.
         !LET !RRprint=''.
         !LET !iRRprint=''.
         !LET !Oprint=''.
         !LET !ORprint=''.
         !LET !iORprint=''.
         !LET !Chiprint=''.
         !LET !pChiprint=''.
         !LET !ChiBDprint=''.
         !LET !pChiBDprint=''.
         !LET !StMHprint=''.
         !LET !TABLE =''.
         !DO !I=1 !TO !COUNT.
            !LET !Aprint= !CONCAT(!Aprint,' A',!I,'(F8.0) @Dec',!I,'(A1)').
            !LET !Bprint= !CONCAT(!Bprint,' B',!I,'(F8.0) @Dec',!I,'(A1)').
            !LET !Nprint= !CONCAT(!Nprint,' N',!I,'(F8.0) @Dec',!I,'(A1)').
            !LET !Rprint= !CONCAT(!Rprint,' R',!I,'(F8.6) @TZero',!I,'(A1)').
            !LET !RRprint= !CONCAT(!RRprint,' RR',!I,'(F8.3) @TZero',!I,'(A1)').
            !LET !iRRprint= !CONCAT(!iRRprint,' iRR',!I,'(F8.3) @TZero',!I,'(A1)').
            !LET !Oprint= !CONCAT(!Oprint,' O',!I,'(F8.3) @TZero',!I,'(A1)').
            !LET !ORprint= !CONCAT(!ORprint,' OR',!I,'(F8.3) @TZero',!I,'(A1)').
            !LET !iORprint= !CONCAT(!iORprint,' iOR',!I,'(F8.3) @TZero',!I,'(A1)').
            !LET !Chiprint= !CONCAT(!Chiprint,' Chi',!I,'(F8.3) ZeroT',!I,'(A1)').
            !LET !pChiprint= !CONCAT(!pChiprint,' pChi',!I,'(F8.5) ZeroT',!I,'(A1)').
            !LET !ChiBDprint= !CONCAT(!ChiBDprint,' ChiBD',!I,'(F8.3) ZeroT',!I,'(A1)').
            !LET !pChiBDprint= !CONCAT(!pChiBDprint,' pChiBD',!I,'(F8.5) ZeroT',!I,'(A1)').
            !LET !StMHprint= !CONCAT(!StMHprint,' StMH',!I,'(F8.3) ZeroT',!I,'(A1)').
            !LET !TABLE =!CONCAT(!TABLE, '---------').
         !DOEND.
         COMPUTE @SE=0.
         IF (!QUOTE(!CL)='SE') @SE = 1.
         !LET !TEMP=!SUBSTR(!STU,1,2).
         COMPUTE @type=0.
         IF (!QUOTE(!TEMP)='CO') @type = 1.
         IF (!QUOTE(!TEMP)='CS') @type = 2.
         STRING @Title (A16) @Title2 @Title4 (A2) @Title3 (A8) @RefCat(A16).
         COMPUTE @Title='            RISK'.
         IF (@OVERALL=1) @Title='      Crude RISK'.
         IF (@type=2) @Title = '      PREVALENCE'.
         IF (@type=2 AND @OVERALL=1) @Title = 'Crude PREVALENCE'.
         COMPUTE @Title2='RR'.
         IF (@type=2) @Title2= 'PR'.
         COMPUTE @Title3='SEln(RR)'.
         IF (@type=2) @Title3= 'SEln(PR)'.
         COMPUTE @Title4='RR'.
         IF (@type=2) @Title4= 'PR'.
         IF (@RefType=1) @RefCat = 'RC:First level  '.
         IF (@RefType=2) @RefCat = 'RC:Last level   '.
         IF (@RefType=3) @RefCat = 'RC:Prev. level  '.
         IF (@RefType=4) @RefCat = 'RC:Subs. level  '.
         IF (@CC=1 or @odds=1) @Title4='OR'.
      END IF.
      
******PRINT RESULTS.
      DO IF (ERROR=0).
*        Notes for Zero Correction.
         DO REPEAT @ZeroCor=@ZeroCor1 to !ZeroCorn /@TZero=@TZero1 to !Zeron.
            COMPUTE @TZero=' '.
            IF (@ZeroCor=1) @TZero='*'.
         END REPEAT.
         IF (@RefType=3) @TZero1=' '.
         IF (@RefType=4) !Zeron=' '.
*        Print table.
         DO IF (ERROR=0).
            DO IF (@OVERALL=0).
               PRINT//'STRATUM: ' Str '|'19 .
            ELSE.
               PRINT//'OVERALL' '|'19 .
            END IF.
            PRINT /'Level of Exposure |' LEXPO1 to !LEXPOn (!COUNT(F8.2,X)) '|   TOTAL |'.
            PRINT /'------------------+' !QUOTE(!TABLE) '+---------+'.
            PRINT /'            Cases |' !Aprint '|' M1(F8.0) @Dec(A1) '|'.
            !IF (!STU = 'CC') !THEN.
               PRINT /'         Controls |' !Bprint '|' M0(F8.0) @Dec(A1) '|'.
            !ELSE.
               PRINT /'          NoCases |' !Bprint '|' M0(F8.0) @Dec(A1) '|'.
            !IFEND.
            PRINT /'                  +' !QUOTE(!TABLE) '+---------+'.
            PRINT /'            TOTAL |' !Nprint '|' N(F8.0) @Dec(A1) '|'.
            PRINT /'                  +' !QUOTE(!TABLE) '+---------+'.
         END IF.
            
*        Print statistic.
         DO IF (@CC=0).
            DO IF (@OVERALL=0 or @odds=0).
               PRINT / ' ' @Title(A16) ' |' !Rprint '|' RT(F8.6).
               DO IF (@odds=1).
                  PRINT / '             ODDS |' !Oprint '|' OT(F8.3).
               END IF.
            END IF.
         ELSE.
            PRINT / '      Pseudo-ODDS |' !Oprint '|' OT(F8.3).
         END IF.
         
*        Print ratio of each category versus the reference category.
         DO IF (@CC=0 AND @odds=0).
            PRINT / @RefCat(A16)  @Title2(A2) '|' !RRprint '|'.
         ELSE.
            PRINT / @RefCat(A16) 'OR|' !ORprint '|'.
         END IF.

         DO IF (@OVERALL=1).
            DO IF (@CC=0 AND @odds=0).
               DO IF (@SE=0).
                  PRINT / '      ' @CL(F2) '% CI Lower|' lbRR1 to !lbRRn (!COUNT(F8.3,X)) '|'.
                  PRINT / '             Upper|' ubRR1 to !ubRRn (!COUNT(F8.3,X)) '|'.
               ELSE.
                  PRINT / '          ' @Title3(A8) '|' SElnRR1 to !SElnRRn (!COUNT(F8.3,X)) '|'.
               END IF.
               DO IF (invRR=1).
                  DO IF (ERROR=0).
                     PRINT /'     Reciprocal ' @Title2(A2) '|' !iRRprint '|'.
                  END IF.
                  DO IF (@SE=0).
                     PRINT / '      ' @CL(F2) '% CI Lower|' ilbRR1 to !ilbRRn (!COUNT(F8.3,X)) '|'.
                     PRINT / '             Upper|' iubRR1 to !iubRRn (!COUNT(F8.3,X)) '|'.
                  END IF.
               END IF.
            ELSE.
               DO IF (@SE=0).
                  PRINT /'      ' @CL(F2) '% CI Lower|' lbOR1 to !lbORn (!COUNT(F8.3,X)) '|'.
                  PRINT /'             Upper|' ubOR1 to !ubORn (!COUNT(F8.3,X)) '|'.
               ELSE.
                  PRINT /'          SEln(OR)|' SElnOR1 to !SElnORn (!COUNT(F8.3,X)) '|'.
               END IF.
               DO IF (invOR=1).
                  DO IF (ERROR=0).
                     PRINT /'     Reciprocal OR|' !iORprint '|'.
                  END IF.
                  DO IF (@SE=0).
                     PRINT / '      ' @CL(F2) '% CI Lower|' ilbOR1 to !ilbORn (!COUNT(F8.3,X)) '|'.
                     PRINT / '             Upper|' iubOR1 to !iubORn (!COUNT(F8.3,X)) '|'.
                  END IF.
               END IF.
            END IF.
            DO IF (ERROR=0).
               PRINT /'                  +'!QUOTE(!TABLE)'+'.
            END IF.
         END IF.

*        Print: MH Trend Test.
         !LET !BLANK=' '.
         !DO !I =4 !to !COUNT.
            !LET !BLANK=!CONCAT(!BLANK,'         ').
         !DOEND.
         !LET !SEP=' '.
         !LET !SEP2=' '.
         !DO !I =1 !to !COUNT.
            !IF (!I=3) !THEN.
               !LET !SEP='|'.
            !IFEND.
            !IF (!I=4) !THEN.
               !LET !SEP2='|'.
            !IFEND.
         !DOEND.
         DO IF (ERROR=0).
            PRINT /'   Test for Trend | Z =' X (F8.4) '  (p =' P(F7.5) ')' !QUOTE(!BLANK) !QUOTE(!SEP).
            PRINT /'        Corrected | Z =' XC (F8.4)'  (p =' PC(F7.5)')' !QUOTE(!BLANK) !QUOTE(!SEP).
            PRINT /'------------------+'!QUOTE(!TABLE)'+'.
         END IF.
      END IF.
      EXECUTE.

      DO IF (ERROR=0 AND $casenum=1).
*        Notes for Zero Correction.
         DO REPEAT ZeroCor=ZeroCor1 to !CONCAT('ZeroCor',!COUNT) /ZeroT=ZeroT1 to !ZeroTn.
            COMPUTE ZeroT=' '.
            IF (ZeroCor=1) ZeroT='*'.
         END REPEAT.
         IF (@RefType=1 OR @RefType=3) ZeroT1=' '.
         IF (@RefType=2 OR @RefType=4) !ZeroTn=' '.

*        Print ADJUSTED M-H results.
         PRINT /'     ADJUSTED M-H |'!QUOTE(!BLANKS(!LENGTH(!TABLE))) '|'.
         PRINT /@RefCat(A16) @Title4(A2) '|' !StMHprint '|'.
         DO IF (@SE=0).
            PRINT /'      ' @CL(F2) '% CI Lower|' lbStMH1 to !lbStMHn (!COUNT(F8.3,X)) '|'.
            PRINT /'             Upper|' ubStMH1 to !ubStMHn (!COUNT(F8.3,X)) '|'.
         ELSE.
            PRINT /'          SE(ln' @Title4(A2) ')|' SEStMH1 to !SEStMHn (!COUNT(F8.6,X)) '|'.
         END IF.
         DO IF (@iStMH=1).
            PRINT /'     Reciprocal ' @Title4(A2) '|' iStMH1 to !iStMHn (!COUNT(F8.3,X)) '|'.
            DO IF (@SE=0).
               PRINT /'      ' @CL(F2) '% CI Lower|' ilbStMH1 to !ilbStMHn (!COUNT(F8.3,X)) '|'.
               PRINT /'             Upper|' iubStMH1 to !iubStMHn (!COUNT(F8.3,X)) '|'.
            END IF.
         END IF.

*        Print Homogeneity results.
         PRINT /@Title4(A2) ' Homogeneity:   |' !QUOTE(!BLANKS(!LENGTH(!TABLE))) '|'.
         PRINT /' Wald        Chi2 |' !Chiprint    '|'.
         PRINT /'                p |' !pChiprint   '|'.
         DO IF (@CC=1 or @odds=1).
            PRINT /' Breslow-Day Chi2|' !ChiBDprint  '|'.
            PRINT /'                p |' !pChiBDprint '|'.
         END IF.
         PRINT /'                  +'!QUOTE(!TABLE)'+'.

*        Print trend test results.
         !LET !BLANK2='  '.
         !DO !I =5 !to !COUNT.
            !LET !BLANK2=!CONCAT(!BLANK2,'         ').
         !DOEND.
         PRINT /'   Test for Trend | Z =' XO (F8.4) '  (p =' pXO (F7.5) ')' !QUOTE(!BLANK) !QUOTE(!SEP).
         PRINT /'        Corrected | Z =' XOc(F8.4) '  (p =' pXOC(F7.5) ')' !QUOTE(!BLANK) !QUOTE(!SEP).
         PRINT /'   Homogeneity of | Chi2='  X2 (F6.2) '  (p =' pX2(F7.5) ')' !QUOTE(!BLANK) !QUOTE(!SEP).
         PRINT /'    Linear trends |   df=' dfX2 (F3) '                 ' !QUOTE(!BLANK) !QUOTE(!SEP).
*        PRINT /' Corrected trends | Chi2='  #XXC(F8.4)  '; df=' #dfXX (F2.0) '; (p=' #PXXC(F7.5)')' !QUOTE(!BLANK2) !QUOTE(!SEP2).
         PRINT /'------------------+'!QUOTE(!TABLE)'+'.
      END IF.
      EXECUTE.

      DO IF ($casenum=1 AND @ERROR=0).
         DO IF (@CC=1 or @odds=1).
            PRINT / 'Recommended method'.
         END IF.

         DO IF (WarnDec=1).
            PRINT/'(.)WARNING: Number of cases with decimal values'.
            PRINT/'            The values are printed rounded.'.
         END IF.
            
         DO IF (WarnZero=1 AND @Zero>0).
            DO IF (@Zero=1).
               PRINT /'(*)Computed with a constant continuity correction (k=0.5)'.
            ELSE IF (@Zero=2).
               PRINT /'(*)Computed with a proportional continuity correction'.
            ELSE IF (@Zero=3).
               PRINT /'(*)Computed with a reciprocal continuity correction'.
            END IF.
            DO IF (ERROR=0).
               PRINT /'   Exact inference is recommended'.
            END IF.
         END IF.
      END IF.
      
      DATASET ACTIVATE @original.
      DATASET CLOSE @9675DATA.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
