PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
  PRINT /'Macro !TCOI V2008.02.29 loaded.'
        /'Execute !TCOI HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !TCOI (LEXPO=!CHAREND('/') 
                 /A=!CHAREND('/') 
                 /T=!CHAREND('/')
                /CL=!CHAREND('/')!DEFAULT(95) 
                /RC=!CHAREND('/')!DEFAULT('F')
               /NST=!CHAREND('/')
              /HELP=!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2008.02.29').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
!LET !LEXPOMAX=11.
DO IF ($casenum=1).
   PRINT //'Macro !TCOI V' !VERSION ' (c)JM.Domenech & R.Granero'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*  Print HELP.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* TREND TEST (Cohort Incidence Study)                                        *'
            /'* Created 1999.10.25 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech & R.Granero                                                *'
            /'* Programmers: A.Bonillo & R.Sesma                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM, Granero R. Macro !TCOI for SPSS Statistics.                   *'
            /'*    Trend Test (Cohort Incidence Study) [computer program].                 *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* !TCOI LEXPO= Levels of exposure                 (LEXPO >= 0 )              *'
            /'*              The maximum number of levels is ' !QUOTE(!LEXPOMAX)          '*'78
            /'*        /A  = List of events                     (A >= 0)                   *'
            /'*        /T  = List of person-time                (Ti>= Ai)                  *'
            /'*       [/RC]= Reference category: F(First)   by default:F                   *'
            /'*                                  L(Last)                                   *'
            /'*                                  P(Previous)                               *'
            /'*                                  S(Subsequent)                             *'
            /'*       [/CL]= Confidence level(%) by default: 95 (CL >=50 and < 100)        *'
            /'*      [/NST]= Name of the study (Label)                                     *'
            /'*      [/HELP] Print Macro call arguments and Samples of calls               *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
            /'*                                                                            *'
            /'*                                       +-------------+--------------------+ *'
            /'*Samples of calls:                      |             |  Level of Exposure | *'
            /'*!TCOI HELP.                            |             |  0 |  1 | ... |  J | *'
            /'*!TCOI LEXPO=    0        1      2.5    +-------------+----+----+-----+----+ *'
            /'*       /A  =   82      140      150    | Cases       | A0 | A1 | ... | AJ | *'
            /'*       /T  =31966.37 49672.66 44112.19 | Person-Time | T0 | T1 | ... | TJ | *'
            /'*       /RC =F /NST="Study Name".       +-------------+----+----+-----+----+ *'
            /'******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Testing the parameters.
   !IF (!LEXPO=!NULL !or !A=!NULL !or !T=!NULL) !THEN 
      PRINT /'ERROR: Missing parameter'.
   !ELSE.
      COMPUTE #ERROR=0.
      COMPUTE #WARNDEC=0.
      COMPUTE #LEXPOMAX=!LEXPOMAX.
      COMPUTE #N=0.
      COMPUTE #j=0.
      COMPUTE #i=0.

*     Test LEXPO.
      DO REPEAT LEXPO=!LEXPO.
         COMPUTE #TEMP=$SYSMIS.
         COMPUTE #TEMP=LEXPO.
         DO IF (SYSMIS(#TEMP)).
            COMPUTE #ERROR=1.
         ELSE.
            IF (LEXPO<0) #ERROR=1.
         END IF.
         COMPUTE #N=#N+1.
      END REPEAT.

*     Test A.
      DO REPEAT A=!A.
         COMPUTE #TEMP=$SYSMIS.
         COMPUTE #TEMP=A.
         DO IF (SYSMIS(#TEMP)).
            COMPUTE #ERROR=1.
         ELSE.
            IF (MOD(A,1)<>0) #WARNDEC=1.
            IF (A<0) #ERROR=1.
         END IF.
         COMPUTE #i=#i+1.
      END REPEAT.

*     Test T.
      DO REPEAT T=!T /A=!A.
         COMPUTE #TEMP=$SYSMIS.
         COMPUTE #TEMP=T.
         DO IF (SYSMIS(#TEMP)).
            COMPUTE #ERROR=1.
         ELSE.
            IF (MOD(T,1)<>0) #WARNDEC=1.
            IF (T<=0 OR T<A) #ERROR=1.
         END IF.
         COMPUTE #j=#j+1.
      END REPEAT.

*     Test RC.
      !LET !RCU=!UPCASE(!RC).
      !IF (!RCU<>F !AND !RCU<>L !AND !RCU<>P !AND !RCU<>S) !THEN. 
         COMPUTE #ERROR=1.
      !IFEND.

*     Test parameter CL.
      COMPUTE #CL=$SYSMIS. 
      COMPUTE #CL = !CL.
      DO IF (SYSMIS(#CL)).
         COMPUTE #ERROR=1.
      ELSE.
         IF (#CL<50 or #CL>=100) #ERROR=1.
      END IF.

      IF (#N<>#i or #N<>#j) #ERROR=1.     /*Test number of elements.

*     Test maximum number of LEXPO.
      DO IF (#N>#LEXPOMAX).
         COMPUTE #ERROR=2.
      END IF.

      DO IF (#ERROR=1).
         PRINT /'ERROR: Parameter(s) with wrong values'.
      ELSE IF (#ERROR=2).
         PRINT /'ERROR: The number of levels of exposure is greater than ' !QUOTE(!LEXPOMAX).
      ELSE .
*        Correct parameters, compute and print results.
         COMPUTE #P = (#CL+100)/200.
         COMPUTE #Z=IDF.NORMAL(#P,0,1).

*        Count the number of elements.
         !LET !COUNT=!NULL.
         !LET !TABLE=!NULL.
         !LET !TABLE2=!NULL.
         !LET !TABLE3=!NULL.
         !LET !SEP=' '.
         !DO !I !IN (!LEXPO).
            !LET !COUNT=!CONCAT(!COUNT,' ').
            !LET !TABLE =!CONCAT(!TABLE, '---------').
            !LET !TABLE2 =!CONCAT(!TABLE2, '         ').
            !IF (!TABLE3<>!NULL) !THEN.
               !LET !TABLE3=!CONCAT(!TABLE3,'         ').
            !IFEND.
            !IF (!LENGTH(!COUNT)=3) !THEN.
               !LET !TABLE3=' '.
               !LET !SEP='|'.
            !IFEND.
         !DOEND.
         !LET !COUNT=!LENGTH(!COUNT).

*        Type of reference category (First=0,Last=1,Previous=2,Subsequent=3).
         !LET !TITLE=''.
         !IF (!RCU=F) !THEN.
            COMPUTE #RC=0.
            !LET !TITLE='to First level '.
         !ELSE.
            !IF (!RCU=L) !THEN.
               COMPUTE #RC=1.
               !LET !TITLE='to Last level  '.
            !ELSE.
               !IF (!RCU=P) !THEN.
                  COMPUTE #RC=2.
                  !LET !TITLE='to Prev. level '.
               !ELSE.
                  COMPUTE #RC=3.
                  !LET !TITLE='to Subs. level '.
               !IFEND.
            !IFEND.
         !IFEND.

         !LET !LEn=!CONCAT('#LE',!COUNT).
         !LET !An =!CONCAT('#A' ,!COUNT).
         !LET !Tn =!CONCAT('#T' ,!COUNT).
         NUMERIC #LE1 to !LEn #A1 to !An #T1 to !Tn.
         DO REPEAT LEXPO=!LEXPO /A=!A /T=!T /LEn=#LE1 to !LEn /An=#A1 to !An /Tn=#T1 to !Tn.
            COMPUTE An=A.
            COMPUTE Tn=T.
            COMPUTE LEn=LEXPO.

            COMPUTE #SA=#SA+LEXPO*A. 
            COMPUTE #SS=#SS+LEXPO*T.
         END REPEAT.
*        Sums of cases, total person-time.
         COMPUTE #M1 =SUM(#A1 to !An).
         COMPUTE #T  =SUM(#T1 to !Tn).
         COMPUTE #SS=#SS/#T.
         
*        Create the 'reference' A, T.
         !LET !ARFn =!CONCAT('#ARF' ,!COUNT).
         !LET !ARLn =!CONCAT('#ARL' ,!COUNT).
         !LET !ARSn =!CONCAT('#ARS' ,!COUNT).
         !LET !ARPn =!CONCAT('#ARP' ,!COUNT).
         !LET !TRFn =!CONCAT('#TRF' ,!COUNT).
         !LET !TRLn =!CONCAT('#TRL' ,!COUNT).
         !LET !TRSn =!CONCAT('#TRS' ,!COUNT).
         !LET !TRPn =!CONCAT('#TRP' ,!COUNT).
         NUMERIC #ARF1 to !ARFn #ARL1 to !ARLn #ARS1 to !ARSn #ARP1 to !ARPn
                 #TRF1 to !TRFn #TRL1 to !TRLn #TRS1 to !TRSn #TRP1 to !TRPn.
         COMPUTE #Aprev = $SYSMIS.
         COMPUTE #Tprev = $SYSMIS.
         DO REPEAT An=#A1 to !An /ARFn=#ARF1 to !ARFn /ARLn=#ARL1 to !ARLn /ARSn=#ARS1 to !ARSn /ARPn=#ARP1 to !ARPn
                  /Tn=#T1 to !Tn /TRFn=#TRF1 to !TRFn /TRLn=#TRL1 to !TRLn /TRSn=#TRS1 to !TRSn /TRPn=#TRP1 to !TRPn
                 /ASn=#A2 to !An #A1 /TSn=#T2 to !Tn #T1.
            COMPUTE ARFn=#A1.
            COMPUTE TRFn=#T1.
            COMPUTE ARLn=!An.
            COMPUTE TRLn=!Tn.
            COMPUTE ARSn=ASn.
            COMPUTE TRSn=TSn.
            COMPUTE ARPn=#Aprev.
            COMPUTE TRPn=#Tprev.
            COMPUTE #Aprev = An.
            COMPUTE #Tprev = Tn.
         END REPEAT.
         COMPUTE !ARSn = $SYSMIS.
         COMPUTE !TRSn = $SYSMIS.

*        Compute I,IR.
         !LET !ACn=!CONCAT('#AC',!COUNT).
         !LET !TCn=!CONCAT('#TC',!COUNT).
         !LET !IT=!CONCAT('#I',!COUNT).
         !LET !lbIn=!CONCAT('#lbI',!COUNT).
         !LET !ubIn=!CONCAT('#ubI',!COUNT).
         !LET !IRn=!CONCAT('#IR',!COUNT).
         !LET !lbIRn=!CONCAT('#lbIR',!COUNT).
         !LET !ubIRn=!CONCAT('#ubIR',!COUNT).
         NUMERIC #I1 to !IT #lbI1 to !lbIn #ubI1 to !ubIn #IR1 to !IRn #lbIR1 to !lbIRn #ubIR1 to !ubIRn.
         STRING #AC1 to !ACn (A9) #TC1 to !TCn (A9) #TDec(A1).
         COMPUTE #TDec = ' '.
         IF (#WARNDEC=1) #TDec='.'.
         DO REPEAT An=#A1 to !An /ARFn=#ARF1 to !ARFn /ARLn=#ARL1 to !ARLn /ARSn=#ARS1 to !ARSn /ARPn=#ARP1 to !ARPn
                  /Tn=#T1 to !Tn /TRFn=#TRF1 to !TRFn /TRLn=#TRL1 to !TRLn /TRSn=#TRS1 to !TRSn /TRPn=#TRP1 to !TRPn
                  /In=#I1 to !IT /lbIn=#lbI1 to !lbIn /ubIn=#ubI1 to !ubIn 
                  /IRn=#IR1 to !IRn /lbIRn=#lbIR1 to !lbIRn /ubIRn=#ubIR1 to !ubIRn
                  /ACn=#AC1 to !ACn /TCn=#TC1 to !TCn /LEXPO=!LEXPO.
            COMPUTE #A1n=An.         /*Get A1,T1 and the A0,T0 (reference level).
            IF (#RC=0) #A0n=ARFn.
            IF (#RC=1) #A0n=ARLn.
            IF (#RC=2) #A0n=ARPn.
            IF (#RC=3) #A0n=ARSn.
            COMPUTE #T1n=Tn.
            IF (#RC=0) #T0n=TRFn.
            IF (#RC=1) #T0n=TRLn.
            IF (#RC=2) #T0n=TRPn.
            IF (#RC=3) #T0n=TRSn.
            
            COMPUTE ACn = CONCAT(STRING(An,F8.0),#TDec).        /*Print parameters.
            COMPUTE TCn = CONCAT(STRING(Tn,F8.0),#TDec).

*           Compute I and exact bounds.
            COMPUTE In=#A1n/#T1n.
            COMPUTE lbIn = 0.
            COMPUTE ubIn = 1.
            IF (#A1n > 0)    lbIn= IDF.CHISQ(1-#P,2*#A1n)/(2*#T1n).
            IF (#A1n < #T1n) ubIn= IDF.CHISQ(#P,2*(#A1n+1))/(2*#T1n).

*           Compute IR and bounds of each exposure vs the reference category.
            COMPUTE IRn=In/(#A0n/#T0n).
            COMPUTE #SElnIR = SQR(1/#A1n+1/#A0n).
            COMPUTE lbIRn= IRn*EXP((-1)*#Z*#SElnIR).
            COMPUTE ubIRn= IRn*EXP(#Z*#SElnIR).

            COMPUTE #SLS2=#SLS2+#T1n*(LEXPO-#SS)**2.
         END REPEAT.
*        Corrections.
         IF (#RC=0 OR #RC=2) #ubIR1=$sysmis.
         IF (#RC=0 OR #RC=2) #lbIR1=$sysmis.
         IF (#RC=1 OR #RC=3) !ubIRn=$sysmis.
         IF (#RC=1 OR #RC=3) !lbIRn=$sysmis.

*        Total I and bounds.
         COMPUTE #IT=#M1/#T.
         COMPUTE #lbIRT = 0.
         COMPUTE #ubIRT = 1.
         IF (#M1 > 0)  #lbIRT= IDF.CHISQ(1-#P,2*#M1)/(2*#T).
         IF (#M1 < #T) #ubIRT= IDF.CHISQ(#P,2*(#M1+1))/(2*#T).

*        Tendency test and signification.
         COMPUTE #X=(#SA-#M1*#SS)/ SQRT(#M1/#T*#SLS2).
         COMPUTE #sX= 2*(1-cdfnorm(ABS(#X))).
     
*        Print results.
         PRINT /'TREND TEST (Cohort Incidence Study)'.
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.

         PRINT//'Level of Exposure |'#LE1 to !LEN (!COUNT(F8.2,X)) '|   TOTAL |'.
         PRINT /'------------------+'!QUOTE(!TABLE)'+---------+'.
         PRINT /'            Cases |'#AC1 to !ACn (!COUNT(A9)) '|' #M1(F8.0) #TDec(A1) '|'.
         PRINT /'      Person-Time |'#TC1 to !TCN (!COUNT(A9)) '|' #T (F8.0) #TDec(A1) '|'.
         PRINT /'------------------+'!QUOTE(!TABLE)'+---------+'.

         PRINT /'             RATE |' #I1 to !IT (!COUNT(F8.6,X)) '|' #IT(F8.6) . 
         PRINT /!QUOTE(!CL)6'% CI Lower |'8 #lbI1 to !lbIn (!COUNT(F8.6,X)) '|' #lbIRT(F8.6) .
         PRINT /'    (Exact) Upper |' #ubI1 to !ubIn (!COUNT(F8.6,X)) '|' #ubIRT(F8.6) .
         PRINT /'------------------+'!QUOTE(!TABLE) '+'.

         PRINT /'COMPARISONS       |'!QUOTE(!TABLE2)'|'.
         PRINT /!QUOTE(!TITLE) 'IR |'16 #IR1 to !IRn (!COUNT(F8.3,X)) '|'.
         PRINT /!QUOTE(!CL)6'% CI Lower |'8 #lbIR1 to !lbIRn (!COUNT(F8.3,X)) '|'.
         PRINT /'            Upper |' #ubIR1 to !ubIRn (!COUNT(F8.3,X)) '|'.
         PRINT /'------------------+'!QUOTE(!TABLE)'+'.

         PRINT /'MH Test for Trend | Z =' #X(F8.4) '  (p ='#sX(F7.5) ')' !QUOTE(!TABLE3) !QUOTE(!SEP) .
         PRINT /'------------------+'!QUOTE(!TABLE)'+'.

         DO IF (#WARNDEC=1).
            PRINT / '(.)WARNING: Number of Cases or Person-Time with decimal values.'.
            PRINT / '            The values are printed rounded.'.
         END IF.
     END IF.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
