PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !TCOR V2012.02.13 loaded.'
         /'Execute !TCOR HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !TCOR ( LEXPO =!CHAREND('/') 
             /VarExp =!CHAREND('/') /VarRes =!CHAREND('/') 
                  /A =!CHAREND('/') /B =!CHAREND('/') /N =!CHAREND('/') 
                /ST=!CHAREND('/')!DEFAULT('CO') 
                /CL=!CHAREND('/')!DEFAULT(95) 
                /RC=!CHAREND('/')!DEFAULT('F')
              /Zero=!CHAREND('/')!DEFAULT('N')
              /PrCI=!CHAREND('/')!DEFAULT('W')
               /NST=!CHAREND('/')
              /HELP=!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2012.02.13').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
!LET !WINDOW='HIDDEN'.
!LET !LEXPOMAX=11.
DO IF ($casenum=1).
   PRINT //'Macro !TCOR V' !VERSION ' (c)JM.Domenech'.
END IF.
!IF (!HELP<>1) !THEN.
*  Print HELP.
   DO IF ($casenum=1).
      PRINT /'********************************************************************************'
            /'* TREND TEST (Cumulative data)                                                 *'
            /'* Created 1999.10.25 Last revised ' !VERSION                                  '*'80
            /'* (c) JM.Domenech                                                              *'
            /'* Programmers: R.Sesma & A.Bonillo                                             *'
            /'*                                                                              *'
            /'* Vancouver reference:                                                         *'
            /'* Domenech JM. Macro !TCOR for SPSS Statistics.                                *'
            /'*    Trend Test (Cumulative data) [computer program].                          *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'80
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                     *'
            /'*                                                                              *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                                *'
            /'* Parameter for PRINTING MACRO DOCUMENTATION ----------------------------------*'
            /'*  !TCOR HELP.                                                                 *'
            /'*                                                                              *'
            /'* Parameters for INDIVIDUAL DATA ----------------------------------------------*'
            /'*  !TCOR VarExp(LEXPO)= Exposure variable and Levels of exposure (LEXPO >= 0)  *'
            /'*                       The maximum number of levels is ' !QUOTE(!LEXPOMAX)   '*'80
            /'*       /VarRes[(ValNonCase ValCase)]= Response variable and values for        *'
            /'*                                   NonCase, Case. By default: ValNonCase= 0   *'
            /'*                                                                 ValCase= 1   *'
            /'*                                                                              *'
            /'* Parameters for AGGREGATED DATA ----------------------------------------------*'
            /'*  !TCOR LEXPO = Levels of exposure (LEXPO >= 0 )                              *'
            /'*                The maximum number of levels is ' !QUOTE(!LEXPOMAX)          '*'80
            /'*           /A = List of Exposed Cases     (A >= 0)                            *'
            /'*          {/B = List of Exposed NonCases  (B >= 0)                            *'
            /'*        or /N}= List of Exposed TOTAL     (N > 0 and N >= A)                  *'
            /'*                                                                              *'
            /'* Parameters for BOTH TYPES OF DATA -------------------------------------------*'
            /'*         [/ST]= Study type: CO or CO(RR) or CO(OR) (Cohort)   by default: CO  *'
            /'*                            CS or CS(PR) or CS(OR) (Cross-Sectional)          *'
            /'*                            CC (Case-Control)                                 *'
            /'*                Note: (RR) (PR) (OR) specify the required statistic           *'
            /'*                by default: RR for CO study, PR for CS study, OR for CC study *'
            /'*         [/RC]= Reference category: F(First)    by default: F                 *'
            /'*                                    L(Last)                                   *'
            /'*                                    P(Previous)                               *'
            /'*                                    S(Subsequent)                             *'
            /'*         [/CL]= Confidence level(%) by default: 95     (CL >=50 and < 100)    *'
            /'*              = SE for printing Standard Error instead of Confidence Interval *'
            /'*       [/Zero]= OR continuity correction for cells with zero events:          *'
            /'*                N (None)                               by default: N          *'
            /'*                C (Constant, add k=0.5 to each cell)                          *'
            /'*                P (Proportional: add k1=N1/N and k0=N0/N) for CO & CS studies *'
            /'*                                 add k1=M1/N and k0=M0/N) for CC studies      *'
            /'*                R (Reciprocal: add k1=1/N0 and k0=1/N1) for CO & CS studies   *'
            /'*                               add k1=1/M0 and k0=1/M1) for CC studies        *'
            /'*       [/PrCI]= Method for compute CI of proportions:                         *'
            /'*                W  Wilson                           by default: W             *'
            /'*                E  Exact (Clopper-Pearson)                                    *'
            /'*                A  Asymptotic                                                 *'
            /'*        [/NST]= Name of the study (Label)                                     *'
            /'*                                                                              *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements   *'
            /'*                                                                              *'
            /'* Samples of calls:                    +--------+----------------------+-----+ *'
            /'* !TCOR HELP.                          |        |   Level of Exposure  |TOTAL| *'
            /'* !TCOR VarExp=Tabaco(0 5 15 30)       |        |  0 |  1 |  ...  |  J |     | *'
            /'*      /VarRes=Apgar(0 1) /RC=L /ST=CO.+--------+----+----+-------+----+-----+ *'
            /'* !TCOR LEXPO =   0   1   2  3.5   4   |Cases   | A0 | A1 |  ...  | AJ |  M1 | *'
            /'*          /A =  74  26  24   56   1   |NonCases| B0 | B1 |  ...  | BJ |  M0 | *'
            /'*          /N = 219  61  40   67   1   +--------+----+----+-------+----+-----+ *'
            /'*         /RC =F /ST=CO /CL=95 /Zero=P |   TOTAL| N0 | N1 |  ...  | NJ |  N  | *'
            /'*        /NST ="Name of the Study".    +--------+----+----+-------+----+-----+ *'
            /'********************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Test coherent parameters.
   !LET !ERROR=0.
   !IF (!VarExp=!NULL !AND !VarRes=!NULL !AND !A=!NULL !AND !LEXPO=!NULL) !THEN.
*     VarExp,VarResp,A,LEXPO missing.
      !LET !ERROR=1.
      !LET !ErrorText='VarExp,VarRes or A,LEXPO'.
   !IFEND.
   !IF (!ERROR=0 !AND ((!VarExp<>!NULL !OR !VarRes<>!NULL) !AND (!A<>!NULL !OR !B<>!NULL !OR !N<>!NULL !OR !LEXPO<>!NULL))) !THEN.
*     Error: too much parameters.
      !LET !ERROR=2.
   !IFEND.
   !IF (!VarExp<>!NULL !OR !VarRes<>!NULL) !THEN.
      !IF (!ERROR=0 !AND ((!VarExp<>!NULL !AND !VarRes=!NULL) !OR (!VarExp=!NULL !AND !VarRes<>!NULL))) !THEN.
*        VarExp or VarResp missing.
         !LET !ERROR=1.
         !LET !ErrorText='VarExp or VarRes'.
      !IFEND.
      !IF (!ERROR=0 !AND !Index(!VarExp,'(')=0) !THEN.
*        LEXPO missing.
         !LET !ERROR=1.
         !LET !ErrorText='LEXPO'.
      !IFEND.
  !ELSE.
      !IF (!ERROR=0 !AND (!LEXPO=!NULL !OR !A=!NULL)) !THEN.
*        A,LEXPO missing.
         !LET !ERROR=1.
         !LET !ErrorText='A or LEXPO'.
      !IFEND.
      !IF (!ERROR=0 !AND !B=!NULL !AND !N=!NULL) !THEN.
*        B,N missing.
         !LET !ERROR=1.
         !LET !ErrorText='B or N'.
      !IFEND.
      !IF (!ERROR=0 !AND !N<>!NULL !AND !B<>!NULL) !THEN.
*        Too much parameters: N and B.
         !LET !ERROR=4.
      !IFEND.
   !IFEND.
*  Test parameter ST.
   !LET !STU=!UPCASE(!ST).
   !IF (!ERROR=0 !AND !STU<>'CO' !AND !STU<>'CC' !AND !STU<>'CS' !AND !STU<>'CO(OR)' !AND 
                      !STU<>'CO(RR)' !AND !STU<>'CS(OR)' !AND !STU<>'CS(PR)') !THEN.
      !LET !ERROR=3.
      !LET !ErrorText='ST'.
   !IFEND.
*  Test parameter RC.
   !LET !RCU=!UPCASE(!RC).
   !IF (!ERROR=0 !AND !RCU<>'F' !AND !RCU<>'L' !AND !RCU<>'P' !AND !RCU<>'S') !THEN.
      !LET !ERROR=3.
      !LET !ErrorText='RC'.
   !IFEND.
*  Test parameter Zero.
   !LET !ZeroU=!UPCASE(!Zero).
   !IF (!ERROR=0 !AND !ZeroU<>'N' !AND !ZeroU<>'C' !AND !ZeroU<>'P' !AND !ZeroU<>'R') !THEN.
      !LET !ERROR=3.
      !LET !ErrorText='Zero'.
   !IFEND.
*  Test parameter PrCI.
   !LET !PrCIU=!UPCASE(!PrCI).
   !IF (!ERROR=0 !AND !PrCIU<>'W' !AND !PrCIU<>'E' !AND !PrCIU<>'A') !THEN.
      !LET !ERROR=3.
      !LET !ErrorText='PrCI'.
   !IFEND.
*  If necessary, print error messages.
   TEMPORARY.
   N 1.
   !IF (!ERROR=1) !THEN.
      PRINT /'ERROR: Parameter(s) ' !QUOTE(!ErrorText) ' missing. See the HELP.'.
   !IFEND.
   !IF (!ERROR=2) !THEN.
      PRINT /'ERROR: Too much parameters. Individual Data parameters are incompatible with'.
      PRINT /'       Aggregated Data parameters. See the HELP.'.
   !IFEND.
   !IF (!ERROR=3) !THEN.
      PRINT /'ERROR: Parameter(s) ' !QUOTE(!ErrorText) ' with wrong values. See the HELP.'.
   !IFEND.
   !IF (!ERROR=4) !THEN.
      PRINT /'ERROR: Too much parameters. Parameter B is incompatible with parameter N. See the HELP.'.
   !IFEND.
   EXECUTE.
   
   !IF (!ERROR=0) !THEN.
******CREATE @DATA DATASET.
*     Name the original dataset to restore and copy to the @work dataset.
*     WARNING: that overrides any existent dataset named @original.
      OMS /SELECT ALL /IF COMMANDS = ["Dataset Copy" "Dataset Name"] /DESTINATION   VIEWER = NO.
      DATASET NAME @original.
      OMSEND.

      !IF (!VarRes<>!NULL !AND !VarExp<>!NULL) !THEN.
*********INDIVIDUAL DATA: Create the @DATA dataset from the CROSSTABS.
*        VarExp contains the name and the Levels of the Exposure variable: VExp(LEXPO).
         !LET !Pos=!Index(!VarExp,'(').
*        Get the name of the variable.
         !LET !VExp=!SubStr(!VarExp,1,!Length(!SubStr(!Blanks(!Pos),2))).
*        Get LEXPO list.
         !LET !Values=!SubStr(!VarExp,!Length(!Concat(!Blanks(!Pos),' '))).
         !LET !Levels=!SubStr(!Values,1,!Length(!SubStr(!Blanks(!Length(!Values)),2))).

*        VarRes contains the name and the values of the Response variable: VResp(ValNonCase ValCase).
         !LET !Pos=!Index(!VarRes,'(').
         !IF (!Pos<>0) !THEN.
*           Get the name of the variable.
            !LET !VResp=!SubStr(!VarRes,1,!Length(!SubStr(!Blanks(!Pos),2))).
*           Read the values.
            !LET !Values=!SubStr(!VarRes,!Length(!Concat(!Blanks(!Pos),' '))).
            !LET !Values=!SubStr(!Values,1,!Length(!SubStr(!Blanks(!Length(!Values)),2))).
            !LET !COUNT=1.
            !DO !Val !IN (!Values).
               !IF (!COUNT=1) !THEN !LET !ValNonCase=!Val !IFEND.
               !IF (!COUNT=2) !THEN !LET !ValCase=!Val !IFEND.
               !LET !COUNT = !Length(!Concat(!Blanks(!COUNT),' ')).
            !DOEND.
         !ELSE.
*           VarRes contains only the name of the Response variable; ValNonCase and ValCase by default (0 1).
            !LET !VResp=!VarRes.
            !LET !ValCase=1.
            !LET !ValNonCase=0.
         !IFEND.

         DATASET COPY @9675work WINDOW=!WINDOW.
         DATASET ACTIVATE @9675work.
         
*        AUTORECODE, RECODE of the Exposure, Response variables to @Exp, @Resp variables.
         PRESERVE.
         SET ERRORS = NONE RESULTS = NONE MESSAGES = NONE PRINTBACK = NONE.
         AUTORECODE VARIABLES=!VExp /INTO @9675Exp.
         RESTORE.
         RECODE !VResp (MISSING=SYSMIS) (!ValCase=1) (!ValNonCase=0) (ELSE=SYSMIS) INTO @9675Resp.
         FORMATS @9675Exp @9675Resp (F1).
         EXECUTE.

*        Compute the CROSSTABS - Use OMS to redirect output tables to the @DATA, @CASE datasets.
         PRESERVE.
         SET OLANG=ENGLISH TNUMBERS=VALUES.
         DATASET DECLARE @9675DATA WINDOW=!WINDOW.
         OMS /SELECT ALL /IF COMMANDS = ["Crosstabs"] /DESTINATION VIEWER = NO.
         OMS /SELECT TABLES /IF COMMANDS = ["Crosstabs"] SUBTYPES = ["Crosstabulation"]
             /DESTINATION FORMAT = SAV NUMBERED = Num OUTFILE = @9675DATA .
         DATASET DECLARE @9675CASES WINDOW=!WINDOW.
         OMS /SELECT TABLES /IF COMMANDS = ["Crosstabs"]  SUBTYPES = ["Case Processing Summary"]
             /DESTINATION FORMAT = SAV NUMBERED = Num OUTFILE = @9675CASES.
         OMS /SELECT ALL /IF COMMANDS = ["Crosstabs"] /DESTINATION VIEWER = NO.
         CROSSTABS @9675Resp BY @9675Exp /FORMAT DVALUE /COUNT=ASIS.
         OMSEND.
         RESTORE.

*        Get the VarRes variable labels using FREQUENCIES + OMS.
         PRESERVE.
         SET OLANG=ENGLISH TNUMBERS=BOTH.
         OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION VIEWER = NO.
         DATASET DECLARE @9675DESCRIP WINDOW=!WINDOW.
         OMS /SELECT TABLES /IF COMMANDS = ["Frequencies"]  SUBTYPES = ["Frequencies"]
             /DESTINATION FORMAT = SAV NUMBERED = Num OUTFILE = @9675DESCRIP.
         OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION VIEWER = NO.
         FREQUENCIES !VResp.
         OMSEND.
         RESTORE.

*        COUNT= Number of Levels of Exposure .
         !LET !COUNT=''.
         !LET !Rename_old=''.
         !DO !I !IN(!Levels).
            !LET !COUNT = !CONCAT(!COUNT,' ').
            !LET !Rename_old= !CONCAT(!Rename_old,' @',!LENGTH(!COUNT)).
         !DOEND.
         !LET !COUNT=!LENGTH(!COUNT).
*        Prepare variables to create data.         
         !LET !Anames=''.
         !LET !Bnames=''.
         !LET !Nnames=''.
         !LET !Bcreate=''.
         !LET !Ncreate=''.
         !DO !I=1 !TO !COUNT.
            !LET !Anames= !CONCAT(!Anames,' A',!I).
            !LET !Bnames= !CONCAT(!Bnames,' B',!I).
            !LET !Nnames= !CONCAT(!Nnames,' N',!I).
            !LET !Bcreate= !CONCAT(!Bcreate,' /B',!I,'=LEAD(A',!I,' 1)').
            !LET !Ncreate= !CONCAT(!Ncreate,' /N',!I,'=LEAD(A',!I,' 2)').
         !DOEND.
         !LET !Rename_old= !CONCAT(!Rename_old,' Total').
         !LET !Rename_new= !CONCAT(!Anames,' M1').

*        Close @work dataset.
         DATASET ACTIVATE @9675DATA.
         DATASET CLOSE @9675work.

*        Keep interesting variables and rename.
         MATCH FILES FILE=* /RENAME=(!Rename_old = !Rename_new) /KEEP= !Rename_new.
         EXECUTE.

*        Use CREATE to compute B, N from A.
         OMS /SELECT ALL /IF COMMANDS = ["Create"] /DESTINATION VIEWER=NO.
         CREATE !Bcreate !Ncreate /M0=LEAD(M1,1) /N=LEAD(M1,2) .
         OMSEND.
         N 1.
         EXECUTE.

*        Compute LEXPO variables.
         !LET !COUNT=''.
         !LET !LEXPOnames = ''.
         !DO !I !IN(!Levels).
            !LET !COUNT = !CONCAT(!COUNT,' ').
            COMPUTE !CONCAT('LEXPO',!LENGTH(!COUNT)) = $SYSMIS.
            COMPUTE !CONCAT('LEXPO',!LENGTH(!COUNT)) = !I.
            !LET !LEXPOnames = !CONCAT(!LEXPOnames,' ',!CONCAT('LEXPO',!LENGTH(!COUNT))).
         !DOEND.
         !LET !COUNT=!LENGTH(!COUNT).
         COMPUTE NLevels=!COUNT.
         COMPUTE NLevelsMax=!LEXPOMAX.

*********GET VarRes VALUE LABELS.
*        Only Var2=@Descrip is interesting.
*        Erase the Total row.
         DATASET ACTIVATE @9675Descrip.
         MATCH FILES FILE=* /RENAME=(Var2=@Descrip) /KEEP=@Descrip.
         SELECT IF (@Descrip<>'Total').
         EXECUTE.
*        Get the Val, Descrip info from @Descrip (by default, F8 and A50 formats are suposed).
         COMPUTE @Pos = INDEX(@Descrip,' ').
         COMPUTE Val=NUMBER(SUBSTR(@Descrip,1,@Pos-1),F8).
         STRING Descrip(A50).
         COMPUTE Descrip=SUBSTR(@Descrip,@Pos+1).
*        If there are no value labels defined, the descrip is the value.
         DO IF (LENGTH(LTRIM(Descrip))=0).
            COMPUTE Descrip=@Descrip.
         END IF.
*        Add the ValCase, ValNonCase info.
         COMPUTE ValCase = !ValCase.
         COMPUTE ValNonCase = !ValNonCase.
         EXECUTE.
         
         DATASET ACTIVATE @9675DATA.
      !ELSE.
*********AGGREGATED DATA: Create the @DATA dataset from the A,B,N,LEXPO parameters.
*        Create @DATA: copy the active dataset, and keep only the first row.
         DATASET COPY @9675DATA WINDOW=!WINDOW.
         DATASET ACTIVATE @9675DATA.
         SPLIT FILE OFF.
         WEIGHT OFF.
         N 1.
         COMPUTE U=1.
         MATCH FILES FILE=* /KEEP=U.
         !LET !COUNT=''.
         !DO !I !IN(!LEXPO).
            !LET !COUNT = !CONCAT(!COUNT,' ').
            COMPUTE !CONCAT('LEXPO',!LENGTH(!COUNT)) = $SYSMIS.
            COMPUTE !CONCAT('LEXPO',!LENGTH(!COUNT)) = !I.
         !DOEND.
         !LET !COUNT=!LENGTH(!COUNT).
         COMPUTE NLevels=!COUNT.
         COMPUTE NLevelsMax=!LEXPOMAX.
         !LET !TEMP=''.
         !DO !I !IN(!A).
            !LET !TEMP = !CONCAT(!TEMP,' ').
            COMPUTE !CONCAT('A',!LENGTH(!TEMP)) = $SYSMIS.
            COMPUTE !CONCAT('A',!LENGTH(!TEMP)) = !I.
         !DOEND.
         NUMERIC B1 to !CONCAT('B',!COUNT) N1 to !CONCAT('N',!COUNT).
         !IF (!B<>!NULL) !THEN.
            !LET !TEMP=''.
            !LET !Bnames=''.
            !DO !I !IN(!B).
               !LET !TEMP = !CONCAT(!TEMP,' ').
               COMPUTE !CONCAT('B',!LENGTH(!TEMP)) = $SYSMIS.
               COMPUTE !CONCAT('B',!LENGTH(!TEMP)) = !I.
               COMPUTE !CONCAT('N',!LENGTH(!TEMP)) = !CONCAT('A',!LENGTH(!TEMP)) + !CONCAT('B',!LENGTH(!TEMP)) .
            !DOEND.
         !IFEND.
         !IF (!N<>!NULL) !THEN.
            !LET !TEMP=''.
            !DO !I !IN(!N).
               !LET !TEMP = !CONCAT(!TEMP,' ').
               COMPUTE !CONCAT('N',!LENGTH(!TEMP)) = $SYSMIS.
               COMPUTE !CONCAT('N',!LENGTH(!TEMP)) = !I.
               COMPUTE !CONCAT('B',!LENGTH(!TEMP)) = !CONCAT('N',!LENGTH(!TEMP)) - !CONCAT('A',!LENGTH(!TEMP)) .
            !DOEND.
         !IFEND.
         COMPUTE M1=SUM(A1 TO !CONCAT('A',!COUNT)).
         COMPUTE M0=SUM(B1 TO !CONCAT('B',!COUNT)).
         COMPUTE N=M1+M0.
         
         !LET !Anames=''.
         !LET !Bnames=''.
         !LET !Nnames=''.
         !LET !LEXPOnames=''.
         !DO !I=1 !TO !COUNT.
            !LET !Anames= !CONCAT(!Anames,' A',!I).
            !LET !Bnames= !CONCAT(!Bnames,' B',!I).
            !LET !Nnames= !CONCAT(!Nnames,' N',!I).
            !LET !LEXPOnames= !CONCAT(!LEXPOnames,' LEXPO',!I).
         !DOEND.
      !IFEND.

*     Confidence level.
      COMPUTE @CL=$SYSMIS.
      !IF (!UPCASE(!CL)='SE') !THEN.
         COMPUTE @CL = 95.
      !ELSE.
         COMPUTE @CL = !CL.
      !IFEND.
      COMPUTE @U=1.

******TEST NUMERIC PARAMETERS (and decimals): A B N @CL.
      COMPUTE @ERROR=0.
      COMPUTE @ERRtype=0.
      DO REPEAT A=!Anames /B=!Bnames /N=!Nnames /LEXPO=!LEXPOnames.
         DO IF (@ERROR=0).
            DO IF SYSMIS(A).
               COMPUTE @ERRtype=1.
            ELSE IF SYSMIS(B).
               COMPUTE @ERRtype=2.
            ELSE IF SYSMIS(N).
               COMPUTE @ERRtype=3.
            ELSE IF SYSMIS(LEXPO).
               COMPUTE @ERRtype=4.
            ELSE.
               DO IF (A<0).
                  COMPUTE @ERRtype=1.
               ELSE IF (B<0).
                  COMPUTE @ERRtype=2.
               ELSE IF (N<=0 OR N<A).
                  COMPUTE @ERRtype=3.
               ELSE IF (LEXPO<0).
                  COMPUTE @ERRtype=4.
               END IF.
            END IF.
            IF (@ERRtype>0) @ERROR=1.
         END IF.
      END REPEAT.
      DO IF (@ERROR=0).
         DO IF SYSMIS(@CL).
            COMPUTE @ERROR=1.
         ELSE.
            IF (@CL<50 OR @CL>=100) @ERROR=1.
         END IF.
         IF (@ERROR=1) @ERRtype=5.
      END IF.
      IF (Nlevels>NLevelsMax) @ERROR=2.

      !IF (!A<>!NULL) !THEN.
*        For AGGREGATED DATA call, correct ERRtype to display the correct error message.
         !IF (!B=!NULL) !THEN.
            IF (@ERRtype=2) @ERRtype=3.
         !ELSE.
            IF (@ERRtype=3) @ERRtype=2.
         !IFEND.
      !IFEND.
      DO IF (@ERROR=1 AND @ERRtype=1).
         PRINT /'ERROR: Parameter A with wrong values. See the HELP.'.
      ELSE IF (@ERROR=1 AND @ERRtype=2).
         PRINT /'ERROR: Parameter B with wrong values. See the HELP.'.
      ELSE IF (@ERROR=1 AND @ERRtype=3).
         PRINT /'ERROR: Parameter N with wrong values. See the HELP.'.
      ELSE IF (@ERROR=1 AND @ERRtype=4).
         PRINT /'ERROR: Parameter LEXPO with wrong values. See the HELP.'.
      ELSE IF (@ERROR=1 AND @ERRtype=5).
         PRINT /'ERROR: Parameter CL with wrong values. See the HELP.'.
      ELSE IF (@ERROR=2).
         PRINT /'ERROR: The number of levels of exposure is greater than ' !QUOTE(!LEXPOMAX).
      ELSE.
*        Print header.
         PRINT /'TREND TEST (Cumulative data)'.
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.
      END IF.
      EXECUTE.

*     Print Value Labels and Case Processing Summary (Individual Data).
      !IF (!VarRes<>!NULL !AND !VarExp<>!NULL) !THEN.
         DATASET ACTIVATE @9675Descrip.
*        Add @ERROR variable with the error information.
         COMPUTE @U=1.
         MATCH FILES FILE=* /TABLE=@9675DATA /BY @U 
            /KEEP=Val Descrip ValNonCase ValCase @ERROR.
         EXECUTE.

*        EXPOSURE variable, unexposed and exposed values.
         DO IF ($casenum=1 AND @ERROR=0).
            PRINT //'EXPOSURE variable: ' !QUOTE(!VExp).
         END IF.
         EXECUTE.
   
*        RESPONSE variable, NonCases and Cases values.
         DO IF ($casenum=1 AND @ERROR=0).
            PRINT //'RESPONSE variable: ' !QUOTE(!VResp).
         END IF.
         EXECUTE.
         DO IF (Val=ValNonCase AND @ERROR=0).
            PRINT /'         NonCases: ' Descrip.
         END IF.
         EXECUTE.
         DO IF (Val=ValCase AND @ERROR=0).
            PRINT /'            Cases: ' Descrip.
         END IF.
         EXECUTE.

*        Case Processing Summary.
         DATASET ACTIVATE @9675CASES.
         COMPUTE @U=1.
         MATCH FILES FILE=* /TABLE=@9675DATA /BY @U 
            /KEEP=Valid_N Valid_Percent Total_N @ERROR.
         EXECUTE.
         DO IF (@ERROR=0).
            PRINT //'Valid cases=' Valid_N(F6) '(' Valid_Percent(PCT6.1) ')'.
            PRINT  /'Total cases=' Total_N(F6).
         END IF.
         EXECUTE.
   
         DATASET ACTIVATE @9675DATA.
         DATASET CLOSE @9675Descrip.
         DATASET CLOSE @9675CASES.
      !IFEND.

      DO IF (@ERROR=0).
*        CI compute method (PrCI): W (Wilson) = 1 - default; E (Exact) = 2; A (Asymptotic) = 3.
         COMPUTE @PrCI=0.
         IF (!QUOTE(!PrCIU)='W') @PrCI=1.
         IF (!QUOTE(!PrCIU)='E') @PrCI=2.
         IF (!QUOTE(!PrCIU)='A') @PrCI=3.
*        @RefType= 1 - RC=F; 2 - RC=L; 3 - RC=P; 4 - RC=S;
         COMPUTE @RefType=0.
         IF (!QUOTE(!RCU)='F') @RefType = 1.
         IF (!QUOTE(!RCU)='L') @RefType = 2.
         IF (!QUOTE(!RCU)='P') @RefType = 3.
         IF (!QUOTE(!RCU)='S') @RefType = 4.
*        Type of continuity correction: 1 - Constant; 2 - Proportional; 3 - Reciprocal.
         COMPUTE @ZERO=0.
         IF (!QUOTE(!ZeroU)='C') @ZERO=1.
         IF (!QUOTE(!ZeroU)='P') @ZERO=2.
         IF (!QUOTE(!ZeroU)='R') @ZERO=3.
*        CC=1 -> ST=CC.
         COMPUTE @CC=0.
         IF (!QUOTE(!STU)='CC') @CC=1.

         COMPUTE @P = (@CL+100)/200.
         COMPUTE @Z=IDF.NORMAL(@P,0,1).
         
*        Create the 'reference' A, B.
         !LET !Arefn =!CONCAT('Aref' ,!COUNT).
         !LET !Brefn =!CONCAT('Bref' ,!COUNT).
         !LET !An =!CONCAT('A' ,!COUNT).
         !LET !Bn =!CONCAT('B' ,!COUNT).
         !LET !Nn =!CONCAT('N' ,!COUNT).
         NUMERIC Aref1 to !Arefn Bref1 to !Brefn.
         COMPUTE #Aprev = $SYSMIS.
         COMPUTE #Bprev = $SYSMIS.
         DO REPEAT A=A1 to !An /B=B1 to !Bn /Aref=Aref1 to !Arefn /Bref=Bref1 to !Brefn /Anext=A2 to !An A1 /Bnext=B2 to !Bn B1.
            IF (@RefType=1) Aref=A1.
            IF (@RefType=1) Bref=B1.
            IF (@RefType=2) Aref=!An.
            IF (@RefType=2) Bref=!Bn.
            IF (@RefType=3) Aref=#Aprev.
            IF (@RefType=3) Bref=#Bprev.
            IF (@RefType=4) Aref=Anext.
            IF (@RefType=4) Bref=Bnext.
            COMPUTE #Aprev = A.
            COMPUTE #Bprev = B.
         END REPEAT.
         IF (@RefType=4) !Arefn = $SYSMIS.
         IF (@RefType=4) !Brefn = $SYSMIS.

*        Compute Risk, Odds.
         !LET !Rn =!CONCAT('R' ,!COUNT).
         !LET !lbRn =!CONCAT('lbR' ,!COUNT).
         !LET !ubRn =!CONCAT('ubR' ,!COUNT).
         !LET !SERn =!CONCAT('SER' ,!COUNT).
         !LET !RRn =!CONCAT('RR' ,!COUNT).
         !LET !lbRRn =!CONCAT('lbRR' ,!COUNT).
         !LET !ubRRn =!CONCAT('ubRR' ,!COUNT).
         !LET !SElnRRn =!CONCAT('SElnRR' ,!COUNT).
         !LET !On =!CONCAT('O' ,!COUNT).
         !LET !ORn =!CONCAT('OR' ,!COUNT).
         !LET !lbORn =!CONCAT('lbOR' ,!COUNT).
         !LET !ubORn =!CONCAT('ubOR' ,!COUNT).
         !LET !SElnORn =!CONCAT('SElnOR' ,!COUNT).
         !LET !Zeron =!CONCAT('@TZero' ,!COUNT).
         COMPUTE @WarnZero= 0.
         COMPUTE @WarnCIA=0.
         STRING @TZero1 to !Zeron(A1).
         NUMERIC R1 to !Rn lbR1 to !lbRn ubR1 to !ubRn SER1 to !SERn RR1 to !RRn lbRR1 to !lbRRn ubRR1 to !ubRRn SElnRR1 to !SElnRRn
                 O1 to !On OR1 to !ORn lbOR1 to !lbORn ubOR1 to !ubORn SElnOR1 to !SElnORn.
         DO REPEAT A=A1 to !An /B=B1 to !Bn /Aref=Aref1 to !Arefn /Bref=Bref1 to !Brefn /Tzero=@TZero1 to !Zeron
                  /R=R1 to !Rn /lbR=lbR1 to !lbRn /ubR=ubR1 to !ubRn /SER=SER1 to !SERn /O=O1 to !On
                 /RR=RR1 to !RRn /lbRR=lbRR1 to !lbRRn /ubRR=ubRR1 to !ubRRn /SElnRR=SElnRR1 to !SElnRRn
                /ORn=OR1 to !ORn /lbOR=lbOR1 to !lbORn /ubOR=ubOR1 to !ubORn /SElnOR=SElnOR1 to !SElnORn.

*           A1,B1,A0,B0 for each level.
            COMPUTE @A1= A.
            COMPUTE @B1= B.
            COMPUTE @A0= Aref.
            COMPUTE @B0= Bref.

*           Continuity correction.
            COMPUTE TZero= ' '.
            DO IF (@ZERO>0 AND (@A1=0 OR @B1=0 OR @A0=0 OR @B0=0)).
               COMPUTE @WarnZero= 1.
               COMPUTE TZero= '*'.
               COMPUTE #M1=@A0+@A1.
               COMPUTE #M0=@B0+@B1.
               COMPUTE #N1=@A1+@B1.
               COMPUTE #N0=@A0+@B0.
               COMPUTE #N=#N0+#N1.
               
               IF (@ZERO=1) @K1=0.5.
               IF (@ZERO=1) @K0=0.5.
               IF (@ZERO=2 AND @CC=0) @K1=#N1/#N.
               IF (@ZERO=2 AND @CC=0) @K0=#N0/#N.
               IF (@ZERO=2 AND @CC=1) @K1=#M1/#N.
               IF (@ZERO=2 AND @CC=1) @K0=#M0/#N.
               IF (@ZERO=3 AND @CC=0) @K1=1/#N0.
               IF (@ZERO=3 AND @CC=0) @K0=1/#N1.
               IF (@ZERO=3 AND @CC=1) @K1=1/#M0.
               IF (@ZERO=3 AND @CC=1) @K0=1/#M1.

               DO IF (@CC=0).
                  COMPUTE @A1=@A1+@K1.
                  COMPUTE @B1=@B1+@K1.
                  COMPUTE @A0=@A0+@K0.
                  COMPUTE @B0=@B0+@K0.
               ELSE IF (@CC=1).
                  COMPUTE @A1=@A1+@K1.
                  COMPUTE @A0=@A0+@K1.
                  COMPUTE @B1=@B1+@K0.
                  COMPUTE @B0=@B0+@K0.
               END IF.
            END IF.

*           RISK.
            COMPUTE #N1=(@A1+@B1).
            COMPUTE R = @A1/#N1.
*           Risk CI.
            COMPUTE SER= SQR(R*(1-R)/#N1).
            DO IF (@PrCI=1).      /*Wilson bounds.
               COMPUTE #WA = 2*@A1 + @Z**2.
               COMPUTE #WB = @Z * SQRT(@Z**2 + 4*@A1*(#N1-@A1)/#N1).
               COMPUTE #WC = 2*(#N1 + @Z**2).
               COMPUTE lbR= (#WA-#WB)/#WC.
               COMPUTE ubR= (#WA+#WB)/#WC.
            ELSE IF (@PrCI=2).    /*Exact bounds.
               COMPUTE lbR= 0.
               COMPUTE ubR= 1.
               IF (@A1 > 0)  lbR= @A1/(@A1+(#N1-@A1+1)*IDF.F(@P,2*(#N1-@A1+1),2*@A1)).
               IF (#N1 > @A1) ubR=(@A1+1)/((@A1+1)+((#N1-@A1)/IDF.F(@P,2*(@A1+1),2*(#N1-@A1)))).               
            ELSE IF (@PrCI=3).    /*Asymptotic bounds.
               COMPUTE ubR = R + @Z*SER.
               COMPUTE lbR = R - @Z*SER.
               IF (ubR>1 OR lbR<0) @WarnCIA=1.
            END IF.
*           RR: RISK RATIO of each exposure vs the reference category.
            COMPUTE #N0=(@A0+@B0).
            COMPUTE RR=R/(@A0/#N0).
*           Risk ratio CI.
            COMPUTE SElnRR = SQR(1/@A0-1/#N0+1/@A1-1/#N1).
            COMPUTE lbRR= EXP(LN(RR)-(@Z*SElnRR)).
            COMPUTE ubRR= EXP(LN(RR)+(@Z*SElnRR)).

*           ODDS.
            COMPUTE O=@A1/@B1.
*           OR: ODDS RATIO of each exposure vs the reference category.
            COMPUTE ORn=O/(@A0/@B0).
*           Odds ratio CI.
            COMPUTE SElnOR=SQR(1/@A0+1/@B0+1/@A1+1/@B1).
            COMPUTE lbOR= EXP(LN(ORn)-(@Z*SElnOR)).
            COMPUTE ubOR= EXP(LN(ORn)+(@Z*SElnOR)).
         END REPEAT.
*        Corrections.
         DO IF ANY(@RefType,1,3).
            COMPUTE ubRR1 = $SYSMIS.
            COMPUTE lbRR1 = $SYSMIS.
            COMPUTE SElnRR1 = $SYSMIS.
            COMPUTE ubOR1 = $SYSMIS.
            COMPUTE lbOR1 = $SYSMIS.
            COMPUTE SElnOR1 = $SYSMIS.
         ELSE IF ANY(@RefType,2,4).
            COMPUTE !ubRRn = $SYSMIS.
            COMPUTE !lbRRn = $SYSMIS.
            COMPUTE !SElnRRn = $SYSMIS.
            COMPUTE !ubORn = $SYSMIS.
            COMPUTE !lbORn = $SYSMIS.
            COMPUTE !SElnORn = $SYSMIS.
         END IF.
         DO IF (@WarnZero=1).
            IF (@RefType=3) @TZero1=' '.
            IF (@RefType=4) !Zeron=' '.
         END IF.
        
*        Total RISK & CI.
         COMPUTE RT=M1/N.
         COMPUTE SERT= SQR(RT*(1-RT)/N).
         DO IF (@PrCI=1).      /*Wilson bounds*/.
            COMPUTE #WA = 2*M1 + @Z**2.
            COMPUTE #WB = @Z * SQRT(@Z**2 + 4*M1*(N-M1)/N).
            COMPUTE #WC = 2*(N + @Z**2).
            COMPUTE lbRT= (#WA-#WB)/#WC.
            COMPUTE ubRT= (#WA+#WB)/#WC.
         ELSE IF (@PrCI=2).    /*Exact bounds*/.
            COMPUTE lbRT= 0.
            COMPUTE ubRT= 1.
            IF (M1 > 0) lbRT= M1/(M1+(N-M1+1)*IDF.F(@P,2*(N-M1+1),2*M1)).
            IF (N > M1) ubRT= (M1+1)/(M1+1 +(N-M1)/IDF.F(@P,2*(M1+1),2*(N-M1))).
         ELSE IF (@PrCI=3).    /*Asymptotic bounds*/.
            COMPUTE ubRT = RT + @Z*SERT.
            COMPUTE lbRT = RT - @Z*SERT.
            IF (ubRT>1 OR lbRT<0) WarnCIA=1.
         END IF.
*        Total ODDS.
         COMPUTE OT=M1/M0.

*        Trend test and signification.
         !LET !LEXPOn= !CONCAT('LEXPO',!COUNT).
         COMPUTE #SA=0.
         COMPUTE #SS=0.
         DO REPEAT LEXPO=LEXPO1 to !LEXPOn /A=A1 to !An /N=N1 to !Nn.
            COMPUTE #SA=#SA+LEXPO*A. 
            COMPUTE #SS=#SS+LEXPO*N.
         END REPEAT.
         COMPUTE #SS=#SS/N.
         COMPUTE #SLS2=0.
         DO REPEAT LEXPO=LEXPO1 to !LEXPOn /N=N1 to !Nn.
            COMPUTE #SLS2=#SLS2+N*(LEXPO-#SS)**2.
         END REPEAT.
         COMPUTE X=(#SA-M1*#SS)/ SQRT(M1*M0*#SLS2/(N**2-N)).
         COMPUTE P=2*(1-cdfnorm(ABS(X))).

*        Detect decimal parameters.
         COMPUTE @WarnDec= 0.
         !LET !Decn = !CONCAT('@Dec',!COUNT).
         STRING @Dec1 to !Decn (A1).
         DO REPEAT A=A1 to !An /B=B1 to !Bn /N=N1 to !Nn /Dec=@Dec1 to !Decn.
            COMPUTE Dec=' '.
            DO IF (MOD(A,1)<>0 OR MOD(B,1)<>0 OR MOD(N,1)<>0).
               COMPUTE @WarnDec=1.
               COMPUTE Dec='.'.
            END IF.
         END REPEAT.
*        Auxiliary macro variables to print.
         !LET !Aprint=''.
         !LET !Bprint=''.
         !LET !Nprint=''.
         !LET !Rprint=''.
         !LET !RRprint=''.
         !LET !Oprint=''.
         !LET !ORprint=''.
         !LET !TABLE =''.
         !DO !I=1 !TO !COUNT.
            !LET !Aprint= !CONCAT(!Aprint,' A',!I,'(F8.0) @Dec',!I,'(A1)').
            !LET !Bprint= !CONCAT(!Bprint,' B',!I,'(F8.0) @Dec',!I,'(A1)').
            !LET !Nprint= !CONCAT(!Nprint,' N',!I,'(F8.0) @Dec',!I,'(A1)').
            !LET !Rprint= !CONCAT(!Rprint,' R',!I,'(F8.6) @TZero',!I,'(A1)').
            !LET !RRprint= !CONCAT(!RRprint,' RR',!I,'(F8.3) @TZero',!I,'(A1)').
            !LET !Oprint= !CONCAT(!Oprint,' O',!I,'(F8.3) @TZero',!I,'(A1)').
            !LET !ORprint= !CONCAT(!ORprint,' OR',!I,'(F8.3) @TZero',!I,'(A1)').
            !LET !TABLE =!CONCAT(!TABLE, '---------').
         !DOEND.
*        Auxiliary variables to print.
         STRING @CItype (A12).
         IF (!QUOTE(!PrCIU)='W') @CItype = '    (Wilson)'.
         IF (!QUOTE(!PrCIU)='E') @CItype = '     (Exact)'.
         IF (!QUOTE(!PrCIU)='A') @CItype = '(Asymptotic)'.
         COMPUTE @SE=0.
         IF (!QUOTE(!CL)='SE') @SE = 1.
         !LET !TEMP=!SUBSTR(!STU,1,2).
         COMPUTE @type=0.
         IF (!QUOTE(!TEMP)='CO') @type = 1.
         IF (!QUOTE(!TEMP)='CS') @type = 2.
         COMPUTE @odds=0.
         IF (!QUOTE(!STU)='CO(OR)' OR !QUOTE(!STU)='CS(OR)') @odds = 1.
         STRING @Title (A10) @Title2 (A2) @Title3 (A8) @RefCat(A16).
         COMPUTE @Title='      RISK'.
         COMPUTE @Title2='RR'.
         COMPUTE @Title3='SEln(RR)'.
         IF (@type=2) @Title = 'PREVALENCE'.
         IF (@type=2) @Title2= 'PR'.
         IF (@type=2) @Title3= 'SEln(PR)'.
         IF (@RefType=1) @RefCat = 'RC:First level  '.
         IF (@RefType=2) @RefCat = 'RC:Last level   '.
         IF (@RefType=3) @RefCat = 'RC:Prev. level  '.
         IF (@RefType=4) @RefCat = 'RC:Subs. level  '.
      END IF.

******PRINT RESULTS.
      DO IF (@ERROR=0).
*        Print table.
         PRINT //'Level of Exposure |'LEXPO1 to !LEXPOn (!COUNT(F8.2,X)) '|   TOTAL |'.
         PRINT  /'------------------+'!QUOTE(!TABLE)'+---------+'.
         PRINT  /'            Cases |' !Aprint '|' M1(F8.0) !Decn(A1) '|'.
         !IF (!STU = 'CC') !THEN.
            PRINT  /'         Controls |' !Bprint '|' M0(F8.0) !Decn(A1) '|'.
         !ELSE.
            PRINT  /'          NoCases |' !Bprint '|' M0(F8.0) !Decn(A1) '|'.
         !IFEND.
         PRINT  /'                  +'!QUOTE(!TABLE)'+---------+'.
         PRINT  /'            TOTAL |' !Nprint '|' N(F8.0) !Decn(A1) '|'.
         PRINT  /'------------------+'!QUOTE(!TABLE) '+---------+'.

*        Print statistic.
         DO IF (@CC=0).
            PRINT / '       ' @Title(A10) ' |' !Rprint '|' RT(F8.6).
            DO IF (@odds=0).
               DO IF (@SE=0).
                  PRINT / '      ' @CL(F2) '% CI Lower|' lbR1 to !lbRn (!COUNT(F8.6,X)) '|' lbRT(F8.6) .
                  PRINT /         @CItype(A12) ' Upper|' ubR1 to !ubRn (!COUNT(F8.6,X)) '|' ubRT(F8.6) .
               ELSE.
                  PRINT / '    Asymptotic SE |' SER1 to !SERn (!COUNT(F8.6,X)) '|' SERT(F8.6) .
               END IF.
            ELSE.
               PRINT / '             ODDS |' !Oprint '|' OT(F8.3).
            END IF.
         ELSE.
            PRINT / '      Pseudo-ODDS |' !Oprint '|' OT(F8.3).
         END IF.
         PRINT / '                  +' !QUOTE(!TABLE) '+'.

*        Print ratio of each category versus the reference category.
         DO IF (@CC=0 AND @odds=0).
            PRINT / @RefCat(A16)  @Title2(A2) '|' !RRprint '|'.
            DO IF (@SE=0).
               PRINT / '      ' @CL(F2) '% CI Lower|' lbRR1 to !lbRRn (!COUNT(F8.3,X)) '|'.
               PRINT / '             Upper|' ubRR1 to !ubRRn (!COUNT(F8.3,X)) '|'.
            ELSE.
               PRINT / '          ' @Title3(A8) '|' SElnRR1 to !SElnRRn (!COUNT(F8.3,X)) '|'.
            END IF.
         ELSE.
            PRINT / @RefCat(A16) 'OR|' !ORprint '|'.
            DO IF (@SE=0).
               PRINT /'      ' @CL(F2) '% CI Lower|' lbOR1 to !lbORn (!COUNT(F8.3,X)) '|'.
               PRINT /'             Upper|' ubOR1 to !ubORn (!COUNT(F8.3,X)) '|'.
            ELSE.
               PRINT /'          SEln(OR)|' SElnOR1 to !SElnORn (!COUNT(F8.3,X)) '|'.
            END IF.
         END IF.
         PRINT / '------------------+' !QUOTE(!TABLE) '+'.
*        Print: MH Trend Test.
         !LET !BLANK=' '.
         !DO !I =4 !to !COUNT.
            !LET !BLANK=!CONCAT(!BLANK,'         ').
         !DOEND.
         !LET !SEP=' '.
         !DO !I =1 !to !COUNT.
            !IF (!I=3) !THEN.
               !LET !SEP='|'.
            !IFEND.
         !DOEND.
         PRINT /'MH Test for Trend | Z =' X (F8.4) '  (p =' P(F7.5) ')' !QUOTE(!BLANK) !QUOTE(!SEP).
         PRINT /'------------------+'!QUOTE(!TABLE)'+'.

*        Print: warnings.
         DO IF (@WarnDEC=1).
            PRINT / '(.)WARNING: Number of cases with decimal values'.
            PRINT / '            The values are printed rounded.'.
         END IF.

         DO IF (@WarnZero=1 AND @Zero>0).
            DO IF (@ZERO=1).
               PRINT /'(*)Computed with a constant continuity correction (k=0.5)'.
            ELSE IF (@ZERO=2).
               PRINT /'(*)Computed with a proportional continuity correction'.
            ELSE IF (@ZERO=3).
               PRINT /'(*)Computed with a reciprocal continuity correction'.
            END IF.
            PRINT /'   Exact inference is recommended'.
         END IF.

         DO IF (@WarnCIA=1 AND @SE=0).
            PRINT /'WARNING: Asymptotic CI out of range'.
         END IF.
      END IF.
      
*     Restore original dataset and close temporary dataset @DATA.
      DATASET ACTIVATE @original.
      DATASET CLOSE @9675DATA.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
