PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !MisExa V2009.10.30 loaded.'
         /'Execute !MisExa HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !MisExa (VL =!CHAREND('/') /ID=!CHAREND('/') !DEFAULT(CASE) 
              /NST =!CHAREND('/')
              /HELP=!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132.
!LET !VERSION=!QUOTE('2009.10.30').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
+   PRINT //'Macro !MisExa V' !VERSION ' (c) JM.Domenech'.
END IF.

!IF (!HELP<>1) !THEN.
*Impresin de la documentacin.
+  DO IF ($casenum=1).
+    PRINT /'******************************************************************************'
           /'* EXAMINE VARIABLES TO ENTER IN REGRESSIONS MODELS                           *'
           /'* Created 1999.01.25 Last revised ' !VERSION                                '*'78
           /'* (c) JM.Domenech                                                            *'
           /'* Programmers: A.Bonillo & R.Sesma                                           *'
           /'*                                                                            *'
           /'* Vancouver reference:                                                       *'
           /'* Domenech JM. Macro !MisExa for SPSS Statistics.                            *'
           /'*    Examine Variables to Enter in Regressions Models [computer program].    *'
           /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
           /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
           /'*                                                                            *'
           /'* Macro Call (tested for SPSS 15.0 and higher):                              *' 
           /'* !MisExa VL= List of variables to examine                                   *'
           /'*         ID= Name of case identification variable        (by default, CASE) *'
           /'*     [/NST]= Name of the study (Label)                                      *'
           /'*     [/HELP] Print Macro call arguments and Samples of calls                *'
           /'*                                                                            *'
           /'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
           /'*                                                                            *'
           /'* Samples of calls:                                                          *'
           /'* !MisExa HELP.                                                              *'
           /'* !MisExa VL=Size Smoke Tobacco Age /ID=Case /NST="Name of the Study".       *'
           /'******************************************************************************'.
+  END IF.
EXECUTE.
*Testing the parameters.
!ELSE.
+ !IF (!VL=!NULL) !THEN
+   TEMPORARY.
+     N 1.
+     PRINT /'ERROR: Missing parameter'.
+     EXECUTE.
+ !ELSE
+   COUNT @TotalMis = !VL (MISSING).
+   VARIABLE LABELS @TotalMis 'Total Missing values by Subject'.
+   FORMATS @TotalMis (F4).

    !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
       DO IF ($CASENUM=1).
          STRING #NST (A131).
          COMPUTE #NST = CONCAT('STUDY: ',!NST).
          PRINT /#NST.
       END IF.
    !IFEND.

+   DESCRIPTIVES VARIABLES=!VL  /STATISTICS=MEAN STDDEV MIN MAX /MISSING=VARIABLES.
+   DESCRIPTIVES VARIABLES=!VL  /STATISTICS=MEAN STDDEV MIN MAX /MISSING=LISTWISE.

+   FREQUENCIES VARIABLES= @TotalMis.

+   TEMPORARY.
+     RECODE !VL (MISSING=1) (ELSE=0).
+     FORMATS !VL (F1).
+     DESCRIPTIVES VARIABLES= @totalmis !VL /STATISTICS MEAN SUM.

+   TEMPORARY.
+      SELECT IF (@TotalMis > 0).
+      LIST !ID @TotalMis.
+ !IFEND.
!IFEND.
RESTORE.
!ENDDEFINE.
RESTORE.