PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
  PRINT /'Macro !CI2IP V2008.02.29 loaded.'
        /'Execute !CI2IP HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !CI2IP (A1=!CHAREND('/')
              /B1=!CHAREND('/')
              /N1=!CHAREND('/')
              /M1=!CHAREND('/')
              /A0=!CHAREND('/')
              /B0=!CHAREND('/')
              /N0=!CHAREND('/')
              /M0=!CHAREND('/')
               /R=!CHAREND('/')
              /PE=!CHAREND('/')
            /Zero=!CHAREND('/')!DEFAULT('N') 
            /PrCI=!CHAREND('/')!DEFAULT('W') 
              /CL=!CHAREND('/')!DEFAULT('95')
              /ST=!CHAREND('/')!DEFAULT('CS') 
             /NST=!CHAREND('/')
            /HELP=!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132.
!LET !VERSION=!QUOTE('2008.02.29').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
   PRINT //'Macro !CI2IP V' !VERSION ' (c)JM.Domenech & R.Granero'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*  Print the help.
   DO IF ($casenum=1).
      PRINT /'********************************************************************************'
            /'* CONFIDENCE INTERVALS FOR MEASURES OF ASSOCIATION                             *'
            /'* 2x2 Table (Independent samples)                                              *'
            /'* Created 1999.03.05 Last revised ' !VERSION                                  '*'80
            /'* (c) JM.Domenech & R.Granero                                                  *'
            /'* Programmer: R.Sesma                                                          *'
            /'*                                                                              *'
            /'* Vancouver reference:                                                         *'
            /'* Domenech JM, Granero R. Macro !CI2IP for SPSS Statistics.                    *'
            /'*    Confidence Intervals for Measures of Association: 2x2 Table               *'
            /'*    (Independent samples) [computer program].                                 *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'80
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                     *'
            /'*                                                                              *'
            /'* Macro call for Experimental, Cohort Study or Cross-sectional:                *'
            /'* !CI2IP A1 = Events in group 1 (Exposed)              (A1 >= 0)               *'
            /'*      {/B1 = NonEvents in group 1                     (B1 >= 0)               *'
            /'*    or /N1}= Size of group 1                          (N1 >= A1 and > 0)      *'
            /'*       /A0 = Events in group 0 (UnExposed)            (A0 >= 0)               *'
            /'*      {/B0 = NonEvents in group 0                     (B0 >= 0)               *'
            /'*    or /N0}= Size of group 0                          (N0 >= A0 and > 0)      *'
            /'*------------------------------------------------------------------------------*'
            /'* Macro call for Case-Control Study:                                           *'
            /'* !CI2IP A1 = Exposed in Cases                         (A1 >= 0)               *'
            /'*      {/A0 = UnExposed in Cases                       (A0 >= 0)               *'
            /'*    or /M1}= Total Cases                              (M1 >= A1)              *'
            /'*       /B1 = Exposed in Controls                      (B1 >= 0)               *'
            /'*      {/B0 = UnExposed in Controls                    (B0 >= 0)               *'
            /'*    or /M0}= Total Controls                           (M0 >= B1)              *'
            /'*       {/R = Proportion of cases in the population    (0 < R  < 1)            *'
            /'*    or /PE}= Proportion of exposed in the population  (0 < PE < 1)            *'
            /'*------------------------------------------------------------------------------*'
            /'* Parameters for ALL studies:                                                  *'
            /'*       /ST = Study type:  CS (Cross-Sectional) ; by default: CS               *'
            /'*                       or EX (Experimental)                                   *'
            /'*                       or CO (Cohort)                                         *'
            /'*                       or CC (Case-Control)                                   *'
            /'*      [/CL]= Confidence level(%); by default: 95      (50 <= CL < 100)        *'
            /'*    [/Zero]= Continuity correction for cells with zero events:                *'
            /'*             N (None)                               by default: N             *'
            /'*             C (Constant, add k=0.5 to each cell)                             *'
            /'*             P (Proportional, add k1=N1/N and k0=N0/N for EX, CO & CS studies)*'
            /'*                              add k1=M1/N and k0=M0/N for CC studies)         *'
            /'*             R (Reciprocal, add k1=1/N0 and k0=1/N1 for EX, CO & CS studies)  *'
            /'*                            add k1=1/M0 and k0=1/M1 for CC studies)           *'
            /'*                            Reciprocal is a Recommended correction            *'
            /'*    [/PrCI]= Method for compute CI of proportions:                            *'
            /'*             W  Wilson                           by default: W (recommended)  *'
            /'*             E  Exact (Clopper-Pearson)                                       *'
            /'*             A  Asymptotic                                                    *'
            /'*     [/NST]= Name of the study (Label)                                        *'
            /'*     [/HELP] Print Macro call arguments and Samples of calls                  *'
            /'*                                                                              *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements   *'
            /'*       Macro tested for SPSS 15.0 and higher                                  *'
            /'*                                                                              *'
            /'* Samples of calls:                        +--------+---------+---------+-----+*'
            /'* !CI2IP HELP.                             |        | GROUP 0 | GROUP 1 |TOTAL|*'
            /'* !CI2IP A1=11 /N1=16 /A0=3 /N0=12 /ST=CS. |        |UnExposed| Exposed |     |*'
            /'* !CI2IP A1=11.5 /N1=18                    +--------+---------+---------+-----+*'
            /'*       /A0=3.8  /N0=22 /ST=CS.            |   Cases|    A0   |    A1   |  M1 |*'
            /'* !CI2IP A1=21 /M1=50 /B1=7 /M0=50 /ST=CC. |NonCases|    B0   |    B1   |  M0 |*'
            /'* !CI2IP A1=21 /M1=100 /B1=0 /M0=50        +--------+---------+---------+-----+*'
            /'*       /Zero=P /R=0.09 /ST=CC             |   TOTAL|    N0   |    N1   |  N  |*'
            /'*       /NST="Study Name" /CL=95 /PrCI=W.  +--------+---------+---------+-----+*'
            /'********************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Testing the parameter(s).
   COMPUTE #ERROR=0.
   COMPUTE #WARNDEC=0.
   COMPUTE #REXT=0.
   COMPUTE #A1=$SYSMIS.
   COMPUTE #A0=$SYSMIS.
   COMPUTE #B1=$SYSMIS.
   COMPUTE #B0=$SYSMIS.
   COMPUTE #M1=$SYSMIS.
   COMPUTE #M0=$SYSMIS.
   COMPUTE #N1=$SYSMIS.
   COMPUTE #N0=$SYSMIS.
   COMPUTE #R=$SYSMIS.
   COMPUTE #PE=$SYSMIS.
  
   !LET !STU=!UPCASE(!ST).  
   !IF (!STU<>'CS' !AND !STU<>'EX' !AND !STU<>'CO' !AND !STU<>'CC') !THEN.
      COMPUTE #ERROR=1.
      PRINT /'ERROR: Parameter(s) with wrong values'.
   !ELSE.
      COMPUTE #ST=0.        /*Study type: #ST=1 CS-default;ST=2 EX;ST=3 CO;#ST=4 CC.
      IF (!QUOTE(!STU)='CS') #ST=1.
      IF (!QUOTE(!STU)='EX') #ST=2.
      IF (!QUOTE(!STU)='CO') #ST=3.
      IF (!QUOTE(!STU)='CC') #ST=4.

      !IF (!STU='CS' !OR !STU='EX' !OR !STU='CO') !THEN.
*        Check integrity of parameters for cross-sectional (and EX,CO) study.
         !IF (!A1=!NULL !OR !A0=!NULL !OR (!B1=!NULL !AND !N1=!NULL) !OR (!B0=!NULL !AND !N0=!NULL)) !THEN. 
            COMPUTE #ERROR=2.
         !ELSE.
            COMPUTE #A1=!A1.
            COMPUTE #A0=!A0.

            !IF (!N1<>!NULL !and !N0<>!NULL) !THEN.
               !IF (!B1<>!NULL !or !B0<>!NULL) !THEN.
                  COMPUTE #ERROR=3.
               !ELSE.
                  COMPUTE #N1=!N1.
                  COMPUTE #N0=!N0.
                  COMPUTE #B0=#N0-#A0.
                  COMPUTE #B1=#N1-#A1.
               !IFEND.
            !ELSE.
               !IF (!B1<>!NULL !and !B0<>!NULL) !THEN.
                  !IF (!N1<>!NULL !or !N0<>!NULL) !THEN.
                     COMPUTE #ERROR=3.
                  !ELSE.
                     COMPUTE #B1=!B1.
                     COMPUTE #B0=!B0.
                     COMPUTE #N1=#A1+#B1.
                     COMPUTE #N0=#A0+#B0.
                  !IFEND.
               !ELSE.
                  COMPUTE #ERROR=2.
               !IFEND.
            !IFEND.
            COMPUTE #M1=#A0+#A1.
            COMPUTE #M0=#B0+#B1.
         !IFEND.
         !IF (!M1<>!NULL !or !M0<>!NULL !or !R<>!NULL !or !PE<>!NULL) !THEN.
            COMPUTE #ERROR=3.
         !IFEND.
      !IFEND.

      !IF (!STU='CC') !THEN.
*        Check integrity of parameters for case-control study.
         !IF (!A1=!NULL !OR !B1=!NULL !OR (!A0=!NULL !AND !M1=!NULL) !OR (!B0=!NULL !AND !M0=!NULL)) !THEN. 
            COMPUTE #ERROR=2.
         !ELSE.
            COMPUTE #A1=!A1.
            COMPUTE #B1=!B1.

            !IF (!M1<>!NULL !and !M0<>!NULL) !THEN.
               !IF (!A0<>!NULL !or !B0<>!NULL) !THEN.
                  COMPUTE #ERROR=3.
               !ELSE.
                  COMPUTE #M1=!M1.
                  COMPUTE #M0=!M0.
                  COMPUTE #B0=#M0-#B1.
                  COMPUTE #A0=#M1-#A1.
               !IFEND.
            !ELSE.
               !IF (!A0<>!NULL !and !B0<>!NULL) !THEN.
                  !IF (!M1<>!NULL !or !M0<>!NULL) !THEN.
                     COMPUTE #ERROR=3.
                  !ELSE.
                     COMPUTE #A0=!A0.
                     COMPUTE #B0=!B0.
                     COMPUTE #M1=#A0+#A1.
                     COMPUTE #M0=#A0+#B0.
                  !IFEND.
               !ELSE.
                  COMPUTE #ERROR=2.
               !IFEND.
            !IFEND.
            COMPUTE #N0=#A0+#B0.
            COMPUTE #N1=#A1+#B1.
         !IFEND.
         
         !IF (!N1<>!NULL !or !N0<>!NULL !or (!R<>!NULL !and !PE<>!NULL)) !THEN.
            COMPUTE #ERROR=3.
         !IFEND.
      !IFEND.
      
      DO IF (#ERROR=0).
*        Test parameters #A1,#A0,#B1,#B0,#M1,#M0.
         DO IF (SYSMIS(#A1) OR SYSMIS(#A0) OR SYSMIS(#B1) OR SYSMIS(#B0) OR SYSMIS(#M0) OR SYSMIS(#M1)).
            COMPUTE #ERROR=1.
         ELSE IF (#A1<0 OR #A0<0 OR #B1<0 OR #B0<0 OR #M1<#A1 OR #M0<#B1).
            COMPUTE #ERROR=1.
         END IF.
            
*        Test parameters #N1,#N0.
         DO IF (SYSMIS(#N1) OR SYSMIS(#N0)).
            COMPUTE #ERROR=1.
         ELSE IF (#N1<=0 OR #N0<=0 OR #N1<#A1 OR #N0<#A0).
            COMPUTE #ERROR=1.
         END IF.
         
*        Decimal parameters.
         DO IF (#ERROR=0).
            IF (MOD(#A1,1)<>0 OR MOD(#A0,1)<>0 OR MOD(#B1,1)<>0 OR MOD(#B0,1)<>0) #WARNDEC=1.
         END IF.

*        Test parameters #R,#PE.
         DO IF (#ST=4).
            !IF (!R<>!NULL) !THEN.
               COMPUTE #R=!R.
               COMPUTE #REXT=1.
               DO IF SYSMIS(#R).
                  COMPUTE #ERROR=1.
               ELSE IF (#R<=0 OR #R>=1).
                  COMPUTE #ERROR=1.
               END IF.
            !IFEND.
            !IF (!PE<>!NULL) !THEN.
               COMPUTE #PE=!PE.
               COMPUTE #REXT=1.
               DO IF SYSMIS(#PE).
                  COMPUTE #ERROR=1.
               ELSE IF (#PE<=0 OR #PE>=1).
                  COMPUTE #ERROR=1.
               END IF.
            !IFEND.
         END IF.
      END IF.
      
*     Test parameter CL.
      COMPUTE #CL=$SYSMIS.
      COMPUTE #CL=!CL.
      DO IF (SYSMIS(#CL)).
         COMPUTE #ERROR=1.
      ELSE.
         IF (#CL<=50 or #CL>=100) #ERROR=1.
      END IF.
      
*     Test parameter Zero.
      !LET !ZeroU=!UPCASE(!Zero).
      COMPUTE #Zero=0.     /*Continuity correction: #Zero=0 (NONE-default); #Zero=1 (constant); #Zero=2 (prop); #Zero=3 (recip).
      !IF (!ZeroU<>'N' !AND !ZeroU<>'C' !AND !ZeroU<>'P' !AND !ZeroU<>'R') !THEN.
         COMPUTE #ERROR=1.
      !ELSE.
         IF !QUOTE(!ZeroU)='N' #ZERO=0.
         IF !QUOTE(!ZeroU)='C' #ZERO=1.
         IF !QUOTE(!ZeroU)='P' #ZERO=2.
         IF !QUOTE(!ZeroU)='R' #ZERO=3.
      !IFEND.

*     Test parameter PrCI.
      COMPUTE #PrCI=0.       /*Method for compute the CI of proportions: W (Wilson) = 1 - default; E (Exact) = 2; A (Asymptotic) = 3.
      STRING #CItype (A9).
      !LET !PrCIU=!UPCASE(!PrCI).
      !IF (!PrCIU<>'W' !AND !PrCIU<>'E' !AND !PrCIU<>'A') !THEN.
         COMPUTE #ERROR=1.
      !ELSE.
         !IF (!PrCIU='W') !THEN.
            COMPUTE #PrCI=1.
            COMPUTE #CItype = ' (Wilson)'.
         !ELSE.
            !IF (!PrCIU='E') !THEN.
               COMPUTE #PrCI=2.
               COMPUTE #CItype = ' (Exact) '.
            !ELSE.
               !IF (!PrCIU='A') !THEN.
                  COMPUTE #PrCI=3.
                  COMPUTE #CItype  = ' (Asymp) '.
               !IFEND.
            !IFEND.
         !IFEND.
      !IFEND.
      
      DO IF (#ERROR=1).
         PRINT /'ERROR: Parameter(s) with wrong values'.
      ELSE IF (#ERROR=2).
         PRINT /'ERROR: Missing parameter'.
      ELSE IF (#ERROR=3).
         PRINT /'ERROR: Too much parameters'.
      ELSE.
*        Correct parameters, compute and print results.    
         COMPUTE #ALFA=(#CL+100)/200.
         COMPUTE #Z=IDF.NORMAL(#ALFA,0,1).
         COMPUTE #N=#N0+#N1.

*        Association Chi-square.
         COMPUTE #WARNCHI=0.
         COMPUTE #Chi2 = #N*((#A1*#B0-#A0*#B1)**2) / (#M1*#M0*#N1*#N0) .
         COMPUTE #Chi2C= #N*(((ABS(#A1*#B0-#A0*#B1) ) -#N/2)**2) / (#M1*#M0*#N1*#N0) .
         IF ( ABS(#A1*#B0-#A0*#B1) < (#N/2) ) #chi2C=0.
         COMPUTE #sp =(1- CDF.CHISQ(ABS(#chi2),1)).
         COMPUTE #spC=(1- CDF.CHISQ(ABS(#chi2C),1)).
         IF (#M1*(#N1/#N)<5 OR #M0*(#N1/#N) <5 OR #M1*(#N0/#N)<5 OR #M0*(#N0/#N)<5)  #WARNCHI=1.

         COMPUTE #A1p=#A1.          /*Save original parameters for print.
         COMPUTE #A0p=#A0.
         COMPUTE #B1p=#B1.
         COMPUTE #B0p=#B0.
         COMPUTE #M1p=#M1.
         COMPUTE #M0p=#M0.
         COMPUTE #N1p=#N1.
         COMPUTE #N0p=#N0.
         COMPUTE #Np=#N.

         COMPUTE #WARNZERO=0.       /*Continuity correction.
         IF (#A1=0 OR #B1=0 OR #A0=0 OR #B0=0) #WARNZERO=1.
         STRING #TZero(A1).
         COMPUTE #TZero = ' '.
         IF (#WARNZERO=1 and #ZERO>0) #TZero = '*'.
         DO IF (#ZERO>0 AND #WARNZERO>0).            
            DO IF (#ZERO=1).
               COMPUTE #K1=0.5.
               COMPUTE #K0=0.5.
            ELSE IF (#ZERO=2).
               IF (#ST<4) #K1=#N1/#N.
               IF (#ST<4) #K0=#N0/#N.
               IF (#ST=4) #K1=#M1/#N.
               IF (#ST=4) #K0=#M0/#N.
            ELSE IF (#ZERO=3).
               IF (#ST<4) #K1=1/#N0.
               IF (#ST<4) #K0=1/#N1.
               IF (#ST=4) #K1=1/#M0.
               IF (#ST=4) #K0=1/#M1.
            END IF.
            DO IF (#ST<4).
               COMPUTE #A1=#A1+#K1.
               COMPUTE #B1=#B1+#K1.
               COMPUTE #A0=#A0+#K0.
               COMPUTE #B0=#B0+#K0.
            ELSE IF (#ST=4).
               COMPUTE #A1=#A1+#K1.
               COMPUTE #A0=#A0+#K1.
               COMPUTE #B1=#B1+#K0.
               COMPUTE #B0=#B0+#K0.
            END IF.
            COMPUTE #M1=#A0+#A1.
            COMPUTE #M0=#B0+#B1.
            COMPUTE #N1=#A1+#B1.
            COMPUTE #N0=#A0+#B0.
            COMPUTE #N=#N1+#N0.
         END IF.

*        Compute the proportions #P1, #P0 and the risks #R1, #R0.
         NUMERIC #P1 #P0 #R1 #R0 #PeCS #RCS #ubP1 #ubP0 #ubR1 #ubR0 #ubPeCS #ubRCS #lbP1 #lbP0 #lbR1 #lbR0 #lbPeCS #lbRCS.
         DO REPEAT P=#P1 #P0 #R1 #R0 #PeCS #RCS
                  /A=#A1 #B1 #A1 #A0 #N1 #M1
                  /N=#M1 #M0 #N1 #N0 #N #N
                /ubP=#ubP1 #ubP0 #ubR1 #ubR0 #ubPeCS #ubRCS
                /lbP=#lbP1 #lbP0 #lbR1 #lbR0 #lbPeCS #lbRCS.
            COMPUTE P = A/N.
            DO IF (#PrCI=1).      /*Wilson bounds.
               COMPUTE #WA = 2*A + #Z**2.
               COMPUTE #WB = #Z * SQRT(#Z**2 + 4*A*(N-A)/N).
               COMPUTE #WC = 2*(N + #Z**2).
               COMPUTE lbP= (#WA-#WB)/#WC.
               COMPUTE ubP= (#WA+#WB)/#WC.
            ELSE IF (#PrCI=2).    /*Exact bounds.
               COMPUTE lbP= 0.
               COMPUTE ubP= 1.
               IF (A > 0) lbP= A/(A+(N-A+1)*IDF.F(#ALFA,2*(N-A+1),2*A)).
               IF (N > A) ubP=(A+1)/((A+1)+((N-A)/IDF.F(#ALFA,2*(A+1),2*(N-A)))).               
            ELSE IF (#PrCI=3).    /*Asymptotic bounds.
               COMPUTE #SEAsymp = SQR(P*(1-P)/N).
               COMPUTE ubP = P + #Z*#SEASymp.
               COMPUTE lbP = P - #Z*#SEASymp.
            END IF.
         END REPEAT.

*        Compute R,PE,Risk and Odds for Case-Control study.
         DO IF (#ST=4 AND #REXT=1).
*           Compute of R and PE.
            !IF (!R<>!NULL) !THEN.
               !LET !TEXTR = '(external) '.
               !LET !TEXTPE = '(estimated)'.
               COMPUTE #PE=(#A1/#M1)*#R + (#B1/#M0)*(1-#R).
            !ELSE.
               COMPUTE #R=(#PE-(#B1/#M0))/((#A1/#M1)-(#B1/#M0)).
               !LET !TEXTR = '(estimated)'.
               !LET !TEXTPE = '(external) '.
            !IFEND.              
*           Risk and Odds.
            COMPUTE #O= #R/(1-#R). 
            COMPUTE #O0= #O*(#A0/#M1)/(#B0/#M0). 
            COMPUTE #O1= #O*(#A1/#M1)/(#B1/#M0). 
            COMPUTE #R0= #O0/(1+#O0). 
            COMPUTE #R1= #O1/(1+#O1).
         END IF.

*        Print header and 2x2 table with proportions.
         STRING #TDec (A1).
         COMPUTE #TDec=' '.
         IF (#WARNDEC=1) #TDec='.'.
         DO IF (#ST=1).
            PRINT /'ASSOCIATION MEASURES: CROSS-SECTIONAL STUDY'.
            !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
               STRING #NST (A131).
               COMPUTE #NST = CONCAT('STUDY: ',!NST).
               PRINT /#NST.
            !IFEND.
            
            PRINT//'                  |     Exposure      |         | Exposed proportion'.
            PRINT /'                  |Unexposed| Exposed |   TOTAL | '!QUOTE(!CL)'% CI' #CItype.
            PRINT /'------------------+---------+---------+---------+--------------------'.
            PRINT /'            Cases |' #A0p(F8) #TDec(A1) '|' #A1p(F8) #TDec(A1) '|' #M1p(F8) #TDec(A1) '| ' #P1(F7.6) #TZero(A1).
            PRINT /'                  |         |         |         |('#lbP1(F7.6) ' to ' #ubP1(F7.6) ')'.
            PRINT /'         NonCases |' #B0p(F8) #TDec(A1) '|' #B1p(F8) #TDec(A1) '|' #M0p(F8) #TDec(A1) '| ' #P0(F7.6) #TZero(A1).
            PRINT /'                  |         |         |         |('#lbP0(F7.6) ' to ' #ubP0(F7.6) ')'.
            PRINT /'------------------+---------+---------+---------+--------------------'.
            PRINT /'            TOTAL |' #N0p(F8) #TDec(A1) '|' #N1p(F8) #TDec(A1) '|' #Np(F8) #TDec(A1) '| ' #PeCS(F7.6) #TZero(A1).
            PRINT /'                  |         |         |         |('#lbPeCS(F7.6) ' to ' #ubPeCS(F7.6) ')'.
            PRINT /'       Prevalence | ' #R0(F7.6) #TZero(A1) '| ' #R1(F7.6) #TZero(A1) '| ' #RCS(F7.6) #TZero(A1) '|'.
            PRINT /'  95% CI    Lower | ' #lbR0(F7.6) ' | ' #lbR1(F7.6) ' | ' #lbRCS(F7.6) ' |'.
            PRINT / #CItype  '  Upper | ' #ubR0(F7.6) ' | ' #ubR1(F7.6) ' | ' #ubRCS(F7.6) ' |'.
         ELSE IF (#ST=2).
            PRINT /'ASSOCIATION MEASURES: EXPERIMENTAL STUDY'.
            !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
               PRINT /'STUDY: ' !NST.
            !IFEND.
            
            PRINT//'                  | Treat.0 | Treat.1 |   TOTAL'.
            PRINT /'------------------+---------+---------+---------'.
            PRINT /'           Events |' #A0p(F8) #TDec(A1) '|' #A1p(F8) #TDec(A1) '|' #M1p(F8) #TDec(A1).
            PRINT /'        NonEvents |' #B0p(F8) #TDec(A1) '|' #B1p(F8) #TDec(A1) '|' #M0p(F8) #TDec(A1).
            PRINT /'------------------+---------+---------+---------'.
            PRINT /'            TOTAL |' #N0p(F8) #TDec(A1) '|' #N1p(F8) #TDec(A1) '|' #Np(F8) #TDec(A1).
            PRINT /'                  |         |         |'.
            PRINT /'             Risk | ' #R0(F7.6) #TZero(A1) '| ' #R1(F7.6) #TZero(A1) '| '.
            PRINT /'  95% CI    Lower | ' #lbR0(F7.6) ' | ' #lbR1(F7.6) ' | '.
            PRINT / #CItype  '  Upper | ' #ubR0(F7.6) ' | ' #ubR1(F7.6) ' | '.
         ELSE IF (#ST=3).
            PRINT /'ASSOCIATION MEASURES: COHORT STUDY'.
            !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
               PRINT /'STUDY: ' !NST.
            !IFEND.
            
            PRINT//'                  |UnExposed| Exposed |   TOTAL'.
            PRINT /'------------------+---------+---------+---------'.
            PRINT /'            Cases |' #A0p(F8) #TDec(A1) '|' #A1p(F8) #TDec(A1) '|' #M1p(F8) #TDec(A1).
            PRINT /'         NonCases |' #B0p(F8) #TDec(A1) '|' #B1p(F8) #TDec(A1) '|' #M0p(F8) #TDec(A1).
            PRINT /'------------------+---------+---------+---------'.
            PRINT /'            TOTAL |' #N0p(F8) #TDec(A1) '|' #N1p(F8) #TDec(A1) '|' #Np(F8) #TDec(A1).
            PRINT /'                  |         |         |'.
            PRINT /'             Risk | ' #R0(F7.6) #TZero(A1) '| ' #R1(F7.6) #TZero(A1) '| '.
            PRINT /'  95% CI    Lower | ' #lbR0(F7.6) ' | ' #lbR1(F7.6) ' | '.
            PRINT / #CItype  '  Upper | ' #ubR0(F7.6) ' | ' #ubR1(F7.6) ' | '.
         ELSE IF (#ST=4).
            PRINT /'ASSOCIATION MEASURES: CASE-CONTROL STUDY'.
            !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
               PRINT /'STUDY: ' !NST.
            !IFEND.
            
            PRINT//'                  |     Exposure      |         | Exposed proportion'.
            PRINT /'                  |Unexposed| Exposed |   TOTAL | '!QUOTE(!CL)'% CI' #CItype.
            PRINT /'------------------+---------+---------+---------+--------------------'. 
            PRINT /'            Cases |' #A0p(F8) #TDec(A1) '|' #A1p(F8) #TDec(A1) '|' #M1p(F8) #TDec(A1) '| ' #P1(F7.6) #TZero(A1).
            PRINT /'                  |         |         |         |('#lbP1(F7.6) ' to ' #ubP1(F7.6) ')'.
            PRINT /'         NonCases |' #B0p(F8) #TDec(A1) '|' #B1p(F8) #TDec(A1) '|' #M0p(F8) #TDec(A1) '| ' #P0(F7.6) #TZero(A1).
            PRINT /'                  |         |         |         |('#lbP0(F7.6) ' to ' #ubP0(F7.6) ')'.
            PRINT /'------------------+---------+---------+---------+--------------------'.
            DO IF (#REXT=0).
               PRINT /'            TOTAL |' #N0p(F8) #TDec(A1) '|' #N1p(F8) #TDec(A1) '|' #Np(F8) #TDec(A1) '|'.
            ELSE.
*              If R or PE external, print results.
               PRINT /'            TOTAL |' #N0p(F8) #TDec(A1) '|' #N1p(F8) #TDec(A1) '|' #Np(F8) #TDec(A1) '| ' #PE(F7.6) !QUOTE(!TEXTPE).
               PRINT /'                  |         |         |         |'.
               PRINT /'             Risk | ' #R0(F7.6) #TZero(A1) '| ' #R1(F7.6) #TZero(A1) '| '#R(F7.6) #TZero(A1) '|'.
               PRINT /'             Odds |'  #O0(F8.4) #TZero(A1) '|'  #O1(F8.4) #TZero(A1) '|' #O(F8.4) #TZero(A1) '|'.
            END IF.
         END IF.

*        Compute and print RD,RR,OR.
         PRINT//'------------------+-------------------+----------------------------------'.
         PRINT /'                  |     Estimate      | ' !QUOTE(!CL) '% Confidence Interval'.
         PRINT /'------------------+-------------------+----------------------------------'.

         DO IF (#ST<4).
*           Risk/Prev difference.
            COMPUTE #RD= #R1-#R0.
*           Wald CI of difference of two proportions.
            COMPUTE #SERD= SQR(#R1*(1-#R1)/#N1 + #R0*(1-#R0)/#N0).
            COMPUTE #lbRDWald= #RD - #Z*#SERD.
            COMPUTE #ubRDWald= #RD + #Z*#SERD.
*           Newcombe-Wilson CI of difference of two proportions.
            COMPUTE #f0= #A0**2 /(#N0**2 + #N0*#Z**2).
            COMPUTE #f1= #A1**2 /(#N1**2 + #N1*#Z**2).
            COMPUTE #w0= (2*#A0 + #Z**2)/(2*(#N0 + #Z**2)).
            COMPUTE #w1= (2*#A1 + #Z**2)/(2*(#N1 + #Z**2)).
            COMPUTE #l0= #w0 - SQR(#w0**2 - #f0).
            COMPUTE #l1= #w1 - SQR(#w1**2 - #f1).
            COMPUTE #u0= #w0 + SQR(#w0**2 - #f0).
            COMPUTE #u1= #w1 + SQR(#w1**2 - #f1).
            COMPUTE #d = SQR((#R1-#l1)**2 + (#u0-#R0)**2).
            COMPUTE #e = SQR((#u1-#R1)**2 + (#R0-#l0)**2).
            COMPUTE #lbRDWil= #RD - #d.
            COMPUTE #ubRDWil= #RD + #e.
            
*           Print results.
            STRING #RDTITLE (A18).
            COMPUTE #RDTITLE = '  Risk diff. (RD) '.
            IF (#ST=1) #RDTITLE = ' Prev. Diff. (PD) '.
            PRINT / #RDTITLE(A18)  '|'19 #RD(T22,F11.6) #TZero(A1) '|'39 #lbRDWald(F12.6) ' ' #ubRDWald(F12.6) ' Wald'.
            PRINT /                '|'19                '|'39 #lbRDWil(F12.6)  ' ' #ubRDWil(F12.6)  ' Newcombe'.
         END IF.

*        Risk/Prev Ratio.
         COMPUTE #RR=(#A1/#N1)/(#A0/#N0).
         COMPUTE #SElnRR = SQR((1/#A0)-(1/#N0)+(1/#A1)-(1/#N1)).
         COMPUTE #ubRR = #RR*EXP(#Z*#SElnRR).
         COMPUTE #lbRR = #RR*EXP(-#Z*#SElnRR).

*        Odds Ratio.
         COMPUTE #OR=(#A1/#B1)/(#A0/#B0).
         COMPUTE #SElnOR = SQR((1/#A0)+(1/#A1)+(1/#B0)+(1/#B1)).
         COMPUTE #ubOR = #OR*EXP(#Z*#SElnOR).
         COMPUTE #lbOR = #OR*EXP(-#Z*#SElnOR).

*        Print Risk/Prev Ratio for ST=CS,CO,EX studies.
         DO IF (#ST<4).
            STRING #RRTITLE(A18).
            COMPUTE #RRTITLE = '  Risk ratio (RR) '.
            IF (#ST=1) #RRTITLE = ' Prev. Ratio (PR) '.            
            PRINT / #RRTITLE(A18)    '|'19 #RR(T22,F11.4) #TZero (A1) '|'39 #lbRR(F12.4) ' ' #ubRR(F12.4).
            DO IF (#RR<1).
               COMPUTE #IRR=1/#RR.
               COMPUTE #IubRR=1/#lbRR.
               COMPUTE #IlbRR=1/#ubRR.
               PRINT / '       reciprocal |' #IRR(T22,F11.4) '|'39 #IlbRR(F12.4) ' ' #IubRR(F12.4).
            END IF.
         END IF.

*        Print Odds ratio.
         PRINT /'  Odds ratio (OR) |'   #OR(T22,F11.4) #TZero (A1) '|'39 #lbOR(F12.4) ' ' #ubOR(F12.4).
         DO IF (#OR<1).
            COMPUTE #IOR=1/#OR.
            COMPUTE #IubOR=1/#lbOR.
            COMPUTE #IlbOR=1/#ubOR.
            PRINT / '       reciprocal |' #IOR(T22,F11.4) '|'39 #IlbOR(F12.4) ' ' #IubOR(F12.4).
         END IF.

*        Compute and Print RR, RD for CC studies with R or PE external.
         DO IF (#ST=4 AND #REXT=1).
*           Risk Ratio.
            COMPUTE #RR= (#A1/#A0)/(#PE/(1-#PE)).
*           Risk difference.
            COMPUTE #RD=#R*(#RR-1)/(#PE*(#RR-1)+1).

            PRINT /'------------------+-------------------+----------------------------------'.
            PRINT /'  Population Risk | ' #R(F7.6) !QUOTE(!TEXTR) '|'39.
            PRINT /'   Risk Ratio(RR) | ' #RR(T22,F11.4) #TZero(A1) '|'39.
            PRINT /'   Risk Diff.(RD) | ' #RD(T22,F11.6) #TZero(A1) '|'39.
         END IF.

*        Print Association Chi2.
         STRING #TChi (A2).
         COMPUTE #TChi='  '.
         IF (#WARNCHI=1) #TChi='**'.
         PRINT /'------------------+-------------------+----------------------------------'.
         PRINT /' Association Chi2 |' #Chi2 (T25,F8.4) #TChi(A2) '|'39 '  P=' #sp (F8.6). 
         PRINT /'        Corrected |' #Chi2C(T25,F8.4)           '|'39 '  P=' #spc(F8.6).
         PRINT /'------------------+-------------------+----------------------------------'.

         DO IF (#ST<4).
            PRINT /'Recommended CI'.
         END IF.

*        Print warnings.
         DO IF (#WARNDEC=1).
            PRINT / '(.)WARNING: Number of cases with decimal values.'.
            PRINT / '            The values are printed rounded.'.
         END IF.
         DO IF (#WARNZERO=1 AND #ZERO>0).
            DO IF (#ZERO=1).
               PRINT /'(*)Computed with a constant continuity correction (k=0.5)'.
            ELSE IF (#ZERO=2).
               PRINT /'(*)Computed with a proportional continuity correction'.
            ELSE IF (#ZERO=3).
               PRINT /'(*)Computed with a reciprocal continuity correction'.
            END IF.
            PRINT /'   Exact inference is recommended'.
         END IF. 
         DO IF (#WARNChi=1).
            PRINT/'(**)WARNING: Small samples for Association Chi-Square' . 
         END IF.
      END IF.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
