PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
  PRINT /'Macro !CI2PP V2009.05.25 loaded.'
        /'Execute !CI2PP HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !CI2PP ( PP=!CHAREND('/') 
               /AA=!CHAREND('/')  
               /PA=!CHAREND('/')
               /AP=!CHAREND('/') 
               /CL=!CHAREND('/') !DEFAULT('95')
               /ST=!CHAREND('/') !DEFAULT('CO') 
              /NST=!CHAREND('/')
             /HELP=!CHAREND('/') !DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2009.05.25').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
PRINT //'Macro !CI2PP V' !VERSION ' (c)JM.Domenech & R.Granero'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*  Print documentation.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* CONFIDENCE INTERVALS FOR MEASURES OF CHANGE                                *'
            /'* 2x2 Table (Paired samples)                                                 *'
            /'* Created 1998.06.06 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech & R.Granero                                                *'
            /'* Programmers: A.Bonillo & R.Sesma                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM, Granero R. Macro !CI2PP for SPSS Statistics.                  *'
            /'*    Confidence Intervals for Measures of Change: 2x2 Table                  *'
            /'*    (Paired samples) [computer program].                                    *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro call (tested for SPSS 15.0 and higher):                              *'
            /'* !CI2PP PP= Event(+) present in X and Y        (PP integer >= 0)            *'
            /'*       /AP= Event(+) present only in Y         (AP integer >= 0)            *'
            /'*       /PA= Event(+) present only in X         (PA integer >= 0)            *'
            /'*       /AA= Event(+) absent in X and Y         (AA integer >= 0)            *'
            /'*     [/CL]= Confidence level(%); by default: 95  (50 < CL < 100)            *'
            /'*     [/ST]= Study type: CO (Cohort, Experimental or Cross-Sectional)        *'
            /'*                     or CC (Pair matched Case-Control);  by default: CO     *'
            /'*    [/NST]= Name of the study (Label)                                       *'
            /'*    [/HELP] Print Macro call arguments and Samples of calls                 *'
            /'*                                                                            *'
            /'* Notes: Sense of change: Pr(Y+) - Pr(X+)                                    *'
            /'*        Parameters enclosed in square brackets [ ] are optional             *'
            /'*                                   +---------------+-----------+----------+ *'
            /'*                                   |               |Response of Exposure X| *'
            /'* Samples of calls:                 |               |    (-)    |    (+)   | *'
            /'* !CI2PP HELP.                      +---------------+-----------+----------+ *'
            /'* !CI2PP AA=0 /PP=2 /PA=7 /AP=1.    |Response of (+)|     AP    |     PP   | *'
            /'* !CI2PP AA=98 /PP=85 /PA=40 /AP=25 |Exposure Y  (-)|     AA    |     PA   | *'
            /'*       /ST=CC.                     +---------------+-----------+----------+ *'
            /'* !CI2PP AP=9 /PP=3 /AA=5 /PA=1 /CL=90 /ST=CO /NST="Name of the Study".      *'
            /'******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Testing the parameters.
   !IF (!PP=!NULL !or !AA=!NULL !or !AP=!NULL !or !PA=!NULL) !THEN.
      PRINT /'ERROR: Missing parameter'.
   !ELSE.

      !LET !STU=!UPCASE(!ST).
      COMPUTE #ST=0.        /*Study type.
      IF (!QUOTE(!STU)='CO') #ST=1.  /* Exposure Y-X.
      IF (!QUOTE(!STU)='CC') #ST=2.  /* Case-Controls.

      COMPUTE #ERROR=0.
      COMPUTE #PP=$SYSMIS.
      COMPUTE #AP=$SYSMIS.
      COMPUTE #PA=$SYSMIS.
      COMPUTE #AA=$SYSMIS.
      COMPUTE #CL=$SYSMIS.
      COMPUTE #PP=!PP.
      COMPUTE #AP=!AP.
      COMPUTE #PA=!PA.
      COMPUTE #AA=!AA.
      COMPUTE #CL=!CL.
      
*     Test parameters PP,AP,PA,AA,CL.
      DO IF (SYSMIS(#PP) OR SYSMIS(#AP) OR SYSMIS(#PA) OR SYSMIS(#AA) OR SYSMIS(#CL)).
         COMPUTE #ERROR=1.
      ELSE.
         IF (#PP<0 OR #AP<0 OR #PA<0 OR #AA<0 OR #CL<=50 OR #CL>=100 OR #ST=0) #ERROR=1.
      END IF.

      DO IF (#ERROR=1).
         PRINT /'ERROR: Parameter(s) with wrong values'.
      ELSE.
*        Correct parameters.

*        Decimal parameters.
         COMPUTE #WARNDEC = 0.
         IF (MOD(#PP,1)<>0 OR MOD(#AA,1)<>0 OR MOD(#AP,1)<>0 OR MOD(#PA,1)<>0) #WARNDEC=1.
         STRING #TDec(A1).
         COMPUTE #TDec=' '.
         IF (#WARNDEC=1) #TDec='.'.
         
*********PAIRED SAMPLES.
*        Sum of rows, columns, Z.
         COMPUTE #NCnE=#AA+#AP.
         COMPUTE #CnE=#PP+#PA.
         COMPUTE #CE =#PP+#AP.
         COMPUTE #NCE=#PA+#AA.
         COMPUTE #N=#PP+#AP+#AA+#PA.
         COMPUTE #P=(#CL+100)/200.
         COMPUTE #Z=IDF.NORMAL(#P,0,1).

*        Wilson p bounds.
         COMPUTE #WA = 2*#AP + #Z**2.
         COMPUTE #WB = #z * SQRT(#Z**2 + 4*#AP*#PA/(#AP+#PA)).
         COMPUTE #WC = 2*(#AP+#PA + #Z**2).
         COMPUTE #LBpW= (#WA-#WB)/#WC.
         COMPUTE #UBpW= (#WA+#WB)/#WC.

*        Exact p bounds.
         COMPUTE #LBpE=(#AP)/(#AP+(#PA+1)*IDF.F(#P,2*(#PA+1),2*#AP) ).
         COMPUTE #UBpE=(#AP+1)/((#AP+1)+#PA/IDF.F(#P,2*(#AP+1),2*#PA) ).
   
*********Difference.
         COMPUTE #RD=(#AP-#PA)/#N.
*        Exact bounds.
         COMPUTE #lbRd=(2*#LBpE-1)*(#AP+#PA)/#N.
         COMPUTE #ubRd=(2*#UBpE-1)*(#AP+#PA)/#N.
*        Asymptotic bounds.
         COMPUTE #SERD = SQRT(#AP+#PA-((#AP-#PA)**2/#N))/#N.
         COMPUTE #lbRDA= #RD - #Z*#SERD.
         COMPUTE #UbRDA= #RD + #Z*#SERD.
*        Newcombe method 10 bounds - 'Statistics with confidence', pg.52.
*        #Pe bounds.
         COMPUTE #Pe= #CE/#N.
         COMPUTE #WA1 = 2*#CE + #Z**2.
         COMPUTE #WB1 = #Z * SQRT(#Z**2 + 4*#CE*(#N-#CE)/#N).
         COMPUTE #WC1 = 2*(#N + #Z**2).
         COMPUTE #lbW1= (#WA1-#WB1)/#WC1.
         COMPUTE #ubW1= (#WA1+#WB1)/#WC1.
*        #Pu bounds.
         COMPUTE #Pu= #CnE/#N.
         COMPUTE #WA2 = 2*#CnE + #Z**2.
         COMPUTE #WB2 = #Z * SQRT(#Z**2 + 4*#CnE*(#N-#CnE)/#N).
         COMPUTE #WC2 = 2*(#N + #Z**2).
         COMPUTE #lbW2= (#WA2-#WB2)/#WC2.
         COMPUTE #ubW2= (#WA2+#WB2)/#WC2.
*        Coefficient #Fi.
         COMPUTE #WA = #NCnE * #CnE * #CE * #NCE.
         DO IF (#WA = 0).
            COMPUTE #FI = 0.
         ELSE.
            COMPUTE #WB = #PP*#AA - #AP*#PA.
            IF (#WB > #N/2) #WC = #WB - #N/2.
            IF (#WB >= 0 AND #WB <= #N/2) #WC = 0.
            IF (#WB < 0) #WC = #WB.
            COMPUTE #FI = #WC / SQRT(#WA).
         END IF.
*        Bounds.
         COMPUTE #lbRDW= #RD - SQRT((#Pe-#lbW1)**2 - 2*#FI*(#Pe-#lbW1)*(#ubW2-#Pu) + (#ubW2-#Pu)**2 ).
         COMPUTE #ubRDW= #RD + SQRT((#Pu-#lbW2)**2 - 2*#FI*(#Pu-#lbW2)*(#ubW1-#Pe) + (#ubW1-#Pe)**2 ).
   
*********Odds Ratio.
         COMPUTE #OR=#AP/#PA.
*        Exact bounds.
         COMPUTE #lbOR= #LBpE/(1-#LBpE).
         COMPUTE #ubOR= #UBpE/(1-#UBpE).
*        Asymptotic bounds.
         COMPUTE #SElnOR = SQRT(1/#AP + 1/#PA).
         COMPUTE #lbORA= #OR*EXP(-1*#Z*#SElnOR).
         COMPUTE #ubORA= #OR*EXP(#Z*#SElnOR).
*        Wilson bounds.
         COMPUTE #LbORW= #LBpW/(1-#LBpW).
         COMPUTE #UbORW= #UBpW/(1-#UBpW).
   
*********McNemar test.  
         COMPUTE #MN_Chi2=((#AP-#PA)/SQRT(#AP+#PA))**2.
         COMPUTE #MN_sp=(1-CDF.CHISQ(#MN_Chi2,1)).
         COMPUTE #MN_Chi2C=((ABS(#AP-#PA)-1)/SQRT(#AP+#PA))**2.
         IF (ABS(#AP-#PA)<0.5) #MN_Chi2C=0.
         COMPUTE #MN_spC=(1-CDF.CHISQ(#MN_Chi2C,1)).
*        McNemar (exact) Test.
         DO IF (MOD(#AP,1)=0 AND MOD(#PA,1)=0).
            COMPUTE #APA=MIN(#AP,#PA).
            COMPUTE #s2=2*CDF.BINOM(#APA,#PA+#AP,0.5).
         ELSE.
*           Decimal parameters: P value computed by linear interpolation.
            DO IF (#AP < #PA).
               COMPUTE #AP1= TRUNC(#AP).
               COMPUTE #PA1= TRUNC(#PA) + (MOD(#PA,1)<>0).
               COMPUTE #AP0= TRUNC(#AP) + (MOD(#AP,1)<>0).
               COMPUTE #PA0= TRUNC(#PA).
            ELSE IF (#AP > #PA).
               COMPUTE #AP1= TRUNC(#AP) + (MOD(#AP,1)<>0).
               COMPUTE #PA1= TRUNC(#PA).
               COMPUTE #AP0= TRUNC(#AP).
               COMPUTE #PA0= TRUNC(#PA) + (MOD(#PA,1)<>0).
               COMPUTE #s21=2*CDF.BINOM(#PA1,#PA1+#AP1,0.5).
            END IF.
            COMPUTE #APA1=MIN(#AP1,#PA1).
            COMPUTE #APA0=MIN(#AP0,#PA0).
            COMPUTE #s21=2*CDF.BINOM(#APA1,#PA1+#AP1,0.5).
            COMPUTE #s20=2*CDF.BINOM(#APA0,#PA0+#AP0,0.5).
            IF(#PA1 EQ #AP1) #s21=1.
            IF(#PA0 EQ #AP0) #s20=1.
            COMPUTE #K12= ABS(#AP1-#AP0) + ABS(#PA1-#PA0).
            COMPUTE #s2= ((#K12-MOD(#AP,1)-MOD(#PA,1))*#s21 + ( MOD(#AP,1)+MOD(#PA,1) )*#s20)/#K12 .
         END IF.
         IF(#PA EQ #AP) #s2=1.
         STRING #TMN (A1).
         COMPUTE #TMN=' '.
         IF ((#AP+#PA)<10) #TMN='*'.
   
*********Test of association.
         COMPUTE #ORass= (#PP*#AA)/(#AP*#PA) .
         IF (#PP*#AA = 0) #ORass= $SYSMIS.
         COMPUTE #Chi2= (#N*(#PP*#AA - #AP*#PA)**2)/(#NCnE*#CnE*#CE*#NCE).
         COMPUTE #sp=1-CDF.CHISQ(#Chi2,1).
         COMPUTE #Chi2C=(#N*(ABS(#PP*#AA - #AP*#PA)-#N/2)**2)/(#NCnE*#CnE*#CE*#NCE).
         IF (ABS(#PP*#AA - #AP*#PA)<(#N/2)) #Chi2C=0.
         COMPUTE #spC=1-CDF.CHISQ(#Chi2C,1).
         STRING #TChi (A2).
         COMPUTE #TChi='  '.
         COMPUTE #WARNCHI=0.
         IF (#CE*#CnE/#N<5 OR #NCE*#CnE/#N<5 OR #CE*#NCnE/#N<5 OR #NCE*#NCnE/#N<5) #WARNCHI=1.
         IF (#WARNCHI=1) #TCHi='**'.
                  
*        Print header.
         PRINT /'CONFIDENCE INTERVALS FOR MEASURES OF CHANGE'.
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.

         STRING #TitleCols (A23) #TitleRows1 #TitleRows2 (A11) #TitleDiff (A15).
         COMPUTE #TitleCols= 'Response of exposure X'.
         COMPUTE #TitleRows1= 'Response of'.
         COMPUTE #TitleRows2= ' exposure Y'.
         COMPUTE #TitleDiff= '  Pr(Y+)-Pr(X+)'.
         IF (#ST=2) #TitleCols= '  Exposure of Controls'.
         IF (#ST=2) #TitleRows1= 'Exposure   '.
         IF (#ST=2) #TitleRows2= 'of Cases   '.
         IF (#ST=2) #TitleDiff= 'Pr(Ca+)-Pr(Co+)'.
         
*        Print PAIRED SAMPLES results.
         PRINT//'2x2 Table (PAIRED SAMPLES)'.
         PRINT /'                    |' #TitleCols(A23)     '|'.
         PRINT /'                    |       (-) |       (+) |   TOTAL   Proportion'.
         PRINT /'--------------------+-----------+-----------+---------------------'.
         PRINT /#TitleRows1(A11) '      (+)|'#AP(T25,F7) #TDec(A1) '|'33 #PP(T37,F7) #TDec(A1) '|'45 #CE (T46,F8) #TDec(A1) #Pe(F12.6).
         PRINT /#TitleRows2(A11) '      (-)|'#AA(T25,F7) #TDec(A1) '|'33 #PA(T37,F7) #TDec(A1) '|'45 #NCE(T46,F8) #TDec(A1).
         PRINT /'--------------------+-----------+-----------+---------------------'.
         PRINT /'              TOTAL |'#NCnE(T25,F7) #TDec(A1) '|'33 #CnE(T37,F7) #TDec(A1) '|'45 #N(T46,F8) #TDec(A1).
         PRINT /'         Proportion |'             '|'33 #Pu(T36,F8.6)'|'45.

         PRINT//'--------------------+-----------------------+-------------------------------------'.
         PRINT /'                    |        Estimate       | '!QUOTE(!CL)'% Confidence Interval'.
         PRINT /'--------------------+-----------------------+-------------------------------------'.
         PRINT /'         Difference |'#RD(T27,F11.6) '|'45 #lbRD(T48,F11.6) #ubRD(T61,F11.6)  ' Exact'. 
         PRINT /'     ' #TitleDiff(A15) '|'               '|'45 #lbRDW(T48,F11.6)#ubRDW(T61,F11.6) ' Newcombe'. 
         PRINT /                    '|'21             '|'45 #lbRDA(T48,F11.6)#ubRDA(T61,F11.6) ' Asymptotic'. 
         PRINT /                    '|'21             '|'45. 
         DO IF (#AP>0 AND #PA>0).
            PRINT /'     Odds ratio (OR)|' #OR (T27,F11.4) '|'45 #lbOR (T48,F11.4)  #UbOR (T61,F11.4) ' Exact'.
            PRINT /'  (exposure-disease)|'                 '|'45 #lbORW(T48,F11.4)  #UbORW(T61,F11.4) ' Wilson'. 
            PRINT /                    '|'21               '|'45 #lbORA(T48,F11.4)  #UbORA(T61,F11.4) ' Asymptotic'. 
            DO IF (#OR<1).
               COMPUTE #IOR=1/#OR.
               COMPUTE #IubOR=1/#lbOR.
               COMPUTE #IlbOR=1/#ubOR.
               COMPUTE #IubORA=1/#lbORA.
               COMPUTE #IlbORA=1/#ubORA.
               COMPUTE #IubORW=1/#lbORW.
               COMPUTE #IlbORW=1/#ubORW.
               PRINT /'    reciprocal(1/OR)|' #IOR(T27,F11.4) '|'45 #IlbOR (T48,F11.4) #IubOR (T61,F11.4) ' Exact'.
               PRINT /                    '|'21               '|'45 #IlbORW(T48,F11.4) #IubORW(T61,F11.4) ' Wilson'. 
               PRINT /                    '|'21               '|'45 #IlbORA(T48,F11.4) #IubORA(T61,F11.4) ' Asymptotic'. 
            END IF.
         ELSE IF (#AP=0).
            PRINT /'     Odds ratio (OR)|' #OR (T27,F11.4) '|'45 #lbOR(T48,F11.4)  #ubOR (T61,F11.4) ' Exact'. 
            PRINT /'  (exposure-disease)|'                 '|'45 #lbORW(T48,F11.4) #ubORW(T61,F11.4) ' Wilson'. 
            COMPUTE #IlbOR=1/#ubOR.
            COMPUTE #IlbORW=1/#ubORW.
            PRINT /'    reciprocal(1/OR)|         infinity'    '|'45 #IlbOR(T48,F11.4) '    infinity Exact'. 
            PRINT /                    '|'21                   '|'45 #IlbORW(T48,F11.4)'    infinity Wilson'. 
         ELSE.
            PRINT /'     Odds ratio (OR)|         infinity'    '|'45 #lbOR(T48,F11.4) '    infinity Exact'.
            PRINT /'  (exposure-disease)|'                     '|'45 #lbORW(T48,F11.4)'    infinity Wilson'. 
         END IF.
         PRINT  /'--------------------+-----------------------+-------------------------------------'.
         PRINT  /'TEST OF EXACT SYMMETRY '.
         PRINT  /'McNemar matched-pair|'                     '|'45  'P = '51 #s2 (F7.6) ' (Exact)'.
         PRINT  /'         Chi-Square |' #MN_Chi2 (T29,F9.4) #TMN(A2)'|'45  'P = '51 #MN_sp (F7.6). 
         PRINT  /'          Corrected |' #MN_Chi2C(T29,F9.4) '|'45  'P = '51 #MN_spC(F7.6). 
         PRINT  /'--------------------+-----------------------+-------------------------------------'.
         PRINT  /'TEST OF ASSOCIATION'.
         PRINT  /'                 OR |' #ORass (T29,F9.4)   '|'45.
         PRINT  /'         Chi-Square |' #Chi2 (T29,F9.4) #TChi(A3)'|'45  'P = '51 #sp (F7.6). 
         PRINT  /'          Corrected |' #Chi2C(T29,F9.4)    '|'45  'P = '51 #spC(F7.6). 
         PRINT  /'--------------------+-----------------------+-------------------------------------'.
         DO IF (#WARNDEC=1).
            PRINT / '(.)WARNING: Number of cases with decimal values.'.
            PRINT / '            The values are printed rounded.'.
         END IF.
         PRINT  /'Recommended CI'.
         DO IF ((#AP+#PA)<10).
            PRINT /'(*)WARNING: Small samples for McNemar matched-pair test'.
         END IF.
         DO IF (#WARNCHI=1).
            PRINT /'(**)WARNING: Small samples for Association Chi-Square'.
         END IF.
   
******** RELATIVE SYMMETRY.
******** Not for Case-control studies.
         DO IF (#ST=1).
            COMPUTE #A1=#PA.
            COMPUTE #A0=#AP.
            COMPUTE #B1=#PP.
            COMPUTE #B0=#AA.
            COMPUTE #M1=#A0+#A1.
            COMPUTE #M0=#B0+#B1.
            COMPUTE #N1=#A1+#B1.
            COMPUTE #N0=#A0+#B0.
            COMPUTE #N=#N1+#N0.      
      
            COMPUTE #Prop=#M1/#N.
            COMPUTE #P1=#A1/#N1.
            COMPUTE #P0=#A0/#N0.
   
***         Proportion Difference (PD).
            COMPUTE #PD= #P1-#P0.
*           Wald CI of difference of two proportions.
            COMPUTE #SEWa= SQR(#P1*(1-#P1)/#N1 + #P0*(1-#P0)/#N0).
            COMPUTE #lbPDWa= #PD - #SEWa*#Z.
            COMPUTE #ubPDWa= #PD + #SEWa*#Z.
*           Newcombe-Wilson CI of difference of two proportions.
            COMPUTE #F0= #A0**2 /(#N0**2 + #N0*#Z**2).
            COMPUTE #F1= #A1**2 /(#N1**2 + #N1*#Z**2).
            COMPUTE #W0= (2*#A0 + #Z**2)/(2*(#N0 + #Z**2)).
            COMPUTE #W1= (2*#A1 + #Z**2)/(2*(#N1 + #Z**2)).
            COMPUTE #L0= #W0 - SQR(#W0**2 - #F0).
            COMPUTE #L1= #W1 - SQR(#W1**2 - #F1).
            COMPUTE #U0= #W0 + SQR(#W0**2 - #F0).
            COMPUTE #U1= #W1 + SQR(#W1**2 - #F1).
            COMPUTE #lbPDWi= #PD - SQR((#P1-#L1)**2 + (#U0-#P0)**2).
            COMPUTE #ubPDWi= #PD + SQR((#U1-#P1)**2 + (#P0-#L0)**2).
   
***         Proportion Ratio (PR).
            COMPUTE #PR=#P1/#P0.
            COMPUTE #SElnPR = SQR((1/#A0)-(1/#N0)+(1/#A1)-(1/#N1)).
            COMPUTE #lbPR= #PR*EXP((-1)*#Z*#SElnPR).
            COMPUTE #ubPR= #PR*EXP(#Z*#SElnPR).
   
***         Odds Ratio.
            COMPUTE #OR= (#A1/#B1)/(#A0/#B0).
            COMPUTE #SElnOR = SQR(1/#A0+1/#B0+1/#A1+1/#B1).
            COMPUTE #lbOR= #OR*EXP((-1)*#Z*#SElnOR).
            COMPUTE #UbOR= #OR*EXP(#Z*#SElnOR).
   
***         Chi-Square.
            COMPUTE #Chi2 = #N*((#A1*#B0-#A0*#B1)**2) / (#M1*#M0*#N1*#N0).
            COMPUTE #Chi2c= #N*(((ABS(#A1*#B0-#A0*#B1))-#N/2)**2) / (#M1*#M0*#N1*#N0).
            IF ( ABS(#A1*#B0-#A0*#B1) < (#N/2) ) #Chi2c=0.
            COMPUTE #sp= (1- CDF.CHISQ(ABS(#Chi2),1)).
            COMPUTE #spC=(1- CDF.CHISQ(ABS(#Chi2C),1)).
            COMPUTE #TChi='   '.
            COMPUTE #WARNCHI=0.
            IF (#M1*#N1/#N<5 OR #M0*#N1/#N<5 OR #M1*#N0/#N<5 OR #M0*#N0/#N<5) #WARNCHI=1.
            IF (#WARNCHI=1) #TChi='**'.
            
*           Print RELATIVE SYMMETRY results.
            PRINT///'2x2 Table (RELATIVE SYMMETRY)'.
            PRINT /'                    |Response of exposure X |'.
            PRINT /'                    |       (-) |       (+) |   TOTAL   Proportion'.
            PRINT /'--------------------+-----------+-----------+---------------------'.
            PRINT /'CHANGE of Y     Yes |' #A0(T25,F7) #TDec(A1) '|'33 #A1(T37,F7) #TDec(A1) '|'45 #M1 (T46,F8) #TDec(A1) #Prop(F12.6).
            PRINT /'   versus X      No |' #B0(T25,F7) #TDec(A1) '|'33 #B1(T37,F7) #TDec(A1) '|'45 #M0 (T46,F8) #TDec(A1).
            PRINT /'--------------------+-----------+-----------+---------------------'.
            PRINT /'              TOTAL |' #N0(T25,F7) #TDec(A1) '|'33 #N1(T37,F7) #TDec(A1) '|'45 #N (T46,F8) #TDec(A1).
            PRINT /'   Prop. of changes |' #P0(T24,F8.6)'|'33 #P1(T36,F8.6)'|'45.
            PRINT//'--------------------+-----------------------+-------------------------------------'.
            PRINT /'                    |        Estimate       | '!QUOTE(!CL)'% Confidence Interval'.
            PRINT /'--------------------+-----------------------+-------------------------------------'.
            PRINT /'   Prop. Diff. (PD) |'#PD(T27,F11.6) '|'45 #lbPDWa(T48,F11.6) #ubPDWa(T61,F11.6) ' Wald'. 
            PRINT /                    '|'21             '|'45 #lbPDWi(T48,F11.6) #ubPDWi(T61,F11.6) ' Newcombe'.
            DO IF (#A1>0 and #A0>0).
               PRINT /'   Prop. Ratio (PR) |'#PR(T27,F11.4) '|'45 #lbPR(T48,F11.4) #ubPR(T61,F11.4).
               DO IF (#PR<1).
                  COMPUTE #IPR=1/#PR.
                  COMPUTE #IlbPR=1/#ubPR.
                  COMPUTE #IubPR=1/#lbPR.
                  PRINT /'   reciprocal(1/PR) |'#IPR(T27,F11.4) '|'45 #IlbPR(T48,F11.4) #IubPR(T61,F11.4).
               END IF.
            ELSE IF (#A1=0).
               PRINT /'   Prop. Ratio (PR) |            0'        '|'45.
               PRINT /'   reciprocal(1/PR) |         infinity'    '|'45.
            ELSE IF (#A0=0).
               PRINT /'   Prop. Ratio (PR) |         infinity'    '|'45.
            END IF.
            DO IF (#A1>0 AND #A0>0 AND #B1>0 AND #B0>0).
               PRINT /'    Odds ratio (OR) |'#OR(T27,F11.4) '|'45 #lbOR(T48,F11.4) #ubOR(T61,F11.4).
               DO IF (#OR<1).
                  COMPUTE #IOR=1/#OR.
                  COMPUTE #IlbOR=1/#ubOR.
                  COMPUTE #IubOR=1/#lbOR.
                  PRINT /'   reciprocal(1/OR) |'#IOR(T27,F11.4) '|'45 #IlbOR(T48,F11.4) #IubOR(T61,F11.4).
               END IF.
            ELSE IF (#A1=0).
               PRINT /'    Odds ratio (OR) |            0'        '|'45.
               PRINT /'   reciprocal(1/OR) |         infinity'    '|'45.
            ELSE IF (#A0=0 OR #B1=0 OR #B0=0).
               PRINT /'    Odds ratio (OR) |         infinity'    '|'45.
            END IF.
            PRINT /'--------------------+-----------------------+-------------------------------------'.
            PRINT /'TEST OF RELATIVE SYMMETRY'.
            PRINT /'         Chi-Square |'#Chi2 (T29,F9.4) #TChi(A3)'|'45  'P = '51 #sp (F7.6). 
            PRINT /'          Corrected |'#Chi2C(T29,F9.4) '|'45  'P = '51 #spC(F7.6). 
            PRINT /'--------------------+-----------------------+-------------------------------------'.
            DO IF (#WARNDEC=1).
               PRINT / '(.)WARNING: Number of cases with decimal values.'.
               PRINT / '            The values are printed rounded.'.
            END IF.
            PRINT /'Recommended CI'.
            DO IF (#WARNCHI=1).
               PRINT /'(**)WARNING: Small samples for Association Chi-Square'.
            END IF.
         END IF.
      END IF.
!IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
