PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
  PRINT /'Macro !CI2R V2009.04.27 loaded.'
        /'Execute !CI2R HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !CI2R ( R1= !CHAREND('/')
              /N1= !CHAREND('/')
              /R0= !CHAREND('/')
              /N0= !CHAREND('/')
              /CL= !CHAREND('/') !DEFAULT('95')
             /NST= !CHAREND('/')
            /HELP= !CHAREND('/') !DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2009.04.27').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
   PRINT //'Macro !CI2R V' !VERSION ' (c)JM.Domenech'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*  Print HELP.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* CONFIDENCE INTERVAL FOR COMPARING TWO PEARSON CORRELATIONS                 *'
            /'* Created 2009.04.27 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech                                                            *'
            /'* Programmer: R.Sesma                                                        *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM. Macro !CI2R for SPSS Statistics.                              *'
            /'*    Confidence Interval for comparing two Pearson Correlations              *'
            /'*    [computer program].                                                     *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro call for comparing two pearson correlations                          *'
            /'* !CI2R R1 = Pearson correlation in group 1                 (-1 <= R1 <= 1)  *'
            /'*      /N1 = Sample size of group 1                         (Integer > 3 )   *'
            /'*      /R0 = Pearson correlation in group 0                 (-1 <= R0 <= 1)  *'
            /'*      /N0 = Sample size of group 0                         (Integer > 3 )   *'
            /'*----------------------------------------------------------------------------*'
            /'* Macro call for comparing one correlation with a hypothetical correlation:  *'
            /'* !CI2R R1 = Pearson correlation                            (-1 <= R1 <= 1)  *'
            /'*      /N1 = Sample size                                    (Integer > 3 )   *'
            /'*      /R0 = Hypothetical pearson correlation               (-1 <= R0 <= 1)  *'
            /'* Parameters for ALL studies:                                                *'
            /'*----------------------------------------------------------------------------*'
            /'*   [/CL]= Confidence level(%); by default: 95 (50 <= CL < 100)              *'
            /'*  [/NST]= Name of the study (Label)                                         *'
            /'*  [/HELP] Print Macro call arguments and Samples of calls                   *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in square brackets [ ] are optional              *'
            /'*       Macro tested for SPSS 15.0 and higher                                *'
            /'*                                                                            *'
            /'* Samples of calls:                                                          *'
            /'*  !CI2R HELP.                                                               *'
            /'*  !CI2R R1=0.65 /N1=84 /R0=0.40 /N0=101.                                    *'
            /'*  !CI2R R1=0.9414 /N1=10 /R0=0.40 /CL=95 /NST="Name of the study".          *'
            /'******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Test parameters.
   !IF (!R1=!NULL !OR !N1=!NULL !OR !R0=!NULL) !THEN.
      PRINT /'ERROR: Missing parameter(s) R1,N1 or R0. See the HELP.'.
   !ELSE.
      COMPUTE #ERROR=0.
      
*     Test parameters R1,N1,R0.
      COMPUTE #R1=$SYSMIS.
      COMPUTE #N1=$SYSMIS.
      COMPUTE #R0=$SYSMIS.
      COMPUTE #R1=!R1.
      COMPUTE #N1=!N1.
      COMPUTE #R0=!R0.
      DO IF SYSMIS(#R1).
         COMPUTE #ERROR=1.
      ELSE IF SYSMIS(#R0).
         COMPUTE #ERROR=2.
      ELSE IF SYSMIS(#N1).
         COMPUTE #ERROR=3.
      ELSE.
         IF (#R1<-1 OR #R1>1) #ERROR=1.
         IF (#R0<-1 OR #R0>1) #ERROR=2.
         IF (#N1<=3) #ERROR=3.
         IF (MOD(#N1,1)<>0) #ERROR=4.
      END IF.
*     Test parameter N0.
      COMPUTE #N0=$SYSMIS.
      COMPUTE #Hypo=1.
      !IF (!N0<>!NULL) !THEN.
         COMPUTE #N0=!N0.
         COMPUTE #Hypo=0.
         DO IF SYSMIS(#N0).
            COMPUTE #ERROR=5.
         ELSE.
            IF (#N0<=3) #ERROR=5.
            IF (MOD(#N0,1)<>0) #ERROR=6.
         END IF.
      !IFEND.
*     Test parameter CL.
      COMPUTE #CL=$SYSMIS.
      COMPUTE #CL=!CL.
      DO IF (SYSMIS(#CL)).
         COMPUTE #ERROR=7.
      ELSE.
         IF (#CL<50 OR #CL>=100) #ERROR=7.
      END IF. 

      DO IF (#ERROR=1).
         PRINT /'ERROR: Parameter R1 with wrong value. See the HELP.'.
      ELSE IF (#ERROR=2).
         PRINT /'ERROR: Parameter R0 with wrong value. See the HELP.'.
      ELSE IF (#ERROR=3).
         PRINT /'ERROR: Parameter N1 with wrong value. See the HELP.'.
      ELSE IF (#ERROR=4).
         PRINT /'ERROR: Parameter N1 with decimal value. See the HELP.'.
      ELSE IF (#ERROR=5).
         PRINT /'ERROR: Parameter N0 with wrong value. See the HELP.'.
      ELSE IF (#ERROR=6).
         PRINT /'ERROR: Parameter N0 with decimal value. See the HELP.'.
      ELSE IF (#ERROR=7).
         PRINT /'ERROR: Parameter CL with wrong value. See the HELP.'.
      ELSE.
*        Correct parameters.
*        Print header.
         DO IF (#Hypo).
            PRINT /'COMPARING ONE PEARSON CORRELATION WITH A HYPOTETICAL CORRELATION'.
         ELSE.
            PRINT /'CONFIDENCE INTERVAL FOR COMPARING TWO PEARSON CORRELATIONS'.
         END IF.
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.

         COMPUTE #W = LN(SQRT((1+#R1)/(1-#R1)))-LN(SQRT((1+#R0)/(1-#R0))).
         COMPUTE #SE = SQRT(1/(#N1-3)).
         IF (NOT #Hypo) #SE = SQRT(1/(#N1-3) + 1/(#N0-3)).
         COMPUTE #Z = #W/#SE.
         COMPUTE #S = 2*(1-CDF.NORMAL(ABS(#Z),0,1)).
         COMPUTE #D = #R1-#R0.
         
         DO IF (#Hypo).
            PRINT//'Sample:       R1 = '!QUOTE(!R1).
            PRINT /'              N1 = '!QUOTE(!N1).
            PRINT /'Hypothetical: R0 = '!QUOTE(!R0).   
            PRINT//'Difference: R1-R0= ' #D (F8.5).
            PRINT /'Significance (two-sided test):  Z='#Z (F6.2) '  p='#S (F8.6).
         ELSE.
            COMPUTE #P = (#CL+100)/200.
            COMPUTE #ZI= #W - IDF.NORMAL(#P,0,1)*#SE.
            COMPUTE #ZS= #W + IDF.NORMAL(#P,0,1)*#SE.
            COMPUTE #LI= (EXP(2*#ZI)-1) / (EXP(2*#ZI)+1).
            COMPUTE #LS= (EXP(2*#ZS)-1) / (EXP(2*#ZS)+1).

            PRINT//'Sample 1:  R1 = '!QUOTE(!R1).
            PRINT /'           N1 = '!QUOTE(!N1).
            PRINT /'Sample 0:  R0 = '!QUOTE(!R0).
            PRINT /'           N0 = '!QUOTE(!N0).
            PRINT//'Difference: R1-R0= ' #D (F7.5).
            PRINT /'  '!QUOTE(!CL)'% CI of R1-R0:' #LI (F8.5) '  to' #LS (F8.5) .
            PRINT /'Significance (two-sided test):  Z='#Z (F6.2) '  p='#S (F8.6).
         END IF. 
      END IF.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
