PRESERVE.
SET ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !DR V2008.02.29 cargada.'
         /'Ejecutar !DR HELP. para imprimir la documentacin y la referencia bibliogrfica de la Macro.'/.
END IF.
DEFINE !DR ( V=!CHAREND('/') 
            /C=!CHAREND('/')!DEFAULT('@Id') 
           /VL=!CHAREND('/')
           /DI=!CHAREND('/')
           /DF=!CHAREND('/')
           /DD=!CHAREND('/')
          /DDl=!CHAREND('/')
          /DDu=!CHAREND('/')
           /VK=!CHAREND('/') 
        /TABLE=!CHAREND('/')
            /F=!CHAREND('/')
       /RENAME=!CHAREND('/')
           /ND=!CHAREND('/') 
       /SYSMIS=!CHAREND('/')!DEFAULT(0)
          /DUP=!CHAREND('/')
            /R=!CHAREND('/')!DEFAULT(1)
       /FORMAT=!CHAREND('/')!DEFAULT(0)
         /VarL=!CHAREND('/')
           /CN=!CHAREND('/')!DEFAULT('@casenum')
            /L=!CHAREND('/')!DEFAULT(1) 
          /NST=!CHAREND('/')  
         /HELP=!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINT=NONE ERRORS=NONE LENGTH=NONE WIDTH=132 MESSAGES=NONE.
!LET !VERSION=!QUOTE('2008.02.29').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
*Impresin de la cabecera.
DO IF ($casenum=1).
  PRINT //'Macro !DR V' !VERSION ' (c)JM.Domenech & A.Bonillo'.
END IF.

!IF (!HELP<>1) !THEN
*Impresin de la documentacin.
+  DO IF ($casenum=1).
+    PRINT /'******************************************************************************'
           /'* DEPURACIN DE DATOS: DETECCIN DE DUPLICADOS Y                             *'
           /'*             VERIFICACIN DE RANGOS DE VARIABLES NUMRICAS, CADENA Y FECHA  *'
           /'* Creacin 1998.11.30 ltima revisin ' !VERSION                            '*'78
           /'* (c) JM.Domenech & A.Bonillo                                                *'
           /'* Programador: A.Bonillo                                                     *'
           /'*                                                                            *'
           /'* Referencia Vancouver:                                                      *'
           /'* Domenech JM, Bonillo A. Macro !DR para SPSS Statistics.                    *'
           /'*    Depuracin de Datos: Deteccin de Duplicados y Verificacin de Rangos   *'
           /'*    de Variables Numricas, Cadena y Fecha [programa informtico].          *'
           /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
           /'*    Disponible en: http://www.metodo.uab.cat/macros.htm.                    *'
           /'*                                                                            *'
           /'* Llamada de la Macro:                                                       *'
           /'*     !DR V= Lista de variables a verificar                                  *'
           /'*----------------------------------------------------------------------------*'
           /'* Parmetros para detectar duplicados                                        *'
           /'*     /DUP = Deteccin de duplicados (1=S, 0=No)   (por defecto,  0)        *'
           /'*    [/R  ]= Nmero de registros que deben tener igual identificador         *'
           /'*                                                   (por defecto,  1)        *'
           /'*     [/VL]= Lista de valores vlidos (en formato SPSS)                      *'
           /'*                                                                            *'
           /'* Ejemplos de llamada:                                                       *'
           /'*       !DR V= caso /DUP=1.                                                  *'
           /'*       !DR V= caso /DUP=1 /VL=1 thru 150.                                   *'
           /'*----------------------------------------------------------------------------*'
           /'* Parmetros para variables numricas y cadenas                              *'
           /'*      /VL = Lista de valores vlidos (en formato SPSS)                      *'
           /'*     [/ND]= Nmero mximo de cifras decimales de los valores                *'
           /'* [/FORMAT]= Verificacin de formato (1=S, 0=No)   (por defecto,  0)        *'
           /'*                                                                            *'
           /'* Ejemplos de llamada:                                                       *'
           /'*       !DR V=sexo /VL="M","F"," ".                                          *'
           /'*       !DR V=talla /VL=0.95 thru 2 /ND=2.                                   *'
           /'*       !DR V=dpt dcs /VL=1,2,3.                                             *'
           /'*----------------------------------------------------------------------------*'
           /'* Parmetros para valores contenidos en una tabla diccionario                *'
           /'*   /TABLE= Nombre del archivo .SAV con el DICCIONARIO de cdigos            *'
           /'*      /VK= Lista de los identificadores en el DICCIONARIO (por defecto, V)  *'
           /'*     [/F]= Formato de la variable V a verificar, si es cadena               *'
           /'*               An (n: nmero de caracteres)                                 *'
           /'*  [/VarL]= Lista de otras variables a listar.                               *'
           /'*[/RENAME]= Lista de variables a renombrar            (por defecto ninguna)  *'
           /'*                                                                            *'
           /'* Ejemplos de llamada:                                                       *'
           /'*       !DR V=CIE /VK=CIE9 /F=A6 /TABLE="C:\...\CIE9.SAV".                   *'
           /'*----------------------------------------------------------------------------*'
           /'* Parmetros para verificar un campo fecha expresado en fechas               *'
           /'*      /DI = Fecha inicial: da, mes, ao                                    *'
           /'*      /DF = Fecha final  : da, mes, ao                                    *'
           /'* [/FORMAT]= Verificacin de formato (1=S, 0=No)   (por defecto,  0)        *'
           /'*                                                                            *'
           /'* Ejemplos de llamada:                                                       *'
           /'*       !DR V=fr /DI=1,4,1993 /DF=30,12,1993 /SYSMIS=1.                      *'
           /'*----------------------------------------------------------------------------*'
           /'* Parmetros para verificar un campo fecha expresad en fechas                *'
           /'*      /DD = Diferencia entre los campos fecha a la de referencia            *'
           /'*     /DDl = Valor mnimo del tiempo transcurrido (das)                     *'
           /'*     /DDu = Valor mximo del tiempo transcurrido (das)                     *'
           /'* [/FORMAT]= Verificacin de formato (1=S, 0=No)   (por defecto,  0)        *'
           /'*                                                                            *'
           /'* Ejemplos de llamada:                                                       *'
           /'*       !DR V=fn /DD=fr-fn /DDl=365.25*6 /DDu=365.25*45.                     *'
           /'*----------------------------------------------------------------------------*'
           /'* Parmetros para todo tipo de variables                                     *'
           /'* [/SYSMIS]= Deteccin del valor sysmis (1=S, 0=No)   (por defecto,  0)     *'
           /'*   [/VarL]= Lista de otras variables a listar                               *'
           /'*   [ /NST]= Nombre del estudio (Etiqueta)                                   *'
           /'*    [/HELP] Imprimir documentacin de la Macro y ejemplos de llamadas       *'
           /'*      [/C]= Lista de variables identificadoras del sujeto                   *'
           /'*                                                     (por defecto,@Id)      *'
           /'*     [/CN]= Variable identificadora de la secuencia de los sujetos          *'
           /'*                                                     (por defecto,@casenum) *'
           /'*      [/L]= Listado de incidencias (1=Errores, 0=Ninguno)                   *'
           /'*                                                     (por defecto,  1)      *'
           /'* Nota: Los parmetros incluidos entre corchetes [] son opcionales           *'
           /'*       Macro verificada en SPSS 15.0 y superior                             *'
           /'*                                                                            *'
           /'* ATENCIN: La macro presenta resultados errneos si hay casos filtrados.    *'
           /'*           Si desea trabajar con un subconjunto de los datos utilice la     *'
           /'*           instruccin SELECT IF para generar un conjunto de datos nuevo    *'
           /'*           que tenga slo los casos seleccionados.                          *'
           /'******************************************************************************'.
+  END IF.
+  EXECUTE.
+  !ELSE.
*     Comprobacin de parmetros.
+    !IF (!V=!NULL) !THEN
+      DO IF ($casenum=1).
+        PRINT /'ERROR: Falta parmetro'.
+      END IF.
+      EXECUTE.
+    !ELSE.
      !IF (!NST !NE !NULL) !THEN .        /*Print NST if available.
         DO IF ($casenum=1).
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('ESTUDIO: ',!NST).
            PRINT /#NST.
         END IF.
      !IFEND.
*      Comprobacin del algoritmo a realizar.
*      DETECCIN DE DUPLICADOS.
+      !IF (!DUP<>!NULL !OR !R<>1 ) !THEN

*         Nombre de la variable auxiliar.
+        !LET !NAME=N_IDT@.
*         Borrado de la variable n_idt@ si exista.
+         MATCH FILES /FILE=* /DROP=!NAME.
+         MATCH FILES /FILE=* /DROP=I_IDT@.

*         Creacin de variables auxiliares V@. 
+         !LET !V@=!NULL.
+         !DO !I !IN (!V).
+           !LET !V@=!CONCAT(!I,'@ ',!V@).
+         !DOEND.

*         Creacin de variables numricas usar RANK.
+         AUTORECODE VARIABLES =!V /into !V@.

*         Conteo de registros.
+         RANK !HEAD(!V@) BY !V@ /N into !NAME /PRINT=NO.
*         Secuencia de registros.
+         RANK !CN BY !V@ /RANK into I_IDT@ /PRINT=NO.
+         FORMATS I_IDT@ (F4).
+         VARIABLE LABEL !NAME !CONCAT ('Nmero de registros que comparten ',!V)
                         I_IDT@ 'Secuencia de registros'.

*         Borrado de las variables auxiliares.
+         MATCH FILES /FILE=* /DROP=!V@.

+         !IF (!L>=1) !THEN
*          Asignacin de la @ a una variable temporal.
+          RENAME VARIABLES (!NAME=@@).
+          TEMPORARY.
+            SELECT IF (@@<>!R).
+            STRING !NAME (A18).
+            IF (@@<10) !NAME=CONCAT('Repetido ',STRING(@@,F1),' veces').
+            IF (@@>=10 AND @@<100) !NAME=CONCAT('Repetido ',STRING(@@,F2),' veces').
+            IF (@@>=100 AND @@<1000) !NAME=CONCAT('Repetido ',STRING(@@,F3),' veces').
+            LIST !CN !V !NAME !VarL.
+            RENAME VARIABLES (@@=!NAME).
+         !IFEND.

+         !IF (!DUP=1) !THEN
+            TITLE "Instrucciones de eliminacin de duplicados".
+            DO IF (!NAME<>I_IDT@).
+              PRINT /'SELECT IF (' !QUOTE(!CN) ' <> ' !CN  ').' . 
+            END IF.
+            EXECUTE.
+            DO IF ($CASENUM=1).
+              PRINT / 'EXECUTE.' . 
+            END IF.
+            EXECUTE.
+            TITLE "FIN de las instrucciones de eliminacin de duplicados".
+         !IFEND.

+      !IFEND.

+      !DO !I !IN (!V).

*        Creacin del nombre de variable cadena "hermana".
+        !IF (!FORMAT=1) !THEN
+          !LET !@FORMAT = !CONCAT('',!I).
+        !ELSE 
+          !LET !@FORMAT = !EVAL(!I).
+        !IFEND.

*        DEPURACIN DE RANGO CUANTITATIVA O CATEGRICA.
+        !IF (!VL<>!NULL) !THEN

*           Nombre de la variable auxiliar.
+           !IF ( !INDEX(!VL,"'")<>0) !THEN.
+             !LET !@V= !CONCAT('@1',!I).
+           !ELSE.
+             !LET !@V = !CONCAT('@',!I).
+           !IFEND. 

*           Si VarL existe debemos comprobar slo los casos que han cumplido la condicin.
+          !IF (!VarL<>!NULL) !THEN
+            DO IF (MISSING(!@V)).
+          !ELSE.
+            COMPUTE !@V=$SYSMIS.
+          !IFEND.

+          FORMATS !@V (F1).
*          Comprobacin rango o lista de valores.
+          DO IF (!SYSMIS=1).
+            RECODE !I (MISSING=0) (!VL=-1) (ELSE=2) INTO !@V.
+          ELSE IF (!SYSMIS=0).
+            RECODE !I (MISSING,!VL=-1) (ELSE=2) INTO !@V.
+          END IF.

*          Comprobar que V no tiene exceso de precisin.
+          !IF (!ND<>!NULL) !THEN
+            COMPUTE #MOD=MOD(!I*10**!ND,1).
+            IF (#MOD>0.5) #MOD=1-#MOD.
+            IF (#MOD>0) !@V=4.
+            IF (#MOD>(10**-(!ND*2)) ) !@V=3.
+          !IFEND.

+          !IF (!DUP<>!NULL) !THEN
+            RECODE !I (MISSING=0) (!VL=-1) (ELSE=2) INTO !@V.
+            COMPUTE #MOD=MOD(!I*10**0,1).
+            IF (#MOD>0.5) #MOD=1-#MOD.
+            IF (#MOD>0) !@V=4.
+            IF (#MOD>(10**-(!ND*2)) ) !@V=3.
+          !IFEND.

+          !IF (!VarL<>!NULL) !THEN
+            END IF.
+          !IFEND.

+        !ELSE.
*          DEPURACIN DE UNA FECHA.
+          !IF (!DI<>!NULL !OR !DF<>!NULL) !THEN

*            Nombre de la variable auxiliar.
+            !LET !@V = !CONCAT('@2',!I).

*            Si VarL existe debemos comprobar slo los casos que han cumplido la condicin.
+           !IF (!VarL<>!NULL) !THEN
+             DO IF (MISSING(!@V)).
+           !ELSE.
*             Si no existe VarL la variable @ es inicializada.
+             COMPUTE !@V=$SYSMIS.
+           !IFEND.

*             Comprobacin del intervalo rango y missing.
+             IF (RANGE(!I, DATE.DMY(!DI), DATE.DMY(!DF))) !@V=-1.
+             IF (NOT(RANGE(!I, DATE.DMY(!DI), DATE.DMY(!DF)))) !@V=2.
+             IF (!SYSMIS=0 AND MISSING(!I) ) !@V=-1.
+             IF (!SYSMIS=1 AND MISSING(!I) ) !@V= 0.
+             FORMATS !@V (F1).
+            !IF (!VarL<>!NULL) !THEN
+              END IF.
+            !IFEND.
+          !ELSE.
*            DEPURACIN DE UN RANGO ENTRE FECHAS.
+            !IF (!DD<>!NULL !AND (!DDl<>!NULL !OR !DDu<>!NULL) ) !THEN

*              Deteccin de la diferencia.
+              !LET !V1 = !HEAD(!DD).
+              !LET !V2 = !TAIL(!TAIL(!DD)).
+              !IF (!head(!v)=!v1) !THEN
+                !LET !DDD= !concat(!i,'-',!V2).
+              !ELSE.
+                !LET !DDD= !concat(!V1,'-',!i).
                 !LET !V2= !V1.
+              !IFEND.

*              Nombre de la variable auxiliar.
+              !LET !@V = !CONCAT('@2',!I).

*              Si VarL existe debemos comprobar slo los casos que hayan cumplido la condicin.
+              !IF (!VarL<>!NULL) !THEN
+                DO IF (MISSING(!@V)).
+              !ELSE.
*                Si no existe VarL la variable @ es inicializada.
+                COMPUTE !@V=$SYSMIS.
+              !IFEND.

*              Comprobacin de rango y missing.
+              IF RANGE(CTIME.DAYS(!EVAL(!DDD)),!DDl, !DDu) OR MISSING(!V2) !@V=-1.
+              IF NOT RANGE(CTIME.DAYS(!EVAL(!DDD)),!DDl, !DDu) !@V=2.
+              IF (!SYSMIS=0 AND MISSING(!EVAL(!DDD)) ) !@V=-1.
+              IF (!SYSMIS=1 AND MISSING(!EVAL(!DDD)) ) !@V= 0.
+              FORMATS !@V (F1).

+             !ELSE.
*              DEPURACIN A TRAVS DE UN DICCIONARIO.
+               !IF (!TABLE<>!NULL !AND (!DDl=!NULL !OR !DDu=!NULL) !AND !VL=!NULL ) !THEN
+                 !LET !SBLANK=!NULL.
+                 !LET !BLANK=' '.
+                   !LET !SBLANK=!CONCAT(!SBLANK,!BLANK).
*                   Conteo de variables para construir los nombres.
+                   !LET !COUNT=!LENGTH(!SBLANK).
+                   !LET !RENAME2=!NULL.
*                   Nombres a renombrar.
+                   !DO !J !IN (!RENAME).
+                     !LET !RENAME2=!CONCAT(!RENAME2,' ',!CONCAT(!J,!COUNT)).
+                   !DOEND.

*                   Nombre de variable cadena "hermana".
+                   !IF (!FORMAT=1) !THEN
+                     !LET !@FORMAT = !CONCAT('',!I).
+                   !ELSE 
+                     !LET !@FORMAT = !EVAL(!I).
+                   !IFEND.

*                   Asignacin de los identificadores.
+                   !IF (!VK=!NULL) !THEN 
+                     !LET !TVK=!EVAL(!I).
+                   !ELSE
+                     !LET !TVK=!EVAL(!VK).
+                   !IFEND.

+                   SORT CASES BY !I.

*                   Nombre de la variable auxiliar.
+                   !LET !@Vt= !CONCAT('@t',!I).
+                   !LET !@V = !CONCAT('@1',!I).

*                   Si VarL existe debemos asignamos los errores lgicos a una variable temporal.
+                   !IF (!VarL<>!NULL) !THEN 
+                     COMPUTE @=!@V.
+                   !IFEND.

*                   Si la variable @ existe es borrada.
+                   MATCH FILES /FILE=*  /DROP=!@V.

*                   Creado de una variable con nombre controlado para poder borrar despus.
+                   COMPUTE @@@X@@@=$SYSMIS.

*                   Creacin de la variable cadena con longitud determinada.
+                   !IF (!F<>!NULL) !THEN
+                     STRING @tempK (!F).
+                     COMPUTE @tempK=!I.
+                     RENAME VARIABLES (!I @tempK=@tempK !I).
+                   !IFEND.

*                   Aadido del diccionario.
+                   MATCH FILES /FILE=*  /TABLE=!TABLE  
                    !IF (!VK<>!NULL) !THEN 
                          /RENAME= (!TVK=!I) 
                    !IFEND
                    !IF (!RENAME<>!NULL) !THEN 
                          /RENAME= (!RENAME=!RENAME2) 
                    !IFEND
                          /IN=!@Vt  /BY !I       .
+                   EXECUTE.

+                   !IF (!F<>!NULL) !THEN
+                     RENAME VARIABLES (@tempK !I=!I @tempK).
+                   !IFEND.

*                   Creacin de una variable con nombre controlado para poder borrar despus.
+                   COMPUTE @@@Y@@@=$SYSMIS.

*                   Borrado de las variables del diccionario aadidas.
+                   COMPUTE !@V=!@Vt.
+                   MATCH FILES /FILE=*  /DROP= @@@X@@@ TO  @@@y@@@.

*                   La variable auxiliar es cambiada a nuestra propuesta.
+                   RECODE !@V (0=2) (1=-1).
+                   IF ($SYSMIS=1 AND MISSING(!I) ) !@V=-1.

*                   Si VarL existe debemos asignamos los guardados en una variable temporal a la var @.
+                   !IF (!VarL<>!NULL) !THEN 
+                     COMPUTE !@V=MAX(@,!@V).
+                     MATCH FILES /FILE=* /DROP=@.
+                   !IFEND.
+                   SORT CASES BY @CASENUM.
+               !IFEND.
+            !IFEND.
+          !IFEND.
+        !IFEND.

*         PROCESOS GENERALES INDEPENDIENTEMENTE DE LA MACRO ADMINISTRADA.

*         Error de formato: comprobar que si V es missing la variable F debe estar vaca.
+         IF (!@FORMAT<>' ' AND SYSMIS(!I) ) !@V=1.

*         Etiquetas de la variable auxiliar.
+         !IF (!VL<>!NULL !OR !DI<>!NULL !OR !DF<>!NULL !OR !DD<>!NULL !OR !TABLE<>!NULL) !THEN
+           ADD VALUE LABEL !@V  -1 'Correcto' 0 'Missing'  1 'Error Formato' 
                                  2 'Fuera Rango' 3 'Error en Nmero Decimal' 4 'Pequeo Error de Precisin'.

*           Listado de casos con error.
+           !IF (!L>=1) !THEN
*             Asignacin de la @ a una variable temporal.
+             RENAME VARIABLES (!@V=@).
+             TEMPORARY.
*             Cambio de formato en V si se depura precisin.
+             !IF (!ND<>!NULL) !THEN
+               !LET !A=!CONCAT('F8.',!LENGTH(!CONCAT(!BLANKS(!ND),!BLANKS(1)))).
+               FORMATS !I (!A).
+             !IFEND.
+             DO IF (!L=1).
+               SELECT IF (@>=0).
+             ELSE IF (!L=2).
+               SELECT IF (@>=1).
+             END IF.
*             Variable auxiliar cadena para listar.
+             STRING !@V (A15).
+             IF (@= 0) !@V='0: Missing'. 
+             IF (@= 1) !@V='1: Err Formato'.
+             IF (@= 2) !@V='2: Fuera Rango'.
+             IF (@= 3) !@V='3: Err Num Dec'.
+             IF (@= 4) !@V='4: Peq Err Prec'.
+             IF (@>=10)!@V=CONCAT(STRING(@,F2),': Err Cond'). 
+             LIST !CN !C !@V !I  !V2  !VarL.
*             Asignacin de la variable temporal a la auxiliar @.
+             RENAME VARIABLES (@=!@V).
+           !IFEND.
+         !IFEND. 
+      !DOEND.
+    !IFEND.
!IFEND.  
EXECUTE.
RESTORE.
!ENDDEFINE.
EXECUTE.

DO IF ($casenum=1).
   PRINT /'Macro !INCIDEN V2008.02.29 cargada.'
         /'Ejecutar !INCIDEN HELP. para imprimir la documentacin y la referencia bibliogrfica de la Macro.'/.
END IF.
EXECUTE.
DEFINE !INCIDEN ( V=!CHAREND('/')
              /COMM=!CHAREND('/')!DEFAULT(1)
                 /C=!CHAREND('/')!DEFAULT('@Id')
                /CN=!CHAREND('/')!DEFAULT('@casenum') 
                 /L=!CHAREND('/')!DEFAULT(1)
               /NST=!CHAREND('/')
              /HELP=!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET ERRORS=NONE PRINTBACK=NONE LENGTH=NONE WIDTH=132 MESSAGES=NONE.
!LET !VERSION=!QUOTE('2008.02.29').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
   PRINT //'Macro !INCIDEN V' !VERSION ' (c)JM.Domenech & A.Bonillo'.
END IF.

!IF (!HELP<>1) !THEN
*Impresin de la documentacin.
+  DO IF ($casenum=1).
+    PRINT /'******************************************************************************'
           /'* DEPURACIN DE DATOS: Informe de incidencias                                *'
           /'* Creacin 1998.11.30 ltima revisin ' !VERSION                            '*'78
           /'* (c) JM.Domenech & A.Bonillo                                                *'
           /'* Programador: A.Bonillo                                                     *'
           /'*                                                                            *'
           /'* Referencia Vancouver:                                                      *'
           /'* Domenech JM, Bonillo A. Macro !INCIDEN para SPSS Statistics.               *'
           /'*    Depuracin de Datos: Informe de incidencias [programa informtico].     *'
           /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
           /'*    Disponible en: http://www.metodo.uab.cat/macros.htm.                    *'
           /'*                                                                            *'
           /'* Llamada de la Macro:                                                       *'
           /'* !INCIDEN V= Lista de variables auxiliares a verificar                      *'
           /'*    [   /C]= Lista de variables identificadoras del sujeto                  *'
           /'*                                                     (por defecto, @Id)     *'
           /'*    [  /CN]= Variable identificadora de la secuencia de los sujetos         *'
           /'*                                                     (por defecto, @casenum)*'
           /'*    [/COMM]= Suprime la lnea de comentarios en los IF (1=S, 0=No)         *'
           /'*                                                     (por defecto,  1)      *'
           /'*    [   /L]= Listado de incidencias (1=Errores, 0=Ninguno)                  *'
           /'*                                                     (por defecto,  1)      *'
           /'*    [ /NST]= Nombre del estudio (Etiqueta)                                  *'
           /'*     [/HELP] Imprimir documentacin de la Macro y ejemplos de llamadas      *'
           /'*                                                                            *'
           /'* Nota: Los parmetros incluidos entre corchetes [] son opcionales           *'
           /'*       Macro verificada en SPSS 15.0 y superior                             *'
           /'*                                                                            *'
           /'* ATENCIN: La macro trabaja sobre TODOS los casos (ignora posibles filtros).*'
           /'*           Si desea trabajar con un subconjunto de los datos utilice la     *'
           /'*           instruccin SELECT IF para generar un conjunto de datos nuevo    *'
           /'*           que tenga slo los casos seleccionados.                          *'
           /'*                                                                            *'
           /'* Ejemplos de llamada:                                                       *'
           /'* !INCIDEN V= @2fr @2fn @1sexo @talla @dpt @dcs @fuma @tab @1tiptab @1cie.   *'
           /'******************************************************************************'.
+  END IF.
EXECUTE.
!ELSE.
*   Comprobacin de parmetros.
+  !IF (!V=!NULL ) !THEN
+    DO IF ($casenum=1).
+      PRINT /'ERROR: Falta parmetro'.
+    END IF.
+    EXECUTE.
+  !ELSE

+     TEMPORARY.
+     COMPUTE a=1.
+     RANK A BY A /N into @ /PRINT=NO.

+     COUNT #NER=!V (0 thru HI).
+     COUNT #NC =!V (LO thru -1).
+     COMPUTE #NERcum=#NERcum+#NER.
+     COMPUTE #NCcum =#NCcum+#NC.
+     COMPUTE #TOT=SUM(#NERcum,#NCcum).
+     FORMATS #NERcum #NCcum #TOT (F8).

+     COMPUTE #PCTNER=100*#NERcum/#TOT.
+     COMPUTE #PCTNC =100*#NCcum/#TOT.
+     FORMATS #PCTNER #PCTNC (F5.2).

+     COMPUTE #@@=#@@+1.
+     DO IF (#@@=@).
        !IF (!NST !NE !NULL) !THEN .        /*Print NST if available.
           STRING #NST (A131).
           COMPUTE #NST = CONCAT('ESTUDIO: ',!NST).
           PRINT /#NST /.
        !IFEND.
+       PRINT /'ESTADSTICA DE INCIDENCIAS LISTADAS ------------+'.
+       PRINT /'Total ERRORES ............. ='#NERcum '(' #PCTNER '%)'.
+       PRINT /'Total valores correctos.... ='#NCcum  '(' #PCTNC  '%)'.
+       PRINT /'================================================+'/.
+     END IF.
+     EXECUTE.

+     !LET !CAB=!NULL.
+     !DO !i !IN (!C).
+       !IF (!CAB=!NULL) !THE 
+         !LET !CAB=!CONCAT(!CAB,!QUOTE(!CONCAT(!i,'= ')), !i).
+       !ELSE.
+         !LET !CAB=!CONCAT(!CAB,!QUOTE(!CONCAT(' ; ',!i,'= ')), !i).
+       !IFEND.
+     !DOEND.

*     Errores y missing.
+     COUNT #NER=!V (0 thru HI).
+     COUNT #NC =!V (LO thru -1).
+     FORMATS #NER #NC (F4).

*     Impresin de las cabeceras.
+     DO IF (#NER>0).
+       PRINT  /'Identificador caso:  ' !CAB. 
+       PRINT  /'Registro nm: ' !CN '; Nm. de errores=' #NER.
+       PRINT  /'------------------------------------------------+'.
+     END IF.

*     Impresin de valores.
+     !DO !i !IN (!V).
+       !IF (!SUBSTR(!i,2,1)='1' !OR !SUBSTR(!i,2,1)='2') !THEN 
+         !LET !VV=!SUBSTR(!i,3).
+       !ELSE.
+         !LET !VV=!SUBSTR(!i,2).
+       !IFEND. 

+       !LET !V=!CONCAT('',!VV).
+        DO IF (!i>=0 and !i<>3 AND !i<>4).
+          PRINT  /!QUOTE(!VV) ' = ' !VV '|'49. 
+        ELSE IF (!i=3 OR !i=4 ).
+          PRINT  /!QUOTE(!VV) ' = ' !VV '*' '|'49. 
+        END IF.

+     !DOEND.

*      Impresin del pie de las cabeceras.
+      DO IF (#NER>0).
+        PRINT /'================================================+'/.
+      END IF.
+      EXECUTE.

*     PRINTADO DE IFS.
+     COUNT #NER=!V (0 thru HI).
+     COUNT #NC =!V (-4 thru -1).
+     FORMATS #NER #NC (F4).

+     TITLE "Instrucciones de correccin de los errores".
+     DO IF (#NER>0 AND !COMM<>1).
+       PRINT //'* ID Case ' !CAB '.' . 
+     END IF.

+     !DO !i !IN (!V).
+       !IF (!SUBSTR(!i,2,1)='1' !OR !SUBSTR(!i,2,1)='2') !THEN 
+         !LET !VV=!SUBSTR(!i,3).
+       !ELSE.
+         !LET !VV=!SUBSTR(!i,2).
+       !IFEND. 

+        DO IF (!i>=0).
+         !IF (!SUBSTR(!i,2,1)='1') !THEN 
+            PRINT /'IF ' !CAB !QUOTE(!VV) '= " ".' . 
+         !ELSE.
+           !IF (!SUBSTR(!i,2,1)='2') !THEN 
+              PRINT /'IF ' !CAB !QUOTE(!VV) '= DATE.DMY($SYSMIS,0,0).' . 
+           !ELSE.
+              PRINT /'IF ' !CAB !QUOTE(!VV) '= $SYSMIS.' . 
+           !IFEND. 
+         !IFEND. 
+        END IF.
+     !DOEND.
+      MATCH FILE /FILE=* /DROP=@.
+      EXECUTE.
+      DO IF ($CASENUM=1).
+        PRINT / 'EXECUTE.' . 
+      END IF.
+      EXECUTE.
+      TITLE "FIN Instrucciones de correccin de los errores".
+  !IFEND.
!IFEND.
RESTORE.
!ENDDEFINE.

PRESERVE.
SET ERRORS=NONE.
EXECUTE.
RESTORE.
RESTORE.
