PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
  PRINT /'Macro !COMB V2008.02.29 loaded.'
        /'Execute !COMB HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !COMB( T  = !CHAREND('/')
             /N  = !CHAREND('/')
             /R  = !CHAREND('/')
             /NST= !CHAREND('/')
            /HELP= !CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2008.02.29').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
  PRINT //'Macro !COMB V' !VERSION ' (c)JM.Domenech'.
END IF.
TEMPORARY.
N 1.
COMPUTE #ERROR=0.
!IF (!HELP<>1) !THEN.
* Print the help.
  DO IF ($casenum=1).
     PRINT /'*****************************************************************'
           /'* COMBINATORICS                                                 *'
           /'* Created 2006.10.20 Last revised ' !VERSION                   '*'65
           /'* (c) JM.Domenech                                               *'
           /'* Programmer: R.Sesma                                           *'
           /'*                                                               *'
           /'* Vancouver reference:                                          *'
           /'* Domenech JM. Macro !COMB for SPSS Statistics.                 *'
           /'*    Combinatorics [computer program]. V' !VERSION '.'         '*'65
           /'*    Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'65
           /'*    Available from: http://www.metodo.uab.cat/macros.htm.      *'
           /'*                                                               *'
           /'* Macro Call (tested for SPSS 15.0 and higher):                 *'
           /'* !COMB T = Type  V : Variation                                 *'
           /'*                 VR: Variation with repetition                 *'
           /'*                 P : Permutation                               *'
           /'*                 PR: Permutation with repetition               *'
           /'*                 C : Combination                               *'
           /'*                 CR: Combination with repetition               *'
           /'*      /N = Number of elements                                  *'
           /'*      /R = Number to be chosen (order) or                      *'
           /'*           Number of repetitions for each element (for PR)     *'
           /'*   [/NST]= Name of the study (Label)                           *'
           /'*   [/HELP] Print Macro call arguments and Samples of calls     *'
           /'*                                                               *'
           /'* Note: Parameters enclosed in square brackets [ ] are optional *'
           /'*                                                               *'
           /'* Samples of calls:                                             *'
           /'* !COMB HELP.                                                   *'
           /'* !COMB T=C /N=4 /R=2.                                          *'
           /'* !COMB T=CR /N=4 /R=2.                                         *'
           /'* !COMB T=P /N=3 /NST="Name of the Study".                      *'
           /'* !COMB T=PR /N=4 /R=1 5 1 3.                                   *'
           /'* !COMB T=PR /N=3 /R=4 2 5.                                     *'
           /'*****************************************************************'.
  END IF.
  EXECUTE.
!ELSE. 
  !IF (!T=!NULL) !THEN.
     PRINT /'ERROR: Missing parameter'.
  !ELSE
     COMPUTE #MAX=99999999999999.
     COMPUTE #MAXNM=160.
*    Variation.
     !IF (!T=V) !THEN
*       Test parameters.
        !IF (!N=!NULL !OR !R=!NULL) !THEN
           PRINT /'ERROR: Missing parameter'.
        !ELSE
           COMPUTE #M=!N.
           COMPUTE #N=!R.
           
           DO IF ((#M+#N)<#MAXNM).
              DO IF (#M<=0 or #N<=0 or #N>#M).
                 PRINT /'ERROR: Parameter(s) with wrong values'.
              ELSE IF (MOD(#M,1)<>0 or MOD(#N,1)<>0).
                 PRINT /'ERROR: Parameter(s) with decimal values'.
              ELSE.
*                Parameters correct.
*                Compute factorial of M.
                 COMPUTE #NUM=1.
                 LOOP #I=1 TO #M.
                    COMPUTE #NUM=#NUM * #I.
                 END LOOP.
*                Compute factorial of (M-N).
                 COMPUTE #DEN=1.
                 LOOP #I=1 TO (#M-#N).
                    COMPUTE #DEN=#DEN * #I.
                 END LOOP.

*                Vm,n: m!/(m-n)!.
                 COMPUTE #V = #NUM/#DEN.

                 PRINT /'VARIATIONS'.
                 !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
                    STRING #NST (A131).
                    COMPUTE #NST = CONCAT('STUDY: ',!NST).
                    PRINT /#NST.
                 !IFEND.
                 PRINT /'Number of elements : ' !QUOTE(!N).
                 DO IF (#V>#MAX).
                    PRINT /'Number to be chosen: ' !QUOTE(!R) 'V('28 !QUOTE(!N) ';' !QUOTE(!R) ')= ' #V(E15.8).
                 ELSE.
                    STRING RESULT(A18).
                    COMPUTE RESULT=LTRIM(STRING(#V,DOT18.0)).
                    PRINT /'Number to be chosen: ' !QUOTE(!R) 'V('28 !QUOTE(!N) ';' !QUOTE(!R) ')= ' RESULT.
                 END IF.
              END IF.
           ELSE.
              PRINT /'Error: The result can not be computed'.
           END IF.
        !IFEND.
     !IFEND.

*    Variation with repetition.
     !IF (!T=VR) !THEN
*       Test parameters.
        !IF (!N=!NULL !OR !R=!NULL) !THEN
           PRINT /'ERROR: Missing parameter'.
        !ELSE
           COMPUTE #M=!N.
           COMPUTE #N=!R.
           
           DO IF ((#M+#N)<#MAXNM).
              DO IF (#M<=0 or #N<=0).
                 PRINT /'ERROR: Parameter(s) with wrong values'.
              ELSE IF (MOD(#M,1)<>0 or MOD(#N,1)<>0).
                 PRINT /'ERROR: Parameter(s) with decimal values'.
              ELSE.
*                Parameters correct.
*                VRm,n: m**n.
                 COMPUTE #VR=#M**#N.

                 PRINT /'VARIATIONS WITH REPETITION'.
                 !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
                    STRING #NST (A131).
                    COMPUTE #NST = CONCAT('STUDY: ',!NST).
                    PRINT /#NST.
                 !IFEND.
                 PRINT /'Number of elements : ' !QUOTE(!N).
                 DO IF (#VR>#MAX).
                    PRINT /'Number to be chosen: ' !QUOTE(!R) 'VR('28 !QUOTE(!N) ';' !QUOTE(!R) ')= ' #VR(E15.8).
                 ELSE.
                    STRING RESULT(A18).
                    COMPUTE RESULT=LTRIM(STRING(#VR,DOT18.0)).
                    PRINT /'Number to be chosen: ' !QUOTE(!R) 'VR('28 !QUOTE(!N) ';' !QUOTE(!R) ')= ' RESULT.
                 END IF.
              END IF.
           ELSE.
              PRINT /'Error: The result can not be computed'.
           END IF.
        !IFEND.
     !IFEND.

*    Permutation.
     !IF (!T=P) !THEN
*       Test parameters.
        !IF (!N=!NULL) !THEN
           PRINT /'ERROR: Missing parameter'.
        !ELSE
           COMPUTE #M=!N.
           
           DO IF (#M<#MAXNM).
              DO IF (#M<=0).
                 PRINT /'ERROR: Parameter(s) with wrong values'.
              ELSE IF (MOD(#M,1)<>0).
                 PRINT /'ERROR: Parameter(s) with decimal values'.
              ELSE.
*                Parameters correct.
*                Pm: m!.
*                Compute factorial of M.
                 COMPUTE #P=1.
                 LOOP #I=1 TO #M.
                    COMPUTE #P=#P * #I.
                 END LOOP.

                 PRINT /'PERMUTATIONS'.
                 !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
                    STRING #NST (A131).
                    COMPUTE #NST = CONCAT('STUDY: ',!NST).
                    PRINT /#NST.
                 !IFEND.
                 DO IF (#P>#MAX).
                    PRINT /'Number of elements: ' !QUOTE(!N) 'P('28 !QUOTE(!N) ')= ' #P(E15.8).
                 ELSE.
                    STRING RESULT(A18).
                    COMPUTE RESULT=LTRIM(STRING(#P,DOT18.0)).
                    PRINT /'Number of elements: ' !QUOTE(!N) 'P('28 !QUOTE(!N) ')= ' RESULT.
                 END IF.
              END IF.
           ELSE.
              PRINT /'Error: The result can not be computed'.
           END IF.
        !IFEND.
     !IFEND.

*    Permutation with repetition.
     !IF (!T=PR) !THEN
*       Test parameters.
        !IF (!N=!NULL !OR !R=!NULL) !THEN
           PRINT /'ERROR: Missing parameter'.
        !ELSE
           COMPUTE #ERROR=0.
           COMPUTE #NUMBER=!N.

           !LET !SBLANK1=' '.
           !DO !I !IN (!R).
              !LET !SBLANK1=!CONCAT(!SBLANK1,' ').
           !DOEND.

           !LET !REPET=' '.
           !LET !SBLANK2=' '.
           !DO !I !IN (!R).
              !LET !SBLANK2=!CONCAT(!SBLANK2,' ').
              !IF (!SBLANK1=!SBLANK2) !THEN
                 !LET !TEMP=!CONCAT(!I,!NULL).
              !ELSE
                 !LET !TEMP=!CONCAT(!I,',').
              !IFEND.
              !LET !REPET=!CONCAT(!REPET,!TEMP).
           !DOEND.


           COMPUTE #COUNT=0.
           COMPUTE #M=0.
           DO REPEAT N=!R. 
              COMPUTE #COUNT=#COUNT + 1.
              COMPUTE #M=#M + N.
              DO IF (N<=0).
                 COMPUTE #ERROR=1.
              ELSE IF (MOD(N,1)<>0).
                 COMPUTE #ERROR=2.
              END IF.
           END REPEAT.

           DO IF (#M<#MAXNM).
              DO IF (#COUNT<=0 or #NUMBER<>#COUNT or #ERROR=1).
                 PRINT /'ERROR: Parameter(s) with wrong values'.
              ELSE IF (MOD(#NUMBER,1)<>0 or #ERROR=2).
                 PRINT /'ERROR: Parameter(s) with decimal values'.
              ELSE.
*                Parameters correct.
*                Compute denominator.
                 COMPUTE #DEN=1.
                 DO REPEAT N=!R. 
                    COMPUTE #FACT=1.
                    LOOP #I=1 TO N.
                       COMPUTE #FACT=#FACT * #I.
                    END LOOP.
                    COMPUTE #DEN=#DEN*#FACT.
                 END REPEAT.

*                Compute numerator.
                 COMPUTE #NUM=1.
                 LOOP #I=1 TO #M.
                    COMPUTE #NUM=#NUM * #I.
                 END LOOP.

*                PRm: m!/(m1!m2!...mk!).
                 COMPUTE #PR=#NUM/#DEN.

                 PRINT /'PERMUTATIONS WITH REPETITIONS'.
                 !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
                    STRING #NST (A131).
                    COMPUTE #NST = CONCAT('STUDY: ',!NST).
                    PRINT /#NST.
                 !IFEND.
                 PRINT /'Number of different elements: ' !QUOTE(!N).
                 PRINT /'Number of repetitions for each element: ' !QUOTE(!R).
                 DO IF (#PR>#MAX).
                    PRINT /'PR(' !QUOTE(!N) ';' !QUOTE(!REPET) ')= ' #PR(E15.8).
                 ELSE.
                    STRING RESULT(A18).
                    COMPUTE RESULT=LTRIM(STRING(#PR,DOT18.0)).
                    PRINT /'PR(' !QUOTE(!N) ';' !QUOTE(!REPET) ')= ' RESULT.
                 END IF.
              END IF.
           ELSE.
              PRINT /'Error: The result can not be computed'.
           END IF.
        !IFEND.
     !IFEND.

*    Combination.
     !IF (!T=C) !THEN
*       Test parameters.
        !IF (!N=!NULL !OR !R=!NULL) !THEN
           PRINT /'ERROR: Missing parameter'.
        !ELSE
           COMPUTE #M=!N.
           COMPUTE #N=!R.
           
           DO IF ((#M+#N)<#MAXNM).
              DO IF (#M<=0 or #N<=0 or #N>#M).
                 PRINT /'ERROR: Parameter(s) with wrong values'.
              ELSE IF (MOD(#M,1)<>0 or MOD(#N,1)<>0).
                 PRINT /'ERROR: Parameter(s) with decimal values'.
              ELSE.
*                Parameters correct.
*                Compute numerator m!.
                 COMPUTE #NUM=1.
                 LOOP #I=1 TO #M.
                    COMPUTE #NUM=#NUM * #I.
                 END LOOP.

*                Compute denominator (m-n)!.
*                Compute factorial of N.
                 COMPUTE #DEN1=1.
                 LOOP #I=1 TO #N.
                    COMPUTE #DEN1=#DEN1 * #I.
                 END LOOP.
*                Compute factorial of (M-N).
                 COMPUTE #DEN2=1.
                 LOOP #I=1 TO (#M-#N).
                    COMPUTE #DEN2=#DEN2 * #I.
                 END LOOP.
                 COMPUTE #DEN=#DEN1*#DEN2.

*                Cm,n: m!/n!(m-n)!.
                 COMPUTE #C = #NUM/#DEN.

                 PRINT /'COMBINATIONS'.
                 !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
                    STRING #NST (A131).
                    COMPUTE #NST = CONCAT('STUDY: ',!NST).
                    PRINT /#NST.
                 !IFEND.
                 PRINT /'Number of elements : ' !QUOTE(!N).
                 DO IF (#C>#MAX).
                    PRINT /'Number to be chosen: ' !QUOTE(!R) 'C('28 !QUOTE(!N) ';' !QUOTE(!R) ')= ' #C(E15.8).
                 ELSE.
                    STRING RESULT(A18).
                    COMPUTE RESULT=LTRIM(STRING(#C,DOT18.0)).
                    PRINT /'Number to be chosen: ' !QUOTE(!R) 'C('28 !QUOTE(!N) ';' !QUOTE(!R) ')= ' RESULT.
                 END IF.
              END IF.
           ELSE.
              PRINT /'Error: The result can not be computed'.
           END IF.
        !IFEND.
     !IFEND.


*    Combination with repetition.
     !IF (!T=CR) !THEN
*       Test parameters.
        !IF (!N=!NULL !OR !R=!NULL) !THEN
           PRINT /'ERROR: Missing parameter'.
        !ELSE
           COMPUTE #M=!N.
           COMPUTE #N=!R.
           
           DO IF ((#M+#N)<#MAXNM).
              DO IF (#M<=0 or #N<=0).
                 PRINT /'ERROR: Parameter(s) with wrong values'.
              ELSE IF (MOD(#M,1)<>0 or MOD(#N,1)<>0).
                 PRINT /'ERROR: Parameter(s) with decimal values'.
              ELSE.
*                Parameters correct.
*                Compute numerator (m+n-1)!.
                 COMPUTE #NUM=1.
                 LOOP #I=1 TO (#M+#N-1).
                    COMPUTE #NUM=#NUM * #I.
                 END LOOP.

*                Compute denominator n!(m-1)!.
*                Compute factorial of N.
                 COMPUTE #DEN1=1.
                 LOOP #I=1 TO #N.
                    COMPUTE #DEN1=#DEN1 * #I.
                 END LOOP.
*                Compute factorial of (M-1).
                 COMPUTE #DEN2=1.
                 LOOP #I=1 TO (#M-1).
                    COMPUTE #DEN2=#DEN2 * #I.
                 END LOOP.
                 COMPUTE #DEN=#DEN1*#DEN2.

*                CRm,n: (m+n-1)!/n!(m-1)!.
                 COMPUTE #CR = #NUM/#DEN.

                 PRINT /'COMBINATIONS WITH REPETITION'.
                 !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
                    STRING #NST (A131).
                    COMPUTE #NST = CONCAT('STUDY: ',!NST).
                    PRINT /#NST.
                 !IFEND.
                 PRINT /'Number of elements : ' !QUOTE(!N).
                 DO IF (#CR>#MAX).
                    PRINT /'Number to be chosen: ' !QUOTE(!R) 'CR('28 !QUOTE(!N) ';' !QUOTE(!R) ')= ' #CR(E15.8).
                 ELSE.
                    STRING RESULT(A18).
                    COMPUTE RESULT=LTRIM(STRING(#CR,DOT18.0)).
                    PRINT /'Number to be chosen: ' !QUOTE(!R) 'CR('28 !QUOTE(!N) ';' !QUOTE(!R) ')= ' RESULT.
                 END IF.
              END IF.
           ELSE.
              PRINT /'Error: The result can not be computed'.
           END IF.
        !IFEND.
     !IFEND.

     !IF ((!T<>V) !AND (!T<>VR) !AND (!T<>P) !AND (!T<>PR) !AND (!T<>C) !AND (!T<>CR)) !THEN
        PRINT /'ERROR: Parameter(s) with wrong values'.
     !IFEND.
  !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.