PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
  PRINT /'Macro !HYPER V2010.11.22 loaded.'
        /'Execute !HYPER HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !HYPER (K  =!CHAREND('/') 
              /N  =!CHAREND('/')
              /N1 =!CHAREND('/') 
              /N0 =!CHAREND('/')
             /NST =!CHAREND('/')
             /HELP=!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2010.11.22').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
   PRINT //'Macro !HYPER V' !VERSION ' (c)JM.Domenech & R.Granero'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*  Print HELP.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* HYPERGEOMETRIC DISTRIBUTION                                                *'
            /'* Created 1999.12.13 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech & R.Granero                                                *'
            /'* Programmers: A.Bonillo & R.Sesma                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM, Granero R. Macro !HYPER for SPSS Statistics.                  *'
            /'*    Hypergeometric Distribution [computer program].                         *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* !HYPER    N = Sample size                         (Integer > 0 & <= N1+N0) *'
            /'*          /N1= Number of events in the population             (Integer > 0) *'
            /'*          /N0= Number of non-events in the population         (Integer > 0) *'
            /'*         [/K]= List with the number of events         (Integer >= 0 & <= N) *'
            /'*                                in the sample. By default 0 THRU N          *'
            /'*       [/NST]= Name of the study (Label)                                    *'
            /'*       [/HELP] Print Macro call arguments and Samples of calls              *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
            /'*                                                                            *'
            /'* Samples of calls:                                                          *'
            /'*  !HYPER HELP.                                                              *'
            /'*  !HYPER N=5 /N1=8 /N0=22.                                                  *'
            /'*  !HYPER K=1 3 /N=3 /N1=6 /N0=4.                                            *'
            /'*  !HYPER K=1 THRU 3 /N=3 /N1=6 /N0=4 /NST="Name of the Study".              *'
            /'******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Testing the parameters.
   COMPUTE #ERROR=0.
   !IF (!N=!NULL !or !N1=!NULL !or !N0=!NULL) !THEN 
      PRINT /'ERROR: Missing parameter'.
   !ELSE.
      COMPUTE #N=$SYSMIS.
      COMPUTE #N1=$SYSMIS.
      COMPUTE #N0=$SYSMIS.
      COMPUTE #N=!N.
      COMPUTE #N1=!N1.
      COMPUTE #N0=!N0.

*     Test parameters N,N1,N0.
      DO IF (SYSMIS(#N) OR SYSMIS(#N1) OR SYSMIS(#N0)).
         COMPUTE #ERROR=1.
      ELSE.
         IF (#N<=0 OR MOD(#N,1)<>0 OR #N1<=0 OR MOD(#N1,1)<>0 OR #N0<=0 OR MOD(#N0,1)<>0) #ERROR=1.
         IF (#N>(#N1+#N0)) #ERROR=1.   /*Testing if sample is minor or equal than population.
      END IF.

*     Detection of the keyword THRU: Krange parameter.
      !IF (!K=!NULL) !THEN.
         !LET !Krange=!CONCAT('0 TO ',!N).
      !ELSE.
         !LET !Krange=!UPCASE(!K).
         !IF (!INDEX(!Krange,'THRU')<>0) !THEN.
            !LET !Krange=!CONCAT(!HEAD(!K),' TO',!TAIL(!TAIL(!K))).
         !IFEND.
      !IFEND.
         
*     Test K list.
      DO REPEAT K=!Krange.
         DO IF (MOD(K,1)<>0).
            COMPUTE #ERROR=1.
         ELSE IF (K<0 OR K>#N1).
            COMPUTE #ERROR=1.
         END IF.      
      END REPEAT.

      DO IF (#ERROR=1).
         PRINT /'ERROR: Parameter(s) with wrong values'.
      ELSE.
*        Correct parameters: compute results and print.
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.
         PRINT /'HYPERGEOMETRIC DISTRIBUTION: H('!QUOTE(!N1)'; '!QUOTE(!N0)'; '!QUOTE(!N)')'.
         
         COMPUTE #TOTAL=0.
         COMPUTE #N10=#N1+#N0.
         COMPUTE #MEAN=(#N1/#N10)*#N.
         COMPUTE #VARIANC=#MEAN*(1-(#N1/#N10))*(#N10-#N)/(#N10-1).
         COMPUTE #FPCF=(#N10-#N)/(#N10-1).
         COMPUTE #SF=#N/#N10.
         PRINT//'+-----------+-------------+-------------+-------------+'.
         PRINT /'|     K     |   Pr(S = K) |  Pr(S <= K) |  Pr(S >= K) |'.
         PRINT /'+-----------+-------------+-------------+-------------+'.
         DO REPEAT K=!Krange.
            COMPUTE #K=K.
            COMPUTE #HYPER= CDF.HYPER(K,#N10,#N,#N1)-CDF.HYPER(K-1,#N10,#N,#N1).
            COMPUTE #TOTAL= #HYPER+#TOTAL.
            COMPUTE #cHYPER= CDF.HYPER(K,#N10,#N,#N1).       /*Cumulative probability.
            COMPUTE #c1HYPER= 1-CDF.HYPER(K-1,#N10,#N,#N1).  /*1 - Cumulative probability.
            PRINT /'|' #K(T4,F4) '|'13 #HYPER(T17,F9.8) '|'27 #cHYPER(T31,F9.8) '|'41 #c1HYPER(T45,F9.8) '|'55.
         END REPEAT.
         PRINT /'+-----------+-------------+-------------+-------------+'.
         PRINT /'|   Total   |' #total(T17,F9.8) '|'27  '|'41         '|'55.
         PRINT /'+-----------+-------------+-------------+-------------+'.
         PRINT /' Finite population correction factor = '#FPCF(F5.4).
         PRINT /' Sampling fraction = '#SF(F5.4).
         PRINT /'     Mean ='#MEAN(F12.5).
         PRINT /' Variance ='#VARIANC(F12.5).

     END IF.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
