PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
  PRINT /'Macro !NORMAL V2011.11.14 loaded.'
        /'Execute !NORMAL HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !NORMAL ( LB =!CHAREND('/') 
                /UB =!CHAREND('/') 
                 /P =!CHAREND('/')
                 /M =!CHAREND('/')!DEFAULT(0)
                /SD =!CHAREND('/')
               /VAR =!CHAREND('/')
               /NST =!CHAREND('/')
              /HELP =!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2011.11.14').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
   PRINT //'Macro !NORMAL V' !VERSION ' (c)JM.Domenech & R.Granero'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*  Print HELP.
   DO IF ($casenum=1).
      PRINT /'************************************************************************************'
            /'* NORMAL DISTRIBUTION                                                              *'
            /'* Created 1999.12.13 Last revised ' !VERSION                                      '*'84
            /'* (c) JM.Domenech & R.Granero                                                      *'
            /'* Programmers: A.Bonillo & R.Sesma                                                 *'
            /'*                                                                                  *'
            /'* Vancouver reference:                                                             *'
            /'* Domenech JM, Granero R. Macro !NORMAL for SPSS Statistics.                       *'
            /'*    Normal Distribution [computer program].                                       *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.'    '*'84
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                         *'
            /'*                                                                                  *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                                    *'
            /'* !NORMAL  M = Mean of the distribution,               by default 0 (M any number) *'
            /'*       {/SD = Standard deviation                      by default 1 (SD > 0)       *'
            /'*    or /VAR}= Variance                                by default 1 (VAR > 0)      *'
            /'*       {/LB = Low Bound                       (LB any number or LO for infinite) *'
            /'*        /UB = Upper Bound                     (UB any number or HI for +infinite) *'
            /'*     or /P} = Central area of the distribution            (0 < P < 1)             *'
            /'*      [/NST]= Name of the study (Label)                                           *'
            /'*      [/HELP] Print Macro call arguments and Samples of calls                     *'
            /'*                                                                                  *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                    *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements       *'
            /'*                                                                                  *'
            /'* Samples of calls:                                                                *'
            /'*  !NORMAL HELP.                                                                   *'
            /'*  !NORMAL M=50 /SD=1.5 /LB=50.5 /UB=51.5 .                                        *'
            /'*  !NORMAL M=50 /SD=1.5 /LB=LO   /UB=50.5 .                                        *'
            /'*  !NORMAL M=50 /VAR=5 /P=0.95 /NST="Name of the Study".                           *'
            /'*  !NORMAL P=0.95 .                                                                *'
            /'************************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Test the parameters.
   COMPUTE #ERROR=0.
   !IF ((!LB=!NULL !or !UB=!NULL) !and !P=!NULL ) !THEN. 
      PRINT /'ERROR: Missing parameter'.
   !ELSE.
      COMPUTE #P=$SYSMIS.
      COMPUTE #LB=$SYSMIS.
      COMPUTE #UB=$SYSMIS.
      COMPUTE #M=$SYSMIS.
      COMPUTE #SD=$SYSMIS.
      COMPUTE #VAR=$SYSMIS.
      
      !IF (!P<>!NULL !AND (!UB<>!NULL !or !LB<>!NULL) ) !THEN.
         COMPUTE #ERROR=2.
      !IFEND.

      !IF (!P<>!NULL) !THEN.
         COMPUTE #P=!P.          /*Test parameter P.      
         DO IF (SYSMIS(#P)).
            COMPUTE #ERROR=1.
         ELSE.
            IF (#P<0 OR #P>=1) #ERROR=1.
         END IF.
      !ELSE.
         !IF (!LB<>'LO') !THEN.  /*Test parameters LB,UB.
            COMPUTE #LB=!LB.
            IF (SYSMIS(#LB)) #ERROR=1.
         !IFEND.
         !IF (!UB<>'HI') !THEN.
            COMPUTE #UB=!UB.
            IF (SYSMIS(#UB)) #ERROR=1.
         !IFEND.
         !IF (!LB='LO' !AND !UB='HI') !THEN.
            COMPUTE #ERROR=1.
         !IFEND.
      !IFEND.

      COMPUTE #M=!M.          /*Test parameter M.
      IF (SYSMIS(#M)) #ERROR=1.

      !IF (!SD=!NULL !AND !VAR=!NULL) !THEN.
         COMPUTE #SD = 1.           /*Default.
      !ELSE.
         !IF (!SD<>!NULL) !THEN.
            COMPUTE #SD=!SD.
            DO IF (SYSMIS(#SD)).
               COMPUTE #ERROR=1.
            ELSE.
               IF (#SD<=0) #ERROR=1.
            END IF.
         !ELSE.
            COMPUTE #VAR=!VAR.
            DO IF (SYSMIS(#VAR)).
               COMPUTE #ERROR=1.
            ELSE.
               IF (#VAR<=0) #ERROR=1.
            END IF.
            COMPUTE #SD = SQRT(#VAR).
         !IFEND.
      !IFEND.


      DO IF (#ERROR=1).
         PRINT /'ERROR: Parameter(s) with wrong values'.
      ELSE IF (#ERROR=2).
         PRINT /'ERROR: Too much parameter(s)'.
      ELSE.
*        Correct parameters, compute results and print.
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.
         !IF (!SD<>!NULL) !THEN.
            PRINT /'NORMAL DISTRIBUTION: Mean='!QUOTE(!M)'; SD='!QUOTE(!SD).
         !ELSE.
            PRINT /'NORMAL DISTRIBUTION: Mean='!QUOTE(!M)'; Var='!QUOTE(!VAR).
         !IFEND.

         !IF (!P<>!NULL) !THEN.
            COMPUTE #Z= PROBIT((#P+1)/2).
            COMPUTE #LB=#M-#Z*#SD.
            COMPUTE #UB=#M+#Z*#SD.
            PRINT /'Central Area = ' !QUOTE(!P) '  ->  Bounds:' #LB(F12.6) '   to ' #UB(F12.6)'  '. 
         !ELSE.
            !IF (!LB='LO' !and !UB<>!NULL) !THEN.
               COMPUTE #AREA=CDF.NORMAL(#UB,#M,#SD).
               PRINT /'Area from -infinite to ' !QUOTE(!UB) ' = ' #AREA(F9.8). 
            !ELSE.
               !IF (!LB<>!NULL !and !UB='HI') !THEN .
                  COMPUTE #AREA=1-CDF.NORMAL(#LB,#M,#SD).
                  PRINT /'Area from ' !QUOTE(!LB) ' to +infinite = ' #AREA(F9.8). 
               !ELSE.
                  !IF (!LB<>!NULL !and !UB<>!NULL) !THEN .
                     COMPUTE #AREA=CDF.NORMAL(#UB,#M,#SD)-CDF.NORMAL(#LB,#M,#SD).
                     PRINT /'Area from ' !QUOTE(!LB) ' to ' !QUOTE(!UB) ' = ' #AREA(F9.8).
                  !IFEND.
               !IFEND.
            !IFEND.
         !IFEND.
      END IF.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
