PRESERVE. 
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
  PRINT /'Macro !PD V2011.11.11 loaded.'
        /'Execute !PD HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !PD ( Z=!CHAREND('/') 
            /T=!CHAREND('/') 
        /CHISQ=!CHAREND('/')
            /F=!CHAREND('/') 
           /DF=!CHAREND('/') 
         /TYPE=!CHAREND('/') 
           /LP=!CHAREND('/')
           /RP=!CHAREND('/')
          /NST=!CHAREND('/') 
         /HELP=!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2011.11.11').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
   PRINT /'Macro !PD V' !VERSION ' (c)JM.Domenech & R.Granero'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*  Print HELP.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* PROBABILITY DISTRIBUTIONS                                                  *'
            /'* Cumulative and inverse distribution functions Z, T, CHI-SQUARE and F       *'
            /'* Created 2000.03.10 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech & R.Granero                                                *'
            /'* Programmers: A.Bonillo & R.Sesma                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM, Granero R. Macro !PD for SPSS Statistics.                     *'
            /'*    Probability Distributions [computer program].                           *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* Parameters for INVERSE DISTRIBUTIONS---------------------------------------*'
            /'*  !PD     { Z = Value of Z random variate                                   *'
            /'*    or     /T = Value of T random variate                                   *'
            /'*    or /CHISQ = Value of CHI-SQUARE random variate        (CHISQ > 0)       *'
            /'*    or     /F}= Value of F random variate                 (F     > 0)       *'
            /'*                                                                            *'
            /'* Parameters for CUMULATIVE DISTRIBUTIONS------------------------------------*'
            /'*  !PD   /TYPE = Probability function:                                       *'
            /'*                T: Student, Z: Normal, CHISQ: Chi-square, F: Snedecor       *' 
            /'*        { /LP = Left tail area                            (0 < LP < 1)       *'
            /'*          /RP}= Right tail area                           (0 < RP < 1)       *'
            /'*                                                                            *'
            /'* Parameters for BOTH TYPES OF DISTRIBUTIONS---------------------------------*'
            /'*          /DF = value1            Degrees of freedom      (DF    > 0)       *'
            /'*                or value1,value2                                            *'
            /'*        [/NST]= Name of the study (Label)                                   *'
            /'*        [/HELP] Print Macro call arguments and Samples of calls             *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in square brackets [ ] are optional              *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements *'
            /'*                                                                            *'
            /'* Samples of calls:                                                          *'
            /'* !PD HELP.                                                                  *'
            /'* !PD Z=3.27 /NST="Study Name".    --> Return left & right tail area         *'
            /'* !PD TYPE=Z /LP=0.25.             --> Return Z value                        *'
            /'*                                                                            *'
            /'* !PD T=3.73 /DF=23.               --> Return left & right tail area         *'
            /'* !PD TYPE=T /DF=18 /RP=0.025.     --> Return T value                        *'
            /'*                                                                            *'
            /'* !PD CHISQ=3.73 /DF=23.           --> Return left & right tail area         *'
            /'* !PD TYPE=CHISQ /DF=18 /LP=0.025. --> Return CHISQ value                    *'
            /'*                                                                            *'
            /'* !PD F=10.282 /DF=4,10.           --> Return left & right tail area         *'
            /'* !PD TYPE=F /LP=0.975 /DF=4,10.   --> Return F value                        *' 
            /'******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Test the parameters.
   COMPUTE #ERROR=0.
   !IF ( (!Z<>!NULL !AND (!T<>!NULL !OR !CHISQ<>!NULL !OR !F<>!NULL !OR !TYPE<>!NULL !OR !RP<>!NULL !OR !LP<>!NULL !OR !DF<>!NULL)) 
           !OR (!T<>!NULL !AND (!CHISQ<>!NULL !OR !F<>!NULL !OR !TYPE<>!NULL !OR !RP<>!NULL !OR !LP<>!NULL)) 
           !OR (!CHISQ<>!NULL !AND (!F<>!NULL !OR !TYPE<>!NULL !OR !RP<>!NULL !OR !LP<>!NULL))
           !OR (!F<>!NULL !AND (!TYPE<>!NULL !OR !RP<>!NULL !OR !LP<>!NULL))
           !OR (!LP<>!NULL !AND !RP<>!NULL) ) !THEN.
      PRINT /'ERROR: Too much parameter(s)'.
   !ELSE.
      COMPUTE #Z=$SYSMIS.
      COMPUTE #T=$SYSMIS.
      COMPUTE #CHISQ=$SYSMIS.
      COMPUTE #F=$SYSMIS.
      COMPUTE #RP=$SYSMIS.
      COMPUTE #LP=$SYSMIS.
      COMPUTE #DF=$SYSMIS.

*     Test parameter TYPE.               
      !IF (!TYPE<>!NULL !AND !TYPE<>T !AND !TYPE<>Z !AND !TYPE<>F !AND !TYPE<>CHISQ) !THEN.
         COMPUTE #ERROR=1.
      !IFEND.

*     Test parameter DF.
      !IF (!DF<>!NULL) !THEN.
         DO REPEAT DF=!DF.
            COMPUTE #COUNT=#COUNT+1.
            COMPUTE #DF=DF.
            DO IF (SYSMIS(#DF)).
               COMPUTE #ERROR=1.
            ELSE.
               IF (DF<=0) #ERROR=1.
            END IF.
         END REPEAT.
      !ELSE.
         !IF (!Z=!NULL !AND !TYPE<>!NULL !AND !TYPE<>Z) !THEN.
            COMPUTE #ERROR=2.    /*Test MISSING parameter DF.
         !IFEND.
      !IFEND.

*     Test MISSING parameters.
      !IF ( !Z=!NULL !AND !T=!NULL !AND !CHISQ=!NULL !AND !F=!NULL !AND !TYPE=!NULL ) !THEN.
         COMPUTE #ERROR=2.
      !ELSE.
         !IF ( (!TYPE<>!NULL !AND (!LP=!NULL !AND !RP=!NULL)) !OR  (!TYPE=!NULL !AND (!RP<>!NULL !OR !LP<>!NULL)) ) !THEN.
            COMPUTE #ERROR=2.
         !IFEND.
      !IFEND.

*     Test parameter Z.
      !IF (!Z<>!NULL) !THEN.
         COMPUTE #Z=!Z.
         IF (SYSMIS(#Z)) #ERROR=1.
      !IFEND.

*     Test parameter T.
      !IF (!T<>!NULL) !THEN.
         COMPUTE #T=!T.         
         DO IF (SYSMIS(#T)).
            COMPUTE #ERROR=1.
         ELSE.
            IF (#COUNT<>1) #ERROR=1.            
         END IF.
      !IFEND.

*     Test parameter CHISQ.
      !IF (!CHISQ<>!NULL) !THEN.
         COMPUTE #CHISQ=!CHISQ.
         DO IF (SYSMIS(#CHISQ)).
            COMPUTE #ERROR=1.
         ELSE.
            IF (#CHISQ<=0 OR #COUNT<>1) #ERROR=1.
         END IF.
      !IFEND.

*     Test parameter F.
      !IF (!F<>!NULL) !THEN.
         COMPUTE #F=!F.
         DO IF (SYSMIS(#F)).
            COMPUTE #ERROR=1.
         ELSE.
            IF (#F<=0 OR #COUNT<>2) #ERROR=1.
         END IF.
      !IFEND.

*     Test parameters RP/LP.
      COMPUTE #Ptype = 0.
      !IF (!RP<>!NULL) !THEN.
         COMPUTE #Ptype = 1.
         COMPUTE #RP=!RP.
         DO IF (SYSMIS(#RP)).
            COMPUTE #ERROR=1.
         ELSE.
            IF (#RP<=0 OR #RP>=1) #ERROR=1.
         END IF.
         COMPUTE #LP = 1 - #RP.
      !IFEND.
      !IF (!LP<>!NULL) !THEN.
         COMPUTE #Ptype = 2.
         COMPUTE #LP=!LP.
         DO IF (SYSMIS(#LP)).
            COMPUTE #ERROR=1.
         ELSE.
            IF (#LP<=0 OR #LP>=1) #ERROR=1.
         END IF.
         COMPUTE #RP = 1 - #LP.
      !IFEND.
      DO IF (#ERROR=1).
         PRINT /'ERROR: Parameter(s) with wrong values'.
      ELSE IF (#ERROR=2).
         PRINT /'ERROR: Missing parameter'.
      ELSE.
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.
         
         !IF (!T <> !NULL)!THEN.
            COMPUTE #LP=CDF.T(!T,!DF).     /*Computing and print a inverse T value.
            COMPUTE #RP=1-#LP.
            PRINT /'STUDENT T= ' !QUOTE(!T) '   DF= '!QUOTE(!DF)  '   Left tail P= ' #LP(F13.12)  '   Right tail P= ' #RP(F13.12)/.
         !ELSE.
            !IF (!TYPE=T)!THEN.           /*Computing and print a cumulative T value.
               COMPUTE #T= IDF.T(#LP,!DF).
               !IF (!RP<>!NULL) !THEN.
                  PRINT /'STUDENT T= ' #T(F13.9) '   DF= '!QUOTE(!DF)   '   Right tail P= '!QUOTE(!RP)/.
               !IFEND.
               !IF (!LP<>!NULL) !THEN.
                  PRINT /'STUDENT T= ' #T(F13.9) '   DF= '!QUOTE(!DF)   '   Left tail P= '!QUOTE(!LP)/.
               !IFEND.
            !IFEND.
         !IFEND.

         !IF (!F <>!NULL) !THEN.
            COMPUTE #LP= CDF.F(!F,!DF).    /*Computing and print a inverse F value.
            COMPUTE #RP= 1-#LP.
            PRINT /'SNEDECOR F= '  !QUOTE(!F) '   DF= '  !QUOTE(!DF) '   Left tail P= ' #LP(F13.12) '   Right tail P= ' #RP(F13.12)/.
         !ELSE.
            !IF (!TYPE=F) !THEN.          /*Computing and print a cumulative F value.
               COMPUTE #F= IDF.F(#LP,!DF).
               !IF (!RP<>!NULL) !THEN.
                  PRINT /'SNEDECOR F= '  #F(F13.8) '   DF= '  !QUOTE(!DF) '   Right tail P= '!QUOTE(!RP)/.
               !IFEND.
               !IF (!LP<>!NULL) !THEN.
                  PRINT /'SNEDECOR F= '  #F(F13.8) '   DF= '  !QUOTE(!DF) '   Left tail P= '!QUOTE(!LP)/.
               !IFEND.
            !IFEND.
         !IFEND.
   
         !IF (!CHISQ <> !NULL) !THEN.     /*Computing and print a inverse CHISQ value.
            COMPUTE #RP= 1-CDF.CHISQ(!CHISQ,!DF).
            COMPUTE #LP = 1 - #RP.
            PRINT /'CHI-SQUARE= ' !QUOTE(!CHISQ) '   DF= '!QUOTE(!DF) '   Left tail P= ' #LP(F13.12)  '   Right tail P= ' #RP(F13.12)/.
         !ELSE.
            !IF (!TYPE=CHISQ) !THEN.      /*Computing and print a cumulative CHISQ value.
               COMPUTE #CHI= IDF.CHISQ(#LP,!DF).
               !IF (!RP<>!NULL) !THEN.
                  PRINT /'CHI-SQUARE = ' #CHI(F13.8) '   DF= ' !QUOTE(!DF) '   Right tail P= ' !QUOTE(!RP)/.
               !IFEND.
               !IF (!LP<>!NULL) !THEN.
                  PRINT /'CHI-SQUARE = ' #CHI(F13.8) '   DF= ' !QUOTE(!DF) '   Left tail P= ' !QUOTE(!LP)/.
               !IFEND.
            !IFEND.
         !IFEND.
   
         !IF (!Z <> !NULL) !THEN.         /*Computing and print a inverse Z value.
            COMPUTE #LP= cdfnorm(!Z).
            COMPUTE #RP= (1-#LP).
            PRINT /'NORMAL Z= ' !QUOTE(!Z) '   Left tail P= ' #LP(F13.12) '   Right tail P= ' #RP(F13.12)/.
         !ELSE.
            !IF (!TYPE=Z) !THEN.          /*Computing and print a cumulative Z value.
               COMPUTE #Z= probit(#LP).
               !IF (!RP<>!NULL) !THEN.
                  PRINT /'NORMAL Z= ' #Z(F13.9) '   Right tail P= ' !QUOTE(!RP)/.
               !IFEND.
               !IF (!LP<>!NULL) !THEN.
                  PRINT /'NORMAL Z= ' #Z(F13.9) '   Left tail P= ' !QUOTE(!LP)/.
               !IFEND.
            !IFEND.
         !IFEND.
      END IF.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
