PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
  PRINT /'Macro !NNT V2008.02.29 loaded.'
        /'Execute !NNT HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !NNT (A1 =!CHAREND('/') /N1=!CHAREND('/')
            /A0 =!CHAREND('/') /N0=!CHAREND('/') 
             /M =!CHAREND('/') !DEFAULT('W') 
            /CL =!CHAREND('/') !DEFAULT('95')
            /NST=!CHAREND('/')
           /HELP=!CHAREND('/') !DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2008.02.29').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
   PRINT //'Macro !NNT V' !VERSION ' (c)JM.Domenech & R.Granero'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*  Impresin de la documentacin.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* NUMBER NEEDED TO TREAT                                                     *'
            /'* Created 2002.02.25 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech & R.Granero                                                *'
            /'* Programmers: A.Bonillo & R.Sesma                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM, Granero R. Macro !NNT for SPSS Statistics.                    *'
            /'*    Number Needed to Treat [computer program].                              *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* !NNT A1 = Events in Treated group              (A1 integer >= 0 )          *'
            /'*     /N1 = Total Treated                        (N1 integer >= A1 and > 0)  *'
            /'*     /A0 = Events in Control group              (A0 integer >= 0 )          *'
            /'*     /N0 = Total Control                        (N0 integer >= A0 and > 0)  *'
            /'*   [  /M]= Estimation method:                                               *'
            /'*           W  Wilson-Newcombe                    by default: W              *'
            /'*           A  Asymptotic (Wald)                                             *'
            /'*   [ /CL]= Confidence level(%); by default: 95  (50 < CL < 100)             *'
            /'*   [/NST]= Name of the study (Label)                                        *'
            /'*   [/HELP] Print Macro call arguments and Samples of calls                  *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
            /'*                                                                            *'
            /'*                                         +-----------+---------+---------+  *'
            /'*                                         |           | Control | Treated |  *'
            /'* Samples of calls:                       +-----------+---------+---------+  *'
            /'* !NNT HELP.                              |    Events |    A0   |    A1   |  *'
            /'* !NNT A1=50 /N1=100 /A0=30 /N0=100.      | NonEvents |         |         |  *'
            /'* !NNT A1=100 /N1=1000 /A0=80 /N0=1000    +-----------+---------+---------+  *'
            /'*     /CL=95 /M=W /NST="Study Name".      |     TOTAL |    N0   |    N1   |  *'
            /'*                                         +-----------+---------+---------+  *'
            /'******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Testing the parameter(s).
   !IF (!A1=!NULL !or !N1=!NULL !or !A0=!NULL !or !N0=!NULL) !THEN.
      PRINT /'ERROR: Missing parameter'.
   !ELSE.
      COMPUTE #ERROR=0.
      COMPUTE #A1=$sysmis.
      COMPUTE #A0=$sysmis.
      COMPUTE #N1=$sysmis.
      COMPUTE #N0=$sysmis.
      COMPUTE #CL=$sysmis.
      COMPUTE #A1=!A1.
      COMPUTE #A0=!A0.
      COMPUTE #N1=!N1.
      COMPUTE #N0=!N0.
      COMPUTE #CL=!CL.

*     Test parameters A1,N1,A0,N0,CL.
      DO IF (SYSMIS(#A1) OR SYSMIS(#N1) OR SYSMIS(#A0) OR SYSMIS(#N0) OR SYSMIS(#CL)).
         COMPUTE #ERROR=1.
      ELSE IF (#A1<0 or #N1<1 or #N1<#A1 or #A0<0 or #N0<1 or #N0<#A0 or #CL<=50 or #CL>=100).
         COMPUTE #ERROR=1.
      ELSE IF (MOD(#A1,1)<>0 or MOD(#N1,1)<>0 or MOD(#A0,1)<>0 or MOD(#N0,1)<>0).
         COMPUTE #ERROR=1.
      END IF.

*     Test parameter M.
      !LET !MU = !UPCASE(!M).
      STRING #METHOD (A8).
      COMPUTE #M = 0.    /*Estimation method: #M=1 (Wilson-Newcombe-default); #M=2 (Wald).
      !IF (!MU<>'A' !AND !MU<>'W' ) !THEN.
         COMPUTE #ERROR=1.
      !ELSE.
         !IF (!MU='W') !THEN.
            COMPUTE #M=1.
            COMPUTE #METHOD = 'Newcombe'.
         !ELSE.
            !IF (!MU='A') !THEN.
               COMPUTE #M=2.
               COMPUTE #METHOD = 'Wald'.
            !IFEND.
         !IFEND.
      !IFEND.

      DO IF (#ERROR=1).
         PRINT /'ERROR: Parameter(s) with wrong values'.
      ELSE.
*        Correct parameters, compute results and print.
         COMPUTE #ALPHA = (#CL+100)/200.
         COMPUTE #Z= IDF.NORMAL(#ALPHA,0,1).

*        Proportions and bounds.
         NUMERIC #R1 #R0 #lbR1e #lbR0e #ubR1e #ubR0e #lbR1w #lbR0w #ubR1w #ubR0w #lbR1a #lbR0a #ubR1a #ubR0a.
         DO REPEAT P=#R1 #R0 /A=#A1 #A0 /N=#N1 #N0
               /lbRe=#lbR1e #lbR0e /ubRe=#ubR1e #ubR0e
               /lbRw=#lbR1w #lbR0w /ubRw=#ubR1w #ubR0w
               /lbRa=#lbR1a #lbR0a /ubRa=#ubR1a #ubR0a.
            COMPUTE P=A/N.
            
*           Exact bounds.
            COMPUTE lbRe = 0.
            COMPUTE ubRe = 1.
            IF (A>0) lbRe=A/(A+(N-A+1)*IDF.F(#ALPHA,2*(N-A+1),2*A)).
            IF (A<N) ubRe=(A+1)/(A+1+(N-A)/IDF.F(#ALPHA,2*(A+1),2*(N-A))).

*           Wilson bounds.
            COMPUTE #WA = 2*A + #Z**2.
            COMPUTE #WB = #Z * SQRT(#Z**2 + 4*A*(N-A)/N).
            COMPUTE #WC = 2*(N + #Z**2).
            COMPUTE lbRw= (#WA-#WB)/#WC.
            COMPUTE ubRw= (#WA+#WB)/#WC.
            
*           Asymptotic bounds.
            COMPUTE #SE = SQR((P*(1-P)/N)).
            COMPUTE lbRa= P - #SE*#Z.
            COMPUTE ubRa= P + #SE*#Z.
         END REPEAT.

*        Difference of two proportions.
         COMPUTE #RD= #R1-#R0.
         DO IF (#M=1).     /*Newcombe-Wilson CI.
            COMPUTE #f0= #A0**2 /(#N0**2 + #N0*#Z**2).
            COMPUTE #f1= #A1**2 /(#N1**2 + #N1*#z**2).
            COMPUTE #w0= (2*#A0 + #Z**2)/(2*(#N0 + #Z**2)).
            COMPUTE #w1= (2*#A1 + #Z**2)/(2*(#N1 + #Z**2)).
            COMPUTE #l0= #w0 - SQR(#w0**2 - #f0).
            COMPUTE #l1= #w1 - SQR(#w1**2 - #f1).
            COMPUTE #u0= #w0 + SQR(#w0**2 - #f0).
            COMPUTE #u1= #w1 + SQR(#w1**2 - #f1).
            COMPUTE #d = SQR((#R1-#l1)**2 + (#u0-#R0)**2).
            COMPUTE #e = SQR((#u1-#R1)**2 + (#R0-#L0)**2).
            COMPUTE #lbRD= #RD - #d.
            COMPUTE #ubRD= #RD + #e.
         ELSE IF (#M=2).   /*WALD CI.
            COMPUTE #SE= SQR(#R1*(1-#R1)/#N1 + #R0*(1-#R0)/#N0).
            COMPUTE #lbRD= #RD - #SE*#Z.
            COMPUTE #ubRD= #RD + #SE*#Z.            
         END IF.

*        Number needed subjects to treat.
         COMPUTE #NNT= 1/#RD.
         COMPUTE #lbNNT= 1/#ubRD.
         COMPUTE #ubNNT= 1/#lbRD.

*        Print header, proportions and bounds.
         PRINT  /'NUMBER NEEDED TO TREAT'.
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.
         PRINT //'------------------------+----------+--------------------------------'.
         PRINT  /'  GROUP Events Subjects | Estimate |   '!QUOTE(!CL)'% Confidence Interval'.
         PRINT  /'------------------------+----------+--------------------------------'.
         PRINT  /'Treated'  #A1(T8,F7) #N1(T16,F8)'|'25 #R1(T27,F8.6) '|'36 #lbR1e(T38,F8.6) ' to ' #ubR1e(T50,F8.6) ' Exact'.
         DO IF (#M=1).
            PRINT  /                        '|'25      '|'36 #lbR1w(T38,F8.6) ' to ' #ubR1w(T50,F8.6) ' Wilson*'.         
         ELSE IF (#M=2).
            PRINT  /                        '|'25      '|'36 #lbR1a(T38,F8.6) ' to ' #ubR1a(T50,F8.6) ' Asymptotic'.
         END IF.
         PRINT  / '|'25 '|'36 .
         PRINT  /'Control'  #A0(T8,F7) #N0(T16,F8)'|'25 #R0(T27,F8.6) '|'36 #lbR0e(T38,F8.6) ' to ' #ubR0e(T50,F8.6) ' Exact'.
         DO IF (#M=1).
            PRINT  /                        '|'25      '|'36 #lbR0w(T38,F8.6) ' to ' #ubR0w(T50,F8.6) ' Wilson*'.
         ELSE IF (#M=2).
            PRINT  /                        '|'25      '|'36 #lbR0a(T38,F8.6) ' to ' #ubR0a(T50,F8.6) ' Asymptotic'.
         END IF.
         PRINT  /'------------------------+----------+--------------------------------'.

*        Print Risk difference and bounds.
         PRINT  /'        Risk difference |' #RD(T27,F8.6) '|'36 #lbRD(T38,F8.6) ' to ' #ubRD(T50,F8.6) ' ' #METHOD.
         PRINT  /'------------------------+----------+--------------------------------'.

*        Print NNT and bounds.
         DO IF (#M=2 and ((#R1=0 AND #R0=0) OR (#R1=1 AND #R0=1))).
            PRINT  /' Number needed to treat | infinity' '|'36  ' infinity to   infinity'.
         ELSE IF (#lbRD>0 AND #ubRD>0). 
            PRINT  /' Number needed to treat |'#NNT(T27,F8.1) '|'36  #lbNNT(T38,F8.1) ' to ' #ubNNT(T50,F8.1).
            PRINT  /'         Benefit (NNTB) |' '|'36 .
         ELSE IF  (#lbRD<0 AND #ubRD<0).
            PRINT  /' Number needed to treat |'#NNT(T27,F8.1) '|'36  #lbNNT(T38,F8.1) ' to ' #ubNNT(T50,F8.1).
            PRINT  /'                        |' '|'36 .
            COMPUTE #NNT= ABS(#NNT).
            COMPUTE #lbNNT= ABS(#lbNNT).
            COMPUTE #ubNNT= ABS(#ubNNT).
            PRINT  /'             Harm (NNTH)|'#NNT(T27,F8.1) '|'36  #ubNNT(T38,F8.1) ' to ' #lbNNT(T50,F8.1).
         ELSE IF  (#lbRD<0 AND #ubRD>0). 
            DO IF (#RD=0).
               PRINT /' Number needed to treat | infinity' '|'36  '-infinity to '42 #ubNNT(T56,F8.1).
               PRINT /'                        |' '| AND'36 #lbNNT(T45,F6.1) ' to +infinity'.
               PRINT /'|'25 '|'36 .
               COMPUTE #ubNNT=ABS(#ubNNT).
               PRINT /'          Benefit (NNTB)| infinity' '|'36  #lbNNT(T43,F8.1) ' to  infinity'.
               PRINT /'             Harm (NNTH)| infinity' '|'36  #ubNNT(T43,F8.1) ' to  infinity'.
            ELSE.
               PRINT /' Number needed to treat |'#NNT(T27,F8.1) '|'36  '-infinity to '42 #ubNNT(T56,F8.1).
               PRINT /'                        |' '| AND'36 #lbNNT(T45,F6.1) ' to +infinity'.
               PRINT /'|'25 '|'36 .                              
               COMPUTE #NNT= ABS(#NNT).
               COMPUTE #ubNNT=ABS(#ubNNT).
               PRINT /'          Benefit (NNTB)|'#NNT(T27,F8.1) '|'36  #lbNNT(T43,F8.1) ' to  infinity'.
               PRINT /'             Harm (NNTH)|'#NNT(T27,F8.1) '|'36  #ubNNT (T43,F8.1) ' to  infinity'.
            END IF.
         
         END IF.
         PRINT /'------------------------+----------+--------------------------------'.
         DO IF (#M=1).
            PRINT  /'(*) Wilson method is recommended'.                        
         ELSE IF (#M=2).
            PRINT  /'WARNING!!! Wilson-Newcombe methods are recommended'.
         END IF.

      END IF.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.

