PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
  PRINT /'Macro !SCCT V2009.02.02 loaded.'
        /'Execute !SCCT HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !SCCT (T = !CHAREND('/')
          /CP1  = !CHAREND('/')
          /CP0  = !CHAREND('/') 
          /ALPHA= !CHAREND('/')
          /BETA = !CHAREND('/') 
          /NST  = !CHAREND('/')
          /HELP = !CHAREND('/') !DEFAULT(1)  ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2009.02.02').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
   PRINT /'Macro !SCCT V' !VERSION ' (c)JM.Domenech'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*  Impresin de la documentacin.
   DO IF ($casenum=1).
      PRINT /'*********************************************************************************'
            /'* STOCHASTIC CURTAILMENT: Clinical trials                                       *'
            /'* Created 2000.02.24 Last revised ' !VERSION                                   '*'81
            /'* (c) JM.Domenech                                                               *'
            /'* Programmer: A.Bonillo                                                         *'
            /'*                                                                               *'
            /'* Vancouver reference:                                                          *'
            /'* Domenech JM. Macro !SCCT for SPSS Statistics.                                 *'
            /'*    Stochastic Curtailment: Clinical trials [computer program].                *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'81
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                      *'
            /'*                                                                               *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                                 *'
            /'* !SCCT T= Percentage of information accrued                  (0 < T <= 100)    *'
            /'*    /CP0= Conditional power of accept alternative hypothesis (50 <= CP0 < 100) *'
            /'*  [/CP1]= Conditional power of accept null hypothesis        (50 <= CP1 < 100) *'
            /'*          By default: CP1 = CP0                                                *'
            /'*  /ALPHA= Alpha risk in %                                    (0 < ALPHA < 50)  *'
            /'*   /BETA= Beta  risk in %                                    (0 < BETA  < 50)  *'
            /'*  [/NST]= Name of the study (Label)                                            *'
            /'*  [/HELP] Print Macro call arguments and Samples of calls                      *'
            /'*                                                                               *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                 *'
            /'*                                                                               *'
            /'* Samples of calls:                                                             *'
            /'*  !SCCT HELP.                                                                  *'
            /'*  !SCCT T=50 /CP0=90 /ALPHA=5 /BETA=15.                                        *'
            /'*  !SCCT T=60 /CP0=90 /CP1=80 /ALPHA=5 /BETA=10 /NST="Name of the Study".       *'
            /'*********************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Testing the parameters.
   !IF (!T=!NULL !OR !CP0=!NULL !OR !ALPHA=!NULL !OR !BETA=!NULL) !THEN.
      PRINT /'ERROR: Missing parameter'.
   !ELSE.
      COMPUTE #ERROR=0.
      COMPUTE #T=$SYSMIS.
      COMPUTE #CP0=$SYSMIS.
      COMPUTE #CP1=$SYSMIS.
      COMPUTE #ALPHA=$SYSMIS.
      COMPUTE #BETA=$SYSMIS.

      COMPUTE #T=!T.
      COMPUTE #CP0=!CP0.
      !IF (!CP1=!NULL) !THEN.  
         COMPUTE #CP1=!CP0.
      !ELSE.
         COMPUTE #CP1=!CP1.
      !IFEND.
      COMPUTE #ALPHA=!ALPHA.
      COMPUTE #BETA=!BETA.

      DO IF (SYSMIS(#T) OR SYSMIS(#CP0) OR SYSMIS(#CP1) OR SYSMIS(#ALPHA) OR SYSMIS(#BETA)).
         COMPUTE #ERROR=1.
      ELSE IF (#T<=0 OR #T>100 OR #ALPHA<=0 OR #ALPHA>=50 OR #BETA<=0 OR #BETA>=50 OR
               #CP0<50 OR #CP0>=100 OR #CP1<50 OR #CP1>=100 ).
         COMPUTE #ERROR=1.
      END IF.

      DO IF (#ERROR=1).
         PRINT /'ERROR: Parameter(s) with wrong values'.
      ELSE.
*        Correct parameters, compute results and print.      
         COMPUTE #T=#T/100.
         COMPUTE #ZCP0=IDF.NORMAL(1-#CP0/100,0,1).
         COMPUTE #ZCP1=IDF.NORMAL(#CP1/100,0,1).
         COMPUTE #zalpha1 = IDF.NORMAL((100-#ALPHA)/100,0,1).
         COMPUTE #zalpha2 = IDF.NORMAL((100-#ALPHA/2)/100,0,1).
         COMPUTE #zteta1  = #zalpha1 + IDF.NORMAL(1-#BETA/100,0,1).
         COMPUTE #zteta2  = #zalpha2 + IDF.NORMAL(1-#BETA/100,0,1).
         
         COMPUTE #ztr1=(#zalpha1 - #ZCP0*SQRT(1-#T))/SQRT(#T).
         COMPUTE #ztr2=(#zalpha2 - #ZCP0*SQRT(1-#T))/SQRT(#T).
         COMPUTE #ztr2n=-1*#ztr2.
         COMPUTE #ptr1=(1-CDF.NORMAL(#ztr1,0,1)).
         COMPUTE #ptr2=(1-CDF.NORMAL(#ztr2,0,1))*2.
         
         COMPUTE #zta1=(#zalpha1 - #ZCP1*SQRT(1-#T) - #zteta1*(1-#T))/SQRT(#T).
         COMPUTE #zta2=(#zalpha2 - #ZCP1*SQRT(1-#T) - #zteta2*(1-#T))/SQRT(#T).
         COMPUTE #zta2n=-1*#zta2.
         COMPUTE #pta1=(1-CDF.NORMAL(#zta1,0,1)).
         COMPUTE #pta2=(1-CDF.NORMAL(#zta2,0,1))*2.

*        Print header.
         PRINT /'STOCHASTIC CURTAILMENT: Clinical trials'.
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.
         PRINT//'Risk: Alpha= ' !QUOTE(!ALPHA)'%    Beta= ' !QUOTE(!BETA)'%'.
         DO IF (#CP0<>#CP1).
            PRINT /'Conditional power: for accept H1= ' !QUOTE(!CP0)'%  for accept H0= ' #CP1(F2.0)'%'.
         ELSE.
            PRINT /'Conditional Power= ' !QUOTE(!CP0)'%'.
         END IF.
         PRINT /'Accrued information= ' !QUOTE(!T)'%'.
         PRINT /'------+-----------------------+--------------------+-------------------------+'.
         PRINT /' TEST |        Z value        |       P value      | DECISION                |'.
         PRINT /'------+-----------------------+--------------------+-------------------------+'.
         PRINT /' TWO  |+infinity to ' #ztr2(F9.5) ' | 0       to ' #ptr2(F7.6) ' | STOP: Beneficial effect |'.
         DO IF (#zta2>0).
            PRINT /'SIDED |'#ztr2(F9.5) ' to ' #zta2(F9.5) ' | ' #ptr2(F7.6) ' to ' #pta2(F7.6) ' | CONTINUE                |'.
            PRINT /'      |'#zta2(F9.5) ' to ' #zta2n(F9.5)' | ' #pta2(F7.6) ' to 1       | STOP: Lack of power (H0)|'.
            PRINT /'      |'#zta2n(F9.5)' to ' #ztr2n(F9.5)' | ' #pta2(F7.6) ' to ' #ptr2(F7.6) ' | CONTINUE                |'.
         ELSE.
            PRINT /'SIDED |'#ztr2(F9.5) ' to ' #ztr2n(F9.5)' | ' #ptr2(F7.6) ' to 1       | CONTINUE                |'.
         END IF.
         PRINT /'      |' #ztr2n(F9.5) ' to ' '-infinity | ' #ptr2(F7.6) ' to 0       | STOP: Harmful effect    |'.
         PRINT /'------+-----------------------+--------------------+-------------------------+'.
         PRINT /' ONE  |+infinity to ' #ztr1(F9.5) ' | 0       to ' #ptr1(F7.6) ' | STOP: Beneficial effect |'.
         PRINT /'SIDED |' #ztr1(F9.5) ' to ' #zta1(F9.5) ' | ' #ptr1(F7.6) ' to ' #pta1(F7.6) ' | CONTINUE                |'.
         PRINT /'      |' #zta1(F9.5) ' to -infinity | ' #pta1(F7.6) ' to 1       | STOP: Lack of power (H0)|'.
         PRINT /'------+-----------------------+--------------------+-------------------------+'.
      END IF.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.