PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !DSR V2008.12.30 loaded.'
         /'Execute !DSR HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !DSR  (STRATUM = !CHAREND('/')
                  /A1 = !CHAREND('/')  /T1  = !CHAREND('/')  /N1 = !CHAREND('/')
                  /A0 = !CHAREND('/')  /T0  = !CHAREND('/')  /N0 = !CHAREND('/')
                  /TS = !CHAREND('/')  /ICS = !CHAREND('/')  /AS = !CHAREND('/')
                  /NS = !CHAREND('/')  /RCS = !CHAREND('/')
                  /CL = !CHAREND('/') !DEFAULT('95')
                 /NST = !CHAREND('/')
                /HELP = !CHAREND('/') !DEFAULT(1)).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2008.12.30').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
   PRINT /'Macro !DSR V' !VERSION ' (c)JM.Domenech'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*  Impresin de la documentacin.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* DIRECT STANDARDIZATION: Rates and Ratios                                   *'
            /'* Created 1999.11.08 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech                                                            *'
            /'* Programmer: A.Bonillo                                                      *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM. Macro !DSR for SPSS Statistics.                               *'
            /'*    Direct Standardization: Rates and Ratios [computer program].            *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* !DSR STRATUM= List of Stratum labels(up to 8 characters)  (in SPSS format) *'
            /'*     /A1     = List of cases in Group A1 by Stratum        (A1 integer >=0) *'
            /'*    {/T1     = List of person-time in Group 1 by Stratum   (T1 > 0)         *'
            /'*  or /N1}    = List of population  in Group 1 by Stratum                    *'
            /'*                                                  (N1 integer >= A1 and >0) *'
            /'*    [  /CL]  = Confidence level (%); by default: 95        (50 <= CL < 100) *'
            /'*    [ /NST]  = Name of the study (Label)                                    *'
            /'*       [/HELP] Print Macro call arguments and Samples of calls              *'
            /'*----------------------------------------------------------------------------*'
            /'* Parameters for records STANDARD POPULATION                                 *'
            /'*    {/AS     = List of cases in STANDARD POP. by Stratum   (AS integer >=0) *'
            /'*  or /TS     = List of person-time in STANDARD by Stratum  (TS > 0)         *'
            /'*  or /NS }   = List of population  in STANDARD by Stratum  (NS > 0)         *'
            /'*----------------------------------------------------------------------------*'
            /'* Parameters for compute Comparative Mortality Figure                        *'
            /'*    {/ICS    = Crude rate in STANDARD POPULATION           (ICS > 0)        *'
            /'*  or /RCS}   = Crude risk in STANDARD POPULATION           (0 < RCS < 1)    *'
            /'*----------------------------------------------------------------------------*'
            /'* Parameters for records an additional Group                                 *'
            /'* [   /A0     = List of cases in Group A0 by Stratum        (A0 integer >=0) *'
            /'*    {/T0     = List of person-time in Group 0 by Stratum   (T0 > 0)         *'
            /'*  or /N0} ]  = List of population  in Group 0 by Stratum                    *'
            /'*                                                  (N0 integer >= A0 and >0) *'
            /'*----------------------------------------------------------------------------*'
            /'* Notes: Parameters enclosed in Square Brackets [ ] are optional             *'
            /'*        Parameters enclosed in Braces { } indicate a choice between elements*'
            /'*        Parameters /T1, /T0, /TS and /ICS records RATE DATA.                *'
            /'*        Parameters /N1, /N0, /NS and /RCS records RISK DATA.                *'
            /'*                                                                            *'
            /'* Samples of calls:                                                          *'
            /'* !DSR HELP.                                                                 *'
            /'* !DSR STRATUM= " 0-29" "30-59"  " >60"                                      *'
            /'*     /A1=        3523   10928   59104                                       *'
            /'*     /T1=     3145000 3057000 1294000                                       *'
            /'*     /A0=        3904    1421    2456                                       *'
            /'*     /T0=      741000  275000   59000                                       *'
            /'*     /TS=      350000  350000  300000.                                      *'
            /'*                                                                            *'
            /'* !DSR STRATUM=  " 0-29"   "30-59"    " >60"                                 *'
            /'*     /A1=        3523     10928     59104                                   *'
            /'*     /T1=     3145000.7 3057000.2 1294000.1                                 *'
            /'*     /TS=      350000  350000  300000                                       *'
            /'*     /ICS= 0.00745  /CL= 90 /NST="Name of the Study".                       *'
            /'******************************************************************************'.
   END IF.
   EXECUTE.
   COMPUTE #ERROR=1.
!ELSE.
*  Testing the parameters.
   !IF (!STRATUM=!NULL !or !A1=!NULL !or (!N1=!NULL !and !T1=!NULL) !or (!TS=!NULL !and !NS=!NULL !and !AS=!NULL) !or (!A0<>!NULL !and (!T0=!NULL !and !N0=!NULL))) !THEN
      PRINT /'ERROR: Missing parameter'.
   !ELSE.
      !IF ((!T1<>!NULL !and (!TS=!NULL !and !ICS=!NULL)) !or (!N0<>!NULL !and (!NS=!NULL !and !RCS=!NULL)) )  !THEN.
         PRINT /'ERROR: The parameters are incompatible'.
      !ELSE.
         COMPUTE #ERROR=0.
         COMPUTE #N=0.
         COMPUTE #N1=0.
         COMPUTE #N2=0.
         COMPUTE #N3=0.
         COMPUTE #Tdec=0.

*        Count of the numbers of elements.
         !LET !BLANK=!NULL.
         !LET !SBLANK=!NULL.
         !DO !I !IN (!STRATUM).
            !LET !BLANK=' '.
            !LET !SBLANK=!CONCAT(!SBLANK,!BLANK).
         !DOEND.
*        Levels of group's variable.
         !LET !COUNT=!LENGTH(!SBLANK).

         !IF (!ICS<>!NULL) !THEN
            DO IF (!ICS<=0).
               COMPUTE #ERROR=1.
            END IF.
         !IFEND.

         !IF (!RCS<>!NULL) !THEN
            DO IF (!RCS<=0 or RCS<=1).
               COMPUTE #ERROR=1.
            END IF.
         !IFEND.

         !IF (!TS<>!NULL) !THEN
            DO REPEAT TS=!TS.
               COMPUTE #N2=#N2+1.
               IF (MOD(TS,1)<>0) #Tdec=1 .
               DO IF (TS<=0).
                  COMPUTE #ERROR=1.
               END IF.
            END REPEAT.
            DO IF (#N2<>!COUNT).
               COMPUTE #ERROR=1.
            END IF.
         !IFEND.

         !IF (!NS<>!NULL) !THEN
            COMPUTE #N2=0.
            DO REPEAT NS=!NS.
               COMPUTE #N2=#N2+1.
               DO IF (MOD(NS,1)<>0).
                  COMPUTE #ERROR=2.
               ELSE IF (NS<=0).
                  COMPUTE #ERROR=1.
               END IF.
            END REPEAT.
            DO IF (#N2<>!COUNT).
               COMPUTE #ERROR=1.
            END IF.
         !IFEND.

         !IF (!T1<>!NULL !AND !A1<>!NULL) !THEN
            DO REPEAT A1=!A1 /T1=!T1.
               COMPUTE #N=#N+1.
               IF (MOD(T1,1)<>0) #Tdec=1 .
               DO IF (MOD(A1,1)<>0).
                  COMPUTE #ERROR=2.
               ELSE IF (A1<0 OR T1<=0).
                  COMPUTE #ERROR=1.
               END IF.
            END REPEAT.
            DO IF (#N<>!COUNT).
               COMPUTE #ERROR=1.
            END IF.
         !ELSE.
            !IF (!N1<>!NULL !AND !A1<>!NULL) !THEN
               DO REPEAT A1=!A1 /N1=!N1.
                  COMPUTE #N=#N+1.
                  DO IF  (MOD(A1,1)<>0 or MOD(N1,1)<>0).
                     COMPUTE #ERROR=2.
                  ELSE IF(A1<=0 or N1<=0 or N1<A1).
                     COMPUTE #ERROR=1.
                  END IF.
               END REPEAT.
               DO IF (#N<>!COUNT).
                  COMPUTE #ERROR=1.
               END IF.
            !IFEND.
         !IFEND.

         !IF (!A0<>!NULL !and !T0<>!NULL) !THEN
            DO REPEAT A0=!A0 /T0=!T0.
               COMPUTE #N1=#N1+1.
               IF (MOD(T0,1)<>0) #Tdec=1 .
               DO IF (MOD(A0,1)<>0).
                  COMPUTE #ERROR=2.
               ELSE IF (A0<0 OR T0<=0).
                  COMPUTE #ERROR=1.
               END IF.
            END REPEAT.
            DO IF (#N1<>!COUNT).
               COMPUTE #ERROR=1.
            END IF.
         !IFEND.

         !IF (!A0<>!NULL !and !N0<>!NULL) !THEN
            DO REPEAT A0=!A0 /N0=!N0.
               COMPUTE #N2=#N2+1.
               DO IF (MOD(A0,1)<>0 or MOD(N0,1)<>0).
                  COMPUTE #ERROR=2.
               ELSE IF (A0<=0 or N0<=0 or N0<A0).
                  COMPUTE #ERROR=1.
               END IF.
            END REPEAT.
            DO IF (#N2<>!COUNT).
               COMPUTE #ERROR=1.
            END IF.
         !IFEND.

         !IF (!AS<>!NULL) !THEN
            DO REPEAT AS=!AS.
               COMPUTE #N3=#N3+1.
               DO IF (MOD(AS,1)<>0).
                  COMPUTE #ERROR=2.
               ELSE IF (AS<=0).
                  COMPUTE #ERROR=1.
               END IF.
            END REPEAT.
            DO IF (#N3<>!COUNT).
               COMPUTE #ERROR=1.
            END IF.
         !IFEND.

         !IF (!AS<>!NULL) !THEN
            DO REPEAT AS=!AS.
               COMPUTE #N3=#N3+1.
               DO IF (MOD(AS,1)<>0).
                  COMPUTE #ERROR=2.
               ELSE IF (AS<=0).
                  COMPUTE #ERROR=1.
               END IF.
            END REPEAT.
            DO IF (#N3<>!COUNT).
               COMPUTE #ERROR=1.
            END IF.
         !IFEND.


         DO IF(!CL<50 or !CL>=100).
            COMPUTE #ERROR=1.
         END IF.

         DO IF (#ERROR=1).
            PRINT /'ERROR: Parameter(s) with wrong values'.
         ELSE IF (#ERROR=2).
            PRINT /'ERROR: Parameter(s) with decimal values'.
         ELSE .
*           Z: 1.96.
            COMPUTE #Z=IDF.NORMAL((!CL+100)/200,0,1).

*           Enessims parameters.
            !LET !StdpN=!CONCAT('#Stdp',!COUNT).
            !LET !PTn=!CONCAT('#PT',!COUNT).
            !LET !TPn=!CONCAT('#TP',!COUNT).
            NUMERIC #TP1 to !TPn #PT1 to !PTn.

*           Computing the list of variables of exposure.
            !IF (!T1<>!NULL) !THEN
               DO REPEAT T=!T1 /TEMPT=#PT1 to !PTn.
                  COMPUTE TEMPT=T.
               END REPEAT.
               !LET !Mesure='Rate'.
               !LET !Denom='Person-time'.
            !ELSE.
               !IF (!N1<>!NULL) !THEN
                  DO REPEAT T=!N1 /TEMPT=#PT1 to !PTn.
                     COMPUTE TEMPT=T.
                  END REPEAT.
                  !LET !Mesure='Risk'.
                  !LET !Denom =' Population'.
               !IFEND.
            !IFEND.

            !IF (!T0<>!NULL) !THEN
               DO REPEAT T=!T0 /TEMPT=#TP1 to !TPn.
                  COMPUTE TEMPT=T.
               END REPEAT.
            !ELSE.
               !IF (!N0<>!NULL) !THEN
                  DO REPEAT T=!N0 /TEMPT=#TP1 to !TPn.
                     COMPUTE TEMPT=T.
                  END REPEAT.
               !IFEND.
            !IFEND.

*           Assignation of reference population to variables.
            !IF (!TS=!NULL !and !NS=!NULL ) !THEN
               DO REPEAT T1=#PT1 to !PTn /T0=#TP1 to !TPn /Stdp=#Stdp1 to !StdpN.
                  COMPUTE Stdp=T1+T0.
               END REPEAT.
               !LET !REF='(Estimated)'.
            !ELSE.
               !IF (!TS<>!NULL) !THEN
                  DO REPEAT Stdp2=#Stdp1 to !StdpN /Stdp=!TS.
                     COMPUTE Stdp2=Stdp.
                  END REPEAT.
                  !LET !REF=' (External)'.
               !ELSE.
                  !IF (!NS<>!NULL) !THEN
                     DO REPEAT Stdp2=#Stdp1 to !StdpN /Stdp=!NS.
                        COMPUTE Stdp2=Stdp.
                     END REPEAT.
                     !LET !REF=' (External)'.
                  !ELSE.
                     !IF (!AS<>!NULL) !THEN
                        DO REPEAT Stdp2=#Stdp1 to !StdpN /Stdp=!AS.
                           COMPUTE Stdp2=Stdp.
                        END REPEAT.
                        !LET !REF=' (External)'.
                     !IFEND.
                  !IFEND.
               !IFEND.
            !IFEND.

            DO REPEAT A1=!A1 /T1=#PT1 to !PTn /Stdp=#Stdp1 to !StdpN.
*              Sum of cases in A1.
               COMPUTE #C1 =A1.
               COMPUTE #SC1=#C1+#SC1.

*              Sum of subjects in A1.
               COMPUTE #ST1 =T1.
               COMPUTE #SST1=#ST1+#SST1.

*              Sum of reference population.
               COMPUTE #Tt=Stdp.
               COMPUTE #Total=#Tt+#Total.
            END REPEAT.

            STRING #STRATUM(A8).
*           Prints: Head of Group A1.
            PRINT / 'DIRECT STANDARDIZATION'.
            !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
               STRING #NST (A131).
               COMPUTE #NST = CONCAT('STUDY: ',!NST).
               PRINT /#NST.
            !IFEND.

            PRINT //'GROUP 1 --------------------------------------------------------'.
            PRINT / '        ----------- Observed ------------   Standard    Expected'.
            PRINT / 'Stratum    Cases '!QUOTE(!Denom) !QUOTE(!Mesure)37's' !QUOTE(!REF)43 'Cases'60.
            PRINT / '----------------------------------------------------------------'.

*           Print of stratum A1.
            DO REPEAT STRATUM=!STRATUM /A1=!A1 /T1=#PT1 to !PTn /Stdp=#Stdp1 to !StdpN.
*              Assignation to print.
               COMPUTE #A1=A1.
               COMPUTE #T1=T1.
               COMPUTE #STRATUM=STRATUM.

*              Rate for stratum.
               COMPUTE #SR1=A1/T1.

*              Expected in group A1 and sum.
               COMPUTE #E1=Stdp*#SR1.
               COMPUTE #SE1=#E1+#SE1.

*              SE for group A1.
               DO IF (!QUOTE(!Mesure)='Risk').
                  COMPUTE #NUMSE1=(Stdp**2*#SR1*(1-#SR1)/T1).
               ELSE IF (!QUOTE(!Mesure)='Rate').
                  COMPUTE #NUMSE1=(Stdp**2*#SR1/T1).
               END IF.
               COMPUTE #SUMSE1=#NUMSE1+#SUMSE1.

               PRINT / #STRATUM(T2,A8) #A1(T8,F9) #T1(T20,F9) #SR1(T31,F11.10)  Stdp(T44,F9) #E1(T54,F11.3).
            END REPEAT.
            PRINT / '----------------------------------------------------------------'.

*           Crude and adjusted estimation.
            COMPUTE #CRate1=#SC1/#SST1.
            COMPUTE #DS1=#SE1/#Total.

*           SE and Confidence Interval of DSR, Cochran, 1977.
            COMPUTE #SError1=SQRT(#SUMSE1/#TOTAL**2).
            COMPUTE #LbDS1=#DS1-#Z*#SError1.
            COMPUTE #UbDS1=#DS1+#Z*#SError1.

*           CMF and bounds: computing only if ICS is giving.
            !IF (!ICS<>!NULL) !THEN
               COMPUTE #CMF1=#DS1/!ICS.
               COMPUTE #LbCMF1=#LbDS1/!ICS.
               COMPUTE #UbCMF1=#UbDS1/!ICS.
            !IFEND.

            PRINT / 'TOTAL:' #SC1 (T8,F9) #SST1 (T20,F9) #CRate1(T31,F11.10) #Total(T44,F9) #SE1(T54,F11.3).

*           Computing and printing for Group A0.
            !IF (!A0<>!NULL) !THEN
               PRINT //'GROUP 0 --------------------------------------------------------'.
               PRINT / '        ----------- Observed ------------   Standard    Expected'.
               PRINT / 'Stratum    Cases '!QUOTE(!Denom) !QUOTE(!Mesure)37's' !QUOTE(!REF)43 'Cases'60.
               PRINT / '----------------------------------------------------------------'.

               DO REPEAT STRATUM=!STRATUM /A0=!A0 /T0=#TP1 to !TPn /Stdp=#Stdp1 to !StdpN.
*                 Sum of cases in A0.
                  COMPUTE #C0=A0.
                  COMPUTE #SC0=#C0+#SC0.
                  COMPUTE #STRATUM=STRATUM.

*                 Sum of subjects in A0.
                  COMPUTE #T0 =T0.
                  COMPUTE #SST0=#T0+#SST0.

*                 Rate for stratum.
                  COMPUTE #SR0=A0/T0.

*                 Expect in group A0 and sum.
                  COMPUTE #E0=Stdp*#SR0.
                  COMPUTE #SE0=#E0+#SE0.

*                 SE for group A0.
                  DO IF (!QUOTE(!Mesure)='Risk').
                     COMPUTE #NUMSE0=(Stdp**2*#SR0*(1-#SR0)/T0).
                  ELSE IF (!QUOTE(!Mesure)='Rate').
                     COMPUTE #NUMSE0=(Stdp**2*#SR0/T0).
                  END IF.
                  COMPUTE #SUMSE0=#NUMSE0+#SUMSE0.

                  PRINT / #STRATUM(T2,A8) #C0(T8,F9) #T0(T20,F9) #SR0(T31,F11.10)  Stdp(T44,F9) #E0(T54,F11.3).
               END REPEAT.
               PRINT / '----------------------------------------------------------------'.

*              Crude and adjusted estimation.
               COMPUTE #CRate0=#SC0/#SST0.
               COMPUTE #DS0=#SE0/#Total.

*              SE and Confidence Interval of DSR, Cochran, 1977.
               COMPUTE #SError0=SQRT(#SUMSE0/#TOTAL**2).
               COMPUTE #LbDS0=#DS0-#Z*#SError0.
               COMPUTE #UbDS0=#DS0+#Z*#SError0.

               PRINT / 'TOTAL:' #SC0 (T8,F9) #SST0 (T20,F9) #CRate0(T31,F11.10) #Total(T44,F9) #SE0(T54,F11.3).

*              SRR and SRD.
               COMPUTE #SRR=#DS1/#DS0.
               COMPUTE #SRD=#DS1-#DS0.
               COMPUTE #RR=#CRate1/#CRate0.
               COMPUTE #RD=#CRate1-#CRate0.

*              SE of SRR and SRD.
               COMPUTE #lnSeSRR=SQRT( (#SError1/#DS1)**2+(#SError0/#DS0)**2).
               COMPUTE #LbSRR= #SRR*EXP(-#Z*#lnSeSRR).
               COMPUTE #UbSRR= #SRR*EXP(#Z*#lnSeSRR).

               COMPUTE #SeSRD=SQRT(#SError1**2+#SError0**2).
               COMPUTE #LbSRD= #SRD-#Z*#SeSRD.
               COMPUTE #UbSRD= #SRD+#Z*#SeSRD.

*              CMF and bounds: computing only if ICS is giving.
               !IF (!ICS<>!NULL) !THEN
                  COMPUTE #CMF0=#DS0/!ICS.
                  COMPUTE #LbCMF0=#LbDS0/!ICS.
                  COMPUTE #UbCMF0=#UbDS0/!ICS.
               !IFEND.
            !IFEND.

            PRINT //'                              |   Estimate   |   '!QUOTE(!CL)'% Confidence Interval'.
            PRINT  /'------------------------------+--------------+--------------------------'.
            PRINT  /'          Crude '!QUOTE(!Mesure)' (Group 1)|'#CRate1(T34,F11.10)'|'46.
            PRINT  /' Direct Standardized (Group 1)|'#DS1(T34,F11.10)'|'46 #LbDS1(T49,F11.10)#UbDS1 (T62,F11.10).
            !IF (!ICS<>!NULL) !THEN
               PRINT/'                 CMF (Group 1)|'#CMF1(T32,F11.5)'|'46 #LbCMF1(T48,F12.5)#UbCMF1(T61,F12.5).
            !IFEND.
            PRINT  /'------------------------------+--------------+--------------------------'.

            !IF (!A0<>!NULL) !THEN
               PRINT  /'          Crude '!QUOTE(!Mesure)' (Group 0)|'#CRate0(T34,F11.10)'|'46.
               PRINT  /' Direct Standardized (Group 0)|'#DS0(T34,F11.10) '|'46 #LbDS0(T49,F11.10)#UbDS0 (T62,F11.10).
               !IF (!ICS<>!NULL) !THEN
                  PRINT/'                 CMF (Group 0)|'#CMF0(T32,F11.5)'|'46 #LbCMF0(T48,F12.5)#UbCMF0(T61,F12.5).
               !IFEND.
               PRINT  /'------------------------------+--------------+--------------------------'.
               PRINT  /'        Crude Difference '!QUOTE(!Mesure)' |'#RD(T33,F12.10)  '|'46.
               PRINT  /' Standardized Difference '!QUOTE(!Mesure)' |'#SRD(T33,F12.10) '|'46 #LbSRD(T49,F11.10)#UbSRD (T62,F11.10).
               PRINT  / '|'31 '|'46 .
               PRINT  /'        Crude '!QUOTE(!Mesure)' Ratio (1/0)|' #RR(T32,F11.5)    '|'46.
               PRINT  /' Standardized '!QUOTE(!Mesure)' Ratio (1/0)|'#SRR(T32,F11.5)    '|'46 #LbSRR(T48,F12.5) #UbSRR (T61,F12.5).
               PRINT  /'------------------------------+--------------+--------------------------'.

               DO IF (#SRR<1).
                  COMPUTE #ISRR=1/#SRR.
                  COMPUTE #IlbSRR=1/#UbSRR.
                  COMPUTE #IubSRR=1/#LbSRR.
                  PRINT /'                         inv. |'#ISRR(T32,F11.4) '|'46 #IlbSRR (T48,F12.4) #IUbSRR (T61,F12.4).
                  PRINT /'------------------------------+--------------+--------------------------'.
                  PRINT /'Note: "inv." line contains the inverse of SRR (in case of SRR < 1)'.
                  DO IF (#Tdec=1).
                     PRINT/'NOTE: Person-Time values are printed rounded'.
                  END IF.
               END IF.
            !IFEND.
         END IF.
      !IFEND.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
