PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
  PRINT /'Macro !ISR V2008.02.29 loaded.'
        /'Execute !ISR HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !ISR  (STRATUM =!CHAREND('/')   /AS=!CHAREND('/') /A1 =!CHAREND('/')
   /TS=!CHAREND('/') /T1=!CHAREND('/') /IS=!CHAREND('/') /ICS=!CHAREND('/')   
   /NS=!CHAREND('/') /N1=!CHAREND('/') /RS=!CHAREND('/') /RCS=!CHAREND('/') 
   /M1=!CHAREND('/') /CL=!DEFAULT('95')!CHAREND('/')
   /NST=!CHAREND('/')
   /HELP=!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2008.02.29').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
+   PRINT //'Macro !ISR V' !VERSION ' (c)JM.Domenech'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*Impresin de la documentacin.
+  DO IF ($casenum=1).
+    PRINT /'******************************************************************************'
           /'* INDIRECT STANDARDIZATION RATES                                             *'
           /'* Created 1999.11.08 Last revised ' !VERSION                                '*'78
           /'* (c) JM.Domenech                                                            *'
           /'* Programmer: A.Bonillo                                                      *'
           /'*                                                                            *'
           /'* Vancouver reference:                                                       *'
           /'* Domenech JM. Macro !ISR for SPSS Statistics.                               *'
           /'*    Indirect Standardization Rates [computer program].                      *'
           /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
           /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
           /'*                                                                            *'
           /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
           /'* !ISR STRATUM= List of Stratum labels(up to 8 characters)  (in SPSS format) *'
           /'* [   /AS ]   = List of cases in STANDARD POP.  by Stratum  (A0 integer >=0) *'
           /'* [  {/TS     = List of person-time in STANDARD by Stratum  (TS > 0)         *'
           /'*  or /NS     = List of population  in STANDARD by Stratum  (NS > 0)         *'
           /'*  or /IS     = List of RATES in STANDARD POP.  by Stratum  (0 < IS)         *'
           /'*  or /RS}]   = List of RISK  in STANDARD POP.  by Stratum  (0 < RS < 1)     *'
           /'*    {/ICS    = Crude RATE in STANDARD POPULATION           (ICS > 0)        *'
           /'*  or /RCS}   = Crude risk in STANDARD POPULATION           (0 < RCS < 1)    *'
           /'* [  {/A1     = List of cases in Group 1 by Stratum         (A1 integer >=0) *'
           /'*  or /M1}]   = Total number of Observed cases in Group 1                    *'
           /'*    {/T1     = List of person-time in Group 1 by Stratum   (T1 >0)          *'
           /'*  or /N1}    = List of population  in Group 1 by Stratum                    *'
           /'*                                                  (N1 integer >= A1 and >0) *'
           /'*   [  /CL]   = Confidence level (%); by default: 95        (50 <= CL < 100) *'
           /'*   [ /NST]   = Name of the study (Label)                                    *'
           /'*   [/HELP]     Print Macro call arguments and Samples of calls              *'
           /'*----------------------------------------------------------------------------*'
           /'* Notes: Parameters enclosed in Square Brackets [ ] are optional             *'
           /'*        Parameters enclosed in Braces { } indicate a choice between elements*'
           /'*        Parameters /T1, /TS, IS and /ICS records RATE DATA.                 *'
           /'*        Parameters /N1, /NS, RS and /RCS records RISK DATA.                 *'
           /'*                                                                            *'
           /'* Samples of calls:                                                          *'
           /'* !ISR HELP.                                                                 *'
           /'* !ISR STRATUM=   "<20-24"   "25-34"   "35-44"   "45-54"  "55-64"            *'
           /'*     /IS     = 0.0001298 0.0001525 0.0002804 0.0008162 0.002312             *'
           /'*     /T1     =      8481     39729     65700     73376    58226             *'
           /'*     /ICS    = 0.0008   /M1= 7317 /CL= 90 /NST="Name of the Study".         *'
           /'*                                                                            *'
           /'* !ISR STRATUM= "<20-24"   "25-34"   "35-44"   "45-54"  "55-64"              *'
           /'*     /AS     =     117       310       809      2421     5432               *'
           /'*     /TS     =   27545     56432    128969    342107   186342               *'
           /'*     /A1     =      87       289       733      1998     4571               *'
           /'*     /T1     =  8481.3   39728.7   65700.4   73376.2  58225.6 .             *'
           /'******************************************************************************'.
+  END IF.
EXECUTE.
+   COMPUTE #ERROR=1.
*Testing the parameters.
!ELSE.
!IF (!STRATUM=!NULL  !or ( ((!AS=!NULL !and !TS=!NULL !and !NS=!NULL) !and (!M1=!NULL)) !and !ICS=!NULL !and !RCS=!NULL  ) 
!or ( ((!IS=!NULL !and !RS=!NULL !and !NS=!NULL) !or (!ICS=!NULL !and !RCS=!NULL !and !M1=!NULL !and !A1=!NULL) )
 !and (!AS=!NULL !and !TS=!NULL))   ) !THEN 
+   PRINT /'ERROR: Missing parameter'.
!ELSE.
+   COMPUTE #ERROR=0.
+   COMPUTE #N=0.
+   COMPUTE #N1=0.
+   COMPUTE #Tdec=0.

+     *Count of the numbers of elements.
+     !LET !BLANK=!NULL.
+     !LET !SBLANK=!NULL.
+     !DO !I !IN (!STRATUM).
+       !LET !BLANK=' '.
+       !LET !SBLANK=!CONCAT(!SBLANK,!BLANK).
+     !DOEND.

+     *Levels of group's variable.
+     !LET !COUNT=!LENGTH(!SBLANK).

+   !IF (!AS<>!NULL !and !TS<>!NULL) !THEN
+     DO REPEAT AS=!AS /TS=!TS.
+     COMPUTE #N=#N+1.
+       DO IF (AS<0 OR TS<=0).
+         COMPUTE #ERROR=1.
+       END IF.

+     END REPEAT.
+   !ELSE.
+     !IF (!IS<>!NULL) !THEN 
+       DO REPEAT IS=!IS.
+     COMPUTE #N=#N+1.
+         DO IF (IS<=0).
+           COMPUTE #ERROR=1.
+         END IF.
+       END REPEAT.
+     !IFEND.
+   DO IF (#N<>!COUNT).
+     COMPUTE #ERROR=1.
+   END IF.
+   !IFEND.

+   !IF (!A1<>!NULL !and !T1<>!NULL) !THEN 
+     DO REPEAT A1=!A1 /T1=!T1.
+     COMPUTE #N1=#N1+1.
+     IF (MOD(T1,1)<>0) #Tdec=1 .
+       DO IF (A1<0 OR T1<=0).
+         COMPUTE #ERROR=1.
+       ELSE IF (MOD(A1,1)<>0 ).
+         COMPUTE #ERROR=2.
+       END IF.
+     END REPEAT.
+   !ELSE.
+     !IF (!A1<>!NULL !and !N1<>!NULL) !THEN 
+       DO REPEAT A1=!A1 /N1=!N1.
+     COMPUTE #N1=#N1+1.
+         DO IF (A1<0 or N1<1 or N1<A1).
+           COMPUTE #ERROR=1.
+         ELSE IF (MOD(A1,1)<>0 or MOD(N1,1)<>0).
+           COMPUTE #ERROR=2.
+         END IF.
+       END REPEAT.
+     !ELSE.
+       !IF (!M1<>!NULL !and !T1<>!NULL) !THEN 
+           DO IF (MOD(!M1,1)).
+             COMPUTE #ERROR=2.
+           END IF.
+           DO REPEAT T1=!T1.
+             COMPUTE #N2=#N2+1.
+             DO IF (T1<=0).
+               COMPUTE #ERROR=1.
+             END IF.
+           END REPEAT.
+       !IFEND.
+     !IFEND.

+     !IF (!ICS<>!NULL) !THEN 
+       DO IF(!ICS<=0).
+         COMPUTE #ERROR=1.
+       END IF.
+     !IFEND.

+     !IF (!RCS<>!NULL) !THEN 
+       DO IF(!RCS<=0 or !RCS>=1).
+         COMPUTE #ERROR=1.
+       END IF.
+     !IFEND.

+     DO IF(!CL<50 or !CL>=100).
+       COMPUTE #ERROR=1.
+     END IF.

+   !IFEND.

+     DO IF (#ERROR=1).
+       PRINT /'ERROR: Parameter(s) with wrong values'.
+     ELSE IF (#ERROR=2).
+       PRINT /'ERROR: Parameter(s) with decimal values'.
+     ELSE .
+     *Z: 1.96.
+     COMPUTE #Z=IDF.NORMAL((!CL+100)/200,0,1).

+     !LET !TSn=!CONCAT('#TS',!COUNT).
+     !LET !RtRef=!CONCAT('#RtRef',!COUNT).
+     !LET !Tn=!CONCAT('#T',!COUNT).
+      NUMERIC #RtRef1 to !RtRef.

*      Computing the list of variables of exposition.
+     !IF (!T1<>!NULL) !THEN
+       DO REPEAT T1=!T1 /T=#T1 to !Tn.
+         COMPUTE T=T1.
+       END REPEAT.
+      !LET !Mesure='Rate'.
+      !LET !Denom='Person-Time'.
+      !LET !P1=!T1.
+     !ELSE.
+       !IF (!N1<>!NULL) !THEN
+         DO REPEAT T1=!N1 /T=#T1 to !Tn.
+           COMPUTE T=T1.
+         END REPEAT.
+        !LET !P1=!N1.
+        !LET !Mesure='Risk'.
+        !LET !Denom =' Population'.
+       !IFEND.
+     !IFEND.

+     !IF (!TS<>!NULL) !THEN
+       DO REPEAT TS=!TS /T=#TS1 to !TSn.
+         COMPUTE T=TS.
+       END REPEAT.
+      !LET !PR=!TS.
+     !ELSE.
+       !IF (!NS<>!NULL) !THEN
+         DO REPEAT TS=!NS /T=#TS1 to !TSn.
+           COMPUTE T=TS.
+         END REPEAT.
+        !LET !PR=!NS.
+       !IFEND.
+     !IFEND.

*     Enessims parameters.
+     !IF (!AS<>!NULL) !THEN
+       DO REPEAT RtRef=#RtRef1 to !RtRef /AS=!AS /TS=!PR.
+         COMPUTE RtRef=AS/TS.
+         COMPUTE #TmCRef=AS.
+         COMPUTE #Ctotal=#TmCRef+#CTotal.
+         COMPUTE #TmTRef=TS.
+         COMPUTE #Total=#TmTRef+#Total.
+       END REPEAT.
+       COMPUTE #CRateR=#CTotal/#Total.
+     !ELSE.
+       !IF (!IS<>!NULL) !THEN 
+         DO REPEAT RateRef=#RtRef1 to !RtRef /TempRate=!IS.
+           COMPUTE RateRef=TempRate.
+           COMPUTE #CRateR=!ICS.
+         END REPEAT.
+       !IFEND.
+     !IFEND.

*     Sum of subjects in A1.
+     DO REPEAT T1=!P1.
+       COMPUTE #SA =T1.
+       COMPUTE #SSA=#SA+#SSA.
+     END REPEAT.

+     !IF (!A1<>!NULL) !THEN 
+       DO REPEAT A1=!A1 /T1=!P1.
*         Sum of cases in A1.
+         COMPUTE #CA =A1.
+         COMPUTE #SCA=#CA+#SCA.
+       END REPEAT.
+      !LET !AA1= !CONCAT('/A1=',!A1).
+      !LET !PA1=' #A1(T22,F9) '.
+      !LET !COMPUTE='COMPUTE #A1=A1.'.
+     !ELSE.
+        !IF (!M1<>!NULL) !THEN 
+           COMPUTE #SCA=!M1.
+          !LET !AA1=' '.
+          !LET !PA1=' '.
+          !LET !COMPUTE=' '.
+        !IFEND.
+     !IFEND.

+     STRING #STRATUM(A8).
*     Prints: Head of A1 group.
+     PRINT  /'INDIRECT STANDARDIZATION'.
      !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
         STRING #NST (A131).
         COMPUTE #NST = CONCAT('STUDY: ',!NST).
         PRINT /#NST.
      !IFEND.

+     PRINT //'         ----- Observed ------     Expected         Standard'.
+     PRINT / 'Stratum  '!QUOTE(!Denom)'Cases        Cases  Population '26 !QUOTE(!Mesure).
+     PRINT / '------------------------------------------------------------'.

*     Print of stratum.
+     DO REPEAT STRATUM=!STRATUM !AA1 /T1=!P1 /RtRef=#RtRef1 to !RtRef.
*       Assignation to print.
+      !COMPUTE.
+       COMPUTE #T1=T1.
+       COMPUTE #RtRef=RtRef.
+       COMPUTE #STRATUM=STRATUM.

*       Expected in T1.
+       COMPUTE #EA=T1*#RtRef.
*       Expect in group and sum.
+       COMPUTE #SEA=#EA+#SEA.

+       PRINT / #STRATUM(T2,A8) #T1(T10,F11) !PA1 #EA(T31,F13.3) #RtRef(T50,F11.10).
+     END REPEAT.

*     Crude.
+     COMPUTE #CRateA=#SCA/#SSA.

+     PRINT / '------------------------------------------------------------'.
+     PRINT / 'TOTAL' #SSA (T10,F11) #SCA (T22,F9) #SEA(T31,F13.3) #CRateR(T50,F11.10).

*     Crude and adjusted estimation.
+     COMPUTE #ISA=(#SCA/#SEA)*#CRateR.
+     COMPUTE #SMRa=(#SCA/#SEA).

*     Bounds.
+     COMPUTE #u0A=(#z/2-SQR(#SCA))**2.
+     COMPUTE #u1A=(#z/2+SQR(#SCA+1))**2.
+     COMPUTE #LbISA=(#U0A/#SEA)*#CRateR.
+     COMPUTE #UbISA=(#U1A/#SEA)*#CRateR.
+     COMPUTE #LbSMRa=(#U0A/#SEA).
+     COMPUTE #UbSMRa=(#U1A/#SEA).

+     PRINT//'                           |    Estimate  |  '!QUOTE(!CL)'% Confidence Interval'.
+     PRINT /'---------------------------+--------------+-------------------------'.
+     PRINT /'                Crude '!QUOTE(!Mesure)'|'28 #CRateA(T31,F11.10)'|'43. 
+     PRINT /'Indirect Standardized '!QUOTE(!Mesure)'|'28 #ISA(T31,F11.10)   '|'43 #LbISA (T45,F11.10)#UbISA(T58,F11.10). 
+     PRINT /'|'28  '|'43. 
+     PRINT /'                  SMR (O/E)|'#SMRa(T32,F10.5)   '|'43 #LbSMRa(T45,F11.5)#UbSMRa(T58,F11.5). 
+     PRINT /'---------------------------+--------------+-------------------------'.
+     DO IF (#Tdec=1).
+       PRINT/'NOTE: Person-Time values are printed rounded'.
+     END IF.
+   END IF.
!IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
