PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
  PRINT /'Macro !CIM V2008.02.29 loaded.'
        /'Execute !CIM HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !CIM (M=!CHAREND('/')
	        /SD=!CHAREND('/')
	         /V=!CHAREND('/')
	         /N=!CHAREND('/')
	        /PN=!CHAREND('/')
 	        /CL=!CHAREND('/')!DEFAULT('95')
 	       /NST=!CHAREND('/')
         /HELP=!CHAREND('/')!DEFAULT(1) ).

PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132.
!LET !VERSION=!QUOTE('2008.02.29').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
  PRINT //'Macro !CIM V' !VERSION ' (c) JM.Domenech & R.Granero'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
* Print the help.
  DO IF ($casenum=1).
     PRINT /'********************************************************************************'
           /'* CONFIDENCE INTERVALS FOR MEANS AND VARIANCES (Asymptotics)                   *'
           /'* Created 2005.12.30 Last revised ' !VERSION                                  '*'80
           /'* (c) JM.Domenech & R.Granero                                                  *'
           /'* Programmer: R.Sesma                                                          *'
           /'*                                                                              *'
           /'* Vancouver reference:                                                         *'
           /'* Domenech JM, Granero R. Macro !CIM for SPSS Statistics.                      *'
           /'*    Confidence Intervals for Means and Variances (Asymptotics)                *'
           /'*    [computer program].                                                       *'
           /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'80
           /'*    Available from: http://www.metodo.uab.cat/macros.htm.                     *'
           /'*                                                                              *'
           /'* Macro Call (tested for SPSS 15.0 and higher):                                *'
           /'* !CIM   M = List of Means                                                     *'
           /'*     {/SD = List of Standard Deviations              (SDi > 0)                *'
           /'*   or  /V}= List of Variances                        (Vi  > 0)                *'
           /'*       /N = List of sample sizes                     (Ni: integer > 1)        *'
           /'*     [/PN]= Populations Size; by default: INFINITE   (PN: integer > Ni)       *'
           /'*     [/CL]= Confidence level(%); by default: 95      (50 <= CL < 100)         *'
           /'*    [/NST]= Name of the study (Label)                                         *'
           /'*    [/HELP] Print Macro call arguments and Samples of calls                   *'
           /'*                                                                              *'
           /'* Note: Parameters enclosed in Square Brackets [ ] are optional                *'
           /'*       Parameters enclosed in Braces { } indicate a choice between elements   *'
           /'*                                                                              *'
           /'*                                   +------------+----------+----------+-----+ *'
           /'*                                   |            | Sample 1 | Sample 2 | ... | *'
           /'*                                   +------------+----------+----------+-----+ *'
           /'* Samples of calls:                 |      Means |    M1    |    M2    | ... | *'
           /'* !CIM HELP.                        +------------+----------+----------+-----+ *'
           /'* !CIM M=1.17 /V=2.13 /N=16.        |   Variance |    V1    |    V2    | ... | *'
           /'* !CIM M=2.4 /SD=1.02 /N=25 /CL=90. +------------+----------+----------+-----+ *'
           /'* !CIM M=3.6 /SD=2.1 /N=25 /PN=1847.|SAMPLE size |    N1    |    N2    | ... | *'
           /'* !CIM M=1.17 2.48                  +------------+----------+----------+-----+ *'
           /'*    /SD=0.38 1.82                  |  POP. size |    PN    |    PN    | ... | *'
           /'*     /N=16   82  /NST="Study Name".+------------+----------+----------+-----+ *'
           /'********************************************************************************'.
  END IF.
  EXECUTE.
!ELSE. 
* Testing the parameters.
  !IF (!M=!NULL !or !N=!NULL !or (!SD=!NULL !and !V=!NULL)) !THEN 
     PRINT /'ERROR: Missing parameter'.
  !ELSE.
     COMPUTE #ERROR=0.

*    Test parameter M.
     COMPUTE #COUNTM=0.
     DO REPEAT M=!M. 
        COMPUTE #COUNTM=#COUNTM + 1.
        COMPUTE #TEMP=$SYSMIS.
        COMPUTE #TEMP=M.
        IF (SYSMIS(#TEMP)) #ERROR=1.
     END REPEAT.

*    Test parameter SD or V.
     COMPUTE #COUNTV=0.
     !IF ((!SD<>!NULL) !and (!V<>!NULL)) !THEN
        COMPUTE #ERROR=3.
     !ELSE.
        !IF (!SD<>!NULL) !THEN
           DO REPEAT SD=!SD.
               COMPUTE #COUNTV=#COUNTV + 1.
               COMPUTE #TEMP = $SYSMIS.
               COMPUTE #TEMP = SD.
               DO IF (SYSMIS(#TEMP)).
                  COMPUTE #ERROR=1.
               ELSE.
                  IF (#TEMP<=0) #ERROR=1.
               END IF.
           END REPEAT.
        !ELSE.
           DO REPEAT V=!V.
               COMPUTE #COUNTV=#COUNTV + 1.
               COMPUTE #TEMP = $SYSMIS.
               COMPUTE #TEMP = V.
               DO IF (SYSMIS(#TEMP)).
                  COMPUTE #ERROR=1.
               ELSE.
                  IF (#TEMP<=0) #ERROR=1.
               END IF.
           END REPEAT.
        !IFEND.
     !IFEND.

*    Test parameter N.
     COMPUTE #COUNTN=0.
     DO REPEAT N=!N. 
        COMPUTE #COUNTN=#COUNTN + 1.
        COMPUTE #TEMP=$SYSMIS.
        COMPUTE #TEMP=N.
        DO IF (SYSMIS(#TEMP)).
           COMPUTE #ERROR=1.
        ELSE.
           IF (#TEMP<=1) #ERROR=1.
           IF (MOD(#TEMP,1)<>0) #ERROR=2.
        END IF.
     END REPEAT.

*    Test parameter PN.
     !IF (!PN<>!NULL) !THEN 
        COMPUTE #PN=$SYSMIS.
        COMPUTE #PN=!PN.
        DO IF (SYSMIS(#PN)).
           COMPUTE #ERROR=1.
        ELSE.
           DO REPEAT N=!N. 
              IF (N>=#PN) #ERROR=1.
           END REPEAT.
           IF (MOD(#PN,1)<>0) #ERROR=2.
        END IF.
     !IFEND.

*    Test parameter CL.
     COMPUTE #CL=$SYSMIS.
     COMPUTE #CL = !CL.
     DO IF (SYSMIS(#CL)).
        COMPUTE #ERROR=1.
     ELSE.
        IF (!CL<50 or !CL>=100) #ERROR=1.
     END IF.

*    Test correct number of parameters.
     IF ((#ERROR=0) and ((#COUNTM<>#COUNTN) or (#COUNTM<>#COUNTV) or (#COUNTN<>#COUNTV))) #ERROR=1.

     DO IF (#ERROR=1).
        PRINT /'ERROR: Parameter(s) with wrong values'.
     ELSE IF (#ERROR=2).
        PRINT /'ERROR: Parameter(s) with decimal values'.
     ELSE IF (#ERROR=3).
        PRINT /'ERROR:Too much Parameter(s)'.
     ELSE.
*       Correct parameters: compute of variables and print.
        !LET !SD2 = !NULL.
        !LET !COUNT = ' '
        !DO !I !IN (!N).
           !LET !SD2=!CONCAT(!SD2,' ',!CONCAT('#SD2',!LENGTH(!COUNT))).
           !LET !COUNT=!CONCAT(!COUNT,' ').
        !DOEND.
        NUMERIC !SD2.
        !IF (!SD<>!NULL) !THEN
           DO REPEAT SD2=!SD2 /SD=!SD.
               COMPUTE SD2=SD*SD.
           END REPEAT.
        !ELSE.
           DO REPEAT SD2=!SD2 /V=!V.
               COMPUTE SD2=V.
           END REPEAT.
        !IFEND.
        
        PRINT  /'CONFIDENCE INTERVALS FOR MEANS AND VARIANCES (ASYMPTOTICS)'.
        !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
           STRING #NST (A131).
           COMPUTE #NST = CONCAT('STUDY: ',!NST).
           PRINT /#NST.
        !IFEND.
        !IF (!PN=!NULL) !THEN 
           PRINT  /'Population size: INFINITE'.
        !ELSE.
           PRINT  /'Population size: ' !QUOTE(!PN) ' subjects'.
        !IFEND.

        PRINT //'Sample |           |                |'.
        PRINT  /'  Size | Statistic |    Estimate    | '!QUOTE(!CL)'% Confidence Interval (Asympt)'.
        PRINT  /'-------+-----------+----------------+---------------------------------'.

        COMPUTE #COUNT = 0.
        COMPUTE #WARNING=0.
        STRING #Tn(A1).
        DO REPEAT M=!M /SD2=!SD2 /N=!N.
           COMPUTE #COUNT=#COUNT + 1.
           COMPUTE #M  = M.
           COMPUTE #SD2= SD2.
           COMPUTE #N  = N.
           COMPUTE #p  = (!CL+100)/200.

*          Confidence interval for mean.
           !IF (!PN=!NULL) !THEN
              COMPUTE #FE=1. 
           !ELSE.
              COMPUTE #FE=(!PN - #N)/(!PN - 1).
           !IFEND.
           COMPUTE #E =  IDF.T(#p,(#N-1))*SQR((#SD2/#N)*#FE).
           COMPUTE #lbm= #M - #E.
           COMPUTE #ubm= #M + #E.
           
           COMPUTE #Tn=' '.
           IF (#N<30) #WARNING=1.
           IF (#N<30) #Tn='*'.
           PRINT / #N(T2,F5) '|'8 'Mean'14 #Tn(A1) '|'20 #M(T22,F14.6) '|'37 #lbm(T39,F14.6) ' to ' #ubm(F14.6).

           !IF (!PN=!NULL) !THEN
*             Confidence interval for variance.
              COMPUTE #df = #N - 1.
              COMPUTE #lbv= (#df*#SD2)/IDF.CHISQ(#p,#df).
              COMPUTE #ubv= (#df*#SD2)/IDF.CHISQ(1-#p,#df).

              !IF (!SD<>!NULL) !THEN
                 COMPUTE #SD = SQR(#SD2). 
                 COMPUTE #lbv= SQR(#lbv).
                 COMPUTE #ubv= SQR(#ubv).
                 PRINT /'|'8 'Std Dev**'11 '|'20 #SD(T22,F14.6) '|'37 #lbv(T39,F14.6) ' to ' #ubv(F14.6).
              !ELSE.
                 PRINT /'|'8 'Variance**'10 '|'20 #SD2(T22,F14.6) '|'37 #lbv(T39,F14.6) ' to ' #ubv(F14.6).
              !IFEND.
           !IFEND.

*          Print the separate line.
           DO IF (#COUNT <> #COUNTM).
              PRINT /'|'8 '|'20 '|'37.
           END IF.
        END REPEAT.
        PRINT  /'-------+-----------+----------------+---------------------------------'.
        DO IF (#WARNING=1).
           PRINT /'(*)WARNING: Small Size'.
        END IF.
        !IF (!PN=!NULL) !THEN
           PRINT /'(**)WARNING: Normal assumption is required'.
        !IFEND.
     END IF.
  !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
