PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !CIP V2012.07.13 loaded: CONFIDENCE INTERVALS FOR PROPORTIONS'
         /'Execute !CIP HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !CIP (A=!CHAREND('/')  /N=!CHAREND('/')
          /VAR=!CHAREND('/')  /VAL=!CHAREND('/')
	        /PN=!CHAREND('/')
 	        /CL=!CHAREND('/')!DEFAULT('95')  /PrCI=!CHAREND('/')!DEFAULT('W')
 	       /NST=!CHAREND('/')
         /HELP=!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2012.07.13').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
!LET !WINDOW='HIDDEN'.
DO IF ($casenum=1).
   PRINT //'Macro !CIP V' !VERSION ' (c)JM.Domenech & R.Granero'.
END IF.
!IF (!HELP<>1) !THEN.
*  Print the help.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* CONFIDENCE INTERVALS FOR PROPORTIONS                                       *'
            /'* Created 1998.11.30 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech & R.Granero                                                *'
            /'* Programmers: A.Bonillo & R.Sesma                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM, Granero R. Macro !CIP for SPSS Statistics.                    *'
            /'*    Confidence Intervals for Proportions [computer program].                *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* Parameter for PRINTING MACRO DOCUMENTATION --------------------------------*'
            /'*  !CIP HELP.                                                                *'
            /'*                                                                            *'
            /'* Parameters for INDIVIDUAL DATA --------------------------------------------*'
            /'*  !CIP  VAR = Variable list                                                 *'
            /'*      [/VAL]= Event value list; by default: 1                               *'
            /'*                                                                            *'
            /'* Parameters for AGGREGATED DATA --------------------------------------------*'
            /'*  !CIP    A = List of Events                        (Ai: >= 0)              *'
            /'*         /N = List of sample sizes                  (Ni: >= Ai)             *'
            /'*                                                                            *'
            /'* Parameters for BOTH TYPES OF DATA -----------------------------------------*'
            /'*       [/PN]= Population size; by default:INFINITE  (PN: integer > Ni)      *'
            /'*       [/CL]= Confidence level(%); by default: 95   (50 <= CL < 100)        *'
            /'*            = SE  for printing Standard Error instead of Confidence Interval*'
            /'*     [/PrCI]= Method for compute CI of proportions:                         *'
            /'*              W  Wilson                              by default: W          *'
            /'*              E  Exact (Clopper-Pearson)                                    *'
            /'*              A  Asymptotic                                                 *'
            /'*              ALL                                                           *'
            /'*      [/NST]= Name of the study (Label)                                     *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in square brackets [ ] are optional              *'
            /'*                                                                            *'
            /'* Samples of calls:                                                          *'
            /'* !CIP HELP.                    +------------+----------+----------+-----+   *'
            /'* !CIP VAR=Sexo HF              |            | Sample 1 | Sample 2 | ... |   *'
            /'* !CIP VAR=Sexo HF              +------------+----------+----------+-----+   *'
            /'*     /VAL=  0  1 /PN=2752      |     Events |    A1    |    A2    | ... |   *'
            /'*     /NST="Study Name" /CL=95. +------------+----------+----------+-----+   *'
            /'* !CIP VAR=Sexo Sexo /VAL=0 1.  |  NonEvents |          |          |     |   *'
            /'* !CIP A=11 /N=16 /PrCI=ALL.    +------------+----------+----------+-----+   *'
            /'* !CIP A=0  /N=82 /CL=90.       |SAMPLE size |    N1    |    N2    | ... |   *'
            /'* !CIP A=11 /N=16 /PN=1847.     +------------+----------+----------+-----+   *'
            /'* !CIP A=11 40                  |  POP. size |    PN    |    PN    | ... |   *'
            /'*     /N=16 82/PN=1712 /CL=90.  +------------+----------+----------+-----+   *'
            /'******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE. 
*  Test parameters.
   !LET !ERROR=0.
   !IF (!VAR=!NULL !AND !VAL=!NULL !AND !A=!NULL !AND !N=!NULL) !THEN.
*     VAR,VAL,A,N missing.
      !LET !ERROR=1.
      !LET !ErrorText='VAR,VAL or A,N'.
   !IFEND.
   !IF (!ERROR=0 !AND ((!VAR<>!NULL !OR !VAL<>!NULL) !AND (!A<>!NULL !OR !N<>!NULL))) !THEN.
*     Error: too much parameters.
      !LET !ERROR=2.
   !IFEND.
   !IF (!ERROR=0 !AND (!VAR=!NULL !AND !VAL<>!NULL)) !THEN.
*     VAR missing.
      !LET !ERROR=1.
      !LET !ErrorText='VAR'.
   !ELSE.
      !IF (!ERROR=0 !AND ((!A<>!NULL !AND !N=!NULL) !OR (!A=!NULL !AND !N<>!NULL))) !THEN.
*        A1,A0 missing.
         !LET !ERROR=1.
         !LET !ErrorText='A or N'.
      !IFEND.
   !IFEND.
   !IF (!ERROR=0 !AND (!VAR<>!NULL !AND !VAL<>!NULL)) !THEN.
*     Count the number of elements in VAR, VAL.
      !LET !COUNT = ''.
      !DO !V !IN (!VAR).
         !LET !COUNT=!CONCAT(!COUNT,' ').
      !DOEND.
      !LET !COUNT=!LENGTH(!COUNT).
      !LET !COUNT2= ''.
      !DO !V !IN (!VAL).
         !LET !COUNT2=!CONCAT(!COUNT2,' ').
      !DOEND.
      !LET !COUNT2=!LENGTH(!COUNT2).
      !IF (!COUNT <> !COUNT2) !THEN.
         !LET !ERROR=3.
      !IFEND.
   !IFEND.
   !IF (!ERROR=0 !AND (!A<>!NULL !AND !N<>!NULL)) !THEN.
*     Count the number of elements in A, N.
      !LET !COUNT = ''.
      !DO !I !IN (!A).
         !LET !COUNT=!CONCAT(!COUNT,' ').
      !DOEND.
      !LET !COUNT=!LENGTH(!COUNT).
      !LET !COUNT2= ''.
      !DO !I !IN (!N).
         !LET !COUNT2=!CONCAT(!COUNT2,' ').
      !DOEND.
      !LET !COUNT2=!LENGTH(!COUNT2).
      !IF (!COUNT <> !COUNT2) !THEN.
         !LET !ERROR=5.
      !IFEND.
   !IFEND.
*  Test parameter PrCI.
   !LET !PrCIU=!UPCASE(!PrCI).
   !IF (!ERROR=0 !AND !PrCIU<>'W' !AND !PrCIU<>'E' !AND !PrCIU<>'A' !AND !PrCIU<>'ALL') !THEN.
      !LET !ERROR=4.
   !IFEND.
*  If necessary, print error messages.
   TEMPORARY.
   N 1.
   !IF (!ERROR=1) !THEN.
      PRINT /'ERROR: Parameter(s) ' !QUOTE(!ErrorText) ' missing. See the HELP.'.
   !IFEND.
   !IF (!ERROR=2) !THEN.
      PRINT /'ERROR: Too much parameters. Individual Data parameters are incompatible with'.
      PRINT /'       Aggregated Data parameters. See the HELP.'.
   !IFEND.
   !IF (!ERROR=3) !THEN.
      PRINT /'ERROR: Parameters VAR and VAL must have the same number of elements. See the HELP.'.
   !IFEND.
   !IF (!ERROR=4) !THEN.
      PRINT /'ERROR: Parameter PrCI with wrong value. See the HELP.'.
   !IFEND.
   !IF (!ERROR=5) !THEN.
      PRINT /'ERROR: Parameters A and N must have the same number of elements. See the HELP.'.
   !IFEND.
   EXECUTE.

   !IF (!ERROR=0) !THEN.
******Name the original dataset.
      OMS /SELECT ALL /IF COMMANDS = ["Dataset Copy" "Dataset Name"] /DESTINATION   VIEWER = NO.
      DATASET NAME @original.
      OMSEND.

      !IF (!VAR<>!NULL) !THEN.
*********INDIVIDUAL DATA: get the frequency and n with FIN,NU AGGREGATE functions.
*        Default values for parameter VAL.
         !LET !Values = ''.
         !IF (!VAL=!NULL) !THEN.
            !DO !V !IN (!VAR).
               !LET !Values=!CONCAT(!Values,'1 ').
            !DOEND.
         !ELSE.
            !LET !Values = !VAL.
         !IFEND.
         !LET !VPRINT= !Values.

*        Build the AGGREGATE call.
         !LET !cond = ''.
         !LET !names = ''.
         !LET !COUNT = ' '.
         !DO !V !IN (!VAR).
            !LET !Value = !HEAD(!Values).
            !LET !NUM = !LENGTH(!COUNT).
            !LET !cond = !CONCAT(!cond,' /@f',!num,' = FIN(',!V,',',!Value,',',!Value,')  /@n',!num,' = NU(',!V,')').
            
            !LET !Values = !TAIL(!Values).
            !LET !COUNT = !CONCAT(!COUNT,' ').
            !LET !NAMES=!CONCAT(!NAMES,!QUOTE(!V)," ").
         !DOEND.
         
*        AGGREGATE, with @U temporary variable: store results on a new @temp dataset.
         TEMPORARY.
         COMPUTE @U = 1.
         DATASET DECLARE @9567temp WINDOW=!WINDOW.
         AGGREGATE OUTFILE = '@9567temp' /BREAK=@U
         !cond.

*        Compute a from the frequency and n.
         DATASET ACTIVATE @9567temp WINDOW=ASIS.
         !LET !COUNT = ' '.
         !DO !V !IN (!VAR).
            !LET !NUM = !LENGTH(!COUNT).
            COMPUTE !CONCAT('@a',!num) = !CONCAT('@f',!num) * !CONCAT('@n',!num).
            !LET !COUNT = !CONCAT(!COUNT,' ').
         !DOEND.
         !LET !COUNT = !NUM.

*        Charge the data in temporary # variables.
         !LET !An = !CONCAT(#A,!COUNT).
         !LET !Nn = !CONCAT(#N,!COUNT).
         NUMERIC #A1 to !An #N1 to !Nn.
         !DO !I = 1 !TO !COUNT !BY 1.
            COMPUTE !CONCAT('#A',!I) = !CONCAT('@a',!I).
            COMPUTE !CONCAT('#N',!I) = !CONCAT('@n',!I).
         !DOEND.
      !ELSE.
*********AGGREGATED DATA.
         TEMPORARY.
         N 1.

*        Count the number of elements.
         !LET !COUNT = ''.
         !DO !I !IN (!A).
            !LET !COUNT = !CONCAT(!COUNT,' ').
         !DOEND.
         !LET !COUNT = !LENGTH(!COUNT).

*        Charge the data in temporary # variables.
         !LET !An = !CONCAT(#A,!COUNT).
         !LET !Nn = !CONCAT(#N,!COUNT).
         NUMERIC #A1 to !An #N1 to !Nn.

         DO REPEAT Ao=!A /No=!N /A=#A1 to !An /N=#N1 to !Nn.
            COMPUTE A = Ao.
            COMPUTE N = No.
         END REPEAT.
      !IFEND.

******TEST NUMERIC PARAMETERS: A N CL [PN].
      COMPUTE #ERROR=0.
      COMPUTE #Dec = 0.
*     Test A, N.
      DO REPEAT A=#A1 to !An /N=#N1 to !Nn. 
         DO IF (SYSMIS(A) OR SYSMIS(N)).
            COMPUTE #ERROR = 1.
         ELSE.
            IF ((A<0) OR (N<A)) #ERROR=1.
            IF (MOD(A,1)<>0 OR MOD(N,1)<>0) #Dec = 1.
         END IF.
      END REPEAT.
*     Test CL.
      COMPUTE #SE=0.
      !IF (!UPCASE(!CL)='SE') !THEN.
         COMPUTE #SE = 1.
         !LET !TITLE = "Asymptotic Standard Error".
         COMPUTE CL = 95.
      !ELSE.
         COMPUTE #CL = !CL.
         !LET !TITLE = !CONCAT(!CL,'% Confidence Interval ').
         DO IF (SYSMIS(#CL)).
            COMPUTE #ERROR=2.
         ELSE.
            IF (#CL<50 OR #CL>=100) #ERROR=2.
         END IF.
      !IFEND.
*     Test PN.
      !IF (!PN<>!NULL) !THEN.
         COMPUTE #PN = !PN.
         DO IF (SYSMIS(#PN)).
            COMPUTE #ERROR=3.
         ELSE.
            IF (MOD(#PN,1)<>0) #ERROR=3.
            DO REPEAT N=#N1 to !Nn. 
               IF (#PN<=N) #ERROR=3.
            END REPEAT.
         END IF.
      !IFEND.
      IF (#Dec = 1 AND !QUOTE(!PrCIU) = 'E') #ERROR = 4.

      DO IF (#ERROR=1).
         PRINT /'ERROR: Parameter A or N with wrong values. See the HELP.'.
      ELSE IF (#ERROR=2).
         PRINT /'ERROR: Parameter CL with wrong values. See the HELP.'.
      ELSE IF (#ERROR=3).
         PRINT /'ERROR: Parameter PN with wrong values. See the HELP.'.
      ELSE IF (#ERROR=4).
         PRINT /'ERROR: Parameters A or N have decimal values.'
               /'       It is not possible to compute the Exact Confidence Interval. See the HELP.'.
      ELSE.
*        Print header.
         PRINT /'CONFIDENCE INTERVALS FOR PROPORTIONS'.
*        Print NST if available.
         !IF (!NST !NE !NULL) !THEN .
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.
         !IF (!PN=!NULL) !THEN .
            PRINT  /'Population size: INFINITE'.
         !ELSE.
            PRINT  /'Population size: ' !QUOTE(!PN) ' subjects'.
         !IFEND.

*       Correct parameters: compute of variables and print.
        COMPUTE #Warning = 0.
        COMPUTE #P = (#CL+100)/200.
        COMPUTE #Z = IDF.NORMAL(#P,0,1).

*       Compute CI.
        IF (!QUOTE(!PrCIU)='W') #PrCI=1.       /*Method for compute the CI of proportions: W (Wilson) = 1-default; E (Exact) = 2; A (Asymptotic) = 3; All = 4.
        IF (!QUOTE(!PrCIU)='E') #PrCI=2.
        IF (!QUOTE(!PrCIU)='A') #PrCI=3.
        IF (!QUOTE(!PrCIU)='ALL') #PrCI=4.

        !LET !Pnn = !CONCAT('#P',!COUNT).        /*Enessims parameters.
        !LET !lbWn = !CONCAT('#lbW',!COUNT).
        !LET !ubWn = !CONCAT('#ubW',!COUNT).
        !LET !lbEn = !CONCAT('#lbE',!COUNT).
        !LET !ubEn = !CONCAT('#ubE',!COUNT).
        !LET !lbAn = !CONCAT('#lbA',!COUNT).
        !LET !ubAn = !CONCAT('#ubA',!COUNT).
        !LET !SEn = !CONCAT('#SE',!COUNT).
        NUMERIC #P1 TO !Pnn #lbW1 TO !lbWn #ubW1 TO !ubWn #lbE1 TO !lbEn #ubE1 TO !ubEn #lbA1 TO !lbAn #ubA1 TO !ubAn #SE1 TO !SEn.
        DO REPEAT A=#A1 to !An /N=#N1 to !Nn /Prop=#P1 to !Pnn
               /lbW=#lbW1 to !lbWn /lbE=#lbE1 to !lbEn /lbA=#lbA1 to !lbAn 
               /ubW=#ubW1 to !ubWn /ubE=#ubE1 to !ubEn /ubA=#ubA1 to !ubAn
               /SE=#SE1 to !SEn.
           COMPUTE Prop = A/N.

           COMPUTE #FE=1.
           !IF (!PN<>!NULL) !THEN .
              COMPUTE #FE=(#PN - N)/(#PN - 1).
              COMPUTE #PrCI=3.      /*With parameter PN<>NULL, only show the asymptotic CI.
           !IFEND.

           COMPUTE #WA = 2*A + #Z**2.           /*Wilson bounds.
           COMPUTE #WB = #Z * SQRT(#Z**2 + 4*A*(N-A)/N).
           COMPUTE #WC = 2*(N + #Z**2).
           COMPUTE lbW= (#WA-#WB)/#WC.
           COMPUTE ubW= (#WA+#WB)/#WC.

           COMPUTE lbE= 0.                      /*Exact bounds.
           COMPUTE ubE= 1.
           IF (A > 0) lbE= A /(A + (N-A+1)*IDF.F(#P,2*(N-A+1),2*A)).
           IF (A < N) ubE=(A+1)/(A+1 +(N-A)/IDF.F(#P,2*(A+1),2*(N-A))).

           COMPUTE SE= SQR((Prop*(1-Prop)/N)*#FE). /*Asymptotic bounds.
           COMPUTE lbA= Prop - SE*#Z.
           COMPUTE ubA= Prop + SE*#Z.
           IF ((ubA>1 OR lbA<0) AND (#PrCI>2)) #warning=1.     /*Warning for off the range asymptotic CI.
        END REPEAT.

*       Print results.
        STRING #cOff #cDecA #cDecN (A1).
        COMPUTE #Count = 1.
        !IF (!VAR<>!NULL) !THEN .
*           Print results for INDIVIDUAL data.
            !LET !VLn = !CONCAT('#VL',!COUNT).
            DO REPEAT VL=#VL1 to !VLn /Vprint = !VPRINT.
               COMPUTE VL = Vprint.
            END REPEAT.

            PRINT //'Variable Value Events Subjects | Estimate | '!QUOTE(!TITLE).
            PRINT  /'-------------------------------+----------+--------------------------------'.
            DO REPEAT Na=!Names /Vl=#VL1 TO !VLn /A=#A1 to !An /N=#N1 to !Nn /P=#P1 to !Pnn
                     /lbW=#lbW1 to !lbWn /lbE=#lbE1 to !lbEn /lbA=#lbA1 to !lbAn 
                     /ubW=#ubW1 to !ubWn /ubE=#ubE1 to !ubEn /ubA=#ubA1 to !ubAn
                     /SE=#SE1 to !SEn.

               COMPUTE #cOff = ' '.
               IF ((ubA>1 OR lbA<0) AND (#PrCI>2)) #cOff='*'.     /*Warning for off the range asymptotic CI.
               DO IF (#SE=0).
                  DO IF (#PrCI=1).
                     PRINT /Na Vl(T11,F3) A(F8) N(T23,F8) '|'32 P(T33,F8.6) '|'43 lbW(F8.6) ' to ' ubW(F8.6) '  Wilson'.
                  ELSE IF (#PrCI=2).
                     PRINT /Na Vl(T11,F3) A(F8) N(T23,F8) '|'32 P(T33,F8.6) '|'43 lbE(F8.6) ' to ' ubE(F8.6) '  Exact'.
                  ELSE IF (#PrCI=3).
                     DO IF (A>0 AND A<>N).
                        PRINT /Na Vl(T11,F3) A(F8) N(T23,F8) '|'32 P(T33,F8.6) '|'43 lbA(F8.6) ' to ' ubA(F8.6) #cOff(A1) ' Asymptotic'.
                     ELSE.
                        PRINT /Na Vl(T11,F3) A(F8) N(T23,F8) '|'32 P(T33,F8.6) '| Asymptotic CI not computable'43.
                     END IF.
                  ELSE IF (#PrCI=4).
                     PRINT /Na Vl(T11,F3) A(F8) N(T23,F8) '|'32 P(T33,F8.6) '|'43 lbE(F8.6) ' to ' ubE(F8.6) '  Exact'.
                     PRINT /                              '|'32             '|'43 lbW(F8.6) ' to ' ubW(F8.6) '  Wilson'.
                     DO IF (A>0 AND A<>N).
                        PRINT /                           '|'32             '|'43 lbA(F8.6) ' to ' ubA(F8.6) #cOff(A1) ' Asymptotic'.
                     END IF.
                  END IF.
               ELSE.
                  PRINT /Na Vl(T11,F3) A(F8) N(T23,F8) '|'32 P(T33,F8.6) '|'43 SE(F10.8).
               END IF.
               DO IF (#Count<>!COUNT).
                  PRINT /'|'32 '|'43.
               END IF.
               COMPUTE #Count = #Count + 1.
            END REPEAT.
            PRINT /'-------------------------------+----------+--------------------------------'.
        !ELSE.
            PRINT //'  Events Subjects | Estimate | '!QUOTE(!TITLE).
            PRINT  /'------------------+----------+--------------------------------'.
            DO REPEAT A=#A1 to !An /N=#N1 to !Nn /P=#P1 to !Pnn
                     /lbW=#lbW1 to !lbWn /lbE=#lbE1 to !lbEn /lbA=#lbA1 to !lbAn 
                     /ubW=#ubW1 to !ubWn /ubE=#ubE1 to !ubEn /ubA=#ubA1 to !ubAn
                     /SE=#SE1 to !SEn.

               COMPUTE #cOff = ' '.
               IF ((ubA>1 OR lbA<0) AND (#PrCI>2)) #cOff='*'.     /*Warning for off the range asymptotic CI.
               COMPUTE #cDecA = ' '.
               COMPUTE #cDecN = ' '.
               IF (MOD(A,1)<>0) #cDecA='.'.         /*Warning for decimal values.
               IF (MOD(N,1)<>0) #cDecN='.'.         /*Warning for decimal values.

               DO IF (#SE=0).
                  DO IF (#PrCI=1).
                     PRINT /A(F8) #cDecA(A1) N(T10,F8) #cDecN(A1) '|'19 P(T21,F8.6) '|'30 lbW(F8.6) ' to ' ubW(F8.6) '  Wilson'.
                  ELSE IF (#PrCI=2).
                     PRINT /A(F8) #cDecA(A1) N(T10,F8) #cDecN(A1) '|'19 P(T21,F8.6) '|'30 lbE(F8.6) ' to ' ubE(F8.6) '  Exact'.
                  ELSE IF (#PrCI=3).
                     DO IF (A>0 AND A<>N).
                        PRINT /A(F8) #cDecA(A1) N(T10,F8) #cDecN(A1) '|'19 P(T21,F8.6) '|'30 lbA(F8.6) ' to ' ubA(F8.6) #cOff(A1) ' Asymptotic'.
                     ELSE.
                        PRINT /A(F8) #cDecA(A1) N(T10,F8) #cDecN(A1) '|'19 P(T21,F8.6) '| Asymptotic CI not computable'30.
                     END IF.
                  ELSE IF (#PrCI=4).
                     DO IF (MOD(A,1)=0).
                        PRINT /A(F8) #cDecA(A1) N(T10,F8) #cDecN(A1) '|'19 P(T21,F8.6) '|'30 lbE(F8.6) ' to ' ubE(F8.6) '  Exact'.
                        PRINT /                          '|'19             '|'30 lbW(F8.6) ' to ' ubW(F8.6) '  Wilson'.
                     ELSE.
*                       Decimal parameters make Exact CI impossible to compute.
                        PRINT /A(F8) #cDecA(A1) N(T10,F8) #cDecN(A1) '|'19 P(T21,F8.6) '|'30 lbW(F8.6) ' to ' ubW(F8.6) '  Wilson'.
                     END IF.
                     DO IF (A>0 AND A<>N).
                        PRINT /                       '|'19             '|'30 lbA(F8.6) ' to ' ubA(F8.6) #cOff(A1) ' Asymptotic'.
                     END IF.
                  END IF.
               ELSE.
                  PRINT /A(F8) #cDecA(A1) N(T10,F8) #cDecN(A1) '|'19 P(T21,F8.6) '|'30 SE(F10.8).
               END IF.
               DO IF (#Count<>!COUNT).
                  PRINT /'|'19 '|'30.
               END IF.
               COMPUTE #Count = #Count + 1.
            END REPEAT.
            PRINT /'------------------+----------+--------------------------------'.
        !IFEND.
        DO IF (#PrCI=4).
           PRINT /'Recommended CI'.
        END IF.
        DO IF (#Warning=1).
           PRINT /'(*)Out of Range'.
        END IF.
        DO IF (#Dec=1).
           PRINT /'(.)WARNING: Number of cases with decimal values. The values are printed rounded.'.
        END IF.
      END IF.
      !IF (!VAR <> !NULL) !THEN.
*        Restore original dataset and close temporary dataset.
         DATASET ACTIVATE @original.
         DATASET CLOSE @9567temp.
      !IFEND.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
