PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !CIQ V2011.05.11 loaded.'
         /'Execute !CIQ HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !CIQ (Q=!CHAREND('/')
          /VAR=!CHAREND('/')
            /N=!CHAREND('/')
           /CL=!CHAREND('/')!DEFAULT('95')
 	      /NST=!CHAREND('/')
         /HELP=!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132.
!LET !VERSION=!QUOTE('2011.05.11').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
   PRINT //'Macro !CIQ V' !VERSION ' (c) JM.Domenech'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*  Print the help.
   DO IF ($casenum=1).
      PRINT /'********************************************************************************'
            /'* CONFIDENCE INTERVALS FOR QUANTILES                                           *'
            /'* Created 2010.11.22 Last revised ' !VERSION                                  '*'80
            /'* (c) JM.Domenech                                                              *'
            /'* Programmer: R.Sesma                                                          *'
            /'*                                                                              *'
            /'* Vancouver reference:                                                         *'
            /'* Domenech JM. SPSS Macro !CIQ for SPSS Statistics.                            *'
            /'*    Confidence Intervals for Quantiles [computer program]. V' !VERSION       '*'80
            /'*    Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '. Available from:' '*'80
            /'*    http://www.metodo.uab.cat/macros.htm.                                     *'
            /'*                                                                              *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                                *'
            /'* Parameter for PRINTING MACRO DOCUMENTATION ----------------------------------*'
            /'*  !CIQ HELP.                                                                  *'
            /'* Parameters for INDIVIDUAL DATA ----------------------------------------------*'
            /'*  !CIQ VAR = Variable name                                                    *'
            /'* Parameters for AGGREGATED DATA ----------------------------------------------*'
            /'*  !CIQ   N = Sample size                               (N: integer > 1)       *'
            /'* Parameters for BOTH TYPES OF DATA -------------------------------------------*'
            /'*        /Q = Order of quantile                         (0 < Q < 100)          *'
            /'*      [/CL]= Confidence level(%); by default: 95       (50 <= CL < 100)       *'
            /'*     [/NST]= Name of the study (Label)                                        *'
            /'*                                                                              *'
            /'*  Note: Parameters enclosed in square brackets [ ] are optional               *'
            /'*                                                                              *'
            /'* Samples of calls:                                                            *'
            /'*  !CIQ HELP.                                                                  *'
            /'*  !CIQ N=12 /Q=75 /CL=95.                                                     *'
            /'*  !CIQ N=132 /Q=20 /CL=95 /NST="Trial E67A".                                  *'
            /'*                                                                              *'
            /'* DATA LIST FREE/TR.                                                           *'
            /'* BEGIN DATA.                                                                  *'
            /'* 0 2 0 53 0 3 6 16 5 30 4 7                                                   *'
            /'* END DATA.                                                                    *'
            /'*  !CIQ VAR=TR /Q=75.                                                          *'
            /'********************************************************************************'.
   END IF.
   EXECUTE.
!ELSE. 
   !IF (!Q=!NULL !or (!N=!NULL !and !VAR=!NULL)) !THEN .
      PRINT /'ERROR: Missing parameter'.           /*Error: missing parameter.
   !ELSE.
*     Make a copy of the working dataset.
      DATASET NAME @96732original.

      !IF (!VAR <> !NULL) !THEN.
*********INDIVIDUAL DATA.
*        Copy the original table and keep the interesting variable (VAR).
         DATASET COPY @96732temp.
         DATASET ACTIVATE @96732temp WINDOW=ASIS.
         MATCH FILES FILE=* /RENAME !VAR=VAR /KEEP=VAR.
*        Compute the number of cases with missing values.
         COMPUTE @U=1.
         AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /BREAK=@U /@Ntot =N.
*        Select only the cases with non sysmis values.
         SELECT IF (NOT MISSING(VAR)).
         EXECUTE.
*        Sort cases: use RANK to order.
         COMPUTE @VAR= VAR + RV.UNIFORM(0, 0.0001).       /*Add a small random number to sort. 
         RANK @VAR /RANK INTO @Sort /PRINT=NO.
         SORT CASES BY @Sort.
         COMPUTE @K= $CASENUM.            /*Sequence order.
         COMPUTE N=2.
         EXECUTE.
      !ELSE.
         COMPUTE #N = !N.
         DO IF (SYSMIS(#N)).
            COMPUTE #ERROR=1.
         END IF.
         DO IF (#ERROR=1).
            PRINT /'ERROR: Parameter(s) with wrong value(s).'.
         END IF.

*        Create a temporary table with the K sequence.
         INPUT PROGRAM.
         LOOP #K=1 to !N BY 1.
            COMPUTE @K= #K.
            END CASE.
         END LOOP.
         END FILE.
         END INPUT PROGRAM.
         EXECUTE.
         DATASET NAME @96732temp.
         DATASET ACTIVATE @96732temp WINDOW=ASIS.
         COMPUTE N=!N.
         COMPUTE VAR = 1.
         COMPUTE @U = 1.
         COMPUTE @Ntot = 0.
      !IFEND.
*     Compute the sample size of the table: AGGREGATE.
      AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /BREAK=@U /@N =N.

*     Test parameters.
      COMPUTE @ERROR=0.
      COMPUTE Q=!Q.
      COMPUTE CL= !CL.
      DO IF (SYSMIS(Q) OR SYSMIS(CL) OR SYSMIS(N)).
         COMPUTE @ERROR=1.
      ELSE.
         IF (Q <= 0 OR Q >= 100) @ERROR = 1.
         IF (CL < 50 OR CL >= 100) @ERROR = 1.
         IF (MOD(N,1)<>0 OR N<=1) @ERROR =1.
      END IF.
      TEMPORARY.
      N 1.
      DO IF (@ERROR=1 AND NOT SYSMIS(N)).
         PRINT /'ERROR: Parameter(s) with wrong value(s).'.
      END IF.
      EXECUTE.
      COMPUTE @Q=Q/100.
      COMPUTE @Z = IDF.NORMAL((CL+100)/200,0,1).
      EXECUTE.

*     Altman, Machin, Bryant, Gardner, 2000, p38.
      COMPUTE @rlow_alt = RND(@N*@Q - @Z*SQRT(@N*@Q*(1-@Q))).
      COMPUTE @rup_alt = RND(1 + @N*@Q + @Z*SQRT(@N*@Q*(1-@Q))).
*     Connover, 1999, p144.
      COMPUTE @rlow_con = TRUNC(@N*@Q - @Z*SQRT(@N*@Q*(1-@Q))) + 1.
      COMPUTE @rup_con = TRUNC(@N*@Q + @Z*SQRT(@N*@Q*(1-@Q))) + 1.

*     Add the K=0 row.
      DATASET COPY @967320.
      DATASET ACTIVATE @967320 WINDOW=ASIS.
      N 1.
      COMPUTE @K=0.
      DATASET ACTIVATE @96732temp WINDOW=ASIS.
      ADD FILES FILE=* /FILE='@967320'.
      EXECUTE.
      DATASET CLOSE @967320.

*     Exact: binomial distribution.
      SORT CASES BY @K(A).
      COMPUTE @BINOM =CDF.BINOM(@K,@N,@Q).       /*Cumulative probability.
      COMPUTE @low= @BINOM < (0 + (100-CL)/200).
      COMPUTE @up= @BINOM > (1 - (100-CL)/200).
      SORT CASES BY @K(D).
      COMPUTE low = @low <> LAG(@low).
      SORT CASES BY @K(A).
      COMPUTE up = @up <> LAG(@up).
      IF (low = 1) @Kl = @K+1.
      IF (up = 1) @Ku = @K+1.
      IF (low = 1) @BINOMl = @BINOM.
      IF (up = 1) @BINOMu = @BINOM.
      AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /BREAK=@U 
        /@rlow_exact =MAX(@Kl) /@rup_exact =MAX(@Ku) /BINOMl =MAX(@BINOMl) /BINOMu =MAX(@BINOMu).

      COMPUTE Cover=(BINOMu - BINOMl)*100.      /*Coverage.

*     Warning notes.
      NUMERIC @wlow_alt @wlow_con @wlow_exact @wup_alt @wup_con @wup_exact.
      DO REPEAT rlow = @rlow_alt @rlow_con @rlow_exact /wlow = @wlow_alt @wlow_con @wlow_exact
               /rup = @rup_alt @rup_con @rup_exact /wup = @wup_alt @wup_con @wup_exact.
         COMPUTE wlow = rlow < 1.
         COMPUTE wup = rup > @N.
      END REPEAT.
      AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /BREAK=@U 
        /wlow_alt =MAX(@wlow_alt) /wlow_con =MAX(@wlow_con) /wlow_exact =MAX(@wlow_exact)
        /wup_alt =MAX(@wup_alt) /wup_con =MAX(@wup_con) /wup_exact =MAX(@wup_exact).

      !IF (!VAR <> !NULL) !THEN.
*        Correct out of range values and read the values from the variable.
         DO REPEAT rlow = @rlow_alt @rlow_con @rlow_exact /rup = @rup_alt @rup_con @rup_exact
                  /low = @low_alt @low_con @low_exact /up = @up_alt @up_con @up_exact.
            COMPUTE rlow = MAX(rlow,1).
            COMPUTE rup = MIN(rup,@N).
            IF (@K=rlow) low = VAR.
            IF (@K=rup) up = VAR.
         END REPEAT.

         AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /BREAK=@U 
           /low_alt =MAX(@low_alt) /up_alt =MAX(@up_alt)
           /low_con =MAX(@low_con) /up_con =MAX(@up_con)
           /low_exact =MAX(@low_exact) /up_exact =MAX(@up_exact).
      !IFEND.

      N 1.
      EXECUTE.

*     Compute warning notes.
      !IF (!VAR <> !NULL) !THEN.
         !LET !C = '+'.
      !ELSE.
         !LET !C = '*'.
      !IFEND.
      STRING low_a low_c low_e up_a up_c up_e (A1).
      DO REPEAT wlow = wlow_alt wlow_con wlow_exact /wup = wup_alt wup_con wup_exact
               /low = low_a low_c low_e /up = up_a up_c up_e.
            COMPUTE low = ' '.
            COMPUTE up = ' '.
            IF (wlow = 1) low = !QUOTE(!C).
            IF (wup = 1) up = !QUOTE(!C).
      END REPEAT.
      
      DO IF (@ERROR=0).
         PRINT /'CONFIDENCE INTERVALS FOR QUANTILES'.
*        Print NST if available.
         !IF (!NST !NE !NULL) !THEN .
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.
         PRINT /'Population size: INFINITE'.
         PRINT /''.
         
         !IF (!VAR <> !NULL) !THEN.
            COMPUTE @Excluded = @Ntot - @N.
            PRINT /'Sample Size  Excluded | Quantil | ' !QUOTE(!CL) '% Confidence Interval | Coverage'.
            PRINT /'----------------------+---------+-------------------------+-------------------------'.
            PRINT /@N(F8) @Excluded(T11,F8) '|'23 !QUOTE(!Q)29 '|'33 low_alt(T34,F9.3) low_a(A1) ' to' up_alt(T48,F9.3) up_a(A1) '|'59 'Asympt. Altman'69 .
            PRINT /                         '|'23              '|'33 low_con(T34,F9.3) low_c(A1) ' to' up_con(T48,F9.3) up_c(A1) '|'59 'Asympt. Connover'69 .
            PRINT /                         '|'23              '|'33 low_exact(T34,F9.3) low_e(A1) ' to' up_exact(T48,F9.3) up_e(A1) '|'59 Cover(T62,F4.1) '%  EXACT' .
            PRINT /'----------------------+---------+-------------------------+-------------------------'.
         !ELSE.
            PRINT /'                      | ' !QUOTE(!CL) '% Confidence Interval |'.
            PRINT /'Sample Size | Quantil | Lower rank   Upper rank | Coverage'.
            PRINT /'------------+---------+-------------------------+-------------------------'.
            PRINT /@N(F8) '|'13 !QUOTE(!Q)19 '|'23 @rlow_alt(T24,F8) low_a(A1)  @rup_alt(T37,F8) up_a(A1) '|'49 'Asympt. Altman'59 .
            PRINT /       '|'13              '|'23 @rlow_con(T24,F8) low_c(A1)  @rup_con(T37,F8) up_c(A1) '|'49 'Asympt. Connover'59 .
            PRINT /       '|'13              '|'23 @rlow_exact(T24,F8) low_e(A1) @rup_exact(T37,F8) up_e(A1) '|'49 Cover(T52,F4.1) '%  EXACT' .
            PRINT /'------------+---------+-------------------------+-------------------------'.
         !IFEND.
*        Print warning note.
         DO IF (wlow_alt OR wlow_con OR wlow_exact OR wup_alt OR wup_con OR wup_exact).
            !IF (!VAR<>!NULL) !THEN.
               PRINT /'(+) Censored value'.
            !ELSE.
               PRINT /'(*) WARNING: Small Sample'.
            !IFEND.
         END IF.
      END IF.

      DATASET ACTIVATE @96732original WINDOW=ASIS.
      DATASET CLOSE @96732temp.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
