PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
  PRINT /'Macro !CIR V2009.04.27 loaded.'
        /'Execute !CIR HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !CIR ( R= !CHAREND('/')
             /N= !CHAREND('/')
            /CL= !CHAREND('/') !DEFAULT('95') 
           /NST= !CHAREND('/')
          /HELP= !CHAREND('/') !DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2009.04.27').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
   PRINT //'Macro !CIR V' !VERSION ' (c)JM.Domenech & R.Granero'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*  Print HELP.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* CONFIDENCE INTERVAL FOR PEARSON CORRELATION                                *'
            /'* Created 1998.05.02 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech & R.Granero                                                *'
            /'* Programmers: A.Bonillo & R.Sesma                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM, Granero R. Macro !CIR for SPSS Statistics.                    *'
            /'*    Confidence Interval for Pearson Correlation [computer program].         *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* !CIR R = Pearson correlation                 (-1 <= R <= 1)                *'
            /'*     /N = Sample size                         (Integer > 3 )                *'
            /'*   [/CL]= Confidence level(%); by default: 95 (50 <= CL < 100)              *'
            /'*  [/NST]= Name of the study (Label)                                         *'
            /'*  [/HELP] Print Macro call arguments and Samples of calls                   *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in square brackets [ ] are optional              *'
            /'*                                                                            *'
            /'* Samples of calls:                                                          *'
            /'*  !CIR HELP.                                                                *'
            /'*  !CIR R=0.9414 /N=10.                                                      *'
            /'*  !CIR R=0.9414 /N=10 /CL=95 /NST="Name of the Study".                      *'
            /'******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Test parameters.
   !IF (!R=!NULL !OR !N=!NULL) !THEN.
      PRINT /'ERROR: Missing parameter'.
   !ELSE.
      COMPUTE #ERROR=0.
      
*     Test parameters R,N,CL.
      COMPUTE #R=$SYSMIS.
      COMPUTE #N=$SYSMIS.
      COMPUTE #CL=$SYSMIS.
      COMPUTE #R=!R.
      COMPUTE #N=!N.
      COMPUTE #CL=!CL.
      DO IF (SYSMIS(#R) OR SYSMIS(#N) OR SYSMIS(#CL)).
         COMPUTE #ERROR=1.
      ELSE.
         IF (#R<-1 OR #R>1 OR #N<=3 OR #CL<50 OR #CL>=100) #ERROR=1.
         IF (MOD(#N,1)<>0) #ERROR=2.
      END IF. 

      DO IF (#ERROR=1).
         PRINT /'ERROR: Parameter(s) with wrong values'.
      ELSE IF (#ERROR=2).
         PRINT /'ERROR: Parameter(s) with decimal values'.
      ELSE.
*        Compute and print of the bounds of CI.
         COMPUTE #S = 2*(1-CDF.NORMAL(ABS(LN(SQRT((1+#R)/(1-#R)))*SQRT(#N-3)),0,1)).
         COMPUTE #W = LN(SQRT((1+#R)/(1-#R))) .
         COMPUTE #P = (#CL+100)/200.
         COMPUTE #ZI= #W-IDF.NORMAL(#P,0,1) * 1/(SQRT(#N-3)).
         COMPUTE #ZS= #W+IDF.NORMAL(#P,0,1) * 1/(SQRT(#N-3)).
         COMPUTE #Z = #W/(1/(SQRT(#N-3))).
         COMPUTE #LI= (EXP(2*#ZI)-1) / (EXP(2*#ZI)+1).
         COMPUTE #LS= (EXP(2*#ZS)-1) / (EXP(2*#ZS)+1).

         PRINT /'CONFIDENCE INTERVAL FOR PEARSON CORRELATION'.
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.
                  
         PRINT//'Pearson Correlation: R = '!QUOTE(!R).
         PRINT /'Sample size :        N = '!QUOTE(!N).

         PRINT//'Significance: z = '#Z (F4.2)  '   P= '#S (F9.8).
         PRINT /!QUOTE(!CL)'% CI of R :' #LI (F9.5) '  to' #LS (F9.5) .
      END IF.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
