PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !CC V2010.04.19 loaded.'
         /'Execute !CC HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !CC ( VarExp = !CHAREND('/') /VarRes = !CHAREND('/') 
                /A1 = !CHAREND('/') /A0 = !CHAREND('/') /M1 = !CHAREND('/')
                /B1 = !CHAREND('/') /B0 = !CHAREND('/') /M0 = !CHAREND('/')
                 /R = !CHAREND('/')
                /PE = !CHAREND('/')
                /CL = !CHAREND('/')!DEFAULT('95')
              /Zero = !CHAREND('/')!DEFAULT('N')
              /PrCI = !CHAREND('/')!DEFAULT('W') 
               /NST = !CHAREND('/')
              /HELP = !CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2010.04.19').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
!LET !WINDOW='HIDDEN'.
DO IF ($casenum=1).
   PRINT //'Macro !CC V' !VERSION ' (c)JM.Domenech'.
END IF.
!IF (!HELP<>1) !THEN.
*  Print the help.
   DO IF ($casenum=1).
      PRINT /'********************************************************************************'
            /'* CASE-CONTROL STUDY: ASSOCIATION MEASURES                                     *'
            /'* Created 2000.05.01 Last revised ' !VERSION                                  '*'80
            /'* (c) JM.Domenech                                                              *'
            /'* Programmers: R.Sesma & A.Bonillo                                             *'
            /'*                                                                              *'
            /'* Vancouver reference:                                                         *'
            /'* Domenech JM. Macro !CC for SPSS Statistics.                                  *'
            /'*    Case-Control Study: Association Measures [computer program].              *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'80
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                     *'
            /'*                                                                              *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                                *'
            /'* Parameter for PRINTING MACRO DOCUMENTATION ----------------------------------*'
            /'*  !CC HELP.                                                                   *'
            /'*                                                                              *'
            /'* Parameters for INDIVIDUAL DATA ----------------------------------------------*'
            /'*  !CC VarExp[(ValUnexp ValExp)]= Exposure variable and values for             *'
            /'*                                 Unexposed, Exposed. By default: ValUnexp= 0  *'
            /'*                                                                 ValExp= 1    *'
            /'*     /VarRes[(ValCtr ValCase)]= Response variable and values for              *'
            /'*                                Control, Case.       By default: ValCtr= 0    *'
            /'*                                                                 ValCase= 1   *'
            /'*                                                                              *'
            /'* Parameters for AGGREGATED DATA ----------------------------------------------*'
            /'* !CC   A1 = Exposed in Cases                         (A1 >= 0)                *'
            /'*     {/A0 = UnExposed in Cases                       (A0 >= 0)                *'
            /'*   or /M1}= Total Cases                              (M1 >= A1)               *'
            /'*      /B1 = Exposed in Controls                      (B1 >= 0)                *'
            /'*     {/B0 = UnExposed in Controls                    (B0 >= 0)                *'
            /'*   or /M0}= Total Controls                           (M0 >= B1)               *'
            /'*                                                                              *'
            /'* Parameters for BOTH TYPES OF DATA -------------------------------------------*'
            /'*      {/R = Proportion of cases in the population    (0 < R  < 1)             *'
            /'*   or /PE}= Proportion of exposed in the population  (0 < PE < 1)             *'
            /'*     [/CL]= Confidence level(%); by default: 95      (50 <= CL < 100)         *'
            /'*          = SE  for printing Standard Error instead of Confidence Interval    *'
            /'*   [/Zero]= Continuity correction for cells with zero events:                 *'
            /'*            N (None)                            by default: N                 *'
            /'*            C (Constant & add k=0.5 to each cell)                             *'
            /'*            P (Proportional, add k1=M1/N and k0=M0/N)                         *'
            /'*            R (Reciprocal, add k1=1/M0 and k0=1/M1), recommended correction   *'
            /'*   [/PrCI]= Method for compute CI of proportions:                             *'
            /'*            W  Wilson                           by default: W                 *'
            /'*            E  Exact (Clopper-Pearson)                                        *'
            /'*            A  Asymptotic                                                     *'
            /'*    [/NST]= Name of the study (Label)                                         *'
            /'*    [/HELP] Print Macro call arguments and Samples of calls                   *'
            /'*                                                                              *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements   *'
            /'*                                                                              *'
            /'* Samples of calls:                       +--------+---------+---------+-----+ *'
            /'* !CC HELP.                               |        |UnExposed| Exposed |TOTAL| *'
            /'* !CC VarExp=Raza(0 1) /VarRes=Muerte.    +--------+---------+---------+-----+ *'
            /'* !CC A1=3 /B1=12 /A0=3 /B0=16 /R=.001.   |   Cases|    A0   |    A1   |  M1 | *'
            /'* !CC A1=3 /M1=6 /B1=12 /M0=28 /PE=.48.   |NonCases|    B0   |    B1   |  M0 | *'
            /'* !CC A1=3.6 /B1=12 /A0=0 /B0=16          +--------+---------+---------+-----+ *'
            /'*    /PE=.48 /Zero=P /CL=97.5             |   TOTAL|    N0   |    N1   |  N  | *'
            /'*    /NST="Name of the Study".            +--------+---------+---------+-----+ *'
            /'********************************************************************************'.
   END IF.
   EXECUTE.
!ELSE. 
*  Test coherent parameters.
   !LET !ERROR=0.
   !IF (!VarExp=!NULL !AND !VarRes=!NULL !AND !A1=!NULL !AND !B1=!NULL) !THEN.
*     VarExp,VarResp,A1,B1 missing.
      !LET !ERROR=1.
      !LET !ErrorText='VarExp,VarRes or A1,B1'.
   !IFEND.
   !IF (!ERROR=0 !AND ((!VarExp<>!NULL !OR !VarRes<>!NULL) !AND (!A1<>!NULL !OR !A0<>!NULL !OR !B1<>!NULL !OR !B0<>!NULL !OR !M1<>!NULL !OR !M0<>!NULL))) !THEN.
*     Error: too much parameters.
      !LET !ERROR=2.
   !IFEND.
   !IF (!VarExp<>!NULL !OR !VarRes<>!NULL) !THEN.
      !IF (!ERROR=0 !AND ((!VarExp<>!NULL !AND !VarRes=!NULL) !OR (!VarExp=!NULL !AND !VarRes<>!NULL))) !THEN.
*        VarExp or VarResp missing.
         !LET !ERROR=1.
         !LET !ErrorText='VarExp or VarRes'.
      !IFEND.
   !ELSE.
      !IF (!ERROR=0 !AND ((!A1<>!NULL !AND !B1=!NULL) !OR (!A1=!NULL !AND !B1<>!NULL))) !THEN.
*        A1,B1 missing.
         !LET !ERROR=1.
         !LET !ErrorText='A1 or B1'.
      !IFEND.
      !IF (!ERROR=0 !AND ((!A0=!NULL !AND !M1=!NULL) !OR (!B0=!NULL !AND !M0=!NULL))) !THEN.
*        A0,M1 or B0,M0 mising.
         !LET !ERROR=1.
         !LET !ErrorText='A0,M1 or B0,M0'.
      !IFEND.
      !IF (!ERROR=0 !AND ((!A0<>!NULL !AND !B0=!NULL) !OR (!A0=!NULL !AND !B0<>!NULL))) !THEN.
*        A0 or B0 mising.
         !LET !ERROR=1.
         !LET !ErrorText='A0 or B0'.
      !IFEND.
      !IF (!ERROR=0 !AND ((!M1<>!NULL !AND !M0=!NULL) !OR (!M1=!NULL !AND !M0<>!NULL))) !THEN.
*        M1 or M0 mising.
         !LET !ERROR=1.
         !LET !ErrorText='M1 or M0'.
      !IFEND.
   !IFEND.
*  Test parameter Zero.
   !LET !ZeroU=!UPCASE(!Zero).
   !IF (!ERROR=0 !AND !ZeroU<>'N' !AND !ZeroU<>'C' !AND !ZeroU<>'P' !AND !ZeroU<>'R') !THEN.
      !LET !ERROR=3.
      !LET !ErrorText='Zero'.
   !IFEND.
*  Test parameter PrCI.
   !LET !PrCIU=!UPCASE(!PrCI).
   !IF (!ERROR=0 !AND !PrCIU<>'W' !AND !PrCIU<>'E' !AND !PrCIU<>'A') !THEN.
      !LET !ERROR=3.
      !LET !ErrorText='PrCI'.
   !IFEND.
*  Test parameters R,Pe coherents.
   !IF (!ERROR=0 !AND !R<>!NULL !AND !PE<>!NULL) !THEN.
      !LET !ERROR=4.
   !IFEND.
*  If necessary, print error messages.
   TEMPORARY.
   N 1.
   !IF (!ERROR=1) !THEN.
      PRINT /'ERROR: Parameter(s) ' !QUOTE(!ErrorText) ' missing. See the HELP.'.
   !IFEND.
   !IF (!ERROR=2) !THEN.
      PRINT /'ERROR: Too much parameters. Individual Data parameters are incompatible with'.
      PRINT /'       Aggregated Data parameters. See the HELP.'.
   !IFEND.
   !IF (!ERROR=3) !THEN.
      PRINT /'ERROR: Parameter(s) ' !QUOTE(!ErrorText) ' with wrong values. See the HELP.'.
   !IFEND.
   !IF (!ERROR=4) !THEN.
      PRINT /'ERROR: Too much parameters. R and Pe parameters are incompatible. See the HELP.'.
   !IFEND.
   EXECUTE.

   !IF (!ERROR=0) !THEN.
******GENERATE @DATA: dataset to work with.
      OMS /SELECT ALL /IF COMMANDS = ["Dataset Copy" "Dataset Name"] /DESTINATION   VIEWER = NO.
      DATASET NAME @original.
      OMSEND.

      !IF (!VarRes<>!NULL !AND !VarExp<>!NULL) !THEN.
*********READ INFO from VarExp, VarRes: variable names and values.
*        VarExp contains the name and the values of the Exposure variable: VExp(ValUnexp ValExp).
         !LET !Pos=!Index(!VarExp,'(').
         !IF (!Pos<>0) !THEN.
*           Get the name of the variable.
            !LET !VExp=!SubStr(!VarExp,1,!Length(!SubStr(!Blanks(!Pos),2))).
*           Read the values.
            !LET !Values=!SubStr(!VarExp,!Length(!Concat(!Blanks(!Pos),' '))).
            !LET !Values=!SubStr(!Values,1,!Length(!SubStr(!Blanks(!Length(!Values)),2))).
            !LET !COUNT=1.
            !DO !Val !IN (!Values).
               !IF (!COUNT=1) !THEN !LET !ValUnexp=!Val !IFEND.
               !IF (!COUNT=2) !THEN !LET !ValExp=!Val !IFEND.
               !LET !COUNT = !Length(!Concat(!Blanks(!COUNT),' ')).
            !DOEND.
         !ELSE.
*           VarExp contains only the name of the Exposure variable; ValUnexp and ValExp by default (0 1).
            !LET !VExp=!VarExp.
            !LET !ValExp=1.
            !LET !ValUnexp=0.
         !IFEND.
         
*        VarRes contains the name and the values of the Response variable: VRes(ValNonCase ValCase).
         !LET !Pos=!Index(!VarRes,'(').
         !IF (!Pos<>0) !THEN.
*           Get the name of the variable.
            !LET !VRes=!SubStr(!VarRes,1,!Length(!SubStr(!Blanks(!Pos),2))).
*           Read the values.
            !LET !Values=!SubStr(!VarRes,!Length(!Concat(!Blanks(!Pos),' '))).
            !LET !Values=!SubStr(!Values,1,!Length(!SubStr(!Blanks(!Length(!Values)),2))).
            !LET !COUNT=1.
            !DO !Val !IN (!Values).
               !IF (!COUNT=1) !THEN !LET !ValNonCase=!Val !IFEND.
               !IF (!COUNT=2) !THEN !LET !ValCase=!Val !IFEND.
               !LET !COUNT = !Length(!Concat(!Blanks(!COUNT),' ')).
            !DOEND.
         !ELSE.
*           VarRes contains only the name of the Response variable; ValNonCase and ValCase by default (0 1).
            !LET !VRes=!VarRes.
            !LET !ValCase=1.
            !LET !ValNonCase=0.
         !IFEND.

*********COPY of the active dataset: @work.
         DATASET COPY @9675work WINDOW=!WINDOW.
         DATASET ACTIVATE @9675work.

*********RECODE of the Exposure, Response variables to @Exp, @Resp variables which are 1,0.
         RECODE !VExp (MISSING=SYSMIS) (!ValExp=1) (!ValUnexp=0) (ELSE=SYSMIS) INTO @9675Exp.
         RECODE !VRes (MISSING=SYSMIS) (!ValCase=1) (!ValNonCase=0) (ELSE=SYSMIS) INTO @9675Resp.
         FORMATS @9675Exp @9675Resp (F8.0).
         EXECUTE.

*********CROSSTABS - Use OMS to redirect output tables to the @DATA, @CASES datasets.
         PRESERVE.
         SET OLANG=ENGLISH TNUMBERS=VALUES.
         DATASET DECLARE @9675DATA WINDOW=!WINDOW.
         OMS /SELECT ALL /IF COMMANDS = ["Crosstabs"] /DESTINATION VIEWER = NO.
         OMS /SELECT TABLES /IF COMMANDS = ["Crosstabs"] SUBTYPES = ["Crosstabulation"]
             /DESTINATION FORMAT = SAV NUMBERED = Num OUTFILE = @9675DATA .
         DATASET DECLARE @9675CASES WINDOW=!WINDOW.
         OMS /SELECT TABLES /IF COMMANDS = ["Crosstabs"]  SUBTYPES = ["Case Processing Summary"]
             /DESTINATION FORMAT = SAV NUMBERED = Num OUTFILE = @9675CASES.
         OMS /SELECT ALL /IF COMMANDS = ["Crosstabs"] /DESTINATION VIEWER = NO.
         CROSSTABS VARIABLES=@9675Resp @9675Exp (0,1) /TABLES=@9675Resp BY @9675Exp /FORMAT DVALUE /COUNT=ASIS.
         OMSEND.
         RESTORE.

*********GET VALUE LABELS.
*        Get variable descriptions on a @Descrip dataset using FREQUENCIES + OMS.
         PRESERVE.
         SET TNUMBERS=BOTH OLANG=ENGLISH.
         DATASET DECLARE @9675Descrip WINDOW=!WINDOW.
         OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION   VIEWER = NO.
         OMS /SELECT TABLES /IF COMMANDS = ["Frequencies"]  SUBTYPES = ["Frequencies"]
          /DESTINATION FORMAT = SAV NUMBERED = @Var  OUTFILE = @9675Descrip.
         OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION   VIEWER = NO.
         FREQUENCIES  VARIABLES=!VExp !VRes /ORDER=  ANALYSIS .
         OMSEND.
         RESTORE.

*        Prepare @DATA to compute results: rename vars and keep interesting info.
         DATASET ACTIVATE @9675DATA.
         DATASET CLOSE @9675work.
         MATCH FILES FILE=* /RENAME=(@0 @1 Total = A0 A1 M1) /KEEP=A0 A1 M1.
*        Compute A1, A0, N1, N0, M1, M0, N vars and keep only the first row.
         PRESERVE.
         SET RESULTS=OFF ERRORS=OFF PRINTBACK=OFF.
         CREATE /B1=LEAD(A1 1) /N1=LEAD(A1 2) /B0=LEAD(A0 1) /N0=LEAD(A0 2) /M0=LEAD(M1 1) /N=LEAD(M1 2).
         RESTORE.
         N 1.
         EXECUTE.
         
*        Prepare @Descrip: erase the Total row and compute the Val, Descrip variables.
         DATASET ACTIVATE @9675Descrip.
         SELECT IF (NOT SYSMIS(CumulativePercent)).
         MATCH FILES FILE=*/RENAME=(Var2=@Descrip) /KEEP=@Var @Descrip.
         STRING Descrip (A50).
         COMPUTE Val = NUMBER(SUBSTR(@Descrip,1,INDEX(@Descrip,' ')-1),F8).
         COMPUTE Descrip = SUBSTR(@Descrip,INDEX(@Descrip,' ')+1).
         IF (LENGTH(LTRIM(Descrip))=0) Descrip = LTRIM(STRING(Val,F8)).
         EXECUTE.
         
         DATASET ACTIVATE @9675DATA.
      !ELSE.
*********AGGREGATED DATA: Create the @DATA dataset from the A1,A0,N1,N0,B1,B0 parameters.
*        Create @DATA: copy the active dataset, and keep only the first row.
         DATASET COPY @9675DATA WINDOW=!WINDOW.
         DATASET ACTIVATE @9675DATA.
         SPLIT FILE OFF.
         WEIGHT OFF.
         N 1.
         COMPUTE @U=1.
         MATCH FILES FILE=* /KEEP=@U.
*        Compute A1, A0, N1, N0, M1, M0, N vars and keep only the interesting vars.
         NUMERIC A1 A0 B1 B0 N1 N0 M1 M0 N.
         COMPUTE A1=!A1.
         COMPUTE B1=!B1.
         !IF (!M1<>!NULL !AND !M0<>!NULL) !THEN.
            COMPUTE M1=!M1.
            COMPUTE M0=!M0.
            COMPUTE A0=M1-A1.
            COMPUTE B0=M0-B1.
         !ELSE.
            COMPUTE A0=!A0.
            COMPUTE B0=!B0.
            COMPUTE M1=A1+A0.
            COMPUTE M0=B1+B0.
         !IFEND.
         COMPUTE N1=A1+B1.
         COMPUTE N0=A0+B0.
         COMPUTE N=N1+N0.
      !IFEND.
      
*     Proportion of exposed/cases on the population.
      COMPUTE Pe=0.
      COMPUTE R =0.
      COMPUTE @Pop=0.
      COMPUTE @Pe=0.
      !IF (!R<>!NULL) !THEN.
         COMPUTE R=!R.
         COMPUTE Pe=(A1/M1)*R + (B1/M0)*(1-R).
         COMPUTE @Pop=1.
      !IFEND.
      !IF (!Pe<>!NULL) !THEN.
         COMPUTE Pe=!Pe.
         COMPUTE R=(Pe-(B1/M0))/((A1/M1)-(B1/M0)).
         COMPUTE @Pop=2.
      !IFEND.

*     Confidence level.
      COMPUTE @CL=$SYSMIS.
      !IF (!UPCASE(!CL)='SE') !THEN.
         COMPUTE @CL = 95.
      !ELSE.
         COMPUTE @CL = !CL.
      !IFEND.

******TEST NUMERIC PARAMETERS: A1 A0 B1 B0 N1 N0 M1 M0 N R Pe CL.
      STRING ErrorVar(A2).
      COMPUTE @ERROR=0.
      COMPUTE @U=1.
      COMPUTE ErrorVar=' '.
      DO REPEAT Var=A1 A0 B1 B0 N1 N0 M1 M0 N R Pe @CL /Val=1 TO 12.
         DO IF (@ERROR=0).
            DO IF (SYSMIS(Var)).
               COMPUTE @ERROR=1.
            ELSE.
               IF ((RANGE(Val,1,4) AND Var<0) OR (RANGE(Val,5,9) AND Var<=0) OR 
                   (RANGE(Val,10,11) AND @Pop>0 AND (Var<=0 OR Var>=1)) OR 
                   (Val=12 AND (Var<50 OR Var>=100))) @ERROR=1.
            END IF.
            DO IF (@ERROR=1).
               IF (Val=1) ErrorVar='A1'.
               IF (Val=2) ErrorVar='A0'.
               IF (Val=3) ErrorVar='B1'.
               IF (Val=4) ErrorVar='B0'.
               IF (Val=5) ErrorVar='N1'.
               IF (Val=6) ErrorVar='N0'.
               IF (Val=7) ErrorVar='M1'.
               IF (Val=8) ErrorVar='M0'.
               IF (Val=9) ErrorVar='N'.
               IF (Val=12) ErrorVar='CL'.
               DO IF (RANGE(Val,10,11) AND @Pop>0).
                  !IF (!R<>!NULL) !THEN.
                     COMPUTE ErrorVar='R'.
                  !IFEND.
                  !IF (!Pe<>!NULL) !THEN.
                     COMPUTE ErrorVar='Pe'.
                  !IFEND.
               END IF.
            END IF.
         END IF.
      END REPEAT.
      !IF (!R<>!NULL) !THEN.
         IF (R>0 AND R<1 AND (Pe<=0 OR Pe>=1)) @ERROR=2.
      !IFEND.
      !IF (!Pe<>!NULL) !THEN.
         IF (Pe>0 AND Pe<1 AND (R<=0 OR R>=1)) @ERROR=3.
      !IFEND.

      DO IF (@ERROR=1).
         PRINT /'ERROR: Parameter ' ErrorVar(A2) ' with wrong values. See the HELP.'.
      ELSE IF (@ERROR=2).
         PRINT /'ERROR: For R = ' !QUOTE(!R) ' the estimated value of Pe is ' Pe(F8.3) '.'.
         PRINT /'       Parameter Pe must be >0 and <1. See the HELP.'.
      ELSE IF (@ERROR=3).
         PRINT /'ERROR: For Pe = ' !QUOTE(!Pe) ' the estimated value of R is ' R(F8.3) '.'.
         PRINT /'       Parameter R must be >0 and <1. See the HELP.'.
      ELSE.
*        Print header.
         PRINT /'CASE-CONTROL STUDY: ASSOCIATION MEASURES'.
*        Print NST if available.
         !IF (!NST !NE !NULL) !THEN .
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.
      END IF.

*     Print Value Labels and Case Processing Summary (Individual Data).
      !IF (!VarRes<>!NULL !AND !VarExp<>!NULL) !THEN.
         DATASET ACTIVATE @9675Descrip.
         COMPUTE @U=1.
*        Add @ERROR variable with the error information.
         MATCH FILES FILE=* /TABLE='@9675DATA' BY @U /KEEP=@Var @Descrip Val Descrip @ERROR.
*        EXPOSURE variable, Unexposed and Exposed values.
         DO IF ($casenum=1 AND @ERROR=0).
            PRINT //'EXPOSURE variable: ' !QUOTE(!VExp).
         END IF.
         EXECUTE.
         DO IF (@Var=1 AND Val=!ValUnexp AND @ERROR=0).
            PRINT  /'        Unexposed: ' Descrip.
         END IF.
         EXECUTE.
         DO IF (@Var=1 AND Val=!ValExp AND @ERROR=0).
            PRINT  /'          Exposed: ' Descrip.
         END IF.
         EXECUTE.
*        RESPONSE variable, NonCases and Cases values.
         DO IF ($casenum=1 AND @ERROR=0).
            PRINT //'RESPONSE variable: ' !QUOTE(!VRes) .
         END IF.
         EXECUTE.
         DO IF (@Var=2 AND Val=!ValNonCase AND @ERROR=0).
            PRINT  /'         Controls: ' Descrip.
         END IF.
         EXECUTE.
         DO IF (@Var=2 AND Val=!ValCase AND @ERROR=0).
            PRINT  /'            Cases: ' Descrip.
         END IF.
         EXECUTE.

*        Case Processing Summary.
         DATASET ACTIVATE @9675CASES.
         COMPUTE @U=1.
         MATCH FILES FILE=* /TABLE='@9675DATA' BY @U /KEEP=Valid_N Valid_Percent Total_N @ERROR.
         DO IF (@ERROR=0).
            PRINT //'Valid cases=' Valid_N(F6) '(' Valid_Percent(PCT6.1) ')'.
            PRINT  /'Total cases=' Total_N(F6).
         END IF.
         EXECUTE.
   
         DATASET ACTIVATE @9675DATA.
         DATASET CLOSE @9675Descrip.
         DATASET CLOSE @9675CASES.
      !IFEND.

******COMPUTE RESULTS.
      DO IF (@ERROR=0).
*        Save the original parameters for the print.
         COMPUTE A1o=A1.
         COMPUTE A0o=A0.
         COMPUTE B1o=B1.
         COMPUTE B0o=B0.
         COMPUTE N1o=N1.
         COMPUTE N0o=N0.
         COMPUTE M1o=M1.
         COMPUTE M0o=M0.
         COMPUTE No= N.

         COMPUTE @P = (@CL+100)/200.
         COMPUTE @Z=IDF.NORMAL(@P,0,1).
*        CI compute method (PrCI): W (Wilson) = 1 - default; E (Exact) = 2; A (Asymptotic) = 3.
         COMPUTE @PrCI=0.
         IF (!QUOTE(!UPCASE(!PrCI))='W') @PrCI=1.
         IF (!QUOTE(!UPCASE(!PrCI))='E') @PrCI=2.
         IF (!QUOTE(!UPCASE(!PrCI))='A') @PrCI=3.
*        Type of continuity correction: 1 - Constant; 2 - Proportional; 3 - Reciprocal.
         COMPUTE @ZERO=0.
         IF (!QUOTE(!UPCASE(!Zero))='C') @ZERO=1.
         IF (!QUOTE(!UPCASE(!Zero))='P') @ZERO=2.
         IF (!QUOTE(!UPCASE(!Zero))='R') @ZERO=3.

*        Mantel-Haenszel Chi-Square test.
         COMPUTE @WarnCHI=0.
         COMPUTE #T1 = ABS(A1*N-N1*M1).
         COMPUTE Chi2 = (N-1)*(#T1**2)/(M1*M0*N1*N0).
         COMPUTE Chi2C= (N-1)*(#T1-N/2)**2/(M1*M0*N1*N0).
         IF (#T1 < N/2) Chi2C=0.
         COMPUTE p= (1- CDF.CHISQ(ABS(Chi2),1)).
         COMPUTE pC=(1- CDF.CHISQ(ABS(Chi2C),1)).
         IF (M1*N1/N<5 OR M0*N1/N<5 OR M1*N0/N<5 OR M0*N0/N<5) @WarnCHI=1.
         COMPUTE Chi = SQR(Chi2).
         COMPUTE ChiC= SQR(Chi2C).
   
*        Continuity correction.
         COMPUTE @WarnZERO=0.
         IF ((A1=0 OR A0=0 OR B1=0 OR B0=0) AND @Zero>0) @WarnZERO=1.
         COMPUTE @K1=0.
         COMPUTE @K0=0.
         DO IF (@WarnZERO=1).
            IF (@ZERO=1) @K1=0.5.
            IF (@ZERO=1) @K0=0.5.
            IF (@ZERO=2) @K1=M1/N.
            IF (@ZERO=2) @K0=M0/N.
            IF (@ZERO=3) @K1=1/M0.
            IF (@ZERO=3) @K0=1/M1.
         END IF.
         COMPUTE A1=A1+@K1.
         COMPUTE A0=A0+@K1.
         COMPUTE B1=B1+@K0.
         COMPUTE B0=B0+@K0.
         COMPUTE N1=A1+B1.
         COMPUTE N0=A0+B0.
         COMPUTE M1=A1+A0.
         COMPUTE M0=B1+B0.
         COMPUTE N= N1+N0.
*        Compute R/Pe estimated with the Zero correction.
         DO IF (@WarnZERO=1).
            !IF (!R<>!NULL) !THEN.
               COMPUTE Pe=(A1/M1)*R + (B1/M0)*(1-R).
            !IFEND.
            !IF (!Pe<>!NULL) !THEN.
               COMPUTE R=(Pe-(B1/M0))/((A1/M1)-(B1/M0)).
            !IFEND.
         END IF.
         
*        Proportions.
         COMPUTE @WarnCIA=0.
         NUMERIC P1 P0 lbP1 lbP0 ubP1 ubP0 SEP1 SEP0 .
         DO REPEAT P=P1 P0 /A=A1 B1 /N=M1 M0 /ub=ubP1 ubP0 /lb=lbP1 lbP0 /SE=SEP1 SEP0.
            COMPUTE P = A/N.
            COMPUTE SE= SQR(P*(1-P)/N).
            DO IF (@PrCI=1).      /*Wilson bounds.
               COMPUTE #WA = 2*A + @Z**2.
               COMPUTE #WB = @Z * SQRT(@Z**2 + 4*A*(N-A)/N).
               COMPUTE #WC = 2*(N + @Z**2).
               COMPUTE lb= (#WA-#WB)/#WC.
               COMPUTE ub= (#WA+#WB)/#WC.
            ELSE IF (@PrCI=2).    /*Exact bounds.
               COMPUTE lb= 0.
               COMPUTE ub= 1.
               IF (A > 0) lb= A/(A+(N-A+1)*IDF.F(@P,2*(N-A+1),2*A)).
               IF (N > A) ub=(A+1)/((A+1)+((N-A)/IDF.F(@P,2*(A+1),2*(N-A)))).               
            ELSE IF (@PrCI=3).    /*Asymptotic bounds.
               COMPUTE ub = P + @Z*SE.
               COMPUTE lb = P - @Z*SE.
               IF (ub>1 OR lb<0) @WarnCIA=1.
            END IF.
         END REPEAT.

*        Odds Ratio.
         COMPUTE @OR= (A1*B0)/(B1*A0).
         COMPUTE SElnOR = SQR((1/A0)+(1/B0)+(1/A1)+(1/B1)).
         COMPUTE lbOR= @OR*EXP(-@Z*SElnOR).
         COMPUTE UbOR= @OR*EXP(@Z*SElnOR).
*        Reciprocals.
         COMPUTE iOR=  1/@OR.
         COMPUTE ilbOR=1/ubOR.
         COMPUTE iubOR=1/lbOR.

*        If R or PE external, compute RR, RD and RDp.
         DO IF (@Pop>0).
*           Risk Ratio (RR).
            COMPUTE RR= (A1/A0)/(Pe/(1-Pe)).
*           Risk difference (RD).
            COMPUTE RD=R*(RR-1)/(PE*(RR-1)+1).
*           Risk diff in population (RD).
            COMPUTE RDp=Pe*RD.
         END IF.
*        Attributable/Preventable fraction in exposed (AFe/PFe).
         DO IF (R=0).
            COMPUTE AFe=(@OR-1)/@OR.
            COMPUTE PFe=(1-@OR).
         ELSE.
            COMPUTE AFe=(RR-1)/RR.
            COMPUTE PFe=(1-RR).
         END IF.
         COMPUTE lbAFe= (lbOR-1)/lbOR.
         COMPUTE ubAFe= (ubOR-1)/ubOR.
         COMPUTE lbPFe= 1 - ubOR.
         COMPUTE ubPFe= 1 - lbOR.
*        Attributable fraction in population (AFp).
         COMPUTE AFp=(A1/M1)*AFe.
         COMPUTE SEAFp=((1-AFp)**2)*(1-R)*((B0*M1)/(A0*M0))*SQR(A1/(A0*M1)+B1/(B0*M0)).
         COMPUTE lbAFpM= AFp - @Z*SEAFp.
         COMPUTE ubAFpM= AFp + @Z*SEAFp.
         COMPUTE lbAFpL=1/(1+((1-AFp)/AFp)*Exp(+@Z*SEAFp/((1-AFp)*AFp))).
         COMPUTE ubAFpL=1/(1+((1-AFp)/AFp)*Exp(-@Z*SEAFp/((1-AFp)*AFp))).
*        Preventable fraction in population.
         IF (R=0) Pe= B1/M0.
         COMPUTE PFp=Pe*PFe.
         COMPUTE lbPFpL=1-1/(1-ubAFpL).
         COMPUTE ubPFpL=1-1/(1-lbAFpL).
         COMPUTE lbPFpM=1-1/(1-ubAFpM).
         COMPUTE ubPFpM=1-1/(1-lbAFpM).

*********PRINT RESULTS.
*        Determine if CL=SE, and the title of the CI.
         COMPUTE @SE=0.
         !LET !TITLE = !CONCAT(!CL,'% Confidence Interval').
         !IF (!UPCASE(!CL)='SE') !THEN.
            COMPUTE @SE=1.
            !LET !TITLE = 'Standard Error'.
         !IFEND.
*        Determine text for the CI type.
         STRING @CItype (A13).
         IF (!QUOTE(!PrCIU)='W') @CItype = ' (Wilson)'.
         IF (!QUOTE(!PrCIU)='E') @CItype = ' (Exact)'.
         IF (!QUOTE(!PrCIU)='A') @CItype = ' (Asymptotic)'.

*        Detect decimal parameters.
         STRING @Dec(A1).
         COMPUTE @WarnDec=0.
         COMPUTE @Dec=' '.
         IF (MOD(A1o,1)<>0 OR MOD(A0o,1)<>0 OR MOD(B0o,1)<>0 OR MOD(B1o,1)<>0) @WarnDEC=1.
         IF (@WarnDEC=1) @Dec='.'.

*        Zero correction note.
         STRING @TZero(A1).
         COMPUTE @TZero=' '.
         IF (@WarnZERO=1) @TZero='*'.

*        2x2 table and proportions.         
         DO IF (@SE=0).
            PRINT //'                   |      Exposure     |         | Exposed proportion'.
            PRINT  /'                   |Unexposed| Exposed |   TOTAL | ' @CL(T52,F2) '% CI' @CIType(T58,A13).
            PRINT  /'-------------------+---------+---------+---------+---------------------'.
            PRINT  /'             Cases |' A0o(F8) @Dec(A1)'|' A1o(F8) @Dec(A1) '|' M1o(F8) @Dec(A1) '| ' P1(F7.6) @TZero(A1).
            PRINT  /'                   |         |         |         |(' lbP1(F7.6) ' to ' ubP1(F7.6) ')'.
            PRINT  /'          Controls |' B0o(F8) @Dec(A1)'|' B1o(F8) @Dec(A1) '|' M0o(F8) @Dec(A1) '| ' P0(F7.6) @TZero(A1).
            PRINT  /'                   |         |         |         |(' lbP0(F7.6) ' to ' ubP0(F7.6) ')'.
            PRINT  /'-------------------+---------+---------+---------+--------------------'.
            PRINT  /'             TOTAL |' N0o(F8) @Dec(A1)'|' N1o(F8) @Dec(A1) '|' No(F8) @Dec(A1)'|'.
         ELSE IF (@SE=1).
            PRINT //'                   |      Exposure     |         | Exposed proportion'.
            PRINT  /'                   |Unexposed| Exposed |   TOTAL | (Asymptotic SE)'.
            PRINT  /'-------------------+---------+---------+---------+---------------------'.
            PRINT  /'             Cases |' A0o(F8) @Dec(A1)'|' A1o(F8) @Dec(A1) '|' M1o(F8) @Dec(A1) '| ' P1(F7.6) @TZero(A1).
            PRINT  /'                   |         |         |         |(' SEP1(F9.8) ')'.
            PRINT  /'          Controls |' B0o(F8) @Dec(A1)'|' B1o(F8) @Dec(A1) '|' M0o(F8) @Dec(A1) '| ' P0(F7.6) @TZero(A1).
            PRINT  /'                   |         |         |         |(' SEP0(F9.8) ')'.
            PRINT /'-------------------+---------+---------+---------+--------------------'.
            PRINT  /'             TOTAL |' N0o(F8) @Dec(A1)'|' N1o(F8) @Dec(A1) '|' No(F8) @Dec(A1)'|'.   
         END IF.

*        Estimates.
         PRINT //'-------------------+-------------------+---------------------------------'.
         PRINT  /'                   |     Estimate      | '!QUOTE(!TITLE).
         PRINT  /'-------------------+-------------------+---------------------------------'.
*        Print OR.
         DO IF (A0=0 OR B1=0 OR @OR=0).
            PRINT /'   Odds ratio (OR) |' @OR (T23,F11.4) '|'40. 
         ELSE IF (@SE=0 AND @OR>=1000).
            PRINT /'   Odds ratio (OR) |' @OR (T23,F11.1) @TZero(A1) '|'40 lbOR (T41,F12.1) ubOR (T54,F12.1).
         ELSE IF (@SE=0 AND @OR<1000 AND @OR>=1).
            PRINT /'   Odds ratio (OR) |' @OR (T23,F11.4) @TZero(A1) '|'40 lbOR (T41,F12.4) ubOR (T54,F12.4).
         ELSE IF (@SE=0 AND @OR<1 AND iOR>=1000).
            PRINT /'   Odds ratio (OR) |' @OR (T23,F11.4) @TZero(A1) '|'40 lbOR (T41,F12.4) ubOR  (T54,F12.4).
            PRINT /'        reciprocal |' iOR(T23,F11.1) @TZero(A1) '|'40 ilbOR(T41,F12.1) iubOR (T54,F12.1). 
         ELSE IF (@SE=0 AND @OR<1 AND iOR<1000).
            PRINT /'   Odds ratio (OR) |' @OR (T23,F11.4) @TZero(A1) '|'40 lbOR (T41,F12.4) ubOR  (T54,F12.4).
            PRINT /'        reciprocal |' iOR(T23,F11.4) @TZero(A1) '|'40 ilbOR(T41,F12.4) iubOR (T54,F12.4).    
         ELSE IF (@SE=1 AND @OR>=1000).
            PRINT /'   Odds ratio (OR) |' @OR (T23,F11.1) @TZero(A1) '|'40 SElnOR (T42,F10.8) '***'.
         ELSE IF (@SE=1 AND @OR<1000 AND @OR>=1).
            PRINT /'   Odds ratio (OR) |' @OR (T23,F11.4) @TZero(A1) '|'40 SElnOR (T42,F10.8) '***'.
         ELSE IF (@SE=1 AND @OR<1 AND iOR>=1000).
            PRINT /'   Odds ratio (OR) |' @OR (T23,F11.4) @TZero(A1) '|'40 SElnOR (T42,F10.8) '***'.
            PRINT /'        reciprocal |' iOR(T23,F11.1) @TZero(A1) '|'40. 
         ELSE IF (@SE=1 AND @OR<1 AND iOR<1000).
            PRINT /'   Odds ratio (OR) |' @OR (T23,F11.4) @TZero(A1) '|'40 SElnOR (T42,F10.8) '***'.
            PRINT /'        reciprocal |' iOR(T23,F11.4) @TZero(A1) '|'40.
         END IF.
         PRINT  /'-------------------+-------------------+---------------------------------'.

*        If R or PE external, print RR, RD and RDp.
         DO IF (@Pop=1).
            PRINT  /'   Population Risk | ' R (F7.6) '(EXTERNAL) |'. 
            PRINT  /'Population Exposed | ' Pe(F7.6) '(estimated)|'. 
         ELSE IF (@Pop=2).
            PRINT  /'Population Exposed | ' Pe(F7.6) '(EXTERNAL) |'. 
            PRINT  /'   Population Risk | ' R (F7.6) '(estimated)|'. 
         END IF.
         DO IF (@Pop>0).
            PRINT  /'       RR estimate |  'RR (F11.4) @TZero(A1) '     |'. 
            DO IF (RR<1).
               COMPUTE iRR=1/RR.
               PRINT /'        reciprocal |  ' iRR(F11.4) @TZero(A1) '     |'. 
            END IF.
            PRINT  /'   Risk difference |  ' RD(F11.6)  @TZero(A1) '     |'. 
            PRINT  /'   Risk diff. pop. |  ' RDp(F11.6) @TZero(A1) '     |'.
            PRINT  /'-------------------+-------------------+-------------------------------'.
         END IF.
         
*        Print Attributable/Preventable fraction in exposed/population.
         STRING #ML #LOGIT (A1).
         COMPUTE #ML=''.
         COMPUTE #LOGIT=' '.
         DO IF ((A0=0 OR B1=0) AND @Zero=0).
            COMPUTE AFe=1.
            COMPUTE AFp=A1o/M1o.
            PRINT /' Attr. fract. exp. |' AFe(T23,F11.6) '|'40.
            PRINT /' Attr. fract. pop. |' AFp(T23,F11.6) '|'40.
         ELSE IF ((A1=0 OR B0=0) AND @Zero=0).
            COMPUTE PFe=1.
            COMPUTE PFp=Pe.
            PRINT /' Prev. fract. exp. |' PFe(T23,F11.6) '|'40.
            PRINT /' Prev. fract. pop. |' PFp(T23,F11.6) '|'40.
         ELSE.
            DO IF (@OR>1 AND (@SE=1 OR ((A1=0 OR A0=0 OR B1=0 OR B0=0) AND @Zero=0))).
               PRINT /' Attr. fract. exp. |' AFe(T23,F11.6) @TZero(A1) '|'40.
               PRINT /' Attr. fract. pop. |' AFp(T23,F11.6) @TZero(A1) '|'40.
            ELSE IF (@OR<=1 AND (@SE=1 OR ((A1=0 OR A0=0 OR B1=0 OR B0=0) AND @Zero=0))).
               PRINT /' Prev. fract. exp. |' PFe(T23,F11.6) @TZero(A1) '|'40.
               PRINT /' Prev. fract. pop. |' PFp(T23,F11.6) @TZero(A1) '|'40.
            ELSE IF (@SE=0 AND @OR>1).
               IF (AFp<0.21 OR AFp>0.79) #LOGIT=''.
               IF (AFp<0.21 OR AFp>0.79) #ML=' '.
               PRINT /' Attr. fract. exp. |' AFe(T23,F11.6) @TZero(A1) '|'40 lbAFe(T42,F11.6) ubAFe(T54,F11.6).
               PRINT /' Attr. fract. pop. |' AFp(T23,F11.6) @TZero(A1) '|'40 lbAFpM(T42,F11.6) ubAFpM(T54,F11.6)' (M-L)' #ML(A1). 
               PRINT /'                   |'                           '|'40 lbAFpL(T42,F11.6) ubAFpL(T54,F11.6)' (Logit)' #LOGIT(A1).
            ELSE IF (@SE=0 AND @OR<=1).
               IF (PFp<0.21 OR PFp>0.79) #LOGIT=''.
               IF (PFp<0.21 OR PFp>0.79) #ML=' '.
               PRINT /' Prev. fract. exp. |' PFe(T23,F11.6) @TZero(A1) '|'40 lbPFe(T42,F11.6) ubPFe(T54,F11.6).
               PRINT /' Prev. fract. pop. |' PFp(T23,F11.6) @TZero(A1) '|'40 lbPFpM(T42,F11.6) ubPFpM(T54,F11.6)' (M-L)' #ML(A1). 
               PRINT /'                   |'                           '|'40 lbPFpL(T42,F11.6) ubPFpL(T54,F11.6)' (Logit)' #LOGIT(A1).
            END IF.
         END IF.
         PRINT  /'-------------------+-------------------+-------------------------------'.

*        Mantel-Haenszel Chi test.
         STRING @Chi(A2).
         COMPUTE @Chi='  '.
         IF (@WarnCHI=1) @Chi='**'.
         PRINT /'Mantel-Haenszel Chi|' Chi (T23,F11.4) @Chi (A2) '|'40 'P = '44 p(F6.5) ' (Association)'.
         PRINT /'          Corrected|' ChiC(T23,F11.4) '|'40 'P = '44 pC(F6.5).
         PRINT /'-------------------+-------------------+---------------------------------'.

*        Print notes and warnings.
         DO IF (@SE=0 AND NOT((A1=0 OR A0=0 OR B1=0 OR B0=0) AND @Zero=0)).
            PRINT /'Recommended CI'.
         END IF.
         DO IF (@WARNDEC=1).
            PRINT /'(.)WARNING: Number of cases with decimal values'.
            PRINT /'            The values are printed rounded.'.
         END IF.
         DO IF (@WARNZERO=1).
            DO IF (@ZERO=1).
               PRINT /'(*)Computed with a constant continuity correction (k=0.5)'.
            ELSE IF (@ZERO=2).
               PRINT /'(*)Computed with a proportional continuity correction'.
            ELSE IF (@ZERO=3).
               PRINT /'(*)Computed with a reciprocal continuity correction'.
            END IF.
            PRINT /'   Exact inference is recommended'.
         END IF.
         DO IF (@WARNCHI=1).
            PRINT /'(**)WARNING: Small samples for Association Chi-Square'.
         END IF.
         DO IF (@SE=1).
            PRINT/'(***)SE of natural logarithm of ratio statistic'.
         END IF.
         DO IF (@WarnCIA=1 AND @SE=0).
            PRINT /'WARNING: Asymptotic CI of Risk is out of range'.
         END IF.
      END IF.

*     Restore original dataset and close temporary dataset @DATA.
      DATASET ACTIVATE @original.
      DATASET CLOSE @9675DATA.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
