PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
  PRINT /'Macro !MCC V2008.05.16 loaded.'
        /'Execute !MCC HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !MCC ( PP=!CHAREND('/') 
             /AA=!CHAREND('/')  
             /PA=!CHAREND('/')
             /AP=!CHAREND('/')
             /CL=!CHAREND('/')!DEFAULT('95') 
            /NST=!CHAREND('/')
           /HELP=!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2008.05.16').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
   PRINT //'Macro !MCC V' !VERSION ' (c)JM.Domenech'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*  Impresin de la documentacin.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* MATCHED CASE-CONTROL STUDY: ASSOCIATION MEASURES                           *'
            /'* Created 2000.04.08 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech                                                            *'
            /'* Programmers: A.Bonillo & R.Sesma                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM. Macro !MCC for SPSS Statistics.                               *'
            /'*    Matched Case-Control Study: Association Measures [computer program].    *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* !MCC PP = Number of Cases and Controls both Exposed      (PP integer >= 0) *'
            /'*     /AA = Number of Cases and Controls both UnExposed    (AA integer >= 0) *'
            /'*     /AP = Number of Cases Exposed and Controls UnExposed (AP integer >= 0) *'
            /'*     /PA = Number of Controls Exposed and Cases UnExposed (PA integer >= 0) *'
            /'*    [/CL]= Confidence level(%); by default: 95            (50 <= CL < 100)  *'
            /'*   [/NST]= Name of the study (Label)                                        *'
            /'*   [/HELP] Print Macro call arguments and Samples of calls                  *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
            /'*                                             +---------+------------------+ *'
            /'*                                             |         |     Controls     | *'
            /'*                                             |Cases    |Unexposed|Exposed | *'
            /'*                                             +---------+---------+--------+ *'
            /'* Samples of calls:                           |  Exposed|    AP   |   PP   | *'
            /'* !MCC HELP.                                  +---------+---------+--------+ *'
            /'* !MCC PP=85 /PA=25 /AP=40 /AA=100            |Unexposed|    AA   |   PA   | *'
            /'*     /CL=95 /NST="Name of the Study".        +---------+---------+--------+ *'
            /'******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Testing the parameters.
   !IF (!PP=!NULL !or !AA=!NULL !or !PA=!NULL !or !AP=!NULL) !THEN
      PRINT /'ERROR: Missing parameter'.
   !ELSE.
      COMPUTE #ERROR=0.
      COMPUTE #PP=$SYSMIS.
      COMPUTE #AP=$SYSMIS.
      COMPUTE #PA=$SYSMIS.
      COMPUTE #AA=$SYSMIS.
      COMPUTE #CL=$SYSMIS.
      COMPUTE #PP=!PP.
      COMPUTE #AP=!AP.
      COMPUTE #PA=!PA.
      COMPUTE #AA=!AA.
      COMPUTE #CL=!CL.
      
*     Test parameters PP,AP,PA,AA,CL.
      DO IF (SYSMIS(#PP) OR SYSMIS(#AP) OR SYSMIS(#PA) OR SYSMIS(#AA) OR SYSMIS(#CL)).
         COMPUTE #ERROR=1.
      ELSE.
         IF (#PP<0 OR #AP<0 OR #PA<0 OR #AA<0 OR #CL<=50 OR #CL>=100) #ERROR=1.
      END IF.

      DO IF (#ERROR=1).
         PRINT /'ERROR: Parameter(s) with wrong values'.
      ELSE.
*        Correct parameters.

*        Decimal parameters.
         COMPUTE #WARNDEC=0.
         IF (MOD(#PP,1)<>0 OR MOD(#AA,1)<>0 OR MOD(#AP,1)<>0 OR MOD(#PA,1)<>0) #WARNDEC=1.
         STRING #TDec(A1).
         COMPUTE #TDec=' '.
         IF (#WARNDEC=1) #TDec='.'.

*        Sum of rows & columns, Z.
         COMPUTE #NCnE=#AA+#AP.
         COMPUTE #CnE=#PP+#PA.
         COMPUTE #CE =#PP+#AP.
         COMPUTE #NCE=#PA+#AA.
         COMPUTE #N=#PP+#AP+#AA+#PA.
         COMPUTE #P=(#CL+100)/200.
         COMPUTE #Z=IDF.NORMAL(#P,0,1).

*        Wilson p bounds.
         COMPUTE #WA = 2*#AP + #Z**2.
         COMPUTE #WB = #z * SQRT(#Z**2 + 4*#AP*#PA/(#AP+#PA)).
         COMPUTE #WC = 2*(#AP+#PA + #Z**2).
         COMPUTE #LBpW= (#WA-#WB)/#WC.
         COMPUTE #UBpW= (#WA+#WB)/#WC.

*        Exact p bounds.
         COMPUTE #LBpE=(#AP)/(#AP+(#PA+1)*IDF.F(#P,2*(#PA+1),2*#AP) ).
         COMPUTE #UBpE=(#AP+1)/((#AP+1)+#PA/IDF.F(#P,2*(#AP+1),2*#PA) ).

*********Risk difference.
         COMPUTE #RD=(#AP-#PA)/#N.
*        Exact bounds.
         COMPUTE #lbRd=(2*#LBpE-1)*(#AP+#PA)/#N.
         COMPUTE #ubRd=(2*#UBpE-1)*(#AP+#PA)/#N.
*        Asymptotic bounds.
         COMPUTE #SERD = SQRT(#AP+#PA-(#AP-#PA)**2/#N)/#N.
         COMPUTE #LbRdA= #RD - #Z*#SERD.
         COMPUTE #UbRdA= #RD + #Z*#SERD.
*        Newcombe method 10 bounds - 'Statistics with confidence', pg.52.
*        #Pe bounds.
         COMPUTE #Pe= #CE/#N.
         COMPUTE #WA1 = 2*#CE + #Z**2.
         COMPUTE #WB1 = #Z * SQRT(#Z**2 + 4*#CE*(#N-#CE)/#N).
         COMPUTE #WC1 = 2*(#N + #Z**2).
         COMPUTE #lbW1= (#WA1-#WB1)/#WC1.
         COMPUTE #ubW1= (#WA1+#WB1)/#WC1.
*        #Pu bounds.
         COMPUTE #Pu= #CnE/#N.
         COMPUTE #WA2 = 2*#CnE + #Z**2.
         COMPUTE #WB2 = #z * SQRT(#Z**2 + 4*#CnE*(#N-#CnE)/#N).
         COMPUTE #WC2 = 2*(#N + #Z**2).
         COMPUTE #lbW2= (#WA2-#WB2)/#WC2.
         COMPUTE #ubW2= (#WA2+#WB2)/#WC2.
*        Coeficient #Fi.
         COMPUTE #WA = #NCnE * #CnE * #CE * #NCE.
         DO IF (#WA = 0).
            COMPUTE #FI = 0.
         ELSE.
            COMPUTE #WB = #PP*#AA - #AP*#PA.
            IF (#WB > #N/2) #WC = #WB - #N/2.
            IF (#WB >= 0 AND #WB <= #N/2) #WC = 0.
            IF (#WB < 0) #WC = #WB.
            COMPUTE #FI = #WC / SQRT(#WA).
         END IF.
*        Bounds.
         COMPUTE #LbRdW= #RD - SQRT((#Pe-#lbW1)**2 - 2*#FI*(#Pe-#lbW1)*(#ubW2-#Pu) + (#ubW2-#Pu)**2 ).
         COMPUTE #UbRdW= #RD + SQRT((#Pu-#lbW2)**2 - 2*#FI*(#Pu-#lbW2)*(#ubW1-#Pe) + (#ubW1-#Pe)**2 ).

*********Odds Ratio.
         COMPUTE #OR=#AP/#PA.
*        Exact bounds.
         COMPUTE #lbOR= #LBpE/(1-#LBpE).
         COMPUTE #UbOR= #UBpE/(1-#UBpE).
*        Asymptotic bounds.
         COMPUTE #SElnOR = SQRT(1/#AP + 1/#PA).
         COMPUTE #LbORA= #OR*EXP((-1)*#Z*#SElnOR).
         COMPUTE #UbORA= #OR*EXP(#Z*#SElnOR).
*        Wilson bounds.
         COMPUTE #LbORW= #LBpW/(1-#LBpW).
         COMPUTE #UbORW= #UBpW/(1-#UBpW).

*********McNemar test.  
         COMPUTE #Chi= ABS((#AP-#PA)/SQRT(#AP+#PA)).
         COMPUTE #sp= 2*(1-CDFNORM(#Chi)).
         COMPUTE #ChiC=ABS((ABS(#AP-#PA)-1)/SQRT(#AP+#PA)).
         IF (ABS(#AP-#PA)<0.5) #ChiC=0.
         COMPUTE #spC= 2*(1-CDFNORM(#ChiC)).
*        McNemar (exact) Test.
         DO IF (MOD(#AP,1)=0 AND MOD(#PA,1)=0).
            COMPUTE #APA=MIN(#AP,#PA).
            COMPUTE #s2=2*CDF.BINOM(#APA,#PA+#AP,0.5).
         ELSE.
*           Decimal parameters: P value computed by linear interpolation.
            DO IF (#AP < #PA).
               COMPUTE #AP1= TRUNC(#AP).
               COMPUTE #PA1= TRUNC(#PA) + (MOD(#PA,1)<>0).
               COMPUTE #AP0= TRUNC(#AP) + (MOD(#AP,1)<>0).
               COMPUTE #PA0= TRUNC(#PA).
            ELSE IF (#AP > #PA).
               COMPUTE #AP1= TRUNC(#AP) + (MOD(#AP,1)<>0).
               COMPUTE #PA1= TRUNC(#PA).
               COMPUTE #AP0= TRUNC(#AP).
               COMPUTE #PA0= TRUNC(#PA) + (MOD(#PA,1)<>0).
               COMPUTE #s21=2*CDF.BINOM(#PA1,#PA1+#AP1,0.5).
            END IF.
            COMPUTE #APA1=MIN(#AP1,#PA1).
            COMPUTE #APA0=MIN(#AP0,#PA0).
            COMPUTE #s21=2*CDF.BINOM(#APA1,#PA1+#AP1,0.5).
            COMPUTE #s20=2*CDF.BINOM(#APA0,#PA0+#AP0,0.5).
            IF(#PA1 EQ #AP1) #s21=1.
            IF(#PA0 EQ #AP0) #s20=1.
            COMPUTE #K12= ABS(#AP1-#AP0) + ABS(#PA1-#PA0).
            COMPUTE #s2= ((#K12-MOD(#AP,1)-MOD(#PA,1))*#s21 + ( MOD(#AP,1)+MOD(#PA,1) )*#s20)/#K12 .
         END IF.
         IF(#PA EQ #AP) #s2=1.

*********Attributable, preventable fraction in exposed.
         COMPUTE #AFe = (#OR-1)/#OR.
         COMPUTE #lbAFe= (#lbOR-1)/#lbOR.    /*Exact bounds.
         COMPUTE #ubAFe= (#ubOR-1)/#ubOR.
         COMPUTE #lbAFeA= (#lbORA-1)/#lbORA. /*Asymptotic bounds (not used).
         COMPUTE #ubAFeA= (#ubORA-1)/#ubORA.

         COMPUTE #PFe=1 - #OR.
         COMPUTE #lbPFe= 1 - #ubOR.          /*Exact bounds.
         COMPUTE #ubPFe= 1 - #lbOR.
         COMPUTE #lbPFeA= 1 - #ubORA.        /*Asymptotic bounds (not used).
         COMPUTE #ubPFeA= 1 - #lbORA.

*********Attributable, preventable fraction in population.
         COMPUTE #AFp=#PE*#AFE.
         COMPUTE #lbAFp=1-(1-#AFP)**(1-#Z/#Chi).
         COMPUTE #UbAFp=1-(1-#AFP)**(1+#Z/#Chi).

         COMPUTE #PFp=(#PE*(1-#OR))/(#PE*(1-#OR)+#OR) .
         COMPUTE #ubPFp=(#PE*(1-#lbOR))/(#PE*(1-#lbOR)+#ubOR).
         COMPUTE #lbPFp=(#PE*(1-#ubOR))/(#PE*(1-#ubOR)+#ubOR).

*        Print results.
         PRINT  /'MATCHED CASE-CONTROL STUDY'.
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.
         
         PRINT //'                  |     CONTROLS      |'.
         PRINT  /'                  |UnExposed| Exposed |   TOTAL  Proportion'.
         PRINT  /'------------------+---------+---------+---------------------'.
         PRINT  /' CASES Exposed    |' #AP(T21,F7) #TDec(A1) '|'29 #PP(T30,F7) #TDec(A1) '|'39 #CE (T40,F8) #TDec(A1) #PE(F12.6).
         PRINT  /'       UnExposed  |' #AA(T21,F7) #TDec(A1) '|'29 #PA(T30,F7) #TDec(A1) '|'39 #NCE(T40,F8) #TDec(A1).
         PRINT  /'------------------+---------+---------+---------------------'.
         PRINT  /'            TOTAL |'#NCnE(T20,F8) #TDec(A1)'|'29 #CnE(T30,F7) #TDec(A1) '|'39 #N(T40,F8) #TDec(A1).
         PRINT  /'       Proportion |'                 '|'29 #Pu(T30,F8.6)'|'39.

         PRINT //'------------------+-------------------+----------------------------------'.
         PRINT  /'                  |      Estimate     | '!QUOTE(!CL)'% Confidence Interval'.
         PRINT  /'------------------+-------------------+----------------------------------'.
*        Print Odds Ratio.
         DO IF (#AP>0 AND #PA>0).
            PRINT  /'  Odds ratio (OR) |' #OR (T23,F11.4) '|'39 #lbOR (T40,F11.4)  #UbOR (T52,F11.4) ' Exact'. 
            PRINT  /                  '|'19               '|'39 #lbORW(T40,F11.4)  #UbORW(T52,F11.4) ' Wilson'. 
            PRINT  /                  '|'19               '|'39 #lbORA(T40,F11.4)  #UbORA(T52,F11.4) ' Asymptotic'. 
            DO IF (#OR<1).
               COMPUTE #IOR=1/#OR.
               COMPUTE #IubOR=1/#lbOR.
               COMPUTE #IlbOR=1/#ubOR.
               COMPUTE #IubORA=1/#lbORA.
               COMPUTE #IlbORA=1/#ubORA.
               COMPUTE #IubORW=1/#lbORW.
               COMPUTE #IlbORW=1/#ubORW.
               PRINT /'       reciprocal |      '#IOR(T23,F11.4)'|'39 #IlbOR (T40,F11.4) #IUbOR (T52,F11.4) ' Exact'.
               PRINT /                  '|'19                   '|'39 #IlbORW(T40,F11.4) #IUbORW(T52,F11.4) ' Wilson'. 
               PRINT /                  '|'19                   '|'39 #IlbORA(T40,F11.4) #IUbORA(T52,F11.4) ' Asymptotic'. 
            END IF.
         ELSE IF (#AP=0).
            PRINT  /'  Odds ratio (OR) |' #OR (T23,F11.4) '|'39 #lbOR (T40,F11.4)  #UbOR (T52,F11.4) ' Exact'. 
            PRINT  /                  '|'19               '|'39 #lbORW(T40,F11.4)  #UbORW(T52,F11.4) ' Wilson'. 
            COMPUTE #IlbOR=1/#ubOR.
            COMPUTE #IlbORW=1/#ubORW.
            PRINT  /'       reciprocal |      infinity'   '|'39 #IlbOR(T40,F11.4) '    infinity Exact'. 
            PRINT  /                  '|'19               '|'39 #IlbORW(T40,F11.4)'    infinity Wilson'. 
         ELSE.
            PRINT  /'  Odds ratio (OR) |      infinity'   '|'39 #lbOR(T40,F11.4)  '    infinity Exact'. 
            PRINT  /                  '|'19               '|'39 #lbORW(T40,F11.4) '    infinity Wilson'. 
         END IF.
*        Print Proportion difference.
         PRINT  /                  '|'19              '|'39 . 
         PRINT  /' Prop. difference |' #RD(T23,F11.6) '|'39 #lbRD(T40,F11.6)   #UbRD(T52,F11.6) ' Exact'. 
         PRINT  /'                  |'                '|'39 #lbRDW(T40,F11.6)  #UbRDW(T52,F11.6)' Newcombe'. 
         PRINT  /                  '|'19              '|'39 #lbRDA(T40,F11.6)  #UbRDA(T52,F11.6)' Asymptotic'. 
*        Print Attributtable,preventable fraction.
         DO IF (#AP>0 AND #PA>0).
            PRINT  /                   '|'19              '|'39 . 
            DO IF (#OR>=1).
               PRINT /' Attr. frac. exp. |' #AFe(T23,F11.6)'|'39 #lbAFe (T40,F11.6) #ubAFe (T52,F11.6) ' Exact'. 
               PRINT /' Attr. frac. pop. |' #AFp(T23,F11.6)'|'39 #lbAFp (T40,F11.6) #ubAFp(T52,F11.6) ' Asymptotic'. 
            ELSE IF (#OR<1).
               PRINT /' Prev. frac. exp. |' #PFe(T23,F11.6)'|'39 #lbPFe (T40,F11.6) #ubPFe (T52,F11.6) ' Exact'. 
               PRINT /' Prev. frac. pop. |' #PFp(T23,F11.6)'|'39 #lbPFp (T40,F11.6) #ubPFp(T52,F11.6) ' Asymptotic'. 
            END IF.
         END IF.
*        Print McNemar test.
         STRING #TChi (A1).
         COMPUTE #TChi=' '.
         IF ((#AP+#PA)<10) #TChi='*'.
         PRINT  /'------------------+-------------------+----------------------------------'.
         PRINT  /' McNemar matched-pair test:'               'P ='48 #s2 (F7.5)'  Exact'. 
         PRINT  /'              Chi |' #Chi (T23,F11.4) #TChi(A1)'|'39 'P ='48 #sp (F7.5). 
         PRINT  /'        Corrected |' #ChiC(T23,F11.4) '|'39 'P ='48 #spC(F7.5). 
         PRINT  /'------------------+-------------------+----------------------------------'.
         DO IF (#WARNDEC=1).
            PRINT / '(.)WARNING: Number of cases with decimal values.'.
            PRINT / '            The values are printed rounded.'.
         END IF.
         PRINT  /'Recommended CI'.
         DO IF ((#AP+#PA)<10).
            PRINT /'(*)WARNING: Small samples for McNemar matched-pair test'.
         END IF.
      END IF.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
