PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
	PRINT /'Macro !MMCC V2010.01.25 loaded.'
			/'Execute !MMCC HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !MMCC ( ECO=!CHAREND('/') 
                /A=!CHAREND('/')
                /B=!CHAREND('/') 
               /CL=!CHAREND('/')!DEFAULT('95')
              /NST=!CHAREND('/')
             /HELP=!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE LENGHT=NONE ERRORS=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2010.01.25').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
	PRINT //'Macro !MMCC V' !VERSION ' (c)JM.Domenech'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*	Print HELP.
	DO IF ($casenum=1).
		PRINT /'******************************************************************************'
      		/'* MULTIPLE MATCHED CASE-CONTROL STUDY: ASSOCIATION MEASURES                  *'
      		/'* Created 2000.04.09 Last revised ' !VERSION                                '*'78
      		/'* (c) JM.Domenech                                                            *'
      		/'* Programmers: A.Bonillo & R.Sesma                                           *'
      		/'*                                                                            *'
      		/'* Vancouver reference:                                                       *'
      		/'* Domenech JM. Macro !MMCC for SPSS Statistics.                              *'
      		/'*    Multiple Matched Case-Control Study: Association Measures               *'
      		/'*    [computer program].                                                     *'
      		/'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
      		/'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
      		/'*                                                                            *'
      		/'* Macro Call (tested for SPSS 15.0 and higher):                              *'
      		/'* !MMCC ECO= List of Controls Exposed               (ECO = 0 1 ... r)        *'
      		/'*      /A  = List of Cases Exposed                  (A >= 0)                 *'
      		/'*      /B  = List of Cases UnExposed                (B >= 0)                 *'
      		/'*    [ /CL]= Confidence level(%); by default: 95    (50 <= CL < 100)         *'
      		/'*    [/NST]= Name of the study (Label)                                       *'
      		/'*    [/HELP] Print Macro call arguments and Samples of calls                 *'
      		/'*                                                                            *'
      		/'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
      		/'*                                +----------------+----------------------+   *'
      		/'* Samples of calls:              |                |  Controls Exposed    |   *'
      		/'* !MMCC HELP.                    |                |  0 |  1 |  ...  |  r |   *'
      		/'* !MMCC ECO=    2   1   0        +----------------+----+----+-------+----+   *'
      		/'*      /A  =    0   7  14        |Cases Exposed   | A0 | A1 |  ...  | Ar |   *'
      		/'*      /B  =    0   1   2        |      UnExposed | B0 | B1 |  ...  | Br |   *'
      		/'*      /NST="Name of the Study". +----------------+----+----+-------+----+   *'
      		/'******************************************************************************'.
		END IF.
!ELSE.
*  Testing the parameters.
   !IF (!ECO=!NULL !or !A=!NULL !or !B=!NULL) !THEN. 
      !IF (!ECO=!NULL) !THEN. 
     	   PRINT /'ERROR: Missing parameter ECO. See the HELP.'.
     	!ELSE.
         !IF (!A=!NULL) !THEN. 
        	   PRINT /'ERROR: Missing parameter A. See the HELP.'.
        	!ELSE.
        	   PRINT /'ERROR: Missing parameter B. See the HELP.'.
        	!IFEND.
     	!IFEND.
   !ELSE.
      COMPUTE #ERROR=0.
      COMPUTE #WARNDEC=0.
      COMPUTE #N=0.
      COMPUTE #j=0.
      COMPUTE #i=0.
      COMPUTE #PREV=0.
   
*     Test parameter ECO.
      DO REPEAT ECO=!ECO.
         DO IF (MOD(ECO,1)<>0).
            COMPUTE #WARNDEC=1.
         ELSE IF (ECO<0).
            COMPUTE #ERROR=1.
         ELSE IF (#N=0).
            DO IF (ECO=0).
               COMPUTE #INVERSE=0.
            ELSE.
               COMPUTE #INVERSE=1.
               COMPUTE #PREV=ECO.
            END IF.
         ELSE.
            DO IF (#INVERSE=1).
               IF ECO<>(#PREV-1) #ERROR=1.
            ELSE.
               IF ECO<>(#PREV+1) #ERROR=1.
            END IF.
            COMPUTE #PREV=ECO.
         END IF.
         COMPUTE #N=#N+1.
      END REPEAT.
   
*     Test parameter A.   
      DO REPEAT A=!A. 
         COMPUTE #i=#i+1.
         COMPUTE #TEMP=$SYSMIS.
         COMPUTE #TEMP=A.
         DO IF (SYSMIS(#TEMP)).
            COMPUTE #ERROR=2.
         ELSE.
            IF (MOD(A,1)<>0) #WARNDEC=1.
            IF (A<0) #ERROR=2.
         END IF.
      END REPEAT.
   
*     Test parameter B.   
      DO REPEAT B=!B. 
         COMPUTE #j=#j+1.
         COMPUTE #TEMP=$SYSMIS.
         COMPUTE #TEMP=B.
         DO IF (SYSMIS(#TEMP)).
            COMPUTE #ERROR=3.
         ELSE.
            IF (MOD(B,1)<>0) #WARNDEC=1.
            IF (B<0) #ERROR=3.
         END IF.
      END REPEAT.
   
*     Test the number of parameters.
      DO IF (#N<>#i or #N<>#j).
         COMPUTE #ERROR=4.
      END IF.
   
*     Test CL.
      COMPUTE #CL=$SYSMIS.
      COMPUTE #CL=!CL.
      DO IF (SYSMIS(#CL)).
         COMPUTE #ERROR=5.
      ELSE.
         IF (#CL<50 or #CL>=100) #ERROR=5.
      END IF.

      DO IF (#ERROR=1).
         PRINT /'ERROR: Parameter ECO with wrong value(s). See the HELP.'.   
      ELSE IF (#ERROR=2).
         PRINT /'ERROR: Parameter A with wrong value(s). See the HELP.'.   
      ELSE IF (#ERROR=3).
         PRINT /'ERROR: Parameter B with wrong value(s). See the HELP.'.   
      ELSE IF (#ERROR=4).
         PRINT /'ERROR: Parameters ECO, A and B must have the same number of elements. See the HELP.'.   
      ELSE IF (#ERROR=5).
         PRINT /'ERROR: Parameter CL with wrong value. See the HELP.'.   
      ELSE.
*        Correct parameters.
*        Count the numbers of elements.
         !LET !COUNT=!NULL.
         !LET !TABLE=!NULL.
         !DO !I !IN (!A).
            !LET !COUNT=!CONCAT(!COUNT,' ').
            !LET !TABLE=!CONCAT(!TABLE,'------').
         !DOEND.
         !LET !M=!LENGTH(!SUBSTR(!COUNT,2)).
         !LET !COUNT=!LENGTH(!COUNT).
         
*        Build the list of parameters A and B for a given order of ECO.         
         !LET !ALIST = !NULL.
         !LET !BLIST = !NULL.
         !LET !ACLIST = !NULL.
         !LET !BCLIST = !NULL.
         !IF (!SUBSTR(!ECO,1,1)='0') !THEN.
            !DO !I = 1 !TO !COUNT.
               !LET !ALIST = !CONCAT(!ALIST,' ','#A',!I).
               !LET !BLIST = !CONCAT(!BLIST,' ','#B',!I).
               !LET !ACLIST = !CONCAT(!ACLIST,' ','#AC',!I).
               !LET !BCLIST = !CONCAT(!BCLIST,' ','#BC',!I).
            !DOEND.
         !ELSE.
            !DO !I = !COUNT !TO 1 !BY -1.
               !LET !ALIST = !CONCAT(!ALIST,' ','#A',!I).
               !LET !BLIST = !CONCAT(!BLIST,' ','#B',!I).
               !LET !ACLIST = !CONCAT(!ACLIST,' ','#AC',!I).
               !LET !BCLIST = !CONCAT(!BCLIST,' ','#BC',!I).
            !DOEND.
         !IFEND.

*        Build parameters A,B,N,ECO.
         !LET !An =!CONCAT('#A',!COUNT).
         !LET !Bn =!CONCAT('#B',!COUNT).
         !LET !Nn =!CONCAT('#N',!COUNT).
         !LET !ACn =!CONCAT('#AC',!COUNT).
         !LET !BCn =!CONCAT('#BC',!COUNT).
         !LET !NCn =!CONCAT('#NC',!COUNT).
         !LET !ECOn=!CONCAT('#ECO' ,!COUNT).         
         NUMERIC #A1 to !An #B1 to !Bn #ECO1 to !ECOn #N1 to !Nn.
         STRING #AC1 to !ACn (A6) #BC1 to !BCn (A6) #NC1 to !NCn (A6) #TDec(A1).
         COMPUTE #TDec=' '.
         IF (#WARNDEC=1) #TDec='.'.
         DO REPEAT A=!A /An=!ALIST /B=!B /Bn=!BLIST /ECO=!ECO /ECOn=#ECO1 to !ECOn /N=#N1 to !Nn
                 /AC=!ACLIST /BC=!BCLIST /NC=#NC1 to !NCn. 
            COMPUTE An=A.
            COMPUTE Bn=B.
            COMPUTE N=A+B.
            COMPUTE ECOn=ECO.

            COMPUTE AC = CONCAT(STRING(An,F5.0),#TDec).
            COMPUTE BC = CONCAT(STRING(Bn,F5.0),#TDec).
            COMPUTE NC = CONCAT(STRING(N & F5.0),#TDec).
         END REPEAT.
         COMPUTE #TOTALA=SUM(#A1 to !An).
         COMPUTE #TOTALB=SUM(#B1 to !Bn).
         COMPUTE #TOTALN=SUM(#N1 to !Nn).

*        Compute OR and build the T parameter.
         COMPUTE #i=1.
         COMPUTE #M=!M.
         COMPUTE #ORn=0.
         COMPUTE #ORd=0.
         !LET !Tm=!CONCAT('#T' ,!M).
         !LET !Im=!CONCAT('#I' ,!M).
         !LET !Am = !CONCAT('#A',!M).
         NUMERIC #T1 to !Tm #I1 to !Im.
         DO REPEAT A=#A1 to !Am /B=#B2 to !Bn /T=#T1 to !Tm /I=#I1 to !Im. 
            COMPUTE #ORn = #ORn + ((#M-#i+1)*A).
            COMPUTE #ORd = #ORd + (#i*B).
            COMPUTE I = #i.
            COMPUTE #i = #i + 1.
            COMPUTE T=A+B.
         END REPEAT.
         COMPUTE #OR = #ORn / #ORd.

*        Compute OR IC.
         COMPUTE #i=1.
         COMPUTE #VAR=0.
         DO REPEAT I=#I1 to !Im /T=#T1 to !Tm. 
            COMPUTE #VAR = #VAR + (T*I*#OR*(#M-I+1))/((I*#OR+(#M-I+1))**2).
         END REPEAT.
         COMPUTE #VAR=1/#VAR.
         COMPUTE #Z=IDF.NORMAL((!CL+100)/200,0,1).
         COMPUTE #lbOR =#OR*EXP(-#Z*SQR(#VAR)).
         COMPUTE #ubOR =#OR*EXP(+#Z*SQR(#VAR)).

*        Compute OR IC: Miettinen approximate M-H estimation for 1:2 matching (2010-01-25).
         !IF (!COUNT=3) !THEN.
            COMPUTE #SElnORmiet = SQRT(#A2+4*#A1+(#OR**2)*(4*#B3+#B2))/(2*#A1 + #A2).
            COMPUTE #lbORmiet =#OR*EXP(-#Z*#SElnORmiet).
            COMPUTE #ubORmiet =#OR*EXP(+#Z*#SElnORmiet).
         !IFEND.

*        MH test and signification.
         COMPUTE #i=1.
         COMPUTE #ChiN1=0.
         COMPUTE #ChiN2=0.
         COMPUTE #ChiD=0.
         DO REPEAT I=#I1 to !Im /T=#T1 to !Tm /A=#A1 to !Am /B=#B2 to !Bn. 
            COMPUTE #ChiN1 = #ChiN1 + (#M-I+1)*A.
            COMPUTE #ChiN2 = #ChiN2 + (I*B).
            COMPUTE #ChiD = #ChiD + ((T*I)*(#M-I+1)).
         END REPEAT.
         COMPUTE #Chi=SQR(((#ChiN1-#ChiN2)**2)/#ChiD).
         COMPUTE #ChiC=SQR(((ABS(#ChiN1-#ChiN2)-1/2*(#M+1))**2)/#ChiD).
         COMPUTE #p=2*(1-cdfnorm(#Chi)).
         COMPUTE #pC=2*(1-cdfnorm(#ChiC)).
         
*        Print results.         
         PRINT /'MULTIPLE MATCHED CASE-CONTROL STUDY'.
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.

         PRINT//'                   CONTROLS Exposed '.
         PRINT /'                  |'#ECO1 to !ECOn (!COUNT(F5.0,X)) '| TOTAL|'.
         PRINT /'------------------+'!QUOTE(!TABLE)'+------+'.
         PRINT /'CASES     Exposed |'!ACLIST (!COUNT(A6))'|'#TOTALA(F5.0) #TDec(A1) '|'.
         PRINT /'        UnExposed |'!BCLIST (!COUNT(A6))'|'#TOTALB(F5.0) #TDec(A1) '|'.
         PRINT /'------------------+'!QUOTE(!TABLE)'+------+'.
         PRINT /'            TOTAL |'#NC1 to !NCn (!COUNT(A6)) '|'#TOTALN(F5.0) #TDec(A1) '|'.
         PRINT /'------------------+'!QUOTE(!TABLE)'+------+'.

         PRINT /'------------------+-------------+------------------------------------'.
         PRINT /'                  |   Estimate  | '!QUOTE(!CL)'% Confidence Interval'.
         PRINT /'------------------+-------------+------------------------------------'.
         PRINT /'  Odds ratio (OR) |' #OR(T21,F11.4) '|'33 #lbOR(T34,F9.4) #ubOR(T44,F11.4) ' (M-H)'.
*        For 1:2 matching print the Miettinen IC.
         !IF (!COUNT=3) !THEN.
            PRINT /       '|'19        '|'33 #lbORmiet(T34,F9.4) #ubORmiet(T44,F11.4) ' (Miettinen)'.
         !IFEND.
*        If necessary, print the reciprocal OR.
         DO IF (#OR<1).
            COMPUTE #IOR=1/#OR.
            COMPUTE #IlbOR=1/#ubOR.
            COMPUTE #IubOR=1/#lbOR.
            PRINT /'       reciprocal |' #IOR(T21,F11.4)'|'33 #IlbOR(T34,F9.4) #IubOR(T44,F11.4)  ' (M-H)'. 
            !IF (!COUNT=3) !THEN.
               COMPUTE #IlbORmiet=1/#ubORmiet.
               COMPUTE #IubORmiet=1/#lbORmiet.
               PRINT /       '|'19        '|'33 #IlbORmiet(T34,F9.4) #IubORmiet(T44,F11.4) ' (Miettinen)'.
            !IFEND.
         END IF.

         PRINT /'------------------+-------------+------------------------------------ '.
         PRINT /'     M-H Chi Test | ' #Chi(T21,F11.4) '|   P ='33 #p(F7.5)'  (Association)' .
         PRINT /'        Corrected | ' #ChiC(T21,F11.4)'|   P ='33 #pC(F7.5) .
         PRINT /'------------------+-------------+------------------------------------'.
         !IF (!COUNT=3) !THEN.
            PRINT /'Approximate M-H estimation for 1:2 matching'.
         !IFEND.
         
         DO IF (#WARNDEC=1).
            PRINT / '(.)WARNING: Number of Cases with decimal values.'.
            PRINT / '            The values are printed rounded.'.
         END IF.
      END IF.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
