PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !SCC V2012.03.20 loaded.'
         /'Execute !SCC HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !SCC ( VarExp=!CHAREND('/') /VarRes =!CHAREND('/') /VarStr =!CHAREND('/') 
            /STRATUM=!CHAREND('/') 
                 /A1=!CHAREND('/') /B1 =!CHAREND('/') /M1 =!CHAREND('/')
                 /A0=!CHAREND('/') /B0 =!CHAREND('/') /M0 =!CHAREND('/')
             /METHOD=!CHAREND('/') !DEFAULT('MH')
                 /CL=!CHAREND('/') !DEFAULT('95') 
               /Zero=!CHAREND('/') !DEFAULT('N')
                /NST=!CHAREND('/')
               /HELP=!CHAREND('/') !DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2012.03.20').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
!LET !WINDOW='HIDDEN'.
DO IF ($casenum=1).
  PRINT //'Macro !SCC V' !VERSION ' (c)JM.Domenech'.
END IF.
!IF (!HELP<>1) !THEN.
*Impresin de la documentacin.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* STRATIFIED CASE-CONTROL STUDY: Standardized and pooled estimates           *'
            /'* Created 2000.03.22 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech                                                            *'
            /'* Programmers: R.Sesma & A.Bonillo                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM. Macro !SCC for SPSS Statistics.                               *'
            /'*    Stratified Case-Control Study: Standardize and pooled estimates         *'
            /'*    [computer program].                                                     *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* Parameter for PRINTING MACRO DOCUMENTATION --------------------------------*'
            /'*  !SCC HELP.                                                                *'
            /'*                                                                            *'
            /'* Parameters for INDIVIDUAL DATA --------------------------------------------*'
            /'*  !SCC VarExp[(ValUnexp ValExp)]= Exposure variable and values for          *'
            /'*                                  UnExp, Exposed.  By default: ValUnexp= 0  *'
            /'*                                                                 ValExp= 1  *'
            /'*      /VarRes[(ValCtr ValCase)]= Response variable and values for           *'
            /'*                                   Control, Case.  By default:   ValCtr= 0  *'
            /'*                                                                ValCase= 1  *'
            /'*      /VarStr = Stratum variable                                            *'
            /'*                                                                            *'
            /'* Parameters for AGGREGATED DATA --------------------------------------------*'
            /'* !SCC STRATUM = List of Stratum labels             (in SPSS format)         *'
            /'*          /A1 = List of cases Exposed              (A1i >= 0)               *'
            /'*         {/A0 = List of cases UnExposed            (A0i >= 0)               *'
            /'*       or /M1}= List of total Cases                (M1i >= A1i)             *'
            /'*          /B1 = List of controls Exposed           (B1i >= 0)               *'
            /'*         {/B0 = List of controls UnExposed         (B0i >= 0)               *'
            /'*       or /M0}= List of total Controls             (M0i >= A0i)             *'
            /'*                                                                            *'
            /'* Parameters for BOTH TYPES OF DATA -----------------------------------------*'
            /'*     [/METHOD]= Method of weighting:                                        *'
            /'*                MH Mantel-Haenszel     by default MH                        *'
            /'*                IV Inverse of Variance                                      *'
            /'*                IS Internal Standardization                                 *'
            /'*                ES External Standardization                                 *'
            /'*         [/CL]= Confidence level(%); by default:95 (50 <= CL < 100)         *'
            /'*              = SE  for printing SE(lnOR) instead of Confidence Interval    *'
            /'*       [/Zero]= Continuity correction for cells with zero events:           *'
            /'*                N (None)                            by default: N           *'
            /'*                C (Constant, add k=0.5 to each cell)                        *'
            /'*                P (Proportional, add k1=M1/N and k0=M0/N)                   *'
            /'*                R (Reciprocal, add k1=1/M0 and k0=1/M1), recommended        *'
            /'*        [/NST]= Name of the study (Label)                                   *'
            /'*        [/HELP] Print Macro call arguments and Samples of calls             *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements *'
            /'*                                                                            *'
            /'* Samples of calls:          +-----------------+-----+----+-----+----+-----+ *'
            /'* !SCC HELP.                 |                 |Str 1| .. |Str i| .. |Str I| *'
            /'* !SCC VarExp=Raza(2 1)      +-----------------+-----+----+-----+----+-----+ *'
            /'* /VarRes=Muerte(0 1)        |Cases    Exposed | A11 | .. | A1i | .. | A1I | *'
            /'* /VarStr=Estadio /Zero=C.   |           TOTAL | M11 | .. | M1i | .. | M1I | *'
            /'* !SCC STRATUM= "<54" ">=55" +-----------------+-----+----+-----+----+-----+ *'
            /'*          /A1=    8     22  |Controls Exposed | B11 | .. | B1i | .. | B1I | *'
            /'*          /M1=   13     38  |           TOTAL | M01 | .. | M0i | .. | M0I | *'
            /'*          /B1=  106     98  +-----------------+-----+----+-----+----+-----+ *'
            /'*          /M0=  231    193  +-----------------+-----+----+-----+----+-----+ *'
            /'*      /METHOD= ES /CL= 95.  |                 |Str 1| .. |Str i| .. |Str I| *'
            /'* !SCC STRATUM= "<54" ">=55" +-----------------+-----+----+-----+----+-----+ *'
            /'*          /A1=    8     22  |Exposed    Cases | A11 | .. | A1i | .. | A1I | *'
            /'*          /B1=  106     98  |        Controls | B11 | .. | B1i | .. | B1I | *'
            /'*          /A0=    5     16  +-----------------+-----+----+-----+----+-----+ *'
            /'*          /B0=  125     95  |UnExposed  Cases | A01 | .. | A0i | .. | A0I | *'
            /'*      /METHOD= IV /CL = 95  |        Controls | B01 | .. | B0i | .. | B0I | *'
            /'*         /NST="Study Name". +-----------------+-----+----+-----+----+-----+ *'
            /'******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Test coherent parameters.
   !LET !ERROR=0.
   !IF (!VarExp=!NULL !AND !VarRes=!NULL !AND !VarStr=!NULL !AND !A1=!NULL !AND !B1=!NULL !AND !STRATUM=!NULL) !THEN.
*     VarExp,VarResp,VarStrat,A1,B1,STRATUM missing.
      !LET !ERROR=1.
      !LET !ErrorText='VarExp,VarRes,VarStr or A1,B1,STRATUM'.
   !IFEND.
   !IF (!ERROR=0 !AND ((!VarExp<>!NULL !OR !VarRes<>!NULL !OR !VarStr<>!NULL) !AND 
       (!STRATUM<>!NULL !OR !A1<>!NULL !OR !A0<>!NULL !OR !B1<>!NULL !OR !B0<>!NULL !OR !M1<>!NULL !OR !M0<>!NULL))) !THEN.
*     Error: too much parameters.
      !LET !ERROR=2.
   !IFEND.
   !IF (!VarExp<>!NULL !OR !VarRes<>!NULL !OR !VarStr<>!NULL) !THEN.
      !IF (!ERROR=0 !AND (!VarExp=!NULL !OR !VarRes=!NULL !OR !VarStr=!NULL)) !THEN.
*        VarExp, VarResp or VarStrat missing.
         !LET !ERROR=1.
         !LET !ErrorText='VarExp, VarRes or VarStr'.
      !IFEND.
   !ELSE.
      !IF (!ERROR=0 !AND !STRATUM=!NULL) !THEN.
*        STRATUM missing.
         !LET !ERROR=1.
         !LET !ErrorText='STRATUM'.
      !IFEND.  
      !IF (!ERROR=0 !AND ((!A1<>!NULL !AND !B1=!NULL) !OR (!A1=!NULL !AND !B1<>!NULL))) !THEN.
*        A1,B1 missing.
         !LET !ERROR=1.
         !LET !ErrorText='A1 or B1'.
      !IFEND.
      !IF (!ERROR=0 !AND ((!A0=!NULL !AND !M1=!NULL) !OR (!B0=!NULL !AND !M0=!NULL))) !THEN.
*        A0,M1 or B0,M0 mising.
         !LET !ERROR=1.
         !LET !ErrorText='A0,M1 or B0,M0'.
      !IFEND.
      !IF (!ERROR=0 !AND ((!A0<>!NULL !AND !B0=!NULL) !OR (!A0=!NULL !AND !B0<>!NULL))) !THEN.
*        A0 or B0 mising.
         !LET !ERROR=1.
         !LET !ErrorText='A0 or B0'.
      !IFEND.
      !IF (!ERROR=0 !AND ((!M1<>!NULL !AND !M0=!NULL) !OR (!M1=!NULL !AND !M0<>!NULL))) !THEN.
*        M1 or M0 mising.
         !LET !ERROR=1.
         !LET !ErrorText='M1 or M0'.
      !IFEND.
   !IFEND.
*  Test parameter METHOD.
   !LET !METHODU=!UPCASE(!METHOD).
   !IF (!ERROR=0 !AND !METHODU<>'MH' !AND !METHODU<>'IV' !AND !METHODU<>'IS' !AND !METHODU<>'ES') !THEN.
      !LET !ERROR=3.
      !LET !ErrorText='METHOD'.
   !IFEND.
*  Test parameter Zero.
   !LET !ZeroU=!UPCASE(!Zero).
   !IF (!ERROR=0 !AND !ZeroU<>'N' !AND !ZeroU<>'C' !AND !ZeroU<>'P' !AND !ZeroU<>'R') !THEN.
      !LET !ERROR=3.
      !LET !ErrorText='Zero'.
   !IFEND.
*  If necessary, print error messages.
   TEMPORARY.
   N 1.
   !IF (!ERROR=1) !THEN.
      PRINT /'ERROR: Parameter(s) ' !QUOTE(!ErrorText) ' missing. See the HELP.'.
   !IFEND.
   !IF (!ERROR=2) !THEN.
      PRINT /'ERROR: Too much parameters. Individual Data parameters are incompatible with'.
      PRINT /'       Aggregated Data parameters. See the HELP.'.
   !IFEND.
   !IF (!ERROR=3) !THEN.
      PRINT /'ERROR: Parameter ' !QUOTE(!ErrorText) ' with wrong values. See the HELP.'.
   !IFEND.
   EXECUTE.

   !IF (!ERROR=0) !THEN.
******GENERATE @DATA: dataset to work with.
      OMS /SELECT ALL /IF COMMANDS = ["Dataset Copy" "Dataset Name"] /DESTINATION   VIEWER = NO.
      DATASET NAME @original.
      OMSEND.

      !IF (!VarRes<>!NULL !AND !VarExp<>!NULL !AND !VarStr<>!NULL) !THEN.
*********READ INFO from VarExp, VarRes: variable names and values.
*        VarExp contains the name and the values of the Exposure variable: VExp(ValUnexp ValExp).
         !LET !Pos=!Index(!VarExp,'(').
         !IF (!Pos<>0) !THEN.
*           Get the name of the variable.
            !LET !VExp=!SubStr(!VarExp,1,!Length(!SubStr(!Blanks(!Pos),2))).
*           Read the values.
            !LET !Values=!SubStr(!VarExp,!Length(!Concat(!Blanks(!Pos),' '))).
            !LET !Values=!SubStr(!Values,1,!Length(!SubStr(!Blanks(!Length(!Values)),2))).
            !LET !COUNT=1.
            !DO !Val !IN (!Values).
               !IF (!COUNT=1) !THEN !LET !ValUnexp=!Val !IFEND.
               !IF (!COUNT=2) !THEN !LET !ValExp=!Val !IFEND.
               !LET !COUNT = !Length(!Concat(!Blanks(!COUNT),' ')).
            !DOEND.
         !ELSE.
*           VarExp contains only the name of the Exposure variable; ValUnexp and ValExp by default (0 1).
            !LET !VExp=!VarExp.
            !LET !ValExp=1.
            !LET !ValUnexp=0.
         !IFEND.
         
*        VarRes contains the name and the values of the Response variable: VRes(ValNonCase ValCase).
         !LET !Pos=!Index(!VarRes,'(').
         !IF (!Pos<>0) !THEN.
*           Get the name of the variable.
            !LET !VRes=!SubStr(!VarRes,1,!Length(!SubStr(!Blanks(!Pos),2))).
*           Read the values.
            !LET !Values=!SubStr(!VarRes,!Length(!Concat(!Blanks(!Pos),' '))).
            !LET !Values=!SubStr(!Values,1,!Length(!SubStr(!Blanks(!Length(!Values)),2))).
            !LET !COUNT=1.
            !DO !Val !IN (!Values).
               !IF (!COUNT=1) !THEN !LET !ValNonCase=!Val !IFEND.
               !IF (!COUNT=2) !THEN !LET !ValCase=!Val !IFEND.
               !LET !COUNT = !Length(!Concat(!Blanks(!COUNT),' ')).
            !DOEND.
         !ELSE.
*           VarRes contains only the name of the Response variable; ValNonCase and ValCase by default (0 1).
            !LET !VRes=!VarRes.
            !LET !ValCase=1.
            !LET !ValNonCase=0.
         !IFEND.
         
*********COPY of the active dataset: @work.
         DATASET COPY @9675work WINDOW=!WINDOW.
         DATASET ACTIVATE @9675work.

*********RECODE of the Exposure, Response variables to @Exp, @Resp variables which are 1,0.
         RECODE !VExp (MISSING=SYSMIS) (!ValExp=1) (!ValUnexp=0) (ELSE=SYSMIS) INTO @9675Exp.
         RECODE !VRes (MISSING=SYSMIS) (!ValCase=1) (!ValNonCase=0) (ELSE=SYSMIS) INTO @9675Resp.
         FORMATS @9675Exp @9675Resp (F8.0).
         EXECUTE.

*********CROSSTABS - Use OMS to redirect output tables to the @DATA, @CASES datasets.
         PRESERVE.
         SET OLANG=ENGLISH TNUMBERS=VALUES.
         DATASET DECLARE @9675DATA WINDOW=!WINDOW.
         OMS /SELECT ALL /IF COMMANDS = ["Crosstabs"] /DESTINATION VIEWER = NO.
         OMS /SELECT TABLES /IF COMMANDS = ["Crosstabs"] SUBTYPES = ["Crosstabulation"]
             /DESTINATION FORMAT = SAV NUMBERED = Num OUTFILE = @9675DATA .
         DATASET DECLARE @9675CASES WINDOW=!WINDOW.
         OMS /SELECT TABLES /IF COMMANDS = ["Crosstabs"]  SUBTYPES = ["Case Processing Summary"]
             /DESTINATION FORMAT = SAV NUMBERED = Num OUTFILE = @9675CASES.
         OMS /SELECT ALL /IF COMMANDS = ["Crosstabs"] /DESTINATION VIEWER = NO.
         CROSSTABS @9675Resp BY @9675Exp BY !VarStr /FORMAT DVALUE /COUNT=ASIS.
         OMSEND.
         RESTORE.

*********CROSSTABS - Get the Stratum's labels.
         PRESERVE.
         SET OLANG=ENGLISH TNUMBERS=LABELS.
         DATASET DECLARE @9675StrNames WINDOW=!WINDOW.
         OMS /SELECT ALL /IF COMMANDS = ["Crosstabs"] /DESTINATION VIEWER = NO.
         OMS /SELECT TABLES /IF COMMANDS = ["Crosstabs"] SUBTYPES = ["Crosstabulation"]
             /DESTINATION FORMAT = SAV NUMBERED = Num OUTFILE = @9675StrNames .
         OMS /SELECT ALL /IF COMMANDS = ["Crosstabs"] /DESTINATION VIEWER = NO.
         CROSSTABS @9675Resp BY @9675Exp BY !VarStr /FORMAT DVALUE /COUNT=ASIS.
         OMSEND.
         RESTORE.

*********FREQUENCIES - Get the Number of Stratum.
         PRESERVE.
         SET TNUMBERS=VALUES OLANG=ENGLISH.
         DATASET DECLARE @9675NumStr WINDOW=!WINDOW.
         OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION   VIEWER = NO.
         OMS /SELECT TABLES /IF COMMANDS = ["Frequencies"]  SUBTYPES = ["Frequencies"]
             /DESTINATION FORMAT = SAV NUMBERED = Num  OUTFILE = @9675NumStr.
         OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION   VIEWER = NO.
         FREQUENCIES  VARIABLES=!VarStr /ORDER=ANALYSIS /FORMAT=DVALUE.
         OMSEND.
         RESTORE.
*        The @NumStr dataset has one row and one variable NStr with the number of stratum.
         DATASET ACTIVATE @9675NumStr WINDOW=ASIS.
         SELECT IF (NOT SYSMIS(CumulativePercent)).
         AGGREGATE  /OUTFILE=* MODE=ADDVARIABLES  /BREAK=Num  /NStr=N.
         MATCH FILES FILE=* /KEEP=Num NStr.
         N 1.
         EXECUTE.

*********Fix the CROSSTABS result: delete the total row (necessary for the SPSS19).
*        StrNames: stratum labels.
         DATASET ACTIVATE @9675StrNames WINDOW=ASIS.
         COMPUTE @NumStr = 1.
         DO IF ($CASENUM>1).
            IF (Var1 = LAG(Var1)) @NumStr = LAG(@NumStr).
            IF (Var1 <> LAG(Var1)) @NumStr = LAG(@NumStr) + 1.
         END IF.
         EXECUTE.
         MATCH FILES FILE=* /TABLE='@9675NumStr' /BY=Num.
         SELECT IF (@NumStr <= NStr).
         MATCH FILES FILE=* /DROP=@NumStr NStr.
         EXECUTE.

*        DATA: data to compute results.
         DATASET ACTIVATE @9675DATA WINDOW=ASIS.
         COMPUTE @NumStr = 1.
         DO IF ($CASENUM>1).
            IF (Var1 = LAG(Var1)) @NumStr = LAG(@NumStr).
            IF (Var1 <> LAG(Var1)) @NumStr = LAG(@NumStr) + 1.
         END IF.
         EXECUTE.
         MATCH FILES FILE=* /TABLE='@9675NumStr' /BY=Num.
         SELECT IF (@NumStr <= NStr).
         MATCH FILES FILE=* /DROP=@NumStr NStr.
         EXECUTE.
         
*        Activate the @work dataset and close the @NumStr temporary dataset.
         DATASET ACTIVATE @9675work WINDOW=ASIS.
         DATASET CLOSE @9675NumStr.
         
*********GET VALUE LABELS.
*        Get variable descriptions on a @Descrip dataset using FREQUENCIES + OMS.
         PRESERVE.
         SET TNUMBERS=BOTH OLANG=ENGLISH.
         DATASET DECLARE @9675Descrip WINDOW=!WINDOW.
         OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION   VIEWER = NO.
         OMS /SELECT TABLES /IF COMMANDS = ["Frequencies"]  SUBTYPES = ["Frequencies"]
          /DESTINATION FORMAT = SAV NUMBERED = @Var  OUTFILE = @9675Descrip.
         OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION   VIEWER = NO.
         FREQUENCIES  VARIABLES=!VExp !VRes /ORDER=  ANALYSIS .
         OMSEND.
         RESTORE.

*        Prepare @StrNames dataset with stratum's names.
         DATASET ACTIVATE @9675StrNames.
         DATASET CLOSE @9675work.
         COMPUTE @MATCH=$CASENUM.
         MATCH FILES FILE=* /RENAME=(Var1=Study) /KEEP=@MATCH Study.
         EXECUTE.

*        Add stratum's names to @DATA dataset.
         DATASET ACTIVATE @9675DATA.
         COMPUTE @MATCH=$CASENUM.
         MATCH FILES FILE=* /TABLE=@9675StrNames /BY @MATCH.
         EXECUTE.
         DATASET CLOSE @9675StrNames.
         MATCH FILES FILE=* /RENAME=(@1 @0 Total Var1= A1 A0 M1 ValStudy) /KEEP=Study ValStudy A0 A1 M1.
         EXECUTE.

*        Compute A1, A0, N1, N0, M1, M0, N vars.
         COMPUTE @U=1.
         SPLIT FILE BY ValStudy.
         OMS /SELECT ALL /IF COMMANDS = ["Create"] /DESTINATION VIEWER=NO.
         CREATE /B1=LEAD(A1 1) /N1=LEAD(A1 2) /B0=LEAD(A0 1) /N0=LEAD(A0 2) /M0=LEAD(M1 1) /N=LEAD(M1 2) /Sec=CSUM(@U).
         OMSEND.
         SPLIT FILE OFF.
         SELECT IF (Sec=1).
         EXECUTE.

*        Prepare @Descrip: erase the Total row and compute the Val, Descrip variables.
         DATASET ACTIVATE @9675Descrip.
         SELECT IF (NOT SYSMIS(CumulativePercent)).
         MATCH FILES FILE=*/RENAME=(Var2=@Descrip) /KEEP=@Var @Descrip.
         STRING Descrip (A50).
         COMPUTE Val = NUMBER(SUBSTR(@Descrip,1,INDEX(@Descrip,' ')-1),F8).
         COMPUTE Descrip = SUBSTR(@Descrip,INDEX(@Descrip,' ')+1).
         IF (LENGTH(LTRIM(Descrip))=0) Descrip = LTRIM(STRING(Val,F8)).
         EXECUTE.
         
         DATASET ACTIVATE @9675DATA.
      !ELSE.
*********AGGREGATED DATA: Create the @DATA dataset from the A1,A0,N1,N0,B1,B0 parameters.
*        Create @DATA: copy the active dataset, and keep only the first row.
         DATASET COPY @9675DATA WINDOW=!WINDOW.
         DATASET ACTIVATE @9675DATA.
         SPLIT FILE OFF.
         WEIGHT OFF.
         N 1.
         EXECUTE.
*        Create Study1 TO StudyN vars with STRATUM data.
         !LET !COUNT=''.
         !DO !I !IN(!STRATUM).
            !LET !COUNT=!CONCAT(!COUNT,' ').
            !LET !VAR=!CONCAT('Study',!LENGTH(!COUNT)).
            !LET !FORMAT=!CONCAT('A',!LENGTH(!I)).
            STRING !VAR (!FORMAT).
            COMPUTE !VAR=!I.
         !DOEND.
*        Create A11 TO A1N vars with A1 data.
         !LET !COUNT=!LENGTH(!COUNT).
         !LET !A1n = !CONCAT('A1',!COUNT).
         NUMERIC A11 to !A1n.
         DO REPEAT Var=A11 to !A1n /Val=!A1.
            COMPUTE Var=Val.
         END REPEAT.
         EXECUTE.
*        Create B11 TO B1N vars with B1 data.
         !LET !B1n = !CONCAT('B1',!COUNT).
         NUMERIC B11 to !B1n.
         DO REPEAT Var=B11 to !B1n /Val=!B1.
            COMPUTE Var=Val.
         END REPEAT.
         !IF (!M1<>!NULL !AND !M0<>!NULL) !THEN.
*           Create M11 TO M1N vars with M1 data.
            !LET !M1n = !CONCAT('M1',!COUNT).
            NUMERIC M11 to !M1n.
            DO REPEAT Var=M11 to !M1n /Val=!M1.
               COMPUTE Var=Val.
            END REPEAT.
*           Create M01 TO M0N vars with M0 data.
            !LET !M0n = !CONCAT('M0',!COUNT).
            NUMERIC M01 to !M0n.
            DO REPEAT Var=M01 to !M0n /Val=!M0.
               COMPUTE Var=Val.
            END REPEAT.
*           Use VARSTOCASES to create @DATA.
            OMS /SELECT ALL /IF COMMANDS = ["Variables to Cases"] /DESTINATION   VIEWER = NO.
            VARSTOCASES /ID = id
             /MAKE Study FROM Study1 TO !CONCAT('Study',!COUNT)
             /MAKE A1 FROM A11 TO !CONCAT('A1',!COUNT)
             /MAKE B1 FROM B11 TO !CONCAT('B1',!COUNT)
             /MAKE M1 FROM M11 TO !CONCAT('M1',!COUNT)
             /MAKE M0 FROM M01 TO !CONCAT('M0',!COUNT)
             /KEEP =
             /NULL = DROP.
            OMSEND.
            COMPUTE A0=M1-A1.
            COMPUTE B0=M0-B1.
         !ELSE.
*           Create A01 TO A0N vars with A0 data.
            !LET !A0n = !CONCAT('A0',!COUNT).
            NUMERIC A01 to !A0n.
            DO REPEAT Var=A01 to !A0n /Val=!A0.
               COMPUTE Var=Val.
            END REPEAT.
*           Create B01 TO B0N vars with B0 data.
            !LET !B0n = !CONCAT('B0',!COUNT).
            NUMERIC B01 to !B0n.
            DO REPEAT Var=B01 to !B0n /Val=!B0.
               COMPUTE Var=Val.
            END REPEAT.
*           Use VARSTOCASES to create @DATA.
            OMS /SELECT ALL /IF COMMANDS = ["Variables to Cases"] /DESTINATION   VIEWER = NO.
            VARSTOCASES /ID = id
             /MAKE Study FROM Study1 TO !CONCAT('Study',!COUNT)
             /MAKE A1 FROM A11 TO !CONCAT('A1',!COUNT)
             /MAKE A0 FROM A01 TO !CONCAT('A0',!COUNT)
             /MAKE B1 FROM B11 TO !CONCAT('B1',!COUNT)
             /MAKE B0 FROM B01 TO !CONCAT('B0',!COUNT)
             /KEEP =
             /NULL = DROP.
            OMSEND.
            COMPUTE M1=A1+A0.
            COMPUTE M0=B1+B0.
         !IFEND.
         COMPUTE N1=A1+B1.
         COMPUTE N0=A0+B0.
         COMPUTE N=N1+N0.
      !IFEND.

*     Compute @Str variable with the Stratum's sequence.
      STRING @Str(A8).
      COMPUTE @Str = CONCAT('Str',STRING($casenum,F1)).
      EXECUTE.
      
*     Add OVERALL results: use AGGREGATE to compute the summatories on a temporary @OVERALL dataset and ADD FILES to add the data.
      COMPUTE @U=1.
      DATASET DECLARE @9675OVERALL WINDOW=!WINDOW.
      AGGREGATE /OUTFILE='@9675OVERALL' /BREAK=@U 
         /A1 = SUM(A1) /A0 = SUM(A0) /B1 = SUM(B1) /B0 = SUM(B0)
         /N1 = SUM(N1) /N0 = SUM(N0) /M1 = SUM(M1) /M0 = SUM(M0) /N = SUM(N).
      ADD FILES /FILE=* /FILE='@9675OVERALL' /IN=@OVERALL.
      EXECUTE.
      DATASET CLOSE @9675OVERALL.
      IF (@OVERALL=1) @Str='OVERALL'.

*     Confidence level.
      !IF (!UPCASE(!CL)='SE') !THEN.
         COMPUTE @CL = 95.
         COMPUTE @SE = 1.
      !ELSE.
         COMPUTE @CL = !CL.
         COMPUTE @SE = 0.
      !IFEND.

******TEST NUMERIC PARAMETERS: A1 A0 B1 B0 N1 N0 M1 M0 N CL.
      COMPUTE @ERROR=0.
      COMPUTE @ErrorVar=0.
      DO REPEAT Var=A1 A0 B1 B0 N1 N0 M1 M0 N @CL /Val=1 TO 10.
         DO IF (@ERROR=0).
            DO IF (SYSMIS(Var)).
               COMPUTE @ERROR=1.
            ELSE.
               IF ((RANGE(Val,1,4) AND Var<0) OR (RANGE(Val,5,8) AND Var<0) OR (Val=9 AND Var<=0) OR (Val=10 AND (Var<50 OR Var>=100))) @ERROR=1.
            END IF.
            DO IF (@ERROR=1).
               COMPUTE @ErrorVar=Val.
            END IF.
         END IF.
      END REPEAT.
      AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /BREAK=@U /ERROR=MAX(@ERROR) /ErrorVar=MAX(@ErrorVar).
      STRING ErrorVarN(A2).
      COMPUTE ErrorVarN='  '.
      DO IF (ERROR>0).
         IF (ErrorVar=1) ErrorVarN='A1'.
         IF (ErrorVar=2) ErrorVarN='A0'.
         IF (ErrorVar=3) ErrorVarN='B1'.
         IF (ErrorVar=4) ErrorVarN='B0'.
         IF (ErrorVar=5) ErrorVarN='N1'.
         IF (ErrorVar=6) ErrorVarN='N0'.
         IF (ErrorVar=7) ErrorVarN='M1'.
         IF (ErrorVar=8) ErrorVarN='M0'.
         IF (ErrorVar=9) ErrorVarN='N'.
         IF (ErrorVar=10) ErrorVarN='CL'.
      END IF.

      DO IF (ERROR=1).
         DO IF ($CASENUM=1).
            PRINT /'ERROR: Parameter ' ErrorVarN(A2) ' with wrong values. See the HELP.'.
         END IF.
      ELSE.
*        Print header.
         DO IF ($CASENUM=1).
            PRINT /'STRATIFIED CASE CONTROL STUDY'.
            !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
               STRING #NST (A131).
               COMPUTE #NST = CONCAT('STUDY: ',!NST).
               PRINT /#NST.
            !IFEND.
         END IF.
      END IF.
      EXECUTE.

*     Print Value Labels and Case Processing Summary (Individual Data).
      !IF (!VarRes<>!NULL !AND !VarExp<>!NULL) !THEN.
         DATASET COPY @9675ERROR WINDOW=!WINDOW.
         DATASET ACTIVATE @9675ERROR.
         N 1.
         EXECUTE.
         MATCH FILES FILE=* /KEEP=@U ERROR.
         EXECUTE.
*        Add @ERROR variable with the error information.
         DATASET ACTIVATE @9675Descrip.
         COMPUTE @U=1.
         MATCH FILES FILE=* /TABLE='@9675ERROR' /BY @U /KEEP=@Var @Descrip Val Descrip ERROR.
         EXECUTE.
*        EXPOSURE variable, Unexposed and Exposed values.
         DO IF ($casenum=1 AND ERROR=0).
            PRINT //'EXPOSURE variable: ' !QUOTE(!VExp).
         END IF.
         EXECUTE.
         DO IF (@Var=1 AND Val=!ValUnexp AND ERROR=0).
            PRINT  /'        Unexposed: ' Descrip.
         END IF.
         EXECUTE.
         DO IF (@Var=1 AND Val=!ValExp AND ERROR=0).
            PRINT  /'          Exposed: ' Descrip.
         END IF.
         EXECUTE.
*        RESPONSE variable, NonCases and Cases values.
         DO IF ($casenum=1 AND ERROR=0).
            PRINT //'RESPONSE variable: ' !QUOTE(!VRes) .
         END IF.
         EXECUTE.
         DO IF (@Var=2 AND Val=!ValNonCase AND ERROR=0).
            PRINT  /'         Controls: ' Descrip.
         END IF.
         EXECUTE.
         DO IF (@Var=2 AND Val=!ValCase AND ERROR=0).
            PRINT  /'            Cases: ' Descrip.
         END IF.
         EXECUTE.

*        STRATUM variable.
         DATASET ACTIVATE @9675DATA.
         DO IF ($casenum=1 AND ERROR=0).
            PRINT //' STRATUM variable: ' !QUOTE(!VarStr) .
         END IF.
         EXECUTE.
         DO IF (ERROR=0 AND @OVERALL=0).
            PRINT /     @Str(T14,A4) ': ' Study.
         END IF.
         EXECUTE.

*        Case Processing Summary.
         DATASET ACTIVATE @9675CASES.
         COMPUTE @U=1.
         MATCH FILES FILE=* /TABLE='@9675ERROR' BY @U /KEEP=Valid_N Valid_Percent Total_N ERROR.
         DO IF (ERROR=0).
            PRINT //'Valid cases=' Valid_N(F6) '(' Valid_Percent(PCT6.1) ')'.
            PRINT  /'Total cases=' Total_N(F6).
         END IF.
         EXECUTE.
   
         DATASET ACTIVATE @9675DATA.
         DATASET CLOSE @9675Descrip.
         DATASET CLOSE @9675CASES.
         DATASET CLOSE @9675ERROR.
      !ELSE.
*        STRATUM variable.
         DATASET ACTIVATE @9675DATA.
         DO IF ($casenum=1 AND ERROR=0).
            PRINT //'STRATUM ' @Str(T9,A4) ': ' Study.
         END IF.
         EXECUTE.
         DO IF (ERROR=0 AND @OVERALL=0 AND $casenum>1).
            PRINT  /           @Str(T9,A4) ': ' Study.
         END IF.
         EXECUTE.
      !IFEND.

******COMPUTE RESULTS.
      DO IF (@ERROR=0).
*        Save the original parameters for the print.
         COMPUTE A1o=A1.
         COMPUTE A0o=A0.
         COMPUTE B1o=B1.
         COMPUTE B0o=B0.
         COMPUTE N1o=N1.
         COMPUTE N0o=N0.
         COMPUTE M1o=M1.
         COMPUTE M0o=M0.
         COMPUTE No= N.

*********COMPUTE RESULTS.
         COMPUTE @P = (@CL+100)/200.
         COMPUTE @Z=IDF.NORMAL(@P,0,1).
*        Type of continuity correction.
         COMPUTE @ZERO=0.
         IF (!QUOTE(!ZeroU)='C') @ZERO=1.
         IF (!QUOTE(!ZeroU)='P') @ZERO=2.
         IF (!QUOTE(!ZeroU)='R') @ZERO=3.
*        Method.
         COMPUTE @Method=0.
         IF (!QUOTE(!METHODU)='MH') @Method=1.
         IF (!QUOTE(!METHODU)='IV') @Method=2.
         IF (!QUOTE(!METHODU)='IS') @Method=3.
         IF (!QUOTE(!METHODU)='ES') @Method=4.

*        Proportions.
         COMPUTE Pe=N1/N.
         COMPUTE Pt=M1/N.
         COMPUTE P0=B1/M0.
         COMPUTE P1=A1/M1.

*        MH Chi-Square for each stratum (without any continuity correction).
         COMPUTE #T1 = ABS(A1*N-N1*M1).
         COMPUTE CHIi= (N-1)*(#T1**2)/(M1*M0*N1*N0) .
         COMPUTE CHIci=(N-1)*(#T1-N/2)**2/(M1*M0*N1*N0) .
         IF (#T1 < N/2) CHIci=0.
         COMPUTE pCHIi= (1- CDF.CHISQ(ABS(CHIi),1)).
         COMPUTE pCHIci=(1- CDF.CHISQ(ABS(CHIci),1)).
         DO IF (@OVERALL=0).
            COMPUTE ExMHi= N1*M1/(N1+N0).
            COMPUTE VMHi = N1*N0*M1*M0/((N1+N0)**2*(N1+N0-1)).
         END IF.
         
*        Continuity correction.
         COMPUTE @WarnZERO=0.
         IF ((A1=0 OR A0=0 OR B1=0 OR B0=0) AND @Zero>0) @WarnZERO=1.
         COMPUTE @K1=0.
         COMPUTE @K0=0.
         DO IF (@WARNZERO=1).
            IF (@ZERO=1) @K1=0.5.
            IF (@ZERO=1) @K0=0.5.
            IF (@ZERO=2) @K1=M1/N.
            IF (@ZERO=2) @K0=M0/N.
            IF (@ZERO=3) @K1=1/M0.
            IF (@ZERO=3) @K0=1/M1.
         END IF.
         COMPUTE A1=A1+@K1.
         COMPUTE A0=A0+@K1.
         COMPUTE B1=B1+@K0.
         COMPUTE B0=B0+@K0.
         COMPUTE N1=A1+B1.
         COMPUTE N0=A0+B0.
         COMPUTE M1=A1+A0.
         COMPUTE M0=B1+B0.
         COMPUTE N= N1+N0.

*        Statistic (OR), variance and CI for each stratum.
         COMPUTE STi= (A1*B0)/(A0*B1).
         COMPUTE Vari= 1/A1 + 1/A0 + 1/B1 + 1/B0.
         COMPUTE SESTi= SQRT(Vari).
         COMPUTE lbSTi=STi*EXP(-@Z*SESTi).
         COMPUTE ubSTi=STi*EXP(@Z*SESTi).
*        Reciprocal values.
         COMPUTE iSTi=1/STi.
         COMPUTE iubSTi=1/lbSTi.
         COMPUTE ilbSTi=1/ubSTi.

*        Weights.
         IF (@Method=1) W = (A0*B1)/N.
         IF (@Method=2) W = 1/Vari.
         IF (@Method=3) W = B1.
         IF (@Method=4) W = B0.
         IF (@OVERALL=1) W=$SYSMIS.

*        Estimations: summatories terms.
*        Mantel-Haenszel combined.
         COMPUTE NSTMHi = (A1*N0)/N.
         COMPUTE DSTMHi = (A0*N1)/N.
         COMPUTE NSESTMHi= (M1*N1*N0/(N**2) - A1*A0/N).
         COMPUTE Ri = (A1*B0)/N.
         COMPUTE Si = (A0*B1)/N.
         COMPUTE Pi = (A1+B0)/N.
         COMPUTE Qi = 1-Pi.
         COMPUTE PRi = Pi*Ri.
         COMPUTE PSi = Pi*Si.
         COMPUTE QRi = Qi*Ri.
         COMPUTE QSi = Qi*Si.
*        Inverse of variance.
         COMPUTE NSTIVi= LN(STi)/Vari.
         COMPUTE DSTIVi= (1/Vari).
*        Internal standardization.
         COMPUTE DSTwIi= B1*A0/B0.
         COMPUTE NSESTwIi= (A1**2)*Vari .
*        External standardization.
         COMPUTE NSTwEi= B0*A1/B1.
         COMPUTE NSESTwEi= ((B0*A1/B1)**2)*Vari .
         
*        Prepare string variables for printing.
         STRING @TZero @Dec(A1) @Stratum(A7) @Title(A18).
         COMPUTE @TZero=' '.
         IF (@WarnZERO=1) @TZero='*'.
         COMPUTE @WarnDec=0.
         COMPUTE @Dec=' '.
         IF (MOD(A1o,1)<>0 OR MOD(A0o,1)<>0 OR MOD(B0o,1)<>0 OR MOD(B1o,1)<>0) @WarnDec=1.
         IF (@WarnDEC=1) @Dec='.'.
         DO IF ($CASENUM=1).
            COMPUTE @Stratum='STRATUM'.
         END IF.
         DO IF (@SE=1).
            COMPUTE @Title='SE(lnOR)'.
         ELSE IF (@SE=0).
            COMPUTE @Title=CONCAT(STRING(@CL,F2),'% Conf. Interval').
         END IF.
      END IF.

*     Aggregate to perform the summatories (can't be inside a DO IF).
      TEMPORARY.
      SELECT IF (@OVERALL=0).
      AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /MISSING=COLUMNWISE /BREAK=@U
        /NSTMH = SUM(NSTMHi) /DSTMH = SUM(DSTMHi) /NSESTMH = SUM(NSESTMHi) 
        /R = SUM(Ri) /S = SUM(Si) /P = SUM(Pi) /Q = SUM(Qi) /PR = SUM(PRi) /PS = SUM(PSi) /QR = SUM(QRi) /QS = SUM(QSi)
        /NSTIV = SUM(NSTIVi) /DSTIV = SUM(DSTIVi) 
        /DSTwI = SUM(DSTwIi) /NSESTwI = SUM(NSESTwIi) /A1wI=SUM(A1)
        /NSTwE = SUM(NSTwEi) /NSESTwE = SUM(NSESTwEi) /A0wE=SUM(A0)
        /ExMH = SUM(ExMHi) /VMH = SUM(VMHi) /A1orig = SUM(A1o)
        /TZero = MAX(@TZero) /WarnZero = MAX(@WarnZero) /WarnDec = MAX(@WarnDec).

*     Create the STcrude value (OVERALL statistic).
      COMPUTE @STcrude = $SYSMIS.
      IF (@OVERALL = 1) @STcrude = STi.
      AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /BREAK=@U
        /STcrude = MAX(@STcrude).

      DO IF (ERROR=0).
*        Estimations.
*        Mantel Haenszel.
         COMPUTE STMH=R/S.
         COMPUTE SESTMH= SQR(PR/(2*R**2) + (PS+QR)/(2*R*S) + QS/(2*S**2)).
*        Inverse of variance.
         COMPUTE STIV=EXP(NSTIV/DSTIV).
         COMPUTE SESTIV=SQRT(1/(DSTIV)).
*        Internal standardization.
         COMPUTE STwI= A1wI/DSTwI.
         COMPUTE SESTwI= SQR(NSESTwI)/A1wI.
*        External standardization.
         COMPUTE STwE= NSTwE/A0wE.
         COMPUTE SESTwE= SQR(NSESTwE)/NSTwE.
*        CI, p and reciprocals for each estimation.
         NUMERIC lbSTMH ubSTMH pSTMH lbSTIV ubSTIV pSTIV lbSTwI ubSTwI pSTwI lbSTwE ubSTwE pSTwE
                  iSTMH iSTIV iSTwI iSTwE ilbSTMH ilbSTIV ilbSTwI ilbSTwE iubSTMH iubSTIV iubSTwI iubSTwE.
         DO REPEAT  ST=STMH STIV STwI STwE
                 /SEST=SESTMH SESTIV SESTwI SESTwE
                 /lbST=lbSTMH lbSTIV lbSTwI lbSTwE 
                 /ubST=ubSTMH ubSTIV ubSTwI ubSTwE
                  /pST=pSTMH pSTIV pSTwI pSTwE
                  /iST=iSTMH iSTIV iSTwI iSTwE 
                /ilbST=ilbSTMH ilbSTIV ilbSTwI ilbSTwE 
                /iubST=iubSTMH iubSTIV iubSTwI iubSTwE
                   /ch=chMH chIV chwI chwE.
            COMPUTE lbST= ST*EXP(-@Z*SEST).
            COMPUTE ubST= ST*EXP(@Z*SEST).
            COMPUTE pST= 2*(1-CDFNORM(ABS(LN(ST)/SEST))).
            COMPUTE iST=1/ST.
            COMPUTE iubST=1/lbST.
            COMPUTE ilbST=1/ubST.
            COMPUTE ch = ABS((ST - STcrude)/ST)*100.
         END REPEAT.

         COMPUTE ChiMH=(A1orig-ExMH)**2/VMH.
         COMPUTE ChiMHc=(ABS(A1orig-ExMH)-0.5)**2/(VMH).
         IF (ABS(A1orig-ExMH)<0.5) ChiMHc=0.
         COMPUTE pChiMH= (1- CDF.CHISQ(ABS(ChiMH),1)).
         COMPUTE PChiMHc=(1- CDF.CHISQ(ABS(ChiMHc),1)).

*        Homogeneity: Wald.
         IF (@Method = 1) ChiWi= (LN(STi)-LN(STMH))**2/Vari.
         IF (@Method = 2) ChiWi= (LN(STi)-LN(STIV))**2/Vari.
         IF (@Method = 3) ChiWi= (LN(STi)-LN(STwI))**2/Vari.
         IF (@Method = 4) ChiWi= (LN(STi)-LN(STwE))**2/Vari.

*        Homogeneity: Breslow & Day.
         COMPUTE ChiBDi=$SYSMIS.
*        Use formula 4:11 (Breslow & Day, pag 130) to find Ai (using the previously computed M-H estimation of OR).
         COMPUTE #a = (1 - STMH).      /*Compute the terms of the quadratic equation of Ai (Ai=x, given ax2 + bx + c = 0).
         COMPUTE #b = (N0 + STMH*N1 + M1*(STMH - 1 )).
         COMPUTE #c = -STMH*N1*M1.
*        To find Ai, solve the quadratic equation: x = (-b +/- SQR(b^2 - 4ac))/2a.
         COMPUTE Aiplus = (-#b + SQR((#b**2)-(4*#a*#c)))/(2*#a).       /*Root using the +.
         COMPUTE Biplus = N1 - Aiplus.               /*Find the A,B,C,D quantities of 4:10 (Breslow & Day, pag 130) for Ai+.
         COMPUTE Ciplus = M1 - Aiplus.
         COMPUTE Diplus = N0 - M1 + Aiplus.
         COMPUTE Aiminus = (-#b - SQR((#b**2)-(4*#a*#c)))/(2*#a).       /*Root using the -.
         COMPUTE Biminus = N1 - Aiminus.               /*Find the A,B,C,D quantities of 4:10 (Breslow & Day, pag 130) for Ai-.
         COMPUTE Ciminus = M1 - Aiminus.
         COMPUTE Diminus = N0 - M1 + Aiminus.
*        Only one root Ai+, Ai- is correct: A,B,C,D must be all positive.
*        To compute the Variance use the formula 4:13 (Breslow & Day, pag 130) with the correct A,B,C,D.
         DO IF (Aiplus > 0 AND Biplus > 0 AND Ciplus > 0 AND Diplus > 0).
            COMPUTE ABDi = Aiplus.
            COMPUTE VARBDi = 1/(1/Aiplus + 1/Biplus + 1/Ciplus + 1/Diplus).
         ELSE IF (Aiminus > 0 AND Biminus > 0 AND Ciminus > 0 AND Diminus > 0).
            COMPUTE ABDi = Aiminus.
            COMPUTE VARBDi = 1/(1/Aiminus + 1/Biminus + 1/Ciminus + 1/Diminus).
         END IF.
*        Use formula 4:30 (Breslow & Day, pag 142) to find the homogeneity statistic with the found Ai,VARi.
         COMPUTE ChiBDi = (A1 - ABDi)**2/VARBDi.
      END IF.
      EXECUTE.

      TEMPORARY.
      SELECT IF(@OVERALL=0).
      AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /MISSING=COLUMNWISE /BREAK=@U
        /ChiW = SUM(ChiWi) /ChiBD = SUM(ChiBDi) /COUNT=N.
      COMPUTE pChiW= (1- CDF.CHISQ(ABS(ChiW),COUNT-1)).
      COMPUTE pChiBD= (1- CDF.CHISQ(ABS(ChiBD),COUNT-1)).
      EXECUTE.

*****PRINT RESULTS.
*    Print of stratum's tables.
      DO IF (ERROR=0 AND $CASENUM=1).
         PRINT//'STRATUM           | UnExposed |  Exposed  |    TOTAL  |            '.
         PRINT /'==================+===========+===========+===========+============='.
      END IF.
      EXECUTE.
      DO IF (ERROR=0).
         PRINT  /@Str(A8)    'Cases |'13 A0o(T21,F9) @Dec '|'31 A1o(T33,F9) @Dec '|'43 M1o(T45,F9) @Dec '| Pe1='55 P1(F8.4).
         PRINT  /'         Controls |'   B0o(T21,F9) @Dec '|'31 B1o(T33,F9) @Dec '|'43 M0o(T45,F9) @Dec '| Pe0='55 P0(F8.4).
         PRINT  /'------------------+-----------+-----------+-----------+'.
         PRINT  /'            TOTAL |' N0o(T21,F9) @Dec '|'31 N1o(T33,F9) @Dec '|'43 No(T45,F9) @Dec '| OR='55 STi(T60,F9.4) @TZero.
         PRINT  /'==================+===========+===========+===========+============='.
      END IF.
      EXECUTE.

*     Print: ST, CI (or SE) of each stratum and OVERALL.
      DO IF (ERROR=0 AND $CASENUM=1).
         PRINT //'------------------+-----------------------------------+-------------'.
         PRINT / '                  |         OR     ' @Title(A18)  '|    '55 !QUOTE(!METHODU) ' Weight'.
         PRINT / '------------------+-----------------------------------+-------------'.
      END IF.
      EXECUTE.
      DO IF (ERROR=0).
         DO IF (@OVERALL=0).
            DO IF (@SE=1).
               PRINT /@STRATUM(T1,A7) @Str(T14,A4) '|'19 STi(T21,F10.4) @TZero(A1) SESTi(T36,F10.8) '|'55 W(T56,F13.3) @TZero(A1).
               DO IF (STi<1 AND STi>0).
                  PRINT /'       reciprocal |' iSTi(T21,F10.4) @TZero(A1) '|'55 .
               END IF.
            ELSE IF (@SE=0).
               PRINT /@STRATUM(T1,A7) @Str(T14,A4) '|'19 STi(T21,F10.4) @TZero(A1) lbSTi(T33,F10.4) ubSTi(T44,F10.4) '|'55 W(T56,F13.3) @TZero(A1).
               DO IF (STi<1 AND STi>0).
                  PRINT /'       reciprocal |' iSTi(T21,F10.4) @TZero(A1) ilbSTi(T33,F10.4) iubSTi(T44,F10.4) '|'55 .
               END IF.
            END IF.
         ELSE IF (@OVERALL=1).
            PRINT / '------------------+-----------------------------------+-------------'. 
            DO IF (@SE=1).
               PRINT /'OVERALL     Crude |' STi(T21,F10.4) @TZero(A1) SESTi(T36,F10.8) '| Sig.  Change'55.
               DO IF (STi<1 AND STi>0).
                  PRINT /'       reciprocal |' iSTi(T21,F10.4) @TZero(A1) '|'55 .
               END IF.
            ELSE IF (@SE=0).
               PRINT /'OVERALL     Crude |' STi(T21,F10.4) @TZero(A1) lbSTi(T33,F10.4) ubSTi(T44,F10.4) '| Sig.  Change'55.
               DO IF (STi<1 AND STi>0).
                  PRINT /'       reciprocal |' iSTi(T21,F10.4) @TZero(A1) ilbSTi(T33,F10.4) iubSTi(T44,F10.4) '|'55 .
               END IF.
            END IF.
            PRINT / '------------------+-----------------------------------+-------------'. 
         END IF.
      END IF.
      EXECUTE.

*     Prints: Estimations - MH Combined,Inv of Variance,Internal Std,External Std.
      DO IF (ERROR=0 AND $CASENUM=1).
         STRING  #TITLEMH #TITLEIV #TITLEIS #TITLEES (A18).
         COMPUTE #TITLEMH = '      MH Combined '.
         COMPUTE #TITLEIV = ' Inv. of Variance '.
         COMPUTE #TITLEIS = '    Internal Std. '.
         COMPUTE #TITLEES = '    External Std. '.
         DO REPEAT TITLE = #TITLEMH #TITLEIV #TITLEIS #TITLEES
                     /ST = STMH STIV STwI STwE /lbST = lbSTMH lbSTIV lbSTwI lbSTwE /ubST = ubSTMH ubSTIV ubSTwI ubSTwE
                   /SEST = SESTMH SESTIV SESTwI SESTwE /pST = pSTMH pSTIV pSTwI pSTwE
                    /iST = iSTMH iSTIV iSTwI iSTwE /ilbST = ilbSTMH ilbSTIV ilbSTwI ilbSTwE /iubST = iubSTMH iubSTIV iubSTwI iubSTwE
                     /ch = chMH chIV chwI chwE.
            DO IF (@SE=1).
               PRINT / TITLE(A18) '|'19 ST(T21,F10.4) TZero(A1) SEST(T36,F10.8) '|'55 pST(T56,F6.4)  TZero(A1) ch(T63,PCT6.2).
               DO IF (ST<1 AND ST>0).
                  PRINT /'       reciprocal |' iST(T21,F10.4) TZero(A1) '|'55.
               END IF.
            ELSE.
               PRINT / TITLE(A18) '|'19 ST(T21,F10.4) TZero(A1) lbST(T33,F10.4) ubST(T44,F10.4) '|'55 pST(T56,F6.4) TZero(A1) ch(T63,PCT6.2).
               DO IF (ST<1 AND ST>0).
                  PRINT /'       reciprocal |' iST(T21,F10.4) TZero(A1) ilbST(T33,F10.4) iubST(T44,F10.4) '|'55 .
               END IF.
            END IF.
         END REPEAT.
         PRINT / '------------------+-----------------------------------+-------------'.
      END IF.
      EXECUTE.

*     Prints: MH Chi-Square Significance by Stratum and OVERALL.
      DO IF (ERROR=0 AND $CASENUM=1).
         PRINT / '------------------+-----------------------------------+'.
         PRINT / '                  | MH Chi-Square  Significance       |'.
         PRINT / '------------------+-----------------------------------+'.
      END IF.
      EXECUTE.
      DO IF (ERROR=0).
         DO IF (@OVERALL=0).
            PRINT /@STRATUM(T1,A7) @Str(T14,A4) '|'19 CHIi (T22,F9.4) pCHIi(T33,F9.5) '|'55 .
            PRINT /            '|'19 CHIci(T22,F9.4) pCHIci(T33,F9.5)'(Corrected) |'43 .
         ELSE IF (@OVERALL=1).
            PRINT /'------------------+-----------------------------------+'.
            PRINT /'OVERALL     Crude |' CHIi (T22,F9.4) pCHIi(T33,F9.5) '|'55 .
            PRINT /            '|'19 CHIci(T22,F9.4) pCHIci(T33,F9.5)'(Corrected) |'43 .
         END IF.
      END IF.
      EXECUTE.
      DO IF (ERROR=0 AND $CASENUM=1).
         PRINT /'           POOLED |' ChiMH (T22,F9.4) pChiMH(T33,F9.5)'|'55.
         PRINT /'                  |' ChiMHc(T22,F9.4) pChiMHc(T33,F9.5)'(Corrected) |'43.
         PRINT /'------------------+-----------------------------------+'.
      END IF.
      EXECUTE.

*     Prints: Homogeneity - Wald & Breslow-Day.
      DO IF (ERROR=0 AND $CASENUM=1).
         STRING note (A2).
         COMPUTE note= CONCAT(LTRIM(TZero),'').
         PRINT /'HOMOGENEITY   Wald|' ChiW (T22,F9.4) TZero(A1)  pChiW(T33,F9.5) TZero(A1) '('50 !QUOTE(!METHODU)') |'53.
         PRINT /'       Breslow-Day|' ChiBD (T22,F9.4) TZero(A1) pChiBD(T33,F9.5) note(A2) '(MH)'50 '|'55.
         PRINT /'------------------+-----------------------------------+'.
         PRINT / 'Recommended method'.
      END IF.
      EXECUTE.

*     Prints: Warnings by decimals and zeros.
      DO IF (ERROR=0 AND $CASENUM=1).
         DO IF (WarnDec=1).
            PRINT / '(.)WARNING: Number of cases with decimal values.'.
            PRINT / '            The values are printed rounded.'.
         END IF.
         DO IF (WarnZERO=1).
            DO IF (@ZERO=1).
               PRINT /'(*)Computed with a constant continuity correction (k=0.5)'.
            ELSE IF (@ZERO=2).
               PRINT /'(*)Computed with a proportional continuity correction'.
            ELSE IF (@ZERO=3).
               PRINT /'(*)Computed with a reciprocal continuity correction'.
            END IF.
            PRINT /'   Exact inference is recommended'.
         END IF.
      END IF.
      EXECUTE.
      
*     Restore original dataset and close temporary dataset @DATA.
      DATASET ACTIVATE @original.
      DATASET  CLOSE @9675DATA.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
