PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !COI V2008.02.29 loaded.'
         /'Execute !COI HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !COI ( A1 =!CHAREND('/') 
             /T1 =!CHAREND('/')
             /A0 =!CHAREND('/') 
             /T0 =!CHAREND('/')
             /PE =!CHAREND('/') 
             /CL =!CHAREND('/') !DEFAULT('95')
            /NST =!CHAREND('/')
            /HELP=!CHAREND('/') !DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2008.02.29').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
  PRINT //'Macro !COI V' !VERSION ' (c)JM.Domenech'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*  Print HELP.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* COHORT STUDY (RATE): ASSOCIATION MEASURES                                  *'
            /'* Created 1999.03.05 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech                                                            *'
            /'* Programmers: A.Bonillo & R.Sesma                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM. Macro !COI for SPSS Statistics.                               *'
            /'*    Cohort Study (Rate): Association Measures [computer program].           *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* !COI A1 = Events in Exposed                     (A1 >= 0)                  *'
            /'*     /T1 = Person-time in Exposed                (T1 >= A1 and > 0)         *'
            /'*     /A0 = Events in UnExposed                   (A0 >= 0)                  *'
            /'*     /T0 = Person-time in UnExposed              (T0 >= A0 and > 0)         *'
            /'*    [/PE]= Proportion of exposed in pop.; by default: T1/(T1+T0)  (0<PE<1)  *'
            /'*    [/CL]= Confidence level(%);  by default: 95  (50 <= CL < 100)           *'
            /'*         = SE  for printing Standard Error instead of Confidence Interval   *'
            /'*   [/NST]= Name of the study (Label)                                        *'
            /'*   [/HELP] Print Macro call arguments and Samples of calls                  *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in square brackets [ ] are optional              *'
            /'*                                                                            *'
            /'*                                          +-----------+---------+---------+ *'
            /'* Samples of calls:                        |           |UnExposed| Exposed | *'
            /'* !COI HELP.                               +-----------+---------+---------+ *'
            /'* !COI A1=41 /T1=2801.7 /A0=15 /T0=1901.4. |    Cases  |    A0   |    A1   | *'
            /'* !COI A1=4  /T1=12.83 /A0=11 /T0=16.19    |Person-Time|    T0   |    T1   | *'
            /'*     /NST="Study Name" /CL=90.            +-----------+---------+---------+ *'
            /'******************************************************************************'.
    END IF.
   EXECUTE.
!ELSE.
*  Testing the parameters.
   !IF (!A1=!NULL !or !T1=!NULL !or !A0=!NULL !or !T0=!NULL) !THEN.
      PRINT /'ERROR: Missing parameter'.
   !ELSE.
      COMPUTE #ERROR=0.   
      COMPUTE #A1=$SYSMIS.
      COMPUTE #A0=$SYSMIS.
      COMPUTE #T1=$SYSMIS.
      COMPUTE #T0=$SYSMIS.
      COMPUTE #CL=$SYSMIS.
      COMPUTE #PE=$SYSMIS.
      COMPUTE #A1=!A1.
      COMPUTE #A0=!A0.
      COMPUTE #T1=!T1.
      COMPUTE #T0=!T0.

*     Compute parameter PE.
      STRING #PEtype(A11).
      COMPUTE #PEext=0.          /*PE type: 1= estimated; 2= external.
      !IF (!PE=!NULL) !THEN.
         COMPUTE #PE=#T1/(#T1+#T0).
         COMPUTE #PEext=1.
         COMPUTE #PEtype='(estimated)'.
      !ELSE.
         COMPUTE #PE=!PE.
         COMPUTE #PEext=2.
         COMPUTE #PEtype='(external) '.
      !IFEND.

*     Test parameters A1,A0,T1,T0,CL,PE.
      DO IF (SYSMIS(#A1) OR SYSMIS(#A0) OR SYSMIS(#T1) OR SYSMIS(#T0) OR SYSMIS(#PE)).
         COMPUTE #ERROR=1.
      ELSE.
         IF (#A1<0 OR #A0<0 OR #T1<=0 OR #T0<=0 OR #T1<#A1 OR #T0<#A0 OR #PE<=0 OR #PE>=1) #ERROR=1.
         IF ((#A1+#A0)=0) #ERROR=2.
      END IF.

*     Test parameter CL.
      COMPUTE #SE=0.             /*SE=0 compute and show CI; SE=1 compute and show Standard Error.
      !IF (!UPCASE(!CL)='SE') !THEN.
         COMPUTE #SE=1.
         !LET !TITLE = "Standard Error".
         COMPUTE #CL = 95.
      !ELSE.
         !LET !TITLE = !CONCAT(!CL,'% Confidence Interval').
         COMPUTE #CL=!CL.
         DO IF (SYSMIS(#CL)).
            COMPUTE #ERROR=1.
         ELSE.
            IF (#CL<=50 OR #CL>=100) #ERROR=1.
         END IF.
      !IFEND.

      DO IF (#ERROR=1).
         PRINT /'ERROR: Parameter(s) with wrong values'.
      ELSE IF (#ERROR=2).
         PRINT /'ERROR: Non estimable'.
      ELSE.
*        Correct parameters.

*        Check for decimal parameters.
         COMPUTE #WARNDEC=0.
         IF (MOD(#A1,1)<>0 OR MOD(#A0,1)<>0 OR MOD(#T1,1)<>0 OR MOD(#T0,1)<>0) #WARNDEC=1.
         STRING #TDec(A1).
         COMPUTE #TDec=' '.
         IF (#WARNDEC=1) #TDec='.'.
         
*        Sum of rows and columns and Z.
         COMPUTE #M1=#A1+#A0.
         COMPUTE #T=#T1+#T0.
         COMPUTE #P=(#CL+100)/200.
         COMPUTE #Z=IDF.NORMAL(#P,0,1).

*        Mantel-Haenszel Chi-Square.
         COMPUTE #Chi2 = (#A1-#M1*#T1/#T)**2 / (#M1*#T1*#T0/#T**2) .
         COMPUTE #sp= (1- CDF.CHISQ(ABS(#Chi2),1)).
         COMPUTE #WARNCHI=0.
         IF (#M1*#T0/#T<5  OR  #M1*#T1/#T<5) #WARNCHI=1.
         
*        Incidence rates and EXACT bounds.
         NUMERIC #I1 #I0 #I #lbI1 #lbI0 #lbI #ubI1 #ubI0 #ubI.
         DO REPEAT I=#I1 #I0 #I /A=#A1 #A0 #M1 /T=#T1 #T0 #T
                /ubI=#ubI1 #ubI0 #ubI /lbI=#lbI1 #lbI0 #lbI.
            COMPUTE I = A/T.
            COMPUTE lbI = 0.
            COMPUTE ubI = 1.
            IF (A > 0) lbI= IDF.CHISQ(1-#P,2*A)/(2*T).
            IF (A < T) ubI= IDF.CHISQ(#P,2*(A+1))/(2*T).
         END REPEAT.

*        Incidence ratio.
         COMPUTE #IR=#I1/#I0.
         COMPUTE #SElnIR = SQR(1/#A1+1/#A0).
         COMPUTE #lbIR= #IR*EXP((-1)*#Z*#SElnIR).
         COMPUTE #ubIR= #IR*EXP(#Z*#SElnIR).
*        Incidence difference.
         COMPUTE #ID= #I1-#I0.
         COMPUTE #SEID= SQRT(#I1/#T1 + #I0/#T0).
         COMPUTE #lbID= #ID - #Z*#SEID.
         COMPUTE #ubID= #ID + #Z*#SEID.
*        Attributable fraction in exposed.
         COMPUTE #AFe=1 - 1/#IR.
         COMPUTE #lbAFe= 1 - 1/#lbIR.
         COMPUTE #ubAFe= 1 - 1/#ubIR.
         IF (#A0=0) #AFe=1.
*        Preventable fraction in exposed.
         COMPUTE #PFe=1 - #IR.
         COMPUTE #lbPFe= 1 - #ubIR.
         COMPUTE #ubPFe= 1 - #lbIR.

*        Incidence difference in population.
         COMPUTE #IDp = #PE*#ID.
         DO IF (#PEext=1).
            COMPUTE #SEIDp= SQR((#ID**2)*#T1*#T0/#T + (#T1**2)*(#SEID**2))/#T.
            COMPUTE #lbIDp= #IDp - #SEIDp*#Z.
            COMPUTE #ubIDp= #IDp + #SEIDp*#Z.
         ELSE IF (#PEext=2).
            COMPUTE #lbIDp= #PE*#lbID.
            COMPUTE #ubIDp= #PE*#ubID.
         END IF.
*        Attributable fraction in population.
         COMPUTE #AFp=(#PE*(#IR-1))/(1+#PE*(#IR-1)).
         DO IF (#PEext=1).
            COMPUTE #SElnAFp=(#AFp/(1-#AFp))*SQR((#SElnIR/(#IR-1))**2 + 2/(#A1*(#IR-1)) + #A0/(#A1*#M1)).
            COMPUTE #lbAFp=1- (1-#AFp)*EXP(#Z*#SElnAFp).
            COMPUTE #UbAFp=1- (1-#AFp)*EXP((-1)*#Z*#SElnAFp).
         ELSE IF (#PEext=2).
            COMPUTE #lbAFp= (#PE*(#lbIR-1))/(1+#PE*(#lbIR-1)).
            COMPUTE #ubAFp= (#PE*(#ubIR-1))/(1+#PE*(#ubIR-1)).
         END IF.
         IF (#A0=0) #AFp=1.
*        Preventable fraction in population.
         COMPUTE #PFp  = 1- 1/(1-#AFp).
         COMPUTE #lbPFp= 1- 1/(1-#ubAFp).
         COMPUTE #ubPFp= 1- 1/(1-#lbAFp).


*        Print results.
         COMPUTE #WARNSE=0.
         PRINT /'COHORT STUDY (RATE): ASSOCIATION MEASURES'.
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.
         
         PRINT//'                    |UnExposed| Exposed |   TOTAL '.
         PRINT /'--------------------+---------+---------+---------'.
         PRINT /'              Cases |' #A0(T22,F8) #TDec(A1) '|'31 #A1(T32,F8) #TDec(A1) '|'41 #M1(T42,F8) #TDec(A1).
         PRINT /'        Person-time |' #T0(T22,F8) #TDec(A1) '|'31 #T1(T32,F8) #TDec(A1) '|'41 #T(T42,F8) #TDec(A1).
         PRINT /'--------------------+---------+---------+---------'.
         PRINT /'     Incidence rate |'#I0(T22,F8.6)   '|'31 #I1(T32,F8.6)  '|'41 #I(T42,F8.6).
         DO IF (#SE=0).
            PRINT /'      95% CI  Lower |'#lbI0(T22,F8.6) '|'31 #lbI1(T32,F8.6)'|'41 #lbI(T42,F8.6).
            PRINT /'      (Exact) Upper |'#ubI0(T22,F8.6) '|'31 #ubI1(T32,F8.6)'|'41 #ubI(T42,F8.6).
         END IF.

*        Print Incidence difference.
         PRINT //'--------------------+-------------------+-------------------------'.
         PRINT  /'                    |      Estimate     | '!QUOTE(!TITLE).
         PRINT  /'--------------------+-------------------+-------------------------'.
         DO IF (#SE=0).
            PRINT  /'     Incidence diff.|' #ID(T25,F11.8)  '|'41 #lbID(T43,F11.8) #ubID (T55,F11.8). 
         ELSE.
            PRINT  /'     Incidence diff.|' #ID(T25,F11.8)  '|'41 #SEID(T43,F10.8).
         END IF.

*        Print Attributable/Preventable fraction in exposed.
         DO IF (#AFe=1 OR (#AFe>=0 AND #SE=1)).
            PRINT/'    Attr. frac. exp.|'#AFe(T25,F11.8)'|'41. 
         ELSE IF (#AFe>=0).
            PRINT/'    Attr. frac. exp.|'#AFe(T25,F11.8)'|'41 #lbAFe(T43,F11.8) #ubAFe(T55,F11.8). 
         END IF.
         DO IF (#PFe=1 OR (#PFe>0 AND #SE=1)).
            PRINT/'    Prev. frac. exp.|'#PFe(T25,F11.8)'|'41. 
         ELSE IF (#PFe>0).
            PRINT/'    Prev. frac. exp.|'#PFe(T25,F11.8)'|'41 #lbPFe(T43,F11.8) #ubPFe(T55,F11.8). 
         END IF.

*        Print Incidence difference in the population.
         PRINT  /'--------------------+-------------------+-------------------------'.
         PRINT  /'  Prop. exposed pop.|' #PE(T23,F7.6) #PEtype(A11) '|'41.
         DO IF (#SE=0).
            PRINT  /'Incidence diff. pop.|' #IDp(T25,F11.8) '|'41 #lbIDp(T43,F11.8) #ubIDp(T55,F11.8). 
         ELSE.
            DO IF (#PEext=1).
               PRINT  /'Incidence diff. pop.|' #IDp(T25,F11.8) '|'41 #SEIDp(T43,F10.8).
            ELSE.
               PRINT  /'Incidence diff. pop.|' #IDp(T25,F11.8) '|'41 .
            END IF.
         END IF.

*        Print Attributable/Preventable fraction in the population.
         COMPUTE #SYS = (SYSMIS(#SElnIR)).
         DO IF (#AFp>0 AND #SYS=1).
            PRINT/'    Attr. frac. pop.|'#AFp(T25,F11.8)'|'41. 
         ELSE IF (#AFp>0 AND #SYS=0).
            DO IF (#SE=0).
               PRINT/'    Attr. frac. pop.|'#AFp(T25,F11.8)'|'41 #lbAFp (T43,F11.8) #ubAFp(T55,F11.8). 
            ELSE IF (#SE=1 AND #PEext=1).
               COMPUTE #WARNSE=1.
               PRINT/'    Attr. frac. pop.|'#AFp(T25,F11.8)'|'41 #SElnAFp (T43,F10.8) '**'. 
            ELSE IF (#SE=1 AND #PEext=2).
               PRINT/'    Attr. frac. pop.|'#AFp(T25,F11.8)'|'41 . 
            END IF.
         END IF.
         DO IF (#PFp>0 AND #SYS=1).
            PRINT/'    Prev. frac. pop.|'#PFp(T25,F11.8)'|'41.
         ELSE IF (#PFp>0 AND #SYS=0).
            DO IF (#SE=0).
               PRINT/'    Prev. frac. pop.|'#PFp(T25,F11.8)'|'41 #lbPFp (T43,F11.8) #ubPFp(T55,F11.8). 
            ELSE.
               PRINT/'    Prev. frac. pop.|'#PFp(T25,F11.8)'|'41. 
            END IF.
         END IF.

*        Print Incidence ratio IR.
         PRINT  /'--------------------+-------------------+-------------------------'.
         DO IF (#A0=0).
            PRINT  /'Incidence ratio (IR)|      infinity     |'.
         ELSE IF (#IR=0).
            PRINT  /'Incidence ratio (IR)|' #IR(T25,F11.4)  '|'41.
            PRINT  /'         reciprocal |      infinity     |'. 
         ELSE.
            DO IF (#SE=0).
               PRINT  /'Incidence ratio (IR)|'#IR(T25,F11.4) '|'41 #lbIR (T43,F11.4) #UbIR (T55,F11.4).
            ELSE.
               COMPUTE #WARNSE=1.
               PRINT  /'Incidence ratio (IR)|'#IR(T25,F11.4) '|'41 #SElnIR (T43,F10.8) '**'.
            END IF.
            DO IF (#IR<1).
               COMPUTE #IIR=1/#IR.
               COMPUTE #IlbIR=1/#ubIR.
               COMPUTE #IubIR=1/#lbIR.
               DO IF (#SE=0).
                  PRINT/'         reciprocal |' #IIR(T25,F11.4) '|'41 #IlbIR (T43,F11.4) #IUbIR (T55,F11.4). 
               ELSE.
                  PRINT/'         reciprocal |' #IIR(T25,F11.4) '|'41. 
               END IF.
            END IF.
         END IF.
*        Print Mantel-Haenszel Chi2.
         STRING #TChi (A1).
         COMPUTE #TChi=' '.
         IF (#WARNCHI=1) #TChi='*'.
         PRINT  /'--------------------+-------------------+-------------------------'.
         PRINT  /'Mantel-Haenszel Chi2|' #Chi2(T28,F8.4) #TChi(A1) '|'41 ' p = ' #sp(F6.5) ' (Association)'. 
         PRINT  /'--------------------+-------------------+-------------------------'.

         DO IF (#WARNDEC=1).
            PRINT / '(.)WARNING: Number of Cases or Person-Time with decimal values.'.
            PRINT / '            The values are printed rounded.'.
         END IF.
         DO IF (#WARNCHI=1).
            PRINT/'(*)WARNING: Small samples for Association Chi-Square' . 
         END IF.
         DO IF (#WARNSE=1).
            PRINT/'(**)SE of natural logarithm of ratio statistic'.
         END IF.
      END IF.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
