PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !COR V2009.07.03 loaded.'
         /'Execute !COR HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !COR (  VarExp =!CHAREND('/') 
              /VarRes =!CHAREND('/') 
                  /A1 =!CHAREND('/') /B1 =!CHAREND('/') /N1 =!CHAREND('/')
                  /A0 =!CHAREND('/') /B0 =!CHAREND('/') /N0 =!CHAREND('/')
                  /Pe =!CHAREND('/') 
                  /CL =!CHAREND('/') !DEFAULT('95')
                /Zero =!CHAREND('/') !DEFAULT('N')
                /PrCI =!CHAREND('/') !DEFAULT('W')
                 /NST =!CHAREND('/')
                /HELP =!CHAREND('/') !DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE LENGHT=NONE ERRORS=NONE MESSAGES=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2009.07.03').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
!LET !WINDOW='HIDDEN'.
DO IF ($casenum=1).
  PRINT //'Macro !COR V' !VERSION ' (c)JM.Domenech'.
END IF.
!IF (!HELP<>1) !THEN.
*  Print HELP.
   DO IF ($casenum=1).
      PRINT/'******************************************************************************'
           /'* COHORT STUDY (RISK): ASSOCIATION MEASURES                                  *'
           /'* Created 1999.03.05 Last revised ' !VERSION                                '*'78
           /'* (c) JM.Domenech                                                            *'
           /'* Programmers: R.Sesma & A.Bonillo                                           *'
           /'*                                                                            *'
           /'* Vancouver reference:                                                       *'
           /'* Domenech JM. Macro !COR for SPSS Statistics.                               *'
           /'*    Cohort Study (Risk): Association Measures [computer program].           *'
           /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
           /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
           /'*                                                                            *'
           /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
           /'* Parameter for PRINTING MACRO DOCUMENTATION --------------------------------*'
           /'*  !COR HELP.                                                                *'
           /'*                                                                            *'
           /'* Parameters for INDIVIDUAL DATA --------------------------------------------*'
           /'*  !COR VarExp[(ValUnexp ValExp)]= Exposure variable and values for          *'
           /'*                                  UnExpo, Exposed.  By default: ValUnexp= 0 *'
           /'*                                                                  ValExp= 1 *'
           /'*      /VarRes[(ValNonCase ValCase)]= Response variable and values for       *'
           /'*                                   NonCase, Case. By default: ValNonCase= 0 *'
           /'*                                                                 ValCase= 1 *'
           /'*                                                                            *'
           /'* Parameters for AGGREGATED DATA --------------------------------------------*'
           /'*  !COR A1 = Events in Exposed                (A1 >= 0)                      *'
           /'*     {/B1 = NonEvents in Exposed             (B1 >= 0)                      *'
           /'*   or /N1}= Total of Exposed                 (N1 >= A1 and > 0)             *'
           /'*      /A0 = Events in UnExposed              (A0 >= 0 )                     *'
           /'*     {/B0 = NonEvents in UnExposed           (B0 >= 0)                      *'
           /'*   or /N0}= Total of UnExposed               (N0 >= A0 and > 0)             *'
           /'*                                                                            *'
           /'* Parameters for BOTH TYPES OF DATA -----------------------------------------*'
           /'*    [ /PE]= Proportion of exposed in popul.; by default:N1/(N1+N0) (0<PE<1) *'
           /'*    [ /CL]= Confidence level(%); by default: 95 (50 <= CL < 100)            *'
           /'*          = SE  for printing Standard Error instead of Confidence Interval  *'
           /'*   [/Zero]= Continuity correction for cells with zero events:               *'
           /'*            N (None)                            by default: N               *'
           /'*            C (Constant, add k=0.5 to each cell)                            *'
           /'*            P (Proportional, add k1=N1/N and k0=N0/N)                       *'
           /'*            R (Reciprocal, add k1=1/N0 and k0=1/N1), recommended correction *'
           /'*   [/PrCI]= Method for compute CI of proportions:                           *'
           /'*            W  Wilson                           by default: W               *'
           /'*            E  Exact (Clopper-Pearson)                                      *'
           /'*            A  Asymptotic                                                   *'
           /'*    [/NST]= Name of the study (Label)                                       *'
           /'*                                                                            *'
           /'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
           /'*       Parameters enclosed in Braces { } indicate a choice between elements *'
           /'*                                                                            *'
           /'*                                        +---------+----------+---------+    *'
           /'* Samples of calls:                      |         |UnExposed | Exposed |    *'
           /'* !COR HELP.                             +---------+----------+---------+    *'
           /'* !COR A1=3 /B1=9  /A0=3 /B0=13 /PrCI=W. |   Cases |    A0    |    A1   |    *'
           /'* !COR A1=3 /N1=3  /A0=3 /N0=16 /Zero=C. |NonCases |    B0    |    B1   |    *'
           /'* !COR VarExp=Raza /VarRes=Muerte.       +---------+----------+---------+    *'
           /'* !COR VarExp=Sexo(2 1) /VarRes=Muerte   |   TOTAL |    N0    |    N1   |    *'
           /'*     /CL=90 /NST="Name of the Study".   +---------+----------+---------+    *'
           /'******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Test coherent parameters.
   !LET !ERROR=0.
   !IF (!VarExp=!NULL !AND !VarRes=!NULL !AND !A1=!NULL !AND !A0=!NULL) !THEN.
*     VarExp,VarResp,A1,A0 missing.
      !LET !ERROR=1.
      !LET !ErrorText='VarExp,VarRes or A1,A0'.
   !IFEND.
   !IF (!ERROR=0 !AND ((!VarExp<>!NULL !OR !VarRes<>!NULL) !AND (!A1<>!NULL !OR !A0<>!NULL !OR !B1<>!NULL !OR !B0<>!NULL !OR !N1<>!NULL !OR !N0<>!NULL))) !THEN.
*     Error: too much parameters.
      !LET !ERROR=2.
   !IFEND.
   !IF (!VarExp<>!NULL !OR !VarRes<>!NULL) !THEN.
      !IF (!ERROR=0 !AND ((!VarExp<>!NULL !AND !VarRes=!NULL) !OR (!VarExp=!NULL !AND !VarRes<>!NULL))) !THEN.
*        VarExp or VarResp missing.
         !LET !ERROR=1.
         !LET !ErrorText='VarExp or VarRes'.
      !IFEND.
   !ELSE.
      !IF (!ERROR=0 !AND ((!A1<>!NULL !AND !A0=!NULL) !OR (!A1=!NULL !AND !A0<>!NULL))) !THEN.
*        A1,A0 missing.
         !LET !ERROR=1.
         !LET !ErrorText='A1 or A0'.
      !IFEND.
      !IF (!ERROR=0 !AND ((!N1=!NULL !AND !B1=!NULL) !OR (!N0=!NULL !AND !B0=!NULL))) !THEN.
*        N1,B1 or N0,B0 mising.
         !LET !ERROR=1.
         !LET !ErrorText='N1,B1 or N0,B0'.
      !IFEND.
      !IF (!ERROR=0 !AND ((!N1<>!NULL !AND !N0=!NULL) !OR (!N1=!NULL !AND !N0<>!NULL))) !THEN.
*        N1 or N0 mising.
         !LET !ERROR=1.
         !LET !ErrorText='N1 or N0'.
      !IFEND.
      !IF (!ERROR=0 !AND ((!B1<>!NULL !AND !B0=!NULL) !OR (!B1=!NULL !AND !B0<>!NULL))) !THEN.
*        B1 or B0 mising.
         !LET !ERROR=1.
         !LET !ErrorText='B1 or B0'.
      !IFEND.
   !IFEND.
*  Test parameter Zero.
   !LET !ZeroU=!UPCASE(!Zero).
   !IF (!ERROR=0 !AND !ZeroU<>'N' !AND !ZeroU<>'C' !AND !ZeroU<>'P' !AND !ZeroU<>'R') !THEN.
      !LET !ERROR=3.
      !LET !ErrorText='Zero'.
   !IFEND.
*  Test parameter PrCI.
   !LET !PrCIU=!UPCASE(!PrCI).
   !IF (!ERROR=0 !AND !PrCIU<>'W' !AND !PrCIU<>'E' !AND !PrCIU<>'A') !THEN.
      !LET !ERROR=3.
      !LET !ErrorText='PrCI'.
   !IFEND.
*  If necessary, print error messages.
   TEMPORARY.
   N 1.
   !IF (!ERROR=1) !THEN.
      PRINT /'ERROR: Parameter(s) ' !QUOTE(!ErrorText) ' missing. See the HELP.'.
   !IFEND.
   !IF (!ERROR=2) !THEN.
      PRINT /'ERROR: Too much parameters. Individual Data parameters are incompatible with'.
      PRINT /'       Aggregated Data parameters. See the HELP.'.
   !IFEND.
   !IF (!ERROR=3) !THEN.
      PRINT /'ERROR: Parameter(s) ' !QUOTE(!ErrorText) ' with wrong values. See the HELP.'.
   !IFEND.
   EXECUTE.

   !IF (!ERROR=0) !THEN.
******GENERATE @DATA: dataset to work with.
      OMS /SELECT ALL /IF COMMANDS = ["Dataset Copy" "Dataset Name"] /DESTINATION   VIEWER = NO.
      DATASET NAME @original.
      OMSEND.
      
      !IF (!VarRes<>!NULL !AND !VarExp<>!NULL) !THEN.
*********READ INFO from VarExp, VarRes: variable names and values.
*        VarExp contains the name and the values of the Exposure variable: VExp(ValUnexp ValExp).
         !LET !Pos=!Index(!VarExp,'(').
         !IF (!Pos<>0) !THEN.
*           Get the name of the variable.
            !LET !VExp=!SubStr(!VarExp,1,!Length(!SubStr(!Blanks(!Pos),2))).
*           Read the values.
            !LET !Values=!SubStr(!VarExp,!Length(!Concat(!Blanks(!Pos),' '))).
            !LET !Values=!SubStr(!Values,1,!Length(!SubStr(!Blanks(!Length(!Values)),2))).
            !LET !COUNT=1.
            !DO !Val !IN (!Values).
               !IF (!COUNT=1) !THEN !LET !ValUnexp=!Val !IFEND.
               !IF (!COUNT=2) !THEN !LET !ValExp=!Val !IFEND.
               !LET !COUNT = !Length(!Concat(!Blanks(!COUNT),' ')).
            !DOEND.
         !ELSE.
*           VarExp contains only the name of the Exposure variable; ValUnexp and ValExp by default (0 1).
            !LET !VExp=!VarExp.
            !LET !ValExp=1.
            !LET !ValUnexp=0.
         !IFEND.
         
*        VarRes contains the name and the values of the Response variable: VRes(ValNonCase ValCase).
         !LET !Pos=!Index(!VarRes,'(').
         !IF (!Pos<>0) !THEN.
*           Get the name of the variable.
            !LET !VRes=!SubStr(!VarRes,1,!Length(!SubStr(!Blanks(!Pos),2))).
*           Read the values.
            !LET !Values=!SubStr(!VarRes,!Length(!Concat(!Blanks(!Pos),' '))).
            !LET !Values=!SubStr(!Values,1,!Length(!SubStr(!Blanks(!Length(!Values)),2))).
            !LET !COUNT=1.
            !DO !Val !IN (!Values).
               !IF (!COUNT=1) !THEN !LET !ValNonCase=!Val !IFEND.
               !IF (!COUNT=2) !THEN !LET !ValCase=!Val !IFEND.
               !LET !COUNT = !Length(!Concat(!Blanks(!COUNT),' ')).
            !DOEND.
         !ELSE.
*           VarRes contains only the name of the Response variable; ValNonCase and ValCase by default (0 1).
            !LET !VRes=!VarRes.
            !LET !ValCase=1.
            !LET !ValNonCase=0.
         !IFEND.

*********COPY of the active dataset: @work.
         DATASET COPY @9675work WINDOW=!WINDOW.
         DATASET ACTIVATE @9675work.

*********RECODE of the Exposure, Response variables to @Exp, @Resp variables which are 1,0.
         RECODE !VExp (MISSING=SYSMIS) (!ValExp=1) (!ValUnexp=0) (ELSE=SYSMIS) INTO @9675Exp.
         RECODE !VRes (MISSING=SYSMIS) (!ValCase=1) (!ValNonCase=0) (ELSE=SYSMIS) INTO @9675Resp.
         FORMATS @9675Exp @9675Resp (F8.0).
         EXECUTE.

*********CROSSTABS - Use OMS to redirect output tables to the @DATA, @CASES datasets.
         PRESERVE.
         SET OLANG=ENGLISH TNUMBERS=VALUES.
         DATASET DECLARE @9675DATA WINDOW=!WINDOW.
         OMS /SELECT ALL /IF COMMANDS = ["Crosstabs"] /DESTINATION VIEWER = NO.
         OMS /SELECT TABLES /IF COMMANDS = ["Crosstabs"] SUBTYPES = ["Crosstabulation"]
             /DESTINATION FORMAT = SAV NUMBERED = Num OUTFILE = @9675DATA .
         DATASET DECLARE @9675CASES WINDOW=!WINDOW.
         OMS /SELECT TABLES /IF COMMANDS = ["Crosstabs"]  SUBTYPES = ["Case Processing Summary"]
             /DESTINATION FORMAT = SAV NUMBERED = Num OUTFILE = @9675CASES.
         OMS /SELECT ALL /IF COMMANDS = ["Crosstabs"] /DESTINATION VIEWER = NO.
         CROSSTABS VARIABLES=@9675Resp @9675Exp (0,1) /TABLES=@9675Resp BY @9675Exp /FORMAT DVALUE /COUNT=ASIS.
         OMSEND.
         RESTORE.

*********GET VALUE LABELS.
*        Get variable descriptions on a @Descrip dataset using FREQUENCIES + OMS.
         PRESERVE.
         SET TNUMBERS=BOTH OLANG=ENGLISH.
         DATASET DECLARE @9675Descrip WINDOW=!WINDOW.
         OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION   VIEWER = NO.
         OMS /SELECT TABLES /IF COMMANDS = ["Frequencies"]  SUBTYPES = ["Frequencies"]
          /DESTINATION FORMAT = SAV NUMBERED = @Var  OUTFILE = @9675Descrip.
         OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION   VIEWER = NO.
         FREQUENCIES  VARIABLES=!VExp !VRes /ORDER=  ANALYSIS .
         OMSEND.
         RESTORE.

*        Prepare @DATA to compute results: rename vars and keep interesting info.
         DATASET ACTIVATE @9675DATA.
         DATASET CLOSE @9675work.
         MATCH FILES FILE=* /RENAME=(@0 @1 Total = A0 A1 M1) /KEEP=A0 A1 M1.
*        Compute A1, A0, N1, N0, M1, M0, N vars and keep only the first row.
         PRESERVE.
         SET RESULTS=OFF ERRORS=OFF PRINTBACK=OFF.
         CREATE /B1=LEAD(A1 1) /N1=LEAD(A1 2) /B0=LEAD(A0 1) /N0=LEAD(A0 2) /M0=LEAD(M1 1) /N=LEAD(M1 2).
         RESTORE.
         N 1.
         EXECUTE.
         
*        Prepare @Descrip: erase the Total row and compute the Val, Descrip variables.
         DATASET ACTIVATE @9675Descrip.
         SELECT IF (NOT SYSMIS(CumulativePercent)).
         MATCH FILES FILE=*/RENAME=(Var2=@Descrip) /KEEP=@Var @Descrip.
         STRING Descrip (A50).
         COMPUTE Val = NUMBER(SUBSTR(@Descrip,1,INDEX(@Descrip,' ')-1),F8).
         COMPUTE Descrip = SUBSTR(@Descrip,INDEX(@Descrip,' ')+1).
         IF (LENGTH(LTRIM(Descrip))=0) Descrip = LTRIM(STRING(Val,F8)).
         EXECUTE.
         
         DATASET ACTIVATE @9675DATA.
      !ELSE.
*********AGGREGATED DATA: Create the @DATA dataset from the A1,A0,N1,N0,B1,B0 parameters.
*        Create @DATA: copy the active dataset, and keep only the first row.
         DATASET COPY @9675DATA WINDOW=!WINDOW.
         DATASET ACTIVATE @9675DATA.
         SPLIT FILE OFF.
         WEIGHT OFF.
         N 1.
         COMPUTE @U=1.
         MATCH FILES FILE=* /KEEP=@U.
*        Compute A1, A0, N1, N0, M1, M0, N vars and keep only the interesting vars.
         NUMERIC A1 A0 B1 B0 N1 N0 M1 M0 N.
         COMPUTE A1=!A1.
         COMPUTE A0=!A0.
         !IF (!N1<>!NULL !AND !N0<>!NULL) !THEN.
            COMPUTE N1=!N1.
            COMPUTE N0=!N0.
            COMPUTE B1=N1-A1.
            COMPUTE B0=N0-A0.
         !ELSE.
            COMPUTE B1=!B1.
            COMPUTE B0=!B0.
            COMPUTE N1=A1+B1.
            COMPUTE N0=A0+B0.
         !IFEND.
         COMPUTE M1=A1+A0.
         COMPUTE M0=B1+B0.
         COMPUTE N=N1+N0.
      !IFEND.

*     Proportion of exposed (estimated or external) - by default, estimated.
      COMPUTE Pe=$SYSMIS.
      !IF (!Pe<>!NULL) !THEN
         COMPUTE Pe=!Pe.
         COMPUTE @Pe=1.
      !ELSE.
         COMPUTE Pe=N1/(N1+N0) .
         COMPUTE @Pe=0.
      !IFEND.

*     Confidence level.
      COMPUTE @CL=$SYSMIS.
      !IF (!UPCASE(!CL)='SE') !THEN.
         COMPUTE @CL = 95.
      !ELSE.
         COMPUTE @CL = !CL.
      !IFEND.

******TEST NUMERIC PARAMETERS: A1 A0 B1 B0 N1 N0 M1 M0 N Pe CL.
      STRING ErrorVar(A2).
      COMPUTE @ERROR=0.
      COMPUTE @U=1.
      COMPUTE ErrorVar=' '.
      DO REPEAT Var=A1 A0 B1 B0 N1 N0 M1 M0 N Pe @CL /Val=1 TO 11.
         DO IF (@ERROR=0).
            DO IF (SYSMIS(Var)).
               COMPUTE @ERROR=1.
            ELSE.
               IF ((RANGE(Val,1,4) AND Var<0) OR (RANGE(Val,5,9) AND Var<=0) OR 
                   (Val=10 AND (Var<=0 OR Var>=1)) OR (Val=11 AND (Var<50 OR Var>=100))) @ERROR=1.
            END IF.
            DO IF (@ERROR=1).
               IF (Val=1) ErrorVar='A1'.
               IF (Val=2) ErrorVar='A0'.
               IF (Val=3) ErrorVar='B1'.
               IF (Val=4) ErrorVar='B0'.
               IF (Val=5) ErrorVar='N1'.
               IF (Val=6) ErrorVar='N0'.
               IF (Val=7) ErrorVar='M1'.
               IF (Val=8) ErrorVar='M0'.
               IF (Val=9) ErrorVar='N'.
               IF (Val=10) ErrorVar='Pe'.
               IF (Val=11) ErrorVar='CL'.
            END IF.
         END IF.
      END REPEAT.

      DO IF (@ERROR=1).
         PRINT /'ERROR: Parameter ' ErrorVar(A2) ' with wrong values. See the HELP.'.
      ELSE.
*        Print header.
         PRINT /'COHORT STUDY (RISK): ASSOCIATION MEASURES'.
*        Print NST if available.
         !IF (!NST !NE !NULL) !THEN .
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.
      END IF.
      EXECUTE.
      
*     Print Value Labels and Case Processing Summary (Individual Data).
      !IF (!VarRes<>!NULL !AND !VarExp<>!NULL) !THEN.
         DATASET ACTIVATE @9675Descrip.
         COMPUTE @U=1.
*        Add @ERROR variable with the error information.
         MATCH FILES FILE=* /TABLE='@9675DATA' BY @U /KEEP=@Var @Descrip Val Descrip @ERROR.
*        EXPOSURE variable, Unexposed and Exposed values.
         DO IF ($casenum=1 AND @ERROR=0).
            PRINT //'EXPOSURE variable: ' !QUOTE(!VExp).
         END IF.
         EXECUTE.
         DO IF (@Var=1 AND Val=!ValUnexp AND @ERROR=0).
            PRINT  /'        Unexposed: ' Descrip.
         END IF.
         EXECUTE.
         DO IF (@Var=1 AND Val=!ValExp AND @ERROR=0).
            PRINT  /'          Exposed: ' Descrip.
         END IF.
         EXECUTE.
*        RESPONSE variable, NonCases and Cases values.
         DO IF ($casenum=1 AND @ERROR=0).
            PRINT //'RESPONSE variable: ' !QUOTE(!VRes) .
         END IF.
         EXECUTE.
         DO IF (@Var=2 AND Val=!ValNonCase AND @ERROR=0).
            PRINT  /'         NonCases: ' Descrip.
         END IF.
         EXECUTE.
         DO IF (@Var=2 AND Val=!ValCase AND @ERROR=0).
            PRINT  /'            Cases: ' Descrip.
         END IF.
         EXECUTE.

*        Case Processing Summary.
         DATASET ACTIVATE @9675CASES.
         COMPUTE @U=1.
         MATCH FILES FILE=* /TABLE='@9675DATA' BY @U /KEEP=Valid_N Valid_Percent Total_N @ERROR.
         DO IF (@ERROR=0).
            PRINT //'Valid cases=' Valid_N(F6) '(' Valid_Percent(PCT6.1) ')'.
            PRINT  /'Total cases=' Total_N(F6).
         END IF.
         EXECUTE.
   
         DATASET ACTIVATE @9675DATA.
         DATASET CLOSE @9675Descrip.
         DATASET CLOSE @9675CASES.
      !IFEND.
         
******COMPUTE RESULTS.
      DO IF (@ERROR=0).
*        Save the original parameters for the print.
         COMPUTE A1o=A1.
         COMPUTE A0o=A0.
         COMPUTE B1o=B1.
         COMPUTE B0o=B0.
         COMPUTE N1o=N1.
         COMPUTE N0o=N0.
         COMPUTE M1o=M1.
         COMPUTE M0o=M0.
         COMPUTE No= N.

         COMPUTE @P = (@CL+100)/200.
         COMPUTE @Z=IDF.NORMAL(@P,0,1).
*        CI compute method (PrCI): W (Wilson) = 1 - default; E (Exact) = 2; A (Asymptotic) = 3.
         COMPUTE @PrCI=0.
         IF (!QUOTE(!PrCIU)='W') @PrCI=1.
         IF (!QUOTE(!PrCIU)='E') @PrCI=2.
         IF (!QUOTE(!PrCIU)='A') @PrCI=3.
*        Type of continuity correction: 1 - Constant; 2 - Proportional; 3 - Reciprocal.
         COMPUTE @ZERO=0.
         IF (!QUOTE(!ZeroU)='C') @ZERO=1.
         IF (!QUOTE(!ZeroU)='P') @ZERO=2.
         IF (!QUOTE(!ZeroU)='R') @ZERO=3.

*        Mantel-Haenszel Chi-Square test.
         COMPUTE @WarnCHI=0.
         COMPUTE #T1 = ABS(A1*N-N1*M1).
         COMPUTE Chi2 = (N-1)*(#T1**2)/(M1*M0*N1*N0).
         COMPUTE Chi2C= (N-1)*(#T1-N/2)**2/(M1*M0*N1*N0).
         IF (#T1 < N/2) Chi2C=0.
         COMPUTE p= (1- CDF.CHISQ(ABS(Chi2),1)).
         COMPUTE pC=(1- CDF.CHISQ(ABS(Chi2C),1)).
         IF (M1*N1/N<5 OR M0*N1/N<5 OR M1*N0/N<5 OR M0*N0/N<5) @WarnCHI=1.
   
*        Continuity correction.
         COMPUTE @WarnZERO=0.
         IF ((A1=0 OR A0=0 OR B1=0 OR B0=0) AND @Zero>0) @WarnZERO=1.
         COMPUTE @K1=0.
         COMPUTE @K0=0.
         DO IF (@WARNZERO=1).
            IF (@ZERO=1) @K1=0.5.
            IF (@ZERO=1) @K0=0.5.
            IF (@ZERO=2) @K1=N1/N.
            IF (@ZERO=2) @K0=N0/N.
            IF (@ZERO=3) @K1=1/N0.
            IF (@ZERO=3) @K0=1/N1.
         END IF.
         COMPUTE A1=A1+@K1.
         COMPUTE A0=A0+@K0.
         COMPUTE B1=B1+@K1.
         COMPUTE B0=B0+@K0.
         COMPUTE N1=A1+B1.
         COMPUTE N0=A0+B0.
         COMPUTE M1=A1+A0.
         COMPUTE M0=B1+B0.
         COMPUTE N= N1+N0.

*        Proportions.
         COMPUTE @WarnCIA=0.
         NUMERIC P1 P0 PT lbP1 lbP0 lbPT ubP1 ubP0 ubPT SEP1 SEP0 SEPT.
         DO REPEAT P=P1 P0 PT /A=A1 A0 M1 /N=N1 N0 N
                 /ub=ubP1 ubP0 ubPT /lb=lbP1 lbP0 lbPT /SE=SEP1 SEP0 SEPT.
            COMPUTE P = A/N.
            COMPUTE SE= SQR(P*(1-P)/N).
            DO IF (@PrCI=1).      /*Wilson bounds.
               COMPUTE #WA = 2*A + @Z**2.
               COMPUTE #WB = @Z * SQRT(@Z**2 + 4*A*(N-A)/N).
               COMPUTE #WC = 2*(N + @Z**2).
               COMPUTE lb= (#WA-#WB)/#WC.
               COMPUTE ub= (#WA+#WB)/#WC.
            ELSE IF (@PrCI=2).    /*Exact bounds.
               COMPUTE lb= 0.
               COMPUTE ub= 1.
               IF (A > 0) lb= A/(A+(N-A+1)*IDF.F(@P,2*(N-A+1),2*A)).
               IF (N > A) ub=(A+1)/((A+1)+((N-A)/IDF.F(@P,2*(A+1),2*(N-A)))).               
            ELSE IF (@PrCI=3).    /*Asymptotic bounds.
               COMPUTE ub = P + @Z*SE.
               COMPUTE lb = P - @Z*SE.
               IF (ub>1 OR lb<0) @WarnCIA=1.
            END IF.
         END REPEAT.

*        Risk difference (RD).
         COMPUTE RD= P1-P0.
*        Wald CI of difference of two proportions.
         COMPUTE SERD= SQR(P1*(1-P1)/N1 + P0*(1-P0)/N0).
         COMPUTE lbRDWa= RD - @Z*SERD.
         COMPUTE ubRDWa= RD + @Z*SERD.
*        Wilson CI of difference of two proportions.
         COMPUTE #f0= A0**2 /(N0**2 + N0*@Z**2).
         COMPUTE #f1= A1**2 /(N1**2 + N1*@Z**2).
         COMPUTE #w0= (2*A0 + @Z**2)/(2*(N0 + @Z**2)).
         COMPUTE #w1= (2*A1 + @Z**2)/(2*(N1 + @Z**2)).
         COMPUTE #L0= #w0 - SQR(#w0**2 - #f0).
         COMPUTE #L1= #w1 - SQR(#w1**2 - #f1).
         COMPUTE #U0= #w0 + SQR(#w0**2 - #f0).
         COMPUTE #U1= #w1 + SQR(#w1**2 - #f1).
         COMPUTE lbRDWi= RD - SQR((P1-#L1)**2 + (#U0-P0)**2).
         COMPUTE ubRDWi= RD + SQR((#U1-P1)**2 + (P0-#L0)**2).

*        Risk Ratio (RR).
         COMPUTE RR=P1/P0.
         COMPUTE SElnRR = SQR(1/A0-1/N0+1/A1-1/N1).
         COMPUTE lbRR= RR*EXP(-@Z*SElnRR).
         COMPUTE ubRR= RR*EXP(@Z*SElnRR).
*        Attributable fraction in exposed (AFe).
         COMPUTE AFe=1.
         COMPUTE AFe=1 - 1/RR.
         COMPUTE lbAFe= 1 - 1/lbRR.
         COMPUTE ubAFe= 1 - 1/ubRR.
*        Preventable fraction in exposed (PFe).
         COMPUTE PFe=1.
         COMPUTE PFe=1 - RR.
         COMPUTE lbPFe= 1 - ubRR.
         COMPUTE ubPFe= 1 - lbRR.

*        Risk difference in population (RDp).
         COMPUTE RDp=Pe*RD.
         DO IF (@Pe=0).
            COMPUTE SeRDp= SQR((RD**2)*N1*N0/N + (N1**2)*(SERD**2))/N.
            COMPUTE lbRDp= RDp - @Z*SERDp.
            COMPUTE UbRDp= RDp + @Z*SERDp.
         ELSE IF (@Pe=1).
            COMPUTE lbRDp= Pe*lbRDWi.
            COMPUTE ubRDp= Pe*ubRDWi.
         END IF.
*        Attributable fraction in population (AFp).
         COMPUTE AFp=1.
         COMPUTE AFp=(Pe*(RR-1))/(1+Pe*(RR-1)).
         DO IF (@Pe=0).
            COMPUTE SEAFp=(AFp/(1-AFp))*SQR((SElnRR/(RR-1))**2 + 2/(A1*(RR-1)) + A0/(A1*M1)).
            COMPUTE lbAFp= 1-(1-AFp)*EXP(@Z*SEAFp).
            COMPUTE ubAFp= 1-(1-AFp)*EXP(-@Z*SEAFp).
         ELSE IF (@Pe=1).
            COMPUTE lbAFp= (Pe*(lbRR-1))/(1+Pe*(lbRR-1)).
            COMPUTE ubAFp= (Pe*(ubRR-1))/(1+Pe*(ubRR-1)).
         END IF.
*        Preventable fraction in population (PFp).
         COMPUTE PFp  = 1- 1/(1-AFp).
         COMPUTE lbPFp= 1- 1/(1-lbAFp).
         COMPUTE UbPFp= 1- 1/(1-UbAFp).

*        Odds Ratio.
         COMPUTE @OR= (A1*B0)/(B1*A0).
         COMPUTE SElnOR = SQR((1/A0)+(1/B0)+(1/A1)+(1/B1)).
         COMPUTE lbOR= @OR*EXP(-@Z*SElnOR).
         COMPUTE UbOR= @OR*EXP(@Z*SElnOR).

*        Mantel-Haenszel Chi test.
         COMPUTE Chi =(RD/ABS(RD))*SQR(Chi2).
         COMPUTE ChiC=(RD/ABS(RD))*SQR(Chi2C).

*********PRINT RESULTS.
*        Determine if CL=SE, and the title of the CI.
         COMPUTE @SE=0.
         !LET !TITLE = !CONCAT(!CL,'% Confidence Interval').
         !IF (!UPCASE(!CL)='SE') !THEN.
            COMPUTE @SE=1.
            !LET !TITLE = 'Standard Error'.
         !IFEND.
*        Determine text for the CI type.
         STRING @CItype (A13).
         IF (!QUOTE(!PrCIU)='W') @CItype = '    (Wilson)'.
         IF (!QUOTE(!PrCIU)='E') @CItype = '     (Exact)'.
         IF (!QUOTE(!PrCIU)='A') @CItype = '(Asymptotic)'.
*        Determine text for Pe.
         !LET !PeText='(estimated)'.
         !IF (!PE<>!NULL) !THEN
            !LET !PeText='(external)'.
         !IFEND.

*        Detect decimal parameters.
         STRING @Dec(A1).
         COMPUTE @WarnDec=0.
         COMPUTE @Dec=' '.
         IF (MOD(A1o,1)<>0 OR MOD(A0o,1)<>0 OR MOD(B0o,1)<>0 OR MOD(B1o,1)<>0) @WarnDEC=1.
         IF (@WarnDEC=1) @Dec='.'.

*        Zero correction note.
         STRING @TZero(A1).
         COMPUTE @TZero=' '.
         IF (@WarnZERO=1) @TZero='*'.

*        2x2 table and proportions.
         PRINT //'                   |UnExposed| Exposed |   TOTAL '.
         PRINT  /'-------------------+---------+---------+---------'.
         PRINT  /'             Cases |'A0o(T21,F8) @Dec '|'30 A1o (T31,F8) @Dec '|'40 M1o (T41,F8) @Dec.
         PRINT  /'          NonCases |'B0o(T21,F8) @Dec '|'30 B1o (T31,F8) @Dec '|'40 M0o (T41,F8) @Dec.
         PRINT  /'-------------------+---------+---------+---------'.
         PRINT  /'             TOTAL |'N0o(T21,F8) @Dec '|'30 N1o (T31,F8) @Dec '|'40 No  (T41,F8) @Dec.
         PRINT  /'                   |         |         |           '.
         PRINT  /'              RISK |'P0(T22,F7.6) @TZero '|'30 P1(T32,F7.6) @TZero '|'40 PT(T42,F7.6) @TZero.
         DO IF (@SE=0).
            PRINT  /'     ' @CL(F2) '% CI  Lower |' lbP0(T22,F7.6) '|'30 lbP1(T32,F7.6)'|'40 lbPT(T42,F7.6).
            PRINT  /@CItype(A12) ' Upper |' ubP0(T22,F7.6) '|'30 ubP1(T32,F7.6) '|'40 ubPT(T42,F7.6).
         ELSE.
            PRINT  /'     Asymptotic SE |' SEP0(T22,F7.6) '|'30 SEP1(T32,F7.6) '|'40 SEPT(T42,F7.6).
         END IF.

*        Estimates.
         PRINT //'-------------------+-------------------+---------------------------------'.
         PRINT  /'                   |     Estimate      | '!QUOTE(!TITLE).
         PRINT  /'-------------------+-------------------+---------------------------------'.

*        Risk difference.
         DO IF (@SE=0).
            PRINT  /'   Risk difference |' RD(T23,F11.6) @TZero '|'40 lbRDWa (T41,F12.6) ubRDWa (T53,F12.6) ' Wald'. 
            PRINT  /                   '|'20                    '|'40 lbRDWi (T41,F12.6) ubRDWi (T53,F12.6) ' Newcombe'.
         ELSE.
            PRINT  /'   Risk difference |' RD(T23,F11.6) @TZero '|'40 SERD(T42,F10.8) ' Wald'. 
         END IF.

*        Attributable / Preventable fraction in exposed.
         DO IF (A1=0).
            PRINT /'  Prev. frac. exp. |' PFe(T23,F11.6) '|'40.
         ELSE IF (A0=0).
            PRINT /'  Attr. frac. exp. |' AFe(T23,F11.6) '|'40.
         ELSE IF (RR<1 AND @SE=0).
            PRINT /'  Prev. frac. exp. |' PFe(T23,F11.6) @TZero(A1) '|'40 lbPFe(T41,F12.6) ubPFe(T53,F12.6).
         ELSE IF (RR<1 AND @SE=1).
            PRINT /'  Prev. frac. exp. |' PFe(T23,F11.6) @TZero(A1) '|'40 .
         ELSE IF (RR>=1 AND @SE=0).
            PRINT /'  Attr. frac. exp. |' AFe(T23,F11.6) @TZero(A1) '|'40 lbAFe(T41,F12.6) ubAFe(T53,F12.6).
         ELSE IF (RR>=1 AND @SE=1).
            PRINT /'  Attr. frac. exp. |' AFe(T23,F11.6) @TZero(A1) '|'40 .
         END IF.  
         PRINT  /'-------------------+-------------------+---------------------------------'.
         
*        Risk difference in the population.
         PRINT  /'Prop. exposed pop. |' Pe(T22,F7.6) !QUOTE(!PeText) '|'40. 
         DO IF (@SE=0).
            PRINT  /'   Risk diff. pop. |' RDp(T23,F11.6) @TZero '|'40 lbRDp(T41,F12.6) ubRDp(T53,F12.6).
         ELSE IF (@SE=1 AND @Pe=0).
            PRINT  /'   Risk diff. pop. |' RDp(T23,F11.6) @TZero '|'40 SERDp(T42,F10.8).
         ELSE IF (@SE=1 AND @Pe=1).
            PRINT  /'   Risk diff. pop. |' RDp(T23,F11.6) @TZero '|'40.
         END IF.

*        Attributable / Preventable fraction in population.
         DO IF (A1=0).
            PRINT /'  Prev. frac. pop. |' PFp(T23,F11.6)'|'40.
         ELSE IF (A0=0).
            PRINT /'  Attr. frac. pop. |' AFp(T23,F11.6)'|'40. 
         ELSE IF (RR<1 AND @SE=0).
            PRINT /'  Prev. frac. pop. |' PFp(T23,F11.6) @TZero(A1) '|'40 lbPFp(T41,F12.6) ubPFp(T53,F12.6).
         ELSE IF (RR<1 AND @SE=1).
            PRINT /'  Prev. frac. pop. |' PFp(T23,F11.6) @TZero(A1) '|'40 .
         ELSE IF (RR>=1 AND @SE=0).
            PRINT /'  Attr. frac. pop. |' AFp(T23,F11.6) @TZero(A1) '|'40 lbAFp(T41,F12.6) ubAFp(T53,F12.6).
         ELSE IF (RR>=1 AND @SE=1).
            PRINT /'  Attr. frac. pop. |' AFp(T23,F11.6) @TZero(A1) '|'40 .
         END IF.
         PRINT  /'-------------------+-------------------+---------------------------------'.

*        Risk Ratio.
         COMPUTE iRR=  1/RR.
         COMPUTE ilbRR=1/ubRR.
         COMPUTE iubRR=1/lbRR.
         DO IF (A0=0 OR RR=0).
            PRINT /'   Risk ratio (RR) |' RR (T23,F11.4) '|'40. 
         ELSE IF (@SE=0 AND RR>=1000).
            PRINT /'   Risk ratio (RR) |' RR (T23,F11.1) @TZero(A1) '|'40 lbRR (T41,F12.1) ubRR (T53,F12.1).
         ELSE IF (@SE=0 AND RR<1000 AND RR>=1).
            PRINT /'   Risk ratio (RR) |' RR (T23,F11.4) @TZero(A1) '|'40 lbRR (T41,F12.4) ubRR (T53,F12.4).
         ELSE IF (@SE=0 AND RR<1 AND iRR>=1000).
            PRINT /'   Risk ratio (RR) |' RR (T23,F11.4) @TZero(A1) '|'40 lbRR (T41,F12.4) ubRR  (T53,F12.4).
            PRINT /'        reciprocal |' iRR(T23,F11.1) @TZero(A1) '|'40 ilbRR(T41,F12.1) iubRR (T53,F12.1). 
         ELSE IF (@SE=0 AND RR<1 AND iRR<1000).
            PRINT /'   Risk ratio (RR) |' RR (T23,F11.4) @TZero(A1) '|'40 lbRR (T41,F12.4) ubRR  (T53,F12.4).
            PRINT /'        reciprocal |' iRR(T23,F11.4) @TZero(A1) '|'40 ilbRR(T41,F12.4) iubRR (T53,F12.4).    
         ELSE IF (@SE=1 AND RR>=1000).
            PRINT /'   Risk ratio (RR) |' RR (T23,F11.1) @TZero(A1) '|'40 SElnRR (T42,F10.8) '***'.
         ELSE IF (@SE=1 AND RR<1000 AND RR>=1).
            PRINT /'   Risk ratio (RR) |' RR (T23,F11.4) @TZero(A1) '|'40 SElnRR (T42,F10.8) '***'.
         ELSE IF (@SE=1 AND RR<1 AND iRR>=1000).
            PRINT /'   Risk ratio (RR) |' RR (T23,F11.4) @TZero(A1) '|'40 SElnRR (T42,F10.8) '***'.
            PRINT /'        reciprocal |' iRR(T23,F11.1) @TZero(A1) '|'40. 
         ELSE IF (@SE=1 AND RR<1 AND iRR<1000).
            PRINT /'   Risk ratio (RR) |' RR (T23,F11.4) @TZero(A1) '|'40 SElnRR (T42,F10.8) '***'.
            PRINT /'        reciprocal |' iRR(T23,F11.4) @TZero(A1) '|'40.
         END IF.

*        Odds Ratio.
         COMPUTE iOR=  1/@OR.
         COMPUTE ilbOR=1/ubOR.
         COMPUTE iubOR=1/lbOR.
         DO IF (A0=0 OR B1=0 OR @OR=0).
            PRINT /'   Odds ratio (OR) |' @OR (T23,F11.4) '|'40. 
         ELSE IF (@SE=0 AND @OR>=1000).
            PRINT /'   Odds ratio (OR) |' @OR (T23,F11.1) @TZero(A1) '|'40 lbOR (T41,F12.1) ubOR (T53,F12.1).
         ELSE IF (@SE=0 AND @OR<1000 AND @OR>=1).
            PRINT /'   Odds ratio (OR) |' @OR (T23,F11.4) @TZero(A1) '|'40 lbOR (T41,F12.4) ubOR (T53,F12.4).
         ELSE IF (@SE=0 AND @OR<1 AND iOR>=1000).
            PRINT /'   Odds ratio (OR) |' @OR (T23,F11.4) @TZero(A1) '|'40 lbOR (T41,F12.4) ubOR  (T53,F12.4).
            PRINT /'        reciprocal |' iOR(T23,F11.1) @TZero(A1) '|'40 ilbOR(T41,F12.1) iubOR (T53,F12.1). 
         ELSE IF (@SE=0 AND @OR<1 AND iOR<1000).
            PRINT /'   Odds ratio (OR) |' @OR (T23,F11.4) @TZero(A1) '|'40 lbOR (T41,F12.4) ubOR  (T53,F12.4).
            PRINT /'        reciprocal |' iOR(T23,F11.4) @TZero(A1) '|'40 ilbOR(T41,F12.4) iubOR (T53,F12.4).    
         ELSE IF (@SE=1 AND @OR>=1000).
            PRINT /'   Odds ratio (OR) |' @OR (T23,F11.1) @TZero(A1) '|'40 SElnOR (T42,F10.8) '***'.
         ELSE IF (@SE=1 AND @OR<1000 AND @OR>=1).
            PRINT /'   Odds ratio (OR) |' @OR (T23,F11.4) @TZero(A1) '|'40 SElnOR (T42,F10.8) '***'.
         ELSE IF (@SE=1 AND @OR<1 AND iOR>=1000).
            PRINT /'   Odds ratio (OR) |' @OR (T23,F11.4) @TZero(A1) '|'40 SElnOR (T42,F10.8) '***'.
            PRINT /'        reciprocal |' iOR(T23,F11.1) @TZero(A1) '|'40. 
         ELSE IF (@SE=1 AND @OR<1 AND iOR<1000).
            PRINT /'   Odds ratio (OR) |' @OR (T23,F11.4) @TZero(A1) '|'40 SElnOR (T42,F10.8) '***'.
            PRINT /'        reciprocal |' iOR(T23,F11.4) @TZero(A1) '|'40.
         END IF.
         PRINT  /'-------------------+-------------------+---------------------------------'.

*        Mantel-Haenszel Chi test.
         STRING @Chi(A2).
         COMPUTE @Chi='  '.
         IF (@WarnCHI=1) @Chi='**'.
         PRINT /'Mantel-Haenszel Chi|' Chi (T23,F11.4) @Chi (A2) '|'40 'P = '44 p(F6.5) ' (Association)'.
         PRINT /'          Corrected|' ChiC(T23,F11.4) '|'40 'P = '44 pC(F6.5).
         PRINT /'-------------------+-------------------+---------------------------------'.

*        Print notes and warnings.
         DO IF (@SE=0).
            PRINT /'Recommended CI'.
         END IF.
         DO IF (@WARNDEC=1).
            PRINT /'(.)WARNING: Number of cases with decimal values'.
            PRINT /'            The values are printed rounded.'.
         END IF.
         DO IF (@WARNZERO=1).
            DO IF (@ZERO=1).
               PRINT /'(*)Computed with a constant continuity correction (k=0.5)'.
            ELSE IF (@ZERO=2).
               PRINT /'(*)Computed with a proportional continuity correction'.
            ELSE IF (@ZERO=3).
               PRINT /'(*)Computed with a reciprocal continuity correction'.
            END IF.
            PRINT /'   Exact inference is recommended'.
         END IF.
         DO IF (@WARNCHI=1).
            PRINT /'(**)WARNING: Small samples for Association Chi-Square'.
         END IF.
         DO IF (@SE=1).
            PRINT/'(***)SE of natural logarithm of ratio statistic'.
         END IF.
         DO IF (@WarnCIA=1 AND @SE=0).
            PRINT /'WARNING: Asymptotic CI of Risk is out of range'.
         END IF.
      END IF.

*     Restore original dataset and close temporary dataset @DATA.
      DATASET ACTIVATE @original.
      DATASET CLOSE @9675DATA.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
