PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !MCOR V2008.03.10 loaded.'
         /'Execute !MCOR HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !MCOR ( PP=!CHAREND('/') 
              /AA=!CHAREND('/')  
              /PA=!CHAREND('/')
              /AP=!CHAREND('/') 
              /CL=!CHAREND('/')!DEFAULT('95')
             /NST=!CHAREND('/')
            /HELP=!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2008.03.10').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
  PRINT //'Macro !MCOR V' !VERSION ' (c)JM.Domenech'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*  Print HELP.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* MATCHED COHORT RISK: Risk and impact measures                              *'
            /'* Created 1999.10.13 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech                                                            *'
            /'* Programmers: A.Bonillo & R.Sesma                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM. Macro !MCOR for SPSS Statistics.                              *'
            /'*    Matched Cohort Risk: Risk and impact measures [computer program].       *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* !MCOR PP= Cases presents in UnExposed and Exposed   (PP >= 0)              *'
            /'*      /PA= Cases presents in UnExposed only          (PA >= 0)              *'
            /'*      /AP= Cases presents in Exposed only            (AP >= 0)              *'
            /'*      /AA= Cases absents  in UnExposed and Exposed   (AA >= 0)              *'
            /'*   [ /CL]= Confidence level(%); by default: 95       (50 <= CL < 100)       *'
            /'*         = SE  for printing Standard Error instead of Confidence Interval   *'
            /'*   [/NST]= Name of the study (Label)                                        *'
            /'*   [/HELP] Print Macro call arguments and Samples of calls                  *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
            /'*                                            +--------+-----------------+    *'
            /'*                                            |        |    UnExposed    |    *'
            /'*                                            |Exposed |NonCases| Cases  |    *'
            /'*                                            +--------+--------+--------+    *'
            /'* Samples of calls:                          |   Cases|   AP   |   PP   |    *'
            /'* !MCOR HELP.                                +--------+--------+--------+    *'
            /'* !MCOR PP=30 /PA=10 /AA=210 /AP=50          |NonCases|   AA   |   PA   |    *'
            /'*      /NST="Name of the Study" /CL=95.      +--------+--------+--------+    *'
            /'******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Testing the parameters.
   !IF (!PP=!NULL !or !AA=!NULL !or !PA=!NULL !or !AP=!NULL) !THEN.
      PRINT /'ERROR: Missing parameter'.
   !ELSE.
      COMPUTE #ERROR=0.
      COMPUTE #PP=$SYSMIS.
      COMPUTE #AP=$SYSMIS.
      COMPUTE #PA=$SYSMIS.
      COMPUTE #AA=$SYSMIS.
      COMPUTE #CL=$SYSMIS.
      COMPUTE #PP=!PP.
      COMPUTE #AP=!AP.
      COMPUTE #PA=!PA.
      COMPUTE #AA=!AA.
      
*     Test parameters PP,AP,PA,AA,CL.
      DO IF (SYSMIS(#PP) OR SYSMIS(#AP) OR SYSMIS(#PA) OR SYSMIS(#AA)).
         COMPUTE #ERROR=1.
      ELSE.
         IF (#PP<0 OR #AP<0 OR #PA<0 OR #AA<0 OR #CL<=50 OR #CL>=100) #ERROR=1.
      END IF.

*     Test parameter CL.
      COMPUTE #SE=0.             /*SE=0 compute and show CI; SE=1 compute and show Standard Error.
      !IF (!UPCASE(!CL)='SE') !THEN.
         COMPUTE #SE=1.
         !LET !TITLE = "Asymptotic Standard Error".
         COMPUTE #CL = 95.
      !ELSE.
         !LET !TITLE = !CONCAT(!CL,'% Confidence Interval').
         COMPUTE #CL=!CL.
         DO IF (SYSMIS(#CL)).
            COMPUTE #ERROR=1.
         ELSE.
            IF (#CL<=50 OR #CL>=100) #ERROR=1.
         END IF.
      !IFEND.

      DO IF (#ERROR=1).
         PRINT /'ERROR: Parameter(s) with wrong values'.
      ELSE.
*        Correct parameters.

*        Check for decimal parameters.
         COMPUTE #WARNDEC=0.
         IF (MOD(#PP,1)<>0 OR MOD(#AA,1)<>0 OR MOD(#AP,1)<>0 OR MOD(#PA,1)<>0) #WARNDEC=1.
         STRING #TDec(A1).
         COMPUTE #TDec=' '.
         IF (#WARNDEC=1) #TDec='.'.

*        Sum of rows, columns, Z.
         COMPUTE #NCnE=#AA+#AP.
         COMPUTE #CnE=#PP+#PA.
         COMPUTE #CE =#PP+#AP.
         COMPUTE #NCE=#PA+#AA.
         COMPUTE #N=#PP+#AP+#AA+#PA.
         COMPUTE #P=(#CL+100)/200.
         COMPUTE #Z=IDF.NORMAL(#P,0,1).

*********Risk difference.
         COMPUTE #RD=(#AP-#PA)/#N.
*        Exact bounds.
         COMPUTE #lPI=(#AP)/(#AP+(#PA+1)*IDF.F(#P,2*(#PA+1),2*#AP) ).
         COMPUTE #uPI=(#AP+1)/((#AP+1)+#PA/IDF.F(#P,2*(#AP+1),2*#PA) ).
         COMPUTE #lbRd=(2*#lPI-1)*(#AP+#PA)/#N.
         COMPUTE #ubRd=(2*#uPI-1)*(#AP+#PA)/#N.
*        Asymptotic bounds.
         COMPUTE #SERD = SQRT(#AP+#PA-(#AP-#PA)**2/#N)/#N.
         COMPUTE #LbRdA= #RD - #Z*#SERD.
         COMPUTE #UbRdA= #RD + #Z*#SERD.
*        Newcombe-Wilson bounds.
*        #Pe bounds.
         COMPUTE #Pe= #CE/#N.
         COMPUTE #WA1 = 2*#CE + #Z**2.
         COMPUTE #WB1 = #Z * SQRT(#Z**2 + 4*#CE*(#N-#CE)/#N).
         COMPUTE #WC1 = 2*(#N + #Z**2).
         COMPUTE #lbW1= (#WA1-#WB1)/#WC1.
         COMPUTE #ubW1= (#WA1+#WB1)/#WC1.
*        #Pu bounds.
         COMPUTE #Pu= #CnE/#N.
         COMPUTE #WA2 = 2*#CnE + #Z**2.
         COMPUTE #WB2 = #z * SQRT(#Z**2 + 4*#CnE*(#N-#CnE)/#N).
         COMPUTE #WC2 = 2*(#N + #Z**2).
         COMPUTE #lbW2= (#WA2-#WB2)/#WC2.
         COMPUTE #ubW2= (#WA2+#WB2)/#WC2.
*        Coeficient #Fi.
         COMPUTE #WA = #NCnE * #CnE * #CE * #NCE.
         DO IF (#WA = 0).
            COMPUTE #FI = 0.
         ELSE.
            COMPUTE #WB = #PP*#AA - #AP*#PA.
            IF (#WB > #N/2) #WC = #WB - #N/2.
            IF (#WB >= 0 AND #WB <= #N/2) #WC = 0.
            IF (#WB < 0) #WC = #WB.
            COMPUTE #FI = #WC / SQRT(#WA).
         END IF.
*        Bounds.
         COMPUTE #LbRdW= #RD - SQRT((#Pe-#lbW1)**2 - 2*#FI*(#Pe-#lbW1)*(#ubW2-#Pu) + (#ubW2-#Pu)**2 ).
         COMPUTE #UbRdW= #RD + SQRT((#Pu-#lbW2)**2 - 2*#FI*(#Pu-#lbW2)*(#ubW1-#Pe) + (#ubW1-#Pe)**2 ).

*********Risk Ratio.
         COMPUTE #RR=#CE/#CnE.
         COMPUTE #SElnRR=SQRT((#AP+#PA)/(#CE*#CnE)).
         COMPUTE #lbRR=#RR*EXP((-1)*#Z*#SElnRR).
         COMPUTE #ubRR=#RR*EXP(#Z*#SElnRR).

*        Attributable fraction in exposed.
         COMPUTE #AFe=1.
         COMPUTE #AFe=1 - 1/#RR.
         COMPUTE #lbAFe= 1 - 1/#lbRR.
         COMPUTE #ubAFe= 1 - 1/#UbRR.
*        Preventable fraction in exposed.
         COMPUTE #PFe=1.
         COMPUTE #PFe=1 - #RR.
         COMPUTE #lbPFe= 1 - #UbRR.
         COMPUTE #ubPFe= 1 - #LbRR.

*********McNemar test.  
         COMPUTE #Chi= SQRT((#AP-#PA)**2/(#AP+#PA)).
*        McNemar (exact) Test.
         DO IF (MOD(#AP,1)=0 AND MOD(#PA,1)=0).
            COMPUTE #APA=MIN(#AP,#PA).
            COMPUTE #s2=2*CDF.BINOM(#APA,#PA+#AP,0.5).
         ELSE.
*           Decimal parameters: P value computed by linear interpolation.
            DO IF (#AP < #PA).
               COMPUTE #AP1= TRUNC(#AP).
               COMPUTE #PA1= TRUNC(#PA) + (MOD(#PA,1)<>0).
               COMPUTE #AP0= TRUNC(#AP) + (MOD(#AP,1)<>0).
               COMPUTE #PA0= TRUNC(#PA).
            ELSE IF (#AP > #PA).
               COMPUTE #AP1= TRUNC(#AP) + (MOD(#AP,1)<>0).
               COMPUTE #PA1= TRUNC(#PA).
               COMPUTE #AP0= TRUNC(#AP).
               COMPUTE #PA0= TRUNC(#PA) + (MOD(#PA,1)<>0).
               COMPUTE #s21=2*CDF.BINOM(#PA1,#PA1+#AP1,0.5).
            END IF.
            COMPUTE #APA1=MIN(#AP1,#PA1).
            COMPUTE #APA0=MIN(#AP0,#PA0).
            COMPUTE #s21=2*CDF.BINOM(#APA1,#PA1+#AP1,0.5).
            COMPUTE #s20=2*CDF.BINOM(#APA0,#PA0+#AP0,0.5).
            IF(#PA1 EQ #AP1) #s21=1.
            IF(#PA0 EQ #AP0) #s20=1.
            COMPUTE #K12= ABS(#AP1-#AP0) + ABS(#PA1-#PA0).
            COMPUTE #s2= ((#K12-MOD(#AP,1)-MOD(#PA,1))*#s21 + ( MOD(#AP,1)+MOD(#PA,1) )*#s20)/#K12 .
         END IF.
         IF(#PA EQ #AP) #s2=1.

*        Print results.
         PRINT  /'MATCHED COHORT RISK'.
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.

         PRINT //'                  |     UnExposed     |'.
         PRINT  /'                  |NonCases |  Cases  |   TOTAL  Proportion'.
         PRINT  /'------------------+---------+---------+---------------------'.
         PRINT  /' Exposed    Cases |    '#AP(T21,F7) #TDec(A1) '|'29 #PP(T30,F7) #TDec(A1) '|'39 #CE(T40,F8) #TDec(A1) #PE(F12.6).
         PRINT  /'         NonCases |    '#AA(T21,F7) #TDec(A1) '|'29 #PA(T30,F7) #TDec(A1) '|'39 #NCE(T40,F8)#TDec(A1).
         PRINT  /'------------------+---------+---------+---------------------'.
         PRINT  /'            TOTAL |'#NCnE(T20,F8) #TDec(A1) '|'29 #CnE(T30,F7) #TDec(A1) '|'39 #N(T40,F8) #TDec(A1).
         PRINT  /'       Proportion |'                 '|'29 #Pu(T30,F8.6)'|'39.
         
         PRINT //'------------------+-------------------+-----------------------------------'.
         PRINT  /'                  |      Estimate     | '!QUOTE(!TITLE).
         PRINT  /'------------------+-------------------+-----------------------------------'.

*        Print Risk Ratio.
         DO IF (#SE=0).
            PRINT  /'  Risk ratio (RR) |' #RR (T23,F11.4) '|'39 #lbRR(T41,F11.4) #UbRR(T53,F11.4). 
         ELSE.
            PRINT  /'  Risk ratio (RR) |' #RR (T23,F11.4) '|'39 #SElnRR(T41,F10.8) '*'. 
         END IF.
         DO IF (#RR<1).
            COMPUTE #IRR=1/#RR.
            COMPUTE #IlbRR=1/#ubRR.
            COMPUTE #IubRR=1/#lbRR.
            DO IF (#SE=0).
               PRINT/'       reciprocal |' #IRR(T23,F11.4) '|'39 #IlbRR (T41,F11.4) #IUbRR(T53,F11.4).
            ELSE.
               PRINT/'       reciprocal |' #IRR(T23,F11.4) '|'39 .
            END IF.
         END IF.
         PRINT  /           '|'19            '|'39. 

*        Print Risk difference.
         DO IF (#SE=0).
            PRINT  /'  Risk difference |' #RD(T23,F11.6) '|'39 #lbRD(T41,F11.6)   #ubRD(T53,F11.6) ' Exact'. 
            PRINT  /                  '|'19              '|'39 #lbRDW(T41,F11.6)  #ubRDW(T53,F11.6)' Newcombe'. 
            PRINT  /                  '|'19              '|'39 #lbRDA(T41,F11.6)  #ubRDA(T53,F11.6)' Asymptotic'. 
         ELSE.
            PRINT  /'  Risk difference |' #RD(T23,F11.6) '|'39 #SERD(T41,F10.8). 
         END IF.

*        Print Attributable / Preventable fraction in exposed.
         DO IF (#RR<1).
            DO IF (#SE=0).
               PRINT/' Prev. frac. exp. |'#PFe(T23,F11.6) '|'39 #lbPFe (T41,F11.4) #ubPFe(T53,F11.4). 
            ELSE.
               PRINT/' Prev. frac. exp. |'#PFe(T23,F11.6) '|'39 . 
            END IF.
         ELSE.
            DO IF (#SE=0).
               PRINT/' Attr. frac. exp. |'#AFe(T23,F11.6) '|'39 #lbAFe (T41,F11.4) #ubAFe(T53,F11.4). 
            ELSE.
               PRINT/' Attr. frac. exp. |'#AFe(T23,F11.6) '|'39 . 
            END IF. 
         END IF.

         STRING #TChi(A2).
         COMPUTE #TChi = '  '.
         IF ((#AP+#PA)<10) #TChi= '**'.
         PRINT  /'------------------+-------------------+-----------------------------------'.
         PRINT  /'     McNemar  Chi |' #Chi(T23,F11.4) #TChi '|'39 'p ='43 #s2(F7.5) ' (Exact)'.
         PRINT  /'------------------+-------------------+-----------------------------------'.

         DO IF (#WARNDEC=1).
            PRINT / '(.)WARNING: Number of cases with decimal values.'.
            PRINT / '            The values are printed rounded.'.
         END IF.
         DO IF (#SE=0).
            PRINT /'Recommended CI'.
         ELSE.
            PRINT /'(*) SE of natural logarithm of ratio statistic'.
         END IF.
         DO IF ((#AP+#PA)<10).
            PRINT /'(**)WARNING: Small samples for McNemar matched-pair test'.
         END IF.
      END IF.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.

