PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !SCOI V2012.03.20 loaded.'
         /'Execute !SCOI HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !SCOI (STRATUM=!CHAREND('/')
            /A1      =!CHAREND('/') /T1 =!CHAREND('/')
            /A0      =!CHAREND('/') /T0 =!CHAREND('/')
            /METHOD  =!DEFAULT('MH') !CHAREND('/')
            /CL      =!DEFAULT('95') !CHAREND('/')
            /NST     =!CHAREND('/')
            /HELP    =!CHAREND('/') !DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2012.03.20').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
  PRINT //'Macro !SCOI V' !VERSION ' (c)JM.Domenech'.
END IF.
TEMPORARY.
N 1.
COMPUTE #ERROR=0.
!IF (!HELP<>1) !THEN.
*Impresin de la documentacin.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* STRATIFIED COHORT STUDY (RATE): Standardized and pooled estimates          *'
            /'* Created 1999.10.22 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech                                                            *'
            /'* Programmers: A.Bonillo & R.Sesma                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM. Macro !SCOI for SPSS Statistics.                              *'
            /'*    Stratified Cohort Study (Rate): Standardized and pooled estimates       *'
            /'*    [computer program].                                                     *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* !SCOI STRATUM= List of Stratum labels(up to 8 characters)  (in SPSS format)*'
            /'*      /A1     = List of cases Exposed           (A1i > 0)                   *'
            /'*      /T1     = List of Person-time Exposed     (T1i >= A1i and > 0)        *'
            /'*      /A0     = List of cases UnExposed         (A0i > 0)                   *'
            /'*      /T0     = List of Person-time UnExposed   (T0i >= A0i and > 0)        *'
            /'*     [/METHOD]= Method of weighting: MH Mantel-Haenszel;  by default MH     *'
            /'*                                     IV Invers of Variance                  *'
            /'*                                     IS Internal Standardization            *'
            /'*                                     ES External Standardization            *'
            /'*     [ /CL]   = Confidence level(%); by default:95 (50 <= CL < 100)         *'
            /'*              = SE  for printing SE(lnIR) instead of Confidence Interval    *'
            /'*    [ /NST]   = Name of the study (Label)                                   *'
            /'*    [/HELP]     Print Macro call arguments and Samples of calls             *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in square brackets [ ] are optional              *'
            /'*                                                                            *'
            /'* Samples of calls:           +-----------------+-----+----+-----+----+-----+*'
            /'* !SCOI HELP.                 |                 |Str 1| .. |Str i| .. |Str I|*'
            /'* !SCOI STRATUM="<64"  ">=65" +-----------------+-----+----+-----+----+-----+*'
            /'*      /A1     =  14     76   |Exposed    Cases | A11 | .. | A1i | .. | A1I |*'
            /'*      /T1     =1516    949   |     Person-time | T11 | .. | T1i | .. | T1I |*'
            /'*      /A0     =  10    121   +-----------------+-----+----+-----+----+-----+*'
            /'*      /T0     =1701.3 2245.7 |UnExposed  Cases | A01 | .. | A0i | .. | A0I |*'
            /'*      /METHOD = IV /CL = 90  |     Person-time | T01 | .. | T0i | .. | T0I |*'
            /'*      /NST="Study Name".     +-----------------+-----+----+-----+----+-----+*'
            /'******************************************************************************'.
   END IF.
   EXECUTE.
   COMPUTE #ERROR=1.
!ELSE.
*  Testing the parameters.
   !IF (!A1=!NULL !or !T1=!NULL !or !A0=!NULL !or !T0=!NULL !or !STRATUM=!NULL) !THEN 
      PRINT /'ERROR: Missing parameter'.
   !ELSE.
      COMPUTE #ERROR=0.
      COMPUTE #N=0.

*     Test parameters T1,T0.
      DO REPEAT T1=!T1.
         DO IF (T1<=0).
            COMPUTE #ERROR=1.
         END IF.
      END REPEAT.
      DO REPEAT T0=!T0.
         DO IF (T0<=0).
            COMPUTE #ERROR=1.
         END IF.
      END REPEAT.
      
*     Test parameters A1 & A0.
      DO REPEAT A1=!A1 /A0=!A0 /T1=!T1 /T0=!T0. 
         COMPUTE #N=#N+1.                  
         DO IF (A1<=0 or A0<=0).
            COMPUTE #ERROR=1.
         ELSE IF (T1<A1 or T0<A0).
            COMPUTE #ERROR=1.
         END IF.
      END REPEAT.
   
*     Test parameter CL.
      COMPUTE #SE=0. 
      !IF (!UPCASE(!CL)='SE') !THEN.
         COMPUTE #SE=1.
         !LET !TITLE = "   SE(lnIR)        |    ".
         COMPUTE #CL = 95.
      !ELSE.
         !LET !TITLE = !CONCAT(!CL,'% Conf. Interval |    ').
         DO IF(!CL<50 or !CL>=100).
            COMPUTE #ERROR=1.
         ELSE.
            COMPUTE #CL = !CL.
         END IF.
      !IFEND.
   
*     Count of the numbers of elements.
      !LET !SBLANK=!NULL.
      !DO !I !IN (!STRATUM).
         !LET !SBLANK=!CONCAT(!SBLANK,' ').
      !DOEND.
      !LET !COUNT=!LENGTH(!SBLANK).         
      DO IF (#N<>!COUNT).
         COMPUTE #ERROR=1.
      END IF.

*     Test parameter METHOD.
      !LET !METHODU = !UPCASE(!METHOD).
      !IF (!METHODU<>MH !AND !METHODU<>IV !AND !METHODU<>IS !AND !METHODU<>ES) !THEN.
         COMPUTE #ERROR=1.
      !IFEND.

      DO IF (#ERROR=1).
         PRINT /'ERROR: Parameter(s) with wrong values'.
      ELSE .
*        Correct parameters.
         COMPUTE #N=0.
         COMPUTE #Z=IDF.NORMAL((#CL+100)/200,0,1).
                  
*        Enessims parameters.
         !LET !STRn=!CONCAT('#STR',!COUNT).
         !LET !STRrn=!CONCAT('#STRr',!COUNT).
         !LET !IRn=!CONCAT('#IR',!COUNT). 
         !LET !VIRn=!CONCAT('#VIR',!COUNT). 
         !LET !LbIRn=!CONCAT('#LbIR',!COUNT).
         !LET !UbIRn=!CONCAT('#UbIR',!COUNT).
         !LET !Wn=!CONCAT('#W',!COUNT). 
         !LET !CHIn=!CONCAT('#CHI',!COUNT). 
         !LET !CHIcn=!CONCAT('#CHIc',!COUNT). 
         !LET !Pn=!CONCAT('#P',!COUNT).
         !LET !Pcn=!CONCAT('#Pc',!COUNT).
         
*        Assignation of variables to print, sum of cases*level and sum of level*total.
         NUMERIC #IR1 to !IRN 
                 #CHI1 to !CHIn
                 #CHIc1 to !CHIcn
                 #P1 to !Pn
                 #Pc1 to !Pcn
                 #VIR1 to !VIRN
                 #LbIR1 to !LbIRn
                 #UbIR1 to !UbIRn
                 #W1 to !Wn.
         STRING  #STR1 to !STRn (A8)
                 #STRr1 to !STRrn (A8).
         
         DO REPEAT STRATUM=!STRATUM
                  /CHIi = #CHI1 to !CHIn 
                  /CHIci= #CHIc1 to !CHIcn 
                  /STR  = #STR1 to !STRn 
                  /STRr = #STRr1 to !STRrn 
                  /A1=!A1 /T1=!T1 /A0=!A0 /T0=!T0 
                  /Pi   = #P1 to !Pn  
                  /Pci  = #Pc1 to !Pcn
                  /IRi  = #IR1 to !IRn 
                  /VIRi = #VIR1 to !VIRN 
                  /LbIRi= #LbIR1 to !LbIRn 
                  /UbIRi= #UbIR1 to !UbIRn 
                  /Wi   = #W1 to !Wn.
         
            COMPUTE STR = STRATUM.
            COMPUTE STRr= LPAD(RTRIM(STR),8).
*           Sum of cases by stratum.
            COMPUTE #A1 = #A1+ A1.
            COMPUTE #A0 = #A0+ A0.
            COMPUTE #T1 = #T1+ T1.
            COMPUTE #T0 = #T0+ T0.
            COMPUTE #M1i= A1 + A0.
            COMPUTE #M1 = #M1+#M1i.
            COMPUTE #Ti = T1 + T0.
            COMPUTE #T  = #T + #Ti.
            
*           IR, variance and bounds for each stratum.
            COMPUTE IRi = (A1/T1)/(A0/T0).
            COMPUTE VIRi= 1/A1 + 1/A0.
            COMPUTE LbIRi= IRi*EXP((-1)*#z*SQRT(VIRi)).
            COMPUTE UbIRi= IRi*EXP(#z*SQRT(VIRi)).
            
*           Mantel-Haenszel combined.
            IF (!QUOTE(!METHODU) = 'MH') Wi = A0*T1/#Ti.       /*Weight.
            COMPUTE #NIRMH = #NIRMH + (A1*T0)/#Ti.             /*Numerator.
            COMPUTE #DIRMH = #DIRMH + A0*T1/#Ti.               /*Denominator.
            COMPUTE #NVIRMH= #NVIRMH + (A1+A0)*T0*T1/#Ti**2 - A1*A0/#Ti.   /*Numerator of variance.
            
*           Inverse of variance.
            IF (!QUOTE(!METHODU) = 'IV') Wi = 1/VIRi.    /*Weight.
            COMPUTE #NIRIV = #NIRIV + LN(IRi)/VIRi.      /*Numerator.
            COMPUTE #DIRIV = #DIRIV + (1/VIRi).          /*Denominator.
            
*           Internal standardization.
            IF (!QUOTE(!METHODU) = 'IS') Wi = T1.        /*Weight.
            COMPUTE #IRwID= #IRwID + T1*A0/T0.           /*Denominator.
            COMPUTE #VIRwIN= #VIRwIN + (A1**2)*VIRi .    /*Numerator.
            
*           External standardization.
            IF (!QUOTE(!METHODU) = 'ES') Wi = T0.              /*Weight.
            COMPUTE #IRwEN= #IRwEN + T0*A1/T1.                 /*Denominator.
            COMPUTE #VIRwEN= #VIRwEN + ((T0*A1/T1)**2)*VIRi .  /*Numerator.
            
*           MH Chi-Square by Stratum.
            COMPUTE #X1 = ABS(A1*#Ti-T1*#M1i).
            COMPUTE CHIi= (#X1**2)/(#M1i*T1*T0) .
            COMPUTE CHIci=(#X1-#Ti/2)**2/(#M1i*T1*T0) .
            IF (#X1 < #Ti/2) CHIci=0.
            COMPUTE Pi =(1- CDF.CHISQ(ABS(CHIi),1)).
            COMPUTE Pci=(1- CDF.CHISQ(ABS(CHIci),1)).
            
*           MH Chi-Square POOLED.
            COMPUTE #ExMH= #ExMH + T1*#M1i/#Ti.
            COMPUTE #VMH = #VMH + T1*T0*#M1i/(#Ti**2).
         END REPEAT.
         
*        MH Chi-Squared: crude table (GLOBAL).
         COMPUTE #X1 = ABS(#A1*#T-#T1*#M1).
         COMPUTE #CHI2g =(#X1**2)/(#M1*#T1*#T0).
         COMPUTE #CHI2gc=(#X1-#T/2)**2/(#M1*#T1*#T0).
         IF (#X1 < #T/2) #CHI2gc=0.
         COMPUTE #PCHIg =(1- CDF.CHISQ(ABS(#CHI2g),1)).
         COMPUTE #PCHIgc=(1- CDF.CHISQ(ABS(#CHI2gc),1)).
         
*        MH Chi-Squared: POOLED.
         COMPUTE #ChiMH=(#A1-#ExMH)**2/#VMH.
         COMPUTE #ChiMHc=(ABS(#A1-#ExMH)-0.5)**2/(#VMH).
         IF (ABS(#A1-#ExMH)<0.5) #ChiMHc=0.
         COMPUTE #PChiMH=(1- CDF.CHISQ(ABS(#ChiMH),1)).
         COMPUTE #PChiMHc=(1- CDF.CHISQ(ABS(#ChiMHc),1)).
         
*        Proportions of cases.
         COMPUTE #Ia=#A1/#T1.
         COMPUTE #Ib=#A0/#T0.
         COMPUTE #It=#M1/#T.
         
*        Crude estimation.
         COMPUTE #IRc=$sysmis.
         COMPUTE #IRc=(#A1/#T1)/(#A0/#T0).
         COMPUTE #SEIRc=SQRT(1/#A1 + 1/#A0).
         COMPUTE #LbIRc=EXP(LN(#IRc)-#z*#SEIRc).
         COMPUTE #UbIRc=EXP(LN(#IRc)+#z*#SEIRc).
         
*        Mantel Haenszel.
         COMPUTE #IRMH=$sysmis.
         COMPUTE #IRMH=#NIRMH/#DIRMH.
         COMPUTE #SEIRMH= SQR(#NVIRMH/(#NIRMH*#DIRMH)).
         COMPUTE #LbIRMH= #IRMH*EXP((-1)*#z*#SEIRMH).
         COMPUTE #UbIRMH= #IRMH*EXP(#z*#SEIRMH).
         COMPUTE #PIRMH= 2*(1-CDFNORM(ABS(LN(#IRMH)/#SEIRMH))).
         
*        Inverse of variance.
         COMPUTE #IRIV=$sysmis.
         COMPUTE #IRIV=EXP(#NIRIV/#DIRIV).
         COMPUTE #SEIRIV= 1/SQR(#DIRIV).
         COMPUTE #LbIRIV= #IRIV*EXP((-1)*#z*#SEIRIV).
         COMPUTE #UbIRIV= #IRIV*EXP(#z*#SEIRIV).
         COMPUTE #PIRIV= 2*(1-CDFNORM(ABS(LN(#IRIV)/#SEIRIV))).
         
*        Internal Standarized.
         COMPUTE #IRwI=$sysmis.
         COMPUTE #IRwI=#A1/#IRwID.
         COMPUTE #SEIRwI= SQR(#VIRwIN/#A1**2).
         COMPUTE #LbIRwI=#IRwI*EXP((-1)*#z*#SEIRwI).
         COMPUTE #UbIRwI=#IRwI*EXP(#z*#SEIRwI).
         COMPUTE #PIRwI= 2*(1-CDFNORM(ABS(LN(#IRwI)/#SEIRwI))).
         
*        External Standarized.
         COMPUTE #IRwE=$sysmis.
         COMPUTE #IRwE=#IRwEN/#A0.
         COMPUTE #SEIRwE= SQR(#VIRwEN/(#IRwEN**2)).
         COMPUTE #LbIRwE=#IRwE*EXP((-1)*#z*#SEIRwE).
         COMPUTE #UbIRwE=#IRwE*EXP(#z*#SEIRwE).
         COMPUTE #PIRwE= 2*(1-CDFNORM(ABS(LN(#IRwE)/#SEIRwE))).

*        Change.
         NUMERIC #chMH #chIV #chwI #chwE.
         DO REPEAT IR = #IRMH #IRIV #IRwI #IRwE
                  /ch = #chMH #chIV #chwI #chwE.
            COMPUTE ch = ABS((IR - #IRc)/IR)*100.
         END REPEAT.

*        Chi-square homogeneity (Wald).
         DO REPEAT IRi = #IR1 to !IRn 
                  /VIRi= #VIR1 to !VIRn.            
            DO IF  (!QUOTE(!METHODU) = 'MH').
               COMPUTE #ChiH= #ChiH + (LN(IRi)-LN(#IRMH))**2/VIRi.
            ELSE IF (!QUOTE(!METHODU) = 'IV').
               COMPUTE #ChiH= #ChiH + (LN(IRi)-LN(#IRIV))**2/VIRi.
            ELSE IF (!QUOTE(!METHODU) = 'IS').
               COMPUTE #ChiH= #ChiH + (LN(IRi)-LN(#IRwI))**2/VIRi.
            ELSE IF (!QUOTE(!METHODU) = 'ES').
               COMPUTE #ChiH= #ChiH + (LN(IRi)-LN(#IRwE))**2/VIRi.
            END IF.
         END REPEAT.
         COMPUTE #sp= (1- CDF.CHISQ(ABS(#ChiH),!COUNT-1)).

*        Print results.         
         PRINT  /'STRATIFIED COHORT STUDY (RATE)'.
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.
         
*        Print of stratum's tables.
         PRINT //'STRATUM           | UnExposed |  Exposed  |   TOTAL   |'.
         PRINT  /'==================+===========+===========+===========+============='.         
         STRING #TDec(A1).
         COMPUTE #WARNDEC=0.
         DO REPEAT STR = #STR1 to !STRn 
                  /IRi = #IR1 to !IRn 
                  /VIRi= #VIR1 to !VIRn 
                  /A1=!A1 /A0=!A0 /T1=!T1 /T0=!T0.
            COMPUTE #SDEC=0.
            COMPUTE #TpA1= A1.
            COMPUTE #TpA0= A0.
            COMPUTE #TpT1= T1.
            COMPUTE #TpT0= T0.
            COMPUTE #TpM1= A1+A0.
            COMPUTE #TpN = T0+T1.
            COMPUTE #TpI1= #TpA1/#TpT1.
            COMPUTE #TpI0= #TpA0/#TpT0.
            COMPUTE #TpP = #TpM1/#TpN.
            
            COMPUTE #TDec=' '.   
            IF (MOD(A1,1)<>0 or MOD(A0,1)<>0 or MOD(T1,1)<>0 or MOD(T0,1)<>0) #WARNDEC=1.
            IF (MOD(A1,1)<>0 or MOD(A0,1)<>0 or MOD(T1,1)<>0 or MOD(T0,1)<>0) #TDec='.'.
            COMPUTE #Pe = #TpT1 / #Tpn.
            
            PRINT  /STR(A8) '    Cases |' #TpA0(T22,F8) #TDec '|'31 #TpA1(T34,F8) #TDec '|'43 #TpM1(T46,F8) #TDec '|'55.
            PRINT  /'      Person-time |' #TpT0(T22,F8) #TDec '|'31 #TpT1(T34,F8) #TDec '|'43 #Tpn(T46,F8)  #TDec '| Pe='55 #Pe(T63,F6.4).
            PRINT  /'------------------+-----------+-----------+-----------+'.
            PRINT  /'   Incidence Rate |' #TpI0(T20,F10.8) '|'31 #TpI1(T32,F10.8)'|'43 #TpP(T44,F10.8) '| IR='55 IRi(T60,F9.4).
            PRINT  /'==================+===========+===========+===========+============='.
         END REPEAT.
         
*        Prints: OVERALL.
         COMPUTE #TDec =' '.
         IF (#WARNDEC=1) #TDec='.'.
         COMPUTE #Pe = #T1 / #T.
         PRINT  /'OVERALL     Cases |' #A0(T22,F8) #TDec '|'31 #A1(T34,F8) #TDec '|'43 #M1(T46,F8) #TDec '|'55.
         PRINT  /'      Person-time |' #T0(T22,F8) #TDec '|'31 #T1(T34,F8) #TDec '|'43 #T(T46,F8)  #TDec '| Pe='55 #Pe(T63,F6.4).
         PRINT  /'------------------+-----------+-----------+-----------+'.
         PRINT  /'   Incidence rate |'#Ib(T20,F10.8) '|'31 #Ia(T32,F10.8) '|'43 #It(T44,F10.8) '| IR='55 #IRc(T60,F9.4).
         PRINT  /'==================+===========+===========+===========+============='.

         DO IF (#WARNDEC=1).
            PRINT / '(.)WARNING: Number of Cases or Person-Time with decimal values.'.
            PRINT / '            The values are printed rounded.'.
         END IF.         

         PRINT// '------------------+-----------------------------------+-------------'.
         PRINT / '                  |         IR     '!QUOTE(!TITLE) !QUOTE(!METHODU)' Weight'.
         PRINT / '------------------+-----------------------------------+-------------'.
         
*        Prints: IR+CI or IR+SElnIR for each stratum.
         STRING #STRAT(A7).
         COMPUTE #STRAT='STRATUM'.
         DO REPEAT STRr = #STRr1 to !STRrn
                  /IRi  = #IR1 to !IRn 
                  /VIRi = #VIR1 to !VIRN 
                  /LbIRi= #LbIR1 to !LbIRn 
                  /UbIRi= #UbIR1 to !UbIRn 
                  /Wi   = #W1 to !Wn .
            
            COMPUTE #SElnIR = SQR(VIRi).
            DO IF (#SE=0).
               PRINT /#STRAT(A7) STRr(T10,A8) '|'19 IRi(T21,F10.4) LbIRi(T32,F10.4) UbIRi(T44,F10.4) '|'55 Wi(F13.3).
            ELSE.
               PRINT /#STRAT(A7) STRr(T10,A8) '|'19 IRi(T21,F10.4) #SElnIR(T37,F10.8) '|'55 Wi(F13.3).
            END IF.                  
            DO IF (IRi<1 AND IRi<>0).      /*Inverses of IR.
               COMPUTE #IIRi=1/IRi.
               COMPUTE #IUbIRi=1/LbIRi.
               COMPUTE #ILbIRi=1/UbIRi.
               DO IF (#SE=0).
                  PRINT /'       reciprocal |' #IIRi(T21,F10.4) #ILbIRi(T32,F10.4) #IUbIRi(T44,F10.4) '|'55.
               ELSE.
                  PRINT /'       reciprocal |' #IIRi(T21,F10.4) '|'55.
               END IF.
            END IF.
            COMPUTE #STRAT = '       '.
         END REPEAT.
         PRINT /'------------------+-----------------------------------+-------------'.
         
*        Prints: OVERALL IR+CI or IR+SElnIR.
         STRING #SIG(A13).
         COMPUTE #SIG = ' Sig.  Change'.
         IF (#IRc<1) #SIG = '             '.
         DO IF (#SE=0).
            PRINT /'OVERALL     Crude |' #IRc (T21,F10.4) #LbIRc(T32,F10.4) #UbIRc(T44,F10.4) '|'55 #SIG(A13).
         ELSE.
            PRINT /'OVERALL     Crude |' #IRc (T21,F10.4) #SEIRc(T37,F10.8) '|'55 #SIG(A13).
         END IF.         
         DO IF (#IRc<1).      /*Inverses of IR.
            COMPUTE #IIRc=$sysmis.
            COMPUTE #IIRc=1/#IRc.
            COMPUTE #ILbIRc=1/#UbIRc.
            COMPUTE #IUbIRc=1/#LbIRc.
            DO IF (#SE=0).            
               PRINT /'       reciprocal |' #IIRc (T21,F10.4) #ILbIRc(T32,F10.4) #IUbIRc(T44,F10.4) ' | Sig.  Change'.
            ELSE.
               PRINT /'       reciprocal |' #IIRc (T21,F10.4) '| Sig.  Change'55.
            END IF.
         END IF.
         PRINT /'------------------+-----------------------------------+-------------'.
         
*        Prints: MH combined IR+CI or IR+SElnIR.
         DO IF (#SE=0).
            PRINT /'      MH Combined |' #IRMH (T21,F10.4) #LbIRMH(T32,F10.4) #UbIRMH(T44,F10.4) '|'55 #PIRMH(T56,F6.4) #chMH(T63,PCT6.2).
         ELSE.
            PRINT /'      MH Combined |' #IRMH (T21,F10.4) #SEIRMH(T37,F10.8) '|'55 #PIRMH(T59,F7.5).
         END IF.
         DO IF (#IRMH<1).      /*Inverses of IR.
            COMPUTE #IIRMH=1/#IRMH.
            COMPUTE #IUbIRMH=1/#LbIRMH.
            COMPUTE #ILbIRMH=1/#UbIRMH.
            DO IF (#SE=0).
               PRINT /'       reciprocal |' #IIRMH (T21,F10.4) #ILbIRMH(T32,F10.4) #IUbIRMH(T44,F10.4) '|'55.
            ELSE.
               PRINT /'       reciprocal |' #IIRMH (T21,F10.4) '|'55.
            END IF.
         END IF.
         
*        Prints: Inv of Variance IR+CI or IR+SElnIR.
         DO IF (#SE=0).
            PRINT /' Inv. of Variance |' #IRIV (T21,F10.4) #LbIRIV(T32,F10.4) #UbIRIV(T44,F10.4) '|'55 #PIRIV(T56,F6.4) #chIV(T63,PCT6.2).
         ELSE.
            PRINT /' Inv. of Variance |' #IRIV (T21,F10.4) #SEIRIV(T37,F10.8) '|'55 #PIRIV(T59,F7.5).
         END IF.         
         DO IF (#IRIV<1).      /*Inverses of IR.            
            COMPUTE #IIRIV=1/#IRIV.
            COMPUTE #IUbIRIV=1/#LbIRIV.
            COMPUTE #ILbIRIV=1/#UbIRIV.
            DO IF (#SE=0).
               PRINT /'       reciprocal |' #IIRIV(T21,F10.4) #ILbIRIV(T32,F10.4) #IUbIRIV(T44,F10.4) '|'55.
            ELSE.
               PRINT /'       reciprocal |' #IIRIV(T21,F10.4) '|'55.
            END IF.
         END IF.
         
*        Prints: Internal Std IR+CI or IR+SElnIR.
         DO IF (#SE=0).
            PRINT /'    Internal Std. |' #IRwI (T21,F10.4) #LbIRwI(T32,F10.4) #UbIRwI(T44,F10.4) '|'55 #PIRwI(T56,F6.4) #chwI(T63,PCT6.2).
         ELSE.
            PRINT /'    Internal Std. |' #IRwI (T21,F10.4) #SEIRwI(T37,F10.8) '|'55 #PIRwI(T59,F7.5).
         END IF.
         DO IF (#IRwI<1).     /*Inverses of IR.         
            COMPUTE #IIRwI=1/#IRwI.
            COMPUTE #IUbIRwI=1/#LbIRwI.
            COMPUTE #ILbIRwI=1/#UbIRwI.
            DO IF (#SE=0).
               PRINT /'       reciprocal |' #IIRwI(T21,F10.4) #ILbIRwI(T32,F10.4) #IUbIRwI(T44,F10.4) '|'55.
            ELSE.
               PRINT /'       reciprocal |' #IIRwI(T21,F10.4) '|'55.
            END IF.
         END IF.

*        Prints: External Std IR+CI or IR+SElnIR.
         DO IF (#SE=0).
            PRINT /'    External Std. |' #IRwE (T21,F10.4) #LbIRwE(T32,F10.4) #UbIRwE(T44,F10.4) '|'55 #PIRwE(T56,F6.4) #chwE(T63,PCT6.2).
         ELSE.
            PRINT /'    External Std. |' #IRwE (T21,F10.4) #SEIRwE(T37,F10.8) '|'55 #PIRwE(T59,F7.5).
         END IF.         
         DO IF (#IRwE<1).     /*Inverses of IR.            
            COMPUTE #IIRwE=1/#IRwE.
            COMPUTE #IUbIRwE=1/#LbIRwE.
            COMPUTE #ILbIRwE=1/#UbIRwE.
            DO IF (#SE=0).
               PRINT /'       reciprocal |' #IIRwE(T21,F10.4) #ILbIRwE(T32,F10.4) #IUbIRwE(T44,F10.4) '|'55.
            ELSE.
               PRINT /'       reciprocal |' #IIRwE(T21,F10.4) '|'55.
            END IF.
         END IF.         
         PRINT /'------------------+-----------------------------------+-------------'.
         
*        MH Chi-Square.
         PRINT / '------------------+-----------------------------------+'.
         PRINT / '                  | MH Chi-Square  Significance       |'.
         PRINT / '------------------+-----------------------------------+'.         
*        Prints: Each stratum.
         COMPUTE #STRAT='STRATUM'.
         DO REPEAT STRr  = #STRr1 to !STRrn 
                  /CHIi = #CHI1 to !CHIn /CHIci= #CHIc1 to !CHIcn 
                  /Pi   = #P1 to !Pn /Pci  = #Pc1 to !Pcn.
            PRINT /#STRAT(A7) STRr(T10,A8) '|'19 CHIi (T23,F9.3) Pi(T34,F9.5) '|'55 .         
            PRINT /            '|'19 CHIci(T23,F9.3) Pci(T34,F9.5)'(Corrected)|'44 .
            COMPUTE #STRAT='       '.
         END REPEAT.
         
*        Prints: OVERALL, Wald homogeineity.
         PRINT /'------------------+-----------------------------------+'.
         PRINT /'OVERALL     Crude |' #CHI2g (T23,F9.3) #pchig(T34,F9.5)'|'55.
         PRINT /'                  |' #CHI2gc(T23,F9.3) #pchigc(T34,F9.5)'(Corrected)|'44.
         PRINT /'           POOLED |' #chiMH(T23,F9.3)  #PCHImh(T34,F9.5)'|'55.
         PRINT /'                  |' #chiMHc(T23,F9.3) #PCHImhc(T34,F9.5)'(Corrected)|'44.
         PRINT /'------------------+-----------------------------------+'.
         PRINT /' Wald HOMOGENEITY |' #ChiH(T23,F9.3)   #sp(T34,F9.5)'('51 !QUOTE(!METHODU) ')|'54.
         PRINT /'------------------+-----------------------------------+'.
      END IF.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
