PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !CSP V2009.06.29 loaded.'
         /'Execute !CSP HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !CSP ( VarExp =!CHAREND('/') 
             /VarRes =!CHAREND('/') 
                 /A1 =!CHAREND('/') /N1 =!CHAREND('/') /B1 =!CHAREND('/')
                 /A0 =!CHAREND('/') /N0 =!CHAREND('/') /B0 =!CHAREND('/')
                 /CL =!CHAREND('/') !DEFAULT('95')
               /Zero =!CHAREND('/') !DEFAULT('N')
               /PrCI =!CHAREND('/') !DEFAULT('W')
                /NST =!CHAREND('/')
               /HELP =!CHAREND('/') !DEFAULT(1)).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2009.06.29').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
!LET !WINDOW='HIDDEN'.
DO IF ($casenum=1).
  PRINT //'Macro !CSP V' !VERSION ' (c)JM.Domenech & R.Granero'.
END IF.
!IF (!HELP<>1) !THEN.
*  Impresin de la documentacin.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* CROSS-SECTIONAL PREVALENCE STUDY: Association measures                     *'
            /'* Created 1999.12.22 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech & R.Granero                                                *'
            /'* Programmers: A.Bonillo & R.Sesma                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM, Granero R. Macro !CSP for SPSS Statistics.                    *'
            /'*    Cross-Sectional Prevalence Study: Association measures                  *'
            /'*    [computer program].                                                     *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* Parameter for PRINTING MACRO DOCUMENTATION --------------------------------*'
            /'* !CSP HELP.                                                                 *'
            /'*                                                                            *'
            /'* Parameters for INDIVIDUAL DATA --------------------------------------------*'
            /'* !CSP VarExp[(ValUnexp ValExp)]= Exposure variable and values for           *'
            /'*                                  UnExpo, Exposed.  By default: ValUnexp= 0 *'
            /'*                                                                  ValExp= 1 *'
            /'*      /VarRes[(ValNonCase ValCase)]= Response variable and values for       *'
            /'*                                   NonCase, Case. By default: ValNonCase= 0 *'
            /'*                                                                 ValCase= 1 *'
            /'*                                                                            *'
            /'* Parameters for AGGREGATED DATA --------------------------------------------*'
            /'* !CSP A1 = Events in Exposed                   (A1 >= 0 )                   *'
            /'*    {/B1 = NonEvents in Exposed                (B1 >= 0 )                   *'
            /'*  or /N1}= Total of Exposed                    (N1 >= A1 and N1>0)          *'
            /'*     /A0 = Events in UnExposed                 (A0 >= 0 )                   *'
            /'*    {/B0 = NonEvents in UnExposed              (B0 >= 0 )                   *'
            /'*  or /N0}= Total of UnExposed                  (N0 >= A0 and N0>0)          *'
            /'*                                                                            *'
            /'* Parameters for BOTH TYPES OF DATA -----------------------------------------*'
            /'*    [/CL]= Confidence level(%); by default: 95 (50 <= CL < 100)             *'
            /'*         = SE  for printing Standard Error instead of Confidence Interval   *'
            /'*  [/Zero]= Continuity correction for cells with zero events:                *'
            /'*           N (None)                            by default: N                *'
            /'*           C (Constant, add k=0.5 to each cell)                             *'
            /'*           P (Proportional, add k1=N1/N and k0=N0/N)                        *'
            /'*           R (Reciprocal, add k1=1/N0 and k0=1/N1), recommended correction  *'
            /'*  [/PrCI]= Method for compute CI of proportions:                            *'
            /'*           W  Wilson                           by default: W                *'
            /'*           E  Exact (Clopper-Pearson)                                       *'
            /'*           A  Asymptotic                                                    *'
            /'*   [/NST]= Name of the study (Label)                                        *'
            /'*   [/HELP] Print Macro call arguments and Samples of calls                  *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements *'
            /'*                                                                            *'
            /'*                                           +----------+---------+---------+ *'
            /'* Samples of calls:                         |          |UnExposed| Exposed | *'
            /'*  !CSP HELP.                               +----------+---------+---------+ *'
            /'*  !CSP VarExp=Sexo(1 2) /VarRes=Muerte     |    Cases |    A0   |    A1   | *'
            /'*      /CL=95 /PrCI=W.                      +----------+---------+---------+ *'
            /'*  !CSP A1=3 /N1=12 /A0=0 /N0=16 /Zero=R.   | NonCases |    B0   |    B1   | *'
            /'*  !CSP A1=3 /B1=9  /A0=3 /B0=13 /PrCI=W.   +----------+---------+---------+ *'
            /'*  !CSP A1=3 /N1=12 /A0=3 /N0=16            |    TOTAL |    N0   |    N1   | *'
            /'*      /NST="Name of the Study" /CL=90.     +----------+---------+---------+ *'
            /'******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
   !LET !ERROR=0.
*  Test coherent parameters.
   !IF (!VarExp<>!NULL !OR !VarRes<>!NULL) !THEN.
      !IF (!VarExp=!NULL !OR !VarRes=!NULL) !THEN.
*        Missing parameter VarExp or VarRes.
         !LET !ERROR=1.
      !ELSE.
         !IF (!A1<>!NULL !OR !A0<>!NULL !OR !B1<>!NULL !OR !B0<>!NULL !OR !N1<>!NULL !OR !N0<>!NULL) !THEN.
*           Too much parameters: A1,A0,B1,B0,N1 or N0.
            !LET !ERROR=2.
         !IFEND.
      !IFEND.
   !ELSE.
      !IF (!A1=!NULL !OR !A0=!NULL) !THEN.
*        Missing parameter A1 or A0.
         !LET !ERROR=3.
      !ELSE.
         !IF (!VarExp<>!NULL !OR !VarRes<>!NULL) !THEN.
*           Too much parameters: VarExp,VarRes.
            !LET !ERROR=4.
         !ELSE.
            !IF ((!B1<>!NULL !AND !B0=!NULL) !OR (!B1=!NULL !AND !B0<>!NULL)) !THEN.
*              Missing parameter B1 or B0.
               !LET !ERROR=5.
            !ELSE.
               !IF ((!N1<>!NULL !AND !N0=!NULL) !OR (!N1=!NULL !AND !N0<>!NULL)) !THEN.
*                 Missing parameter N1 or N0.
                  !LET !ERROR=6.
               !ELSE.
                  !IF (!N1<>!NULL !AND !N0<>!NULL !AND !B1<>!NULL !AND !B0<>!NULL) !THEN.
*                    Too much paremeters.
                     !LET !ERROR=7.
                  !IFEND.
               !IFEND.
            !IFEND.
         !IFEND.
      !IFEND.
   !IFEND.
*  Test parameter Zero.
   !LET !ZeroU=!UPCASE(!Zero).
   !IF (!ERROR=0 !AND !ZeroU<>'N' !AND !ZeroU<>'C' !AND !ZeroU<>'P' !AND !ZeroU<>'R') !THEN.
      !LET !ERROR=8.
   !IFEND.
*  Test parameter PrCI.
   !LET !PrCIU=!UPCASE(!PrCI).
   !IF (!ERROR=0 !AND !PrCIU<>'W' !AND !PrCIU<>'E' !AND !PrCIU<>'A') !THEN.
      !LET !ERROR=9.
   !IFEND.

   !IF (!ERROR<>0) !THEN.
*     If necessary, print error messages.
      TEMPORARY.
      N 1.
      !IF (!ERROR=1) !THEN.
         PRINT /'ERROR: Missing parameter VarRef or VarExp. See the HELP.'.
      !IFEND.
      !IF (!ERROR=2 !OR !ERROR=4) !THEN.
         PRINT /'ERROR: Too much parameters. Individual Data parameters are incompatible with'.
         PRINT /'       Aggregated Data parameters. See the HELP.'.
      !IFEND.
      !IF (!ERROR=3) !THEN.
         PRINT /'ERROR: Missing parameter A1 or A0. See the HELP.'.
      !IFEND.
      !IF (!ERROR=5) !THEN.
         PRINT /'ERROR: Missing parameter B1 or B0. See the HELP.'.
      !IFEND.
      !IF (!ERROR=6) !THEN.
         PRINT /'ERROR: Missing parameter N1 or N0. See the HELP.'.
      !IFEND.
      !IF (!ERROR=7) !THEN.
         PRINT /'ERROR: Too much parameters. B1,B0 parameteres are incompatible with'.
         PRINT /'       N1,N0 parameters. See the HELP.'.
      !IFEND.
      !IF (!ERROR=8) !THEN.
         PRINT /'ERROR: Parameter Zero with wrong value. See the HELP.'.
      !IFEND.
      !IF (!ERROR=9) !THEN.
         PRINT /'ERROR: Parameter PrCI with wrong value. See the HELP.'.
      !IFEND.
      EXECUTE.
   !ELSE.
******GENERATE @DATA: dataset to work with.
      OMS /SELECT ALL /IF COMMANDS = ["Dataset Copy" "Dataset Name"] /DESTINATION   VIEWER = NO.
      DATASET NAME @original.
      OMSEND.
      
      !IF (!VarRes<>!NULL !AND !VarExp<>!NULL) !THEN.
*********READ INFO from VarExp, VarRes: variable names and values.
*        VarExp contains the name and the values of the Exposure variable: VExp(ValUnexp ValExp).
         !LET !Pos=!Index(!VarExp,'(').
         !IF (!Pos<>0) !THEN.
*           Get the name of the variable.
            !LET !VExp=!SubStr(!VarExp,1,!Length(!SubStr(!Blanks(!Pos),2))).
*           Read the values.
            !LET !Values=!SubStr(!VarExp,!Length(!Concat(!Blanks(!Pos),' '))).
            !LET !Values=!SubStr(!Values,1,!Length(!SubStr(!Blanks(!Length(!Values)),2))).
            !LET !COUNT=1.
            !DO !Val !IN (!Values).
               !IF (!COUNT=1) !THEN !LET !ValUnexp=!Val !IFEND.
               !IF (!COUNT=2) !THEN !LET !ValExp=!Val !IFEND.
               !LET !COUNT = !Length(!Concat(!Blanks(!COUNT),' ')).
            !DOEND.
         !ELSE.
*           VarExp contains only the name of the Exposure variable; ValUnexp and ValExp by default (0 1).
            !LET !VExp=!VarExp.
            !LET !ValExp=1.
            !LET !ValUnexp=0.
         !IFEND.
         
*        VarRes contains the name and the values of the Response variable: VRes(ValNonCase ValCase).
         !LET !Pos=!Index(!VarRes,'(').
         !IF (!Pos<>0) !THEN.
*           Get the name of the variable.
            !LET !VRes=!SubStr(!VarRes,1,!Length(!SubStr(!Blanks(!Pos),2))).
*           Read the values.
            !LET !Values=!SubStr(!VarRes,!Length(!Concat(!Blanks(!Pos),' '))).
            !LET !Values=!SubStr(!Values,1,!Length(!SubStr(!Blanks(!Length(!Values)),2))).
            !LET !COUNT=1.
            !DO !Val !IN (!Values).
               !IF (!COUNT=1) !THEN !LET !ValNonCase=!Val !IFEND.
               !IF (!COUNT=2) !THEN !LET !ValCase=!Val !IFEND.
               !LET !COUNT = !Length(!Concat(!Blanks(!COUNT),' ')).
            !DOEND.
         !ELSE.
*           VarRes contains only the name of the Response variable; ValNonCase and ValCase by default (0 1).
            !LET !VRes=!VarRes.
            !LET !ValCase=1.
            !LET !ValNonCase=0.
         !IFEND.

*********COPY of the active dataset: @work.
         DATASET COPY @9675work WINDOW=!WINDOW.
         DATASET ACTIVATE @9675work.

*********RECODE of the Exposure, Response variables to @Exp, @Resp variables which are 1,0.
         RECODE !VExp (MISSING=SYSMIS) (!ValExp=1) (!ValUnexp=0) (ELSE=SYSMIS) INTO @9675Exp.
         RECODE !VRes (MISSING=SYSMIS) (!ValCase=1) (!ValNonCase=0) (ELSE=SYSMIS) INTO @9675Resp.
         FORMATS @9675Exp @9675Resp (F8.0).
         EXECUTE.

*********CROSSTABS - Use OMS to redirect output tables to the @DATA, @CASES datasets.
         PRESERVE.
         SET OLANG=ENGLISH TNUMBERS=VALUES.
         DATASET DECLARE @9675DATA WINDOW=!WINDOW.
         OMS /SELECT ALL /IF COMMANDS = ["Crosstabs"] /DESTINATION VIEWER = NO.
         OMS /SELECT TABLES /IF COMMANDS = ["Crosstabs"] SUBTYPES = ["Crosstabulation"]
             /DESTINATION FORMAT = SAV NUMBERED = Num OUTFILE = @9675DATA .
         DATASET DECLARE @9675CASES WINDOW=!WINDOW.
         OMS /SELECT TABLES /IF COMMANDS = ["Crosstabs"]  SUBTYPES = ["Case Processing Summary"]
             /DESTINATION FORMAT = SAV NUMBERED = Num OUTFILE = @9675CASES.
         OMS /SELECT ALL /IF COMMANDS = ["Crosstabs"] /DESTINATION VIEWER = NO.
         CROSSTABS VARIABLES=@9675Resp @9675Exp (0,1) /TABLES=@9675Resp BY @9675Exp /FORMAT DVALUE /COUNT=ASIS.
         OMSEND.
         RESTORE.

*********GET VALUE LABELS.
*        Get variable descriptions on a @Descrip dataset using FREQUENCIES + OMS.
         PRESERVE.
         SET TNUMBERS=BOTH OLANG=ENGLISH.
         DATASET DECLARE @9675Descrip WINDOW=!WINDOW.
         OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION   VIEWER = NO.
         OMS /SELECT TABLES /IF COMMANDS = ["Frequencies"]  SUBTYPES = ["Frequencies"]
          /DESTINATION FORMAT = SAV NUMBERED = @Var  OUTFILE = @9675Descrip.
         OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION   VIEWER = NO.
         FREQUENCIES  VARIABLES=!VExp !VRes /ORDER=  ANALYSIS .
         OMSEND.
         RESTORE.

*        Prepare @DATA to compute results: rename vars and keep interesting info.
         DATASET ACTIVATE @9675DATA.
         DATASET CLOSE @9675work.
         MATCH FILES FILE=* /RENAME=(@0 @1 Total = A0 A1 M1) /KEEP=A0 A1 M1.
*        Compute A1, A0, N1, N0, M1, M0, N vars and keep only the first row.
         PRESERVE.
         SET RESULTS=OFF ERRORS=OFF PRINTBACK=OFF.
         CREATE /B1=LEAD(A1 1) /N1=LEAD(A1 2) /B0=LEAD(A0 1) /N0=LEAD(A0 2) /M0=LEAD(M1 1) /N=LEAD(M1 2).
         RESTORE.
         N 1.
         EXECUTE.
         
*        Prepare @Descrip: erase the Total row and compute the Val, Descrip variables.
         DATASET ACTIVATE @9675Descrip.
         SELECT IF (NOT SYSMIS(CumulativePercent)).
         MATCH FILES FILE=*/RENAME=(Var2=@Descrip) /KEEP=@Var @Descrip.
         STRING Descrip (A50).
         COMPUTE Val = NUMBER(SUBSTR(@Descrip,1,INDEX(@Descrip,' ')-1),F8).
         COMPUTE Descrip = SUBSTR(@Descrip,INDEX(@Descrip,' ')+1).
         IF (LENGTH(LTRIM(Descrip))=0) Descrip = LTRIM(STRING(Val,F8)).
         EXECUTE.
         
         DATASET ACTIVATE @9675DATA.
      !ELSE.
*********AGGREGATED DATA: Create the @DATA dataset from the A1,A0,N1,N0,B1,B0 parameters.
*        Create @DATA: copy the active dataset, and keep only the first row.
         DATASET COPY @9675DATA WINDOW=!WINDOW.
         DATASET ACTIVATE @9675DATA.
         SPLIT FILE OFF.
         WEIGHT OFF.
         N 1.
         COMPUTE @U=1.
         MATCH FILES FILE=* /KEEP=@U.
*        Compute A1, A0, N1, N0, M1, M0, N vars and keep only the interesting vars.
         NUMERIC A1 A0 B1 B0 N1 N0 M1 M0 N.
         COMPUTE A1=!A1.
         COMPUTE A0=!A0.
         !IF (!N1<>!NULL !AND !N0<>!NULL) !THEN.
            COMPUTE N1=!N1.
            COMPUTE N0=!N0.
            COMPUTE B1=N1-A1.
            COMPUTE B0=N0-A0.
         !ELSE.
            COMPUTE B1=!B1.
            COMPUTE B0=!B0.
            COMPUTE N1=A1+B1.
            COMPUTE N0=A0+B0.
         !IFEND.
         COMPUTE M1=A1+A0.
         COMPUTE M0=B1+B0.
         COMPUTE N=N1+N0.
      !IFEND.

******TEST NUMERIC PARAMETERS.
      COMPUTE @ERROR=0.
      COMPUTE @U=1.
*     Test A1,A0.
      DO IF (SYSMIS(A1) OR SYSMIS(A0)).
         COMPUTE @ERROR = 1.
      ELSE.
         IF (A1<0 OR A0<0) @ERROR=1.
      END IF.
      !IF (!N1=!NULL !AND !N0=!NULL) !THEN.
*        Test B1,B0.
         DO IF (SYSMIS(B1) OR SYSMIS(B0)).
            COMPUTE @ERROR = 2.
         ELSE.
            IF (B1<0 OR B0<0) @ERROR=2.
         END IF.
      !ELSE.
*        Test N1,N0.
         DO IF (SYSMIS(N1) OR SYSMIS(N0)).
            COMPUTE @ERROR = 3.
         ELSE.
            IF (N1<A1 OR N0<A0 OR N1<=0 OR N0<=0) @ERROR=3.
         END IF.
      !IFEND.
      IF (N1<=0 OR N0<=0) @ERROR=3.
*     Confidence level.
      COMPUTE @CL=$SYSMIS.
      !IF (!UPCASE(!CL)='SE') !THEN.
         COMPUTE @CL = 95.
      !ELSE.
         COMPUTE @CL = !CL.
         DO IF (SYSMIS(@CL)).
            COMPUTE @ERROR = 4.
         ELSE.
            IF (@CL<50 OR @CL>=100) @ERROR=4.
         END IF.
      !IFEND.
      
      DO IF (@ERROR=1).
         PRINT /'ERROR: Parameter(s) A1 or A0 with wrong values. See the HELP.'.
      ELSE IF (@ERROR=2).
         PRINT /'ERROR: Parameter(s) B1 or B0 with wrong values. See the HELP.'.
      ELSE IF (@ERROR=3).
         PRINT /'ERROR: Parameter(s) N1 or N0 with wrong values. See the HELP.'.
      ELSE IF (@ERROR=4).
         PRINT /'ERROR: Parameter CL with wrong value. See the HELP.'.
      ELSE.
*        Print header.
         PRINT /'CROSS-SECTIONAL STUDY: Association measures'.
*        Print NST if available.
         !IF (!NST !NE !NULL) !THEN .
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.
      END IF.
      EXECUTE.

*     Print Value Labels and Case Processing Summary (Individual Data).
      !IF (!VarRes<>!NULL !AND !VarExp<>!NULL) !THEN.
         DATASET ACTIVATE @9675Descrip.
         COMPUTE @U=1.
*        Add @ERROR variable with the error information.
         MATCH FILES FILE=* /TABLE='@9675DATA' BY @U /KEEP=@Var @Descrip Val Descrip @ERROR.
*        REFERENCE variable, NonCases and Cases values.
         DO IF ($casenum=1 AND @ERROR=0).
            PRINT //'EXPOSURE variable: ' !QUOTE(!VExp).
         END IF.
         EXECUTE.
         DO IF (@Var=1 AND Val=!ValUnexp AND @ERROR=0).
            PRINT  /'        Unexposed: ' Descrip.
         END IF.
         EXECUTE.
         DO IF (@Var=1 AND Val=!ValExp AND @ERROR=0).
            PRINT  /'          Exposed: ' Descrip.
         END IF.
         EXECUTE.
*        Test variable, Negative and Positive values.
         DO IF ($casenum=1 AND @ERROR=0).
            PRINT //'RESPONSE variable: ' !QUOTE(!VRes) .
         END IF.
         EXECUTE.
         DO IF (@Var=2 AND Val=!ValNonCase AND @ERROR=0).
            PRINT  /'         NonCases: ' Descrip.
         END IF.
         EXECUTE.
         DO IF (@Var=2 AND Val=!ValCase AND @ERROR=0).
            PRINT  /'            Cases: ' Descrip.
         END IF.
         EXECUTE.

*        Case Processing Summary.
         DATASET ACTIVATE @9675CASES.
         COMPUTE @U=1.
         MATCH FILES FILE=* /TABLE='@9675DATA' BY @U /KEEP=Valid_N Valid_Percent Total_N @ERROR.
         DO IF (@ERROR=0).
            PRINT //'Valid cases=' Valid_N(F6) '(' Valid_Percent(PCT6.1) ')'.
            PRINT  /'Total cases=' Total_N(F6).
         END IF.
         EXECUTE.
   
         DATASET ACTIVATE @9675DATA.
         DATASET CLOSE @9675Descrip.
         DATASET CLOSE @9675CASES.
      !IFEND.

******COMPUTE RESULTS.
      DO IF (@ERROR=0).
*        Save the original parameters for the print.
         COMPUTE A1o=A1.
         COMPUTE A0o=A0.
         COMPUTE B1o=B1.
         COMPUTE B0o=B0.
         COMPUTE N1o=N1.
         COMPUTE N0o=N0.
         COMPUTE M1o=M1.
         COMPUTE M0o=M0.
         COMPUTE No= N.

         COMPUTE @P = (@CL+100)/200.
         COMPUTE @Z=IDF.NORMAL(@P,0,1).
*        CI compute method (PrCI): W (Wilson) = 1 - default; E (Exact) = 2; A (Asymptotic) = 3.
         COMPUTE @PrCI=0.
         IF (!QUOTE(!PrCIU)='W') @PrCI=1.
         IF (!QUOTE(!PrCIU)='E') @PrCI=2.
         IF (!QUOTE(!PrCIU)='A') @PrCI=3.
*        Type of continuity correction: 1 - Constant; 2 - Proportional; 3 - Reciprocal.
         COMPUTE @ZERO=0.
         IF (!QUOTE(!ZeroU)='C') @ZERO=1.
         IF (!QUOTE(!ZeroU)='P') @ZERO=2.
         IF (!QUOTE(!ZeroU)='R') @ZERO=3.

*        Mantel-Haenszel Chi-Square test.
         COMPUTE @WarnCHI=0.
         COMPUTE #T1 = ABS(A1*N-N1*M1).
         COMPUTE Chi2 = (N-1)*(#T1**2)/(M1*M0*N1*N0).
         COMPUTE Chi2C= (N-1)*(#T1-N/2)**2/(M1*M0*N1*N0).
         IF (#T1 < N/2) Chi2C=0.
         COMPUTE p= (1- CDF.CHISQ(ABS(Chi2),1)).
         COMPUTE pC=(1- CDF.CHISQ(ABS(Chi2C),1)).
         IF (M1*N1/N<5 OR M0*N1/N<5 OR M1*N0/N<5 OR M0*N0/N<5) @WarnCHI=1.

*        Continuity correction.
         COMPUTE @WarnZERO=0.
         IF ((A1=0 OR A0=0 OR B1=0 OR B0=0) AND @Zero>0) @WarnZERO=1.
         COMPUTE @K1=0.
         COMPUTE @K0=0.
         DO IF (@WARNZERO=1).
            IF (@ZERO=1) @K1=0.5.
            IF (@ZERO=1) @K0=0.5.
            IF (@ZERO=2) @K1=N1/N.
            IF (@ZERO=2) @K0=N0/N.
            IF (@ZERO=3) @K1=1/N0.
            IF (@ZERO=3) @K0=1/N1.
         END IF.
         COMPUTE A1=A1+@K1.
         COMPUTE A0=A0+@K0.
         COMPUTE B1=B1+@K1.
         COMPUTE B0=B0+@K0.
         COMPUTE N1=A1+B1.
         COMPUTE N0=A0+B0.
         COMPUTE M1=A1+A0.
         COMPUTE M0=B1+B0.
         COMPUTE N= N1+N0.

*        Proportions.
         COMPUTE @WarnCIA=0.
         NUMERIC pM1 pM0 pN pA1 pA0 pM lbpM1 ubpM1 lbpM0 ubpM0 lbpN ubpN 
                 lbpA1 ubpA1 lbpA0 ubpA0 lbpM ubpM SEpM1 SEpM0 SEpN SEpA1 SEpA0 SEpM.
         DO REPEAT P=pM1 pM0 pN pA1 pA0 pM
                  /A=A1 B1 N1 A1 A0 M1
                  /B=A0 B0 N0 B1 B0 M0
                /lbP=lbpM1 lbpM0 lbpN lbpA1 lbpA0 lbpM
                /ubP=ubpM1 ubpM0 ubpN ubpA1 ubpA0 ubpM
                /SEp=SEpM1 SEpM0 SEpN SEpA1 SEpA0 SEpM.
            COMPUTE P = A/(A+B).
            COMPUTE SEp = SQR(P*(1-P)/(A+B)).
            DO IF (@PrCI=1).      /*Wilson bounds.
               COMPUTE #WA = 2*A + @Z**2.
               COMPUTE #WB = @Z * SQRT(@Z**2 + 4*A*(B)/(A+B)).
               COMPUTE #WC = 2*((A+B) + @Z**2).
               COMPUTE lbP= (#WA-#WB)/#WC.
               COMPUTE ubP= (#WA+#WB)/#WC.
            ELSE IF (@PrCI=2).    /*Exact bounds.
               COMPUTE lbP= 0.
               COMPUTE ubP= 1.
               IF (A > 0) lbP= A/(A+(B+1)*IDF.F(@P,2*(B+1),2*A)).
               IF (B > 0) ubP=(A+1)/((A+1)+(B/IDF.F(@P,2*(A+1),2*B))).               
            ELSE IF (@PrCI=3).    /*Asymptotic bounds.
               COMPUTE ubP = P + @Z*SEp.
               COMPUTE lbP = P - @Z*SEp.
            END IF.
         END REPEAT.

*        Proportion Difference (PD).
         COMPUTE PD= pA1-pA0.
*        Wald CI of difference of two proportions.
         COMPUTE SEWa= SQR(pA1*(1-pA1)/N1 + pA0*(1-pA0)/N0).
         COMPUTE lbWa= PD - SEWa*@Z.
         COMPUTE ubWa= PD + SEWa*@Z.

*        Newcombe-Wilson CI of difference of two proportions.
         COMPUTE #F0= A0**2 /(N0**2 + N0*@Z**2).
         COMPUTE #F1= A1**2 /(N1**2 + N1*@Z**2).
         COMPUTE #W0= (2*A0 + @Z**2)/(2*(N0 + @Z**2)).
         COMPUTE #W1= (2*A1 + @Z**2)/(2*(N1 + @Z**2)).
         COMPUTE #L0= #W0 - SQR(#W0**2 - #F0).
         COMPUTE #L1= #W1 - SQR(#W1**2 - #F1).
         COMPUTE #U0= #W0 + SQR(#W0**2 - #F0).
         COMPUTE #U1= #W1 + SQR(#W1**2 - #F1).
         COMPUTE lbWi= PD - SQR((pA1-#L1)**2 + (#U0-pA0)**2).
         COMPUTE ubWi= PD + SQR((#U1-pA1)**2 + (pA0-#L0)**2).

*        Risk Ratio.
         COMPUTE RR=pA1/pA0.
         COMPUTE SElnRR = SQR((1/A0)-(1/N0)+(1/A1)-(1/N1)).
         COMPUTE lbRR= RR*EXP(-@Z*SElnRR).
         COMPUTE ubRR= RR*EXP(@Z*SElnRR).
         COMPUTE iRR=1/RR.
         COMPUTE ilbRR=1/ubRR.
         COMPUTE iubRR=1/lbRR.

*        Odds Ratio.
         COMPUTE @OR= (A1/B1)/(A0/B0).
         COMPUTE SElnOR = SQR(1/A0+1/B0+1/A1+1/B1).
         COMPUTE lbOR= @OR*EXP(-@Z*SElnOR).
         COMPUTE UbOR= @OR*EXP(@Z*SElnOR).
         COMPUTE iOR=1/@OR.
         COMPUTE ilbOR=1/ubOR.
         COMPUTE iubOR=1/lbOR.


*********PRINT RESULTS.
*        Determine if CL=SE, and the title of the CI.
         COMPUTE @SE=0.
         !LET !TITLE = ''.
*        Determine text for the CI type.
         STRING @CItype (A8).
         !IF (!PrCIU='W') !THEN.
            COMPUTE @CItype = '(Wilson)'.
            !LET !TITLE = !CONCAT(!CL,'% CI (Wilson)').
         !ELSE.
            !IF (!PrCIU='E') !THEN.
               COMPUTE @CItype = '(Exact) '.
               !LET !TITLE = !CONCAT(!CL,'% CI (Exact)').
            !ELSE.
               !IF (!PrCIU='A') !THEN.
                  COMPUTE @CItype = '(Asymp) '.
                  !LET !TITLE = !CONCAT(!CL,'% CI (Asymp)').
               !IFEND.
            !IFEND.
         !IFEND.
         !IF (!UPCASE(!CL)='SE') !THEN.
            COMPUTE @SE=1.
            !LET !TITLE = '(Asymptotic SE)'.
         !IFEND.

*        Detect decimal parameters.
         STRING @Dec(A1).
         COMPUTE @WarnDec=0.
         COMPUTE @Dec=' '.
         IF (MOD(A1o,1)<>0 OR MOD(A0o,1)<>0 OR MOD(B0o,1)<>0 OR MOD(B1o,1)<>0) @WarnDEC=1.
         IF (@WarnDEC=1) @Dec='.'.

*        Zero correction note.
         STRING @TZero(A1).
         COMPUTE @TZero=' '.
         IF (@WarnZERO=1) @TZero='*'.

*        2x2 table and proportions.
         PRINT //'                  |     Exposure      |         | Exposed proportion'.
         PRINT  /'                  |Unexposed| Exposed |   TOTAL | ' !QUOTE(!TITLE).
         PRINT  /'------------------+---------+---------+---------+--------------------'.
         PRINT  /'            Cases |' A0o(T20,F8) @Dec '|'29 A1o(T30,F8) @Dec '|'39 M1o(T40,F8) @Dec '| '49 pM1(F7.6) @TZero(A1).
         DO IF (@SE=0).
            PRINT  /'                  |         |         |         |(' lbpM1(F7.6) ' to ' ubpM1(F7.6) ')'.
         ELSE.
            PRINT  /'                  |         |         |         |(' SEpM1(F7.6) ')'.
         END IF.
         PRINT  /'         NonCases |' B0o(T20,F8) @Dec '|'29 B1o(T30,F8) @Dec '|'39 M0o(T40,F8) @Dec '| '49 pM0(F7.6) @TZero(A1).
         DO IF (@SE=0).
            PRINT  /'                  |         |         |         |(' lbpM0(F7.6) ' to ' ubpM0(F7.6) ')'.
         ELSE.
            PRINT  /'                  |         |         |         |(' SEpM0(F7.6) ')'.
         END IF.
         PRINT  /'------------------+---------+---------+---------+--------------------'.
         PRINT  /'            TOTAL |' N0o(T20,F8) @Dec '|'29 N1o(T30,F8) @Dec '|'39 No (T40,F8) @Dec '| '49 pN(F7.6) @TZero(A1).
         DO IF (@SE=0).
            PRINT  /'                  |         |         |         |(' lbpN(F7.6) ' to ' ubpN(F7.6) ')'.
         ELSE.
            PRINT  /'                  |         |         |         |(' SEpN(F7.6) ')'.
         END IF.
         PRINT  /' Cases proportion |' pA0(T21,F7.6) @TZero(A1) '|'29 pA1(T31,F7.6) @TZero(A1) '|'39 pM(T41,F7.6) @TZero(A1) '|'49.
         DO IF (@SE=0).
            PRINT  /'  '!QUOTE(!CL)'% CI    Lower |' lbpA0(T21,F7.6) '|'29  lbpA1(T31,F7.6) '|'39 lbpM(T41,F7.6) '|'49.
            PRINT  /@CItype '   Upper |' ubpA0(T21,F7.6) '|'29 ubpA1(T31,F7.6) '|'39 ubpM(T41,F7.6) '|'49.
         ELSE.
            PRINT  /'    Asymptotic SE |' SEpA0(T21,F7.6) '|'29 SEpA1(T31,F7.6) '|'39 SEpM(T41,F7.6) '|'49.
         END IF.

*        Estimates.         
         DO IF (@SE=0).
            PRINT //'                  |     Estimate      | '!QUOTE(!CL) '% Confidence Interval'.
            PRINT  /'------------------+-------------------+---------------------------------'.
            PRINT  /' Prop. Diff. (PD) |' PD (T22,F11.6) @TZero(A1)  '|'39 lbWa (T40,F12.6) ubWa (T52,F12.6) ' Wald'. 
            PRINT  /'                  |                   |' lbWi (T40,F12.6) ubWi (T52,F12.6) ' Newcombe'. 
            PRINT  /' Prop. Ratio (PR) |' RR(T22,F11.4) @TZero(A1)   '|'39 lbRR (T40,F12.4) ubRR (T53,F12.4). 
            DO IF (RR<1).
               PRINT /'       reciprocal |' iRR(T22,F11.4) @TZero(A1) '|'39 ilbRR (T40,F12.4) iubRR(T53,F12.4). 
            END IF.
            PRINT  /'  Odds Ratio (OR) |' @OR (T22,F11.4) @TZero(A1) '|'39 lbOR (T40,F12.4) ubOR (T53,F12.4). 
            DO IF (@OR<1).
               PRINT /'       reciprocal |' iOR(T22,F11.4) @TZero(A1) '|'39 ilbOR(T40,F12.4) iUbOR(T53,F12.4).
            END IF.
         ELSE.
            PRINT //'                  |     Estimate      | Standard Error'.
            PRINT  /'------------------+-------------------+---------------------------------'.
            PRINT  /' Prop. Diff. (PD) |' PD (T22,F11.6) @TZero(A1) '|'39 SEWa (T41,F10.8) ' Wald'. 
            PRINT  /' Prop. Ratio (PR) |' RR (T22,F11.4) @TZero(A1) '|'39 SElnRR (T41,F10.8) '***'. 
            DO IF (RR<1).
               PRINT /'       reciprocal |' iRR(T22,F11.4) @TZero(A1) '|'39 . 
            END IF.
            PRINT  /'  Odds Ratio (OR) |' @OR (T22,F11.4) @TZero(A1) '|'39 SElnOR (T41,F10.8) '***'. 
            DO IF (@OR<1).
               PRINT /'       reciprocal |' iOR(T22,F11.4) @TZero(A1) '|'39.
            END IF.
         END IF.

         STRING @Chi(A2).
         COMPUTE @Chi='  '.
         IF (@WarnCHI=1) @Chi='**'.         
         PRINT  /'------------------+-------------------+---------------------------------'.
         PRINT  /'   M-H Chi-Square |' Chi2 (T24,F9.3) @Chi(A2) '|    P = '39 p(T48,F6.5) '(Association)'57. 
         PRINT  /'        Corrected |' Chi2C(T24,F9.3) '|    P = '39 pC(T48,F6.5) . 
         PRINT  /'------------------+-------------------+---------------------------------'.
         
*        Print notes and warnings.
         DO IF (@SE=0).
            PRINT /'Recommended CI'.
         END IF.
         DO IF (@WARNDEC=1).
            PRINT /'(.)WARNING: Number of cases with decimal values'.
            PRINT /'            The values are printed rounded.'.
         END IF.
         DO IF (@WARNZERO=1).
            DO IF (@ZERO=1).
               PRINT /'(*)Computed with a constant continuity correction (k=0.5)'.
            ELSE IF (@ZERO=2).
               PRINT /'(*)Computed with a proportional continuity correction'.
            ELSE IF (@ZERO=3).
               PRINT /'(*)Computed with a reciprocal continuity correction'.
            END IF.
            PRINT /'   Exact inference is recommended'.
         END IF.
         DO IF (@WARNCHI=1).
            PRINT /'(**)WARNING: Small samples for Association Chi-Square'.
         END IF.
         DO IF (@SE=1).
            PRINT/'(***)SE of natural logarithm of ratio statistic'.
         END IF.
         DO IF (@WarnCIA=1 AND @SE=0).
            PRINT /'WARNING: Asymptotic CI of Risk is out of range'.
         END IF.
      END IF.
      
*     Restore original dataset and close temporary dataset @DATA.
      DATASET ACTIVATE @original.
      DATASET CLOSE @9675DATA.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
