PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !DT V2012.05.22 loaded.'
         /'Execute !DT HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !DT ( A1=!CHAREND('/') /A0=!CHAREND('/') /B1=!CHAREND('/') /B0=!CHAREND('/')
       /VarTest=!CHAREND('/') /VarRef=!CHAREND('/')
            /SE=!CHAREND('/') /SP=!CHAREND('/')
            /M1=!CHAREND('/') /N=!CHAREND('/')
            /ST=!CHAREND('/')!DEFAULT('CS') 
            /CL=!CHAREND('/')!DEFAULT(95) 
             /P=!CHAREND('/')!DEFAULT('0.1 0.5 1 2 3 5 7 10 15 20 25 30 40 50 60 70 80 90')
          /PrCI=!CHAREND('/')!DEFAULT('W')
           /NST=!CHAREND('/')
          /HELP=!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2009.06.26').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
!LET !WINDOW='HIDDEN'.
DO IF ($casenum=1).
  PRINT //'Macro !DT V' !VERSION ' (c)JM.Domenech'.
END IF.
!IF (!HELP<>1) !THEN.
*  Print HELP.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* DIAGNOSTIC TESTS                                                           *'
            /'* Created 2007.09.18 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech                                                            *'
            /'* Programmer: R.Sesma                                                        *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM. Macro !DT for SPSS Statistics.                                *'
            /'*    Diagnostic Tests [computer program].                                    *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* Parameter for PRINTING MACRO DOCUMENTATION --------------------------------*'
            /'*  !DT HELP.                                                                 *'
            /'*                                                                            *'
            /'* Parameters for BOTH TYPES OF DATA and ALL STUDY TYPES ---------------------*'
            /'*     [/ST]= Study type: CS (Cross-Sectional) ; by default: CS               *'
            /'*                        or CC (Case-Control)                                *'
            /'*                        or BT (Bayes theorem)                               *'
            /'*      [/P]= List of hypothetical population prevalence(%)    (0 < P < 100)  *'
            /'*            by default: 0.1 0.5 1 2 3 5 7 10 15 20 25 30 40 50 60 70 80 90  *'
            /'*     [/CL]= Confidence level(%); by default: 95          (50 < CL < 100)    *'
            /'*   [/PrCI]= Method for compute CI of proportions:                           *'
            /'*            W  Wilson                        ; by default: W (recommended)  *'
            /'*            E  Exact (Clopper-Pearson)                                      *'
            /'*            A  Asymptotic                                                   *'
            /'*    [/NST]= Name of the study (Label)                                       *'
            /'*                                                                            *'
            /'* Parameters for BAYES THEOREM Study ----------------------------------------*'
            /'*      /SE = Sensitivity(%)                               (0 < SE < 100)     *'
            /'*      /SP = Specificity(%)                               (0 < SP < 100)     *'
            /'*                                                                            *'
            /'* Parameters for CROSS-SECTIONAL and CASE-CONTROL Study ---------------------*'
            /'* For INDIVIDUAL DATA                                                        *'
            /'*  /VarTest[(ValNeg ValPos)]= Diagnostic Test variable and values for        *'
            /'*                                  Positive, Negative. By default: ValNeg= 0 *'
            /'*                                                                  ValPos= 1 *'
            /'*  /VarRef[(ValNonCase ValCase)]= Reference Criterion variable and values    *'
            /'*                               for NonCase, Case. By default: ValNonCase= 0 *'
            /'*                                                                 ValCase= 1 *'
            /'*                                                                            *'
            /'* For AGGREGATED DATA                                                        *'
            /'*      /A1 = Number of Cases with Test +                  (A1 integer >= 0)  *'
            /'*      /A0 = Number of Cases with Test -                  (A0 integer >= 0)  *'
            /'*      /B1 = Number of NonCases with Test +               (B1 integer >= 0)  *'
            /'*      /B0 = Number of NonCases with Test -               (B0 integer >= 0)  *'
            /'*                                                                            *'
            /'* For BOTH TYPES OF DATA and Case-Control Study                              *'
            /'*     [/M1]= Total Cases in a population sample           (M1 integer > 0)   *'
            /'*      [/N]= Size of population sample                    (N integer > M1)   *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements *'
            /'*                                                                            *'
            /'* Samples of calls:                                                          *'
            /'* !DT HELP                                                                   *'
            /'* !DT ST=CS /VarTest=Gluc(0 1) /VarRef=Diab(1 2) /P= 2 5 10 15 20 30 40.     *'
            /'* !DT ST=CC /VarTest=Gluc /VarRef=Diab /M1=98 /N=765 /P= 2 5 10 15 20 30 40. *'
            /'* !DT ST=CS /A1=65 /A0=90 /B1=48 /B0=396        +--------+--------+--------+ *'
            /'*    /P= 0.5 1 2 3 4 5 6 7 8 9 10               |        |NonCases|  Cases | *'
            /'*    /NST="Study Name" /CL=95.                  +--------+--------+--------+ *'
            /'* !DT ST=CC /A1=85 /A0=48 /B1=25 /B0=348        |Test Pos|   B1   |   A1   | *'
            /'*    /M1=98 /N=765 /P= 2 4 6 8 10 12 15.        |     Neg|   B0   |   A0   | *'
            /'* !DT ST=BT /SE=90 /SP=80 /P= 5 10 15 20 30 40. +--------+--------+--------+ *'
            /'******************************************************************************'.
   END IF.
!ELSE.
   !LET !ERROR=0.

*  Test parameter ST, Study Type: CS (1), CC without M1,N (2), CC with M1,N (3), BT (4).
   !LET !Type=0.
   !LET !Title=''.
   !LET !STU=!UPCASE(!ST).
   !IF (!STU='CS') !THEN. 
      !LET !Type=1.
      !LET !Title='CROSS-SECTIONAL STUDY'.
   !ELSE.
      !IF (!STU='CC') !THEN. 
         !LET !Title='CASE-CONTROL STUDY'.
         !IF (!M1=!NULL !AND !N=!NULL) !THEN. 
            !LET !Type=2.
         !ELSE.
            !LET !Type=3.
         !IFEND.
      !ELSE.
         !IF (!STU='BT') !THEN. 
            !LET !Title='BAYES THEOREM'.
            !LET !Type=4.
         !ELSE.
            !LET !ERROR=1.
         !IFEND.
      !IFEND.
   !IFEND.

   !IF (!ERROR=0) !THEN.
      !IF (!Type=4) !THEN.
         !IF (!SE=!NULL !OR !SP=!NULL) !THEN.
*           Missing parameter SE or SP.
            !LET !ERROR=2.
         !IFEND.
         !IF (!VarRef<>!NULL !OR !VarTest<>!NULL !OR !A1<>!NULL !OR !A0<>!NULL !OR !B1<>!NULL !OR !B0<>!NULL !OR !M1<>!NULL !OR !N<>!NULL) !THEN.
*           Too much parameters for ST=BT.
            !LET !ERROR=3.
         !IFEND.
      !ELSE.
         !IF (!SE<>!NULL !OR !SP<>!NULL) !THEN.
*           Too much parameters: SE or SP.
            !LET !ERROR=4.
         !IFEND.
         !IF (!VarRef<>!NULL !OR !VarTest<>!NULL) !THEN.
            !IF (!A1<>!NULL !OR !A0<>!NULL !OR !B1<>!NULL !OR !B0<>!NULL) !THEN.
*              Too much parameters: A1,A0,B1,B0.
               !LET !ERROR=5.
            !IFEND.
            !IF (!VarRef=!NULL !OR !VarTest=!NULL) !THEN.
*              Missing parameter VarRef or VarTest.
               !LET !ERROR=6.
            !IFEND.
         !ELSE.
            !IF (!A1=!NULL !OR !A0=!NULL !OR !B1=!NULL !OR !B0=!NULL) !THEN.
*              Missing parameter A1, A0, B1, B0.
               !LET !ERROR=7.
            !IFEND.
         !IFEND.
         !IF (!Type=1 !AND (!M1<>!NULL !OR !N<>!NULL)) !THEN.
*           Too much parameters: M1 or N.
            !LET !ERROR=8.
         !IFEND.
         !IF (!Type=3 !AND (!M1=!NULL !OR !N=!NULL)) !THEN.
*           Missing parameter M1 or N.
            !LET !ERROR=9.
         !IFEND.
      !IFEND.
   !IFEND.
*  Test parameter PrCI.
   !LET !PrCIU=!UPCASE(!PrCI).
   !IF (!ERROR=0 !AND !PrCIU<>'W' !AND !PrCIU<>'E' !AND !PrCIU<>'A') !THEN.
      !LET !ERROR=10.
   !IFEND.

*  If necessary, print error messages.
   !IF (!ERROR<>0) !THEN.
      TEMPORARY.
      N 1.
      !IF (!ERROR=1) !THEN.
         PRINT /'ERROR: Parameter ST with wrong values. See the HELP.'.
      !IFEND.
      !IF (!ERROR=2) !THEN.
         PRINT /'ERROR: Parameter SE or SP missing. See the HELP.'.
      !IFEND.
      !IF (!ERROR=3) !THEN.
         PRINT /'ERROR: Wrong call for Bayes theorem (ST=BT), there are too much parameters. See the HELP.'.
      !IFEND.
      !IF (!ERROR=4) !THEN.
         PRINT /'ERROR: Too much parameters: SE or SP are not needed. See the HELP.'.
      !IFEND.
      !IF (!ERROR=5) !THEN.
         PRINT /'ERROR: Too much parameters: A1, A0, B1, B0 are not needed. See the HELP.'.
      !IFEND.
      !IF (!ERROR=6) !THEN.
         PRINT /'ERROR: Missing parameter VarRef or VarTest. See the HELP.'.
      !IFEND.
      !IF (!ERROR=7) !THEN.
         PRINT /'ERROR: Missing parameter(s) A1, A0, B1 or B0. See the HELP.'.
      !IFEND.
      !IF (!ERROR=8) !THEN.
         PRINT /'ERROR: Too much parameters: M1 or N are not needed. See the HELP.'.
      !IFEND.
      !IF (!ERROR=9) !THEN.
         PRINT /'ERROR: Missing parameter M1 or N. See the HELP.'.
      !IFEND.
      !IF (!ERROR=10) !THEN.
         PRINT /'ERROR: Parameter PrCI with wrong values. See the HELP.'.
      !IFEND.
      EXECUTE.
   !ELSE.
******GENERATE @DATA: dataset to work with.
      OMS /SELECT ALL /IF COMMANDS = ["Dataset Copy" "Dataset Name"] /DESTINATION   VIEWER = NO.
      DATASET NAME @original.
      OMSEND.

      !IF (!Type<>4) !THEN.
*        Cross-Sectional or Case-Control Study: get the data with CROSSTABS.
         !IF (!VarRef<>!NULL !AND !VarTest<>!NULL) !THEN.
*           VarTest contains the name and the values of the Test variable: VTest(ValNeg ValPos).
            !LET !Pos=!Index(!VarTest,'(').
            !IF (!Pos<>0) !THEN.
*              Get the name of the variable.
               !LET !VTest=!SubStr(!VarTest,1,!Length(!SubStr(!Blanks(!Pos),2))).
*              Read the values.
               !LET !Values=!SubStr(!VarTest,!Length(!Concat(!Blanks(!Pos),' '))).
               !LET !Values=!SubStr(!Values,1,!Length(!SubStr(!Blanks(!Length(!Values)),2))).
               !LET !COUNT=1.
               !DO !Val !IN (!Values).
                  !IF (!COUNT=1) !THEN !LET !ValNeg=!Val !IFEND.
                  !IF (!COUNT=2) !THEN !LET !ValPos=!Val !IFEND.
                  !LET !COUNT = !Length(!Concat(!Blanks(!COUNT),' ')).
               !DOEND.
            !ELSE.
*              VarExp contains only the name of the Exposure variable; ValUnexp and ValExp by default (0 1).
               !LET !VTest=!VarTest.
               !LET !ValPos=1.
               !LET !ValNeg=0.
            !IFEND.

*           VarRef contains the name and the values of the Reference variable: VRef(ValNonCase ValCase).
            !LET !Pos=!Index(!VarRef,'(').
            !IF (!Pos<>0) !THEN.
*              Get the name of the variable.
               !LET !VRef=!SubStr(!VarRef,1,!Length(!SubStr(!Blanks(!Pos),2))).
*              Read the values.
               !LET !Values=!SubStr(!VarRef,!Length(!Concat(!Blanks(!Pos),' '))).
               !LET !Values=!SubStr(!Values,1,!Length(!SubStr(!Blanks(!Length(!Values)),2))).
               !LET !COUNT=1.
               !DO !Val !IN (!Values).
                  !IF (!COUNT=1) !THEN !LET !ValNonCase=!Val !IFEND.
                  !IF (!COUNT=2) !THEN !LET !ValCase=!Val !IFEND.
                  !LET !COUNT = !Length(!Concat(!Blanks(!COUNT),' ')).
               !DOEND.
            !ELSE.
*              VarExp contains only the name of the Exposure variable; ValUnexp and ValExp by default (0 1).
               !LET !VRef=!VarRef.
               !LET !ValCase=1.
               !LET !ValNonCase=0.
            !IFEND.
            
*           Make a copy of the active dataset.
            DATASET COPY @9675work WINDOW=!WINDOW.
            DATASET ACTIVATE @9675work.

************RECODE of the Test, Reference variables to @Test, @Ref variables which are 1,0.
            RECODE !VTest (MISSING=SYSMIS) (!ValPos=1) (!ValNeg=0) (ELSE=SYSMIS) INTO @9675Test.
            RECODE !VRef  (MISSING=SYSMIS) (!ValCase=1) (!ValNonCase=0) (ELSE=SYSMIS) INTO @9675Ref.
            FORMATS @9675Test @9675Ref (F8.0).
            EXECUTE.

************CROSSTABS - Use OMS to redirect output tables to the @DATA, @CASE datasets.
            PRESERVE.
            SET OLANG=ENGLISH TNUMBERS=VALUES.
            DATASET DECLARE @9675DATA WINDOW=!WINDOW.
            OMS /SELECT ALL /IF COMMANDS = ["Crosstabs"] /DESTINATION VIEWER = NO.
            OMS /SELECT TABLES /IF COMMANDS = ["Crosstabs"] SUBTYPES = ["Crosstabulation"]
                /DESTINATION FORMAT = SAV NUMBERED = Num OUTFILE = @9675DATA .
            DATASET DECLARE @9675CASES WINDOW=!WINDOW.
            OMS /SELECT TABLES /IF COMMANDS = ["Crosstabs"]  SUBTYPES = ["Case Processing Summary"]
                /DESTINATION FORMAT = SAV NUMBERED = Num OUTFILE = @9675CASES.
            OMS /SELECT ALL /IF COMMANDS = ["Crosstabs"] /DESTINATION VIEWER = NO.
            CROSSTABS VARIABLES=@9675Test @9675Ref (0,1) /TABLES=@9675Test BY @9675Ref /FORMAT=DVALUE /COUNT=ASIS.
            OMSEND.
            RESTORE.

************GET VALUE LABELS.
*           Get variable descriptions on a @Descrip dataset using FREQUENCIES + OMS.
            PRESERVE.
            SET TNUMBERS=BOTH OLANG=ENGLISH.
            DATASET DECLARE @9675Descrip WINDOW=!WINDOW.
            OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION   VIEWER = NO.
            OMS /SELECT TABLES /IF COMMANDS = ["Frequencies"]  SUBTYPES = ["Frequencies"]
             /DESTINATION FORMAT = SAV NUMBERED = @Var  OUTFILE = @9675Descrip.
            OMS /SELECT ALL /IF COMMANDS = ["Frequencies"] /DESTINATION   VIEWER = NO.
            FREQUENCIES  VARIABLES=!VRef !VTest /ORDER=  ANALYSIS .
            OMSEND.
            RESTORE.

*           Prepare @DATA: compute A1, A0, N1, N0, M1, M0, N vars and keep only the first row..
            DATASET ACTIVATE @9675DATA.
            DATASET CLOSE @9675work.
            MATCH FILES FILE=* /RENAME=(@0 @1 Total = B1 A1 N1) /KEEP=B1 A1 N1.
            EXECUTE.
            PRESERVE.
            SET RESULTS=OFF ERRORS=OFF PRINTBACK=OFF.
            CREATE /B0=LEAD(B1 1) /M0=LEAD(B1 2) /A0=LEAD(A1 1) /M1=LEAD(A1 2) /N0=LEAD(N1 1) /N=LEAD(N1 2).
            RESTORE.
            N 1.
            EXECUTE.

*           Prepare @Descrip: Erase the Total row and compute the Val, Descrip variables.
            DATASET ACTIVATE @9675Descrip.
            SELECT IF (NOT SYSMIS(CumulativePercent)).
            MATCH FILES FILE=*/RENAME=(Var2=@Descrip) /KEEP=@Var @Descrip.
            STRING Descrip (A50).
            COMPUTE Val = NUMBER(SUBSTR(@Descrip,1,INDEX(@Descrip,' ')-1),F8).
            COMPUTE Descrip = SUBSTR(@Descrip,INDEX(@Descrip,' ')+1).
            IF (LENGTH(LTRIM(Descrip))=0) Descrip = LTRIM(STRING(Val,F8)).
            EXECUTE.
            
            DATASET ACTIVATE @9675DATA.
         !ELSE.
************AGGREGATED DATA: Create the @DATA dataset from the A1,A0,B1,B0 parameters.
*           Create @DATA: copy the active dataset, and keep only the first row.
            DATASET COPY @9675DATA WINDOW=!WINDOW.
            DATASET ACTIVATE @9675DATA.
            SPLIT FILE OFF.
            WEIGHT OFF.
            N 1.
            COMPUTE @U=1.
            MATCH FILES FILE=* /KEEP=@U.
            NUMERIC A1 A0 B1 B0 N1 N0 M1 M0 N.
            COMPUTE A1=!A1.
            COMPUTE B1=!B1.
            COMPUTE A0=!A0.
            COMPUTE B0=!B0.
            COMPUTE M1=A1+A0.
            COMPUTE M0=B1+B0.
            COMPUTE N1=A1+B1.
            COMPUTE N0=A0+B0.
            COMPUTE N =N1+N0.
            EXECUTE.
         !IFEND.
      !ELSE.
*********Bayes theorem: create the @DATA dataset to work with.
         DATASET COPY @9675DATA WINDOW=!WINDOW.
         DATASET ACTIVATE @9675DATA.
         SPLIT FILE OFF.
         WEIGHT OFF.
         N 1.
         COMPUTE @U=1.
         MATCH FILES FILE=* /KEEP=@U.
         COMPUTE A1=$SYSMIS.
         COMPUTE A0=$SYSMIS.
         COMPUTE B1=$SYSMIS.
         COMPUTE B0=$SYSMIS.
         COMPUTE M1=$SYSMIS.
         COMPUTE M0=$SYSMIS.
         COMPUTE N1=$SYSMIS.
         COMPUTE N0=$SYSMIS.
         COMPUTE N=$SYSMIS.
         EXECUTE.
      !IFEND.
   
      COMPUTE @ST=!Type.
      COMPUTE @ERROR=0.
      COMPUTE @U=1.
*     Test A1, A0, B1, B0.
      DO IF (@ST<4).
         DO IF (SYSMIS(A1) OR SYSMIS(A0) OR SYSMIS(B1) OR SYSMIS(B0)).
            COMPUTE @ERROR = 1.
         ELSE.
            IF (A1<0 OR A0<0 OR B1<0 OR B0<0 ) @ERROR=1.
            IF (MOD(A1,1)<>0 OR MOD(A0,1)<>0 OR MOD(B1,1)<>0 OR MOD(B0,1)<>0) @ERROR=2.
         END IF.
      END IF.
*     Add P and test.
      !LET !NumP = ''.
      !DO !I !IN (!P).
         !LET !NumP = !CONCAT(!NumP,' ').
         !LET !Var = !CONCAT('P',!LENGTH(!NumP)).
         COMPUTE !Var = $SYSMIS.
         COMPUTE !Var = !I.
         DO IF (SYSMIS(!Var)).
            COMPUTE @ERROR = 3.
         ELSE.
            IF (!Var<=0 OR !Var>=100) @ERROR=3.
         END IF.
      !DOEND.
      !LET !NumP = !LENGTH(!NumP).
*     Confidence level and test.
      COMPUTE @CL=$SYSMIS.
      COMPUTE @CL = !CL.
      DO IF (SYSMIS(@CL)).
         COMPUTE @ERROR = 4.
      ELSE.
         IF (@CL<=50 OR @CL>=100) @ERROR=4.
      END IF.
*     Add M1, N parameters and test.
      COMPUTE M0p = $SYSMIS.
      COMPUTE M1p = $SYSMIS.
      COMPUTE Np = $SYSMIS.
      !IF (!M1 <> !NULL !AND !N<>!NULL) !THEN.
         COMPUTE M1p = !M1.
         COMPUTE Np = !N.
         COMPUTE M0p = Np - M1p.
         DO IF (SYSMIS(M1p) OR SYSMIS(Np)).
            COMPUTE @ERROR=5.
         ELSE.
            IF (M1p<=0 OR Np <= M1p) @ERROR=5.
            IF (MOD(M1p,1)<>0 OR MOD(Np,1)<>0) @ERROR=6.
         END IF.
      !IFEND.
*     Add SE, SP parameters and test.
      COMPUTE SE = $SYSMIS.
      COMPUTE SP = $SYSMIS.
      !IF (!SE <> !NULL !AND !SP <> !NULL) !THEN.
         COMPUTE SE = !SE.
         COMPUTE SP = !SP.
         DO IF (SYSMIS(SE) OR SYSMIS(SP)).
            COMPUTE @ERROR=7.
         ELSE.
            IF (SE<=0 OR SE>=100 OR SP<=0 OR SP>=100) @ERROR=7.
         END IF.
      !IFEND.
      EXECUTE.
   
      DO IF (@ERROR=1).
         PRINT /'ERROR: Parameter(s) A1, A0, B1 or B0 with wrong values. See the HELP.'.
      ELSE IF (@ERROR=2).
         PRINT /'ERROR: Parameter(s) A1, A0, B1 or B0 with decimal values. See the HELP.'.
      ELSE IF (@ERROR=3).
         PRINT /'ERROR: Parameter P with wrong values. See the HELP.'.
      ELSE IF (@ERROR=4).
         PRINT /'ERROR: Parameter CL with wrong value. See the HELP.'.
      ELSE IF (@ERROR=5).
         PRINT /'ERROR: Parameter(s) M1 or N with wrong values. See the HELP.'.
      ELSE IF (@ERROR=6).
         PRINT /'ERROR: Parameter(s) M1 or N with decimal values. See the HELP.'.
      ELSE IF (@ERROR=7).
         PRINT /'ERROR: Parameter(s) SE or SP with wrong values. See the HELP.'.
      ELSE.
*        Print header.
         PRINT /'DIAGNOSTIC TESTS: ' !QUOTE(!Title).
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.
      END IF.
      EXECUTE.

*     Print Value Labels and Case Processing Summary (Individual Data).
      !IF (!VarTest<>!NULL !AND !VarRef<>!NULL) !THEN.
         DATASET ACTIVATE @9675Descrip.
         COMPUTE @U=1.
*        Add @ERROR variable with the error information.
         MATCH FILES FILE=* /TABLE='@9675DATA' BY @U /KEEP=@Var @Descrip Val Descrip @ERROR.
*        REFERENCE variable, NonCases and Cases values.
         DO IF ($casenum=1 AND @ERROR=0).
            PRINT //'Reference Criterion: ' !QUOTE(!VRef).
         END IF.
         EXECUTE.
         DO IF (@Var=1 AND Val=!ValNonCase AND @ERROR=0).
            PRINT /'            NonCase: ' Descrip.
         END IF.
         EXECUTE.
         DO IF (@Var=1 AND Val=!ValCase AND @ERROR=0).
            PRINT /'               Case: ' Descrip.
         END IF.
         EXECUTE.
*        Test variable, Negative and Positive values.
         DO IF ($casenum=1 AND @ERROR=0).
            PRINT //'    Diagnostic Test: ' !QUOTE(!VTest) .
         END IF.
         EXECUTE.
         DO IF (@Var=2 AND Val=!ValNeg AND @ERROR=0).
            PRINT /'           Negative: ' Descrip.
         END IF.
         EXECUTE.
         DO IF (@Var=2 AND Val=!ValPos AND @ERROR=0).
            PRINT /'           Positive: ' Descrip.
         END IF.
         EXECUTE.

*        Case Processing Summary.
         DATASET ACTIVATE @9675CASES.
         COMPUTE @U=1.
         MATCH FILES FILE=* /TABLE='@9675DATA' BY @U /KEEP=Valid_N Valid_Percent Total_N @ERROR.
         DO IF (@ERROR=0).
            PRINT //'Valid cases=' Valid_N(F6) '(' Valid_Percent(PCT6.1) ')'.
            PRINT  /'Total cases=' Total_N(F6).
         END IF.
         EXECUTE.
   
         DATASET ACTIVATE @9675DATA.
         DATASET CLOSE @9675Descrip.
         DATASET CLOSE @9675CASES.
      !IFEND.

*     CI compute method (PrCI): W (Wilson) = 1 - default; E (Exact) = 2; A (Asymptotic) = 3.
      COMPUTE @PrCI=0.
      IF (!QUOTE(!PrCIU)='W') @PrCI=1.
      IF (!QUOTE(!PrCIU)='E') @PrCI=2.
      IF (!QUOTE(!PrCIU)='A') @PrCI=3.
*     Determine text for the CI type.
      STRING @CItype (A9).
      IF (!QUOTE(!PrCIU)='W') @CItype = ' (Wilson)'.
      IF (!QUOTE(!PrCIU)='E') @CItype = ' (Exact)'.
      IF (!QUOTE(!PrCIU)='A') @CItype = ' (Asymp)'.

      DO IF (@ERROR=0).
         COMPUTE @Alpha=(@CL+100)/200.
         COMPUTE @Z=IDF.NORMAL(@Alpha,0,1).

         NUMERIC FP FN ubSe ubSp ubFP ubFN lbSe lbSp lbFP lbFN 
                 P PVp PVn PG ubP ubPVp ubPVn ubPG lbP lbPVp lbPVn lbPG .
         DO IF (@ST<4).
************Cross-Sectional or Case-Control study.
*           Compute the proportions (Se,Sp,FP,FN,P,PVp,PVn,PG).
            COMPUTE #AG = A1+B0.
            COMPUTE #BG = A0+B1.
            COMPUTE #AP = M1.
            COMPUTE #BP = M0.
            IF (@ST=3) #AP = M1p.
            IF (@ST=3) #BP = M0p.
            DO REPEAT P=Se Sp FP FN P PVp PVn PG
                     /A=A1 B0 B1 A0 #AP A1 B0 #AG 
                     /B=A0 B1 B0 A1 #BP B1 A0 #BG 
                   /ubP=ubSe ubSp ubFP ubFN ubP ubPVp ubPVn ubPG
                   /lbP=lbSe lbSp lbFP lbFN lbP lbPVp lbPVn lbPG.
               COMPUTE P = A/(A+B).
               DO IF (@PrCI=1).      /*Wilson bounds.
                  COMPUTE #WA = 2*A + @Z**2.
                  COMPUTE #WB = @Z * SQRT(@Z**2 + 4*A*(B)/(A+B)).
                  COMPUTE #WC = 2*((A+B) + @Z**2).
                  COMPUTE lbP= (#WA-#WB)/#WC.
                  COMPUTE ubP= (#WA+#WB)/#WC.
               ELSE IF (@PrCI=2).    /*Exact bounds.
                  COMPUTE lbP= 0.
                  COMPUTE ubP= 1.
                  IF (A > 0) lbP= A/(A+(B+1)*IDF.F(@Alpha,2*(B+1),2*A)).
                  IF (B > 0) ubP=(A+1)/((A+1)+(B/IDF.F(@Alpha,2*(A+1),2*B))).               
               ELSE IF (@PrCI=3).    /*Asymptotic bounds.
                  COMPUTE #SEAsymp = SQR(P*(1-P)/(A+B)).
                  COMPUTE ubP = P + @Z*#SEASymp.
                  COMPUTE lbP = P - @Z*#SEASymp.
               END IF.
            END REPEAT.
            COMPUTE LRp= Se/(1-Sp).
            COMPUTE LRn= (1-Se)/Sp.

            DO IF (@ST=3).
*              Predictive Values for Case Control study for a given prevalence (by Monsour, Evans y Kupper, 1991).
               COMPUTE SiGp= (1-Sp)*(1-P)/(Se*P).
               COMPUTE PVp = 1/(1+SiGp).
               COMPUTE SESiGp = SQR((1-Se)/(M1*Se) + (Sp)/(M0*(1-Sp)) + 1/(Np*P*(1-P))).
               COMPUTE ubPVp = 1/(1+(SiGp*EXP(-@Z*SESiGp))).
               COMPUTE lbPVp = 1/(1+(SiGp*EXP(@Z*SESiGp))).
               
               COMPUTE SiGn= (1-Se)*P/(Sp*(1-P)).
               COMPUTE PVn = 1/(1+SiGn).
               COMPUTE SESiGn = SQR(Se/(M1*(1-Se)) + (1-Sp)/(M0*Sp) + 1/(Np*P*(1-P))).
               COMPUTE ubPVn = 1/(1+(SiGn*EXP(-@Z*SESiGn))).
               COMPUTE lbPVn = 1/(1+(SiGn*EXP(@Z*SESiGn))).

               COMPUTE PVg = (P*Se+(1-P)*Sp)*100.
            END IF.
         ELSE.
*************Bayes Theorem study.
            COMPUTE Se = Se/100.
            COMPUTE Sp = Sp/100.
            COMPUTE FP = (1 - Sp)*100.
            COMPUTE FN = (1 - Se)*100.
            COMPUTE LRp= (Se/(1-Sp)).
            COMPUTE LRn= ((1-Se)/Sp).
         END IF.
         
*********Predictive Values from Hypothetical Prevalence.
         !LET !Pn = !CONCAT('P',!NumP).
         !LET !PVp = !CONCAT('PVp',!NumP).
         !LET !lbPVp = !CONCAT('lbPVp',!NumP).
         !LET !ubPVp = !CONCAT('ubPVp',!NumP).
         !LET !PVn = !CONCAT('PVn',!NumP).
         !LET !lbPVn = !CONCAT('lbPVn',!NumP).
         !LET !ubPVn = !CONCAT('ubPVn',!NumP).
         !LET !PVg = !CONCAT('PVg',!NumP).
         !LET !POp = !CONCAT('POp',!NumP).
         !LET !POn = !CONCAT('POn',!NumP).
         NUMERIC PVp1 TO !PVp lbPVp1 TO !lbPVp ubPVp1 TO !ubPVp PVn1 TO !PVn lbPVn1 TO !lbPVn ubPVn1 TO !ubPVn
                 PVg1 TO !PVg POp1 TO !POp POn1 TO !POn.
         COMPUTE #SESiGp = SQR((1-Se)/(M1*Se) + (Sp)/(M0*(1-Sp))).
         COMPUTE #SESiGn = SQR(Se/(M1*(1-Se)) + (1-Sp)/(M0*Sp)).
         DO REPEAT P=P1 TO !Pn /PVp=PVp1 TO !PVp /lbPVp=lbPVp1 TO !lbPVp /ubPVp=ubPVp1 TO !ubPVp 
                /PVn=PVn1 TO !PVn /lbPVn=lbPVn1 TO !lbPVn /ubPVn=ubPVn1 TO !ubPVn
                /PVg=PVg1 TO !PVg /POp=POp1 TO !POp /POn=POn1 TO !POn.
            COMPUTE P=P/100.
            DO IF (@ST<4).
*              Cross-Sectional or Case-Control Study.
               COMPUTE #SiGp= (1-Sp)*(1-P)/(Se*P).
               COMPUTE #SiGn= (1-Se)*P/(Sp*(1-P)).
               COMPUTE PVp = (1/(1+#SiGp))*100.
               COMPUTE PVn = (1/(1+#SiGn))*100.
               COMPUTE ubPVp = (1/(1+(#SiGp*EXP(-@Z*#SESiGp))))*100.
               COMPUTE lbPVp = (1/(1+(#SiGp*EXP(@Z*#SESiGp))))*100.
               COMPUTE ubPVn = (1/(1+(#SiGn*EXP(-@Z*#SESiGn))))*100.
               COMPUTE lbPVn = (1/(1+(#SiGn*EXP(@Z*#SESiGn))))*100.
            ELSE.
*              Bayes theorem.
               COMPUTE PVp = ((P*Se)/(P*Se+(1-P)*(1-Sp))).
               COMPUTE PVn = (((1-P)*Sp)/((1-P)*Sp+P*(1-Se))).
               COMPUTE PVg = (P*Se+(1-P)*Sp).
               COMPUTE POp = PVp/(1-PVp).
               COMPUTE POn = PVn/(1-PVn).
               COMPUTE PVp = PVp*100.
               COMPUTE PVn = PVn*100.
               COMPUTE PVg = PVg*100.
            END IF.
            COMPUTE P = P*100.
         END REPEAT.
      END IF.
      EXECUTE.

*********PRINT RESULTS.
      DO IF (@ERROR=0).
*        Print data table.
         DO IF (@ST=1).
            PRINT//'                   | Reference Criterion |       |'.
            PRINT /'   Diagnostic Test | NonCases |    Cases | TOTAL |'.
            PRINT /'-------------------+----------+----------+-------+'.
            PRINT /'          Positive |' B1(T24,F6) ' |' A1(T35,F6) ' |' N1(F6) ' |'.
            PRINT /'          Negative |' B0(T24,F6) ' |' A0(T35,F6) ' |' N0(F6) ' |'.
            PRINT /'-------------------+----------+----------+-------+'.
            PRINT /'             TOTAL |' M0(T24,F6) ' |' M1(T35,F6) ' |' N(F6) ' |'/.
         ELSE IF (@ST=2).
            PRINT//'                   | Reference Criterion |'.
            PRINT /'   Diagnostic Test | NonCases |    Cases |'.
            PRINT /'-------------------+----------+----------+'.
            PRINT /'          Positive |' B1(T24,F6) ' |' A1(T35,F6) ' |'.
            PRINT /'          Negative |' B0(T24,F6) ' |' A0(T35,F6) ' |'.
            PRINT /'-------------------+----------+----------+'.
            PRINT /'             TOTAL |' M0(T24,F6) ' |' M1(T35,F6) ' |'/.
         ELSE IF (@ST=3).
            PRINT//'                   | Reference Criterion |'.
            PRINT /'   Diagnostic Test | NonCases |    Cases |'.
            PRINT /'-------------------+----------+----------+'.
            PRINT /'          Positive |' B1(T24,F6) ' |' A1(T35,F6) ' |'.
            PRINT /'          Negative |' B0(T24,F6) ' |' A0(T35,F6) ' |'.
            PRINT /'-------------------+----------+----------+'.
            PRINT /'             TOTAL |' M0(T24,F6) ' |' M1(T35,F6) ' | TOTAL |'.
            PRINT /'                   +----------+----------+-------+'.
            PRINT /' POPULATION SAMPLE |' M0p(T24,F6) ' |' M1p(T35,F6) ' |' Np(F6) ' |'/.
         END IF.

         DO IF (@ST<4).
*           Prepare tha data for print.
            DO REPEAT P=Se Sp FP FN P PVp PVn PG
                   /ubP=ubSe ubSp ubFP ubFN ubP ubPVp ubPVn ubPG
                   /lbP=lbSe lbSp lbFP lbFN lbP lbPVp lbPVn lbPG.
               COMPUTE P   = P*100.
               COMPUTE ubP = ubP*100.
               COMPUTE lbP = lbP*100.
            END REPEAT.

************Cross-Sectional or Case-Control study.
*           Print Se,Sp,FP,FN,LRp,LRn results.
            PRINT /'-------------------+----------+----------------------------'.
            PRINT /'                   | Estimate | ' !QUOTE(!CL) '% Confidence Interval'.
            PRINT /'-------------------+----------+----------------------------'.
            PRINT /'       Sensitivity |' Se(T22,F7.3) '% |' lbSe(T33,F7.3) ' to ' ubSe(F7.3) @CItype.
            PRINT /'       Specificity |' Sp(T22,F7.3) '% |' lbSp(T33,F7.3) ' to ' ubSp(F7.3) @CItype.
            PRINT /'    False positive |' FP(T22,F7.3) '% |' lbFP(T33,F7.3) ' to ' ubFP(F7.3) @CItype.
            PRINT /'    False negative |' FN(T22,F7.3) '% |' lbFN(T33,F7.3) ' to ' ubFN(F7.3) @CItype.
            PRINT /'  Likelihood Ratio:|          |'.
            PRINT /'          Positive |' LRp(T22,F7.3)'  |'.
            DO IF (LRp<1).
               COMPUTE #ILRp=1/LRp.
               PRINT /'  inverse Positive |' #ILRp(T22,F7.3)'  |'.
            END IF.
            PRINT /'          Negative |' LRn(T22,F7.3)'  |'.
            DO IF (LRn<1).
               COMPUTE #ILRn=1/LRn.
               PRINT /'  inverse Negative |' #ILRn(T22,F7.3)'  |'.
            END IF.
            PRINT /'-------------------+----------+----------------------------'.
            
*           Print Pe, PVp, PVn, (PVg) results.
            DO IF (@ST<>2).
               PRINT /'        Prevalence |' P(T22,F7.3) '% |' lbP(T33,F7.3) ' to ' ubP(F7.3) @CItype.
               PRINT /' Predictive Values:|          |'.
               IF (@ST=3) @CItype = ' (Asymp)*'.
               PRINT /'          Positive |' PVp(T22,F7.3) '% |' lbPVp(T33,F7.3) ' to ' ubPVp(F7.3) @CItype.
               PRINT /'          Negative |' PVn(T22,F7.3) '% |' lbPVn(T33,F7.3) ' to ' ubPVn(F7.3) @CItype.
               DO IF (@ST=1).
                  PRINT /'        Efficiency |' PG(T22,F7.3) '% |' lbPG(T33,F7.3) ' to ' ubPG(F7.3) @CItype.
               ELSE IF (@ST=3).
                  PRINT /'        Efficiency |' PVg(T22,F7.3) '% |'.
               END IF.
               PRINT /'-------------------+----------+----------------------------'.
               DO IF (@ST=3).
                  PRINT /'(*) Monsour, Evans & Kupper. Stat Med.1991;443-56.'.
               END IF.
            END IF.

*           Print Predictive Values from Hypothetical Prevalence.
            PRINT//'            |             Predictive Values*             |'.
            PRINT /'Hypothetical|    (' !QUOTE(!CL) '% Asymptotic Confidence interval)    |'.
            PRINT /' Prevalence |    Positive         |     Negative         |'.
            PRINT /'------------+---------------------+----------------------+'.
            DO REPEAT P=P1 TO !Pn /PVp=PVp1 TO !PVp /lbPVp=lbPVp1 TO !lbPVp /ubPVp=ubPVp1 TO !ubPVp 
                   /PVn=PVn1 TO !PVn /lbPVn=lbPVn1 TO !lbPVn /ubPVn=ubPVn1 TO !ubPVn.
               PRINT / P(T5,F6.2) '% | ' PVp(F7.3) '|'35 PVn(T38,F7.3) '|'58.
               PRINT / '| ('13 lbPVp(F6.3) ' to ' ubPVp(F7.3) ') | (' lbPVn(F7.3) ' to ' ubPVn(F7.3) ') |'.
            END REPEAT.
            PRINT /'------------+---------------------+----------------------+'.
            PRINT /'(*) Assumed constant Sensibility and Specificity'.
         ELSE.
************Bayes theorem.
            COMPUTE Se= Se*100.
            COMPUTE Sp= Sp*100.
            PRINT//'   Sensibility = ' Se(F7.3) '%    Likelihood Ratio Positive =  ' LRp(F7.3).
            DO IF (LRp<1 AND LRn>=1).
               COMPUTE #ILRp=1/LRp.
               PRINT /'   Specificity = ' Sp(F7.3)'%'  'inverse Positive =  '39 #ILRp(F7.3).
               PRINT /'False positive = ' FP(F7.3)'%'  'Negative =  '47 LRn(F7.3).
               PRINT /'False negative = ' FN(F7.3)'%'.
            ELSE IF (LRp>=1 AND LRn<1).
               COMPUTE #ILRn=1/LRn.
               PRINT /'   Specificity = ' Sp(F7.3)'%'  'Negative =  '47 LRn(F7.3).
               PRINT /'False positive = ' FP(F7.3)'%'  'inverse Negative =  '39 #ILRn(F7.3).
               PRINT /'False negative = ' FN(F7.3)'%'.
            ELSE IF (LRp<1 AND LRn<1).
               COMPUTE #ILRp=1/LRp.
               COMPUTE #ILRn=1/LRn.
               PRINT /'   Specificity = ' Sp(F7.3)'%'  'inverse Positive =  '39 #ILRp(F7.3).
               PRINT /'False positive = ' FP(F7.3)'%'  'Negative =  '47 LRn(F7.3).
               PRINT /'False negative = ' FN(F7.3)'%'  'inverse Negative =  '39 #ILRn(F7.3).
            END IF.

*           Print Predictive Values, Efficiency and Posterior Odds from Hypothetical Prevalence.
            PRINT//'Hypothetical|  Predictive Values  |          |  Posterior Odds   |'.
            PRINT /' Prevalence | Positive | Negative |Efficiency|   (+)   |   (-)   |'.
            PRINT /'------------+----------+----------+----------+---------+---------+'.
            DO REPEAT P=P1 TO !Pn /PVp=PVp1 TO !PVp /PVn=PVn1 TO !PVn/PVg=PVg1 TO !PVg /POp=POp1 TO !POp /POn=POn1 TO !POn.
               PRINT / P(T6,F5.2) '% |' PVp(F8.4) '% |' PVn(F8.4) '% |' PVg(F8.4) '% | ' POp(T50,F5.2) ' | ' POn(T60,F5.2) ' |'.
            END REPEAT.
            PRINT /'------------+----------+----------+----------+---------+---------+'.
         END IF.
      END IF.
      EXECUTE.
      
      DATASET ACTIVATE @original.
      DATASET CLOSE @9675DATA.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
