PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !ROC V2010.02.04 loaded.'
         /'Execute !ROC HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !ROC	(TV =!CHAREND('/') 
		      /SV =!CHAREND('/') 
		    /PREV =!CHAREND('/') 
		    /COST =!CHAREND('/') !DEFAULT ('1')
		      /IC =!CHAREND('/') !DEFAULT ('1')
		     /TVS =!CHAREND('/') !DEFAULT ('1')
		      /CL =!CHAREND('/') !DEFAULT ('95')
		   /PRINT =!CHAREND('/') !DEFAULT (0)
		     /NST =!CHAREND('/')
          /HELP =!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2010.02.04').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
!LET !WINDOW='HIDDEN'.
DO IF ($casenum=1).
   PRINT //'Macro !ROC V' !VERSION ' (c)JM.Domenech & R.Granero'.
END IF.
!IF (!HELP<>1) !THEN.
*  Print HELP.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* ROC ANALYSIS                                                               *'
            /'* Created 1998.04.03 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech & R.Granero                                                *'
            /'* Programmers: A.Bonillo & R.Sesma                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM, Granero R. Macro !ROC for SPSS Statistics.                    *'
            /'*    Roc Analysis [computer program].                                        *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* !ROC TV = Test variable  (continuous scale)                                *'
            /'*     /SV = State variable                                                   *'
            /'*    [/IC]= Code of "Illness" group                         (by default: 1)  *'
            /'*           "Non-illness" group: Codes not equal to IC                       *'
            /'*   [/TVS]= "Illness" increase test variable: 1=Yes 0=No    (by default: 1)  *'
            /'*  [/Prev]= Prevalence of "illness" in the population        (0 < PREV < 1)  *'
            /'*                                           (by default: sample prevalence)  *'
            /'*  [/Cost]= Ratio False-Negative/Positive Cost   (FNC/FPC >0; by default: 1) *'
            /'*  [/Print] Plot Boxplot & ROC curve                                         *'
            /'*           By default: Print  coordinate points & optimal cutoff points     *'
            /'*   [ /CL]= Confidence level(%)            (50 <= CL < 100; by default: 95)  *'
            /'*   [/NST]= Name of the study (Label)                                        *'
            /'*   [/Help] Print Macro call arguments and Samples of calls                  *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
            /'*                                                                            *'
            /'* WARNING: The macro provides wrong results if your data are filtered.       *'
            /'*          To work with a set of cases you must use SELECT IF procedure in   *'
            /'*          order to create a new data file containing only selected cases.   *'
            /'*                                                                            *'
            /'* Samples of calls:                                                          *'
            /'* !ROC HELP.                                                                 *'
            /'* !ROC TV=glucemia /SV=diabetes /IC=1 /TVS=1 /PREV=0.14                      *'
            /'*     /Cost=2 /CL=90 /NST="Name of the Study".                               *'
            /'******************************************************************************'.
   END IF.
!ELSE.
*  Test parameters.
   !LET !ERROR=0.

*  Check missing parameters.
   !IF (!TV=!NULL !OR !SV=!NULL) !THEN
      !LET !ERROR=1.
   !IFEND.
*  Comprobar parmetro TVS.
   !IF (!TVS<>1 !AND !TVS<>0) !THEN.
      !LET !ERROR=2.
   !IFEND.
*  Comprobar parmetro PREV (si presente).
   !IF (!PREV<>!NULL) !THEN.
      !IF (!PREV<=0 !OR !PREV>=1) !THEN
         !LET !ERROR=3.
      !IFEND.
   !IFEND.
*  Comprobar parmetro COST.
   !IF (!COST<=0) !THEN
      !LET !ERROR=4.
   !IFEND.
*  Comprobar parmetro CL.
   !IF (!CL<50 !OR !CL>99) !THEN
      !LET !ERROR=5.
   !IFEND.

   !IF (!ERROR<>0) !THEN.
      TEMPORARY.
      N 1.
      !IF (!ERROR=1) !THEN.
         PRINT /'ERROR: Missing parameter TV or SV.See the HELP.'.
      !IFEND.
      !IF (!ERROR=2) !THEN.
         PRINT /'ERROR: Parameter TVS with wrong value. See the HELP.'.
      !IFEND.
      !IF (!ERROR=3) !THEN.
         PRINT /'ERROR: Parameter Prev with wrong value. See the HELP.'.
      !IFEND.
      !IF (!ERROR=4) !THEN.
         PRINT /'ERROR: Parameter Cost with wrong value. See the HELP.'.
      !IFEND.
      !IF (!ERROR=5) !THEN.
         PRINT /'ERROR: Parameter CL with wrong value. See the HELP.'.
      !IFEND.
      EXECUTE.
   !ELSE.
*     Name the original dataset.
      DATASET NAME @original.
   
*     Print NST if available.
      TEMPORARY.
      N 1.
      !IF (!NST !NE !NULL) !THEN.
         STRING #NST (A131).
         COMPUTE #NST = CONCAT('STUDY: ',!NST).
         PRINT /#NST /.
      !IFEND.
      EXECUTE.

*     Print the Boxplot (if asked).
      !IF (!PRINT<>0) !THEN.
         EXAMINE VARIABLES=!TV BY !SV
           /PLOT=BOXPLOT /STATISTICS=NONE /NOTOTAL
           /MISSING=REPORT.
      !IFEND.

*     Parameter TVS defines TestPos parameter of the ROC command.
*     TVS = 1 -> TESTPOS = LARGE, The larger the test result value is, the more positive the test result is.
*     TVS = 0 -> TESTPOS = SMALL, The smaller the test result value is, the more positive the test result is.
      !LET !TESTPOS='LARGE'.
      !LET !PointName='PositiveifGreaterThanorEqualTo'.
      !IF (!TVS=0) !THEN.
         !LET !TESTPOS='SMALL'.
         !LET !PointName='PositiveifLessThanorEqualTo'.
      !IFEND.
*     Execute the ROC command to obtain data (and print the graphic if asked).
      PRESERVE.            /*Set output language to english (OMS).
      SET OLANG=ENGLISH.
*     Obtain the data using OMS to store it on temporary datasets.
      OMS /SELECT ALL  /IF COMMANDS=['ROC Curve']  /DESTINATION VIEWER=NO.
      DATASET DECLARE @95617ROC WINDOW=!WINDOW.
      OMS  /SELECT TABLES  /IF COMMANDS=['ROC Curve'] SUBTYPES=['Coordinates of the Curve']
           /DESTINATION FORMAT=SAV NUMBERED=Num OUTFILE='@95617ROC'.
      DATASET DECLARE @95617CASES WINDOW=!WINDOW.
      OMS  /SELECT TABLES  /IF COMMANDS=['ROC Curve'] SUBTYPES=['Case Processing Summary']
           /DESTINATION FORMAT=SAV NUMBERED=Num OUTFILE='@95617CASES'.
      DATASET DECLARE @95617AUC WINDOW=!WINDOW.
      OMS  /SELECT TABLES  /IF COMMANDS=['ROC Curve'] SUBTYPES=['Area Under the Curve']
           /DESTINATION FORMAT=SAV NUMBERED=Num OUTFILE='@95617AUC'.
      ROC !TV BY !SV (!IC) /PLOT=NONE /PRINT=COORDINATES /CRITERIA=TESTPOS(!TESTPOS).
      OMSEND.     
      !IF (!PRINT<>0) !THEN.
*        Print ONLY the ROC curve.
         OMS /SELECT TABLES  /IF COMMANDS=['ROC Curve'] /DESTINATION VIEWER=NO.
         ROC !TV BY !SV (!IC) /PLOT=CURVE(REFERENCE) /CRITERIA=TESTPOS(!TESTPOS).
         OMSEND.
      !IFEND.
      RESTORE.

*     From the Case Processing Summary, obtain the number of positives, negatives and total valid
      The fist row has the number of positives; the second row has the number of negatives
      Use function LEAD from CREATE to put the number of negatives at the first row
      Finally, keep only the first row with the interesting data.
      DATASET ACTIVATE @95617CASES.
      MATCH FILES FILE=* /RENAME (ValidNlistwise=Npos) /KEEP=Num Npos.
      EXECUTE.
      PRESERVE.
      SET ERRORS=NONE MESSAGES=NONE RESULTS=NONE.
      CREATE /Nneg=LEAD(Npos,1).
      RESTORE.
      COMPUTE Ntot = Npos + Nneg.
      N 1.
      EXECUTE.

*     From the Area Under the Curve obtain the AUC and its CI
      SPSS computes the AUC; add the data from CASES dataset to compute its Exact CI.
      DATASET ACTIVATE @95617AUC.
      MATCH FILES FILE=* /RENAME (Area=AUC) /KEEP=Num AUC.
      MATCH FILES FILE=* /TABLE='@95617CASES' /BY Num.
      EXECUTE.
      COMPUTE B=AUC*Ntot.
      COMPUTE A=(95+100)/200.
      COMPUTE lbAUC= B /(B + (Ntot-B+1)*IDF.F(A, 2*(Ntot-B+1), 2*B)).
      COMPUTE ubAUC=(B+1)/(B+1 +(Ntot-B)/IDF.F(A,2*(B+1),2*(Ntot-B))).
      EXECUTE.

*     PRINT results: number of cases, area under the curve.
      PRINT //'-------------------------------------------------------------------'.
      PRINT  /' Valid cases (total): ' Ntot(F4).
      PRINT  /' Area Under Curve: AUC= ' AUC (F6.5) ' ('!QUOTE(!CL) '% CI: ' lbAUC(F6.5) ' to ' ubAUC (F6.5) ') (Exact)'.
      PRINT  /'-------------------------------------------------------------------'.
      EXECUTE.

*     From the Coordinates of the Curve obtain the Se, Sp and the CutOff points.
      DATASET ACTIVATE @95617ROC WINDOW=FRONT.
*     SPSS computes 1-Specificity, compute Specificity.
      COMPUTE Sp = 1 - @1Specificity.
      MATCH FILES FILE=* /RENAME (!PointName Sensitivity @1Specificity=CutOff Se @1Sp) /KEEP=Num CutOff Se Sp @1Sp.
      EXECUTE.

*     Use the CutOff points fromt the points provided by SPSS, corrected:
      The first point is the minimum observed point - 1: +1 to the first case
      The last point is the maximum observed point + 1:  -1 to the last case.
      COMPUTE @Num = $CASENUM.
      AGGREGATE OUTFILE=* MODE=ADDVARIABLES /@Nmax=N.
      IF (@Num=1) CutOff = CutOff + 1.
      IF (@Num=@Nmax) CutOff = CutOff - 1.
*     OLD (DISABLED in the v2010-02-04): The points (different from the first and the last) 
      are the mean between two consecutive points.
*     IF (@Num>1 AND @Num<@Nmax) CutOff = LAG(CutOff,1) + (Point - LAG(CutOff,1))*2.

*     Remove from the data the points with Se=1,Sp=0 and Sp=0,Se=1.
      SELECT IF NOT((Se=1 AND Sp=0) OR (Se=0 AND Sp=1)).
      MATCH FILES FILE=* /KEEP=Num CutOff Se Sp @1Sp.
      MATCH FILES FILE=* /TABLE='@95617CASES' /BY Num.
      EXECUTE.

*     Close temporary datasets.
      DATASET CLOSE @95617CASES.
      DATASET CLOSE @95617AUC.

*     Prevalence: Sample or provided.
      !LET !SAMPLE=0.
      !IF (!PREV=!NULL) !THEN.
         COMPUTE Preval = NPos/Ntot.
         !LET !TEXT= 'SAMPLE prevalence'.
         !LET !SAMPLE=1.
      !ELSE.
         COMPUTE Preval = !PREV.
         !LET !TEXT= 'Prevalence'.
      !IFEND.
      COMPUTE @Preval = Preval*100.

*     Percentages.
      COMPUTE Se= Se*100.
      COMPUTE Sp= Sp*100.
      COMPUTE @1Sp= @1Sp*100.
*     Compute J, LR+, LR-, PV+, PV-.
      COMPUTE J = Se-@1Sp.
      IF (Sp <> 100) LR_POS =(Se/@1Sp).
      IF (Sp <> 0)   LR_NEGinv =1/((100-Se)/Sp).
      IF (Se <> 0)   VP_POS =100*(Preval*Se)/((Preval*Se)+((1-Preval)*(@1Sp))).
      IF (Sp <> 0)   VP_NEG =100*((1-Preval)*Sp)/((Preval*(100-Se))+((1-Preval)*Sp)).
      EXECUTE.

      STRING  Sign (A2).
      COMPUTE Sign='>='.         /*Sign text (depends on the TVS parameter).
      !IF (!TVS=0) !THEN.
         COMPUTE Sign='<='.
      !IFEND.
*     PRINT results: CUT-OFF points, Se, Sp, J, LR+, 1/LR-, PV+, PV-.
      TEMPORARY.
      N 1.
*     Header.
      PRINT /'                                  Likelihood    Predictive Values*'.
      !IF (!SAMPLE=1) !THEN.
         PRINT /'                                    Ratios    for SAMPLE Prevalence'.
      !ELSE.
         PRINT /'                                    Ratios    for Prevalence=' @Preval(F5.1) '%'.
      !IFEND.
      PRINT /'                         Youden ------------- ---------------------'.
      PRINT /' CUT-OFF    Se(%)  Sp(%)  J(%)    LR+   1/LR-    PV+(%)    PV-(%)'.
      PRINT /'---------  ------ ------ ------ ------ ------  --------- ---------'.
      EXECUTE.
*     Data.
      PRINT / Sign(A2) CutOff(F7.2) Se(T12,F5.1) Sp(T19,F5.1) J(T26,F5.1) LR_POS(T33,F6.2) LR_NEGinv(T40,F6.2) VP_POS(T50,F5.1) VP_NEG(T60,F5.1) .
      EXECUTE.
*     Footnote.
      TEMPORARY.
      N 1.
      PRINT /'-------------------------------------------------------------------'.
      !IF (!SAMPLE=1) !THEN.
         PRINT /'(*)SAMPLE prevalence=' @Preval(F5.2) '%'.
      !ELSE.
         PRINT /'(*)Assumed constant Sensitivity and Specificity'.
      !IFEND.
      EXECUTE.

*     OPTIMAL CUT-OFF POINT 
      From Receiver-Operating Characteristic (ROC) Plots: A Fundamental Evaluation Tool in Clinical Medicine
      Zweig & Campbell, Clinical Chemistry, vol 39, no 4, pag 572 (1993).
*     Add COST: compute a slope m = (false-positive cost/false-negative cost)*((1-Preval)/Preval) = (1/!Cost)*((1-Preval)/Preval).
      COMPUTE M=(1/!Cost)*((1-Preval)/Preval).
*     The OPTIMAL point is the Se,Sp pair that maximizes the function [Se - m(1-Sp)], where m is the slope previously computed
      Compute the function for each Se,Sp,M and use AGGREGATE to find the maximum value.
      COMPUTE Opt= (Se-M*(100-Sp)).
      AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /BREAK=Num /MaxOpt = MAX(Opt).

*     @Optimal = 1 for the optimal Cut-Off point; Noptimal: number of optimal cut-off points.
      COMPUTE Optimal = (MaxOpt=Opt).
      COMPUTE @Noptimal = @NOptimal + Optimal.
      LEAVE @Noptimal.
      EXECUTE.
      AGGREGATE OUTFILE=* MODE=ADDVARIABLES /BREAK = Optimal /Noptimal = MAX(@NOptimal).

*     Optimal Cut-Off point: Opt = MaxOpt.
      TEMPORARY.
      SELECT IF (Opt=MaxOpt).
*     Compute Wilson CI for Se, Sp at the Optimal Cut-Off point.
      COMPUTE @Z=IDF.NORMAL((!CL+100)/200,0,1).
*     Se.
      COMPUTE #N=Npos.
      COMPUTE #A=(Se/100)*#N.
      COMPUTE #WA = 2*#A + @Z**2.
      COMPUTE #WB = @Z * SQRT(@Z**2 + 4*#A*(#N-#A)/#N).
      COMPUTE #WC = 2*(#N + @Z**2).
      COMPUTE lbSe= ((#WA-#WB)/#WC)*100.
      COMPUTE ubSe= ((#WA+#WB)/#WC)*100.
*     Sp.
      COMPUTE #N=Nneg.
      COMPUTE #A=(Sp/100)*#N.
      COMPUTE #WA = 2*#A + @Z**2.           /*Wilson bounds.
      COMPUTE #WB = @Z * SQRT(@Z**2 + 4*#A*(#N-#A)/#N).
      COMPUTE #WC = 2*(#N + @Z**2).
      COMPUTE lbSp= ((#WA-#WB)/#WC)*100.
      COMPUTE ubSp= ((#WA+#WB)/#WC)*100.
*     PRINT results: Optimal CutOff Point.
      PRINT //'OPTIMAL CUTOFF POINT= ' CutOff(F6.2) ' for: ' !QUOTE(!TEXT) ' = ' @Preval(F5.2) '%'. 
      PRINT  /'                                  Ratio FNcost/FPcost = ' !QUOTE(!COST).
      PRINT  /' Sensitivity: Se= ' Se(F5.2) '% ('!QUOTE(!CL) '% CI: ' lbSe(F5.2) ' to ' ubSe(F5.2) ') (Wilson)'.
      PRINT  /' Specificity: Sp= ' Sp(F5.2) '% ('!QUOTE(!CL) '% CI: ' lbSp(F5.2) ' to ' ubSp(F5.2) ') (Wilson)'.
      PRINT  /' Positive predictive value*: PV+ = ' VP_POS(F5.2) '%'.
      PRINT  /' Negative predictive value*: PV- = ' VP_NEG(F5.2) '%'.
*     Print a warning for multiple cutoff points.
      DO IF (Noptimal>1 and @NOptimal=NOptimal).
         PRINT /'WARNING!!! Multiple optimal cutoff points'.
      END IF.
      EXECUTE.

*     Compute the Hypothetical Prevalence x FNC table.
*     Print the header.
      TEMPORARY.
      N 1.
      PRINT//'OPTIMAL CUTOFF POINT**'.
      PRINT /'Hypothetical  ---------- False Negative Cost / False Positive Cost ---------'.
      PRINT /'Prevalence*    1/16    1/8    1/4    1/2     1      2      4      8     16'.
      PRINT /'------------- ------ ------ ------ ------ ------ ------ ------ ------ ------'.
      EXECUTE.
*     Loop through the Hypothetical Prevalences.
      !LET !PrevList = '0.05 0.10 0.20 0.30 0.40 0.50'.
      !LET !CountP=' '.
      !DO !P !IN (!PrevList).
         !LET !Opt1n = !CONCAT('Opt',!LENGTH(!CountP),'1').
         !LET !Opt9n = !CONCAT('Opt',!LENGTH(!CountP),'9').
         !LET !MaxOpt1n = !CONCAT('MaxOpt',!LENGTH(!CountP),'1').
         !LET !MaxOpt9n = !CONCAT('MaxOpt',!LENGTH(!CountP),'9').

         NUMERIC !Opt1n to !Opt9n .
*        For each prevalence, compute Opt for each FNC.
         DO REPEAT FNC=0.0625 0.125 0.25 0.5 1 2 4 8 16 /OptN=!Opt1n to !Opt9n.
            COMPUTE #M=(1/FNC)*((1-!P)/!P).
            COMPUTE OptN= (Se - #M*(100-Sp)).
         END REPEAT.
         AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /BREAK=Num /!MaxOpt1n to !MaxOpt9n = MAX(!Opt1n to !Opt9n).

*        Get the Best operating point for each cost.         
         !LET !CutOff1n = !CONCAT('@CutOff',!LENGTH(!CountP),'1').
         !LET !CutOff9n = !CONCAT('@CutOff',!LENGTH(!CountP),'9').
         !LET !Se1n = !CONCAT('@Se',!LENGTH(!CountP),'1').
         !LET !Se9n = !CONCAT('@Se',!LENGTH(!CountP),'9').
         !LET !Sp1n = !CONCAT('@Sp',!LENGTH(!CountP),'1').
         !LET !Sp9n = !CONCAT('@Sp',!LENGTH(!CountP),'9').
         !LET !CutOff1 = !CONCAT('CutOff',!LENGTH(!CountP),'1').
         !LET !CutOff9 = !CONCAT('CutOff',!LENGTH(!CountP),'9').
         !LET !Se1 = !CONCAT('Se',!LENGTH(!CountP),'1').
         !LET !Se9 = !CONCAT('Se',!LENGTH(!CountP),'9').
         !LET !Sp1 = !CONCAT('Sp',!LENGTH(!CountP),'1').
         !LET !Sp9 = !CONCAT('Sp',!LENGTH(!CountP),'9').
         NUMERIC !CutOff1n to !CutOff9n !Se1n to !Se9n !Sp1n to !Sp9n.
         DO REPEAT Opt=!Opt1n to !Opt9n /MaxOpt=!MaxOpt1n to !MaxOpt9n 
               /CutOffN=!CutOff1n to !CutOff9n /SeN=!Se1n to !Se9n /SpN=!Sp1n to !Sp9n.
            IF (Opt=MaxOpt) CutOffN = CutOff.
            IF (Opt=MaxOpt) SeN = Se.
            IF (Opt=MaxOpt) SpN = Sp.
         END REPEAT.         
         AGGREGATE /OUTFILE=* MODE=ADDVARIABLES /BREAK=Num
                   /!CutOff1 to !CutOff9 = FIRST(!CutOff1n to !CutOff9n)
                   /!Se1 to !Se9 = FIRST(!Se1n to !Se9n) /!Sp1 to !Sp9 = FIRST(!Sp1n to !Sp9n).

*        Print results.
         TEMPORARY.
         N 1.
         COMPUTE #P=!P*100.
         PRINT / #P(F5) '% Cutoff ' !CutOff1 to !CutOff9(9(F6.2,X)).
         PRINT /'           Se  '   !Se1 to !Se9(9(PCT5.1,2X)).
         PRINT /'           Sp  '   !Sp1 to !Sp9(9(PCT5.1,2X)).
         !IF (!LENGTH(!CountP)=6) !THEN.
            PRINT /'----------------------------------------------------------------------------'.
            PRINT /'(*)Assumed constant Sensitivity and Specificity'.
            PRINT /'(**)Zweig & Campbell. Clin Chem. 1993;39:561-77.'.
         !ELSE.
            PRINT /''.
         !IFEND.
         EXECUTE.
        
         !LET !CountP = !CONCAT(!CountP,' ').
      !DOEND.

*     Restore the original dataset and close temporary dataset ROC.
      DATASET ACTIVATE @original.
      DATASET CLOSE @95617ROC.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
