PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !RNDI V2011.09.09 loaded.'
         /'Execute !RNDI HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !RNDI( LN=!CHAREND('/') /HN=!CHAREND('/') 
             /N =!CHAREND('/')
         /ORDER =!CHAREND('/')!DEFAULT('A')
          /SEED =!CHAREND('/')!DEFAULT(RANDOM) 
           /NST =!CHAREND('/')
           /HELP=!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2011.09.09').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
   PRINT //'Macro !RNDI V' !VERSION ' (c)JM.Domenech & R.Granero'.
END IF.
!IF (!HELP<>1) !THEN.
*  Print HELP.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* EXTRACTION OF N RANDOM INTEGERS FROM LN TO HN (Exhaustive sampling)        *'
            /'* Created 1999.03.09 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech & R.Granero                                                *'
            /'* Programmers: A.Bonillo & R.Sesma                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM, Granero R. Macro !RNDI for SPSS Statistics.                   *'
            /'*    Extraction of N Random Integers from LN to HN (Exhaustive sampling)     *'
            /'*    [computer program].                                                     *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* !RNDI LN = Low case number                   (Integer > 0)                 *'
            /'*      /HN = High case number                  (Integer > LN)                *'
            /'*       /N = Sample size (exhaustive sampling) (Integer > 0)                 *'
            /'*  [/ORDER]= Print case order:                                               *'
            /'*            A  Ascending                      by default: A                 *'
            /'*            D  Descending                                                   *'
            /'*            U  Unsorted                                                     *'
            /'*   [/SEED]= Initialization value; by default: RANDOM  (any real number)     *'
            /'*            The Mersenne Twister (MT) random number generator is used       *'
            /'*    [/NST]= Name of the study (Label)                                       *'
            /'*    [/HELP] Print Macro call arguments and Samples of calls                 *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
            /'*                                                                            *'
            /'* Samples of calls:                                                          *'
            /'* !RNDI HELP.                                                                *'
            /'* !RNDI LN=1 /HN=10 /N=5 /ORDER=U /SEED= 1769583145.                         *'
            /'* !RNDI LN=1000 /HN=7853 /N=50 /NST="Name of the Study".                     *'
            /'******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Test parameters.
   !LET !ERROR = 0.
   !IF (!LN=!NULL !OR !HN=!NULL !OR !N=!NULL) !THEN.
      !LET !ERROR = 1.        /*Missing parameters.
   !ELSE.   
*     Test ORDER.
      !LET !ORDERU=!UPCASE(!ORDER).
      !IF (!ORDERU<>'A' !AND !ORDERU<>'D' !AND !ORDERU<>'U') !THEN.
         !LET !ERROR = 2.
      !IFEND.
      !LET !ALFABET=ABCDEFGHIJKLMNOPQRSTUVWXYZ.
      !IF (!N<=0 !OR !INDEX(!ALFABET,!UPCASE(!N))>0) !THEN.
         !LET !ERROR = 3.
      !ELSE.
         !IF (!LN<=0 !OR !INDEX(!ALFABET,!UPCASE(!LN))>0) !THEN.
            !LET !ERROR = 4.
         !ELSE.
            !IF (!HN<=0 !OR !INDEX(!ALFABET,!UPCASE(!HN))>0) !THEN.
               !LET !ERROR = 5.
            !ELSE.
               !IF (!HN<=!LN) !THEN.
                  !LET !ERROR = 6.
               !ELSE.
                  !LET !NEL=!LENGTH(!SUBSTR(!CONCAT(!BLANKS(!HN)),!LN)).
                  !IF (!BLANKS(!N) > !BLANKS(!NEL)) !THEN.
                     !LET !ERROR = 7.
                  !IFEND.
               !IFEND.
            !IFEND.
         !IFEND.
      !IFEND.
      !IF (!SEED<>RANDOM !AND !INDEX(!ALFABET,!UPCASE(!SEED))>0) !THEN.
         !LET !ERROR = 8.
      !IFEND.
   !IFEND.

   !IF (!ERROR<>0) !THEN.
      TEMPORARY.
      N 1.
      !IF (!ERROR=1) !THEN.
         PRINT /'ERROR: Missing parameter LN, HN or N. See the HELP.'.
      !IFEND.
      !IF (!ERROR=2) !THEN.
         PRINT /'ERROR: Parameter ORDER with wrong value. See the HELP.'.
      !IFEND.
      !IF (!ERROR=3) !THEN.
         PRINT /'ERROR: Parameter N with wrong value. See the HELP.'.
      !IFEND.
      !IF (!ERROR=4) !THEN.
         PRINT /'ERROR: Parameter LN with wrong value. See the HELP.'.
      !IFEND.
      !IF (!ERROR=5) !THEN.
         PRINT /'ERROR: Parameter HN with wrong value. See the HELP.'.
      !IFEND.
      !IF (!ERROR=6) !THEN.
         PRINT /'ERROR: Parameter HN must be greater than LN. See the HELP.'.
      !IFEND.
      !IF (!ERROR=7) !THEN.
         PRINT /'ERROR: Parameter N can not be greater than (HN-LN+1). See the HELP.'.
      !IFEND.
      !IF (!ERROR=8) !THEN.
         PRINT /'ERROR: Parameter SEED with wrong value. See the HELP.'.
      !IFEND.
      EXECUTE.
   !ELSE.
*     Name the original dataset.
      DATASET NAME @92678original.

*     Create a data matrix.
      INPUT PROGRAM.
      LOOP #I=!LN TO !HN.
         COMPUTE RN1=#I.
         END CASE.
      END LOOP.
      END FILE.
      END INPUT PROGRAM.
      FORMATS RN1 (F11).
      EXECUTE.
      DATASET NAME @92678RNDI WINDOW=FRONT.

*     Allocation of seed.
      PRESERVE.
      SET RNG=MT MTINDEX= !SEED.

*     Sort.
      !IF (!ORDERU='U') !THEN.
         COMPUTE @SORT=uniform(1)*10.
         SORT CASES BY @SORT.
         DELETE VARIABLES @SORT.
      !ELSE.
         !IF (!ORDERU='D') !THEN.
            SORT CASES BY RN1 (D).
         !IFEND.
      !IFEND.

*     Select a sample of N elements of a HN subjects and print.
      DO IF ($casenum=1).
         COMPUTE #N=!N.
         COMPUTE #NC=!HN-!LN+1.
      END IF.
      DO IF (#NC>0).
         COMPUTE #RND=uniform(1).
         COMPUTE @filter = (#RND < #N/#NC).
         COMPUTE #N =#N - @filter.
         COMPUTE #NC=#NC-1.               
      END IF.
      EXECUTE.
      SELECT IF (@filter=1).
      EXECUTE.
      MATCH FILES FILE=* /KEEP=RN1.
      EXECUTE.
      RESTORE.

*     Test LN, HN, N decimal parameters.
      COMPUTE #ERROR=(MOD(!LN,1)<>0 OR MOD(!HN,1)<>0 OR MOD(!N,1)<>0).

      DO IF ($CASENUM=1).
         DO IF (#ERROR=1).
            PRINT /'ERROR: Parameter LN, HN or N with decimal value. See the HELP.'.
         END IF.
      END IF.

*     Print results.
      DO IF (#ERROR=0).
         DO IF ($CASENUM=1).
            !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
               STRING #NST (A131).
               COMPUTE #NST = CONCAT('STUDY: ',!NST).
               PRINT /#NST.
            !IFEND.
   
            PRINT //'Random number seed= '!QUOTE(!SEED).
            PRINT /!QUOTE(!N) ' integers random numbers between ' !QUOTE(!LN) ' and ' !QUOTE(!HN) ' (Exhaustive sampling):'/.
         ELSE IF (MOD($CASENUM,5)=0 OR $CASENUM=!N).
            COMPUTE #RN2=LAG(RN1,1).
            COMPUTE #RN3=LAG(RN1,2).
            COMPUTE #RN4=LAG(RN1,3).
            COMPUTE #RN5=LAG(RN1,4).
         END IF.
         DO IF (MOD($CASENUM,5)=0).
            PRINT /#RN5 (T1,F11) #RN4 (T13,F11) #RN3 (T25,F11) #RN2 (T37,F11) RN1 (T49,F11).
         ELSE IF ($CASENUM=!N).
            DO IF (MOD(!N,5)=1).
               PRINT /RN1 (T1,F11) .
            ELSE IF (MOD(!N,5)=2).
               PRINT /#RN2 (T1,F11) RN1 (T13,F11).
            ELSE IF (MOD(!N,5)=3).
               PRINT /#RN3 (T1,F11) #RN2(T13,F11) RN1 (T25,F11).
            ELSE IF (MOD(!N,5)=4).
               PRINT /#RN4 (T1,F11) #RN3(T13,F11) #RN2(T25,F11) RN1 (T37,F11).
            END IF.
         END IF.
      END IF.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.