PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !RNDSEQ V2011.09.09 loaded.'
         /'Execute !RNDSEQ HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !RNDSEQ ( RT =!CHAREND('/')!DEFAULT('S')
                 /N =!CHAREND('/')
             /RATIO =!CHAREND('/')
                /BS =!CHAREND('/') 
                /LP =!CHAREND('/') 
                /HP =!CHAREND('/')
             /TREAT =!CHAREND('/') 
            /CENTER =!CHAREND('/') 
           /pCENTER =!CHAREND('/') 
            /STRATA =!CHAREND('/') 
           /pSTRATA =!CHAREND('/') 
            /PREFIX =!CHAREND('/')
              /DRUG =!CHAREND('/') 
              /PROT =!CHAREND('/') 
              /SEED =!CHAREND('/')!DEFAULT(RANDOM)
               /NST =!CHAREND('/')
               /HELP=!CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2011.09.09').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
  PRINT //'Macro !RNDSEQ V' !VERSION ' (c)JM.Domenech'.
END IF.

!IF (!HELP<>1) !THEN.
*  Print HELP.
   DO IF ($CASENUM=1).
      PRINT /'******************************************************************************'
            /'* GENERATION OF RANDOM SEQUENCES                                             *'
            /'* Created 2008.01.07 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech                                                            *'
            /'* Programmers: A.Bonillo & R.Sesma                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM. Macro !RNDSEQ for SPSS Statistics.                            *'
            /'*    Generation of Random Sequences [computer program].                      *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* Parameters for SIMPLE randomization----------------------------------------*'
            /'* !RNDSEQ  N = Number of Subjects        (Integer multiple of Num. TREAT)    *'
            /'*     [RATIO]= Randomization ratio       (Integer)                           *'
            /'*              By default equal sample sizes are considered.                 *'
            /'*                                                                            *'
            /'* Parameters for BLOCKING (balanced restricted randomization)----------------*'
            /'* !RNDSEQ BS = Block Size                (Integer multiple of ratio sum)     *'
            /'*          N = Number of Subjects        (Integer multiple of BS)            *'
            /'*     [RATIO]= Randomization ratio       (Integer)                           *'
            /'*              By default equal sample sizes are considered.                 *'
            /'*                                                                            *'
            /'* Parameters for EFRON adaptive biased-coin randomization--------------------*'
            /'* !RNDSEQ LP = Low probability of assignment  (0   < LP < 0.5)               *'
            /'*         HP = High probability of assignment (0.5 < HP < 1  )               *'
            /'*          N = Number of Subjects        (N integer multiple of Num. TREAT)  *'
            /'*----------------------------------------------------------------------------*'
            /'* Parameters for ALL types of randomization procedures:                      *'
            /'*        /RT = RND Type: S (Simple randomization) ; by default: S            *'
            /'*                     or B (Blocking, balanced restricted randomization)     *'
            /'*                     or E (Efron adaptive biased-coin randomization)        *'
            /'*     /TREAT = Labels of Treatments        (<=20 characters, in SPSS format) *'
            /'*      /DRUG = Label of Drug               (<=20 characters, in SPSS format) *'
            /'*      /PROT = Label of Protocol           (<=20 characters, in SPSS format) *'
            /'*   [/CENTER]= Labels of Centers           (<=20 characters, in SPSS format) *'
            /'*   [/STRATA]= Labels of Strata for Center (<=20 characters, in SPSS format) *'
            /'*  [/pCENTER]= Expected proportions for each Center  by default: Equal prop. *'
            /'*  [/pSTRATA]= Expected proportions for each Strata  by default: Equal prop. *'
            /'*              The proportions expected in each center/stratum must add to 1.*'
            /'*   [/PREFIX]= Prefix of subject number    (<=4 characters)                  *'
            /'*     [/SEED]= Initialization value of RNG (any real number)                 *'
            /'*                                        by default: RANDOM                  *'
            /'*      [/NST]= Name of the study (Label)                                     *'
            /'*      [/HELP] Print Macro call arguments and Samples of calls               *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
            /'*                                                                            *'
            /'* Samples of calls:                                                          *'
            /'* !RNDSEQ HELP.                                                              *'
            /'* !RNDSEQ NST="HTA_Ruti" /DRUG= "YEMR" /PROT="Y.1A" /CENTER= "Clinic BCN"    *'
            /'*      /TREAT= "50mg" "Placebo" /RT=S /N=86 /SEED=-1987653.97 /PREFIX="PR".  *'
            /'* !RNDSEQ DRUG= "AZX" /PROT="AZX.014" /TREAT="A" "P" /RT=E /N=24 /LP=0.33333 *'
            /'*          /HP=0.66667 /CENTER="Clinic" "Sant Pau" /pCENTER=0.7 0.3.         *'
            /'* !RNDSEQ DRUG= "YEMR" /PROT="Y.1A" /RT=B /BS=5 /N=30 /RATIO = 1 2 2         *'
            /'*  /TREAT= "Placebo" "50mg" "100mg" /CENTER="CentA" "CentB" /PREFIX="A" "B". *'
            /'******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Compute number of treatments.
   !LET !NTreat=!NULL.
   !DO !I !IN (!TREAT).
      !LET !NTreat=!CONCAT(!NTreat,' ').
   !DOEND.
   !LET !NTreat=!LENGTH(!NTreat).

*  Compute number of Centers.
   !LET !NCenter=!NULL.
   !IF (!CENTER=!NULL) !THEN.
      !LET !NCenter=' '.
   !ELSE.
      !DO !I !IN (!CENTER).
         !LET !NCenter=!CONCAT(!NCenter,' ').
      !DOEND.
   !IFEND.
   !LET !NCenter=!LENGTH(!NCenter).
         
*  Compute number of Strata.
   !LET !NStrata=!NULL.
   !IF (!STRATA=!NULL) !THEN.
      !LET !NStrata=' '.
   !ELSE.
      !DO !I !IN (!STRATA).
         !LET !NStrata=!CONCAT(!NStrata,' ').
      !DOEND.
   !IFEND.
   !LET !NStrata=!LENGTH(!NStrata).

*  Compute total number of strata (center*strata).
   !LET !NStrat=!NULL.
   !DO !I=1 !TO !NCenter.
      !DO !J=1 !TO !NStrata.
         !LET !NStrat=!CONCAT(!NStrat,' ').
      !DOEND.
   !DOEND.
   !LET !NStrat=!LENGTH(!NStrat).

*  If RATIO parameter null, create the default value.
   !LET !RATIOc = !RATIO.
   !IF (!RATIOc = !NULL) !THEN.
      !LET !RATIOc='1'.
      !DO !I = 2 !TO !NTREAT.
         !LET !RATIOc=!CONCAT(!RATIOc,' 1').
      !DOEND.
   !IFEND.

***Test parameters.
   !LET !ERROR='0'.
*  Test parameter RT.
   !LET !RTU=!UPCASE(!RT).
   !IF (!RTU<>'S' !AND !RTU<>'B' !AND !RTU<>'E') !THEN. 
      !LET !ERROR='2'.
   !ELSE.
*     Test coherent parameters.
      !IF ((!RTU='S' !AND (!BS<>!NULL !OR !LP<>!NULL !OR !HP<>!NULL)) !OR
           (!RTU='B' !AND (!LP<>!NULL !OR !HP<>!NULL)) !OR
           (!RTU='E' !AND (!BS<>!NULL))) !THEN. 
         !LET !ERROR='3'.
      !ELSE.
         !IF ((!RTU='E' !AND (!LP=!NULL !OR !HP=!NULL)) !OR (!RTU='B' !AND !BS=!NULL)) !THEN. 
            !LET !ERROR='1'.
         !IFEND.
      !IFEND.
   !IFEND.
*  Test MISSING parameters.
   !IF (!TREAT=!NULL !OR !N=!NULL !OR !DRUG=!NULL !OR !PROT=!NULL !OR (!CENTER=!NULL !AND !STRATA<>!NULL)) !THEN. 
      !LET !ERROR='1'.
   !IFEND.
*  Test pCENTER parameter.
   !IF (!pCENTER <> !NULL) !THEN.
      !IF (!CENTER=!NULL) !THEN.
         !LET !ERROR='1'.
      !ELSE.
         !LET !COUNT=''.
         !DO !I !IN (!pCENTER).
            !LET !COUNT=!CONCAT(!COUNT,' ').
         !DOEND.
         !IF (!LENGTH(!COUNT)<>!NCenter) !THEN.
            !LET !ERROR='2'.
         !IFEND.
      !IFEND.
   !IFEND.
*  Test pSTRATA parameter.
   !IF (!pSTRATA <> !NULL) !THEN.
      !IF (!STRATA=!NULL) !THEN.
         !LET !ERROR='1'.
      !ELSE.
         !LET !COUNT=''.
         !DO !I !IN (!pSTRATA).
            !LET !COUNT=!CONCAT(!COUNT,' ').
         !DOEND.
         !IF (!LENGTH(!COUNT)<>!NStrata) !THEN.
            !LET !ERROR='2'.
         !IFEND.
      !IFEND.
   !IFEND.
*  Test RATIO parameter.
   !IF (!RATIO <> !NULL) !THEN.
      !IF (!RT='E') !THEN.
         !LET !ERROR='3'.
      !ELSE.
         !LET !COUNT=''.
         !DO !I !IN (!RATIO).
            !LET !COUNT=!CONCAT(!COUNT,' ').
         !DOEND.
         !IF (!LENGTH(!COUNT)<>!NTREAT) !THEN.
            !LET !ERROR='2'.
         !IFEND.
      !IFEND.
   !IFEND.
*  Test PREFIX parameter.
   !IF (!PREFIX <> !NULL) !THEN.
      !LET !COUNT=''.
      !DO !I !IN (!PREFIX).
         !LET !COUNT=!CONCAT(!COUNT,' ').
      !DOEND.
      !IF (!LENGTH(!COUNT)<>!NStrat) !THEN.
         !LET !ERROR='2'.
      !IFEND.
   !IFEND.
   !IF (!N = 0 !OR !N < 0) !THEN.
      !LET !ERROR='2'.
   !IFEND.
   !IF (!BS<>!NULL) !THEN.
      !IF (!BS = 0 !OR !BS < 0) !THEN.
         !LET !ERROR='2'.
      !IFEND.
   !IFEND.
   
   !IF (!ERROR<>'0') !THEN.
      !IF (!ERROR='1') !THEN.
         !LET !MESSAGE='ERROR: Missing parameter'.
      !IFEND.
      !IF (!ERROR='2') !THEN.
         !LET !MESSAGE='ERROR: Parameter(s) with wrong values'.
      !IFEND.
      !IF (!ERROR='3') !THEN.
         !LET !MESSAGE='ERROR: Too much parameter(s)'.
      !IFEND.
      DO IF ($CASENUM=1).
         PRINT /!QUOTE(!MESSAGE).
      END IF.
   !ELSE.
*     Save the original data.
      DATASET NAME @original.

*     Set the Mersenne Twister random number generator and the seed.
      PRESERVE.
      SET RNG=MT MTINDEX=!SEED.

*     Call the auxiliary macro to randomize.      
      !IF (!RTU='S') !THEN. 
         !RNDSE TREAT=!TREAT /N=!N /RT='S' /RATIO=!RATIOc /CENTER=!CENTER /pCENTER=!pCENTER /STRATA=!STRATA /pSTRATA=!pSTRATA
             /NTreat=!NTreat /NCenter=!NCenter /NStrata=!NStrata /NStrat=!NStrat /PREFIX=!PREFIX.
      !IFEND.
      !IF (!RTU='B') !THEN. 
         !RNDB TREAT=!TREAT /BS=!BS /Brat=!RATIOc /N=!N /CENTER=!CENTER /pCENTER=!pCENTER /STRATA=!STRATA /pSTRATA=!pSTRATA
             /NTreat=!NTreat /NCenter=!NCenter /NStrata=!NStrata /NStrat=!NStrat /PREFIX=!PREFIX .
      !IFEND.
      !IF (!RTU='E') !THEN. 
         !RNDSE TREAT=!TREAT /N=!N /RT='E' /LP=!LP /HP=!HP /CENTER=!CENTER /pCENTER=!pCENTER /STRATA=!STRATA /pSTRATA=!pSTRATA
             /NTreat=!NTreat /NCenter=!NCenter /NStrata=!NStrata /NStrat=!NStrat /PREFIX=!PREFIX.
      !IFEND.

      RESTORE.

*     Test numerical parameters.
      COMPUTE ERROR=0.
*     Test N.
      STRING ParamNAME (A8).
      COMPUTE #N = !N.
      DO IF (SYSMIS(#N)).
         COMPUTE ERROR=1.
         COMPUTE ParamNAME = 'N'.
      ELSE.
         !IF (!RT<>'B') !THEN.
            IF (MOD(#N/!NTREAT,1)<>0) ERROR=3.
         !IFEND.
         DO IF (#N<=0).
            COMPUTE ERROR=1.
            COMPUTE ParamNAME = 'N'.
         ELSE IF (MOD(#N,1)<>0).
            COMPUTE ERROR=2.
            COMPUTE ParamNAME = 'N'.
         END IF.
      END IF.
*     Test RATIO.
      !IF (!RATIO<>!NULL) !THEN.
         DO REPEAT r=!RATIOc. 
            COMPUTE #temp=r.
            DO IF (SYSMIS(#temp)).
               COMPUTE ERROR=1.
               COMPUTE ParamNAME = 'RATIO'.
            ELSE.
               DO IF (MOD(#temp,1)<>0).
                  COMPUTE ERROR=2.
                  COMPUTE ParamNAME = 'RATIO'.
               ELSE IF (#temp<0).
                  COMPUTE ERROR=1.
                  COMPUTE ParamNAME = 'RATIO'.
               END IF.
            END IF.
         END REPEAT.
      !IFEND.
*     Test BS.
      !IF (!BS<>!NULL) !THEN.
         COMPUTE #BSmin=0.
         DO REPEAT r=!RATIOc. 
            COMPUTE #BSmin=#BSmin + r.
         END REPEAT.
         COMPUTE #BS = !BS.
         DO IF (SYSMIS(#BS)).
            COMPUTE ERROR=1.
            COMPUTE ParamNAME = 'BS'.
         ELSE.
            DO IF (MOD(#BS,#BSmin)<>0).
               COMPUTE ERROR=4.
            ELSE IF (MOD(#N/#BS,1)<>0).
               COMPUTE ERROR=5.
            ELSE IF (#BS<=0).
               COMPUTE ERROR=1.
               COMPUTE ParamNAME = 'BS'.
            ELSE IF (MOD(#BS,1)<>0).
               COMPUTE ERROR=2.
               COMPUTE ParamNAME = 'BS'.
            END IF.
         END IF.
      !IFEND.
*     Test LP, HP.
      !IF (!LP<>!NULL !AND !HP<>!NULL ) !THEN.
         COMPUTE #LP=!LP.
         COMPUTE #HP=!HP.
         DO IF (SYSMIS(#LP) OR SYSMIS(#HP)).
            COMPUTE ERROR=1.
            COMPUTE ParamNAME = 'LP or HP'.
         ELSE.
            DO IF (#LP<=0 OR #LP>=0.5 OR #HP<=0.5 OR #HP>=1).
               COMPUTE ERROR=1.
               COMPUTE ParamNAME = 'LP or HP'.
            END IF.
         END IF.
      !IFEND.
*     Test pCENTER.
      !IF (!pCENTER<>!NULL) !THEN.
         COMPUTE #SUM=0.
         DO REPEAT p=!pCENTER. 
            COMPUTE #temp=p.
            DO IF (SYSMIS(#temp)).
               COMPUTE ERROR=1.
               COMPUTE ParamNAME = 'pCENTER'.
            ELSE.
               DO IF (#temp<=0 OR #temp>=1).
                  COMPUTE ERROR=1.
                  COMPUTE ParamNAME = 'pCENTER'.
               END IF.
               COMPUTE #SUM = #SUM + #temp.
            END IF.
         END REPEAT.
         DO IF (#SUM<>1).
            COMPUTE ERROR = 1.
            COMPUTE ParamNAME = 'pCENTER'.
         END IF.
      !IFEND.
*     Test pSTRATA.
      !IF (!pSTRATA<>!NULL) !THEN.
         COMPUTE #SUM=0.
         DO REPEAT p=!pSTRATA. 
            COMPUTE #temp=p.
            DO IF (SYSMIS(#temp)).
               COMPUTE ERROR=1.
               COMPUTE ParamNAME = 'pSTRATA'.
            ELSE.
               DO IF (#temp<=0 OR #temp>=1).
                  COMPUTE ERROR=1.
                  COMPUTE ParamNAME = 'pSTRATA'.
               END IF.
               COMPUTE #SUM = #SUM + #temp.
            END IF.
         END REPEAT.
         DO IF (#SUM<>1).
            COMPUTE ERROR = 1.
            COMPUTE ParamNAME = 'pSTRATA'.
         END IF.
      !IFEND.
*     Test SEED.
      !IF (!SEED<>RANDOM) !THEN.
         COMPUTE #SEED=!SEED.
         DO IF (SYSMIS(#SEED)).
            COMPUTE ERROR=1.
            COMPUTE ParamNAME = 'SEED'.
         END IF.
      !IFEND.

      DO IF (ERROR>0).
         DO IF (ERROR=1 AND $CASENUM=1).
            PRINT /'ERROR: Parameter ' ParamNAME(A8) ' with wrong values. See the HELP.'.
         ELSE IF (ERROR=2 AND $CASENUM=1).
            PRINT /'ERROR: Parameter ' ParamNAME(A8) ' with decimal values. See the HELP'.
         ELSE IF (ERROR=3 AND $CASENUM=1).
            PRINT /'ERROR: Parameter N must be a multiple of the number of treatments.'.
         ELSE IF (ERROR=4 AND $CASENUM=1).
            PRINT /'ERROR: Parameter BS must be a multiple of the sum of treatment ratios.'.
         ELSE IF (ERROR=5 AND $CASENUM=1).
            PRINT /'ERROR: Parameter N must be a multiple of the block size (parameter BS).'.                 
         END IF.
      END IF.

*     Print a table in the output window with the randomization results.
      DO IF ($CASENUM=1 AND ERROR=0).
         *Print title.
         !IF (!UNQUOTE(!RT)='S') !THEN.
            PRINT /'COMPLETE RANDOMIZATION'.
         !IFEND.
         !IF (!UNQUOTE(!RT)='B') !THEN.
            PRINT /'PERMUTATED-BLOCK RANDOMIZATION'.
         !IFEND.
         !IF (!UNQUOTE(!RT)='E') !THEN.
            PRINT /'TREATMENT ADAPTIVE RANDOMIZATION (Efron)'.
         !IFEND.         
         *Print NST if available.
         !IF (!NST !NE !NULL) !THEN .
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
            EXECUTE.
         !IFEND.
         *Print seed, drug and protocol.
         PRINT //'Random number seed= '!QUOTE(!SEED).
         PRINT //'Random codes for Drug: ' !DRUG.
         PRINT  /'Protocol: ' !PROT.
      END IF.
      EXECUTE.

      !IF (!NStrat=1 !OR !STRATA=!NULL) !THEN.
*         Print only the SubjectID and the Assignment.
         !LET !Table='-----------------------------------'.
         !LET !TableTitle='SubjectID  Assignment'.
         !LET !TableVars='SubjectID(T1,A8) Assignment(T12,A20)'.
      !IFEND.
      

      !IF (!NStrat<> 1 !AND !STRATA<>!NULL) !THEN.
*        Print the SubjectID, the Stratum and the Assignment.
         !LET !Table='----------------------------------------------------'.
         !LET !TableTitle='SubjectID  Stratum              Assignment'.
         !LET !TableVars='SubjectID(T1,A8) Stratum(T12,A20) Assignment(T33,A20)'.
      !IFEND.

      DO IF (ERROR=0).
         !IF (!CENTER<>!NULL) !THEN.
            DO IF ($CASENUM=1 OR Center <> LAG(Center)).
               DO IF ($CASENUM<>1).
                  PRINT /''.
               END IF.
               PRINT /'Study Center: ' Center.
               PRINT /!QUOTE(!Table).
               PRINT /!QUOTE(!TableTitle).
               PRINT /!QUOTE(!Table).
            END IF.
         !ELSE.
            DO IF ($CASENUM=1).
               PRINT /!QUOTE(!Table).
               PRINT /!QUOTE(!TableTitle).
               PRINT /!QUOTE(!Table).
            END IF.
         !IFEND.
      
         PRINT /!TableVars.
      END IF.
      EXECUTE.
      
*     Print Summary of Sample Size by Treatment (for RT=S or E).
      !IF (!RTU<>'B') !THEN.
         SORT CASES BY treat.
         DO IF ($CASENUM=1 AND ERROR=0).
            PRINT //'Summary of Sample Size by Treatment'.
            PRINT  /!QUOTE(!Table).
         END IF.
         DO IF (($CASENUM=1 OR treat<>LAG(treat)) AND ERROR=0).
            PRINT /Assignment(T3,A20)  NCases(T24,F3.0) ' (' PCT (F4.1)'%)'.
         END IF. 
         EXECUTE.
         DO IF ($CASENUM=1 AND ERROR=0).
            PRINT /!QUOTE(!Table).
            PRINT /'  TOTAL  '  N (T24,F3.0) ' (100%)'. 
         END IF.
         SORT CASES BY @sort.
      !IFEND.

*     Keep only the interesting variables.
      !IF (!CENTER=!NULL !AND !STRATA=!NULL) !THEN.
         MATCH FILES FILE=* /KEEP=SubjectID Assignment.
      !IFEND.
      !IF (!CENTER<>!NULL !AND !STRATA=!NULL) !THEN.
         MATCH FILES FILE=* /KEEP=SubjectID Center Assignment.
      !IFEND.
      !IF (!CENTER<>!NULL !AND !STRATA<>!NULL) !THEN.
         MATCH FILES FILE=* /KEEP=SubjectID Center Stratum Assignment.
      !IFEND.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.

****MACRO TO COMPUTE THE SIMPLE/EFRON RANDOMIZATION.
DEFINE !RNDSE (   N =!CHAREND('/')
                /RT =!CHAREND('/') 
             /TREAT =!CHAREND('/') 
             /RATIO =!CHAREND('/')
                /LP =!CHAREND('/') 
                /HP =!CHAREND('/') 
            /CENTER =!CHAREND('/') 
           /pCENTER =!CHAREND('/') 
            /STRATA =!CHAREND('/') 
           /pSTRATA =!CHAREND('/') 
            /NTreat =!CHAREND('/') 
           /NCenter =!CHAREND('/') 
           /NStrata =!CHAREND('/') 
            /NStrat =!CHAREND('/') 
            /PREFIX =!CHAREND('/')).

***The macro creates a new dataset with a random sequence of treatments using Simple or Efron randomization.

*Create the dataset.
INPUT PROGRAM.
COMPUTE #N=!N.
LOOP #I=1 TO #N.
   COMPUTE temp = $SYSMIS.
   END CASE.
END LOOP.
END FILE.
END INPUT PROGRAM.
DATASET NAME @RNDSEQ WINDOW=FRONT.
DATASET ACTIVATE @RNDSEQ.

**Compute NStrat, NCenter, NStrata, Center and Stratum variables: parse the table.
COMPUTE NStrat = $SYSMIS.
!IF (!NStrat <> 1) !THEN.
   COMPUTE @1 = 1.
   !IF (!CENTER<>!NULL) !THEN.
*     Compute the center proportions.
      !IF (!pCENTER<>!NULL) !THEN.
*        Take the user defined proportions from !pCENTER parameter.
         !LET !COUNT=' '.
         !DO !I !IN (!pCENTER).
            COMPUTE !CONCAT('#pC',!LENGTH(!COUNT)) = !I.
            !LET !COUNT=!CONCAT(!COUNT,' ').
         !DOEND.
      !ELSE.
*        If there are no user-defined proportions, the distribution is uniform.
         !DO !I=1 !TO !NCenter.
            COMPUTE !CONCAT('#pC',!I) = 1/!NCenter.
         !DOEND.
      !IFEND.
      !LET !pCn = !CONCAT('#pC',!NCenter).
*     Compute NCenter variable.
      COMPUTE NCenter = $SYSMIS.
      COMPUTE #N = 0.
      COMPUTE #COUNT = 1.
      DO REPEAT propor=#pC1 TO !pCN.
         IF ($casenum > #N) NCenter = #COUNT.
         COMPUTE #N = #N + !N * propor.
         COMPUTE #COUNT = #COUNT + 1.
      END REPEAT.
*     Add CENTER variable with the !CENTER parameter values.
      STRING Center (A20).
      !LET !COUNT=' '.
      !DO !I !IN (!CENTER).
         IF (NCenter = !LENGTH(!COUNT)) Center = !I.
         !LET !COUNT=!CONCAT(!COUNT,' ').
      !DOEND.
*     Compute the number of subjects of each center.
      !LET !AGGR=''.
      !DO !I=1 !TO (!NCenter).
         COMPUTE !CONCAT('@NCenter',!I) = (NCenter = !I).
         !LET !AGGR=!CONCAT(!AGGR,' /',!CONCAT('NCenter',!I),'=SUM(',!CONCAT('@NCenter',!I),')').
      !DOEND.
      AGGREGATE  /OUTFILE=*  MODE=ADDVARIABLES  /BREAK=@1  !AGGR.
   !IFEND.

   !IF (!STRATA<>!NULL) !THEN.
*     If there's a STRATA parameter, a !CENTER parameter is assumed.
      PRESERVE.
      SET ERRORS = NONE MESSAGES = NONE RESULTS = NONE.
      SPLIT FILE BY NCenter.
      CREATE @Sec_1 = CSUM(@1).
      SPLIT FILE OFF.
      RESTORE.
*     Compute the strata proportions.
      !IF (!pSTRATA<>!NULL) !THEN.
*        Take the user defined proportions from !pSTRATA parameter.
         !LET !COUNT=' '.
         !DO !I !IN (!pSTRATA).
            COMPUTE !CONCAT('#pS',!LENGTH(!COUNT)) = !I.
            !LET !COUNT=!CONCAT(!COUNT,' ').
         !DOEND.
      !ELSE.
*        If there are no user-defined proportions, the distribution is uniform.
         !DO !I=1 !TO !NStrata.
            COMPUTE !CONCAT('#pS',!I) = 1/!NStrata.
         !DOEND.
      !IFEND.
      !LET !pSn = !CONCAT('#pS',!NStrata).
*     Compute NStrata variable (for each center).
      COMPUTE NStrata = $SYSMIS.
      !DO !I = 1 !TO !NCenter.
         COMPUTE #Ntot = !CONCAT('NCenter',!I).
         COMPUTE #N = 0.
         COMPUTE #COUNT = 1.
         DO REPEAT propor=#pS1 TO !pSN.
            IF (@Sec_1 > #N and NCenter = !I) NStrata = #COUNT.
            COMPUTE #Nstrat = #Ntot * propor.
            COMPUTE #N = #N + #NStrat.
            COMPUTE #COUNT = #COUNT + 1.
         END REPEAT.
      !DOEND.
*     Add STRATUM variable with the !STRATA parameter values.
      STRING Stratum (A20).
      !LET !COUNT=' '.
      !DO !I !IN (!STRATA).
         IF (NStrata = !LENGTH(!COUNT)) Stratum = !I.
         !LET !COUNT=!CONCAT(!COUNT,' ').
      !DOEND.
   !IFEND.
*  Compute NStrat variable.
   COMPUTE NStrat = $SYSMIS.
   !LET !COUNT = ' '.
   !IF (!CENTER<>!NULL !AND !STRATA<>!NULL) !THEN.
      !DO !I = 1 !TO !NCenter.
         !DO !J = 1 !TO !NStrata.
            IF (NCenter = !I AND NStrata = !J) NStrat = !LENGTH(!COUNT).
            !LET !COUNT = !CONCAT(!COUNT,' ').
         !DOEND.
      !DOEND.
   !IFEND.
   !IF (!CENTER<>!NULL !AND !STRATA=!NULL) !THEN.
      !DO !I = 1 !TO !NCenter.
         IF (NCenter = !I) NStrat = !LENGTH(!COUNT).
         !LET !COUNT = !CONCAT(!COUNT,' ').
      !DOEND.
   !IFEND.
!ELSE.
   COMPUTE NStrat=1.
   !IF (!CENTER<>!NULL) !THEN.
      STRING Center (A20).
      COMPUTE Center = !CENTER.
   !IFEND.
!IFEND.

**Randomization.
!IF (!UNQUOTE(!RT)='S') !THEN.
*  Compute the sumatory of ratios.
   COMPUTE SUMr=0.
   DO REPEAT r=!RATIO.
      COMPUTE SUMr=SUMr+r.
   END REPEAT.
*  Create the random variable for each stratum.
   !IF (!NStrat<>1) !THEN.
      COMPUTE @MATCH=$casenum.
      !DO !I=1 !TO !NStrat.
         !LET !DsTemp=!CONCAT('@RNDS',!I).
         DATASET COPY !DsTemp WINDOW=HIDDEN.
         DATASET ACTIVATE !DsTemp WINDOW=ASIS.
         SELECT IF (NStrat = !I).
         COMPUTE !CONCAT('RND',!I)=TRUNC(RV.UNIFORM(1,SUMr+1)).
         MATCH FILES /FILE=* /KEEP=@MATCH !CONCAT('RND',!I).
         EXECUTE.
         DATASET ACTIVATE @RNDSEQ WINDOW=ASIS.
         MATCH FILES /FILE=* /TABLE=!DsTemp /BY @MATCH.
         EXECUTE.
         DATASET CLOSE !DsTemp.
      !DOEND.
      COMPUTE RND = SUM(RND1 TO !CONCAT('RND',!NStrat)).
      EXECUTE.
   !ELSE.
      COMPUTE RND=TRUNC(RV.UNIFORM(1,SUMr+1)).
   !IFEND.
*  Build the RECODE command to get the treat variable.
   !LET !RECODE=''.
   !LET !COUNT=' '.
   !LET !LO=' '.
   !LET !HI=''.
   !DO !I !IN (!RATIO).
      !DO !J=1 !TO !I.
         !LET !HI=!CONCAT(!HI,' ').
      !DOEND.
      !LET !RECODE=!CONCAT(!RECODE,' (',!LENGTH(!LO),' THRU ',!LENGTH(!HI),'=',!LENGTH(!COUNT),')').
      !LET !LO=!CONCAT(!HI,' ').
      !LET !COUNT=!CONCAT(!COUNT,' ').
   !DOEND.
   RECODE RND !RECODE INTO treat.
!ELSE.
   COMPUTE @MATCH=$casenum.
   !DO !I=1 !TO !NStrat.
      !IF (!NStrat<>1) !THEN.
         !LET !TreatN=!CONCAT('treat',!I).
         !LET !DsTemp=!CONCAT('@RNDS',!I).
         DATASET COPY !DsTemp WINDOW=HIDDEN.
         DATASET ACTIVATE !DsTemp WINDOW=ASIS.
         SELECT IF (NStrat = !I).
      !ELSE.
         !LET !TreatN='treat'.
      !IFEND.
*     Efron adaptive biased-coin randomization: compute treat variable.
      COMPUTE RND=RV.UNIFORM(0,1).
      IF ($CASENUM=1) #N_s=0.
      COMPUTE !TreatN=0.
      DO IF (#N_s=0).
         COMPUTE !TreatN=(RND<0.5)+1.
         IF (!TreatN=1) #N_s=#N_s-1.
         IF (!TreatN=2) #N_s=#N_s+1.
      ELSE IF (#N_s>0).  
         DO IF (RND>0.333333).
            COMPUTE !TreatN=1.
            COMPUTE #N_s=#N_s-1.
         ELSE.
            COMPUTE !TreatN=2.
            COMPUTE #N_s=#N_s+1.
         END IF.
      ELSE IF (#N_s<0).  
         DO IF (RND<0.66667).
            COMPUTE !TreatN=2.
            COMPUTE #N_s=#N_s+1.
         ELSE.
            COMPUTE !TreatN=1.
            COMPUTE #N_s=#N_s-1.
         END IF.
      END IF.
      !IF (!NStrat<>1) !THEN.
         MATCH FILES /FILE=* /KEEP=@MATCH !TreatN.
         EXECUTE.
         DATASET ACTIVATE @RNDSEQ WINDOW=ASIS.
         MATCH FILES /FILE=* /TABLE=!DsTemp /BY @MATCH.
         EXECUTE.
         DATASET CLOSE !DsTemp.
      !IFEND.
      EXECUTE.
   !DOEND.
   !IF (!NStrat<>1) !THEN.
      COMPUTE treat = SUM(treat1 TO !CONCAT('treat',!NStrat)).
   !IFEND.
   EXECUTE.
!IFEND.

*Compute the Assignment variable: the name associated to the treatment.
STRING Assignment (A20).
!LET !COUNT=' '.
!DO !I !IN (!TREAT).
   IF (treat = !LENGTH(!COUNT)) Assignment = !I.
   !LET !COUNT=!CONCAT(!COUNT,' ').
!DOEND.

*Asignation of identificators.
STRING SubjectID(A8).
!IF (!NStrat = 1) !THEN.
   !IF (!PREFIX=!NULL) !THEN.
      COMPUTE SubjectID = STRING(10000000+$CASENUM,F8).
   !ELSE.
      COMPUTE SubjectID = CONCAT(!PREFIX,REPLACE(STRING($CASENUM,F4),' ','0')).
   !IFEND.
!ELSE.
*  Create the @Sec variable with the sequence information.   
   SPLIT FILE BY NStrat.
   PRESERVE.
   SET ERRORS = NONE MESSAGES = NONE RESULTS = NONE.
   CREATE @Sec = CSUM(@1).
   RESTORE.
   SPLIT FILE OFF.
   !IF (!PREFIX=!NULL) !THEN.
      COMPUTE SubjectID =STRING(NStrat*10000000+@Sec,F8).
   !ELSE.
      !LET !COUNT=' '.
      !DO !I !IN (!PREFIX).
         IF (NStrat = !LENGTH(!COUNT)) SubjectID = CONCAT(!I,REPLACE(STRING(@Sec,F4),' ','0')).
         !LET !COUNT=!CONCAT(!COUNT,' ').
      !DOEND.
   !IFEND.
!IFEND.

*Compute Summary Sample Size by Treatment.
COMPUTE @sort=$casenum.
SORT CASES BY treat.
AGGREGATE  /OUTFILE=*  MODE=ADDVARIABLES  /BREAK=treat  /NCases=N.
COMPUTE N=!N.
COMPUTE PCT=100*NCases/N.
SORT CASES BY @sort.

EXECUTE.
!ENDDEFINE.


****MACRO TO COMPUTE THE PERMUTATED-BLOCK RANDOMIZATION.
DEFINE !RNDB (    N =!CHAREND('/')
                /BS =!CHAREND('/') 
              /Brat =!CHAREND('/')
             /TREAT =!CHAREND('/') 
            /CENTER =!CHAREND('/') 
           /pCENTER =!CHAREND('/') 
            /STRATA =!CHAREND('/') 
           /pSTRATA =!CHAREND('/') 
            /NTreat =!CHAREND('/') 
           /NCenter =!CHAREND('/') 
           /NStrata =!CHAREND('/') 
            /NStrat =!CHAREND('/') 
            /PREFIX =!CHAREND('/')
              /SEED =!CHAREND('/')).

***The macro creates a new dataset with a random sequence of treatments using Block randomization.

*Making data with the variables V1 to V(BS) that will contain the permutations.
*Number of blocks needed = !N / !BS.
*Initialize the variables: V1=1, V2=2, TO V(!BS)=!BS .
INPUT PROGRAM.
*Compute #Ntot, the total number of elements.
COMPUTE #Ntot = !N.
*If there are strata, compute the proportions.
!IF (!NStrat <> 1) !THEN.
   !IF (!CENTER<>!NULL) !THEN.
*     Compute the center proportions.
      !IF (!pCENTER<>!NULL) !THEN.
*        Take the user defined proportions from !pCENTER parameter.
         !LET !COUNT=' '.
         !DO !I !IN (!pCENTER).
            COMPUTE !CONCAT('#pC',!LENGTH(!COUNT)) = !I.
            !LET !COUNT=!CONCAT(!COUNT,' ').
         !DOEND.
      !ELSE.
*        If there are no user-defined proportions, the distribution is uniform.
         !DO !I=1 !TO !NCenter.
            COMPUTE !CONCAT('#pC',!I) = 1/!NCenter.
         !DOEND.
      !IFEND.
   !IFEND.

   !IF (!STRATA<>!NULL) !THEN.
*     Compute the strata proportions.
      !IF (!pSTRATA<>!NULL) !THEN.
*        Take the user defined proportions from !pSTRATA parameter.
         !LET !COUNT=' '.
         !DO !I !IN (!pSTRATA).
            COMPUTE !CONCAT('#pS',!LENGTH(!COUNT)) = !I.
            !LET !COUNT=!CONCAT(!COUNT,' ').
         !DOEND.
      !ELSE.
*        If there are no user-defined proportions, the distribution is uniform.
         !DO !I=1 !TO !NStrata.
            COMPUTE !CONCAT('#pS',!I) = 1/!NStrata.
         !DOEND.
      !IFEND.
   !IFEND.

   !IF (!CENTER<>!NULL !AND !STRATA<>!NULL) !THEN.
*     Compute the strat proportions.
      !LET !COUNT=' '.
      !DO !I=1 !TO !NCenter.
         !DO !J=1 !TO !NStrata.
            !LET !pC = !CONCAT('#pC',!I).
            !LET !pS = !CONCAT('#pS',!J).
            !LET !p = !CONCAT('#p',!LENGTH(!COUNT)).
            COMPUTE !p = !pC*!pS.
            !LET !COUNT=!CONCAT(!COUNT,' ').
         !DOEND.
      !DOEND.
   !ELSE.
      !IF (!CENTER<>!NULL) !THEN.
*        The strat proportions are = center proportions.
         !DO !I=1 !TO !NCenter.
            !LET !pC = !CONCAT('#pC',!I).
            !LET !p = !CONCAT('#p',!I).
            COMPUTE !p = !pC.
         !DOEND.
      !IFEND.
      !IF (!STRATA<>!NULL) !THEN.
*        The strat proportions are = strata proportions.
         !DO !I=1 !TO !NStrata.
            !LET !pS = !CONCAT('#pS',!I).
            !LET !p = !CONCAT('#p',!I).
            COMPUTE !p = !pS.
         !DOEND.
      !IFEND.
   !IFEND.
      
*  Compute the N's corresponding to each stratum.
   COMPUTE #N = 0.
   !DO !I=1 !TO !NStrat.
      COMPUTE #NStrat = #Ntot * !CONCAT('#p',!I).
*     The number of elements on each stratum must be a multiple of the block size.
      IF (MOD(#NStrat,!BS)<>0) #NStrat = (TRUNC(#NStrat/!BS)+1) * !BS.
      COMPUTE #N = #N + #NStrat.
   !DOEND.
   COMPUTE #Ntot = #N.
!IFEND.
*Create the vectors for the permutations.
COMPUTE #N=#Ntot/!BS.
LOOP #I=1 TO #N.
   !DO !J=1 !TO !BS.
      COMPUTE !CONCAT('V',!J)=!J.
   !DOEND.
   END CASE.
END LOOP.
END FILE.
END INPUT PROGRAM.
!LET !VN=!CONCAT('V',!BS).
FORMAT V1 TO !VN (F2).
DATASET NAME @RNDSEQ WINDOW=FRONT.
DATASET ACTIVATE @RNDSEQ.

*Randomization of variables. 
VECTOR V = V1 TO !VN.
LOOP #J = !BS to 1 by -1.
   COMPUTE #IN=TRUNC(RV.UNIFORM(1,#J+1)).
   COMPUTE #IVAL =V(#IN).
   COMPUTE V(#IN)=V(#J).
   COMPUTE V(#J) =#IVAL.
END LOOP.

*Use VARSTOCASES to create a single B variable with the block permutations.
PRESERVE.
SET ERRORS = NONE MESSAGES = NONE RESULTS = NONE.
VARSTOCASES /ID = id
 /MAKE B FROM V1 TO !VN
 /KEEP =
 /NULL = KEEP.
RESTORE.

*Compute the minimum Block size and the ratios from RATIO parameter.
COMPUTE #BSmin=0.
DO REPEAT RATIO=!Brat /r=#r1 to !CONCAT('#r',!NTREAT).
   COMPUTE r=RATIO.
   COMPUTE #BSmin=#BSmin+r.
END REPEAT.
*Compute the treat variable: which treatment corresponds to the B permutated value, using the ratios.
COMPUTE treat = $SYSMIS.
COMPUTE #treat= 1.
COMPUTE #Bmin = 0.
COMPUTE #Bmax = 0.
DO REPEAT r=#r1 to !CONCAT('#r',!NTREAT).
   COMPUTE #Bmax = #Bmax + r*(!BS/#BSmin).
   IF (B >= #Bmin AND B <= #Bmax) treat = #treat.
   COMPUTE #Bmin=#Bmax+1.
   COMPUTE #treat=#treat+1.
END REPEAT.

*Compute the Assignment variable: the name associated to the treatment.
STRING Assignment (A20).
!LET !COUNT=' '.
!DO !I !IN (!TREAT).
   IF (treat = !LENGTH(!COUNT)) Assignment = !I.
   !LET !COUNT=!CONCAT(!COUNT,' ').
!DOEND.

*Compute Nstrat, the variable that defines the strata from the proportions defined.
!IF (!NStrat <> 1) !THEN.
   !IF (!CENTER<>!NULL) !THEN.
*     Compute the center proportions.
      !IF (!pCENTER<>!NULL) !THEN.
*        Take the user defined proportions from !pCENTER parameter.
         !LET !COUNT=' '.
         !DO !I !IN (!pCENTER).
            COMPUTE !CONCAT('#pC',!LENGTH(!COUNT)) = !I.
            !LET !COUNT=!CONCAT(!COUNT,' ').
         !DOEND.
      !ELSE.
*        If there are no user-defined proportions, the distribution is uniform.
         !DO !I=1 !TO !NCenter.
            COMPUTE !CONCAT('#pC',!I) = 1/!NCenter.
         !DOEND.
      !IFEND.
   !IFEND.

   !IF (!STRATA<>!NULL) !THEN.
*     Compute the strata proportions.
      !IF (!pSTRATA<>!NULL) !THEN.
*        Take the user defined proportions from !pSTRATA parameter.
         !LET !COUNT=' '.
         !DO !I !IN (!pSTRATA).
            COMPUTE !CONCAT('#pS',!LENGTH(!COUNT)) = !I.
            !LET !COUNT=!CONCAT(!COUNT,' ').
         !DOEND.
      !ELSE.
*        If there are no user-defined proportions, the distribution is uniform.
         !DO !I=1 !TO !NStrata.
            COMPUTE !CONCAT('#pS',!I) = 1/!NStrata.
         !DOEND.
      !IFEND.
   !IFEND.

   !IF (!CENTER<>!NULL !AND !STRATA<>!NULL) !THEN.
*     Compute the strat proportions.
      !LET !COUNT=' '.
      !DO !I=1 !TO !NCenter.
         !DO !J=1 !TO !NStrata.
            !LET !pC = !CONCAT('#pC',!I).
            !LET !pS = !CONCAT('#pS',!J).
            !LET !p = !CONCAT('#p',!LENGTH(!COUNT)).
            COMPUTE !p = !pC*!pS.
            !LET !COUNT=!CONCAT(!COUNT,' ').
         !DOEND.
      !DOEND.
   !ELSE.
      !IF (!CENTER<>!NULL) !THEN.
*        The strat proportions are = center proportions.
         !DO !I=1 !TO !NCenter.
            !LET !pC = !CONCAT('#pC',!I).
            !LET !p = !CONCAT('#p',!I).
            COMPUTE !p = !pC.
         !DOEND.
      !IFEND.
   !IFEND.

*  Compute NStrat variable.
   COMPUTE #N = 0.
   COMPUTE #COUNT = 1.
   !DO !I=1 !TO !NStrat.
      IF ($CASENUM>#N) NStrat = #COUNT.
      COMPUTE #NStrat = !N * !CONCAT('#p',!I).
*     The number of elements on each stratum must be a multiple of the block size.
      IF (MOD(#NStrat,!BS)<>0) #NStrat = (TRUNC(#NStrat/!BS)+1) * !BS.
      COMPUTE #N = #N + #NStrat.
      COMPUTE #COUNT = #COUNT + 1.
   !DOEND.

   !IF (!CENTER<>!NULL !AND !STRATA<>!NULL) !THEN.
*     Compute NCenter, NStrata variables.
      COMPUTE NCenter = $SYSMIS.
      COMPUTE NStrata = $SYSMIS.
      !LET !COUNT=' '.
      !DO !I=1 !TO !NCenter.
         !DO !J=1 !TO !NStrata.
            IF (Nstrat= !LENGTH(!COUNT)) NCenter = !I.
            IF (Nstrat= !LENGTH(!COUNT)) NStrata = !J.
            !LET !COUNT=!CONCAT(!COUNT,' ').
         !DOEND.
      !DOEND.
   !ELSE.
      !IF (!CENTER<>!NULL) !THEN.
*        Compute NCenter variable.
         COMPUTE NCenter = $SYSMIS.
         !LET !COUNT=' '.
         !DO !I=1 !TO !NCenter.
            IF (Nstrat= !LENGTH(!COUNT)) NCenter = !I.
            !LET !COUNT=!CONCAT(!COUNT,' ').
         !DOEND.
      !IFEND.
   !IFEND.

   !IF (!CENTER<>!NULL) !THEN.
*     Add CENTER variable with the !CENTER parameter values.
      STRING Center (A20).
      !LET !COUNT=' '.
      !DO !I !IN (!CENTER).
         IF (NCenter = !LENGTH(!COUNT)) Center = !I.
         !LET !COUNT=!CONCAT(!COUNT,' ').
      !DOEND.
   !IFEND.

   !IF (!STRATA<>!NULL) !THEN.
*     Add STRATUM variable with the !STRATA parameter values.
      STRING Stratum (A20).
      !LET !COUNT=' '.
      !DO !I !IN (!STRATA).
         IF (NStrata = !LENGTH(!COUNT)) Stratum = !I.
         !LET !COUNT=!CONCAT(!COUNT,' ').
      !DOEND.
   !IFEND.
!ELSE.
   !IF (!CENTER<>!NULL) !THEN.
      STRING Center (A20).
      COMPUTE Center = !CENTER.
   !IFEND.
!IFEND.

*Asignation of identificators.
STRING SubjectID(A8).
!IF (!NStrat = 1) !THEN.
   !IF (!PREFIX=!NULL) !THEN.
      COMPUTE SubjectID=STRING(10000000+$CASENUM,F8).
   !ELSE.
      COMPUTE SubjectID=CONCAT(!PREFIX,REPLACE(STRING($CASENUM,F4),' ','0')).
   !IFEND.
!ELSE.
*  Create the @Sec variable with the sequence information.   
   COMPUTE @1=1.
   SPLIT FILE BY NStrat.
   PRESERVE.
   SET ERRORS = NONE MESSAGES = NONE RESULTS = NONE.
   CREATE @Sec = CSUM(@1).
   RESTORE.
   SPLIT FILE OFF.
   !IF (!PREFIX=!NULL) !THEN.
      COMPUTE SubjectID =STRING(NStrat*10000000+@Sec,F8).
   !ELSE.
      !LET !COUNT=' '.
      !DO !I !IN (!PREFIX).
         IF (NStrat = !LENGTH(!COUNT)) SubjectID = CONCAT(!I,REPLACE(STRING(@Sec,F4),' ','0')).
         !LET !COUNT=!CONCAT(!COUNT,' ').
      !DOEND.
   !IFEND.
!IFEND.
EXECUTE.
!ENDDEFINE.
