PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !NCR V2009.02.19 loaded.'
         /'Execute !NCR HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !NCR ( VB = !CHAREND('/')
             /VW = !CHAREND('/') 
         /EFFECT = !CHAREND('/') 
          /ALPHA = !CHAREND('/')
           /BETA = !CHAREND('/')
            /NST = !CHAREND('/')
           /HELP = !CHAREND('/') !DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2009.02.19').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
   PRINT //'Macro !NCR V' !VERSION ' (c)JM.Domenech'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*  Print HELP.
   DO IF ($casenum=1).
      PRINT /'****************************************************************************'
            /'* NUMBER OF COMMUNITIES (RISK): Intervention trials                        *'
            /'* Created 2000.02.14 Last revised ' !VERSION                              '*'76
            /'* (c) JM.Domenech                                                          *'
            /'* Programmers: A.Bonillo & R.Sesma                                         *'
            /'*                                                                          *'
            /'* Vancouver reference:                                                     *'
            /'* Domenech JM. Macro !NCR for SPSS Statistics.                             *'
            /'*    Number of Communities (Risk): Intervention trials [computer program]. *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'76
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                 *'
            /'*                                                                          *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                            *'
            /'* !NCR VB = Supposed Between Group Variance              (VB > 0)          *'
            /'*     /VW = Supposed Within Group Variance               (VW > 0)          *'
            /'* /EFFECT = Minimum expected effect size in proportion   (0 < EFFECT < 1)  *'
            /'* [/ALPHA]= Alpha risk in %; by default: 5               (0 < ALPHA<= 50)  *'
            /'*  [/BETA]= Beta  risk in %; by default: 20 15 10        (0 < BETA <= 50)  *'
            /'*   [/NST]= Name of the study (Label)                                      *'
            /'*   [/HELP] Print Macro call arguments and Samples of calls                *'
            /'*                                                                          *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional            *'
            /'*                                                                          *'
            /'* Samples of calls:                                                        *'
            /'*  !NCR HELP.                                                              *'
            /'*  !NCR VB=0.000001685 /VW=0.000001685 /EFFECT=0.003 /ALPHA=5 /BETA=10.    *'
            /'*  !NCR VB=0.000001685 /VW=0.000001685 /EFFECT=0.003 /NST="Study Name".    *'
            /'****************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Testing the parameters.
   !IF (!VB=!NULL !OR !VW=!NULL !OR !EFFECT=!NULL) !THEN.
      PRINT /'ERROR: Missing parameter'.
   !ELSE.
      COMPUTE #ERROR=0.

*     Test parameter VB,VW,EFFECT.
      COMPUTE #VB=!VB.
      COMPUTE #VW=!VW.
      COMPUTE #EFFECT=!EFFECT.
      DO IF (SYSMIS(#VB) OR SYSMIS(#VW) OR SYSMIS(#EFFECT)).
         COMPUTE #ERROR=1.
      ELSE.
         IF (#VB<=0 OR #VW<=0 OR #EFFECT<=0 OR #EFFECT>=1) #ERROR=1.
      END IF.      

*     Test ALPHA, BETA values.
      !IF (!ALPHA<>!NULL !AND !BETA<>!NULL) !THEN.
         COMPUTE #ALPHA=!ALPHA.
         COMPUTE #BETA=!BETA.
         DO IF (SYSMIS(#ALPHA) OR SYSMIS(#BETA)).
            COMPUTE #ERROR=1.
         ELSE.
            IF (#ALPHA<=0 or #ALPHA>50 or #BETA<=0 or #BETA>50) #ERROR=1.
         END IF.
      !ELSE.
         !IF (!ALPHA<>!NULL !OR !BETA<>!NULL) !THEN.
            COMPUTE #ERROR=2.
         !IFEND.
      !IFEND.
      
      DO IF (#ERROR=1).
         PRINT /'ERROR: Parameter(s) with wrong values'.
      ELSE IF (#ERROR=2).
         PRINT /'ERROR: Missing parameter'.
      ELSE .
*        Print of Head.
         PRINT /'NUMBER OF COMMUNITIES (RISK): Intervention trials'.
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.
         PRINT//'Supposed Between Group Variance= ' !QUOTE(!VB).
         PRINT /'Supposed Within Group Variance = ' !QUOTE(!VW).
         PRINT /'Minimum expected effect size  = ' !QUOTE(!EFFECT).

         COMPUTE #VAR=#VB + #VW.
         COMPUTE #D=#EFFECT.

         !IF (!ALPHA=!NULL !AND !BETA=!NULL) !THEN.
*           Print a table when ALPHA and BETA are defaults.
            !LET !ALPHAdef = '5'.
            !LET !BETAdef  = '20 15 10'.
            !DO !I=1 !TO 2.
               !DO !A !IN(!ALPHAdef).
                  COMPUTE  #ZALPHA=IDF.NORMAL((100-!A/!I)/100,0,1).
                  !DO !B !IN(!BETAdef).
                     COMPUTE #ZBETA=IDF.NORMAL((100-!B)/100,0,1).
                     !LET !VARNAME=!CONCAT('#N',!I,!A,!B).
                     !LET !VARNAMEc=!CONCAT('#Nc',!I,!A,!B).
                     COMPUTE !VARNAME=2*#VAR*(#ZALPHA+#ZBETA)**2/(#D**2).
                     COMPUTE !VARNAMEc=!VARNAME*(TRUNC(!VARNAME)+3)/(TRUNC(!VARNAME)+1).
                     IF (MOD(!VARNAME,1)<>0) !VARNAME=TRUNC(!VARNAME)+1.
                     IF (MOD(!VARNAMEc,1)<>0) !VARNAMEc=TRUNC(!VARNAMEc)+1.
                  !DOEND.
               !DOEND.
            !DOEND.

            DO IF (#ERROR=0).
*              Print: Two and one-sided test in a table.
               PRINT SPACE.
               
               PRINT /'                     |        Number of communities by Group       |'.
               PRINT /'        Alpha Risk=5%|     Two-Sided Test   |     One-Sided Test   |'.
               PRINT /'                Power|    80%    85%    90% |    80%    85%    90% |'.
               PRINT /'---------------------+----------------------+----------------------+'.
               PRINT /'       Normal method |' #N2520(T23,F6) #N2515(T30,F6) #N2510(T37,F6) '|'45 #N1520(T46,F6) #N1515(T53,F6) #N1510(T60,F6) '|'68.
               PRINT /"Students correction |" #Nc2520(T23,F6) #Nc2515(T30,F6) #Nc2510(T37,F6) '|'45 #Nc1520(T46,F6) #Nc1515(T53,F6) #Nc1510(T60,F6) '|'68.
               PRINT /'---------------------+----------------------+----------------------+'.
            END IF.
         !ELSE. 
            COMPUTE #ZALPHA1=IDF.NORMAL((100-#ALPHA)/100,0,1).
            COMPUTE #ZALPHA2=IDF.NORMAL((100-#ALPHA/2)/100,0,1).
            COMPUTE #ZBETA=IDF.NORMAL((100-#BETA)/100,0,1).

            COMPUTE #NUNI = (2*#VAR*(#ZALPHA1+#ZBETA)**2)/(#D**2).
            COMPUTE #NUNIc= #NUNI*(TRUNC(#NUNI)+3)/(TRUNC(#NUNI)+1).
            IF (MOD(#NUNI,1)<>0) #NUNI=TRUNC(#NUNI)+1.
            IF (MOD(#NUNIc,1)<>0) #NUNIc=TRUNC(#NUNIc)+1.
            
            COMPUTE #NBIL = (2*#VAR*(#ZALPHA2+#ZBETA)**2)/(#D**2).
            COMPUTE #NBILc= #NBIL*(TRUNC(#NBIL)+3)/(TRUNC(#NBIL)+1).
            IF (MOD(#NBIL,1)<>0) #NBIL=TRUNC(#NBIL)+1.
            IF (MOD(#NBILc,1)<>0) #NBILc=TRUNC(#NBILc)+1.

            PRINT /'Alpha Risk= '!QUOTE(!ALPHA)'%'.
            PRINT /'Beta Risk = '!QUOTE(!BETA) '%'.

            PRINT // 'Number of communities by Group:'.
            PRINT  / '---------------------+--------------+--------------+'.
            PRINT  / '                     |Two-Sided Test|One-Sided Test|'.
            PRINT  / '---------------------+--------------+--------------+'.
            PRINT  / '       Normal method |' #NBIL(F10.0)'    |' #NUNI (F9.0)'|'52.
            PRINT  / "Students correction |"#NBILc(F10.0)'    |' #NUNIc(F9.0)'|'52.
            PRINT  / '---------------------+--------------+--------------+'/.
         !IFEND.
      END IF.  
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
