PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !NI2IS V2010.02.15 loaded.'
         /'Execute !NI2IS HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !NI2IS (I0 = !CHAREND('/') 
              /I1 = !CHAREND('/') 
              /ID = !CHAREND('/') 
              /IR = !CHAREND('/') 
               /D = !CHAREND('/')
               /R = !CHAREND('/') !DEFAULT('1')
           /ALPHA = !CHAREND('/')
            /BETA = !CHAREND('/')
              /N0 = !CHAREND('/')
              /N1 = !CHAREND('/')
             /NST = !CHAREND('/')
            /HELP = !CHAREND('/') !DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2010.02.15').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
  PRINT //'Macro !NI2IS V' !VERSION ' (c)JM.Domenech'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*  Print the help.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* SAMPLE SIZE (RATE) & POWER DETERMINATION: Two independent samples          *'
            /'* Created 2005.03.04 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech                                                            *'
            /'* Programmers: A.Bonillo & R.Sesma                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM. Macro !NI2IS for SPSS Statistics.                             *'
            /'*    Sample Size (Rate) & Power Determination: Two independent samples       *'
            /'*    [computer program].                                                     *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* !NI2IS I0 = Event risk in UnExposed                        (0< I0  )       *'
            /'*      {/I1 = Event risk in Exposed                          (0< I1  )       *'
            /'*    or /IR = Expected Risk Ratio                            (IR >  0)       *'
            /'*    or /ID}= Expected Risk Difference                       (ID <> 0)       *'
            /'*       /r  = Ratio n0/n1  (by default: 1)                   (R  >  0)       *'
            /'*       /D  = Mean duration of Follow up                     (D  > 0)        *'
            /'*     [/NST]= Name of the study (Label)                                      *'
            /'*     [/HELP] Print Macro call arguments and Samples of calls                *'
            /'*----------------------------------------------------------------------------*'
            /'*        Parameters for SAMPLE SIZE computations:                            *'
            /'*     /ALPHA= Alpha risk(%); by default: 5                   (0< ALPHA<= 50) *'
            /'*      /BETA= Beta  risk(%); by default: 20 15 10            (0< BETA <= 50) *'
            /'*----------------------------------------------------------------------------*'
            /'*        Parameters for POWER computations:                                  *'
            /'*       /N0 = Sample Size in group 0                         (N0>1)          *'
            /'*       /N1 = Sample Size in group 1                         (N1>1)          *'
            /'*   {or /N0 and /r} , {or /N1 and /r}                                        *'
            /'*     /ALPHA= Alpha risk(%); REQUIRED for POWER computations (0< ALPHA<= 50) *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements *'
            /'*                                                                            *'
            /'* Samples of calls:                                                          *'
            /'*  !NI2IS HELP.                                                              *'
            /'*  !NI2IS I0=0.30 /ID=0.10 /D=2.                                             *'
            /'*  !NI2IS I0=0.30 /ID=0.10 /D=2 /r=2.                                        *'
            /'*  !NI2IS I0=0.4  /IR=2 /D=2 /r=3 /ALPHA=5 /BETA=15 /NST="Study Name".       *'
            /'*  !NI2IS I0=0.4  /IR=2 /D=2 /N0=69 /N1=23 /ALPHA=5.                         *'
            /'******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Testing the parameters and computing #I1.
   COMPUTE #ERROR=0.

   !IF (!D=!NULL !OR !I0=!NULL !OR (!I1=!NULL !AND !ID=!NULL !AND !IR=!NULL) ) !THEN.
      PRINT /'ERROR: Missing parameter'.
   !ELSE.
      COMPUTE #I0=!I0.
      COMPUTE #D=!D.
      DO IF (!I0<=0 or !D<=0 ).
         COMPUTE #ERROR=1.
      END IF.

      !IF (!I1<>!NULL !AND !ID=!NULL !AND !IR=!NULL) !THEN.
         COMPUTE #I1=!I1.
         COMPUTE #IR=#I1/!I0.
         COMPUTE #ID=#I1-!I0.
         DO IF (#I1<=0).
            COMPUTE #ERROR=1.
         END IF.
      !ELSE.
         !IF (!I1=!NULL !AND !ID<>!NULL !AND !IR=!NULL) !THEN.
            COMPUTE #I1=!ID+!I0.
            COMPUTE #IR=#I1/!I0.
            COMPUTE #ID=!ID.
            DO IF (!ID=0).
               COMPUTE #ERROR=1.
            END IF.
         !ELSE.
            !IF (!I1=!NULL !AND !ID=!NULL !AND !IR<>!NULL) !THEN.
               COMPUTE #I1=!IR*!I0.
               COMPUTE #IR=!IR.
               COMPUTE #ID=#I1-!I0.
               DO IF (!IR<=0).
                  COMPUTE #ERROR=1.
               END IF.
            !ELSE.
               COMPUTE #ERROR=2.
            !IFEND.
         !IFEND.
      !IFEND.

      !IF (!N0=!NULL !AND !N1=!NULL) !THEN.
         !IF (!ALPHA<>!NULL !AND !BETA=!NULL) !THEN.
            COMPUTE #ERROR=3.
         !ELSE.
            !IF (!ALPHA=!NULL !AND !BETA<>!NULL) !THEN.
               COMPUTE #ERROR=3.
            !IFEND.
         !IFEND.
      !ELSE.
         !IF (!ALPHA=!NULL) !THEN.
            COMPUTE #ERROR=3.
         !ELSE.
            !IF (!BETA<>!NULL) !THEN.
               COMPUTE #ERROR=4.
            !ELSE.
               !IF (!N0<>!NULL !AND !N1<>!NULL !AND !R<>'1') !THEN.
                  COMPUTE #ERROR=4.
               !IFEND.
            !IFEND.
         !IFEND.
      !IFEND.

      !IF (!ALPHA<>!NULL) !THEN.
         COMPUTE #ALPHA=!ALPHA.
         DO IF (#ALPHA<=0 or #ALPHA>50) .
            COMPUTE #ERROR=1.
         END IF.
      !IFEND.

      !IF (!BETA<>!NULL) !THEN.
         COMPUTE #BETA=!BETA.
         DO IF (#BETA<=0 or #BETA>50).
            COMPUTE #ERROR=1.
         END IF.
      !IFEND.

      !IF (!N0=!NULL !AND !N1=!NULL) !THEN.
         COMPUTE #R=!R.
      !ELSE.
         !IF (!N0<>!NULL !AND !N1<>!NULL) !THEN.
            COMPUTE #N0=!N0.
            COMPUTE #N1=!N1.
            COMPUTE #R=(#N0/#N1).
         !ELSE.
            COMPUTE #R=!R.
            !IF (!N0<>!NULL) !THEN.
               COMPUTE #N0=!N0.
               COMPUTE #N1=(#N0/#R).
               IF (MOD(#N1,1)<>0) #N1=TRUNC(#N1)+1.
            !ELSE.
               COMPUTE #N1=!N1.
               COMPUTE #N0=#R*#N1.
               IF (MOD(#N0,1)<>0) #N0=TRUNC(#N0)+1.
            !IFEND.
         !IFEND.
         !IF (!N0<>!NULL) !THEN.
            DO IF (MOD(!N0,1)<>0).
               COMPUTE #ERROR=5.
            ELSE IF (!N0<=1).
               COMPUTE #ERROR=1.
            END IF.
         !IFEND.
         !IF (!N1<>!NULL) !THEN.
            DO IF (MOD(!N1,1)<>0).
               COMPUTE #ERROR=5.
            ELSE IF (!N1<=1).
               COMPUTE #ERROR=1.
            END IF.
         !IFEND.
     !IFEND.

      DO IF (#R<=0).
         COMPUTE #ERROR=1.
      END IF.

      DO IF (#ERROR=1).
         PRINT /'ERROR: Parameter(s) with wrong values'.
      ELSE IF (#ERROR=2).
         PRINT /'ERROR: Too much parameter(s); specify only one of I1, ID, IR'.
      ELSE IF (#ERROR=3).
         PRINT /'ERROR: Missing parameter'.
      ELSE IF (#ERROR=4).
         PRINT /'ERROR: Too much parameter(s)'.
      ELSE IF (#ERROR=5).
         PRINT /'ERROR: Parameter(s) with decimal values.'.
      ELSE.
*        Correct parameters, compute and present results.
         COMPUTE #FLEISS=0.
         COMPUTE #I=0.
         COMPUTE #WARNING1=0.
         COMPUTE #WARNING2=0.
         STRING #TempC (A1).
         COMPUTE #TempC = ' '.

*        Print: Head.
         PRINT /'SAMPLE SIZE (RATE) & POWER DETERMINATION: Two-independent samples'.
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.

         PRINT//'Rate of events in: UnExposed (Group 0)=' #I0(F12.6).
         PRINT /'                   Exposed   (Group 1)=' #I1(F12.6).
         PRINT /'                        Mean followup = '!QUOTE(!D).
         PRINT /'                          Ratio N0/N1 = '!QUOTE(!R).
         PRINT /'Minimum expected: IR='#IR(F6.2) ';   ID='#ID(F10.7) .

*        Print a table when ALPHA and BETA are defaults.
         !IF (!ALPHA=!NULL !AND !BETA=!NULL) !THEN.
            COMPUTE #I=(#I1+#R*#I0)/(#R+1).
            COMPUTE #DArcs= 4*#r*#D*(ARSIN(SQRT(#I1))-ARSIN(SQRT(#I0)) )**2.
            COMPUTE #DNorm=#R*#D*(#ID)**2.
            COMPUTE #FLEISS=(#R+1) / (#R*#D*ABS(#ID)).
            
            IF (#I0*#D<0.2 or #I0*#D>0.8 or #I1*#D<0.2 or #I1*#D>0.8) #WARNING1=1.

            !LET !ALPHAu = '5'.
            !LET !BETAu  = '20 15 10'.
            !DO !J=0 !TO 1.
               !DO !I=1 !TO 2.
                  !DO !A !IN(!ALPHAu).
                     COMPUTE  #ZALPHA=IDF.NORMAL((100-!A/!I)/100,0,1).
                     !DO !B !IN(!BETAu).
                        COMPUTE #ZBETA=IDF.NORMAL((100-!B)/100,0,1).
*                       Sinusual inverse exact probability of Fisher (Arcosinus method).
                        !LET !VArcs=!CONCAT('#NA',!J,!I,!A,!B).
                        COMPUTE !VArcs=(#R)*(#R+1)*(#ZALPHA+#ZBETA)**2 /#DArcs.
                        IF (!J=1) !VArcs=!VArcs/#R.
                        IF (MOD(!VArcs,1)<>0) !VArcs=TRUNC(!VArcs)+1.
*                       Normal method.
                        !LET !VNorm=!CONCAT('#NN',!J,!I,!A,!B).
                        COMPUTE #NUM1=#ZALPHA*SQRT((#R+1)*#I).
                        COMPUTE #NUM2=#ZBETA*SQRT(#I0+#R*#I1).
                        COMPUTE !VNorm=(#NUM1+#NUM2)**2 / #DNorm.
                        IF (!J=0) !VNorm=!VNorm*#R.
                        IF (MOD(!VNorm,1)<>0) !VNorm=TRUNC(!VNorm)+1.
*                       Normal method with Fleiss correction.
                        !LET !VNormC=!CONCAT('#NF',!J,!I,!A,!B).
                        COMPUTE !VNormC=(#NUM1+#NUM2)**2 / #DNorm + #FLEISS.
                        IF (!J=0) !VNormC=!VNormC*#R.
                        IF (MOD(!VNormC,1)<>0) !VNormC=TRUNC(!VNormC)+1.

                        !IF (!J=1) !THEN.
                           IF ((!VNorm*#I1*#D)<10 or (!VNorm*(1-(#I1*#D)))<10) #WARNING2=1.
                        !ELSE.
                           IF ((!VNorm*#I0*#D)<10 or (!VNorm*(1-(#I0*#D)))<10) #WARNING2=1.
                        !IFEND.
                     !DOEND.
                  !DOEND.
               !DOEND.
            !DOEND.
*           Compute Totals for each method.
            !DO !I=1 !TO 2.
               !DO !A !IN(!ALPHAu).
                  !DO !B !IN(!BETAu).
                     !LET !VArcs=!CONCAT('#NA',!I,!A,!B).
                     COMPUTE !VArcs=!CONCAT('#NA0',!I,!A,!B)+!CONCAT('#NA1',!I,!A,!B).
                     !LET !VNorm=!CONCAT('#NN',!I,!A,!B).
                     COMPUTE !VNorm=!CONCAT('#NN0',!I,!A,!B)+!CONCAT('#NN1',!I,!A,!B).
                     !LET !VNormC=!CONCAT('#NF',!I,!A,!B).
                     COMPUTE !VNormC=!CONCAT('#NF0',!I,!A,!B)+!CONCAT('#NF1',!I,!A,!B).
                  !DOEND.
               !DOEND.
            !DOEND.

*           Print: Two and one-sided test in a table.
            PRINT SPACE.
            IF (#WARNING1=1 OR #WARNING2=1) #TempC='*'.
            DO IF (#ERROR=0).
               PRINT /'                      |                SAMPLE SIZE                |'.
               PRINT /'         Alpha Risk=5%|    Two-Sided Test   |    One-Sided Test   |'.
               PRINT /' METHOD          Power|   80%    85%    90% |   80%    85%    90% |'.
               PRINT /'----------------------+---------------------+---------------------+'.
               PRINT /' Normal' #TempC(A1) '           n0 |' #NN02520(T24,F6) #NN02515(T31,F6) #NN02510(T38,F6) '|'45 #NN01520(T46,F6) #NN01515(T53,F6) #NN01510(T60,F6) '|'67.
               PRINT /'                   n1 |' #NN12520(T24,F6) #NN12515(T31,F6) #NN12510(T38,F6) '|'45 #NN11520(T46,F6) #NN11515(T53,F6) #NN11510(T60,F6) '|'67.
               PRINT /'                Total |' #NN2520(T24,F6)  #NN2515(T31,F6)  #NN2510(T38,F6)  '|'45 #NN1520(T46,F6)  #NN1515(T53,F6)  #NN1510(T60,F6)  '|'67.
               PRINT /'----------------------+---------------------+---------------------+'.
               PRINT /' Normal corrected  n0 |' #NF02520(T24,F6) #NF02515(T31,F6) #NF02510(T38,F6) '|'45 #NF01520(T46,F6) #NF01515(T53,F6) #NF01510(T60,F6) '|'67.
               PRINT /'                   n1 |' #NF12520(T24,F6) #NF12515(T31,F6) #NF12510(T38,F6) '|'45 #NF11520(T46,F6) #NF11515(T53,F6) #NF11510(T60,F6) '|'67.
               PRINT /'                Total |' #NF2520(T24,F6)  #NF2515(T31,F6)  #NF2510(T38,F6)  '|'45 #NF1520(T46,F6)  #NF1515(T53,F6)  #NF1510(T60,F6)  '|'67.
               PRINT /'----------------------+---------------------+---------------------+'.
               PRINT /' ArcoSinus         n0 |' #NA02520(T24,F6) #NA02515(T31,F6) #NA02510(T38,F6) '|'45 #NA01520(T46,F6) #NA01515(T53,F6) #NA01510(T60,F6) '|'67.
               PRINT /'                   n1 |' #NA12520(T24,F6) #NA12515(T31,F6) #NA12510(T38,F6) '|'45 #NA11520(T46,F6) #NA11515(T53,F6) #NA11510(T60,F6) '|'67.
               PRINT /'                Total |' #NA2520(T24,F6)  #NA2515(T31,F6)  #NA2510(T38,F6)  '|'45 #NA1520(T46,F6)  #NA1515(T53,F6)  #NA1510(T60,F6)  '|'67.
               PRINT /'----------------------+---------------------+---------------------+'.               
            END IF.
         !ELSE.
*           If ALPHA or BETA aren't defaults print a brief output.
            COMPUTE #ZALPHA1=IDF.NORMAL((100-!ALPHA)/100,0,1).
            COMPUTE #ZALPHA2=IDF.NORMAL((100-!ALPHA/2)/100,0,1).
            COMPUTE #I=(#I1+#R*#I0)/(#R+1).

            COMPUTE #DENA= 4*#r*#D*(ARSIN(SQRT(#I1))-ARSIN(SQRT(#I0)) )**2.

            COMPUTE #DENN=#R*#D*(#ID)**2.
            COMPUTE #FLEISS=(#R+1)/(#R*#D*ABS(#ID)).
            COMPUTE #NUM1N=SQRT((#R+1)*#I).
            COMPUTE #NUM2N=SQRT(#I0+#R*#I1).

            COMPUTE #FI=((#I**3)*#D)/(#I*#D - 1 + EXP(-1*#I*#D)).
            COMPUTE #FI0=((#I0**3)*#D)/(#I0*#D - 1 + EXP(-1*#I0*#D)).
            COMPUTE #FI1=((#I1**3)*#D)/(#I1*#D - 1 + EXP(-1*#I1*#D)).
            COMPUTE #DENE=#R*((#I1-#I0)**2).
            COMPUTE #NUM1E=SQRT((#R+1)*#FI).
            COMPUTE #NUM2E=SQRT(#R*#FI1+#FI0).

            IF (#I0*#D<0.2 or #I0*#D>0.8 or #I1*#D<0.2 or #I1*#D>0.8) #WARNING1=1.

            !IF (!N0=!NULL !AND !N1=!NULL) !THEN.
               COMPUTE #POWER=100-!BETA.
               COMPUTE #ZBETA=IDF.NORMAL((100-!BETA)/100,0,1).

*              Sinusual inverse exact probability of Fisher.
               COMPUTE #N1UNIA=(#R+1)*(#ZALPHA1+#ZBETA)**2/#DENA.
               COMPUTE #N1BILA=(#R+1)*(#ZALPHA2+#ZBETA)**2/#DENA.
               COMPUTE #N0UNIA=#R*#N1UNIA.
               COMPUTE #N0BILA=#R*#N1BILA.
               DO REPEAT N=#N1UNIA #N0UNIA #N1BILA #N0BILA.
                  IF (MOD(N,1)<>0) N=TRUNC(N)+1.
               END REPEAT.
               COMPUTE #NUNIA = #N1UNIA + #N0UNIA.
               COMPUTE #NBILA = #N1BILA + #N0BILA.

*              Method Normal.
               COMPUTE #N1UNIN=(#ZALPHA1*#NUM1N+#ZBETA*#NUM2N)**2/#DENN.
               COMPUTE #N1BILN=(#ZALPHA2*#NUM1N+#ZBETA*#NUM2N)**2/#DENN.
               COMPUTE #N0UNIN=#R*#N1UNIN.
               COMPUTE #N0BILN=#R*#N1BILN.
               DO REPEAT N=#N1UNIN #N0UNIN #N1BILN #N0BILN.
                  IF (MOD(N,1)<>0) N=TRUNC(N)+1.
               END REPEAT.
               COMPUTE #NUNIN = #N1UNIN + #N0UNIN.
               COMPUTE #NBILN = #N1BILN + #N0BILN.

*              Method Normal with Fleiss correction.
               COMPUTE #N1UNINC=(#ZALPHA1*#NUM1N+#ZBETA*#NUM2N)**2/#DENN +(#FLEISS).
               COMPUTE #N1BILNC=(#ZALPHA2*#NUM1N+#ZBETA*#NUM2N)**2/#DENN +(#FLEISS).
               COMPUTE #N0UNINC=#R*#N1UNINC.
               COMPUTE #N0BILNC=#R*#N1BILNC.
               DO REPEAT N=#N1UNINC #N0UNINC #N1BILNC #N0BILNC.
                  IF (MOD(N,1)<>0) N=TRUNC(N)+1.
               END REPEAT.
               COMPUTE #NUNINC = #N1UNINC + #N0UNINC.
               COMPUTE #NBILNC = #N1BILNC + #N0BILNC.

               IF ((#N1UNIN*#I1*#D)<10 or (#N1UNIN*(1-(#I1*#D)))<10) #WARNING2=1.
               IF ((#N1BILN*#I1*#D)<10 or (#N1BILN*(1-(#I1*#D)))<10) #WARNING2=1.
               IF ((#N0UNIN*#I0*#D)<10 or (#N0UNIN*(1-(#I0*#D)))<10) #WARNING2=1.
               IF ((#N0BILN*#I0*#D)<10 or (#N0BILN*(1-(#I0*#D)))<10) #WARNING2=1.

               IF (#WARNING1=1 OR #WARNING2=1) #TempC='*'.
               DO IF (#ERROR=0).
                  PRINT /'Alpha Risk= ' !QUOTE(!ALPHA) '%;  Beta Risk= '!QUOTE(!BETA) '%; Power=' #POWER(F5.1)'%'.
                  PRINT SPACE.

                  PRINT  /'                      |           SAMPLE SIZE           |'.
                  PRINT  /' METHOD               | Two-Sided Test | One-Sided Test |'.
                  PRINT  /'----------------------+----------------+----------------+'.
                  PRINT  /' Normal' #TempC(A1) '           n0 |    '#N0BILN(F7)'     |    '#N0UNIN(F7)'     |'.
                  PRINT  /'                   n1 |    '#N1BILN(F7)'     |    '#N1UNIN(F7)'     |'.
                  PRINT  /'                Total |    '#NBILN(F7) '     |    '#NUNIN(F7) '     |'.
                  PRINT  /'----------------------+----------------+----------------+'.
                  PRINT  /' Normal corrected  n0 |    '#N0BILNC(F7)'     |    '#N0UNINC(F7)'     |'.
                  PRINT  /'                   n1 |    '#N1BILNC(F7)'     |    '#N1UNINC(F7)'     |'.
                  PRINT  /'                Total |    '#NBILNC(F7) '     |    '#NUNINC(F7) '     |'.
                  PRINT  /'----------------------+----------------+----------------+'.
                  PRINT  /' ArcoSinus         n0 |    '#N0BILA(F7)'     |    '#N0UNIA(F7)'     |'.
                  PRINT  /'                   n1 |    '#N1BILA(F7)'     |    '#N1UNIA(F7)'     |'.
                  PRINT  /'                Total |    '#NBILA(F7) '     |    '#NUNIA(F7) '     |'.
                  PRINT  /'----------------------+----------------+----------------+'.
               END IF.
            !ELSE.
*              Sinusual inverse exact probability of Fisher.
               COMPUTE #temp=SQRT((#N1*#DENA)/(#R+1)).
               COMPUTE #POWER1A=100-((1-CDF.NORMAL((#temp - #ZALPHA1),0,1))*100).
               COMPUTE #POWER2A=100-((1-CDF.NORMAL((#temp - #ZALPHA2),0,1))*100).

*              Normal method.
               COMPUTE #temp=SQRT(#N1*#DENN).
               COMPUTE #POWER1N=100-((1-CDF.NORMAL((#temp - (#ZALPHA1*#NUM1N))/(#NUM2N),0,1))*100).
               COMPUTE #POWER2N=100-((1-CDF.NORMAL((#temp - (#ZALPHA2*#NUM1N))/(#NUM2N),0,1))*100).

*              Normal method with Fleiss correction.
               COMPUTE #temp=SQRT((#N1-#FLEISS)*#DENN).
               COMPUTE #POWER1NC=100-((1-CDF.NORMAL((#temp - (#ZALPHA1*#NUM1N))/(#NUM2N),0,1))*100).
               COMPUTE #POWER2NC=100-((1-CDF.NORMAL((#temp - (#ZALPHA2*#NUM1N))/(#NUM2N),0,1))*100).

               IF ((#N0*#I0*#D)<10 or (#N0*(1-(#I0*#D)))<10) #WARNING2=1.
               IF ((#N1*#I1*#D)<10 or (#N1*(1-(#I1*#D)))<10) #WARNING2=1.

               DO IF (#ERROR=0).
                  PRINT /'Sample size: n0 = ' #N0(F6) ' ; n1 = ' #N1(F6) ' (Ratio n0/n1 = ' #R(F4.2)')'.
                  PRINT /'Alpha Risk= ' !QUOTE(!ALPHA) '%'.
                  PRINT SPACE.

                  PRINT  /'                  |              POWER (%)          |'.
                  PRINT  /' METHOD           | Two-Sided Test | One-Sided Test |'.
                  PRINT  /'------------------+----------------+----------------+'.
                  DO IF (#WARNING1=1 or #WARNING2=1).
                     PRINT  /' Normal*          |      '#POWER2N(F4.1)'      |      '#POWER1N(F4.1)'      |'.
                  ELSE.
                     PRINT  /' Normal           |      '#POWER2N(F4.1)'      |      '#POWER1N(F4.1)'      |'.
                  END IF.
                  PRINT  /' Normal corrected |      '#POWER2NC(F4.1)'      |      '#POWER1NC(F4.1)'      |'.
                  PRINT  /' ArcoSinus        |      '#POWER2A(F4.1)'      |      '#POWER1A(F4.1)'      |'.
                  PRINT  /'------------------+----------------+----------------+'.
               END IF.
            !IFEND.
         !IFEND.
         DO IF ((#WARNING1=1 or #WARNING2=1) and #ERROR=0).
            PRINT /'(*)WARNING: Applicability conditions for Normal method not granted'.
            DO IF (#WARNING1=1).
               PRINT /'I0*D and I1*D must be >=0.2 and <=0.8'.
            END IF.
            DO IF (#WARNING2=1).
               PRINT /'N0*I0*D, N0*(1-I0*D), N1*I1*D and N1*(1-I1*D) must be >=10'.
            END IF.
         END IF.
      END IF.
   !IFEND.
   PRINT SPACE.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
