PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !NM2IS V2010.02.15 loaded.'
         /'Execute !NM2IS HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !NM2IS(  SD = !CHAREND('/') 
              /VAR = !CHAREND('/') 
           /EFFECT = !CHAREND('/') 
                /R = !CHAREND('/') !DEFAULT('1')
            /ALPHA = !CHAREND('/')
             /BETA = !CHAREND('/')
               /N0 = !CHAREND('/')
               /N1 = !CHAREND('/')
              /NST = !CHAREND('/')
             /HELP = !CHAREND('/') !DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2010.02.15').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
  PRINT //'Macro !NM2IS V' !VERSION ' (c)JM.Domenech'.
END IF.
TEMPORARY.
N 1.
COMPUTE #ERROR=0.
!IF (!HELP<>1) !THEN.
*  Impresin de la documentacin.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* SAMPLE SIZE (MEAN) & POWER DETERMINATION: Two-independent samples          *'
            /'* Created 2000.03.14 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech                                                            *'
            /'* Programmers: A.Bonillo & R.Sesma                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM. Macro !NM2IS for SPSS Statistics.                             *'
            /'*    Sample Size (Mean) & Power Determination: Two-independent samples       *'
            /'*    [computer program].                                                     *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* !NM2IS {SD = Common standard deviation of Groups 0 and 1  (SD > 0)         *'
            /'*    or /VAR}= Common variance of Groups 0 and 1            (VAR > 0)        *'
            /'*    /EFFECT = Minimum expected effect size                 (EFFECT > 0)     *'
            /'*    [/ALPHA]= Alpha risk in %; by default: 5               (0< ALPHA <= 50) *'
            /'*     {/BETA = Beta  risk in %; by default: 20 15 10        (0< BETA  <= 50) *'
            /'*     or /N1 = Sample Size (Group 1)                        (N1 integer > 0) *'
            /'*      & /N0}= Sample Size (Group 0);  by default: r*N1     (N0 integer > 0) *'
            /'*             (N1 & N0 parameters compute power)                             *'
            /'*        [/r]= Ratio N0/N1; by default:1                    (r  > 0 )        *'
            /'*      [/NST]= Name of the study (Label)                                     *'
            /'*      [/HELP] Print Macro call arguments and Samples of calls               *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements *'
            /'*                                                                            *'
            /'* Samples of calls:                                                          *'
            /'*  !NM2IS HELP.                                                              *'
            /'*  !NM2IS SD=10 /EFFECT=6 /r=1.5 .                                           *'
            /'*  !NM2IS VAR=100 /EFFECT=6 /ALPHA=5 /BETA=15 /NST="Name of the Study".      *'
            /'*  !NM2IS SD=10 /EFFECT=6 /ALPHA=10 /N0=55 /N1=37.                           *'
            /'******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Testing the parameters.
   !IF ((!VAR=!NULL !AND !SD=!NULL) !OR !EFFECT=!NULL) !THEN.
      !IF ((!VAR=!NULL !AND !SD=!NULL)) !THEN.
         PRINT /'ERROR: Missing parameter VAR or SD. See the HELP.'.
      !ELSE.
         PRINT /'ERROR: Missing parameter EFFECT. See the HELP.'.
      !IFEND.
   !ELSE.
      COMPUTE #ERROR=0.

*     Test missing, too much parameters.
      !IF (!N0=!NULL !AND !N1=!NULL) !THEN.
         !IF (!ALPHA<>!NULL !AND !BETA=!NULL) !THEN.
            COMPUTE #ERROR=1.
         !ELSE.
            !IF (!ALPHA=!NULL !AND !BETA<>!NULL) !THEN.
               COMPUTE #ERROR=2.
            !IFEND.
         !IFEND.
      !ELSE.
         !IF (!ALPHA=!NULL) !THEN.
            COMPUTE #ERROR=2.
         !ELSE.
            !IF (!BETA<>!NULL) !THEN.
               COMPUTE #ERROR=3.
            !ELSE.
               !IF (!N0<>!NULL !AND !N1<>!NULL !AND !R<>'1') !THEN.
                  COMPUTE #ERROR=4.
               !IFEND.
            !IFEND.
         !IFEND
      !IFEND.
      !IF (!VAR<>!NULL !AND !SD<>!NULL) !THEN.
         COMPUTE #ERROR=15. 
      !IFEND.

*     Test EFFECT value.
      COMPUTE #EFFECT=!EFFECT.
      DO IF SYSMIS(#EFFECT).
         COMPUTE #ERROR=5.
      ELSE.
         IF (#EFFECT<=0) #ERROR=5.
      END IF.
      
*     Test R value.
      !IF (!R<>!NULL) !THEN.
         COMPUTE #r=!R.
         DO IF SYSMIS(#r).
            COMPUTE #ERROR=6.
         ELSE.
            IF (#r<=0) #ERROR=6.
         END IF.
      !ELSE.
         COMPUTE #r=1.
      !IFEND.

*     Test VAR,SD values.
      !LET !VarParam = 0.
      !IF (!VAR<>!NULL) !THEN.
         !LET !VarParam = 1.
         COMPUTE #VAR=!VAR.
         DO IF SYSMIS(#VAR).
            COMPUTE #ERROR=7.
         ELSE.
            IF (#VAR<=0) #ERROR=7.
         END IF.
      !ELSE.
         COMPUTE #SD=!SD.
         DO IF SYSMIS(#SD).
            COMPUTE #ERROR=8.
         ELSE.
            IF (#SD<=0) #ERROR=8.
            COMPUTE #VAR=#SD**2.
         END IF.
      !IFEND.

*     Test ALPHA values.
      !IF (!ALPHA<>!NULL) !THEN.
         COMPUTE #ALPHA=!ALPHA.
         DO IF SYSMIS(#ALPHA).
            COMPUTE #ERROR=9.
         ELSE.
            IF (#ALPHA<=0 or #ALPHA>50) #ERROR=9.
         END IF.
      !IFEND.

*     Test BETA values.
      !IF (!BETA<>!NULL) !THEN.
         COMPUTE #BETA=!BETA.
         DO IF SYSMIS(#BETA).
            COMPUTE #ERROR=10.
         ELSE.
            IF (#BETA<=0 or #BETA>50) #ERROR=10.
         END IF.
      !IFEND.

*     Test N0 values.
      !IF (!N0<>!NULL) !THEN.
         COMPUTE #N0=!N0.
         DO IF SYSMIS(#N0).
            COMPUTE #ERROR=11.
         ELSE.
            IF (#N0<=1) #ERROR=11.
            IF (MOD(#N0,1)<>0) #ERROR=12.
         END IF.
      !IFEND.

*     Test N1 values.
      !IF (!N1<>!NULL) !THEN.
         COMPUTE #N1=!N1.
         DO IF SYSMIS(#N1).
            COMPUTE #ERROR=13.
         ELSE.
            IF (#N1<=1) #ERROR=13.
            IF (MOD(#N1,1)<>0) #ERROR=14.
         END IF.
      !IFEND.

      DO IF (#ERROR=1).
         PRINT /'ERROR: Missing parameter BETA. See the HELP.'.
      ELSE IF (#ERROR=2).
         PRINT /'ERROR: Missing parameter ALPHA. See the HELP.'.
      ELSE IF (#ERROR=3).
         PRINT /'ERROR: Parameter BETA is incompatible with parameters N1,N0. See the HELP.'.
      ELSE IF (#ERROR=4).
         PRINT /'ERROR: Parameter r is incompatible with parameters N1,N0. See the HELP.'.
      ELSE IF (#ERROR=5).
         PRINT /'ERROR: Parameter EFFECT with wrong value. See the HELP.'.
      ELSE IF (#ERROR=6).
         PRINT /'ERROR: Parameter R with wrong value. See the HELP.'.
      ELSE IF (#ERROR=7).
         PRINT /'ERROR: Parameter VAR with wrong value. See the HELP.'.
      ELSE IF (#ERROR=8).
         PRINT /'ERROR: Parameter SD with wrong value. See the HELP.'.
      ELSE IF (#ERROR=9).
         PRINT /'ERROR: Parameter ALPHA with wrong value. See the HELP.'.
      ELSE IF (#ERROR=10).
         PRINT /'ERROR: Parameter BETA with wrong value. See the HELP.'.
      ELSE IF (#ERROR=11).
         PRINT /'ERROR: Parameter N0 with wrong value. See the HELP.'.
      ELSE IF (#ERROR=12).
         PRINT /'ERROR: Parameter N0 with decimal value. See the HELP.'.
      ELSE IF (#ERROR=13).
         PRINT /'ERROR: Parameter N1 with wrong value. See the HELP.'.
      ELSE IF (#ERROR=14).
         PRINT /'ERROR: Parameter N1 with decimal value. See the HELP.'.
      ELSE IF (#ERROR=15).
         PRINT /'ERROR: Parameters VAR and SD are incompatible. See the HELP.'.
      ELSE.
*        Print: Head.
         PRINT /'SAMPLE SIZE (MEAN) & POWER DETERMINATION: Two-independent samples'.
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.

         !IF (!VarParam=1) !THEN.
            PRINT //'Common variance = '!QUOTE(!VAR).
         !ELSE.
            PRINT //'Common standard deviation = '!QUOTE(!SD).
         !IFEND.
         PRINT /'Minimum expected effect size = '!QUOTE(!EFFECT).

*       Print a table when ALPHA and BETA are defaults.
         !IF (!ALPHA =!NULL !AND !BETA =!NULL) !THEN
            COMPUTE #WARNING=0.
            COMPUTE #D=#R*(#EFFECT)**2.

            !LET !ALPHAu = '5'.
            !LET !BETAu  = '20 15 10'.
            !DO !J=0 !TO 1.
               !DO !I=1 !TO 2.
                  !DO !A !IN(!ALPHAu).
                     COMPUTE  #ZALPHA=IDF.NORMAL((100-!A/!I)/100,0,1).
                     !DO !B !IN(!BETAu).
                        COMPUTE #ZBETA=IDF.NORMAL((100-!B)/100,0,1).
                        !LET !VARNAME=!CONCAT('#N',!J,!I,!A,!B).
                        COMPUTE !VARNAME=(#r+1)*#VAR*(#ZALPHA+#ZBETA)**2/#D.
                        IF (!J=0) !VARNAME=!VARNAME*#R.
                        IF (MOD(!VARNAME,1)<>0) !VARNAME=TRUNC(!VARNAME)+1.
                        IF (!VARNAME<30) #WARNING=1.
                     !DOEND.
                  !DOEND.
               !DOEND.
            !DOEND.
*           Compute Total.
            !DO !I=1 !TO 2.
               !DO !A !IN(!ALPHAu).
                  !DO !B !IN(!BETAu).
                     COMPUTE !CONCAT('#N',!I,!A,!B)=!CONCAT('#N0',!I,!A,!B)+!CONCAT('#N1',!I,!A,!B).
                  !DOEND.
               !DOEND.
            !DOEND.

            DO IF (#ERROR=0).
*              Print: Two and one-sided test in a table.
               PRINT /'Ratio N0/N1 = '!QUOTE(!R).
               PRINT SPACE.

               PRINT /'Alpha Risk=5%|     Two-Sided Test   |     One-Sided Test   |'.
               PRINT /'        Power|    80%    85%    90% |    80%    85%    90% |'.
               PRINT /'-------------+----------------------+----------------------+'.
               PRINT /'          n0 |' #N02520(T15,F6) #N02515(T22,F6) #N02510(T29,F6) '|'37 #N01520(T38,F6) #N01515(T45,F6) #N01510(T52,F6) '|'60.
               PRINT /'          n1 |' #N12520(T15,F6) #N12515(T22,F6) #N12510(T29,F6) '|'37 #N11520(T38,F6) #N11515(T45,F6) #N11510(T52,F6) '|'60.
               PRINT /'       Total |' #N2520(T15,F6)  #N2515(T22,F6)  #N2510(T29,F6)  '|'37 #N1520(T38,F6)  #N1515(T45,F6)  #N1510(T52,F6)  '|'60.
               PRINT /'-------------+----------------------+----------------------+'.

               DO IF (#WARNING=1).
                  PRINT /'WARNING: Normal assumption required for small size (N<30)'.
               END IF.
            END IF.
         !ELSE.
*           If ALPHA or BETA aren't defaults print a brief output.
            COMPUTE #ZALPHA1=IDF.NORMAL((100-#ALPHA)/100,0,1).
            COMPUTE #ZALPHA2=IDF.NORMAL((100-#ALPHA/2)/100,0,1).
            COMPUTE #WARNING=0.

            !IF (!N0=!NULL !AND !N1=!NULL) !THEN.
               COMPUTE #ZBETA=IDF.NORMAL((100-#BETA)/100,0,1).
               COMPUTE #P=100-#BETA.
               COMPUTE #D=#R*(#EFFECT)**2.
               COMPUTE #N1UNI=(#r+1)*#VAR*(#ZALPHA1+#ZBETA)**2/#D.
               COMPUTE #N0UNI=#R*#N1UNI.
               COMPUTE #N1BIL=(#r+1)*#VAR*(#ZALPHA2+#ZBETA)**2/#D.
               COMPUTE #N0BIL=#R*#N1BIL.

               DO REPEAT N=#N1UNI #N0UNI #N1BIL #N0BIL.
                  IF (MOD(N,1)<>0) N=TRUNC(N)+1.
               END REPEAT.

               COMPUTE #NUNI=#N1UNI+#N0UNI.
               COMPUTE #NBIL=#N1BIL+#N0BIL.

*              Small Size notes.
               STRING #T0BIL #T0UNI #T1BIL #T1UNI (A1).
               COMPUTE #T0BIL=' '.
               COMPUTE #T0UNI=' '.
               COMPUTE #T1BIL=' '.
               COMPUTE #T1UNI=' '.
               IF (#N0BIL<30 OR #N0UNI<30 OR #N1BIL<30 OR #N1UNI<30) #WARNING=1.
               IF (#N0BIL<30) #T0BIL='*'.
               IF (#N0UNI<30) #T0UNI='*'.
               IF (#N1BIL<30) #T1BIL='*'.
               IF (#N1UNI<30) #T1UNI='*'.

               DO IF (#ERROR=0).
                  PRINT /'Alpha Risk = ' !QUOTE(!ALPHA) '%; Beta Risk = '!QUOTE(!BETA) '%; Power = '#P(F4.1)'%'.
                  PRINT /'Ratio N0/N1 = '!QUOTE(!R).
                  PRINT SPACE.

                  PRINT /'SAMPLE SIZE'.
                  PRINT /'Two-Sided Test       One-Sided Test'.
                  PRINT /'   n0 = '#N0BIL(F6.0)#T0BIL(A1) 'n0 = '25 #N0UNI(T30,F6.0)#T0UNI(A1).
                  PRINT /'   n1 = '#N1BIL(F6.0)#T1BIL(A1) 'n1 = '25 #N1UNI(T30,F6.0)#T1UNI(A1).
                  PRINT /'Total = ' #NBIL(T9,F6.0)     'Total = '22 #NUNI(T30,F6.0).
               END IF.
            !ELSE.
               !IF (!N0<>!NULL !AND !N1<>!NULL) !THEN.
                  COMPUTE #R=(#N0/#N1).
               !ELSE.
                  !IF (!N0<>!NULL) !THEN.
                     COMPUTE #N1=(#N0/#R).
                     IF (MOD(#N1,1)<>0) #N1=TRUNC(#N1)+1.
                  !ELSE.
                     COMPUTE #N0=#R*#N1.
                     IF (MOD(#N0,1)<>0) #N0=TRUNC(#N0)+1.
                  !IFEND.
               !IFEND.

               COMPUTE #temp=SQR((#N1*#R*(#EFFECT)**2)/((#R+1)*#VAR)).
               COMPUTE #ZBETA1=#temp - #ZALPHA1.
               COMPUTE #BETA1=(1-CDF.NORMAL(#ZBETA1,0,1))*100.
               COMPUTE #POWER1=100-#BETA1.
               COMPUTE #ZBETA2=#temp - #ZALPHA2.
               COMPUTE #BETA2=(1-CDF.NORMAL(#ZBETA2,0,1))*100.
               COMPUTE #POWER2=100-#BETA2.

               DO IF (#ERROR=0).
                  DO IF (#N0<30 or #N1<30).
                     COMPUTE #WARNING=1.
                     DO IF (#N0<30 and #N1<30).
                        PRINT /'Sample size: n0 = ' #N0(F7) '*; n1 = ' #N1(F7) '* (Ratio N0/N1 = ' #R(F4.2) ')'.
                     ELSE IF (#N0<30 and #N1>=30).
                        PRINT /'Sample size: n0 = ' #N0(F7) '*; n1 = ' #N1(F7) ' (Ratio N0/N1 = ' #R(F4.2) ')'.
                     ELSE IF (#N0>=30 and #N1<30).
                        PRINT /'Sample size: n0 = ' #N0(F7) '; n1 = ' #N1(F7) '* (Ratio N0/N1 = ' #R(F4.2) ')'.
                     END IF.
                  ELSE.
                     PRINT /'Sample size: n0 = ' #N0(F7) '; n1 = ' #N1(F7) ' (Ratio N0/N1 = ' #R(F4.2) ')'.
                  END IF.
                  DO IF (#ERROR=0).
                     PRINT /'Alpha Risk = ' !QUOTE(!ALPHA)'%'.
                     PRINT SPACE.
                     PRINT /'POWER'.
                  END IF.
                  PRINT /' One-Sided Test: Pow = ' #POWER1(F4.1) '% (Beta Risk = ' #BETA1(F4.1) '%)'.
                  PRINT /' Two-Sided Test: Pow = ' #POWER2(F4.1) '% (Beta Risk = ' #BETA2(F4.1) '%)'.
               END IF.
            !IFEND.

            DO IF (#WARNING=1 and #ERROR=0).
               PRINT /'(*)WARNING: Small Size (normal assumption required)'.
            END IF.
         !IFEND.
      END IF.
   !IFEND.
!IFEND.
PRINT SPACE.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
