PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !NR2IS V2010.02.15 loaded.'
         /'Execute !NR2IS HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !NR2IS( R0 = !CHAREND('/') 
              /R1 = !CHAREND('/') 
             /PE0 = !CHAREND('/')
             /PE1 = !CHAREND('/')
              /RD = !CHAREND('/')
              /RR = !CHAREND('/') 
             /ODR = !CHAREND('/') 
               /R = !CHAREND('/') !DEFAULT('1')
           /ALPHA = !CHAREND('/') 
            /BETA = !CHAREND('/') 
              /N0 = !CHAREND('/')
              /N1 = !CHAREND('/')
             /NST = !CHAREND('/')
            /HELP = !CHAREND('/') !DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2010.02.15').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
  PRINT //'Macro !NR2IS V' !VERSION ' (c)JM.Domenech'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*  Print the help.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* SAMPLE SIZE (RISK) & POWER DETERMINATION: Two independent samples          *'
            /'* Created 1999.10.02 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech                                                            *'
            /'* Programmers: A.Bonillo & R.Sesma                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM. Macro !NR2IS for SPSS Statistics.                             *'
            /'*    Sample Size (Risk) & Power Determination: Two independent samples       *'
            /'*    [computer program].                                                     *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'* !NR2IS  r = Ratio N0/N1  (by default: 1)                   (r  > 0 )       *'
            /'*     [/NST]= Name of the study (Label)                                      *'
            /'*     [/HELP] Print Macro call arguments and Samples of calls                *'
            /'*                                                                            *'
            /'*        Parameters for COHORT Risk studies:                                 *'
            /'*        R0 = Event risk in UnExposed(%)                     (0 < R0 < 100)  *'
            /'*      {/R1 = Event risk in Exposed(%)                       (0 < R1 < 100)  *'
            /'*   or  /RR = Expected Risk Ratio                            (RR > 0 )       *'
            /'*   or  /RD = Expected Risk Difference                       (RD <> 0)       *'
            /'*   or /ODR}= Expected Odds Ratio                            (ODR > 0 )      *'
            /'*                                                                            *'
            /'*        Parameters for CASE-CONTROL studies:                                *'
            /'*       PE0 = Proportion of exposed in NonCases(%)           (0 < PE0 < 100) *'
            /'*     {/PE1 = Proportion of exposed in Cases(%)              (0 < PE1 < 100) *'
            /'*   or /ODR}= Expected Odds Ratio                            (ODR > 0 )      *'
            /'*----------------------------------------------------------------------------*'
            /'*        Parameters for SAMPLE SIZE computations:                            *'
            /'*    /ALPHA = Alpha risk(%); by default: 5                   (0< ALPHA<= 50) *'
            /'*     /BETA = Beta  risk(%); by default: 20 15 10            (0< BETA <= 50) *'
            /'*----------------------------------------------------------------------------*'
            /'*        Parameters for POWER computations:                                  *'
            /'*       /N0 = Sample Size in group 0                         (N0>1)          *'
            /'*       /N1 = Sample Size in group 1                         (N1>1)          *'
            /'*   {or /N0 and /r} , {or /N1 and /r}                                        *'
            /'*     /ALPHA= Alpha risk(%); REQUIRED for POWER computations (0< ALPHA<= 50) *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements *'
            /'*                                                                            *'
            /'* Samples of calls:                                                          *'
            /'*  !NR2IS HELP.                                                              *'
            /'*  !NR2IS R0=30 /RD=10.                                                      *'
            /'*  !NR2IS PE0=25 /ODR=2.5 /r=2 .                                             *'
            /'*  !NR2IS R0=4 /RR=2 /r=5.67 /ALPHA=5 /BETA=15 /NST="Name of the Study".     *'
            /'*  !NR2IS R0=4 /RR=2 /r=5.67 /N1=363 /ALPHA=5.                               *'
            /'*  !NR2IS R0=4 /RR=2 /N0=2059 /N1=363 /ALPHA=5.                              *'
            /'******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Testing the parameters and computing #P1.
   COMPUTE #ERROR=0.

   !IF (!R0=!NULL !AND !PE0=!NULL !OR (!R1=!NULL !AND !PE1=!NULL !AND !RD=!NULL !AND !RR=!NULL !AND !ODR=!NULL) ) !THEN.
      PRINT /'ERROR: Missing parameter'.
   !ELSE.
      !IF (!R0<>!NULL) !THEN.
         COMPUTE #P0=!R0.
         !IF (!PE0<>!NULL) !THEN.
            COMPUTE #ERROR=3.
         !ELSE.
            DO IF (!R0<=0 or !R0>=100).
               COMPUTE #ERROR=1.
            END IF.
         !IFEND.
      !ELSE.
         COMPUTE #P0=!PE0.
         !IF (!R0<>!NULL) !THEN.
            COMPUTE #ERROR=3.
         !ELSE.
            DO IF (!PE0<=0 or !PE0>=100).
               COMPUTE #ERROR=1.
            END IF.
         !IFEND.
      !IFEND.

      !IF (!R1<>!NULL !AND !RD=!NULL !AND !RR=!NULL !AND !ODR=!NULL !AND !PE0=!NULL !AND !PE1=!NULL) !THEN.
         COMPUTE #P1=!R1.
         DO IF (!R1<=0 or !R1>=100).
            COMPUTE #ERROR=1.
         END IF.
      !ELSE.
         !IF (!PE1<>!NULL !AND !RD=!NULL !AND !RR=!NULL !AND !ODR=!NULL !AND !R1=!NULL) !THEN.
            COMPUTE #P1=!PE1.
            DO IF (!PE1<=0 or !PE1>=100).
               COMPUTE #ERROR=1.
            END IF.
         !ELSE.
            !IF (!R1=!NULL !AND !RD<>!NULL !AND !RR=!NULL !AND !ODR=!NULL) !THEN.
               COMPUTE #P1=!RD+!R0.
               DO IF (!RD=0).
                  COMPUTE #ERROR=1.
               END IF.
            !ELSE.
               !IF (!R1=!NULL !AND !RD=!NULL !AND !RR<>!NULL !AND !ODR=!NULL) !THEN.
                  COMPUTE #P1=!RR*!R0.
                  DO IF (!RR<=0).
                     COMPUTE #ERROR=1.
                  END IF.
               !ELSE.
                  !IF (!R1=!NULL !AND !PE1=!NULL !AND !RD=!NULL !AND !RR=!NULL !AND !ODR<>!NULL) !THEN.
                     COMPUTE #P1=(100*(!PE0/(100-!PE0)) *!ODR)/( ((!PE0/(100-!PE0))*!ODR)+1).
                     DO IF (!ODR<=0).
                        COMPUTE #ERROR=1.
                     END IF.
                  !ELSE.
                     COMPUTE #ERROR=2.
                  !IFEND.
               !IFEND.
            !IFEND.
         !IFEND.
      !IFEND.


      !IF (!N0=!NULL !AND !N1=!NULL) !THEN.
         !IF (!ALPHA<>!NULL !AND !BETA=!NULL) !THEN.
            COMPUTE #ERROR=4.
         !ELSE.
            !IF (!ALPHA=!NULL !AND !BETA<>!NULL) !THEN.
               COMPUTE #ERROR=4.
            !IFEND.
         !IFEND.
      !ELSE.
         !IF (!ALPHA=!NULL) !THEN.
            COMPUTE #ERROR=4.
         !ELSE.
            !IF (!BETA<>!NULL) !THEN.
               COMPUTE #ERROR=3.
            !ELSE.
               !IF (!N0<>!NULL !AND !N1<>!NULL !AND !R<>'1') !THEN.
                  COMPUTE #ERROR=3.
               !IFEND.
            !IFEND.
         !IFEND
      !IFEND.

      !IF (!ALPHA<>!NULL) !THEN.
         COMPUTE #ALPHA=!ALPHA.
         DO IF (#ALPHA<=0 or #ALPHA>50).
            COMPUTE #ERROR=1.
         END IF.
      !IFEND.

      !IF (!BETA<>!NULL) !THEN.
         COMPUTE #BETA=!BETA.
         DO IF (#BETA<=0 or #BETA>50).
            COMPUTE #ERROR=1.
         END IF.
      !IFEND.

      !IF (!N0=!NULL !AND !N1=!NULL) !THEN.
         COMPUTE #r=!R.
      !ELSE.
         !IF (!N0<>!NULL !AND !N1<>!NULL) !THEN.
            COMPUTE #N0=!N0.
            COMPUTE #N1=!N1.
            COMPUTE #r=(#N0/#N1).
         !ELSE.
            COMPUTE #r=!R.
            !IF (!N0<>!NULL) !THEN.
               COMPUTE #N0=!N0.
               COMPUTE #N1=(#N0/#r).
               IF (MOD(#N1,1)<>0) #N1=TRUNC(#N1)+1.
            !ELSE.
               COMPUTE #N1=!N1.
               COMPUTE #N0=#r*#N1.
               IF (MOD(#N0,1)<>0) #N0=TRUNC(#N0)+1.
            !IFEND.
         !IFEND.
         !IF (!N0<>!NULL) !THEN.
            DO IF (MOD(!N0,1)<>0).
               COMPUTE #ERROR=5.
            ELSE IF (!N0<=1).
               COMPUTE #ERROR=1.
            END IF.
         !IFEND.
         !IF (!N1<>!NULL) !THEN.
            DO IF (MOD(!N1,1)<>0).
               COMPUTE #ERROR=5.
            ELSE IF (!N1<=1).
               COMPUTE #ERROR=1.
            END IF.
         !IFEND.
      !IFEND.

      DO IF (#r<=0).
         COMPUTE #ERROR=1.
      END IF.

      DO IF (#ERROR=1).
         PRINT /'ERROR: Parameter(s) with wrong values'.
      ELSE IF (#ERROR=2).
         PRINT /'ERROR: Too much parameter(s); specify only one of R1, PE1, RD, RR or ODR'.
      ELSE IF (#ERROR=3).
         PRINT /'ERROR: Too much parameter(s)'.
      ELSE IF (#ERROR=4).
         PRINT /'ERROR: Missing parameter'.
      ELSE IF (#ERROR=5).
         PRINT /'ERROR: Parameter(s) with decimal values.'.
      ELSE.
*        Correct parameters.
*        Computing the risk measures.
         NUMERIC #RR #OD #RD #RD1.
         COMPUTE #RR=#P1/#P0.
         COMPUTE #OD=(#P1/(100-#P1))/(#P0/(100-#P0)).
         COMPUTE #RD=#P1-#P0.
         COMPUTE #RD1=#RD/100.
         COMPUTE #WARNING1=0.
         COMPUTE #WARNING2=0.
         STRING #TempC (A1).
         COMPUTE #TempC = ' '.

*        Print: Head.
         PRINT /'SAMPLE SIZE (RISK) & POWER DETERMINATION: Two-independent samples'.
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.
         PRINT /' '.

         !IF (!PE0=!NULL) !THEN.
            PRINT /'Proportion(%) of events in: UnExposed (Group 0)= ' #P0(F5.2)'%'.
            PRINT /'                            Exposed   (Group 1)= ' #P1(F5.2)'%'.
            PRINT /'Minimum expected: RR='#RR(F6.2) '; OR='#OD(F6.2) '; RD= '#RD(F5.2)'%('#RD1(F6.5)')'.
         !ELSE.
            PRINT /'Proportion of exposed in: Noncases (Group 0)= ' #P0(F5.2)'%'.
            PRINT /'                          Cases    (Group 1)= ' #P1(F5.2)'%'.
            PRINT /'Minimum expected: OR='#OD(F6.2).
         !IFEND.

*        Print a table when ALPHA and BETA are defaults.
         !IF (!ALPHA =!NULL !AND !BETA =!NULL) !THEN.
            COMPUTE #DArcs=(4*#r)*(ARSIN(SQRT((#P0+#RD)/100))-ARSIN(SQRT(#P0/100)) )**2.
            COMPUTE #DNorm=#r*(#RD1**2).
            COMPUTE #FLEISS=(#r+1)/(#r*ABS(#RD1)).
            
            IF (#P0<20 or #P1<20 or #P0>80 OR #P1>80) #WARNING1=1.

            !LET !ALPHAu = '5'.
            !LET !BETAu  = '20 15 10'.
            !DO !J=0 !TO 1.
               !DO !I=1 !TO 2.
                  !DO !A !IN(!ALPHAu).
                     COMPUTE  #ZALPHA=IDF.NORMAL((100-!A/!I)/100,0,1).
                     !DO !B !IN(!BETAu).
                        COMPUTE #ZBETA=IDF.NORMAL((100-!B)/100,0,1).
*                       Sinusual inverse exact probability of Fisher (Arcosinus method).
                        !LET !VArcs=!CONCAT('#NA',!J,!I,!A,!B).
                        COMPUTE !VArcs=(#R)*(#R+1)*(#ZALPHA+#ZBETA)**2 /#DArcs.
                        IF (!J=1) !VArcs=!VArcs/#R.
                        IF (MOD(!VArcs,1)<>0) !VArcs=TRUNC(!VArcs)+1.
*                       Normal method.
                        !LET !VNorm=!CONCAT('#NN',!J,!I,!A,!B).
                        COMPUTE #Ppond=(#P1/100+#R*#P0/100)/(#R+1).
                        COMPUTE #NUM1=#ZALPHA*SQRT((#R+1)*#Ppond*(1-#Ppond)).
                        COMPUTE #NUM2=#ZBETA*SQRT( (#P0/100*(100-#P0)/100) +#R*(#P1/100*(100-#P1)/100) ).
                        COMPUTE !VNorm=(#NUM1+#NUM2)**2 / #DNorm.
                        IF (!J=0) !VNorm=!VNorm*#R.
                        IF (MOD(!VNorm,1)<>0) !VNorm=TRUNC(!VNorm)+1.
*                       Normal method with Fleiss correction.
                        !LET !VNormC=!CONCAT('#NF',!J,!I,!A,!B).
                        COMPUTE !VNormC=(#NUM1+#NUM2)**2 / #DNorm + #FLEISS.
                        IF (!J=0) !VNormC=!VNormC*#R.
                        IF (MOD(!VNormC,1)<>0) !VNormC=TRUNC(!VNormC)+1.
                        
                        !IF (!J=1) !THEN.
                           IF ((!VNorm*#P1/100)<10 or (!VNorm*(1-#P1/100))<10) #WARNING2=1.
                        !ELSE.
                           IF ((!VNorm*#P0/100)<10 or (!VNorm*(1-#P0/100))<10) #WARNING2=1.
                        !IFEND.
                     !DOEND.
                  !DOEND.
               !DOEND.
            !DOEND.
*           Compute Totals.
            !DO !I=1 !TO 2.
               !DO !A !IN(!ALPHAu).
                  !DO !B !IN(!BETAu).
                     COMPUTE !CONCAT('#NA',!I,!A,!B)=!CONCAT('#NA0',!I,!A,!B)+!CONCAT('#NA1',!I,!A,!B).
                     COMPUTE !CONCAT('#NN',!I,!A,!B)=!CONCAT('#NN0',!I,!A,!B)+!CONCAT('#NN1',!I,!A,!B).
                     COMPUTE !CONCAT('#NF',!I,!A,!B)=!CONCAT('#NF0',!I,!A,!B)+!CONCAT('#NF1',!I,!A,!B).
                  !DOEND.
               !DOEND.
            !DOEND.

*           Print: Two and one-sided test in a table.
            PRINT /'Ratio N0/N1 = '!QUOTE(!R).
            PRINT SPACE.

            IF (#WARNING1=1 OR #WARNING2=1) #TempC='*'.
            DO IF (#ERROR=0).
               PRINT /'                      |                SAMPLE SIZE                |'.
               PRINT /'         Alpha Risk=5%|    Two-Sided Test   |    One-Sided Test   |'.
               PRINT /' METHOD          Power|   80%    85%    90% |   80%    85%    90% |'.
               PRINT /'----------------------+---------------------+---------------------+'.
               PRINT /' Normal' #TempC(A1) '           n0 |' #NN02520(T24,F6) #NN02515(T31,F6) #NN02510(T38,F6) '|'45 #NN01520(T46,F6) #NN01515(T53,F6) #NN01510(T60,F6) '|'67.
               PRINT /'                   n1 |' #NN12520(T24,F6) #NN12515(T31,F6) #NN12510(T38,F6) '|'45 #NN11520(T46,F6) #NN11515(T53,F6) #NN11510(T60,F6) '|'67.
               PRINT /'                Total |' #NN2520(T24,F6)  #NN2515(T31,F6)  #NN2510(T38,F6)  '|'45 #NN1520(T46,F6)  #NN1515(T53,F6)  #NN1510(T60,F6)  '|'67.
               PRINT /'----------------------+---------------------+---------------------+'.
               PRINT /' Normal corrected  n0 |' #NF02520(T24,F6) #NF02515(T31,F6) #NF02510(T38,F6) '|'45 #NF01520(T46,F6) #NF01515(T53,F6) #NF01510(T60,F6) '|'67.
               PRINT /'                   n1 |' #NF12520(T24,F6) #NF12515(T31,F6) #NF12510(T38,F6) '|'45 #NF11520(T46,F6) #NF11515(T53,F6) #NF11510(T60,F6) '|'67.
               PRINT /'                Total |' #NF2520(T24,F6)  #NF2515(T31,F6)  #NF2510(T38,F6)  '|'45 #NF1520(T46,F6)  #NF1515(T53,F6)  #NF1510(T60,F6)  '|'67.
               PRINT /'----------------------+---------------------+---------------------+'.
               PRINT /' ArcoSinus         n0 |' #NA02520(T24,F6) #NA02515(T31,F6) #NA02510(T38,F6) '|'45 #NA01520(T46,F6) #NA01515(T53,F6) #NA01510(T60,F6) '|'67.
               PRINT /'                   n1 |' #NA12520(T24,F6) #NA12515(T31,F6) #NA12510(T38,F6) '|'45 #NA11520(T46,F6) #NA11515(T53,F6) #NA11510(T60,F6) '|'67.
               PRINT /'                Total |' #NA2520(T24,F6)  #NA2515(T31,F6)  #NA2510(T38,F6)  '|'45 #NA1520(T46,F6)  #NA1515(T53,F6)  #NA1510(T60,F6)  '|'67.
               PRINT /'----------------------+---------------------+---------------------+'.               
            END IF.            
         !ELSE.
*           If ALPHA or BETA aren't defaults print a brief output.
            COMPUTE #ZALPHA1=IDF.NORMAL((100-!ALPHA)/100,0,1).
            COMPUTE #ZALPHA2=IDF.NORMAL((100-!ALPHA/2)/100,0,1).
            COMPUTE #Ppond=(#P1/100 + #r*#P0/100)/(#r+1).
            COMPUTE #NUM1= SQRT((#r+1)*#Ppond*(1-#Ppond)).
            COMPUTE #NUM2= SQRT( (#P0/100)*(1-#P0/100) + #r*(#P1/100)*(1-#P1/100) ).
            COMPUTE #DA=(4*#r)*(ARSIN(SQRT((#P0+#RD)/100))-ARSIN(SQRT(#P0/100)) )**2.
            COMPUTE #DN= #r*(#RD1**2).
            COMPUTE #FLEISS=(#r+1)/(#r*ABS(#RD1)).
            IF (#P0<20 or #P1<20 or #P0>80 OR #P1>80) #WARNING1=1.

            !IF (!N0=!NULL !AND !N1=!NULL) !THEN.
               COMPUTE #ZBETA=IDF.NORMAL((100-!BETA)/100,0,1).

*              Sinusual inverse exact probability of Fisher.
               COMPUTE #N1UNIA=(#r+1)*(#ZALPHA1+#ZBETA)**2/#DA.
               COMPUTE #N1BILA=(#r+1)*(#ZALPHA2+#ZBETA)**2/#DA.
               COMPUTE #N0UNIA=#r*#N1UNIA.
               COMPUTE #N0BILA=#r*#N1BILA.
               IF (MOD(#N1UNIA,1)<>0) #N1UNIA=TRUNC(#N1UNIA)+1.
               IF (MOD(#N1BILA,1)<>0) #N1BILA=TRUNC(#N1BILA)+1.
               IF (MOD(#N0UNIA,1)<>0) #N0UNIA=TRUNC(#N0UNIA)+1.
               IF (MOD(#N0BILA,1)<>0) #N0BILA=TRUNC(#N0BILA)+1.
               COMPUTE #NUNIA=#N1UNIA+#N0UNIA.
               COMPUTE #NBILA=#N1BILA+#N0BILA.

*              Normal method.
               COMPUTE #N1UNIN=(#ZALPHA1*#NUM1 + #ZBETA*#NUM2)**2 /#DN.
               COMPUTE #N1BILN=(#ZALPHA2*#NUM1 + #ZBETA*#NUM2)**2 /#DN.
               COMPUTE #N0UNIN=#r*#N1UNIN.
               COMPUTE #N0BILN=#r*#N1BILN.
               IF (MOD(#N1UNIN,1)<>0) #N1UNIN=TRUNC(#N1UNIN)+1.
               IF (MOD(#N1BILN,1)<>0) #N1BILN=TRUNC(#N1BILN)+1.
               IF (MOD(#N0UNIN,1)<>0) #N0UNIN=TRUNC(#N0UNIN)+1.
               IF (MOD(#N0BILN,1)<>0) #N0BILN=TRUNC(#N0BILN)+1.
               COMPUTE #NUNIN=#N1UNIN+#N0UNIN.
               COMPUTE #NBILN=#N1BILN+#N0BILN.

*              Normal method with Fleiss correction.
               COMPUTE #N1UNINC=(#ZALPHA1*#NUM1 + #ZBETA*#NUM2)**2 /#DN + (#FLEISS).
               COMPUTE #N1BILNC=(#ZALPHA2*#NUM1 + #ZBETA*#NUM2)**2 /#DN + (#FLEISS).
               COMPUTE #N0UNINC=#r*#N1UNINC.
               COMPUTE #N0BILNC=#r*#N1BILNC.
               IF (MOD(#N1UNINC,1)<>0) #N1UNINC=TRUNC(#N1UNINC)+1.
               IF (MOD(#N1BILNC,1)<>0) #N1BILNC=TRUNC(#N1BILNC)+1.
               IF (MOD(#N0UNINC,1)<>0) #N0UNINC=TRUNC(#N0UNINC)+1.
               IF (MOD(#N0BILNC,1)<>0) #N0BILNC=TRUNC(#N0BILNC)+1.
               COMPUTE #NUNINC=#N1UNINC+#N0UNINC.
               COMPUTE #NBILNC=#N1BILNC+#N0BILNC.

               IF ((#N1UNIN*#P1/100)<10 or (#N1UNIN*(1-#P1/100))<10) #WARNING2=1.
               IF ((#N1BILN*#P1/100)<10 or (#N1BILN*(1-#P1/100))<10) #WARNING2=1.
               IF ((#N0UNIN*#P0/100)<10 or (#N0UNIN*(1-#P0/100))<10) #WARNING2=1.
               IF ((#N0BILN*#P0/100)<10 or (#N0BILN*(1-#P0/100))<10) #WARNING2=1.
               
               DO IF (#ERROR=0).
                  IF (#WARNING1=1 OR #WARNING2=1) #TempC='*'.
                  PRINT /'Alpha Risk = ' !QUOTE(!ALPHA) '%; Beta Risk = '!QUOTE(!BETA) '%;  Ratio N0/N1 = ' !QUOTE(!R).
                  PRINT SPACE.

                  PRINT  /'                      |           SAMPLE SIZE           |'.
                  PRINT  /' METHOD               | Two-Sided Test | One-Sided Test |'.
                  PRINT  /'----------------------+----------------+----------------+'.
                  PRINT  /' Normal' #TempC(A1) '           n0 |    '#N0BILN(F7)'     |    '#N0UNIN(F7)'     |'.
                  PRINT  /'                   n1 |    '#N1BILN(F7)'     |    '#N1UNIN(F7)'     |'.
                  PRINT  /'                Total |    '#NBILN(F7) '     |    '#NUNIN(F7) '     |'.
                  PRINT  /'----------------------+----------------+----------------+'.
                  PRINT  /' Normal corrected  n0 |    '#N0BILNC(F7)'     |    '#N0UNINC(F7)'     |'.
                  PRINT  /'                   n1 |    '#N1BILNC(F7)'     |    '#N1UNINC(F7)'     |'.
                  PRINT  /'                Total |    '#NBILNC(F7) '     |    '#NUNINC(F7) '     |'.
                  PRINT  /'----------------------+----------------+----------------+'.
                  PRINT  /' ArcoSinus         n0 |    '#N0BILA(F7)'     |    '#N0UNIA(F7)'     |'.
                  PRINT  /'                   n1 |    '#N1BILA(F7)'     |    '#N1UNIA(F7)'     |'.
                  PRINT  /'                Total |    '#NBILA(F7) '     |    '#NUNIA(F7) '     |'.
                  PRINT  /'----------------------+----------------+----------------+'.
               END IF.
            !ELSE.
*              Sinusual inverse exact probability of Fisher.
               COMPUTE #temp=SQR((#N1*#DA)/(#r + 1)).
               COMPUTE #POWER1A=100-((1-CDF.NORMAL(#temp - #ZALPHA1,0,1))*100).
               COMPUTE #POWER2A=100-((1-CDF.NORMAL(#temp - #ZALPHA2,0,1))*100).

*              Normal method.
               COMPUTE #temp=SQR(#N1*#DN).
               COMPUTE #POWER1N=100-((1-CDF.NORMAL((#temp - #ZALPHA1*#NUM1)/#NUM2,0,1))*100).
               COMPUTE #POWER2N=100-((1-CDF.NORMAL((#temp - #ZALPHA2*#NUM1)/#NUM2,0,1))*100).

*              Normal method with Fleiss correction.
               COMPUTE #temp=SQR((#N1-#FLEISS)*#DN).
               COMPUTE #POWER1NC=100-((1-CDF.NORMAL((#temp - #ZALPHA1*#NUM1)/#NUM2,0,1))*100).
               COMPUTE #POWER2NC=100-((1-CDF.NORMAL((#temp - #ZALPHA2*#NUM1)/#NUM2,0,1))*100).

               IF ((#N0*#P0/100)<10 or (#N0*(1-#P0/100))<10) #WARNING2=1.
               IF ((#N1*#P1/100)<10 or (#N1*(1-#P1/100))<10) #WARNING2=1.

               DO IF (#ERROR=0).
                  PRINT /'Sample size: n0 = ' #N0(F6) ' ; n1 = '#N1(F6) ' (Ratio n0/n1 = ' #r(F4.2) ')'.
                  PRINT /'Alpha Risk = ' !QUOTE(!ALPHA) '%'.
                  PRINT SPACE.

                  PRINT  /'                  |              POWER (%)          |'.
                  PRINT  /' METHOD           | Two-Sided Test | One-Sided Test |'.
                  PRINT  /'------------------+----------------+----------------+'.
                  DO IF (#WARNING1=1 or #WARNING2=1).
                     PRINT  /' Normal*          |      '#POWER2N(F4.1)'      |      '#POWER1N(F4.1)'      |'.
                  ELSE.
                     PRINT  /' Normal           |      '#POWER2N(F4.1)'      |      '#POWER1N(F4.1)'      |'.
                  END IF.
                  PRINT  /' Normal corrected |      '#POWER2NC(F4.1)'      |      '#POWER1NC(F4.1)'      |'.
                  PRINT  /' ArcoSinus        |      '#POWER2A(F4.1)'      |      '#POWER1A(F4.1)'      |'.
                  PRINT  /'------------------+----------------+----------------+'.
               END IF.
            !IFEND.
         !IFEND.
         DO IF ((#WARNING1=1 or #WARNING2=1) and #ERROR=0).
            PRINT /'(*)WARNING: Applicability conditions for Normal method not granted'.
            DO IF (#WARNING1=1).
               PRINT /'P0 and P1 must be >=20 and <=80'.
            END IF.
            DO IF (#WARNING2=1).
               PRINT /'N0*P0, N0*(1-P0), N1*P1 and N1*(1-P1) must be >=10'.
            END IF.
         END IF.
      END IF.
   !IFEND.
   PRINT SPACE.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.
