PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !NRMCC V2012.04.11 loaded.'
         /'Execute !NRMCC HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !NRMCC (ODR=!CHAREND('/') 
              /PE0=!CHAREND('/')
              /EOR=!CHAREND('/') 
              /r  =!CHAREND('/') !DEFAULT ('1')
            /ALPHA=!CHAREND('/')
            /BETA =!CHAREND('/')
             /NST =!CHAREND('/')
            /HELP =!CHAREND('/') !DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2012.04.11').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
   PRINT //'Macro !NRMCC V' !VERSION ' (c)JM.Domenech'.
END IF.
TEMPORARY.
N 1.
*Impresin de la documentacin.
!IF (!HELP<>1) !THEN.
   DO IF ($casenum=1).
      PRINT /'******************************************************************************'
            /'* SAMPLE SIZE: MATCHED CASE-CONTROL STUDY                                    *'
            /'* Created 2003.03.18 Last revised ' !VERSION                                '*'78
            /'* (c) JM.Domenech                                                            *'
            /'* Programmers: A.Bonillo & R.Sesma                                           *'
            /'*                                                                            *'
            /'* Vancouver reference:                                                       *'
            /'* Domenech JM. Macro !NRMCC for SPSS Statistics.                             *'
            /'*    Sample Size: Matched Case-Control Study [computer program].             *'
            /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
            /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
            /'*                                                                            *'
            /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
            /'*  !NRMCC ODR = Expected Odds Ratio (Matched)               (ODR > 0)        *'
            /'*        /PE0 = Proportion of exposed in Controls(%)        (0 < PE0 < 100)  *'
            /'*        /EOR = Exposure Odds Ratio between Cases & Controls: Phi  (EOR > 0) *'
            /'*         [/r]= Ratio M0/M1; by default: 1                  (r integer >= 1) *'
            /'*     [/ALPHA]= Alpha risk(%); by default: 5                (0< ALPHA<= 50)  *'
            /'*     [ /BETA]= Beta  risk(%); by default: 20 15 10         (0< BETA <= 50)  *'
            /'*       [/NST]= Name of the study (Label)                                    *'
            /'*       [/HELP] Print Macro call arguments and Samples of calls              *'
            /'*                                                                            *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
            /'*                                                                            *'
            /'* Samples of calls:                                                          *'
            /'*  !NRMCC HELP.                                                              *'
            /'*  !NRMCC ODR=2 /PE0=20 /EOR=2.5 /r=1 /ALPHA=5 /BETA=15 /NST="Study Name".   *'
            /'*  !NRMCC ODR=3 /PE0=30 /EOR=2.5 /r=2.                                       *'
            /'******************************************************************************'.
   END IF.
   EXECUTE.
!ELSE.
*  Testing the parameters.
   !IF (!ODR=!NULL !OR !PE0=!NULL !OR !EOR=!NULL) !THEN.
      PRINT /'ERROR: Missing parameter'.
   !ELSE.
      COMPUTE #ERROR=0.

*     Test parameter ODR,PE0,EOR,r.
      COMPUTE #OR=!ODR.
      COMPUTE #PE0=!PE0.
      COMPUTE #EOR=!EOR.
      COMPUTE #r=!r.
      DO IF (SYSMIS(#OR) OR SYSMIS(#PE0) OR SYSMIS(#EOR) OR SYSMIS(#r)).
         COMPUTE #ERROR=1.
      ELSE.
         IF (#OR<=0 OR #EOR<=0 OR #PE0<=0 OR #PE0>=100 OR MOD(#r,1)<>0 OR #r<1) #ERROR=1.
         COMPUTE #PE0=#PE0/100.
      END IF.

*     Test ALPHA, BETA values.
      !IF (!ALPHA<>!NULL !AND !BETA<>!NULL) !THEN.
         COMPUTE #ALPHA=!ALPHA.
         COMPUTE #BETA=!BETA.
         DO IF (SYSMIS(#ALPHA) OR SYSMIS(#BETA)).
            COMPUTE #ERROR=1.
         ELSE.
            IF (#ALPHA<=0 or #ALPHA>50 or #BETA<=0 or #BETA>50) #ERROR=1.
         END IF.
      !ELSE.
         !IF (!ALPHA<>!NULL !OR !BETA<>!NULL) !THEN.
            COMPUTE #ERROR=2.
         !IFEND.
      !IFEND.

      DO IF (#ERROR=1).
         PRINT /'ERROR: Parameter(s) with wrong values'.
      ELSE IF (#ERROR=2).
         PRINT /'ERROR: Missing parameter'.
      ELSE.
         COMPUTE #A=(#EOR-1)/#OR.
         COMPUTE #B= #PE0+(1-#PE0)/#OR.
         COMPUTE #C= -#PE0*(1-#PE0).
         COMPUTE #PI10= (-#B+SQRT(#B**2-4*#A*#C))/(2*#A).
         COMPUTE #PI01= #PI10/#OR.
         COMPUTE #PI1M0= #PI10 + #PI01.
         COMPUTE #PI1_0= #PI10 - #PI01.
         COMPUTE #FR= (#r + 1)/(2*#r).

*        Print: Head.
         PRINT /'SAMPLE SIZE: MATCHED CASE-CONTROL STUDY'.
         !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
            STRING #NST (A131).
            COMPUTE #NST = CONCAT('STUDY: ',!NST).
            PRINT /#NST.
         !IFEND.  
  
         PRINT//'Prop. of exposed in Controls= ' #PE0(F5.4).
         PRINT /'Exposure Odds Ratio between Cases & Controls: Phi=' #EOR(F5.2).
         PRINT /'Minimum expected Odds Ratio ='#OR(F6.2).
         PRINT /'Controls/Cases Ratio = '!QUOTE(!R).

         !IF (!ALPHA =!NULL !AND !BETA =!NULL) !THEN.
*           Print a table when ALPHA and BETA are defaults.
            !LET !ALPHAdef = '5'.
            !LET !BETAdef  = '20 15 10'.
            !DO !J=0 !TO 1.
               !DO !I=1 !TO 2.
                  !DO !A !IN(!ALPHAdef).
                     COMPUTE  #ZALPHA=IDF.NORMAL((100-!A/!I)/100,0,1).
                     !DO !B !IN(!BETAdef).
                        COMPUTE #ZBETA=IDF.NORMAL((100-!B)/100,0,1).
                        !LET !VARNAME=!CONCAT('#N',!J,!I,!A,!B).
                        COMPUTE !VARNAME=#FR*(((#ZALPHA*SQRT(#PI1M0)+ #ZBETA*SQRT(#PI1M0-#PI1_0**2))/#PI1_0 )**2).
                        IF (!J=0) !VARNAME=!VARNAME*#R.
                        IF (MOD(!VARNAME,1)<>0) !VARNAME=TRUNC(!VARNAME)+1.
                     !DOEND.
                  !DOEND.
               !DOEND.
            !DOEND.
*           Compute Totals.
            !DO !I=1 !TO 2.
               !DO !A !IN(!ALPHAdef).
                  !DO !B !IN(!BETAdef).
                     COMPUTE !CONCAT('#N',!I,!A,!B)=!CONCAT('#N0',!I,!A,!B)+!CONCAT('#N1',!I,!A,!B).
                  !DOEND.
               !DOEND.
            !DOEND.

            DO IF (#ERROR=0).
*              Print: Two and one-sided test in a table.
               PRINT /'METHOD: Multinomial with Fleiss-Levin correction'.
               PRINT SPACE.

               PRINT /'Alpha Risk=5%|    Two-Sided Test   |    One-Sided Test   |'.
               PRINT /'        Power|   80%    85%    90% |   80%    85%    90% |'.
               PRINT /'-------------+---------------------+---------------------+'.
               PRINT /'       Cases |' #N12520(T15,F6) #N12515(T22,F6) #N12510(T29,F6) '|'36 #N11520(T37,F6) #N11515(T44,F6) #N11510(T51,F6) '|'58.
               PRINT /'    Controls |' #N02520(T15,F6) #N02515(T22,F6) #N02510(T29,F6) '|'36 #N01520(T37,F6) #N01515(T44,F6) #N01510(T51,F6) '|'58.
               PRINT /'       TOTAL |' #N2520(T15,F6)  #N2515(T22,F6)  #N2510(T29,F6)  '|'36 #N1520(T37,F6)  #N1515(T44,F6)  #N1510(T51,F6)  '|'58.
               PRINT /'-------------+---------------------+---------------------+'.
            END IF.
         !ELSE.
*           If ALPHA or BETA aren't defaults print a brief output.
            COMPUTE  #ZALPHA1=IDF.NORMAL((100-#ALPHA)/100,0,1).
            COMPUTE  #ZALPHA2=IDF.NORMAL((100-#ALPHA/2)/100,0,1).
            COMPUTE  #ZBETA=IDF.NORMAL((100-#BETA)/100,0,1).

            COMPUTE #N1UNI=#FR*(((#ZALPHA1*SQRT(#PI1M0)+ #ZBETA*SQRT(#PI1M0-#PI1_0**2))/#PI1_0 )**2).
            COMPUTE #N1BIL=#FR*(((#ZALPHA2*SQRT(#PI1M0)+ #ZBETA*SQRT(#PI1M0-#PI1_0**2))/#PI1_0 )**2).
            COMPUTE #N0UNI=#R*#N1UNI.
            COMPUTE #N0BIL=#R*#N1BIL.

            IF (MOD(#N1UNI,1)<>0) #N1UNI=TRUNC(#N1UNI)+1.
            IF (MOD(#N1BIL,1)<>0) #N1BIL=TRUNC(#N1BIL)+1.
            IF (MOD(#N0UNI,1)<>0) #N0UNI=TRUNC(#N0UNI)+1.
            IF (MOD(#N0BIL,1)<>0) #N0BIL=TRUNC(#N0BIL)+1.

            COMPUTE #NUNI=#N1UNI+#N0UNI.
            COMPUTE #NBIL=#N1BIL+#N0BIL.

            PRINT  /'Alpha Risk = ' !QUOTE(!ALPHA) '%;  Beta Risk = '!QUOTE(!BETA) '%'.
            PRINT /'METHOD: Multinomial with Fleiss-Levin correction'.
            PRINT //'------------------+------------------+'.
            PRINT  /' TWO-SIDED TEST   | ONE-SIDED TEST   |'.
            PRINT  /'------------------+------------------+'.
            PRINT  /'    Cases='#N1BIL(F7) ' |    Cases=' #N1UNI(F7)' |'.
            PRINT  /' Controls='#N0BIL(F7) ' | Controls=' #N0UNI(F7)' |'.
            PRINT  /'    TOTAL='#NBIL (F7) ' |    TOTAL=' #NUNI (F7)' |'.
            PRINT  /'------------------+------------------+'.
         !IFEND.
      END IF.
   !IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.