PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !POW2IM V2009.04.29 loaded.'
         /'Execute !POW2IM HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !POW2IM (SE=!CHAREND('/') /DELTA=!CHAREND('/')
             /SIDE=!CHAREND('/') !DEFAULT('2')
            /ALPHA=!CHAREND('/') !DEFAULT('5')
             /UNIT=!CHAREND('/') 
              /DIR=!CHAREND('/')
              /NST=!CHAREND('/')
             /HELP=!CHAREND('/')!DEFAULT(1)).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2009.04.29').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
  PRINT //'Macro !POW2IM V' !VERSION ' (c)JM.Domenech & R.Granero'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*Impresin de la documentacin.
+  DO IF ($casenum=1).
+    PRINT /'******************************************************************************'
           /'* POWER CURVE: Z test for two independent means                              *'
           /'* Created 1999.02.19 Last revised ' !VERSION                                '*'78
           /'* (c) JM.Domenech & R.Granero                                                *'
           /'* Programmers: A.Bonillo & R.Sesma                                           *'
           /'*                                                                            *'
           /'* Vancouver reference:                                                       *'
           /'* Domenech JM, Granero R. Macro !POW2IM for SPSS Statistics.                 *'
           /'*    Power Curve: Z test for two independent means [computer program].       *'
           /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
           /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
           /'*                                                                            *'
           /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
           /'* !POW2IM   SE = Standard error of the difference(1)                         *'
           /'*      [/DELTA]= Difference increase       ; by default automatic            *'
           /'*      [ /SIDE]= 1(One-sided), 2(Two-sided); by default 2  (1 or 2)          *'
           /'*      [/ALPHA]= List of alpha risk(%)     ; by default 5% (0 < ALPHA <= 50) *'
           /'*      [ /UNIT]= Label with measurement units (up to 8 characters)           *'
           /"*      [  /DIR]= Working directory (must be unprotected)  By default: 'C:\'  *"
           /'*                Must be enclosed in a set of apostrophes. The macro makes a *'
           /'*                copy of the original data in this directory.                *'
           /'*      [  /NST]= Name of the study (Label)                                   *'
           /'*        [/HELP] Print Macro call arguments and Samples of calls             *'
           /'*                                                                            *'
           /'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
           /'* WARNING: This Macro creates a new SPSS working data file. For SAFETY, a    *'
           /'*          copy of your active data file is saved in the working directory   *'
           /'*          with the name @original.sav (by default, C:\@original.sav).       *'
           /'* (1) Standard error of the difference (SE):                                 *'
           /'*     NonEqual variances:   SE= SQR{Var0/n0 + Var1/n1}                       *'
           /'*     Equal variances:      SE= SQR{Var/n0  + Var/n1}                        *'
           /'*                              Var=(n0*Var0 + n1*Var1)/(n0+n1)               *'
           /'*                                                                            *'
           /'* Samples of calls:                                                          *'
           /'*  !POW2IM HELP.                                                             *'
           /'*  !POW2IM SE=2.5 /DELTA=1 /SIDE=1 /ALPHA=1 2.5 5 10 /UNIT= "cs".            *'
           /"*  !POW2IM SE=6.5 /NST='Name of the Study' /DIR='C:\Temporal'.               *"
           /'******************************************************************************'.
+  END IF.
EXECUTE.
+   COMPUTE #ERROR=1.
!ELSE.

*  Working directory.
!IF (!DIR=!NULL) !THEN.
   !LET !FOLDER = 'C:\'.
!ELSE.
   !LET !FOLDER = !CONCAT(!UNQUOTE(!DIR),'\').
!IFEND.
!LET !ORIGINAL=!CONCAT(!FOLDER,'@original.sav')).
SAVE OUTFILE=!QUOTE(!ORIGINAL).

*Creation of a matrix that contanis the difference increase.
INPUT PROGRAM.
!IF (!DELTA !NE !NULL) !THEN 
+   COMPUTE #DELTA=!DELTA.              /*User increase.
!ELSE.
+   COMPUTE #DELTA= RND(!SE*20)/100.    /*Automatic increase. 
!IFEND.

LOOP #J= 0 TO !SE*5 BY #DELTA.          /*Matrix of data.
+   COMPUTE EFFECT=#J.
+   END CASE.
END LOOP.
END FILE.
END INPUT PROGRAM.
EXECUTE.

*   Testing the parameters.
+   DO IF (!SE<=0).
+     COMPUTE #ERROR=1.
+   END IF.

+   DO REPEAT ALPHA=!ALPHA.
+     DO IF (ALPHA<=0 or ALPHA>50).
+       RECODE ALL (ELSE=SYSMIS).
+       COMPUTE #ERROR=1.
+     END IF.
+   END REPEAT.

!IF (!SIDE=1 !OR !SIDE=2) !THEN 
*Building the labels.
+   !LET !@CAB1 =!NULL.
+   !LET !@CAB2 =!NULL.
+   !LET !@ALPHA=!NULL.
+   !LET !ETIQ  =!NULL.
+   !LET !GRAPH =!NULL.
+   !DO !I !IN(!ALPHA).
+     !LET !@TALPHA=!CONCAT('P',!I).
+     !LET !@ALPHA =!CONCAT(!@ALPHA,' ',!@TALPHA).
+     !IF (!LENGTH(!I)=1) !THEN 
+       !LET !@TCAB1 =!CONCAT(' Alpha= ',!I,'%').
+     !ELSE.
+       !LET !@TCAB1 =!CONCAT(' Alpha=',!I,'%').
+     !IFEND.
+     !LET !@CAB1  =!CONCAT(!@CAB1,' ',!@TCAB1).
+     !LET !@TCAB2 =' POWER (%)'.
+     !LET !@CAB2  =!CONCAT(!@CAB2,' ',!@TCAB2).
+     !LET !TETIQ  =!CONCAT(!@TALPHA,' ',!QUOTE(!@TCAB1)).
+     !LET !ETIQ   =!CONCAT(!ETIQ,' ',!TETIQ).
+     !LET !TGRAPH ='EFFECT'.
+     !LET !GRAPH  =!CONCAT(!GRAPH,' ',!TGRAPH).
+   !DOEND.

*   Unit of mesure in braquets.
+   !IF (!UNIT<>!NULL) !THEN  
+     !LET !UNIT2=!CONCAT('(',!UNQUOTE(!UNIT),')').
+   !IFEND.
 
+   !IF (!SIDE=1) !THEN
+     !LET !HIPO='One-sided'.
+     COMPUTE #SIDE=1.
+   !ELSE. 
+     !LET !HIPO='Two-sided'.
+     COMPUTE #SIDE=2.
+   !IFEND.

*   Printing the head.
+   DO IF ($CASENUM=1 AND #ERROR=0).
+     PRINT /'POWER CURVE: ' !QUOTE(!HIPO) ' Z test for compare 2 independent means'.
      !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
         STRING #NST (A131).
         COMPUTE #NST = CONCAT('STUDY: ',!NST).
         PRINT /#NST.
      !IFEND.
      
+     PRINT//'True DIFF.' !QUOTE(!@CAB1).
+     PRINT /!QUOTE(!UNIT2) !QUOTE(!@CAB2)11.
+   END IF.

+   DO REPEAT POTEN=!@ALPHA /ALPHA=!ALPHA.
+     COMPUTE #P=(100-(ALPHA/#SIDE))/100.
+     COMPUTE #DC= IDF.NORMAL(#P,0,1)*!SE.
+     COMPUTE #ZBETA=(#DC-EFFECT)/ !SE.
+     COMPUTE POTEN=100*(1-CDFNORM(#ZBETA)).
+   END REPEAT.
+   FORMATS EFFECT (F9.1) !@ALPHA (F10.2).

+   DO IF   (#ERROR=0).
+     PRINT /EFFECT ' ' !@ALPHA.
+   ELSE IF   (#ERROR=1 AND $CASENUM=1).
+     PRINT /'ERROR: Parameter(s) with wrong values'.
+   END IF.

VARIABLE LABELS !ETIQ EFFECT !QUOTE(!CONCAT('True difference ',!UNIT)).
EXECUTE.
GRAPH /TITLE='Power curve' /SUBTITLE=!QUOTE(!CONCAT(!HIPO,' Z test for 2 independent means')) 
      /SCATTERPLOT(OVERLAY)= !GRAPH WITH !@ALPHA (PAIR).
!IFEND.
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.