PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !POW2IP V2009.04.29 loaded.'
         /'Execute !POW2IP HELP. for printing Help & Macro bibliographic reference.'/.
END IF.
EXECUTE.
DEFINE !POW2IP ( N= !CHAREND('/')
               /P0= !CHAREND('/') 
               /P1= !CHAREND('/')!DEFAULT(99)  
            /DELTA= !CHAREND('/')!DEFAULT(1)
             /SIDE= !CHAREND('/')!DEFAULT('2') 
            /ALPHA= !CHAREND('/')!DEFAULT('5') 
              /DIR= !CHAREND('/')
              /NST= !CHAREND('/')
             /HELP= !CHAREND('/')!DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2009.04.29').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
DO IF ($casenum=1).
  PRINT //'Macro !POW2IP V' !VERSION ' (c)JM.Domenech & R.Granero'.
END IF.
TEMPORARY.
N 1.
!IF (!HELP<>1) !THEN.
*Impresin de la documentacin.
+  DO IF ($casenum=1).
+    PRINT /'******************************************************************************'
           /'* POWER CURVE: Z test for comparing two independent proportions              *'
           /'* Created 1999.03.06 Last revised ' !VERSION                                '*'78
           /'* (c) JM.Domenech & R.Granero                                                *'
           /'* Programmers: A.Bonillo & R.Sesma                                           *'
           /'*                                                                            *'
           /'* Vancouver reference:                                                       *'
           /'* Domenech JM, Granero R. Macro !POW2IP for SPSS Statistics.                 *'
           /'*    POWER CURVE: Z test for comparing two independent proportions           *'
           /'*    [computer program].                                                     *'
           /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'78
           /'*    Available from: http://www.metodo.uab.cat/macros.htm.                   *'
           /'*                                                                            *'
           /'* Macro Call (tested for SPSS 15.0 and higher):                              *'
           /'* !POW2IP N = Number of subjects in each group(N=N0=N1)   (N > 0)            *'
           /'*        P0 = Events percentage under the null hypothesis (0 < P0 < 100)     *'
           /'*      [/P1]= Max/min percentage under the alternative hypothesis            *'
           /'*                                by default 99            (0 < P1 < 100)     *'
           /'*   [/DELTA]= Difference increase       ; by default 1    (DELTA > 0)        *'
           /'*    [/SIDE]= 1(One-sided), 2(Two-sided); by default 2    (1 or 2)           *'
           /'*   [/ALPHA]= List of alpha risk(%)     ; by default 5%   (0 < ALPHA <= 50)  *'
           /"*     [/DIR]= Working directory (must be unprotected)  By default: 'C:\'     *"
           /'*             Must be enclosed in a set of apostrophes. The macro makes a    *'
           /'*             copy of the original data in this directory.                   *'
           /'*     [/NST]= Name of the study (Label)                                      *'
           /'*     [/HELP] Print Macro call arguments and Samples of calls                *'
           /'*                                                                            *'
           /'* Note: Parameters enclosed in Square Brackets [ ] are optional              *'
           /'*                                                                            *'
           /'* WARNING: This Macro creates a new SPSS working data file. For SAFETY, a    *'
           /'*          copy of your active data file is saved in the working directory   *'
           /'*          with the name @original.sav (by default, C:\@original.sav).       *'
           /'*                                                                            *'
           /'* Samples of calls:                                                          *'
           /'*  !POW2IP HELP.                                                             *'
           /'*  !POW2IP N=10 /P0=30 /P1=99 /DELTA=2.5 /SIDE=2 /ALPHA=1 2.5 5 10.          *'
           /'*  !POW2IP P0=30 /N=10 /P1=8 /DELTA=2 /SIDE=1 /ALPHA= 1 5 10.                *'
           /"*  !POW2IP P0=60 /N=72 /NST='Name of the study' /DIR='C:\Temporal'.          *"
           /'******************************************************************************'.
+  END IF.
EXECUTE.
+   COMPUTE #ERROR=1.

!ELSE.

*Making data.
*Working directory and save original data.
!IF (!DIR=!NULL) !THEN.
   !LET !FOLDER = 'C:\'.
!ELSE.
   !LET !FOLDER = !CONCAT(!UNQUOTE(!DIR),'\').
!IFEND.
!LET !ORIGINAL=!CONCAT(!FOLDER,'@original.sav').
SAVE OUTFILE=!QUOTE(!ORIGINAL).
*Creation of a matrix that contanis the difference increase.
INPUT PROGRAM.
LOOP #J= 0 TO ABS(!P1-!P0) BY !DELTA.
+   COMPUTE EFFECT=#J.                           /*Increase.
+   END CASE.
END LOOP.
END FILE.
END INPUT PROGRAM.
EXECUTE.

*Testing the parameters.
COMPUTE #ERROR=0.
DO REPEAT ALPHA=!ALPHA.
+   DO IF ( (ALPHA<=0 or ALPHA>50) AND $CASENUM=1).
+     PRINT /'ERROR: Parameter(s) with wrong values'.
+       COMPUTE #ERROR=1.
+   END IF.
END REPEAT.

DO IF ((!P0<=0 OR !P0>=100 OR !P1<=0 OR !P1>=100) AND ($CASENUM=1)).
+   PRINT /'ERROR: Parameter(s) with wrong values'.
+   COMPUTE #ERROR=1.
END IF.

!IF ( (!SIDE=1 !OR !SIDE=2) !AND !P0<>!NULL !AND !N<>!NULL) !THEN 

*Building the labels.
+   !LET !@CAB1 =!NULL.
+   !LET !@CAB2 =!NULL.
+   !LET !@ALPHA=!NULL.
+   !LET !ETIQ  =!NULL.
+   !LET !GRAPH =!NULL.
+   !DO !I !IN(!ALPHA).
+     !LET !@TALPHA=!CONCAT('P',!I).
+     !LET !@ALPHA =!CONCAT(!@ALPHA,' ',!@TALPHA).
+     !IF (!LENGTH(!I)=1) !THEN 
+       !LET !@TCAB1 =!CONCAT(' Alpha= ',!I,'%').
+     !ELSE.
+       !LET !@TCAB1 =!CONCAT(' Alpha=',!I,'%').
+     !IFEND.
+     !LET !@CAB1  =!CONCAT(!@CAB1,' ',!@TCAB1).
+     !LET !@TCAB2 =' POWER (%)'.
+     !LET !@CAB2  =!CONCAT(!@CAB2,' ',!@TCAB2).
+     !LET !TETIQ  =!CONCAT(!@TALPHA,' ',!QUOTE(!@TCAB1)).
+     !LET !ETIQ   =!CONCAT(!ETIQ,' ',!TETIQ).
+     !LET !TGRAPH ='EFFECT'.
+     !LET !GRAPH  =!CONCAT(!GRAPH,' ',!TGRAPH).
+   !DOEND.

!IF (!SIDE=1) !THEN
+  !LET !HIPO='One-sided'.
!ELSE. 
+  !LET !HIPO='Two-sided'.
!IFEND.
!IFEND.

*Printing the head.
DO IF ($CASENUM=1 AND #ERROR=0).
+   PRINT /	'POWER CURVE: ' !QUOTE(!HIPO) ' Z test for two independent proportions'.
   !IF (!NST !NE !NULL) !THEN .	/*Print NST if available.
      STRING #NST (A131).
      COMPUTE #NST = CONCAT('STUDY: ',!NST).
      PRINT /#NST.
   !IFEND.
+   PRINT//'   True' !QUOTE(!@CAB1)11.
+   PRINT /'  DIFF.(%)' !QUOTE(!@CAB2)11.
END IF.
EXECUTE.

  !IF (!P1 > !P0) !THEN
+  COMPUTE #P1= !P0+EFFECT.
  !ELSE. 
+  COMPUTE #P1= !P0-EFFECT.
  !IFEND.
+  COMPUTE #EE0= SQRT(2*((!P0+#P1)/2)*(100-(!P0+#P1)/2)/!N).
+  COMPUTE #EE1= SQRT(!P0*(100-!P0)/!N + #P1*(100-#P1)/!N).

DO REPEAT POTEN=!@ALPHA /ALPHA=!ALPHA.
+   COMPUTE #P=(100-(ALPHA/!SIDE))/100.
+   COMPUTE #DC= IDF.NORMAL(#P,0,1)*#EE0.
+   COMPUTE #ZBETA=(#DC-EFFECT)/#EE1.
+   COMPUTE POTEN=100*(1-CDFNORM(#ZBETA)).
END REPEAT.
FORMATS EFFECT (F9.1) !@ALPHA (F10.2).

COMPUTE #ERROR=0.
DO REPEAT ALPHA=!ALPHA.
+   DO IF (ALPHA<=0 or ALPHA>=100).
+     RECODE ALL (ELSE=SYSMIS).
+     COMPUTE #ERROR=1.
+   END IF.
END REPEAT.

DO IF (!P0<=0 OR !P0>=100 OR !P1<=0 OR !P1>=100).
+   RECODE ALL (ELSE=SYSMIS).
+   COMPUTE #ERROR=1.
END IF.

+   DO IF (#ERROR=0).
+     PRINT /EFFECT ' ' !@ALPHA.
+   END IF.

VARIABLE LABELS !ETIQ EFFECT 'True difference (%)'.
EXECUTE.

GRAPH /TITLE='POWER CURVE' /SUBTITLE=!QUOTE( !CONCAT(!HIPO,' Z test for two independent proportions') )
  /SCATTERPLOT(OVERLAY)= !GRAPH WITH !@ALPHA (PAIR).
!IFEND.
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.