PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE.
DO IF ($casenum=1).
   PRINT /'Macro !NSize V2012.02.20 loaded.'
         /'Execute !NSize HELP. for printing Help & Macro bibliographic reference.'.
END IF.
EXECUTE.
DEFINE !NSize ( TYPE = !CHAREND('/') 
                 /P0 = !CHAREND('/') /P1 = !CHAREND('/') /R0 = !CHAREND('/') /R1 = !CHAREND('/') /P = !CHAREND('/')
                /ODR = !CHAREND('/') /Pd = !CHAREND('/') /ORa = !CHAREND('/') /D = !CHAREND('/')
                 /RR = !CHAREND('/') /RD = !CHAREND('/') /IR = !CHAREND('/') /ID = !CHAREND('/')
                /PE0 = !CHAREND('/') /PE1 = !CHAREND('/') /I0 = !CHAREND('/') /I1 = !CHAREND('/')
                /VAR = !CHAREND('/') /SD = !CHAREND('/') 
             /EFFECT = !CHAREND('/') /EQLIM = !CHAREND('/') /Means = !CHAREND('/') /c = !CHAREND('/')
              /ALPHA = !CHAREND('/') /BETA = !CHAREND('/') 
                  /N = !CHAREND('/') /N0 = !CHAREND('/') /N1 = !CHAREND('/') /r = !CHAREND('/')
               /APRE = !CHAREND('/') /ns = !CHAREND('/') /CL = !CHAREND('/')
                /NST = !CHAREND('/') /HELP = !CHAREND('/') !DEFAULT(1) ).
PRESERVE.
SET PRINTBACK=NONE ERRORS=NONE LENGHT=NONE WIDTH=132 .
!LET !VERSION=!QUOTE('2012.02.20').
!LET !YEAR=!QUOTE(!SUBSTR(!VERSION,2,4)).
!LET !tested=!QUOTE('(tested for SPSS 15.0 and higher)').
DO IF ($casenum=1).
  PRINT //'Macro !NSize V' !VERSION ' (c)JM.Domenech & R.Granero'.
END IF.
TEMPORARY.
N 1.
!IF ((!HELP<>1) !AND (!TYPE=!NULL)) !THEN.
   PRINT /'********************************************************************************'
         /'* SAMPLE SIZE & POWER: Comparisons and estimations for independent             *'
         /'*                      proportions, means, correlations, risks and rates       *'
         /'* Created 2010.06.30 Last revised ' !VERSION                                  '*'80
         /'* (c) JM.Domenech & R.Granero                                                  *'
         /'* Programmer: R.Sesma                                                          *'
         /'*                                                                              *'
         /'* Vancouver reference:                                                         *'
         /'* Domenech JM, Granero R. Macro !NSize for SPSS Statistics.                    *'
         /'*    Sample Size and Power: Comparisons and estimations for independent        *'
         /'*    proportions, means, correlations, risks and rates [computer program].     *'
         /'*    V' !VERSION '. Bellaterra: Universitat Autnoma de Barcelona; ' !YEAR '.' '*'80
         /'*    Available from: http://www.metodo.uab.cat/macros.htm.                     *'
         /'*                                                                              *'
         /'* Macro Call ' !tested                                                        '*'80
         /'* ***Parameters for ALL computations ------------------------------------------*'
         /'* !NSize Type = Type of computation:                                           *'
         /'*        Co1P : Comparison of one proportion to a reference (non equal)        *'
         /'*        Co2P : Comparison of two proportions (non equal)                      *'
         /'*        C2PE : Comparison of two proportions (equivalence)                    *'
         /'*        C2PP : Paired comparison of two proportions                           *'
         /'*        Co1M : Comparison of one mean to a reference (non equal)              *'
         /'*        Co2M : Comparison of two means (non equal)                            *'
         /'*        CokM : Comparison of k means (ANOVA)                                  *'
         /'*        C2ME : Comparison of two means (equivalence)                          *'
         /'*        CI1P : Estimation of population proportion                            *'
         /'*        CI2P : Estimation of the difference between 2 proportions             *'
         /'*        CI1M : Estimation of population mean                                  *'
         /'*        CI2M : Estimation of the difference between 2 means                   *'
         /'*        Co1C : Comparison of one correlation to a reference                   *'
         /'*        Co2C : Comparison of two correlations                                 *'
         /'*        Co2R : Comparison of two risks                                        *'
         /'*        Co2I : Comparison of two rates                                        *'
         /'*       [/NST]= Name of the study (Label, Optional)                            *'
         /'*                                                                              *'
         /'* For printing Help about each TYPE, execute:                                  *'
         /'*         !NSize Type=Co1P /HELP. or                                           *'
         /'*         !NSize Type=Co2P /HELP. or                                           *'
         /'*         !NSize Type=C2PE /HELP. or                                           *'
         /'*         !NSize Type=C2PP /HELP. or                                           *'
         /'*         !NSize Type=Co1M /HELP. or                                           *'
         /'*         !NSize Type=Co2M /HELP. or                                           *'
         /'*         !NSize Type=CokM /HELP. or                                           *'
         /'*         !NSize Type=C2ME /HELP. or                                           *'
         /'*         !NSize Type=CI1P /HELP. or                                           *'
         /'*         !NSize Type=CI2P /HELP. or                                           *'
         /'*         !NSize Type=CI1M /HELP. or                                           *'
         /'*         !NSize Type=CI2M /HELP. or                                           *'
         /'*         !NSize Type=Co1C /HELP. or                                           *'
         /'*         !NSize Type=Co2C /HELP. or                                           *'
         /'*         !NSize Type=Co2R /HELP. or                                           *'
         /'*         !NSize Type=Co2I /HELP.                                              *'
         /'********************************************************************************'.
!ELSE.
   COMPUTE #ERROR=0.

   !IF (!TYPE=!NULL) !THEN.
      PRINT /'ERROR: Missing parameter TYPE. See the HELP.'.
   !ELSE.
      !LET !TypeU = !UPCASE(!TYPE).
      !IF (!TypeU<>'CO1P' !AND !TypeU<>'CO2P' !AND !TypeU<>'C2PE' !AND !TypeU<>'CO1M' !AND !TypeU<>'CO2M' !AND !TypeU<>'C2ME' !AND 
           !TypeU<>'CI1P' !AND !TypeU<>'CI1M' !AND !TypeU<>'CI2P' !AND !TypeU<>'CI2M' !AND !TypeU<>'CO1C' !AND !TypeU<>'CO2C' !AND
           !TypeU<>'COKM' !AND !TypeU<>'C2PP' !AND !TypeU<>'CO2R' !AND !TypeU<>'CO2I') !THEN.
         PRINT /'ERROR: Parameter TYPE with wrong value. See the HELP.'.
      !ELSE.
         !IF (!HELP<>1) !THEN.
*           Print HELP corresponding to one TYPE.
            !PrintHELP Type=!TypeU /Version=!VERSION /tested=!tested.
         !ELSE.
            !IF (!TypeU='CO1P' !OR !TypeU='CO2P' !OR !TypeU='C2PE') !THEN.
               !NPa P0=!P0 /P=!P /P1=!P1 /EFFECT=!EFFECT /EQLIM=!EQLIM /ALPHA=!ALPHA /BETA=!BETA /N=!N /NST=!NST /Type=!TypeU.
            !IFEND.
            !IF (!TypeU='CO1M' !OR !TypeU='CO2M' !OR !TypeU='C2ME') !THEN.
               !NMa SD=!SD /Var=!Var /EFFECT=!EFFECT /EQLIM=!EQLIM /ALPHA=!ALPHA /BETA=!BETA /N=!N /N0=!N0 /N1=!N1 /NST=!NST /r=!r /Type=!TypeU.
            !IFEND.
            !IF (!TypeU='CI1P' !OR !TypeU='CI2P' !OR !TypeU='CI1M' !OR !TypeU='CI2M') !THEN.
               !IF (!TypeU='CI1P' !OR !TypeU='CI2P') !THEN.
                  !EPa P0=!P0 /P1=!P1 /APRE=!APRE /ns=!ns /CL=!CL /N=!N /N0=!N0 /N1=!N1 /r=!r /NST=!NST /Type=!TypeU.
               !ELSE.
                  !EMa SD=!SD /VAR=!VAR /APRE=!APRE /ns=!ns /CL=!CL /N=!N /N0=!N0 /N1=!N1 /r=!r /NST=!NST /Type=!TypeU.
               !IFEND.
            !IFEND.
            !IF (!TypeU='CO1C' !OR !TypeU='CO2C') !THEN.
               !Cora R0=!R0 /R=!R /R1=!R1 /EFFECT=!EFFECT /ALPHA=!ALPHA /BETA=!BETA /N0=!N0 /N1=!N1 /NST=!NST /Type=!TypeU.
            !IFEND.
            !IF (!TypeU='COKM') !THEN.
               !NMk Means=!Means /Var=!Var /SD=!SD /N=!N /Effect=!Effect /c=!c /NST=!NST.
            !IFEND.
            !IF (!TypeU='C2PP') !THEN.
               !N2P ODR=!ODR /Pd=!Pd /P0=!P0 /ORa=!ORa /r=!r /Alpha=!Alpha /Beta=!Beta /N=!N /NST=!NST.
            !IFEND.
            !IF (!TypeU='CO2R') !THEN.
               !N2R R0=!R0 /R1=!R1 /RR=!RR /RD=!RD /PE0=!PE0 /PE1=!PE1 /ODR=!ODR /r=!r /Alpha=!Alpha /Beta=!Beta /N0=!N0 /N1=!N1 /NST=!NST.
            !IFEND.
            !IF (!TypeU='CO2I') !THEN.
               !N2I I0=!I0 /I1=!I1 /IR=!IR /ID=!ID /r=!r /D=!D /Alpha=!Alpha /Beta=!Beta /N0=!N0 /N1=!N1 /NST=!NST.
            !IFEND.
         !IFEND.
      !IFEND.
   !IFEND.
!IFEND.           
EXECUTE.
RESTORE.
!ENDDEFINE.
RESTORE.

****NPa: Auxiliary macro for TYPE=Co1P, Co2P, C2PE (old N1P, N2IP, N2IPE).
DEFINE  !NPa( P0 = !CHAREND('/') /P = !CHAREND('/') /P1 = !CHAREND('/') /Type = !CHAREND('/')
         /EFFECT = !CHAREND('/') /EQLIM = !CHAREND('/') /ALPHA = !CHAREND('/') /BETA = !CHAREND('/') /N = !CHAREND('/') 
            /NST = !CHAREND('/')).

   !IF (!P0=!NULL !AND !Type<>'CO1P') !THEN.
      COMPUTE #ERROR=3.                      /*Missing P0.
   !ELSE.
      !IF (!Type<>'C2PE') !THEN.
         !IF (!EFFECT=!NULL !AND !P1=!NULL) !THEN.
            COMPUTE #ERROR=4.                   /*Missing EFFECT or P1.
         !ELSE.
            !IF (!P1<>!NULL !AND !EFFECT<>!NULL) !THEN.
               COMPUTE #ERROR=5.                /*Too much parameters: EFFECT or P1.
            !IFEND.
         !IFEND.
         !IF (!EQLIM<>!NULL) !THEN.
            COMPUTE #ERROR=9.                   /*Too much parameters: EQLIM.
         !IFEND.
      !ELSE.
         !IF (!EQLIM=!NULL) !THEN.
            COMPUTE #ERROR=8.                   /*Missing EQLIM.
         !IFEND.
         !IF (!P1<>!NULL !OR !Effect<>!NULL) !THEN.
            COMPUTE #ERROR=10.                  /*Too much parameters: P1, Effect.
         !IFEND.
      !IFEND.
      !IF (!N=!NULL) !THEN.
         !IF ((!ALPHA<>!NULL !AND !BETA=!NULL) !OR (!ALPHA=!NULL !AND !BETA<>!NULL)) !THEN.
            COMPUTE #ERROR=6.          /*Missing parameter ALPHA or BETA.
         !IFEND.
      !ELSE.
         !IF (!BETA<>!NULL) !THEN.
            COMPUTE #ERROR=7.          /*Too much parameters: BETA or N.
         !IFEND.
      !IFEND.
   !IFEND.
   !IF (!Type='CO1P') !THEN.
      !IF (!P=!NULL) !THEN.
         COMPUTE #ERROR=11.                      /*Missing P.
      !ELSE.
         !IF (!P0<>!NULL) !THEN.
            COMPUTE #ERROR=12.                   /*Too much parameters P0 with Type = Co1P.
         !IFEND.
      !IFEND.
   !IFEND.
   !IF (!Type='CO1P') !THEN.
      !TestParameter Param=!P /Type=1 /ParamName=P.
      !TestParameter Param=!EFFECT /Type=2 /ParamName=Effect /Aux=!P.
   !ELSE.
      !TestParameter Param=!P0 /Type=1 /ParamName=P0.
      !TestParameter Param=!EFFECT /Type=2 /ParamName=Effect /Aux=!P0.
   !IFEND.
   !TestParameter Param=!P1 /Type=1 /ParamName=P1.
   !TestParameter Param=!EQLIM /Type=10 /ParamName=EQLIM.
   !TestParameter Param=!ALPHA /Type=3  /ParamName=Alpha.
   !TestParameter Param=!BETA /Type=3  /ParamName=Beta.
   !TestParameter Param=!N /Type=4   /ParamName=N.

   DO IF (#ERROR=1 OR #ERROR=2).
*     Do nothing: there's been a TestParameter error, the macro must stop here.
   ELSE IF (#ERROR=3).
      PRINT /'ERROR: Missing parameter P0. See the HELP.'.
   ELSE IF (#ERROR=4).
      PRINT /'ERROR: Missing parameter P1 or EFFECT. See the HELP.'.
   ELSE IF (#ERROR=5).
      PRINT /'ERROR: Too much parameters. Parameter P1 is incompatible with Effect. See the HELP.'.
   ELSE IF (#ERROR=6).
      PRINT /'ERROR: Missing parameter Alpha or Beta. See the HELP.'.
   ELSE IF (#ERROR=7).
      PRINT /'ERROR: Too much parameters. Parameter Beta is incompatible with N. See the HELP.'. 
   ELSE IF (#ERROR=8).
      PRINT /'ERROR: Missing parameter EQLIM. See the HELP.'.
   ELSE IF (#ERROR=9).
      PRINT /'ERROR: Too much parameters. Parameter EQLIM is incompatible with Type=Co1P or Type=Co2P. See the HELP.'. 
   ELSE IF (#ERROR=10).
      PRINT /'ERROR: Too much parameters. Parameters P1, Effect are incompatible with Type=C2PE. See the HELP.'. 
   ELSE IF (#ERROR=11).
      PRINT /'ERROR: Missing parameter P. See the HELP.'.
   ELSE IF (#ERROR=12).
      PRINT /'ERROR: Too much parameters. Parameter P0 is incompatible with Type=Co1P. See the HELP.'. 
   ELSE.
*     Prepare parameters.
      !IF (!Type='CO1P') !THEN.
         COMPUTE #P0=!P.
      !IFEND.
      !IF (!Type<>'C2PE') !THEN.
         !IF (!P1<>!NULL) !THEN.
            COMPUTE #EFFECT=(#P1-#P0).
         !ELSE.
            COMPUTE #P1=(#EFFECT+#P0).
         !IFEND.
      !ELSE.
         COMPUTE #P0=#P0/100.
         COMPUTE #EQLIM=#EQLIM/100.
      !IFEND.
      COMPUTE #WARNING1=0.
      COMPUTE #WARNING2=0.

*     Print: Head.
      !IF (!Type='CO1P') !THEN.
         PRINT /'SAMPLE SIZE & POWER DETERMINATION: One single proportion'.
      !IFEND.
      !IF (!Type='CO2P') !THEN.
         PRINT /'SAMPLE SIZE & POWER DETERMINATION: Two-independent proportions'.
      !IFEND.
      !IF (!Type='C2PE') !THEN.
         PRINT /'SAMPLE SIZE (EQUIVALENCE PROPORTIONS) & POWER DETERMINATION: Two-independent samples'.
      !IFEND.
      !PrintNST NST=!NST.
      
      !IF (!Type='CO1P') !THEN.
         PRINT//'Proportion (%) of events in: Reference Population= ' #P0(F5.2)'%'.
         PRINT /'Proportion (%) of events in:               Sample= ' #P1(F5.2)'%'.
         PRINT /'Minimun expected effect size:          Difference= ' #EFFECT(F5.2)'%'.
      !IFEND.
      !IF (!Type='CO2P') !THEN.
         PRINT//'Proportion (%) of events in:  Group 0 = ' #P0(F5.2)'%'.
         PRINT /'                              Group 1 = ' #P1(F5.2)'%'.
         PRINT /'Minimum expected effect size: Difference= ' #EFFECT(F5.2)'%'.
      !IFEND.
      !IF (!Type='C2PE') !THEN.
         PRINT//'Expected percentage of successes = '!QUOTE(!P0) '%'.
         PRINT /'Equivalence limits = '!QUOTE(!EQLIM) '%'.
      !IFEND.
      
      !IF (!Type<>'C2PE') !THEN.
         IF (#P0<20 or #P1<20 or #P0>80 OR #P1>80) #WARNING1=1.
         STRING #Note (A1).
         COMPUTE #Note = ' '.
      !IFEND.

      !IF (!N =!NULL) !THEN.
         !IF (!ALPHA =!NULL !AND !BETA =!NULL) !THEN.
*           Print a table when ALPHA and BETA are defaults.
            !LET !ALPHAdef = '5'.
            !LET !BETAdef  = '20 15 10'.
            !DO !I=1 !TO 2.
               COMPUTE #I=!I.
               !DO !A !IN(!ALPHAdef).
                  COMPUTE  #ALPHA=!A.
                  !DO !B !IN(!BETAdef).
                     COMPUTE  #BETA=!B.
                     !IF (!Type<>'C2PE') !THEN.
*                       Get the Sample Size for each method.
                        !GetNp Var=!CONCAT('#NA',!I,!A,!B) /Method='Arcs' /Type=!Type.
                        !GetNp Var=!CONCAT('#NN',!I,!A,!B) /Method='Norm' /Type=!Type.
                        !GetNp Var=!CONCAT('#NF',!I,!A,!B) /Method='NormC' /Type=!Type.
                     !ELSE.
                        !GetNp Var=!CONCAT('#NN',!I,!A,!B) /Method='Norm' /Type=!Type.
                     !IFEND.
                  !DOEND.
               !DOEND.
            !DOEND.
*           Print: Two and one-sided test in a table.
            !IF (!Type<>'C2PE') !THEN.
               IF (#WARNING1 OR #WARNING2) #Note = '*'.
               !IF (!Type='CO1P') !THEN.
                  PRINT //'                      |                SAMPLE SIZE                |'.
               !ELSE.
                  PRINT //'                      |            SAMPLE SIZE by group           |'.
               !IFEND.
               PRINT  /'         Alpha Risk=5%|    Two-Sided Test   |    One-Sided Test   |'.
               PRINT  /' METHOD          Power|   80%    85%    90% |   80%    85%    90% |'.
               PRINT  /'----------------------+---------------------+---------------------+'.
               PRINT  /' Normal' #Note(A1) '            n | ' #NN2520(T24,F6) #NN2515(T31,F6) #NN2510(T38,F6) '|'45 #NN1520(T46,F6) #NN1515(T53,F6) #NN1510(T60,F6) '|'67.
               PRINT  /'----------------------+---------------------+---------------------+'.
               PRINT  /' Normal corrected   n | ' #NF2520(T24,F6) #NF2515(T31,F6) #NF2510(T38,F6) '|'45 #NF1520(T46,F6) #NF1515(T53,F6) #NF1510(T60,F6) '|'67.
               PRINT  /'----------------------+---------------------+---------------------+'.
               PRINT  /' ArcoSinus          n | ' #NA2520(T24,F6) #NA2515(T31,F6) #NA2510(T38,F6) '|'45 #NA1520(T46,F6) #NA1515(T53,F6) #NA1510(T60,F6) '|'67.
               PRINT  /'----------------------+---------------------+---------------------+'.
            !ELSE.
               PRINT //'                      |                SAMPLE SIZE                |'.
               PRINT  /'         Alpha Risk=5%|   Equivalence Test  | Non-inferiority Test|'.
               PRINT  /' METHOD          Power|   80%    85%    90% |   80%    85%    90% |'.
               PRINT  /'----------------------+---------------------+---------------------+'.
               PRINT  /' Normal            n0 |' #NN25200(T24,F6) #NN25150(T31,F6) #NN25100(T38,F6) '|'45 #NN15200(T46,F6) #NN15150(T53,F6) #NN15100(T60,F6) '|'67.
               PRINT  /'                   n1 |' #NN25201(T24,F6) #NN25151(T31,F6) #NN25101(T38,F6) '|'45 #NN15201(T46,F6) #NN15151(T53,F6) #NN15101(T60,F6) '|'67.
               PRINT  /'                Total |' #NN2520(T24,F6)  #NN2515(T31,F6)  #NN2510(T38,F6)  '|'45 #NN1520(T46,F6)  #NN1515(T53,F6)  #NN1510(T60,F6)  '|'67.
               PRINT  /'----------------------+---------------------+---------------------+'.
            !IFEND.
         !ELSE.
*           Print Sample Size for a given ALPHA and BETA.
            !DO !I=1 !TO 2.
               COMPUTE #I=!I.
               !IF (!Type<>'C2PE') !THEN.
*                 Get the Sample Size for each method.
                  !GetNp Var=!CONCAT('#NA',!I) /Method='Arcs' /Type=!Type.
                  !GetNp Var=!CONCAT('#NN',!I) /Method='Norm' /Type=!Type.
                  !GetNp Var=!CONCAT('#NF',!I) /Method='NormC' /Type=!Type.
               !ELSE.
                  !GetNp Var=!CONCAT('#NN',!I) /Method='Norm' /Type=!Type.
               !IFEND.
            !DOEND.

            !IF (!Type<>'C2PE') !THEN.
               IF (#WARNING1 OR #WARNING2) #Note = '*'.            
               COMPUTE #POWER=100-!BETA.
               PRINT /'Alpha Risk = ' !QUOTE(!ALPHA) '%;  Beta Risk = '!QUOTE(!BETA) '% (Power = ' #POWER(F5.2) '%)'.
               !IF (!Type='CO1P') !THEN.
                  PRINT //'                   |           SAMPLE SIZE           |'.
               !ELSE.
                  PRINT //'                   |      SAMPLE SIZE by group       |'.
               !IFEND.
               PRINT  /' METHOD            | Two-Sided Test | One-Sided Test |'.
               PRINT  /'-------------------+----------------+----------------+'.
               PRINT  /' Normal' #Note(A1)'|'20 #NN2(T25,F7) '|'37 #NN1(T42,F7) '|'54.
               PRINT  /'-------------------+----------------+----------------+'.
               PRINT  /' Normal corrected  |'   #NF2(T25,F7) '|'37 #NF1(T42,F7) '|'54.
               PRINT  /'-------------------+----------------+----------------+'.
               PRINT  /' ArcoSinus         |'   #NA2(T25,F7) '|'37 #NA1(T42,F7) '|'54.
               PRINT  /'-------------------+----------------+----------------+'.
            !ELSE.
               PRINT /'Alpha Risk = ' !QUOTE(!ALPHA) '%; Beta Risk = '!QUOTE(!BETA) '%;  Ratio N0/N1 = 1'.
               PRINT //'                |         SAMPLE SIZE           |'.
               PRINT  /' METHOD         | Equivalence | Non-inferiority |'.
               PRINT  /'----------------+-------------+-----------------+'.
               PRINT  /' Normal      n0 |' #NN20(T21,F7)  '|'31 #NN10(T37,F7) '|'49.
               PRINT  /'             n1 |' #NN21(T21,F7)  '|'31 #NN11(T37,F7) '|'49.
               PRINT  /'          Total |' #NN2 (T21,F7)  '|'31 #NN1 (T37,F7) '|'49.
               PRINT  /'----------------+-------------+-----------------+'.
            !IFEND.
         !IFEND.
      !ELSE.
*        Print POWER for a given N, ALPHA.
         !IF (!ALPHA=!NULL) !THEN.
            COMPUTE #ALPHA=5.
         !IFEND.
         !DO !I=1 !TO 2.
            COMPUTE #I=!I.
            !IF (!Type<>'C2PE') !THEN.
*              Get the Power for each method.
               !GetPowerP Var=!CONCAT('#PA',!I) /Method='Arcs' /Type=!Type.
               !GetPowerP Var=!CONCAT('#PN',!I) /Method='Norm' /Type=!Type.
               !GetPowerP Var=!CONCAT('#PF',!I) /Method='NormC' /Type=!Type.
            !ELSE.
               !GetPowerP Var=!CONCAT('#PN',!I) /Method='Norm' /Type=!Type.
            !IFEND.
         !DOEND.

         !IF (!Type='CO1P') !THEN.
            PRINT /'Sample size: n = ' #N(F6).
         !ELSE.
            PRINT /'Sample size: n0 = n1 = ' #N(F6).
         !IFEND.
         PRINT /'Alpha Risk = ' #ALPHA(F2) '%'.
         !IF (!Type<>'C2PE') !THEN.
            IF ((#N*#P0/100)<10 or (#N*(1-#P0/100))<10) #WARNING2=1.
            IF ((#N*#P1/100)<10 or (#N*(1-#P1/100))<10) #WARNING2=1.
            IF (#WARNING1 OR #WARNING2) #Note = '*'.
            PRINT //'                  |              POWER (%)          |'.
            PRINT  /' METHOD           | Two-Sided Test | One-Sided Test |'.
            PRINT  /'------------------+----------------+----------------+'.
            PRINT  /' Normal' #Note(A1) '|'19 #PN2(T26,F4.1) '|'36 #PN1(T43,F4.1) '|'53.
            PRINT  /' Normal corrected |'     #PF2(T26,F4.1) '|'36 #PF1(T43,F4.1) '|'53.
            PRINT  /' ArcoSinus        |'     #PA2(T26,F4.1) '|'36 #PA1(T43,F4.1) '|'53.
            PRINT  /'------------------+----------------+----------------+'.
         !ELSE.
            PRINT //'                  |              POWER (%)          |'.
            PRINT  /' METHOD           | Two-Sided Test | One-Sided Test |'.
            PRINT  /'------------------+----------------+----------------+'.
            PRINT  /' Normal           |' #PN2(T26,F4.1) '|'36 #PN1(T43,F4.1) '|'53.
            PRINT  /'------------------+----------------+----------------+'.
         !IFEND.
      !IFEND.
*     Print Warnings.
      DO IF (#WARNING1=1 or #WARNING2=1).
         PRINT /'(*)WARNING: Applicability conditions for Normal method not granted'.
         !IF (!Type='CO1P') !THEN.
            DO IF (#WARNING1=1).
               PRINT /'P and P1 must be >=20 and <=80'.
            ELSE IF (#WARNING2=1).
               PRINT /'N*P, N*(1-P), N*P1 and N*(1-P1) must be >=10'.
            END IF.
         !ELSE.
            DO IF (#WARNING1=1).
               PRINT /'P0 and P1 must be >=20 and <=80'.
            ELSE IF (#WARNING2=1).
               PRINT /'N*P0, N*(1-P0), N*P1 and N*(1-P1) must be >=10'.
            END IF.
         !IFEND.
      END IF.
   END IF.

!ENDDEFINE.

****N2P: Auxiliary macro for TYPE=C2PP (old N2PP).
DEFINE !N2P( ODR = !CHAREND('/') /Pd = !CHAREND('/') /P0 = !CHAREND('/') /ORa = !CHAREND('/')
              /r = !CHAREND('/') /Alpha = !CHAREND('/') /Beta = !CHAREND('/') /N = !CHAREND('/')
            /NST = !CHAREND('/')).

   !IF (!ODR=!NULL) !THEN.
      COMPUTE #ERROR=3.          /*Missing parameter ODR.
   !ELSE.
      !IF ((!N<>!NULL) !AND (!Pd=!NULL !AND !P0=!NULL !AND !ORa=!NULL)) !THEN.
         COMPUTE #ERROR=4.       /*Missing parameters Pd or P0 and ORa.
      !ELSE.
         !IF (!Pd<>!NULL !AND (!P0<>!NULL !OR !ORa<>!NULL)) !THEN.
            COMPUTE #ERROR=5.    /*Too much parameters: Pd and P0 or ORa.
         !ELSE.
            !IF ((!P0<>!NULL !AND !ORa=!NULL) !OR (!P0=!NULL !AND !ORa<>!NULL)) !THEN.
               COMPUTE #ERROR=6.    /*Missing parameter P0 or ORa.
            !ELSE.
               !IF (!N<>!NULL !AND !Beta<>!NULL) !THEN.
                  COMPUTE #ERROR=7. /*Too much parameters: N incompatible with Beta.
               !IFEND.
            !IFEND.
         !IFEND.
      !IFEND.
      !IF ((!N=!NULL) !AND ((!Alpha=!NULL !AND !Beta<>!NULL) !OR (!Alpha<>!NULL !AND !Beta=!NULL))) !THEN.
         COMPUTE #ERROR=8.       /*Missing parameter Alpha or Beta.
      !IFEND.
   !IFEND.
   !TestParameter Param=!ODR /Type=15 /ParamName=ODR.
   !TestParameter Param=!Pd /Type=1 /ParamName=Pd.
   !TestParameter Param=!P0 /Type=1 /ParamName=P0.
   !TestParameter Param=!ORa /Type=15 /ParamName=ORa.
   !TestParameter Param=!r /Type=16 /ParamName=r.
   !TestParameter Param=!Alpha /Type=3 /ParamName=Alpha.
   !TestParameter Param=!Beta /Type=3 /ParamName=Beta.
   !TestParameter Param=!N /Type=4 /ParamName=N.

   DO IF (#ERROR=1 OR #ERROR=2).
*     Do nothing: TestParameter error.
   ELSE IF (#ERROR=3).
      PRINT /'ERROR: Missing parameter ODR. See the HELP.'.
   ELSE IF (#ERROR=4).
      PRINT /'ERROR: Missing parameter(s) Pd or P0 and ORa. See the HELP.'.
   ELSE IF (#ERROR=5).
      PRINT /'ERROR: Too much parameters. Parameter Pd is incompatible with parameters P0 and ORa. See the HELP.'.
   ELSE IF (#ERROR=6).
      PRINT /'ERROR: Missing parameter P0 or ORa. See the HELP.'.
   ELSE IF (#ERROR=7).
      PRINT /'ERROR: Too much parameters. Parameter Beta is incompatible with parameter N. See the HELP.'.
   ELSE IF (#ERROR=8).
      PRINT /'ERROR: Missing parameter Alpha or Beta. See the HELP.'.
   ELSE.
      COMPUTE #ODR=!ODR.
      !IF (!r<>!NULL) !THEN.
         COMPUTE #r=!r.
      !ELSE.
         COMPUTE #r=1.
      !IFEND.
*     Print header.
      DO IF (#r=1).
         PRINT /'SAMPLE SIZE & POWER: Two-paired proportions'.
      ELSE.
         PRINT /'SAMPLE SIZE & POWER: Matched Case-Control Study'.
      END IF.
      !PrintNST NST=!NST.

      !IF (!Pd<>!NULL) !THEN.
         COMPUTE #Pd=!Pd/100.
      !IFEND.
      !IF (!P0<>!NULL !AND !ORa<>!NULL) !THEN.
*        Estimate of the Discordant pairs proportion Pd.
         COMPUTE #P0=!P0/100.
         COMPUTE #ORa=!ORa.
         COMPUTE #P1 = #ODR*#P0/(1+(#ODR-1)*#P0).
         COMPUTE #Q1 = 1-#P1.
         COMPUTE #Pd =((#ODR+1)*#P0*(1-#P0)/(1+(#ODR-1)*#P0))*((SQRT(1+4*(#ORa-1)*#P1*#Q1)-1)/(2*(#ORa-1)*#P1*#Q1)).
      !IFEND.
*     Estimate of the difference of proportions P1-P0.
      COMPUTE #Diff= #Pd*(#ODR-1)/(#ODR+1).

*     Print parameters.
      COMPUTE #Diff_print= #Diff*100.
      COMPUTE #P0_print= #P0*100.
      COMPUTE #Pd_print= #Pd*100.
      !IF (!N=!NULL) !THEN.
         PRINT //'EXPECTED PARAMETERS'.
      !IFEND.
      PRINT  /'  Effect size'.
      !IF (!Pd<>!NULL) !THEN.
         PRINT  /'    Response/Exposure Odds Ratio:    OR = ' #ODR(F5.2).
         PRINT  /'    Prop. Difference (estimated): P1-P0 = ' #Diff_print(F5.2)'%'.
         PRINT  /'  Proportion of Discordant pairs:    Pd = ' #Pd_print(F5.2)  '%'.
      !IFEND.
      !IF (!P0<>!NULL !AND !ORa<>!NULL) !THEN.
         PRINT  /'       Response/Exposure Odds Ratio:     OR = ' #ODR(F5.2).
         PRINT  /'       Prop. Difference (estimated):  P1-P0 = ' #Diff_print(F5.2)'%'.
         DO IF (#r=1).
            PRINT  /'  Proportion in the Reference group:     P0 = ' #P0_print(F5.2)  '%'.
         ELSE.
            PRINT  /'  Proportion of exposure in Controls:    P0 = ' #P0_print(F5.2)  '%'.
         END IF.
         PRINT  /'  Marginal Odds Ratio (Association)     ORa = ' #ORa(F5.2).
         PRINT  /'  Proportion of Discordant pairs'.
         PRINT  /'       Fleiss-Levin estimation:          Pd = ' #Pd_print(F5.2)  '%'.
      !IFEND.
      !IF (!Pd=!NULL !AND !P0=!NULL !AND !ORa=!NULL) !THEN.
         PRINT  /'       Response/Exposure Odds Ratio:     OR = ' #ODR(F5.2).
      !IFEND.
      !IF (!N<>!NULL) !THEN.
         DO IF (#r=1).
            PRINT /'Sample Size:    Total number of pairs = ' !QUOTE(!N).
         ELSE.
            PRINT /'Sample Size:    Total number of Cases = ' !QUOTE(!N).
         END IF.
      !IFEND.
      !IF (!ALPHA<>!NULL !AND !BETA<>!NULL) !THEN.
         COMPUTE #Power=100-!BETA.
         PRINT /'  Alpha Risk = ' !QUOTE(!ALPHA)'%;  Beta Risk = ' !QUOTE(!BETA) '% (Power= ' #Power(F3.0) '%)'.
      !IFEND.
      DO IF (#r=1).
         PRINT  /'Paired Ratio (1:r)= 1:1'.
      ELSE.
         PRINT  /'Matching Ratio 1:' !QUOTE(!r).
      END IF.

      !IF (!N=!NULL) !THEN.
*********SAMPLE SIZE.
         !IF (!ALPHA=!NULL !AND !BETA=!NULL) !THEN.
            !LET !ALPHAdef = '5'.
            !LET !BETAdef = '20 15 10'.
         !ELSE.
            !LET !ALPHAdef = !ALPHA.
            !LET !BETAdef = !BETA.
         !IFEND.

*        Compute results for each Alpha, Beta, Two-Sided and One-Sided.
         !DO !I=1 !TO 2.
            !DO !A !IN(!ALPHAdef).
               !DO !B !IN(!BETAdef).
                  COMPUTE #Zalpha = IDF.NORMAL((100-!A/!I)/100,0,1).
                  COMPUTE #Zbeta  = IDF.NORMAL((100-!B)/100,0,1).

*                 Discordant pairs (Nd).
*                 Normal (Schlesselman).
                  !LET !Nd= !CONCAT('#Nd',!I,!A,!B).
                  !LET !Ndc=!CONCAT('#Ndc',!I,!A,!B).
                  COMPUTE !Nd= ((#Zalpha*(#ODR+1)+2*#Zbeta*SQRT(#ODR))/(#ODR-1))**2.
*                 Continuity correction.
                  COMPUTE !Ndc= !Nd + 2*(#ODR+1)/(#ODR-1).

*                 Matched results.
                  DO IF (#r > 1).
*                    Normal (Schlesselman).
                     !LET !NdCases= !CONCAT('#NdCases',!I,!A,!B).
                     !LET !NdContr= !CONCAT('#NdContr',!I,!A,!B).
                     COMPUTE !NdCases= !Nd*(#r+1)/(2*#r).
                     COMPUTE !NdContr= #r*!NdCases.
*                    Continuity correction.
                     !LET !NdcCases= !CONCAT('#NdcCases',!I,!A,!B).
                     !LET !NdcContr= !CONCAT('#NdcContr',!I,!A,!B).
                     COMPUTE !NdcCases= !Ndc*(#r+1)/(2*#r).
                     COMPUTE !NdcContr= #r*!NdcCases.
                  END IF.
               
                  !IF (!Pd<>!NULL !OR (!P0<>!NULL !AND !ORa<>!NULL)) !THEN.
*                    Discordant pairs: Connett.
                     !LET !Ndco=!CONCAT('#Ndco',!I,!A,!B).
                     COMPUTE !Ndco= (#Zalpha*SQRT(#ODR+1)+#Zbeta*SQRT(#ODR+1 -((#ODR-1)**2)*#Pd/(#ODR+1)))**2/((#ODR-1)**2/(#ODR+1)).

*                    Total pairs (N).
                     DO IF (#r = 1).
                        !LET !Nn = !CONCAT('#N',!I,!A,!B).
                        !LET !Nc = !CONCAT('#Nc',!I,!A,!B).
                        !LET !Nco= !CONCAT('#Nco',!I,!A,!B).
                        COMPUTE !Nn = !Nd/#Pd.
                        COMPUTE !Nc = !Ndc/#Pd.
                        COMPUTE !Nco= !Ndco/#Pd.
                     ELSE.
*                       Normal (Schlesselman).
                        !LET !Ncases= !CONCAT('#Ncases',!I,!A,!B).
                        !LET !Ncontr= !CONCAT('#Ncontr',!I,!A,!B).
                        COMPUTE !Ncases= !NdCases/#Pd.
                        COMPUTE !Ncontr= !NdContr/#Pd. 
*                       Continuity correction.
                        !LET !NcCases= !CONCAT('#NcCases',!I,!A,!B).
                        !LET !NcContr= !CONCAT('#NcContr',!I,!A,!B).
                        COMPUTE !NcCases= !NdcCases/#Pd.
                        COMPUTE !NcContr= !NdcContr/#Pd. 
*                       Connett.
                        !LET !NdcoCases= !CONCAT('#NdcoCases',!I,!A,!B).
                        !LET !NdcoContr= !CONCAT('#NdcoContr',!I,!A,!B).
                        COMPUTE !NdcoCases= !Ndco*(#r+1)/(2*#r).
                        COMPUTE !NdcoContr= #r*!NdcoCases.
                        !LET !NcoCases= !CONCAT('#NcoCases',!I,!A,!B).
                        !LET !NcoContr= !CONCAT('#NcoContr',!I,!A,!B).
                        COMPUTE !NcoCases= !NdcoCases/#Pd.
                        COMPUTE !NcoContr= !NdcoContr/#Pd. 
                     END IF. 
                  !IFEND.

*                 Sample Size must be integer.
                  IF (MOD(!Nd,1)<>0) !Nd = TRUNC(!Nd) + 1.
                  IF (MOD(!Ndc,1)<>0) !Ndc = TRUNC(!Ndc) + 1.
                  DO IF (#r > 1).
                     IF (MOD(!NdCases,1)<>0) !NdCases = TRUNC(!NdCases) + 1.
                     IF (MOD(!NdContr,1)<>0) !NdContr = TRUNC(!NdContr) + 1.
                     IF (MOD(!NdcCases,1)<>0) !NdcCases = TRUNC(!NdcCases) + 1.
                     IF (MOD(!NdcContr,1)<>0) !NdcContr = TRUNC(!NdcContr) + 1.
                  END IF.
                  !IF (!Pd<>!NULL !OR (!P0<>!NULL !AND !ORa<>!NULL)) !THEN.
                     IF (MOD(!Ndco,1)<>0) !Ndco = TRUNC(!Ndco) + 1.
                     DO IF (#r = 1).
                        IF (MOD(!Nn,1)<>0) !Nn = TRUNC(!Nn) + 1.
                        IF (MOD(!Nc,1)<>0) !Nc = TRUNC(!Nc) + 1.
                        IF (MOD(!Nco,1)<>0) !Nco = TRUNC(!Nco) + 1.
                     ELSE.
                        IF (MOD(!NdcoCases,1)<>0) !NdcoCases = TRUNC(!NdcoCases) + 1.
                        IF (MOD(!NdcoContr,1)<>0) !NdcoContr = TRUNC(!NdcoContr) + 1.
                        IF (MOD(!Ncases,1)<>0) !Ncases = TRUNC(!Ncases) + 1.
                        IF (MOD(!Ncontr,1)<>0) !Ncontr = TRUNC(!Ncontr) + 1.
                        IF (MOD(!NcCases,1)<>0) !NcCases = TRUNC(!NcCases) + 1.
                        IF (MOD(!NcContr,1)<>0) !NcContr = TRUNC(!NcContr) + 1.
                        IF (MOD(!NcoCases,1)<>0) !NcoCases = TRUNC(!NcoCases) + 1.
                        IF (MOD(!NcoContr,1)<>0) !NcoContr = TRUNC(!NcoContr) + 1.
                     END IF. 
                  !IFEND.
               !DOEND.
            !DOEND.
         !DOEND.

*        Print the table.
         !IF (!ALPHA=!NULL !AND !BETA=!NULL) !THEN.
            PRINT //'                      |                SAMPLE SIZE                |'.
            PRINT  /'         Alpha Risk=5%|    Two-Sided Test   |    One-Sided Test   |'.
            PRINT  /'METHOD           Power|   80%    85%    90% |   80%    85%    90% |'.
            PRINT  /'----------------------+---------------------+---------------------+'.
            !IF (!Pd<>!NULL !OR (!P0<>!NULL !AND !ORa<>!NULL)) !THEN.               
               DO IF (#r=1).
                  PRINT /'Normal approach       |                     |                     |'.
                  PRINT /'  Discordant pairs Nd |' #Nd2520(T24,F6) #Nd2515(T31,F6) #Nd2510(T38,F6) '|'45 #Nd1520(T46,F6) #Nd1515(T53,F6) #Nd1510(T60,F6) '|'67.
                  PRINT /'       Total pairs N  |' #N2520(T24,F6)  #N2515(T31,F6)  #N2510(T38,F6)  '|'45 #N1520(T46,F6)  #N1515(T53,F6)  #N1510(T60,F6)  '|'67.
                  PRINT /'----------------------+---------------------+---------------------+'.
                  PRINT /'Continuity correction |                     |                     |'.
                  PRINT /'  Discordant pairs Nd |' #Ndc2520(T24,F6) #Ndc2515(T31,F6) #Ndc2510(T38,F6) '|'45 #Ndc1520(T46,F6) #Ndc1515(T53,F6) #Ndc1510(T60,F6) '|'67.
                  PRINT /'       Total pairs N  |' #Nc2520(T24,F6)  #Nc2515(T31,F6)  #Nc2510(T38,F6)  '|'45 #Nc1520(T46,F6)  #Nc1515(T53,F6)  #Nc1510(T60,F6)  '|'67.
                  PRINT /'----------------------+---------------------+---------------------+'.
                  PRINT /'Connett approach*     |                     |                     |'.
                  PRINT /'  Discordant pairs Nd |' #Ndco2520(T24,F6) #Ndco2515(T31,F6) #Ndco2510(T38,F6) '|'45 #Ndco1520(T46,F6) #Ndco1515(T53,F6) #Ndco1510(T60,F6) '|'67.
                  PRINT /'       Total pairs N  |' #Nco2520(T24,F6)  #Nco2515(T31,F6)  #Nco2510(T38,F6)  '|'45 #Nco1520(T46,F6)  #Nco1515(T53,F6)  #Nco1510(T60,F6)  '|'67.
                  PRINT /'----------------------+---------------------+---------------------+'.
                  PRINT /'(*) Recommended method'.
               ELSE.
                  PRINT /'Normal approach       |                     |                     |'.
                  PRINT /'  Discordant    Cases |' #NdCases2520(T24,F6) #NdCases2515(T31,F6) #NdCases2510(T38,F6) '|'45 #NdCases1520(T46,F6) #NdCases1515(T53,F6) #NdCases1510(T60,F6) '|'67.
                  PRINT /'  Discordant Controls |' #NdContr2520(T24,F6) #NdContr2515(T31,F6) #NdContr2510(T38,F6) '|'45 #NdContr1520(T46,F6) #NdContr1515(T53,F6) #NdContr1510(T60,F6) '|'67.
                  PRINT /'       Total    Cases |' #NCases2520(T24,F6)  #NCases2515(T31,F6)  #NCases2510(T38,F6)  '|'45 #NCases1520(T46,F6)  #NCases1515(T53,F6)  #NCases1510(T60,F6)  '|'67.
                  PRINT /'       Total Controls |' #NContr2520(T24,F6)  #NContr2515(T31,F6)  #NContr2510(T38,F6)  '|'45 #NContr1520(T46,F6)  #NContr1515(T53,F6)  #NContr1510(T60,F6)  '|'67.
                  PRINT /'----------------------+---------------------+---------------------+'.
                  PRINT /'Continuity correction |                     |                     |'.
                  PRINT /'  Discordant    Cases |' #NdcCases2520(T24,F6) #NdcCases2515(T31,F6) #NdcCases2510(T38,F6) '|'45 #NdcCases1520(T46,F6) #NdcCases1515(T53,F6) #NdcCases1510(T60,F6) '|'67.
                  PRINT /'  Discordant Controls |' #NdcContr2520(T24,F6) #NdcContr2515(T31,F6) #NdcContr2510(T38,F6) '|'45 #NdcContr1520(T46,F6) #NdcContr1515(T53,F6) #NdcContr1510(T60,F6) '|'67.
                  PRINT /'       Total    Cases |' #NcCases2520(T24,F6)  #NcCases2515(T31,F6)  #NcCases2510(T38,F6)  '|'45 #NcCases1520(T46,F6)  #NcCases1515(T53,F6)  #NcCases1510(T60,F6)  '|'67.
                  PRINT /'       Total Controls |' #NcContr2520(T24,F6)  #NcContr2515(T31,F6)  #NcContr2510(T38,F6)  '|'45 #NcContr1520(T46,F6)  #NcContr1515(T53,F6)  #NcContr1510(T60,F6)  '|'67.
                  PRINT /'----------------------+---------------------+---------------------+'.
                  PRINT /'Connett approach*     |                     |                     |'.
                  PRINT /'  Discordant    Cases |' #NdcoCases2520(T24,F6) #NdcoCases2515(T31,F6) #NdcoCases2510(T38,F6) '|'45 #NdcoCases1520(T46,F6) #NdcoCases1515(T53,F6) #NdcoCases1510(T60,F6) '|'67.
                  PRINT /'  Discordant Controls |' #NdcoContr2520(T24,F6) #NdcoContr2515(T31,F6) #NdcoContr2510(T38,F6) '|'45 #NdcoContr1520(T46,F6) #NdcoContr1515(T53,F6) #NdcoContr1510(T60,F6) '|'67.
                  PRINT /'       Total    Cases |' #NcoCases2520(T24,F6)  #NcoCases2515(T31,F6)  #NcoCases2510(T38,F6)  '|'45 #NcoCases1520(T46,F6)  #NcoCases1515(T53,F6)  #NcoCases1510(T60,F6)  '|'67.
                  PRINT /'       Total Controls |' #NcoContr2520(T24,F6)  #NcoContr2515(T31,F6)  #NcoContr2510(T38,F6)  '|'45 #NcoContr1520(T46,F6)  #NcoContr1515(T53,F6)  #NcoContr1510(T60,F6)  '|'67.
                  PRINT /'----------------------+---------------------+---------------------+'.
                  PRINT /'(*) Recommended method'.
               END IF.
            !ELSE.
               DO IF (#r=1).
                  PRINT /'Normal approach       |                     |                     |'.
                  PRINT /'  Discordant pairs Nd |' #Nd2520(T24,F6) #Nd2515(T31,F6) #Nd2510(T38,F6) '|'45 #Nd1520(T46,F6) #Nd1515(T53,F6) #Nd1510(T60,F6) '|'67.
                  PRINT /'----------------------+---------------------+---------------------+'.
                  PRINT /'Continuity correction |                     |                     |'.
                  PRINT /'  Discordant pairs Nd |' #Ndc2520(T24,F6) #Ndc2515(T31,F6) #Ndc2510(T38,F6) '|'45 #Ndc1520(T46,F6) #Ndc1515(T53,F6) #Ndc1510(T60,F6) '|'67.
                  PRINT /'----------------------+---------------------+---------------------+'.
               ELSE.
                  PRINT /'Normal approach       |                     |                     |'.
                  PRINT /'  Discordant    Cases |' #NdCases2520(T24,F6) #NdCases2515(T31,F6) #NdCases2510(T38,F6) '|'45 #NdCases1520(T46,F6) #NdCases1515(T53,F6) #NdCases1510(T60,F6) '|'67.
                  PRINT /'  Discordant Controls |' #NdContr2520(T24,F6) #NdContr2515(T31,F6) #NdContr2510(T38,F6) '|'45 #NdContr1520(T46,F6) #NdContr1515(T53,F6) #NdContr1510(T60,F6) '|'67.
                  PRINT /'----------------------+---------------------+---------------------+'.
                  PRINT /'Continuity correction |                     |                     |'.
                  PRINT /'  Discordant    Cases |' #NdcCases2520(T24,F6) #NdcCases2515(T31,F6) #NdcCases2510(T38,F6) '|'45 #NdcCases1520(T46,F6) #NdcCases1515(T53,F6) #NdcCases1510(T60,F6) '|'67.
                  PRINT /'  Discordant Controls |' #NdcContr2520(T24,F6) #NdcContr2515(T31,F6) #NdcContr2510(T38,F6) '|'45 #NdcContr1520(T46,F6) #NdcContr1515(T53,F6) #NdcContr1510(T60,F6) '|'67.
                  PRINT /'----------------------+---------------------+---------------------+'.
               END IF.
            !IFEND.
         !ELSE.
            PRINT //'                      |           SAMPLE SIZE           |'.
            PRINT  /'METHOD                | Two-Sided Test | One-Sided Test |'.
            PRINT  /'----------------------+----------------+----------------+'.
            !IF (!Pd<>!NULL !OR (!P0<>!NULL !AND !ORa<>!NULL)) !THEN.
               DO IF (#r=1).
                  PRINT /'Normal approach       |                |                |'.
                  PRINT /'  Discordant pairs Nd |' !CONCAT('#Nd2',!ALPHA,!BETA)(T28,F6) '|'40 !CONCAT('#Nd1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'       Total pairs N  |' !CONCAT('#N2',!ALPHA,!BETA)(T28,F6)  '|'40 !CONCAT('#N1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'----------------------+----------------+----------------+'.
                  PRINT /'Continuity correction |                |                |'.
                  PRINT /'  Discordant pairs Nd |' !CONCAT('#Ndc2',!ALPHA,!BETA)(T28,F6) '|'40 !CONCAT('#Ndc1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'       Total pairs N  |' !CONCAT('#Nc2',!ALPHA,!BETA)(T28,F6)  '|'40 !CONCAT('#Nc1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'----------------------+----------------+----------------+'.
                  PRINT /'Connett approach*     |                |                |'.
                  PRINT /'  Discordant pairs Nd |' !CONCAT('#Ndco2',!ALPHA,!BETA)(T28,F6) '|'40 !CONCAT('#Ndco1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'       Total pairs N  |' !CONCAT('#Nco2',!ALPHA,!BETA)(T28,F6)  '|'40 !CONCAT('#Nco1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'----------------------+----------------+----------------+'.
                  PRINT /'(*) Recommended method'.
               ELSE.
                  PRINT /'Normal approach       |                |                |'.
                  PRINT /'  Discordant    Cases |' !CONCAT('#NdCases2',!ALPHA,!BETA)(T28,F6) '|'40 !CONCAT('#NdCases1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'  Discordant Controls |' !CONCAT('#NdContr2',!ALPHA,!BETA)(T28,F6) '|'40 !CONCAT('#NdContr1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'       Total    Cases |' !CONCAT('#NCases2',!ALPHA,!BETA)(T28,F6)  '|'40 !CONCAT('#NCases1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'       Total Controls |' !CONCAT('#NContr2',!ALPHA,!BETA)(T28,F6)  '|'40 !CONCAT('#NContr1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'----------------------+----------------+----------------+'.
                  PRINT /'Continuity correction |                |                |'.
                  PRINT /'  Discordant    Cases |' !CONCAT('#NdcCases2',!ALPHA,!BETA)(T28,F6) '|'40 !CONCAT('#NdcCases1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'  Discordant Controls |' !CONCAT('#NdcContr2',!ALPHA,!BETA)(T28,F6) '|'40 !CONCAT('#NdcContr1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'       Total    Cases |' !CONCAT('#NcCases2',!ALPHA,!BETA)(T28,F6)  '|'40 !CONCAT('#NcCases1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'       Total Controls |' !CONCAT('#NcContr2',!ALPHA,!BETA)(T28,F6)  '|'40 !CONCAT('#NcContr1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'----------------------+----------------+----------------+'.
                  PRINT /'Connett approach*     |                |                |'.
                  PRINT /'  Discordant    Cases |' !CONCAT('#NdcoCases2',!ALPHA,!BETA)(T28,F6) '|'40 !CONCAT('#NdcoCases1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'  Discordant Controls |' !CONCAT('#NdcoContr2',!ALPHA,!BETA)(T28,F6) '|'40 !CONCAT('#NdcoContr1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'       Total    Cases |' !CONCAT('#NcoCases2',!ALPHA,!BETA)(T28,F6)  '|'40 !CONCAT('#NcoCases1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'       Total Controls |' !CONCAT('#NcoContr2',!ALPHA,!BETA)(T28,F6)  '|'40 !CONCAT('#NcoContr1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'----------------------+----------------+----------------+'.
                  PRINT /'(*) Recommended method'.
               END IF.
            !ELSE.
               DO IF (#r=1).
                  PRINT /'Normal approach       |                |                |'.
                  PRINT /'  Discordant pairs Nd |' !CONCAT('#Nd2',!ALPHA,!BETA)(T28,F6) '|'40 !CONCAT('#Nd1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'----------------------+----------------+----------------+'.
                  PRINT /'Continuity correction |                |                |'.
                  PRINT /'  Discordant pairs Nd |' !CONCAT('#Ndc2',!ALPHA,!BETA)(T28,F6) '|'40 !CONCAT('#Ndc1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'----------------------+----------------+----------------+'.
               ELSE.
                  PRINT /'Normal approach       |                |                |'.
                  PRINT /'  Discordant    Cases |' !CONCAT('#NdCases2',!ALPHA,!BETA)(T28,F6) '|'40 !CONCAT('#NdCases1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'  Discordant Controls |' !CONCAT('#NdContr2',!ALPHA,!BETA)(T28,F6) '|'40 !CONCAT('#NdContr1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'----------------------+----------------+----------------+'.
                  PRINT /'Continuity correction |                |                |'.
                  PRINT /'  Discordant    Cases |' !CONCAT('#NdcCases2',!ALPHA,!BETA)(T28,F6) '|'40 !CONCAT('#NdcCases1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'  Discordant Controls |' !CONCAT('#NdcContr2',!ALPHA,!BETA)(T28,F6) '|'40 !CONCAT('#NdcContr1',!ALPHA,!BETA)(T45,F6) '|'57.
                  PRINT /'----------------------+----------------+----------------+'.
               END IF.
            !IFEND.
         !IFEND.
      !ELSE.
*********POWER.
         COMPUTE #N=!N.
         !IF (!ALPHA=!NULL) !THEN.
            COMPUTE #Alpha=0.05.
         !ELSE.
            COMPUTE #Alpha=!ALPHA/100.
         !IFEND.
         COMPUTE #Zalpha1= IDF.NORMAL(1-#Alpha,0,1).
         COMPUTE #Zalpha2= IDF.NORMAL(1-#Alpha/2,0,1).
         COMPUTE #N= #N*2*#r/(#r+1).
         COMPUTE #Zbeta1= ((#ODR-1)*SQRT(#N*#Pd/(#ODR+1))-#Zalpha1*SQRT(#ODR+1))/SQRT(#ODR+1-#Pd*(#ODR-1)**2/(#ODR+1)).
         COMPUTE #Zbeta2= ((#ODR-1)*SQRT(#N*#Pd/(#ODR+1))-#Zalpha2*SQRT(#ODR+1))/SQRT(#ODR+1-#Pd*(#ODR-1)**2/(#ODR+1)).
         COMPUTE #Power1= CDF.NORMAL(#Zbeta1,0,1)*100.
         COMPUTE #Power2= CDF.NORMAL(#Zbeta2,0,1)*100.

*        Print results.
         COMPUTE #Alpha= #Alpha*100.
         PRINT  /'Alpha Risk = ' #Alpha(F2) '%'.
         PRINT  /'METHOD: Normal (Connett approach)'.
         
         PRINT //'                |  POWER  |'.
         PRINT  /'----------------+---------+'.
         PRINT  /' Two-Sided Test |'  #Power2(T20,F4.1)'%  |'.
         PRINT  /' One-Sided Test |'  #Power1(T20,F4.1)'%  |'.
         PRINT  /'----------------+---------+'.
      !IFEND.      
   END IF.
!ENDDEFINE.

****N2R: Auxiliary macro for TYPE=Co2R (old NR2IS).
DEFINE !N2R( R0 = !CHAREND('/') /R1 = !CHAREND('/') /RR = !CHAREND('/') /RD = !CHAREND('/')
           /PE0 = !CHAREND('/') /PE1 = !CHAREND('/') /ODR = !CHAREND('/') 
         /Alpha = !CHAREND('/') /Beta = !CHAREND('/') /N0 = !CHAREND('/') /N1 = !CHAREND('/') /r = !CHAREND('/') 
           /NST = !CHAREND('/')).

   !IF (!R0=!NULL !AND !PE0=!NULL) !THEN.
      COMPUTE #ERROR=3.          /*Missing parameter R0 or PE0.
   !ELSE.
      !IF (!R0<>!NULL) !THEN.
         !IF (!PE0<>!NULL !OR !PE1<>!NULL) !THEN.
            COMPUTE #ERROR=4.    /*Too much parameters: PE0, PE1 with R0.
         !ELSE.
            !IF (!R1=!NULL !AND !RR=!NULL !AND !RD=!NULL !AND !ODR=!NULL) !THEN.
               COMPUTE #ERROR=5.    /*Missing parameter R1 or RR or RD or ODR.
            !ELSE.
               !LET !temp = ''.
               !IF (!R1<>!NULL) !THEN.
                  !LET !temp = !CONCAT(!temp,' ').
               !IFEND.
               !IF (!RR<>!NULL) !THEN.
                  !LET !temp = !CONCAT(!temp,' ').
               !IFEND.
               !IF (!RD<>!NULL) !THEN.
                  !LET !temp = !CONCAT(!temp,' ').
               !IFEND.
               !IF (!ODR<>!NULL) !THEN.
                  !LET !temp = !CONCAT(!temp,' ').
               !IFEND.
               !IF (!LENGTH(!temp)>1) !THEN.
                  COMPUTE #ERROR=6.  /*Too much parameters: R1 or RR or RD or ODR.
               !IFEND.
            !IFEND.
         !IFEND.
      !ELSE.
         !IF (!R0<>!NULL !OR !R1<>!NULL !OR !RR<>!NULL !OR !RD<>!NULL) !THEN.
            COMPUTE #ERROR=7.    /*Too much parameters: R0, R1, RR, RD with PE0.
         !ELSE.
            !IF (!PE1=!NULL !AND !ODR=!NULL) !THEN.
               COMPUTE #ERROR=8.    /*Missing parameter PE1 or ODR.
            !ELSE.
               !IF (!PE1<>!NULL !AND !ODR<>!NULL) !THEN.
                  COMPUTE #ERROR=9.    /*Too much parameters: PE1 or ODR.
               !IFEND.
            !IFEND.
         !IFEND.
      !IFEND.
   !IFEND.
   !IF (!N0=!NULL !AND !N1=!NULL) !THEN.
      !IF ((!Alpha=!NULL !AND !Beta<>!NULL) !OR (!Alpha<>!NULL !AND !Beta=!NULL)) !THEN.
         COMPUTE #ERROR=10.         /*Missing parameter Alpha or Beta.
      !IFEND.
   !ELSE.
      !IF (!Beta<>!NULL) !THEN.
         COMPUTE #ERROR=11.         /*Too much parameters Beta and N0,N1.
      !ELSE.
         !IF (!N0<>!NULL !AND !N1<>!NULL !AND !r<>!NULL) !THEN.
            COMPUTE #ERROR=12.         /*Too much parameters N0,N1 and r.
         !IFEND.
      !IFEND.
   !IFEND.
   !TestParameter Param=!R0 /Type=1 /ParamName=R0.
   !TestParameter Param=!R1 /Type=1 /ParamName=R1.
   !TestParameter Param=!PE0 /Type=1 /ParamName=PE0.
   !TestParameter Param=!PE1 /Type=1 /ParamName=PE1.
   !TestParameter Param=!RD /Type=10 /ParamName=RD.
   !TestParameter Param=!RR /Type=5 /ParamName=RR.
   !TestParameter Param=!ODR /Type=5 /ParamName=ODR.
   !TestParameter Param=!r /Type=5 /ParamName=r.
   !TestParameter Param=!N0 /Type=4 /ParamName=N0.
   !TestParameter Param=!N1 /Type=4 /ParamName=N1.
   !TestParameter Param=!Alpha /Type=17 /ParamName=Alpha.
   !TestParameter Param=!Beta /Type=17 /ParamName=Beta.

   DO IF (#ERROR=1 OR #ERROR=2).
*     Do nothing: TestParameter error.
   ELSE IF (#ERROR=3).
      PRINT /'ERROR: Missing parameter R0 or PE0. See the HELP.'.
   ELSE IF (#ERROR=4).
      PRINT /'ERROR: Too much parameters. Parameters PE0 and PE1 are incompatible with R0. See the HELP.'.
   ELSE IF (#ERROR=5).
      PRINT /'ERROR: Missing parameter R1 or RR or RD or ODR. See the HELP.'.
   ELSE IF (#ERROR=6).
      PRINT /'ERROR: Too much parameters. Only one parameter R1 or RR or RD or ODR is allowed. See the HELP.'.
   ELSE IF (#ERROR=7).
      PRINT /'ERROR: Too much parameters. Parameters R0,R1,RR and RD are incompatible with PE0. See the HELP.'.
   ELSE IF (#ERROR=8).
      PRINT /'ERROR: Missing parameter PE1 or ODR. See the HELP.'.
   ELSE IF (#ERROR=9).
      PRINT /'ERROR: Too much parameters. Parameters PE1 and ODR are incompatible. See the HELP.'.
   ELSE IF (#ERROR=10).
      PRINT /'ERROR: Missing parameter Alpha or Beta. See the HELP.'.
   ELSE IF (#ERROR=11).
      PRINT /'ERROR: Too much parameters. Parameter Beta is incompatible with N0,N1. See the HELP.'.
   ELSE IF (#ERROR=12).
      PRINT /'ERROR: Too much parameters. Parameters N0,N1 are incompatible with r. See the HELP.'.
   ELSE.
*     Print header.
      PRINT /'SAMPLE SIZE (RISK) & POWER: Two-independent samples'.
      !PrintNST NST=!NST.

*     Compute the risk measures.
      !IF (!R0<>!NULL) !THEN.
         COMPUTE #P0=!R0.
         !IF (!R1<>!NULL) !THEN.
            COMPUTE #P1=!R1.
         !ELSE.
            !IF (!RD<>!NULL) !THEN.
               COMPUTE #P1=!RD+!R0.
            !ELSE.
               !IF (!RR<>!NULL) !THEN.
                  COMPUTE #P1=!RR*!R0.
               !IFEND.
            !IFEND.
         !IFEND.
      !ELSE.
         COMPUTE #P0=!PE0.
         !IF (!PE1<>!NULL) !THEN.
            COMPUTE #P1=!PE1.
         !IFEND.
      !IFEND.
      !IF (!ODR<>!NULL) !THEN.
         COMPUTE #P1=(100*(#P0/(100-#P0)) *!ODR)/( ((#P0/(100-#P0))*!ODR)+1).
      !IFEND.
      COMPUTE #RR=#P1/#P0.
      COMPUTE #OD=(#P1/(100-#P1))/(#P0/(100-#P0)).
      COMPUTE #RD=#P1-#P0.
      COMPUTE #RD1=#RD/100.
*     r value.
      COMPUTE #r=1.
      !IF (!r<>!NULL) !THEN.
         COMPUTE #r = !r.
      !IFEND.
*     N0, N1 values.
      !IF (!N0<>!NULL !OR !N1<>!NULL) !THEN.
         !IF (!N0<>!NULL !AND !N1<>!NULL) !THEN.
            COMPUTE #N0=!N0.
            COMPUTE #N1=!N1.
            COMPUTE #r=(#N0/#N1).
         !ELSE.
            !IF (!N0<>!NULL) !THEN.
               COMPUTE #N0=!N0.
               COMPUTE #N1=(#N0/#r).
               IF (MOD(#N1,1)<>0) #N1=TRUNC(#N1)+1.
            !ELSE.
               COMPUTE #N1=!N1.
               COMPUTE #N0=#r*#N1.
               IF (MOD(#N0,1)<>0) #N0=TRUNC(#N0)+1.
            !IFEND.
         !IFEND.
      !IFEND.
      COMPUTE #WARNING1 = 0.
      COMPUTE #WARNING2 = 0.
      STRING #TempC (A1).
      COMPUTE #TempC = ' '.
      IF (#P0<20 or #P1<20 or #P0>80 OR #P1>80) #WARNING1=1.

      COMPUTE #DArcs=(4*#r)*(ARSIN(SQRT((#P0+#RD)/100))-ARSIN(SQRT(#P0/100)) )**2.
      COMPUTE #DNorm=#r*(#RD1**2).
      COMPUTE #FLEISS=(#r+1)/(#r*ABS(#RD1)).
      COMPUTE #Ppond=(#P1/100+#r*#P0/100)/(#r+1).
            
      !IF (!R0<>!NULL) !THEN.
         PRINT /'Proportion(%) of events in: UnExposed (Group 0)= ' #P0(F5.2)'%'.
         PRINT /'                            Exposed   (Group 1)= ' #P1(F5.2)'%'.
         PRINT /'Minimum expected: RR='#RR(F6.2) '; OR='#OD(F6.2) '; RD= '#RD(F5.2)'%('#RD1(F6.5)')'.
      !ELSE.
         PRINT /'Proportion of exposed in: Noncases (Group 0)= ' #P0(F5.2)'%'.
         PRINT /'                          Cases    (Group 1)= ' #P1(F5.2)'%'.
         PRINT /'Minimum expected: OR='#OD(F6.2).
      !IFEND.

*     Print a table when ALPHA and BETA are defaults.
      !IF (!N0=!NULL !AND !N1=!NULL) !THEN.
         !IF (!ALPHA =!NULL !AND !BETA =!NULL) !THEN.
            !LET !ALPHAdef = '5'.
            !LET !BETAdef  = '20 15 10'.
            !DO !J=0 !TO 1.
               COMPUTE #J=!J.
               !DO !I=1 !TO 2.
                  COMPUTE #I=!I.
                  !DO !A !IN(!ALPHAdef).
                     COMPUTE #Alpha = !A.
                     !DO !B !IN(!BETAdef).
                        COMPUTE #Beta = !B.
                        !GetN2R VarName = !CONCAT('#N',!J,!I,!A,!B).
                     !DOEND.
                  !DOEND.
               !DOEND.
            !DOEND.
*           Compute Totals.
            !DO !I=1 !TO 2.
               !DO !A !IN(!ALPHAdef).
                  !DO !B !IN(!BETAdef).
                     COMPUTE !CONCAT('#N',!I,!A,!B,'A')=!CONCAT('#N0',!I,!A,!B,'A')+!CONCAT('#N1',!I,!A,!B,'A').
                     COMPUTE !CONCAT('#N',!I,!A,!B,'N')=!CONCAT('#N0',!I,!A,!B,'N')+!CONCAT('#N1',!I,!A,!B,'N').
                     COMPUTE !CONCAT('#N',!I,!A,!B,'F')=!CONCAT('#N0',!I,!A,!B,'F')+!CONCAT('#N1',!I,!A,!B,'F').
                  !DOEND.
               !DOEND.
            !DOEND.

*           Print: Two and one-sided test in a table.
            IF (#WARNING1=1 OR #WARNING2=1) #TempC='*'.
            PRINT /'Ratio N0/N1 = ' #r(F4.2).
            PRINT SPACE.
            PRINT /'                      |                SAMPLE SIZE                |'.
            PRINT /'         Alpha Risk=5%|    Two-Sided Test   |    One-Sided Test   |'.
            PRINT /' METHOD          Power|   80%    85%    90% |   80%    85%    90% |'.
            PRINT /'----------------------+---------------------+---------------------+'.
            PRINT /' Normal' #TempC(A1) '           n0 |' #N02520N(T24,F6) #N02515N(T31,F6) #N02510N(T38,F6) '|'45 #N01520N(T46,F6) #N01515N(T53,F6) #N01510N(T60,F6) '|'67.
            PRINT /'                   n1 |' #N12520N(T24,F6) #N12515N(T31,F6) #N12510N(T38,F6) '|'45 #N11520N(T46,F6) #N11515N(T53,F6) #N11510N(T60,F6) '|'67.
            PRINT /'                Total |' #N2520N(T24,F6)  #N2515N(T31,F6)  #N2510N(T38,F6)  '|'45 #N1520N(T46,F6)  #N1515N(T53,F6)  #N1510N(T60,F6)  '|'67.
            PRINT /'----------------------+---------------------+---------------------+'.
            PRINT /' Normal corrected  n0 |' #N02520F(T24,F6) #N02515F(T31,F6) #N02510F(T38,F6) '|'45 #N01520F(T46,F6) #N01515F(T53,F6) #N01510F(T60,F6) '|'67.
            PRINT /'                   n1 |' #N12520F(T24,F6) #N12515F(T31,F6) #N12510F(T38,F6) '|'45 #N11520F(T46,F6) #N11515F(T53,F6) #N11510F(T60,F6) '|'67.
            PRINT /'                Total |' #N2520F(T24,F6)  #N2515F(T31,F6)  #N2510F(T38,F6)  '|'45 #N1520F(T46,F6)  #N1515F(T53,F6)  #N1510F(T60,F6)  '|'67.
            PRINT /'----------------------+---------------------+---------------------+'.
            PRINT /' ArcoSinus         n0 |' #N02520A(T24,F6) #N02515A(T31,F6) #N02510A(T38,F6) '|'45 #N01520A(T46,F6) #N01515A(T53,F6) #N01510A(T60,F6) '|'67.
            PRINT /'                   n1 |' #N12520A(T24,F6) #N12515A(T31,F6) #N12510A(T38,F6) '|'45 #N11520A(T46,F6) #N11515A(T53,F6) #N11510A(T60,F6) '|'67.
            PRINT /'                Total |' #N2520A(T24,F6)  #N2515A(T31,F6)  #N2510A(T38,F6)  '|'45 #N1520A(T46,F6)  #N1515A(T53,F6)  #N1510A(T60,F6)  '|'67.
            PRINT /'----------------------+---------------------+---------------------+'.
         !ELSE.
*           If ALPHA or BETA aren't defaults print a brief output.
            COMPUTE #Alpha = !Alpha.
            COMPUTE #Beta = !Beta.
            !DO !J=0 !TO 1.
               COMPUTE #J=!J.
               !DO !I=1 !TO 2.
                  COMPUTE #I=!I.
                  !GetN2R VarName = !CONCAT('#N',!J,!I).
               !DOEND.
            !DOEND.
*           Compute Totals.
            !DO !I=1 !TO 2.
               COMPUTE !CONCAT('#N',!I,'A')=!CONCAT('#N0',!I,'A')+!CONCAT('#N1',!I,'A').
               COMPUTE !CONCAT('#N',!I,'N')=!CONCAT('#N0',!I,'N')+!CONCAT('#N1',!I,'N').
               COMPUTE !CONCAT('#N',!I,'F')=!CONCAT('#N0',!I,'F')+!CONCAT('#N1',!I,'F').
            !DOEND.

            IF (#WARNING1=1 OR #WARNING2=1) #TempC='*'.
            PRINT /'Alpha Risk = ' !QUOTE(!ALPHA) '%; Beta Risk = '!QUOTE(!BETA) '%;  Ratio N0/N1 = ' #r(F4.2).
            PRINT //'                      |           SAMPLE SIZE           |'.
            PRINT  /' METHOD               | Two-Sided Test | One-Sided Test |'.
            PRINT  /'----------------------+----------------+----------------+'.
            PRINT  /' Normal' #TempC(A1) 'n0 |'20 #N02N(T28,F7) '|'40 #N01N(T45,F7) '|'57.
            PRINT  /'                   n1 |'     #N12N(T28,F7) '|'40 #N11N(T45,F7) '|'57.
            PRINT  /'                Total |'     #N2N(T28,F7)  '|'40 #N1N(T45,F7)  '|'57.
            PRINT  /'----------------------+----------------+----------------+'.
            PRINT  /' Normal corrected  n0 |'     #N02F(T28,F7) '|'40 #N01F(T45,F7) '|'57.
            PRINT  /'                   n1 |'     #N12F(T28,F7) '|'40 #N11F(T45,F7) '|'57.
            PRINT  /'                Total |'     #N2F(T28,F7)  '|'40 #N1F(T45,F7)  '|'57.
            PRINT  /'----------------------+----------------+----------------+'.
            PRINT  /' ArcoSinus         n0 |'     #N02A(T28,F7) '|'40 #N01A(T45,F7) '|'57.
            PRINT  /'                   n1 |'     #N12A(T28,F7) '|'40 #N11A(T45,F7) '|'57.
            PRINT  /'                Total |'     #N2A(T28,F7)  '|'40 #N1A(T45,F7)  '|'57.
            PRINT  /'----------------------+----------------+----------------+'.
         !IFEND.
      !ELSE.
*        POWER results.
         !LET !AlphaPrint = !Alpha.
         !IF (!Alpha=!NULL) !THEN.
            !LET !AlphaPrint = 5.
         !IFEND.
         COMPUTE #Alpha = !AlphaPrint.
         !DO !I=1 !TO 2.
            COMPUTE #I=!I.
            !GetPower2R VarName = !CONCAT('#Power',!I).
         !DOEND.
         IF (#WARNING1=1 OR #WARNING2=1) #TempC='*'.
         PRINT /'Sample size: n0 = ' #N0(F6) ' ; n1 = '#N1(F6) ' (Ratio n0/n1 = ' #r(F4.2) ')'.
         PRINT /'Alpha Risk = ' !QUOTE(!AlphaPrint) '%'.
         PRINT  /'                  |              POWER (%)          |'.
         PRINT  /' METHOD           | Two-Sided Test | One-Sided Test |'.
         PRINT  /'------------------+----------------+----------------+'.
         PRINT  /' Normal' #TempC(A1) '|'19 #Power2N(T26,F4.1) '|'36 #Power1N(T43,F4.1) '|'53.
         PRINT  /' Normal corrected |' #Power2F(T26,F4.1)      '|'36 #Power1F(T43,F4.1) '|'53.
         PRINT  /' ArcoSinus        |' #Power2A(T26,F4.1)      '|'36 #Power1A(T43,F4.1) '|'53.
         PRINT  /'------------------+----------------+----------------+'.
      !IFEND.
      DO IF (#WARNING1=1 or #WARNING2=1).
         PRINT /'(*)WARNING: Applicability conditions for Normal method not granted'.
         DO IF (#WARNING1=1).
            PRINT /'P0 and P1 must be >=20 and <=80'.
         END IF.
         DO IF (#WARNING2=1).
            PRINT /'N0*P0, N0*(1-P0), N1*P1 and N1*(1-P1) must be >=10'.
         END IF.
      END IF.
   END IF.

!ENDDEFINE.

DEFINE  !GetN2R( VarName = !CHAREND('/')).

   COMPUTE #ZAlpha=IDF.NORMAL((100-#Alpha/#I)/100,0,1).
   COMPUTE #ZBeta=IDF.NORMAL((100-#Beta)/100,0,1).
   
*  Sinusual inverse exact probability of Fisher (Arcosinus method).
   !LET !NArcs = !CONCAT(!VarName,'A').
   COMPUTE !NArcs = #r*(#r+1)*(#ZAlpha+#ZBeta)**2 /#DArcs.
   IF (#J=1) !NArcs=!NArcs/#r.
   IF (MOD(!NArcs,1)<>0) !NArcs = TRUNC(!NArcs)+1.
*  Normal method.
   !LET !NNorm = !CONCAT(!VarName,'N').
   COMPUTE #Num1=#ZAlpha*SQRT((#r+1)*#Ppond*(1-#Ppond)).
   COMPUTE #Num2=#ZBeta*SQRT((#P0/100*(100-#P0)/100)+#r*(#P1/100*(100-#P1)/100)).
   COMPUTE !NNorm=((#Num1+#Num2)**2 / #DNorm).
   IF (#J=0) !NNorm=!NNorm*#r.
   IF (MOD(!NNorm,1)<>0) !NNorm=TRUNC(!NNorm)+1.
   DO IF (#J=1).
      IF ((!NNorm*#P1/100)<10 or (!NNorm*(1-#P1/100))<10) #WARNING2=1.
   ELSE.
      IF ((!NNorm*#P0/100)<10 or (!NNorm*(1-#P0/100))<10) #WARNING2=1.   
   END IF.
*  Normal method with Fleiss correction.
   !LET !NNormF=!CONCAT(!VarName,'F').
   COMPUTE !NNormF=((#Num1+#Num2)**2 / #DNorm) + #FLEISS.
   IF (#J=0) !NNormF=!NNormF*#r.
   IF (MOD(!NNormF,1)<>0) !NNormF=TRUNC(!NNormF)+1.
   
!ENDDEFINE.

DEFINE  !GetPower2R( VarName = !CHAREND('/')).

   COMPUTE #ZAlpha=IDF.NORMAL((100-#Alpha/#I)/100,0,1).
   
*  Sinusual inverse exact probability of Fisher (Arcosinus method).
   !LET !PArc = !CONCAT(!VarName,'A').
   COMPUTE !PArc = 100-((1-CDF.NORMAL(SQR((#N1*#DArcs)/(#r + 1)) - #ZAlpha,0,1))*100).
*  Normal method.
   !LET !PNorm = !CONCAT(!VarName,'N').
   COMPUTE #Num1= SQRT((#r+1)*#Ppond*(1-#Ppond)).
   COMPUTE #Num2= SQRT((#P0/100)*(1-#P0/100) + #r*(#P1/100)*(1-#P1/100)).
   COMPUTE !PNorm=100-((1-CDF.NORMAL((SQR(#N1*#DNorm) - #Zalpha*#Num1)/#Num2,0,1))*100).
   IF ((#N0*#P0/100)<10 or (#N0*(1-#P0/100))<10) #WARNING2=1.
   IF ((#N1*#P1/100)<10 or (#N1*(1-#P1/100))<10) #WARNING2=1.
*  Normal method with Fleiss correction.
   !LET !PNormF=!CONCAT(!VarName,'F').
   COMPUTE !PNormF=100-((1-CDF.NORMAL((SQR((#N1-#FLEISS)*#DNorm) - #Zalpha*#Num1)/#Num2,0,1))*100).
   
!ENDDEFINE.

****N2I: Auxiliary macro for TYPE=Co2I (old NI2IS).
DEFINE !N2I( I0 = !CHAREND('/') /I1 = !CHAREND('/') /IR = !CHAREND('/') /ID = !CHAREND('/')
             /r = !CHAREND('/') /D = !CHAREND('/')
         /Alpha = !CHAREND('/') /Beta = !CHAREND('/') /N0 = !CHAREND('/') /N1 = !CHAREND('/')  
           /NST = !CHAREND('/')).

   !IF (!I0=!NULL) !THEN.
      COMPUTE #ERROR=3.          /*Missing parameter I0.
   !ELSE.
      !IF (!D=!NULL) !THEN.
         COMPUTE #ERROR=4.       /*Missing parameter D.
      !ELSE.
         !IF (!I1=!NULL !AND !IR=!NULL !AND !ID=!NULL) !THEN.
            COMPUTE #ERROR=5.    /*Missing parameter I1, IR or ID.
         !ELSE.
               !LET !temp = ''.
               !IF (!I1<>!NULL) !THEN.
                  !LET !temp = !CONCAT(!temp,' ').
               !IFEND.
               !IF (!IR<>!NULL) !THEN.
                  !LET !temp = !CONCAT(!temp,' ').
               !IFEND.
               !IF (!ID<>!NULL) !THEN.
                  !LET !temp = !CONCAT(!temp,' ').
               !IFEND.
               !IF (!LENGTH(!temp)>1) !THEN.
                  COMPUTE #ERROR=6.  /*Too much parameters: I1 or IR or ID.
               !IFEND.
         !IFEND.
      !IFEND.
   !IFEND.
   !IF (!N0=!NULL !AND !N1=!NULL) !THEN.
      !IF ((!Alpha=!NULL !AND !Beta<>!NULL) !OR (!Alpha<>!NULL !AND !Beta=!NULL)) !THEN.
         COMPUTE #ERROR=7.         /*Missing parameter Alpha or Beta.
      !IFEND.
   !ELSE.
      !IF (!Beta<>!NULL) !THEN.
         COMPUTE #ERROR=8.         /*Too much parameters Beta and N0,N1.
      !ELSE.
         !IF (!N0<>!NULL !AND !N1<>!NULL !AND !r<>!NULL) !THEN.
            COMPUTE #ERROR=9.         /*Too much parameters N0,N1 and r.
         !IFEND.
      !IFEND.
   !IFEND.
   !TestParameter Param=!I0 /Type=5 /ParamName=I0.
   !TestParameter Param=!I1 /Type=5 /ParamName=I1.
   !TestParameter Param=!IR /Type=5 /ParamName=IR.
   !TestParameter Param=!D /Type=5 /ParamName=D.
   !TestParameter Param=!r /Type=5 /ParamName=r.
   !TestParameter Param=!ID /Type=10 /ParamName=ID.
   !TestParameter Param=!N0 /Type=4 /ParamName=N0.
   !TestParameter Param=!N1 /Type=4 /ParamName=N1.
   !TestParameter Param=!Alpha /Type=17 /ParamName=Alpha.
   !TestParameter Param=!Beta /Type=17 /ParamName=Beta.

   DO IF (#ERROR=1 OR #ERROR=2).
*     Do nothing: TestParameter error.
   ELSE IF (#ERROR=3).
      PRINT /'ERROR: Missing parameter I0. See the HELP.'.
   ELSE IF (#ERROR=4).
      PRINT /'ERROR: Missing parameter D. See the HELP.'.
   ELSE IF (#ERROR=5).
      PRINT /'ERROR: Missing parameter I1 or IR or ID. See the HELP.'.
   ELSE IF (#ERROR=6).
      PRINT /'ERROR: Too much parameters. Only one parameter I1 or IR or ID is allowed. See the HELP.'.
   ELSE IF (#ERROR=7).
      PRINT /'ERROR: Missing parameter Alpha or Beta. See the HELP.'.
   ELSE IF (#ERROR=8).
      PRINT /'ERROR: Too much parameters. Parameter Beta is incompatible with N0,N1. See the HELP.'.
   ELSE IF (#ERROR=9).
      PRINT /'ERROR: Too much parameters. Parameters N0,N1 are incompatible with r. See the HELP.'.
   ELSE.
*     Print header.
      PRINT /'SAMPLE SIZE (RATE) & POWER: Two-independent samples'.
      !PrintNST NST=!NST.

*     Read the parameters.
      COMPUTE #I0=!I0.
      COMPUTE #D=!D.
      !IF (!I1<>!NULL) !THEN.
         COMPUTE #I1=!I1.
         COMPUTE #IR=#I1/#I0.
         COMPUTE #ID=#I1-#I0.
      !IFEND.
      !IF (!ID<>!NULL) !THEN.
         COMPUTE #ID=!ID.
         COMPUTE #I1=#ID+#I0.
         COMPUTE #IR=#I1/#I0.
      !IFEND.
      !IF (!IR<>!NULL) !THEN.
         COMPUTE #IR=!IR.
         COMPUTE #I1=#IR*#I0.
         COMPUTE #ID=#I1-#I0.
      !IFEND.
*     r value.
      COMPUTE #r=1.
      !IF (!r<>!NULL) !THEN.
         COMPUTE #r = !r.
         !LET !rPrint = !r.
      !ELSE.   
         !LET !rPrint = 1.
      !IFEND.
*     N0, N1 values.
      !IF (!N0<>!NULL !OR !N1<>!NULL) !THEN.
         !IF (!N0<>!NULL !AND !N1<>!NULL) !THEN.
            COMPUTE #N0=!N0.
            COMPUTE #N1=!N1.
            COMPUTE #r=(#N0/#N1).
         !ELSE.
            !IF (!N0<>!NULL) !THEN.
               COMPUTE #N0=!N0.
               COMPUTE #N1=(#N0/#r).
               IF (MOD(#N1,1)<>0) #N1=TRUNC(#N1)+1.
            !ELSE.
               COMPUTE #N1=!N1.
               COMPUTE #N0=#r*#N1.
               IF (MOD(#N0,1)<>0) #N0=TRUNC(#N0)+1.
            !IFEND.
         !IFEND.
      !IFEND.  
*     Compute common results.
      COMPUTE #I=(#I1+#r*#I0)/(#R+1).
      COMPUTE #DArcs= 4*#r*#D*(ARSIN(SQRT(#I1))-ARSIN(SQRT(#I0)))**2.
      COMPUTE #DNorm=#R*#D*(#ID)**2.
      COMPUTE #FLEISS=(#R+1) / (#R*#D*ABS(#ID)).

      COMPUTE #WARNING1 = 0.
      COMPUTE #WARNING2 = 0.
      STRING #TempC (A1).
      COMPUTE #TempC = ' '.
      IF (#I0*#D<0.2 or #I0*#D>0.8 or #I1*#D<0.2 or #I1*#D>0.8) #WARNING1=1.

      PRINT//'Rate of events in: UnExposed (Group 0)=' #I0(F12.6).
      PRINT /'                   Exposed   (Group 1)=' #I1(F12.6).
      PRINT /'                        Mean followup = '!QUOTE(!D).
      PRINT /'                          Ratio N0/N1 = '!QUOTE(!rPrint).
      PRINT /'Minimum expected: IR='#IR(F6.2) ';   ID='#ID(F10.7) .
   
      !IF (!N0=!NULL !AND !N1=!NULL) !THEN.
         !IF (!ALPHA=!NULL !AND !BETA=!NULL) !THEN.
*           Print a table when ALPHA and BETA are defaults.
            !LET !ALPHAdef = '5'.
            !LET !BETAdef  = '20 15 10'.
            !DO !J=0 !TO 1.
               COMPUTE #J=!J.
               !DO !K=1 !TO 2.
                  COMPUTE #K=!K.
                  !DO !A !IN(!ALPHAdef).
                     COMPUTE #Alpha = !A.
                     !DO !B !IN(!BETAdef).
                        COMPUTE #Beta = !B.
                        !GetN2I VarName = !CONCAT('#N',!J,!K,!A,!B).
                     !DOEND.
                  !DOEND.
               !DOEND.
            !DOEND.
*           Compute Totals.
            !DO !K=1 !TO 2.
               !DO !A !IN(!ALPHAdef).
                  !DO !B !IN(!BETAdef).
                     COMPUTE !CONCAT('#N',!K,!A,!B,'A')=!CONCAT('#N0',!K,!A,!B,'A')+!CONCAT('#N1',!K,!A,!B,'A').
                     COMPUTE !CONCAT('#N',!K,!A,!B,'N')=!CONCAT('#N0',!K,!A,!B,'N')+!CONCAT('#N1',!K,!A,!B,'N').
                     COMPUTE !CONCAT('#N',!K,!A,!B,'F')=!CONCAT('#N0',!K,!A,!B,'F')+!CONCAT('#N1',!K,!A,!B,'F').
                  !DOEND.
               !DOEND.
            !DOEND.

*           Print: Two and one-sided test in a table.
            IF (#WARNING1=1 OR #WARNING2=1) #TempC='*'.
            PRINT //'                      |                SAMPLE SIZE                |'.
            PRINT /'         Alpha Risk=5%|    Two-Sided Test   |    One-Sided Test   |'.
            PRINT /' METHOD          Power|   80%    85%    90% |   80%    85%    90% |'.
            PRINT /'----------------------+---------------------+---------------------+'.
            PRINT /' Normal' #TempC(A1) '           n0 |' #N02520N(T24,F6) #N02515N(T31,F6) #N02510N(T38,F6) '|'45 #N01520N(T46,F6) #N01515N(T53,F6) #N01510N(T60,F6) '|'67.
            PRINT /'                   n1 |' #N12520N(T24,F6) #N12515N(T31,F6) #N12510N(T38,F6) '|'45 #N11520N(T46,F6) #N11515N(T53,F6) #N11510N(T60,F6) '|'67.
            PRINT /'                Total |' #N2520N(T24,F6)  #N2515N(T31,F6)  #N2510N(T38,F6)  '|'45 #N1520N(T46,F6)  #N1515N(T53,F6)  #N1510N(T60,F6)  '|'67.
            PRINT /'----------------------+---------------------+---------------------+'.
            PRINT /' Normal corrected  n0 |' #N02520F(T24,F6) #N02515F(T31,F6) #N02510F(T38,F6) '|'45 #N01520F(T46,F6) #N01515F(T53,F6) #N01510F(T60,F6) '|'67.
            PRINT /'                   n1 |' #N12520F(T24,F6) #N12515F(T31,F6) #N12510F(T38,F6) '|'45 #N11520F(T46,F6) #N11515F(T53,F6) #N11510F(T60,F6) '|'67.
            PRINT /'                Total |' #N2520F(T24,F6)  #N2515F(T31,F6)  #N2510F(T38,F6)  '|'45 #N1520F(T46,F6)  #N1515F(T53,F6)  #N1510F(T60,F6)  '|'67.
            PRINT /'----------------------+---------------------+---------------------+'.
            PRINT /' ArcoSinus         n0 |' #N02520A(T24,F6) #N02515A(T31,F6) #N02510A(T38,F6) '|'45 #N01520A(T46,F6) #N01515A(T53,F6) #N01510A(T60,F6) '|'67.
            PRINT /'                   n1 |' #N12520A(T24,F6) #N12515A(T31,F6) #N12510A(T38,F6) '|'45 #N11520A(T46,F6) #N11515A(T53,F6) #N11510A(T60,F6) '|'67.
            PRINT /'                Total |' #N2520A(T24,F6)  #N2515A(T31,F6)  #N2510A(T38,F6)  '|'45 #N1520A(T46,F6)  #N1515A(T53,F6)  #N1510A(T60,F6)  '|'67.
            PRINT /'----------------------+---------------------+---------------------+'.               
         !ELSE.
*           If ALPHA or BETA aren't defaults print a brief output.
            COMPUTE #Alpha = !Alpha.
            COMPUTE #Beta = !Beta.
            !DO !J=0 !TO 1.
               COMPUTE #J=!J.
               !DO !K=1 !TO 2.
                  COMPUTE #K=!K.
                  !GetN2I VarName = !CONCAT('#N',!J,!K).
               !DOEND.
            !DOEND.
*           Compute Totals.
            !DO !K=1 !TO 2.
               COMPUTE !CONCAT('#N',!K,'A')=!CONCAT('#N0',!K,'A')+!CONCAT('#N1',!K,'A').
               COMPUTE !CONCAT('#N',!K,'N')=!CONCAT('#N0',!K,'N')+!CONCAT('#N1',!K,'N').
               COMPUTE !CONCAT('#N',!K,'F')=!CONCAT('#N0',!K,'F')+!CONCAT('#N1',!K,'F').
            !DOEND.
            
            IF (#WARNING1=1 OR #WARNING2=1) #TempC='*'.
            COMPUTE #POWER=100-!BETA.
            PRINT /'Alpha Risk= ' !QUOTE(!ALPHA) '%;  Beta Risk= '!QUOTE(!BETA) '%; Power=' #POWER(F5.1)'%'.
            PRINT //'                      |           SAMPLE SIZE           |'.
            PRINT  /' METHOD               | Two-Sided Test | One-Sided Test |'.
            PRINT  /'----------------------+----------------+----------------+'.
            PRINT  /' Normal' #TempC(A1) 'n0 |'20 #N02N(T28,F7) '|'40 #N01N(T45,F7) '|'57.
            PRINT  /'                   n1 |'     #N12N(T28,F7) '|'40 #N11N(T45,F7) '|'57.
            PRINT  /'                Total |'     #N2N(T28,F7)  '|'40 #N1N(T45,F7)  '|'57.
            PRINT  /'----------------------+----------------+----------------+'.
            PRINT  /' Normal corrected  n0 |'     #N02F(T28,F7) '|'40 #N01F(T45,F7) '|'57.
            PRINT  /'                   n1 |'     #N12F(T28,F7) '|'40 #N11F(T45,F7) '|'57.
            PRINT  /'                Total |'     #N2F(T28,F7)  '|'40 #N1F(T45,F7)  '|'57.
            PRINT  /'----------------------+----------------+----------------+'.
            PRINT  /' ArcoSinus         n0 |'     #N02A(T28,F7) '|'40 #N01A(T45,F7) '|'57.
            PRINT  /'                   n1 |'     #N12A(T28,F7) '|'40 #N11A(T45,F7) '|'57.
            PRINT  /'                Total |'     #N2A(T28,F7)  '|'40 #N1A(T45,F7)  '|'57.
            PRINT  /'----------------------+----------------+----------------+'.
         !IFEND.
      !ELSE.
*        POWER results.
         !LET !AlphaPrint = !Alpha.
         !IF (!Alpha=!NULL) !THEN.
            !LET !AlphaPrint = 5.
         !IFEND.
         COMPUTE #Alpha = !AlphaPrint.
         !DO !K=1 !TO 2.
            COMPUTE #K=!K.
            !GetPower2I VarName = !CONCAT('#Power',!K).
         !DOEND.
         IF (#WARNING1=1 OR #WARNING2=1) #TempC='*'.
         PRINT /'Sample size: n0 = ' #N0(F6) ' ; n1 = ' #N1(F6) ' (Ratio n0/n1 = ' #r(F4.2)')'.
         PRINT /'Alpha Risk= ' !QUOTE(!AlphaPrint) '%'.
         PRINT //'                  |              POWER (%)          |'.
         PRINT  /' METHOD           | Two-Sided Test | One-Sided Test |'.
         PRINT  /'------------------+----------------+----------------+'.
         PRINT  /' Normal' #TempC(A1) '|'19 #Power2N(T26,F4.1) '|'36 #Power1N(T43,F4.1) '|'53.
         PRINT  /' Normal corrected |' #Power2F(T26,F4.1)      '|'36 #Power1F(T43,F4.1) '|'53.
         PRINT  /' ArcoSinus        |' #Power2A(T26,F4.1)      '|'36 #Power1A(T43,F4.1) '|'53.
         PRINT  /'------------------+----------------+----------------+'.
      !IFEND.
      DO IF (#WARNING1=1 or #WARNING2=1).
         PRINT /'(*)WARNING: Applicability conditions for Normal method not granted'.
         DO IF (#WARNING1=1).
            PRINT /'I0*D and I1*D must be >=0.2 and <=0.8'.
         END IF.
         DO IF (#WARNING2=1).
            PRINT /'N0*I0*D, N0*(1-I0*D), N1*I1*D and N1*(1-I1*D) must be >=10'.
         END IF.
      END IF.
   END IF.

!ENDDEFINE.

DEFINE  !GetN2I( VarName = !CHAREND('/')).

   COMPUTE #ZAlpha=IDF.NORMAL((100-#Alpha/#K)/100,0,1).
   COMPUTE #ZBeta=IDF.NORMAL((100-#Beta)/100,0,1).
   
*  Sinusual inverse exact probability of Fisher (Arcosinus method).
   !LET !NArcs = !CONCAT(!VarName,'A').
   COMPUTE !NArcs = #r*(#r+1)*(#ZAlpha+#ZBeta)**2 /#DArcs.
   IF (#J=1) !NArcs=!NArcs/#r.
   IF (MOD(!NArcs,1)<>0) !NArcs = TRUNC(!NArcs)+1.
*  Normal method.
   !LET !NNorm = !CONCAT(!VarName,'N').
   COMPUTE #Num1=#ZAlpha*SQRT((#r+1)*#I).
   COMPUTE #Num2=#ZBeta*SQRT(#I0+#r*#I1).
   COMPUTE !NNorm=(#Num1+#Num2)**2 / #DNorm.
   IF (#J=0) !NNorm=!NNorm*#r.
   IF (MOD(!NNorm,1)<>0) !NNorm=TRUNC(!NNorm)+1.
   DO IF (#J=1).
      IF ((!NNorm*#I1*#D)<10 or (!NNorm*(1-(#I1*#D)))<10) #WARNING2=1.
   ELSE.
      IF ((!NNorm*#I0*#D)<10 or (!NNorm*(1-(#I0*#D)))<10) #WARNING2=1.
   END IF.
*  Normal method with Fleiss correction.
   !LET !NNormF=!CONCAT(!VarName,'F').
   COMPUTE !NNormF=((#Num1+#Num2)**2 / #DNorm) + #FLEISS.
   IF (#J=0) !NNormF=!NNormF*#r.
   IF (MOD(!NNormF,1)<>0) !NNormF=TRUNC(!NNormF)+1.
   
!ENDDEFINE.

DEFINE  !GetPower2I( VarName = !CHAREND('/')).

   COMPUTE #ZAlpha=IDF.NORMAL((100-#Alpha/#K)/100,0,1).
   
*  Sinusual inverse exact probability of Fisher (Arcosinus method).
   !LET !PArc = !CONCAT(!VarName,'A').
   COMPUTE !PArc = 100-((1-CDF.NORMAL(SQR((#N1*#DArcs)/(#r + 1)) - #ZAlpha,0,1))*100).
*  Normal method.
   !LET !PNorm = !CONCAT(!VarName,'N').
   COMPUTE #Num1= SQRT((#r+1)*#I).
   COMPUTE #Num2= SQRT(#I0+#r*#I1).
   COMPUTE !PNorm=100-((1-CDF.NORMAL((SQR(#N1*#DNorm) - #Zalpha*#Num1)/#Num2,0,1))*100).
   IF ((#N0*#I0*#D)<10 or (#N0*(1-(#I0*#D)))<10) #WARNING2=1.
   IF ((#N1*#I1*#D)<10 or (#N1*(1-(#I1*#D)))<10) #WARNING2=1.
*  Normal method with Fleiss correction.
   !LET !PNormF=!CONCAT(!VarName,'F').
   COMPUTE !PNormF=100-((1-CDF.NORMAL((SQR((#N1-#FLEISS)*#DNorm) - #Zalpha*#Num1)/#Num2,0,1))*100).
   
!ENDDEFINE.

****NMa: Auxiliary macro for TYPE=Co1M, Co2P, C2ME (old N2IM, NM2IS, N2IME).
DEFINE  !NMa( SD = !CHAREND('/') /Var = !CHAREND('/') /Type  = !CHAREND('/')
         /EFFECT = !CHAREND('/') /EQLIM = !CHAREND('/') /ALPHA = !CHAREND('/') /BETA = !CHAREND('/') 
              /N = !CHAREND('/') /N0 = !CHAREND('/') /N1 = !CHAREND('/') /r = !CHAREND('/')
            /NST = !CHAREND('/')).

   !IF (!Type='CO1M') !THEN.
      !IF (!N0<>!NULL !OR !N1<>!NULL !OR !r<>!NULL !OR !EQLIM<>!NULL) !THEN.
         COMPUTE #ERROR=3.       /*EQLIM, N0, N1, and r are incompatible with Type=C1M.
      !IFEND.
   !ELSE.
      !IF (!Var=!NULL !AND !SD=!NULL) !THEN.
         COMPUTE #ERROR=5.       /*Missing SD or Var.
      !ELSE.
         !IF (!Var<>!NULL !AND !SD<>!NULL) !THEN.
            COMPUTE #ERROR=7.    /*Too much parameters: Var, SD.
         !ELSE.
            !IF (!Type='CO2M') !THEN.
               !IF (!N<>!NULL !OR !EQLIM<>!NULL) !THEN.
                  COMPUTE #ERROR=10.   /*Too much parameters: N, EQLIM and Type=Co2P.
               !ELSE.
                  !IF (!N1=!NULL !AND !N0=!NULL) !THEN.
                     !IF ((!ALPHA<>!NULL !AND !BETA=!NULL) !OR (!ALPHA=!NULL !AND !BETA<>!NULL)) !THEN.
                        COMPUTE #ERROR=8.    /*Missing ALPHA or BETA.
                     !IFEND.
                  !ELSE.
                     !IF (!N1<>!NULL !AND !N0<>!NULL !AND !r<>!NULL) !THEN.
                        COMPUTE #ERROR=11.    /*Too much parameters: N1, N0, r.
                     !IFEND.
                     !IF (!BETA<>!NULL) !THEN.
                        COMPUTE #ERROR=14.    /*Too much parameters: BETA with N1, N0.
                     !IFEND.
                  !IFEND.
               !IFEND.
            !IFEND.
         !IFEND.
      !IFEND.
   !IFEND.
   !IF (!Type='CO1M' !OR !Type='C2ME') !THEN.
      !IF (!N=!NULL) !THEN.
         !IF ((!ALPHA<>!NULL !AND !BETA=!NULL) !OR (!ALPHA=!NULL !AND !BETA<>!NULL)) !THEN.
            COMPUTE #ERROR=8.    /*Missing ALPHA or BETA.
         !IFEND.
      !ELSE.
         !IF (!BETA<>!NULL) !THEN.
            COMPUTE #ERROR=9.    /*Too much parameters: BETA, N.
         !IFEND.
      !IFEND.
   !IFEND.
   !IF (!Type='CO1M' !OR !Type='CO2M') !THEN.
      !IF (!Effect=!NULL) !THEN.
         COMPUTE #ERROR=6.          /*Missing EFFECT.
      !IFEND.
   !ELSE.
      !IF (!Effect<>!NULL !OR !N0<>!NULL !OR !N1<>!NULL !OR !r<>!NULL) !THEN.
         COMPUTE #ERROR=12.       /*Effect, N0, N1 and r are incompatible with Type=C2ME.
      !ELSE.
         !IF (!EQLIM=!NULL) !THEN.
            COMPUTE #ERROR=13.       /*Missing parameter EQLIM.
         !IFEND.
      !IFEND.   
   !IFEND.
   !TestParameter Param=!SD /Type=5 /ParamName=SD.
   !TestParameter Param=!Var /Type=5 /ParamName=Var.
   !TestParameter Param=!EQLIM /Type=5 /ParamName=EQLIM.
   !TestParameter Param=!EFFECT /Type=10 /ParamName=Effect.
   !TestParameter Param=!ALPHA /Type=3  /ParamName=Alpha.
   !TestParameter Param=!BETA /Type=3  /ParamName=Beta.
   !TestParameter Param=!N /Type=4   /ParamName=N.
   !TestParameter Param=!N0 /Type=4   /ParamName=N0.
   !TestParameter Param=!N1 /Type=4   /ParamName=N1.
   !TestParameter Param=!r /Type=5   /ParamName=r.


   DO IF (#ERROR=1 OR #ERROR=2).
*     Do nothing: TestParameter error.
   ELSE IF (#ERROR=3).
      PRINT /'ERROR: Too much parameters.'
            /'       Parameters EQLIM, N0, N1 and r are incompatible with Type=Co1M. See the HELP.'.
   ELSE IF (#ERROR=4).
      PRINT /'ERROR: Missing parameter Var. See the HELP.'.
   ELSE IF (#ERROR=5).
      PRINT /'ERROR: Missing parameter Var or SD. See the HELP.'.
   ELSE IF (#ERROR=6).
      PRINT /'ERROR: Missing parameter Effect. See the HELP.'.
   ELSE IF (#ERROR=7).
      PRINT /'ERROR: Too much parameters. Parameters Var and SD are incompatible. See the HELP.'.
   ELSE IF (#ERROR=8).
      PRINT /'ERROR: Missing parameter Alpha or Beta. See the HELP.'.
   ELSE IF (#ERROR=9).
      PRINT /'ERROR: Too much parameters. Parameters N and Beta are incompatible. See the HELP.'.
   ELSE IF (#ERROR=10).
      PRINT /'ERROR: Too much parameters. Parameters N and EQLIM are incompatible with Type=Co2M. See the HELP.'.
   ELSE IF (#ERROR=11).
      PRINT /'ERROR: Too much parameters. Parameters N1, N0 and r are incompatible. See the HELP.'.
   ELSE IF (#ERROR=12).
      PRINT /'ERROR: Too much parameters.'
            /'       Parameters Effect, N0, N1 and r are incompatible with Type=C2ME. See the HELP.'.
   ELSE IF (#ERROR=13).
      PRINT /'ERROR: Missing parameter EQLIM. See the HELP.'.
   ELSE IF (#ERROR=14).
      PRINT /'ERROR: Too much parameters. Parameters Beta and N0,N1 are incompatible. See the HELP.'.
   ELSE.
      COMPUTE #Warning=0.
      !IF (!Type='CO2M') !THEN.
         !IF (!N1=!NULL !AND !N0=!NULL) !THEN.
            !IF (!r=!NULL) !THEN.
               COMPUTE #r=1.
            !IFEND.
         !ELSE.
            !IF (!N1<>!NULL !AND !N0<>!NULL !AND !r=!NULL) !THEN.
               COMPUTE #r=#N0/#N1.
            !IFEND.
            !IF (!N1<>!NULL !AND !N0=!NULL !AND !r<>!NULL) !THEN.
               COMPUTE #N0=#r*#N1.
               
            !IFEND.
            !IF (!N1=!NULL !AND !N0<>!NULL !AND !r<>!NULL) !THEN.
               COMPUTE #N1=#N0/#r.
            !IFEND.
            !IF (!N1<>!NULL !AND !N0=!NULL !AND !r=!NULL) !THEN.
               COMPUTE #r=1.
               COMPUTE #N0=#r*#N1.
            !IFEND.
            IF (MOD(#N1,1)<>0) #N1=TRUNC(#N1)+1.
            IF (MOD(#N0,1)<>0) #N0=TRUNC(#N0)+1.
         !IFEND.
      !IFEND.
      !IF (!Var<>!NULL) !THEN.
         COMPUTE #Var=!Var.
      !ELSE.
         COMPUTE #SD = !SD.
         COMPUTE #Var=#SD**2.
      !IFEND.
      
*     Print: Head.
      !IF (!Type='CO1M') !THEN.
         PRINT /'SAMPLE SIZE (MEAN) & POWER DETERMINATION: One sample'.
      !IFEND.
      !IF (!Type='CO2M') !THEN.
         PRINT /'SAMPLE SIZE (MEAN) & POWER DETERMINATION: Two-independent samples'.
      !IFEND.
      !IF (!Type='C2ME') !THEN.
         PRINT /'SAMPLE SIZE (EQUIVALENCE MEANS) & POWER DETERMINATION: Two-independent samples'.
      !IFEND.
      !PrintNST NST=!NST.

      !IF (!Var<>!NULL) !THEN.
         !IF (!Type='CO1M') !THEN.
            PRINT //'Expected variance = '!QUOTE(!Var).
         !ELSE.
            PRINT //'Common variance = '!QUOTE(!Var).
         !IFEND.
      !ELSE.
         PRINT //'Common standard deviation = '!QUOTE(!SD).
      !IFEND.
      !IF (!Effect<>!NULL) !THEN.
         PRINT /'Minimum expected effect size = '!QUOTE(!Effect).
      !ELSE.
         PRINT /'Equivalence limits = '!QUOTE(!EQLIM).
      !IFEND.
      
      !IF (!N=!NULL !AND !N1=!NULL !AND !N0=!NULL) !THEN.
         !IF (!ALPHA=!NULL !AND !BETA=!NULL) !THEN.
*           ALPHA and BETA by default.
            !LET !ALPHAdef = '5'.
            !LET !BETAdef = '20 15 10'.
            !DO !I=1 !TO 2.
               COMPUTE #I=!I
               !DO !A !IN(!ALPHAdef).
                  COMPUTE #Alpha = !A.
                  !DO !B !IN(!BETAdef).
                     COMPUTE #Beta = !B.
                     !GetNm Var=!CONCAT('#N',!I,!A,!B) /Type=!Type /r=!r.
                  !DOEND.
               !DOEND.
            !DOEND.
*           Print table with sample sizes for Alpha, Beta defaults.
            !IF (!Type='CO1M') !THEN.
               PRINT //'             |                 SAMPLE SIZE                 |'.
               PRINT  /'Alpha Risk=5%|     Two-Sided Test   |     One-Sided Test   |'.
               PRINT  /'        Power|    80%    85%    90% |    80%    85%    90% |'.
               PRINT  /'-------------+----------------------+----------------------+'.
               PRINT  /'           n |' #N2520(T15,F6) #N2515(T22,F6) #N2510(T29,F6) '|'37 #N1520(T38,F6) #N1515(T45,F6) #N1510(T52,F6) '|'60.
               PRINT  /'-------------+----------------------+----------------------+'.
            !IFEND.
            !IF (!Type='CO2M') !THEN.
               PRINT /'Ratio N0/N1 = ' #r(F4.2).
               PRINT //'Alpha Risk=5%|     Two-Sided Test   |     One-Sided Test   |'.
               PRINT  /'        Power|    80%    85%    90% |    80%    85%    90% |'.
               PRINT  /'-------------+----------------------+----------------------+'.
               PRINT  /'          n0 |' #N25200(T15,F6) #N25150(T22,F6) #N25100(T29,F6) '|'37 #N15200(T38,F6) #N15150(T45,F6) #N15100(T52,F6) '|'60.
               PRINT  /'          n1 |' #N25201(T15,F6) #N25151(T22,F6) #N25101(T29,F6) '|'37 #N15201(T38,F6) #N15151(T45,F6) #N15101(T52,F6) '|'60.
               PRINT  /'       Total |' #N2520(T15,F6)  #N2515(T22,F6)  #N2510(T29,F6)  '|'37 #N1520(T38,F6)  #N1515(T45,F6)  #N1510(T52,F6)  '|'60.
               PRINT  /'-------------+----------------------+----------------------+'.
            !IFEND.
            !IF (!Type='C2ME') !THEN.
               PRINT //'             |            SAMPLE SIZE by group             |'.
               PRINT  /'Alpha Risk=5%|     Equivalence Test | Non-inferiority Test |'.
               PRINT  /'        Power|    80%    85%    90% |    80%    85%    90% |'.
               PRINT  /'-------------+----------------------+----------------------+'.
               PRINT  /'           n |' #N2520(T15,F6) #N2515(T22,F6) #N2510(T29,F6) '|'37 #N1520(T38,F6) #N1515(T45,F6) #N1510(T52,F6) '|'60.
               PRINT  /'-------------+----------------------+----------------------+'.
            !IFEND.
         !ELSE.
*           Print Sample Size for a given ALPHA and BETA.
            !DO !I=1 !TO 2.
               COMPUTE #I=!I.
*              Get the Sample Size for each method.
               !GetNm Var=!CONCAT('#N',!I) /Type=!Type /r=!r.
            !DOEND.
            COMPUTE #Power=100-#Beta.
            PRINT /'Alpha Risk = '!QUOTE(!Alpha)'%; Beta Risk = '!QUOTE(!Beta)'% (Power =  '#Power(F2)'%)'.
            !IF (!Type='CO1M') !THEN.
               STRING #Note2 #Note1 (A1).
               COMPUTE #Note2=' '.
               COMPUTE #Note1=' '.
               IF (#N2<30) #Note2='*'.
               IF (#N1<30) #Note1='*'.
               PRINT //'SAMPLE SIZE'.
               PRINT  /' Two-Sided Test:  N ='#N2(F7) #Note2(A1).
               PRINT  /' One-Sided Test:  N ='#N1(F7) #Note1(A1).
            !IFEND.
            !IF (!Type='CO2M') !THEN.
               STRING #Note20 #Note10 #Note21 #Note11 (A1).
               COMPUTE #Note20=' '.
               COMPUTE #Note10=' '.
               COMPUTE #Note21=' '.
               COMPUTE #Note11=' '.
               IF (#N20<30) #Note20='*'.
               IF (#N10<30) #Note10='*'.
               IF (#N21<30) #Note21='*'.
               IF (#N11<30) #Note11='*'.
               PRINT /'Ratio N0/N1 = ' #r(F4.2).
               PRINT //'SAMPLE SIZE'.
               PRINT  /'Two-Sided Test       One-Sided Test'.
               PRINT  /'   n0 = '#N20(F6.0) #Note20(A1) 'n0 = '25 #N10(T30,F6.0) #Note10(A1).
               PRINT  /'   n1 = '#N21(F6.0) #Note21(A1) 'n1 = '25 #N11(T30,F6.0) #Note11(A1).
               PRINT  /'Total = ' #N2(T9,F6.0)     'Total = '22 #N1(T30,F6.0).
            !IFEND.
            !IF (!Type='C2ME') !THEN.
               STRING #Note2 #Note1 (A1).
               COMPUTE #Note2=' '.
               COMPUTE #Note1=' '.
               IF (#N2<30) #Note2='*'.
               IF (#N1<30) #Note1='*'.
               COMPUTE #Total2 = #N2*2.
               COMPUTE #Total1 = #N1*2.
               PRINT //'EQUIVALENCE (Two One-Sided Test)'.
               PRINT  /' Size by group:  N =' #N2(F7) #Note2(A1) '  (Total=' #Total2 (F7) ')'.
               PRINT //'NON INFERIORITY (One-Sided Test)'.
               PRINT  /' Size by group:  N =' #N1(F7) #Note1(A1) '  (Total=' #Total1 (F7) ')'.
            !IFEND.
         !IFEND.
      !ELSE.
*        Print POWER for a given N, ALPHA.
         !LET !AlphaPrint = !Alpha.
         !IF (!Alpha=!NULL) !THEN.
            COMPUTE #Alpha=5.
            !LET !AlphaPrint = 5.
         !IFEND.
*        Get the Power for each method.
         !GetPowerM Type=!Type.
         !IF (!Type='CO1M') !THEN.
            STRING #Note (A1).
            COMPUTE #Note=' '.
            IF (#N<30) #Note='*'.
            IF (#N<30) #Warning=1.
            PRINT /'Sample size = ' !QUOTE(!N) #Note(A1).
         !IFEND.
         !IF (!Type='CO2M') !THEN.
            STRING #Note1 #Note0 (A1).
            COMPUTE #Note1=' '.
            COMPUTE #Note0=' '.
            IF (#N0<30) #Note0='*'.
            IF (#N1<30) #Note1='*'.
            IF (#N0<30 or #N1<30) #Warning=1.
            PRINT /'Sample size: n0 = ' #N0(F7) #Note0(A1) '; n1 = ' #N1(F7) #Note1(A1) ' (Ratio N0/N1 = ' #R(F4.2) ')'.
         !IFEND.
         !IF (!Type='C2ME') !THEN.
            STRING #Note (A1).
            COMPUTE #Note=' '.
            IF (#N<30) #Note='*'.
            IF (#N<30) #Warning=1.
            PRINT /'Sample size (by group) = ' !QUOTE(!N) #Note(A1).
         !IFEND.
         PRINT  /'Alpha Risk = ' !QUOTE(!AlphaPrint)'%'.
         PRINT //'POWER'.
         PRINT  /' Two-Sided Test: Pow = ' #Power2(F4.1) '% (Beta Risk = ' #Beta2(F4.1) '%)'.
         PRINT  /' One-Sided Test: Pow = ' #Power1(F4.1) '% (Beta Risk = ' #Beta1(F4.1) '%)'.
      !IFEND.
*     Warning Small Size.
      DO IF (#Warning=1).
         !IF (!ALPHA=!NULL !AND !BETA=!NULL) !THEN.
            PRINT /'WARNING: Normal assumption required for small size (N<30)'.
         !ELSE.
            PRINT /'(*)WARNING: Normal assumption required for small size (N<30)'.
         !IFEND.
      END IF.
   END IF.
!ENDDEFINE.

****NMk: Auxiliary macro for TYPE=CokM (old NkIM).
DEFINE  !NMk( Var = !CHAREND('/') /SD = !CHAREND('/') /N = !CHAREND('/') 
           /Means = !CHAREND('/') /Effect = !CHAREND('/') /c = !CHAREND('/') 
             /NST = !CHAREND('/')).

   !IF (!Var=!NULL !AND !SD=!NULL) !THEN.
      COMPUTE #ERROR=3.       /*Missing SD or Var.
   !ELSE.
      !IF (!Var<>!NULL !AND !SD<>!NULL) !THEN.
         COMPUTE #ERROR=4.    /*Too much parameters: Var, SD.
      !ELSE.
         !IF (!Means=!NULL !AND (!Effect=!NULL !OR !c=!NULL)) !THEN.
            COMPUTE #ERROR=5. /*Missing Means or Effect, c.
         !ELSE.
            !IF (!Means<>!NULL !AND (!Effect<>!NULL !OR !c<>!NULL)) !THEN.
               COMPUTE #ERROR=6. /*Too much parameters: Means, Effect, c.
            !ELSE.
*              Test parameters Means, Effect, c and N.
               !IF (!Means<>!NULL) !THEN.
                  COMPUTE #CountM=0.
                  !DO !M !IN (!Means).
                     COMPUTE #temp = $SYSMIS.
                     COMPUTE #temp = !M.
                     DO IF (SYSMIS(#temp)).
                        COMPUTE #ERROR=7.     /*Parameter Means with wrong value.
                     END IF.
                     COMPUTE #CountM=#CountM+1.
                  !DOEND.
                  IF (#CountM<2) #ERROR=7.
                  !IF (!N<>!NULL) !THEN.
                     COMPUTE #CountN=0.
                     !DO !J !IN (!N).
                        COMPUTE #temp = $SYSMIS.
                        COMPUTE #temp = !J.
                        DO IF (SYSMIS(#temp)).
                           COMPUTE #ERROR=8.             /*Parameter N with wrong value.
                        ELSE.
                           IF (#temp <= 1) #ERROR=8.     /*Parameter N with wrong value.
                           IF (MOD(#temp,1)<>0) #ERROR=9.     /*Parameter N with decimal value.
                        END IF.
                        COMPUTE #CountN=#CountN+1.
                     !DOEND.
                     IF (#CountM<>#CountN) #ERROR=10.    /*There must the same number of elements in Means and N.
                  !ELSE.
                     IF (#CountM>12) #ERROR=11.    /*The maximum number of Means is 12 for Sample Size.
                  !IFEND.
               !ELSE.
                  !IF ((!Effect=!NULL !OR !c=!NULL)) !THEN.
                     COMPUTE #ERROR=12.
                  !ELSE.
                     !IF (!N<>!NULL) !THEN.
                        !TestParameter Param=!N /Type=4  /ParamName=N.
                     !IFEND.
                  !IFEND.               
               !IFEND.
            !IFEND.
         !IFEND.
      !IFEND.
   !IFEND.
   !TestParameter Param=!SD /Type=5  /ParamName=SD.
   !TestParameter Param=!Var /Type=5 /ParamName=Var.
   !TestParameter Param=!c /Type=14  /ParamName=c.
   !TestParameter Param=!Effect /Type=10  /ParamName=Effect.


   DO IF (#ERROR=1 OR #ERROR=2).
*     Do nothing: TestParameter error.
   ELSE IF (#ERROR=3).
      PRINT /'ERROR: Missing parameter Var or SD. See the HELP.'.
   ELSE IF (#ERROR=4).
      PRINT /'ERROR: Too much parameters. Parameters Var and SD are incompatible. See the HELP.'.
   ELSE IF (#ERROR=5).
      PRINT /'ERROR: Missing parameters Means or Effect, c. See the HELP.'.
   ELSE IF (#ERROR=6).
      PRINT /'ERROR: Too much parameters. Parameters Means, Effect and c are incompatible. See the HELP.'.
   ELSE IF (#ERROR=7).
      PRINT /'ERROR: Parameter Means with wrong values. See the HELP.'.
   ELSE IF (#ERROR=8).
      PRINT /'ERROR: Parameter N with wrong values. See the HELP.'.
   ELSE IF (#ERROR=9).
      PRINT /'ERROR: Parameter N with decimal values. See the HELP.'.
   ELSE IF (#ERROR=10).
      PRINT /'ERROR: Parameters Means and N must have the same number of elements. See the HELP.'.
   ELSE IF (#ERROR=11).
      PRINT /'ERROR: For Sample Size results on Pairwise Comparisons the maximum number of '.
      PRINT /'       groups in parameter Means is k=12. See the HELP.'.
   ELSE IF (#ERROR=12).
      PRINT /'ERROR: Missing parameter Effect or c. See the HELP.'.
   ELSE.
*     Print header.
      PRINT /'SAMPLE SIZE (MEAN) & POWER: k-independents samples (ANOVA)'.
      !PrintNST NST=!NST.
      !IF (!Var<>!NULL) !THEN.
         COMPUTE #Var=!Var.
         PRINT //'Common variance = '!QUOTE(!VAR).
      !ELSE.
         COMPUTE #SD = !SD.
         COMPUTE #Var=#SD**2.
         PRINT //'Common standard deviation = '!QUOTE(!SD).
      !IFEND.

      !IF (!Means<>!NULL) !THEN.
*********SIMULTANEOUS COMPARISONS.
         !LET !COUNT = ''.
         !DO !M !IN (!Means).
            !LET !COUNT=!CONCAT(!COUNT,' ').
            COMPUTE !CONCAT('#Mi',!LENGTH(!COUNT)) = !M.    /*Charge in #Min the Means values.
         !DOEND.
         !LET !COUNT=!LENGTH(!COUNT).
         COMPUTE #I=1.
         STRING #Group1 to !CONCAT('#Group',!COUNT) (A2).
         DO REPEAT Group=#Group1 to !CONCAT('#Group',!COUNT).
            DO IF (#I<10).
               COMPUTE Group = CONCAT('0',STRING(#I,F1)).
            ELSE.
               COMPUTE Group = STRING(#I,F2).
            END IF.
            COMPUTE #I=#I+1.
         END REPEAT.
         COMPUTE #J=!COUNT.
         !IF (!N=!NULL) !THEN.
*           SAMPLE SIZE calculations.
            COMPUTE #M= SUM(#Mi1 to !CONCAT('#Mi',!COUNT))/#J.
            COMPUTE #D=0.
            DO REPEAT Mi=#Mi1 to !CONCAT('#Mi',!COUNT).
               COMPUTE #D=#D + (Mi-#M)**2/#Var.
            END REPEAT.
*           The DO IF values come from numeric results.
            DO IF (#J=2).
               COMPUTE #N5.80= TRUNC(1+7.849/#D).
               COMPUTE #N5.85= TRUNC(1+8.976/#D).
               COMPUTE #N5.90= TRUNC(1+10.507/#D).
               COMPUTE #N1.80= TRUNC(1+11.679/#D).
               COMPUTE #N1.85= TRUNC(1+13.048/#D).
               COMPUTE #N1.90= TRUNC(1+14.879/#D).
            ELSE IF (#J=3).
               COMPUTE #N5.80= TRUNC(1+9.635/#D).
               COMPUTE #N5.85= TRUNC(1+10.923/#D).
               COMPUTE #N5.90= TRUNC(1+12.654/#D).
               COMPUTE #N1.80= TRUNC(1+13.881/#D).
               COMPUTE #N1.85= TRUNC(1+15.403/#D).
               COMPUTE #N1.90= TRUNC(1+17.427/#D).
            ELSE IF (#J=4).
               COMPUTE #N5.80= TRUNC(1+10.903/#D).
               COMPUTE #N5.85= TRUNC(1+12.301/#D).
               COMPUTE #N5.90= TRUNC(1+14.171/#D).
               COMPUTE #N1.80= TRUNC(1+15.458/#D).
               COMPUTE #N1.85= TRUNC(1+17.087/#D).
               COMPUTE #N1.90= TRUNC(1+19.247/#D).
            ELSE IF (#J=5).
               COMPUTE #N5.80= TRUNC(1+11.935/#D).
               COMPUTE #N5.85= TRUNC(1+13.422/#D).
               COMPUTE #N5.90= TRUNC(1+15.405/#D).
               COMPUTE #N1.80= TRUNC(1+16.749/#D).
               COMPUTE #N1.85= TRUNC(1+18.466/#D).
               COMPUTE #N1.90= TRUNC(1+20.737/#D).
            ELSE IF (#J=6).
               COMPUTE #N5.80= TRUNC(1+12.828/#D).
               COMPUTE #N5.85= TRUNC(1+14.391/#D).
               COMPUTE #N5.90= TRUNC(1+16.469/#D).
               COMPUTE #N1.80= TRUNC(1+17.869/#D).
               COMPUTE #N1.85= TRUNC(1+19.661/#D).
               COMPUTE #N1.90= TRUNC(1+22.028/#D).
            ELSE IF (#J=7).
               COMPUTE #N5.80= TRUNC(1+13.624/#D).
               COMPUTE #N5.85= TRUNC(1+15.255/#D).
               COMPUTE #N5.90= TRUNC(1+17.419/#D).
               COMPUTE #N1.80= TRUNC(1+18.872/#D).
               COMPUTE #N1.85= TRUNC(1+20.731/#D).
               COMPUTE #N1.90= TRUNC(1+23.182/#D).
            ELSE IF (#J=8).
               COMPUTE #N5.80= TRUNC(1+14.351/#D).
               COMPUTE #N5.85= TRUNC(1+16.042/#D).
               COMPUTE #N5.90= TRUNC(1+18.284/#D).
               COMPUTE #N1.80= TRUNC(1+19.787/#D).
               COMPUTE #N1.85= TRUNC(1+21.707/#D).
               COMPUTE #N1.90= TRUNC(1+24.235/#D).
            ELSE IF (#J=9).
               COMPUTE #N5.80= TRUNC(1+15.022/#D).
               COMPUTE #N5.85= TRUNC(1+16.770/#D).
               COMPUTE #N5.90= TRUNC(1+19.083/#D).
               COMPUTE #N1.80= TRUNC(1+20.635/#D).
               COMPUTE #N1.85= TRUNC(1+22.611/#D).
               COMPUTE #N1.90= TRUNC(1+25.211/#D).
            ELSE IF (#J=10).
               COMPUTE #N5.80= TRUNC(1+15.650/#D).
               COMPUTE #N5.85= TRUNC(1+17.460/#D).
               COMPUTE #N5.90= TRUNC(1+19.829/#D).
               COMPUTE #N1.80= TRUNC(1+21.429/#D).
               COMPUTE #N1.85= TRUNC(1+23.457/#D).
               COMPUTE #N1.90= TRUNC(1+26.123/#D).
            ELSE IF (#J=11).
               COMPUTE #N5.80= TRUNC(1+16.241/#D).
               COMPUTE #N5.85= TRUNC(1+18.090/#D).
               COMPUTE #N5.90= TRUNC(1+20.532/#D).
               COMPUTE #N1.80= TRUNC(1+22.177/#D).
               COMPUTE #N1.85= TRUNC(1+24.254/#D).
               COMPUTE #N1.90= TRUNC(1+26.982/#D).
            ELSE IF (#J=12).
               COMPUTE #N5.80= TRUNC(1+16.802/#D).
               COMPUTE #N5.85= TRUNC(1+18.697/#D).
               COMPUTE #N5.90= TRUNC(1+21.198/#D).
               COMPUTE #N1.80= TRUNC(1+22.886/#D).
               COMPUTE #N1.85= TRUNC(1+25.011/#D).
               COMPUTE #N1.90= TRUNC(1+27.798/#D).
            END IF.
*           Print results.
            PRINT /'Hypothetical Means: '.
            !LET !COUNT=' '.
            !DO !M !IN (!Means).
               PRINT /'   Group ' !CONCAT('#Group',!LENGTH(!COUNT)) '= ' !QUOTE(!M).
               !LET !COUNT=!CONCAT(!COUNT,' ').
            !DOEND.
*           Print a table of sample sizes with default ALPHA and BETA.
            PRINT //'             |             SAMPLE SIZE by group            |'.
            PRINT  /'        Alpha|         Risk=5%      |         Risk=1%      |'.
            PRINT  /'        Power|    80%    85%    90% |    80%    85%    90% |'.
            PRINT  /'-------------+----------------------+----------------------+'.
            PRINT  /'           n |' #N5.80(T15,F6) #N5.85(T22,F6) #N5.90(T29,F6) '|'37 #N1.80(T38,F6) #N1.85(T45,F6) #N1.90(T52,F6) '|'60.
            PRINT  /'-------------+----------------------+----------------------+'.
         !ELSE.
*           POWER calculations.
            COMPUTE #N= 0.
            COMPUTE #M= 0.
            !LET !COUNT = ''.
            !DO !J !IN (!N).
               !LET !COUNT = !CONCAT(!COUNT,' ').
               COMPUTE !CONCAT('#Ni',!LENGTH(!COUNT)) = !J.
               COMPUTE !CONCAT('#NMi',!LENGTH(!COUNT)) = !CONCAT('#Ni',!LENGTH(!COUNT)) * !CONCAT('#Mi',!LENGTH(!COUNT)).
               COMPUTE #N= #N + !CONCAT('#Ni',!LENGTH(!COUNT)).
               COMPUTE #M= #M + !CONCAT('#NMi',!LENGTH(!COUNT)).
            !DOEND.
            !LET !COUNT = !LENGTH(!COUNT).
            COMPUTE #M= #M / #N.
            COMPUTE #D=0.
            DO REPEAT Mi=!Means /Ni=!N.
               COMPUTE #D = #D + Ni*(Mi-#M)**2/#Var.
            END REPEAT.
            COMPUTE #Power1=(1-NCDF.F(IDF.F(1-0.01,#J-1,#N-#J),#J-1,#N-#J, #D))*100.
            COMPUTE #Power5=(1-NCDF.F(IDF.F(1-0.05,#J-1,#N-#J),#J-1,#N-#J, #D))*100.
*           Print results.
            PRINT /'              Means    n'.
            !LET !COUNT=' '.
            !DO !I !IN (!Means).
               !LET !J = !LENGTH(!COUNT).
               PRINT /'Group ' !CONCAT('#Group',!J)(A2) ':' !CONCAT('#Mi',!J)(F10.4) ' ' !CONCAT('#Ni',!J)(F4).
               !LET !COUNT = !CONCAT(!COUNT,' ').
            !DOEND.
            PRINT //'Alpha   Power'.
            PRINT  /'   5%  ' #Power5(F5.1)'%'.
            PRINT  /'   1%  ' #Power1(F5.1)'%'.
         !IFEND.
      !ELSE.
*********PAIRWISE COMPARISONS.
         COMPUTE #Effect = !Effect.
         COMPUTE #c = !c.
         PRINT /'Minimum expected effect size = ' !QUOTE(!Effect).
         PRINT /'Number of pairwise comparisons = ' !QUOTE(!c).

         COMPUTE #Warning=0.
         !IF (!N=!NULL) !THEN.
*           SAMPLE SIZE calculations: ALPHA and BETA by default.
            !LET !ALPHAdef = '5 1'.
            !LET !BETAdef = '20 15 10'.
            !DO !A !IN(!ALPHAdef).
               COMPUTE #ZAlpha = IDF.NORMAL((100-!A/(2*#c))/100,0,1).
               !DO !B !IN(!BETAdef).
                  COMPUTE #ZBeta = IDF.NORMAL((100-!B)/100,0,1).
                  !LET !Vname=!CONCAT('#N',!A,'.',!B).
                  COMPUTE !Vname=2*#Var*(#ZAlpha+#ZBeta)**2/(#Effect)**2.
                  IF (MOD(!Vname,1)<>0) !Vname = TRUNC(!Vname) + 1.
                  IF (!Vname<30) #Warning=1.
               !DOEND.
            !DOEND.
*           Print results.
            PRINT //'             |             SAMPLE SIZE by group            |'.
            PRINT  /'        Alpha|         Risk=5%      |         Risk=1%      |'.
            PRINT  /'        Power|    80%    85%    90% |    80%    85%    90% |'.
            PRINT  /'-------------+----------------------+----------------------+'.
            PRINT  /'           n |' #N5.20(T15,F6) #N5.15(T22,F6) #N5.10(T29,F6) '|'37 #N1.20(T38,F6) #N1.15(T45,F6) #N1.10(T52,F6) '|'60.
            PRINT  /'-------------+----------------------+----------------------+'.
            DO IF (#WARNING=1).
               PRINT /'WARNING: Normal assumption required for small size (N<30)'.
            END IF.
         !ELSE.
*           POWER calculations.
            COMPUTE #N=!N.
            COMPUTE #D= SQRT(#N*#Effect**2/(2*#Var)).
            COMPUTE #zbeta = #D - IDF.NORMAL(1-0.01/(2*#c),0,1).
            COMPUTE #Power1=100 - ((1 - CDF.NORMAL(#zbeta,0,1))*100).
            COMPUTE #zbeta = #D - IDF.NORMAL(1-0.05/(2*#c),0,1).
            COMPUTE #Power5=100 - ((1 - CDF.NORMAL(#zbeta,0,1))*100).
*           Print results.
            PRINT /'Sample size by group = ' !QUOTE(!N).
            PRINT //'Alpha   Power'.
            PRINT  /'   5%  ' #Power5(F5.1)'%'.
            PRINT  /'   1%  ' #Power1(F5.1)'%'.
         !IFEND.
      !IFEND.
   END IF.
!ENDDEFINE.

****EPa: Auxiliary macro for TYPE=EP, EPD (old NP, NPD).
DEFINE  !EPa( P0 = !CHAREND('/') /P1 = !CHAREND('/') /Type = !CHAREND('/')
           /APRE = !CHAREND('/') /ns = !CHAREND('/') /CL = !CHAREND('/') 
              /N = !CHAREND('/') /N0 = !CHAREND('/') /N1 = !CHAREND('/') /r = !CHAREND('/') 
            /NST = !CHAREND('/')).

   !IF (!P0=!NULL) !THEN.
      COMPUTE #ERROR=3.                /*Missing P0.
   !ELSE.
      !IF (!Type='CI1P') !THEN.
         !IF (!P1<>!NULL !OR !N0<>!NULL !OR !N1<>!NULL !OR !r<>!NULL) !THEN.
            COMPUTE #ERROR=4.                /*Too much parameters: P1,N0,N1,r with Type=EP.
         !ELSE.
            !IF (!APRE=!NULL !AND !ns=!NULL) !THEN.
               COMPUTE #ERROR=5.             /*Mising parameter APRE or ns.
            !ELSE.
               !IF (!APRE<>!NULL !AND !ns<>!NULL) !THEN.
                  COMPUTE #ERROR=6.          /*Too much parameters: APRE or ns.
               !IFEND.
            !IFEND.
         !IFEND.
      !IFEND.
      !IF (!Type='CI2P') !THEN.
         !IF (!P1=!NULL) !THEN.
            COMPUTE #ERROR=7.                /*Missing P1.            
         !ELSE.
            !IF (!ns<>!NULL !OR !N<>!NULL) !THEN.
               COMPUTE #ERROR=8.             /*Too much parameters: ns,N with Type=EPD.
            !ELSE.
               !IF (!APRE=!NULL !AND !N1=!NULL) !THEN.
                  COMPUTE #ERROR=9.          /*Missing parameter APRE or N1.
               !ELSE.
                  !IF (!APRE<>!NULL !AND !N1<>!NULL) !THEN.
                     COMPUTE #ERROR=10.       /*Too much parameters: APRE and N1.
                  !ELSE.
                     !IF (!N0<>!NULL !AND !r<>!NULL) !THEN.
                        COMPUTE #ERROR=11.    /*Too much parameters: N0 and r.
                     !IFEND.
                  !IFEND.
               !IFEND.
            !IFEND.
         !IFEND.
      !IFEND.
   !IFEND.
   !TestParameter Param=!P0 /Type=1 /ParamName=P0.
   !TestParameter Param=!P1 /Type=1 /ParamName=P1.
   !TestParameter Param=!APRE /Type=6 /ParamName=APRE /Aux=!P0.
   !TestParameter Param=!ns /Type=4 /ParamName=ns.
   !TestParameter Param=!N /Type=7  /ParamName=N /Aux=!ns.
   !TestParameter Param=!N1 /Type=4  /ParamName=N1.
   !TestParameter Param=!N0 /Type=4  /ParamName=N0.
   !TestParameter Param=!r /Type=5  /ParamName=r.
   !TestParameter Param=!CL /Type=8  /ParamName=CL.

   DO IF (#ERROR=1 OR #ERROR=2).
*     Do nothing: TestParameter error.
   ELSE IF (#ERROR=3).
      PRINT /'ERROR: Missing parameter P0. See the HELP.'.
   ELSE IF (#ERROR=4).
      PRINT /'ERROR: Too much parameters. Parameters P1,N0,N1 and r are incompatible with Type=CI1P. See the HELP.'.
   ELSE IF (#ERROR=5).
      PRINT /'ERROR: Missing parameter APRE or ns. See the HELP.'.
   ELSE IF (#ERROR=6).
      PRINT /'ERROR: Too much parameters. Parameter APRE is incompatible with ns. See the HELP.'.
   ELSE IF (#ERROR=7).
      PRINT /'ERROR: Missing parameter P1. See the HELP.'.
   ELSE IF (#ERROR=8).
      PRINT /'ERROR: Too much parameters. Parameters ns and N are incompatible with Type=CI2P. See the HELP.'.
   ELSE IF (#ERROR=9).
      PRINT /'ERROR: Missing parameter APRE or N1. See the HELP.'.
   ELSE IF (#ERROR=10).
      PRINT /'ERROR: Too much parameters. Parameters APRE and N1 are incompatible. See the HELP.'.
   ELSE IF (#ERROR=11).
      PRINT /'ERROR: Too much parameters. Parameters N0 and r are incompatible. See the HELP.'.
   ELSE.
*     Prepare parameters.
*     Charge APRE values.
      !IF (!APRE<>!NULL) !THEN.
         !LET !COUNT=!NULL.
         !DO !I !IN (!APRE).
            !LET !COUNT=!CONCAT(!COUNT,' ').
         !DOEND.
         !LET !COUNT=!LENGTH(!COUNT).
         !LET !APREn = !CONCAT('#APRE',!COUNT).
         !LET !RPREn = !CONCAT('#RPRE',!COUNT).
         !IF (!COUNT=1) !THEN.
            NUMERIC #APRE1.
            NUMERIC #RPRE1.
         !ELSE.
            NUMERIC #APRE1 to !APREn #RPRE1 to !RPREn.
         !IFEND.
         DO REPEAT APRE0=!APRE /APRE=#APRE1 to !APREn /RPRE=#RPRE1 to !RPREn.
            COMPUTE APRE=APRE0.
            COMPUTE RPRE=(APRE/#P0)*100.
         END REPEAT.
      !IFEND.
      !IF (!Type='CI2P') !THEN.
         !IF (!N1<>!NULL !AND !N0<>!NULL) !THEN.
            COMPUTE #r=#N0/#N1.
         !ELSE.
            !IF (!r=!NULL) !THEN.
               COMPUTE #r=1.
            !IFEND.
            !IF (!N1<>!NULL !AND !N0=!NULL) !THEN.
               COMPUTE #N0=#r*#N1.
            !IFEND.
         !IFEND.
      !IFEND.

*     Print header.
      !IF (!Type='CI1P') !THEN.
         PRINT /'SAMPLE SIZE: Estimation of population proportion'.
      !IFEND.
      !IF (!Type='CI2P') !THEN.
         PRINT /'SAMPLE SIZE: CI of difference between two proportions (independent samples)'.
      !IFEND.
      !PrintNST NST=!NST.

      !IF (!Type='CI1P') !THEN.
         PRINT //'Supposed Population Proportion = '!QUOTE(!P0)'%'. 
         !IF (!ns<>!NULL) !THEN. 
            PRINT /'Sample Size = ' !QUOTE(!ns).
         !IFEND.
         !IF (!N<>!NULL) !THEN.
            PRINT /'Population Size = '!QUOTE(!N).
         !ELSE.
            PRINT /'Population Size = INFINITE'.
            COMPUTE #N=$SYSMIS.
         !IFEND.
      !IFEND.
      !IF (!Type='CI2P') !THEN.
         STRING #Note(A22).
         COMPUTE #Note = ' '.
         IF (#P0=50 AND #P1=50) #Note=' (conservative option)'.
         PRINT//'Supposed proportion of events in Population 0 = '!QUOTE(!P0)'%'#Note(A22).
         PRINT /'Supposed proportion of events in Population 1 = '!QUOTE(!P1)'%'#Note(A22).
         PRINT /'Ratio N0/N1 = ' #r(F5.2).
      !IFEND.
      PRINT /'NORMAL method'.
      PRINT SPACE.

      !IF (!APRE<>!NULL) !THEN.
*        Absolute precission -> from APRE obtain n size.
         !IF (!Type='CI1P') !THEN.
            PRINT /'  PRECISION of CI   |SAMPLE SIZE'.
            !IF (!CL=!NULL) !THEN.
               PRINT /'Relative   Absolute |        Confidence level'.
               PRINT /' ( e/P)      ( e) |      90% |      95% |      99% |'.
               PRINT /'--------------------+----------+----------+----------+'.
            !ELSE.
               PRINT /'Relative   Absolute |Confidence level'.
               PRINT /' ( e/P)      ( e) |        ' !QUOTE(!CL)'%' '|'38.
               PRINT /'--------------------+----------------+'.
            !IFEND.
         !IFEND.
         !IF (!Type='CI2P') !THEN.
            PRINT /'                |NUMBER of subjects'.
            !IF (!CL=!NULL) !THEN.
               PRINT /'PRECISION       |              Confidence level'.
               PRINT /'of CI(d)  Group|      90% |      95% |    97.5% |      99% |'.
               PRINT /'----------------+----------+----------+----------+----------+'.
            !ELSE.
               PRINT /'PRECISION       |Confidence level'.
               PRINT /'of CI(d)  Group|       ' !QUOTE(!CL)'%' '|'34.
               PRINT /'----------------+----------------+'.
            !IFEND.
         !IFEND.
         
         DO REPEAT APRE=#APRE1 to !APREn /RPRE=#RPRE1 to !RPREn.
            !IF (!CL=!NULL) !THEN.
               !GetNe Var=#nSIZE90 /Type=!Type /CL=90 /APRE=APRE.
               !GetNe Var=#nSIZE95 /Type=!Type /CL=95 /APRE=APRE.
               !GetNe Var=#nSIZE97 /Type=!Type /CL=97.5 /APRE=APRE.
               !GetNe Var=#nSIZE99 /Type=!Type /CL=99 /APRE=APRE.
               !IF (!Type='CI1P') !THEN.
                  PRINT /RPRE(T3,F5.2)'%' APRE(T14,F5.2)'%' '|'21 #nSIZE90(T23,F8) '|'32 #nSIZE95(T34,F8) '|'43 #nSIZE99(T45,F8) '|'54.
               !IFEND.
               !IF (!Type='CI2P') !THEN.
                  PRINT / APRE(T1,F8.2)'%' 'n0'14 '|'17 #nSIZE900(T19,F8) '|'28 #nSIZE950(T30,F8) '|'39 #nSIZE970(T41,F8) '|'50 #nSIZE990(T52,F8) '|'61.
                  PRINT /                  'n1'14 '|'17 #nSIZE901(T19,F8) '|'28 #nSIZE951(T30,F8) '|'39 #nSIZE971(T41,F8) '|'50 #nSIZE991(T52,F8) '|'61.
                  PRINT /               'Total'11 '|'17 #nSIZE90(T19,F8) '|'28 #nSIZE95(T30,F8) '|'39 #nSIZE97(T41,F8) '|'50 #nSIZE99(T52,F8) '|'61.
                  PRINT /'----------------+----------+----------+----------+----------+'.
               !IFEND.
            !ELSE.
               !GetNe Var=#nSIZE /Type=!Type /CL=!CL /APRE=APRE.
               !IF (!Type='CI1P') !THEN.
                  PRINT /RPRE(T3,F5.2)'%' APRE(T14,F5.2)'%' '|'21 #nSIZE(T24,F8) '|'38.
               !IFEND.
               !IF (!Type='CI2P') !THEN.
                  PRINT / APRE(T1,F8.2)'%' 'n0'14 '|'17 #nSIZE0(T20,F8) '|'34.
                  PRINT /                  'n1'14 '|'17 #nSIZE1(T20,F8) '|'34.
                  PRINT /               'Total'11 '|'17 #nSIZE(T20,F8)  '|'34.
                  PRINT /'----------------+----------------+'.
               !IFEND.
            !IFEND.
         END REPEAT.
         !IF (!Type='CI1P') !THEN.
            !IF (!CL=!NULL) !THEN.
               PRINT /'--------------------+----------+----------+----------+'.
            !ELSE.
               PRINT /'--------------------+----------------+'.
            !IFEND.
         !IFEND.
      !ELSE.
*        Sample size -> from ns obtain APRE.
         !IF (!Type='CI1P') !THEN.
            PRINT /'        |PRECISION of CI (e)'.
            !IF (!CL=!NULL) !THEN.
               PRINT /' Sample |        Confidence level'.
               PRINT /'   Size |      90% |      95% |      99% |'.
               PRINT /'--------+----------+----------+----------+'.
            !ELSE.
               PRINT /' Sample |Confidence level'.
               PRINT /'   Size |      ' !QUOTE(!CL)'%' '|'26.
               PRINT /'--------+----------------+'.
            !IFEND.
         !IFEND.
         !IF (!Type='CI2P') !THEN.
            PRINT /'             |PRECISION of CI (d)'.
            !IF (!CL=!NULL) !THEN.
               PRINT /'      Sample |          Confidence level'.
               PRINT /'Group   Size |    90% |    95% |  97.5% |    99% |'.
               PRINT /'-------------+--------+--------+--------+--------+'.
            !ELSE.
               PRINT /'      Sample |Confidence level'.
               PRINT /'Group   Size |        ' !QUOTE(!CL)'%' '|'31.
               PRINT /'-------------+----------------+'.
            !IFEND.
         !IFEND.
         
*        Compute of e.
         COMPUTE #nsorig=#ns.
         !IF (!CL=!NULL) !THEN.
            !Gete Var=#e90 /Type=!Type /CL=90.
            !Gete Var=#e95 /Type=!Type /CL=95.
            !Gete Var=#e97 /Type=!Type /CL=97.5.
            !Gete Var=#e99 /Type=!Type /CL=99.
            !IF (!Type='CI1P') !THEN.
               PRINT / #nsorig(F7) '|'9 #e90(T13,F5.2)'%' '|'20 #e95(T24,F5.2)'%' '|'31 #e99(T35,F5.2)'%' '|'42.
               PRINT /'--------+----------+----------+----------+'.
            !IFEND.
            !IF (!Type='CI2P') !THEN.
               PRINT /' n0' #N0(T5,F8) '|'14 #e90(T16,F5.2)'%' '|'23 #e95(T25,F5.2)'%' '|'32 #e97(T34,F5.2)'%' '|'41 #e99(T43,F5.2)'%' '|'50.
               PRINT /' n1' #N1(T5,F8) '|'14 '|'23 '|'32 '|'41 '|'50.
               PRINT /'-------------+--------+--------+--------+--------+'.
            !IFEND.
         !ELSE.
            !Gete Var=#e /Type=!Type /CL=!CL.
            !IF (!Type='CI1P') !THEN.
               PRINT / #nsorig(F7) '|'9 #e(T13,F5.2)'%' '|'26.
               PRINT /'--------+----------------+'.
            !IFEND.
            !IF (!Type='CI2P') !THEN.
               PRINT /' n0' #N0(T5,F8) '|'14 #e(T20,F5.2)'%' '|'31 .
               PRINT /' n1' #N1(T5,F8) '|'14 '|'31 .
               PRINT /'-------------+----------------+'.
            !IFEND.
         !IFEND.
      !IFEND.
   END IF.
   
!ENDDEFINE.

****EMa: Auxiliary macro for TYPE=EM, EMD (old NM, NMD).
DEFINE  !EMa( SD = !CHAREND('/') /Var = !CHAREND('/') /Type = !CHAREND('/')
           /APRE = !CHAREND('/') /ns = !CHAREND('/') /CL = !CHAREND('/') 
              /N = !CHAREND('/') /N0 = !CHAREND('/') /N1 = !CHAREND('/') /r = !CHAREND('/') 
            /NST = !CHAREND('/')).

   !IF (!SD=!NULL !AND !Var=!NULL) !THEN.
      COMPUTE #ERROR=3.                /*Missing SD or Var.
   !ELSE.
      !IF (!SD<>!NULL !AND !Var<>!NULL) !THEN.
         COMPUTE #ERROR=4.             /*Too much parameters: SD and Var.
      !ELSE.
         !IF (!Type='CI1M') !THEN.
            !IF (!N0<>!NULL !OR !N1<>!NULL !OR !r<>!NULL) !THEN.
               COMPUTE #ERROR=5.       /*Too much parameters: N0,N1,r with Type=EM.
            !ELSE.
               !IF (!APRE=!NULL !AND !ns=!NULL) !THEN.
                  COMPUTE #ERROR=6.             /*Mising parameter APRE or ns.
               !ELSE.
                  !IF (!APRE<>!NULL !AND !ns<>!NULL) !THEN.
                     COMPUTE #ERROR=7.          /*Too much parameters: APRE or ns.
                  !IFEND.
               !IFEND.
            !IFEND.
         !IFEND.
         !IF (!Type='CI2M') !THEN.
            !IF (!ns<>!NULL !OR !N<>!NULL) !THEN.
               COMPUTE #ERROR=8.            /*Too much parameters: ns,N with Type=EMD.
            !ELSE.
               !IF (!APRE=!NULL !AND !N1=!NULL) !THEN.
                  COMPUTE #ERROR=9.     /*Missing parameter APRE or N1.
               !ELSE.
                  !IF (!APRE<>!NULL !AND !N1<>!NULL) !THEN.
                     COMPUTE #ERROR=10.       /*Too much parameters: APRE and N1.
                  !ELSE.
                     !IF (!N0<>!NULL !AND !r<>!NULL) !THEN.
                        COMPUTE #ERROR=11.    /*Too much parameters: N0 and r.
                     !IFEND.
                  !IFEND.
               !IFEND.
            !IFEND.
         !IFEND.
      !IFEND.
   !IFEND.
   !TestParameter Param=!SD /Type=5 /ParamName=SD.
   !TestParameter Param=!Var /Type=5 /ParamName=Var.
   !TestParameter Param=!APRE /Type=9 /ParamName=APRE /Aux=0.
   !TestParameter Param=!ns /Type=4 /ParamName=ns.
   !TestParameter Param=!N /Type=7  /ParamName=N /Aux=!ns.
   !TestParameter Param=!N1 /Type=4  /ParamName=N1.
   !TestParameter Param=!N0 /Type=4  /ParamName=N0.
   !TestParameter Param=!r /Type=5  /ParamName=r.
   !TestParameter Param=!CL /Type=8  /ParamName=CL.

   DO IF (#ERROR=1 OR #ERROR=2).
*     Do nothing: TestParameter error.
   ELSE IF (#ERROR=3).
      PRINT /'ERROR: Missing parameter SD or Var. See the HELP.'.
   ELSE IF (#ERROR=4).
      PRINT /'ERROR: Too much parameters. Parameters SD and Var are incompatible. See the HELP.'.
   ELSE IF (#ERROR=5).
      PRINT /'ERROR: Too much parameters. Parameters N0,N1 and r are incompatible with Type=CI1M. See the HELP.'.
   ELSE IF (#ERROR=6).
      PRINT /'ERROR: Missing parameter APRE or ns. See the HELP.'.
   ELSE IF (#ERROR=7).
      PRINT /'ERROR: Too much parameters. Parameters APRE and ns are incompatible. See the HELP.'.
   ELSE IF (#ERROR=8).
      PRINT /'ERROR: Too much parameters. Parameters ns and N are incompatible with Type=CI2M. See the HELP.'.
   ELSE IF (#ERROR=9).
      PRINT /'ERROR: Missing parameter APRE or N1. See the HELP.'.
   ELSE IF (#ERROR=10).
      PRINT /'ERROR: Too much parameters. Parameters APRE and N1 are incompatible. See the HELP.'.
   ELSE IF (#ERROR=11).
      PRINT /'ERROR: Too much parameters. Parameters N0 and r are incompatible. See the HELP.'.
   ELSE.
*     Prepare parameters.
      !IF (!SD=!NULL) !THEN.
         COMPUTE #SD=SQRT(#VAR).
      !IFEND.
*     Charge APRE values.
      !IF (!APRE<>!NULL) !THEN.
         !LET !COUNT=!NULL.
         !DO !I !IN (!APRE).
            !LET !COUNT=!CONCAT(!COUNT,' ').
         !DOEND.
         !LET !COUNT=!LENGTH(!COUNT).
         !LET !APREn = !CONCAT('#APRE',!COUNT).
         !IF (!COUNT=1) !THEN.
            NUMERIC #APRE1.
         !ELSE.
            NUMERIC #APRE1 to !APREn.
         !IFEND.
         DO REPEAT APRE0=!APRE /APRE=#APRE1 to !APREn.
            COMPUTE APRE=APRE0.
         END REPEAT.
      !IFEND.
      !IF (!Type='CI2M') !THEN.
         !IF (!N1<>!NULL !AND !N0<>!NULL) !THEN.
            COMPUTE #r=#N0/#N1.
         !ELSE.
            !IF (!r=!NULL) !THEN.
               COMPUTE #r=1.
            !IFEND.
            !IF (!N1<>!NULL !AND !N0=!NULL) !THEN.
               COMPUTE #N0=#r*#N1.
            !IFEND.
         !IFEND.
      !IFEND.
      
*     Print header.
      !IF (!Type='CI1M') !THEN.
         PRINT /'SAMPLE SIZE: Estimation of population mean'.
      !IFEND.
      !IF (!Type='CI2M') !THEN.
         PRINT /'SAMPLE SIZE: Difference between two means (independent samples)'.
      !IFEND.
      !PrintNST NST=!NST.

      !IF (!SD<>!NULL) !THEN.
         PRINT //'Supposed Standard Deviation = '!QUOTE(!SD).
      !IFEND.
      !IF (!Var<>!NULL) !THEN.
         PRINT //'Supposed Variance = '!QUOTE(!VAR).
      !IFEND.
      !IF (!Type='CI1M') !THEN.
         !IF (!ns<>!NULL) !THEN. 
            PRINT /'Sample Size = ' !QUOTE(!ns).
         !IFEND.
         !IF (!N<>!NULL) !THEN.
            PRINT /'Population Size = '!QUOTE(!N).
         !ELSE.
            PRINT /'Population Size = INFINITE'.
            COMPUTE #N=$SYSMIS.
         !IFEND.
      !IFEND.
      !IF (!Type='CI2M') !THEN.
         PRINT /'Ratio N0/N1 = ' #r(F5.2).
      !IFEND.
      PRINT /'NORMAL method.'.
      PRINT SPACE.

      !IF (!APRE<>!NULL) !THEN.              /*Absolute precission -> from APRE obtain n size.
         !IF (!Type='CI1M') !THEN.
            PRINT /'          |SAMPLE SIZE'.
            !IF (!CL=!NULL) !THEN.
               PRINT /'PRECISION |        Confidence level'.
               PRINT /'of CI(e) |      90% |      95% |      99% |'.
               PRINT /'----------+----------+----------+----------+'.
            !ELSE.
               PRINT /'PRECISION |Confidence level'.
               PRINT /'of CI(e) |      ' !QUOTE(!CL)'%' '|'28.
               PRINT /'----------+----------------+'.
            !IFEND.
         !ELSE.
            PRINT /'                |NUMBER of subjects'.
            !IF (!CL=!NULL) !THEN.
               PRINT /'PRECISION       |              Confidence level'.
               PRINT /'of CI(d)  Group|      90% |      95% |    97.5% |      99% |'.
               PRINT /'----------------+----------+----------+----------+----------+'.
            !ELSE.
               PRINT /'PRECISION       |Confidence level'.
               PRINT /'of CI(d)  Group|       ' !QUOTE(!CL)'%' '|'34.
               PRINT /'----------------+----------------+'.
            !IFEND.
         !IFEND.

*        Compute of n SIZE. 
         DO REPEAT APRE=#APRE1 to !APREn.
            !IF (!CL=!NULL) !THEN.
               !GetNe Var=#nSIZE90 /Type=!Type /CL=90 /APRE=APRE.
               !GetNe Var=#nSIZE95 /Type=!Type /CL=95 /APRE=APRE.
               !GetNe Var=#nSIZE97 /Type=!Type /CL=97.5 /APRE=APRE.
               !GetNe Var=#nSIZE99 /Type=!Type /CL=99 /APRE=APRE.
               !IF (!Type='CI1M') !THEN.
                  PRINT / APRE(T5,F5.2) '|'11 #nSIZE90(T13,F8) '|'22 #nSIZE95(T24,F8) '|'33 #nSIZE99(T35,F8) '|'44.
               !ELSE.
                  PRINT / APRE(T1,F8.2) 'n0'14 '|'17 #nSIZE900(T19,F8) '|'28 #nSIZE950(T30,F8) '|'39 #nSIZE970(T41,F8) '|'50 #nSIZE990(T52,F8) '|'61.
                  PRINT /               'n1'14 '|'17 #nSIZE901(T19,F8) '|'28 #nSIZE951(T30,F8) '|'39 #nSIZE971(T41,F8) '|'50 #nSIZE991(T52,F8) '|'61.
                  PRINT /            'Total'11 '|'17 #nSIZE90(T19,F8) '|'28 #nSIZE95(T30,F8) '|'39 #nSIZE97(T41,F8) '|'50 #nSIZE99(T52,F8) '|'61.
                  PRINT /'----------------+----------+----------+----------+----------+'.
               !IFEND.
            !ELSE.
               !GetNe Var=#nSIZE /Type=!Type /CL=!CL /APRE=APRE.
               !IF (!Type='CI1M') !THEN.
                  PRINT / APRE(T5,F5.2) '|'11 #nSIZE(T14,F8) '|'28.
               !ELSE.
                  PRINT / APRE(T1,F8.2) 'n0'14 '|'17 #nSIZE0(T20,F8) '|'34.
                  PRINT /               'n1'14 '|'17 #nSIZE1(T20,F8) '|'34.
                  PRINT /            'Total'11 '|'17 #nSIZE(T20,F8)  '|'34.
                  PRINT /'----------------+----------------+'.
               !IFEND.
            !IFEND.
         END REPEAT.
         !IF (!Type='CI1M') !THEN.
            !IF (!CL=!NULL) !THEN.
               PRINT /'----------+----------+----------+----------+'.
            !ELSE.
               PRINT /'----------+----------------+'.
            !IFEND.
         !IFEND.
      !ELSE.
         !IF (!Type='CI1M') !THEN.
            PRINT /'        |PRECISION of CI (e)'.
            !IF (!CL=!NULL) !THEN.
               PRINT /' Sample |        Confidence level'.
               PRINT /'   Size |      90% |      95% |      99% |'.
               PRINT /'--------+----------+----------+----------+'.
            !ELSE.
               PRINT /' Sample |Confidence level'.
               PRINT /'   Size |      ' !QUOTE(!CL)'%' '|'26.
               PRINT /'--------+----------------+'.
            !IFEND.
         !ELSE.
            PRINT /'             |PRECISION of CI (d)'.
            !IF (!CL=!NULL) !THEN.
               PRINT /'      Sample |          Confidence level'.
               PRINT /'Group   Size |    90% |    95% |  97.5% |    99% |'.
               PRINT /'-------------+--------+--------+--------+--------+'.
            !ELSE.
               PRINT /'      Sample |Confidence level'.
               PRINT /'Group   Size |      ' !QUOTE(!CL)'%' '|'31.
               PRINT /'-------------+----------------+'.
            !IFEND.
         !IFEND.

*        Compute of e.
         COMPUTE #nsorig=#ns.
         !IF (!CL=!NULL) !THEN.
            !Gete Var=#e90 /Type=!Type /CL=90.
            !Gete Var=#e95 /Type=!Type /CL=95.
            !Gete Var=#e97 /Type=!Type /CL=97.5.
            !Gete Var=#e99 /Type=!Type /CL=99.
            !IF (!Type='CI1M') !THEN.
               PRINT / #nsorig(F7) '|'9 #e90(T11,F7.2) '|'20 #e95(T22,F7.2) '|'31 #e99(T33,F7.2) '|'42.
               PRINT /'--------+----------+----------+----------+'.
            !ELSE.
               PRINT /' n0' #N0(T5,F8) '|'14 #e90(T16,F6.2) '|'23 #e95(T25,F6.2) '|'32 #e97(T34,F6.2) '|'41 #e99(T43,F6.2) '|'50.
               PRINT /' n1' #N1(T5,F8) '|'14 '|'23 '|'32 '|'41 '|'50.
               PRINT /'-------------+--------+--------+--------+--------+'.
            !IFEND.
         !ELSE.
            !Gete Var=#e /Type=!Type /CL=!CL.
            !IF (!Type='CI1M') !THEN.
               PRINT / #nsorig(F7) '|'9 #e(T11,F7.2) '|'26.
               PRINT /'--------+----------------+'.
            !ELSE.
               PRINT /' n0' #N0(T5,F8) '|'14 #e(T19,F8.2) '|'31 .
               PRINT /' n1' #N1(T5,F8) '|'14 '|'31 .
               PRINT /'-------------+----------------+'.
            !IFEND.
         !IFEND.
      !IFEND.
   END IF.

!ENDDEFINE.

****Cora: Auxiliary macro for TYPE=Co1C, Co2C (old NCor).
DEFINE  !Cora( R0 = !CHAREND('/') /R = !CHAREND('/') /R1 = !CHAREND('/') /EFFECT = !CHAREND('/') /Type = !CHAREND('/')
           /ALPHA = !CHAREND('/') /BETA = !CHAREND('/') /N0 = !CHAREND('/') /N1 = !CHAREND('/') 
            /NST = !CHAREND('/')).

   !IF (!R0=!NULL !AND !Type<>'CO1C') !THEN.
      COMPUTE #ERROR=3.                      /*Missing R0.
   !ELSE.
      !IF (!EFFECT=!NULL !AND !R1=!NULL) !THEN.
         COMPUTE #ERROR=4.                   /*Missing EFFECT or R1.
      !ELSE.
         !IF (!R1<>!NULL !AND !EFFECT<>!NULL) !THEN.
            COMPUTE #ERROR=5.                /*Too much parameters: EFFECT or R1.
         !IFEND.
      !IFEND.
      !IF (!N1=!NULL !AND !N0=!NULL) !THEN.
         !IF ((!ALPHA<>!NULL !AND !BETA=!NULL) !OR (!ALPHA=!NULL !AND !BETA<>!NULL)) !THEN.
            COMPUTE #ERROR=6.          /*Missing parameter ALPHA or BETA.
         !IFEND.
      !ELSE.
         !IF (!BETA<>!NULL) !THEN.
            COMPUTE #ERROR=7.          /*Too much parameters: BETA or N1,N0.
         !IFEND.
         !IF (!TYPE='CO1C' !AND !N0<>!NULL) !THEN.
            COMPUTE #ERROR=8.          /*Too much parameters: N0 with TYPE=Co1C.
         !IFEND.
         !IF (!TYPE='CO2C' !AND (!N0=!NULL !OR !N1=!NULL)) !THEN.
            COMPUTE #ERROR=9.          /*Missing parameters: N1 or N0.
         !IFEND.
      !IFEND.
   !IFEND.
   !IF (!Type='CO1C') !THEN.
      !IF (!R=!NULL) !THEN.
         COMPUTE #ERROR=11.                      /*Missing P.
      !ELSE.
         !IF (!R0<>!NULL) !THEN.
            COMPUTE #ERROR=12.                   /*Too much parameters P0 with Type = Co1P.
         !IFEND.
      !IFEND.
   !IFEND.
   !IF (!Type='CO1C') !THEN.
      !TestParameter Param=!R /Type=11 /ParamName=R.
      !TestParameter Param=!EFFECT /Type=12 /ParamName=Effect /Aux=!R.
   !ELSE.
      !TestParameter Param=!R0 /Type=11 /ParamName=R0.
      !TestParameter Param=!EFFECT /Type=12 /ParamName=Effect /Aux=!R0.
   !IFEND.
   !TestParameter Param=!R1 /Type=11 /ParamName=R1.
   !TestParameter Param=!ALPHA /Type=3 /ParamName=Alpha.
   !TestParameter Param=!BETA /Type=3 /ParamName=Beta.
   !TestParameter Param=!N0 /Type=13 /ParamName=N0.
   !TestParameter Param=!N1 /Type=13 /ParamName=N1.

   !IF (!Effect = !NULL) !THEN.
      !IF (!Type='CO1C') !THEN.
         COMPUTE #Effect = !R - !R0.
      !ELSE.
         COMPUTE #Effect = !R1 - !R0.
      !IFEND.
      IF (#ERROR=0 AND (#Effect <= -1 OR #Effect >= 1)) #ERROR = 10.
   !IFEND.

   DO IF (#ERROR=1 OR #ERROR=2).
*     Do nothing: there's been a TestParameter error, the macro must stop here.
   ELSE IF (#ERROR=3).
      PRINT /'ERROR: Missing parameter R0. See the HELP.'.
   ELSE IF (#ERROR=4).
      PRINT /'ERROR: Missing parameter R1 or Effect. See the HELP.'.
   ELSE IF (#ERROR=5).
      PRINT /'ERROR: Too much parameters. Parameter R1 is incompatible with Effect. See the HELP.'.
   ELSE IF (#ERROR=6).
      PRINT /'ERROR: Missing parameter Alpha or Beta. See the HELP.'.
   ELSE IF (#ERROR=7).
      PRINT /'ERROR: Too much parameters. Parameter Beta is incompatible with N1,N0. See the HELP.'. 
   ELSE IF (#ERROR=8).
      PRINT /'ERROR: Too much parameters. Parameter N0 is incompatible with TYPE=Co1C. See the HELP.'.
   ELSE IF (#ERROR=9).
      PRINT /'ERROR: Missing parameter N1 or N0. See the HELP.'. 
   ELSE IF (#ERROR=10).
      !IF (!Type='CO1C') !THEN.
         PRINT /'ERROR: Parameter R or EFFECT with wrong value. See the HELP.'. 
      !ELSE.
         PRINT /'ERROR: Parameter R1 or EFFECT with wrong value. See the HELP.'. 
      !IFEND.
   ELSE IF (#ERROR=11).
      PRINT /'ERROR: Missing parameter R. See the HELP.'.
   ELSE IF (#ERROR=12).
      PRINT /'ERROR: Too much parameters. Parameter R0 is incompatible with TYPE=Co1C. See the HELP.'.
   ELSE.
*     Prepare parameters.
      !IF (!Type='CO1C') !THEN.
         COMPUTE #R0= !R.
      !ELSE.
         COMPUTE #R0= !R0.
      !IFEND.
      !IF (!EFFECT<>!NULL) !THEN.
         COMPUTE #Effect = !EFFECT.
         COMPUTE #R1 = #Effect + #R0.
      !ELSE.
         COMPUTE #R1 = !R1.
         COMPUTE #Effect = #R1 - #R0.
      !IFEND.
      COMPUTE #FZR0= 0.5*LN((1+#R0)/(1-#R0)).
      COMPUTE #FZR1= 0.5*LN((1+#R1)/(1-#R1)).

*     Print header.
      !IF (!Type='CO1C') !THEN.
         PRINT /'SAMPLE SIZE & POWER DETERMINATION: One correlation coefficient'.
      !IFEND.
      !IF (!Type='CO2C') !THEN.
         PRINT /'SAMPLE SIZE & POWER DETERMINATION: Two correlation coefficients'.
      !IFEND.
      !PrintNST NST=!NST.

      !IF (!Type='CO1C') !THEN.
         PRINT//'Correlation in a Reference Population R  = ' #R0 (F6.4).
         PRINT /'Correlation in a Sample               R1 = ' #R1(F6.4).
         !IF (!N1<>!NULL) !THEN.
            PRINT /'                                      N1 =  ' !QUOTE(!N1).
         !IFEND.
         PRINT /'Minimum expected effect size       (R1-R)= ' #Effect(F6.4).
         COMPUTE #OneTwo=1.
      !IFEND.
      !IF (!Type='CO2C') !THEN.
         PRINT//'Correlation in a Sample 0        R0 = ' #R0 (F6.4).
         !IF (!N0<>!NULL) !THEN.
            PRINT /'                                 N0 =  ' !QUOTE(!N0).
         !IFEND.
         PRINT /'Correlation in a Sample 1        R1 = ' #R1(F6.4).
         !IF (!N1<>!NULL) !THEN.
            PRINT /'                                 N1 =  ' !QUOTE(!N1).
         !IFEND.
         PRINT /'Minimum expected effect size (R1-R0)= ' #Effect(F6.4).
         COMPUTE #OneTwo=2.
      !IFEND.
      
      !IF (!N1=!NULL !AND !N0=!NULL) !THEN.
         !IF (!ALPHA=!NULL !AND !BETA=!NULL) !THEN.
*           Print a table when ALPHA and BETA are defaults.
            !LET !ALPHAdef = '5'.
            !LET !BETAdef  = '20 15 10'.
            !DO !I=1 !TO 2.
               COMPUTE #I=!I.
               !DO !A !IN(!ALPHAdef).
                  !DO !B !IN(!BETAdef).
                     COMPUTE #I=!I.
                     COMPUTE #Alpha = !A.
                     COMPUTE #Beta = !B.
                     !GetNCor Var=!CONCAT('#N',!I,!A,!B) /Type=!Type.
                  !DOEND.
               !DOEND.
            !DOEND.
*           Print: Two and one-sided test in a table.
            !IF (!Type='CO1C') !THEN.
               PRINT //'             |                 SAMPLE SIZE                 |'.
            !ELSE.
               PRINT //'             |            SAMPLE SIZE by group             |'.
            !IFEND.
            PRINT /'Alpha Risk=5%|     Two-Sided Test   |     One-Sided Test   |'.
            PRINT /'        Power|    80%    85%    90% |    80%    85%    90% |'.
            PRINT /'-------------+----------------------+----------------------+'.
            PRINT /'           n |' #N2520(T15,F6) #N2515(T22,F6) #N2510(T29,F6) '|'37 #N1520(T38,F6) #N1515(T45,F6) #N1510(T52,F6) '|'60.
            PRINT /'-------------+----------------------+----------------------+'.
         !ELSE.
            COMPUTE #Alpha = !Alpha.
            COMPUTE #Beta = !Beta.
            COMPUTE #I=1.
            !GetNCor Var=!CONCAT('#N1') /Type=!Type.
            COMPUTE #I=2.
            !GetNCor Var=!CONCAT('#N2') /Type=!Type.
*           Print results.
            COMPUTE #Power = 100 - #Beta.
            PRINT /'Alpha Risk = ' !QUOTE(!Alpha) '%'.
            PRINT /'Beta Risk  = ' !QUOTE(!Beta) '% (Power = ' #Power(F5.2) '%)'.

            !IF (!Type='CO1C') !THEN.
               PRINT  //'SAMPLE SIZE'.
            !ELSE.
               PRINT  //'SAMPLE SIZE by group'.
            !IFEND.
            PRINT  /' Two-Sided Test:  N =' #N2(F7).
            PRINT  /' One-Sided Test:  N =' #N1(F7).
         !IFEND.
      !ELSE.
         !LET !AlphaPrint = 5.
         COMPUTE #Alpha = 5.
         !IF (!Alpha <> !NULL) !THEN.
            COMPUTE #Alpha = !Alpha.
            !LET !AlphaPrint = !Alpha.
         !IFEND.
         !GetPowerCor Type=!Type /N1=!N1 /N0=!N0.
*        Print.
         PRINT /'Alpha Risk = ' !QUOTE(!AlphaPrint) '%'.

         PRINT //'POWER'.
         PRINT  /' Two-Sided Test: Power= ' #Power2(F4.1)'%'.
         PRINT  /' One-Sided Test: Power= ' #Power1(F4.1)'%'.
      !IFEND.
   END IF.

!ENDDEFINE.

****GetNcor: Auxiliary macro to compute Sample Sizes - correlation coefficients.
DEFINE !GetNcor( Var = !CHAREND('/') /Type = !CHAREND('/')).
   COMPUTE #ZAlfa= IDF.NORMAL((100-#Alpha/#I)/100,0,1).
   COMPUTE #ZBeta= IDF.NORMAL((100-#Beta)/100,0,1).
*  Sinusual inverse exact probability of Fisher (Arcosinus method).
   COMPUTE !Var= #OneTwo*((#ZAlfa+#ZBeta)/(#FZR1-#FZR0))**2 + 3. 
   IF (MOD(!Var,1)<>0) !Var=TRUNC(!Var)+1.
!ENDDEFINE.

****GetNcor: Auxiliary macro to compute POWER - correlation coefficients.
DEFINE !GetPowerCor( Type = !CHAREND('/') /N1 = !CHAREND('/') /N0 = !CHAREND('/')).

   COMPUTE #N1=!N1.
   COMPUTE #ZAlpha1= IDF.NORMAL((100-#Alpha)/100,0,1).
   COMPUTE #ZAlpha2= IDF.NORMAL((100-#Alpha/2)/100,0,1).
   !IF (!Type='CO1C') !THEN.
      COMPUTE #ZBeta1= (#FZR1-#FZR0)/SQRT(1/(#N1-3))- #ZAlpha1.
      COMPUTE #ZBeta2= ABS((#FZR1-#FZR0)/SQRT(1/(#N1-3)))- #ZAlpha2.

*      METHOD DISABLED.
*      COMPUTE #FZalfa1= 0.5*ln(IDF.F((100-#alpha)/100,#n1-2,#n1-2)).
*      COMPUTE #FZalfa2= 0.5*ln(IDF.F((100-#alpha/2)/100,#n1-2,#n1-2)).
*      COMPUTE #Zbeta1= (ABS(#FZr1-#FZR)-#FZalfa1)*SQRT(#n1-3).
*      COMPUTE #Zbeta2= (ABS(#FZr1-#FZR)-#FZalfa2)*SQRT(#n1-3).
   !ELSE.
      COMPUTE #N0=!N0.
      COMPUTE #ZBeta1= (#FZR1-#FZR0)/SQRT(1/(#N0-3)+ 1/(#N1-3)) - #ZAlpha1.
      COMPUTE #ZBeta2= ABS((#FZR1-#FZR0)/SQRT(1/(#N0-3)+ 1/(#N1-3))) - #ZAlpha2.
   !IFEND.
   COMPUTE #Power1= CDF.NORMAL(#ZBeta1,0,1)*100.
   COMPUTE #Power2= CDF.NORMAL(#ZBeta2,0,1)*100.
!ENDDEFINE.

****GetNp: Auxiliary macro to compute Sample Sizes - proportions.
DEFINE !GetNp( Var = !CHAREND('/') /Method = !CHAREND('/') /Type = !CHAREND('/')).

   !IF (!Type<>'C2PE') !THEN.
      COMPUTE #ZALPHA=IDF.NORMAL((100-#ALPHA/#I)/100,0,1).
      COMPUTE #ZBETA=IDF.NORMAL((100-#BETA)/100,0,1).
   !ELSE.
      COMPUTE #ZALPHA=IDF.NORMAL((100-#ALPHA)/100,0,1).
      COMPUTE #ZBETA=IDF.NORMAL((100-#BETA/#I)/100,0,1).
   !IFEND.

   !IF (!Type='CO1P') !THEN.   
      DO IF (!Method='Arcs').
         COMPUTE #DArcs = 4*(ARSIN(SQRT(#P1/100))-ARSIN(SQRT(#P0/100)))**2.
         COMPUTE !Var=(#ZALPHA+#ZBETA)**2/#DArcs.
      ELSE IF (!Method='Norm').
         COMPUTE !Var=(#ZALPHA*SQRT(#P0/100*(1-#P0/100))+#ZBETA*SQRT(#P1/100*(1-#P1/100)))**2/((#EFFECT/100)**2).
      ELSE IF (!Method='NormC').
         COMPUTE !Var=(#ZALPHA*SQRT(#P0/100*(1-#P0/100))+#ZBETA*SQRT(#P1/100*(1-#P1/100)))**2/((#EFFECT/100)**2) + 2/ABS(#EFFECT/100).
      END IF.
   !IFEND.
   !IF (!Type='CO2P') !THEN.
      COMPUTE #r=1.
      DO IF (!Method='Arcs').
         COMPUTE #DArcs=(4*#r)*(ARSIN(SQRT(#P1/100))-ARSIN(SQRT(#P0/100)))**2.
         COMPUTE !Var=(#r)*(#r+1)*(#ZALPHA+#ZBETA)**2/#DArcs.
      ELSE IF (!Method='Norm').
         COMPUTE #Ppond=(#P1/100+#r*#P0/100)/(#r+1).
         COMPUTE #N1=#ZALPHA*SQRT((#r+1)*#Ppond*(1-#Ppond)).
         COMPUTE #N2=#ZBETA*SQRT((#P0/100*(100-#P0)/100) + #r*(#P1/100*(100-#P1)/100)).
         COMPUTE !Var=(#N1+#N2)**2/(#r*((#EFFECT/100)**2)).
      ELSE IF (!Method='NormC').
         COMPUTE #Ppond=(#P1/100+#r*#P0/100)/(#r+1).
         COMPUTE #N1=#ZALPHA*SQRT((#r+1)*#Ppond*(1-#Ppond)).
         COMPUTE #N2=#ZBETA*SQRT((#P0/100*(100-#P0)/100) + #r*(#P1/100*(100-#P1)/100)).
         COMPUTE !Var=(#N1+#N2)**2/(#r*((#EFFECT/100)**2)) + (#r+1)/(#r*ABS(#EFFECT/100)).
      END IF.
   !IFEND.
   !IF (!Type='C2PE') !THEN.
      !LET !Var1=!CONCAT(!Var,1).
      !LET !Var0=!CONCAT(!Var,0).
      COMPUTE !Var1=2*(#P0*(1-#P0)*(#ZALPHA+#ZBETA)**2)/(#EQLIM**2).
******ARCOSINUS METHOD DISABLED.
*     COMPUTE #DArcs =2*(ARSIN(SQRT(#P0+#EQLIM))-ARSIN(SQRT(#P0)))**2.
*     COMPUTE !Var1=(#ZALPHA+#ZBETA)**2/#DArcs.
      IF (MOD(!Var1,1)<>0) !Var1 = TRUNC(!Var1)+1.
      COMPUTE !Var0=!Var1.
      COMPUTE !Var=!Var1+!Var0.
   !IFEND.
   IF (MOD(!Var,1)<>0) !Var=TRUNC(!Var)+1.

*  Check Warnings.
   !IF (!Type<>'C2PE') !THEN.
      IF (!Method='Norm' AND ((!Var*#P1/100)<10 or (!Var*(1-#P1/100))<10)) #WARNING2=1.
      IF (!Method='Norm' AND ((!Var*#P0/100)<10 or (!Var*(1-#P0/100))<10)) #WARNING2=1.
   !IFEND.
   
!ENDDEFINE.

****GetNm: Auxiliary macro to compute Sample Sizes - means.
DEFINE !GetNm( Var = !CHAREND('/') /Type = !CHAREND('/') /r = !CHAREND('/')).

   !IF (!Type<>'C2ME') !THEN.
      COMPUTE #ZAlpha=IDF.NORMAL((100-#Alpha/#I)/100,0,1).
      COMPUTE #ZBeta=IDF.NORMAL((100-#Beta)/100,0,1).
   !ELSE.
      COMPUTE #ZAlpha=IDF.NORMAL((100-#Alpha)/100,0,1).
      COMPUTE #ZBeta=IDF.NORMAL((100-#Beta/#I)/100,0,1).
   !IFEND.

   !IF (!Type='CO1M' !OR !Type='C2ME') !THEN.
      !IF (!Type='CO1M') !THEN.
         COMPUTE !Var=#Var*(#ZAlpha+#ZBeta)**2/(#Effect)**2.
      !ELSE.
         COMPUTE !Var=2*#Var*(#ZAlpha+#ZBeta)**2/(#EQLIM)**2.
      !IFEND.
      IF (MOD(!Var,1)<>0) !Var=TRUNC(!Var)+1.
      IF (!Var<30) #Warning=1.
   !ELSE.
      !LET !Var1 = !CONCAT(!Var,1).
      !LET !Var0 = !CONCAT(!Var,0).
      COMPUTE !Var1=(#r+1)*#Var*(#Zalpha+#Zbeta)**2/(#r*(#Effect)**2).
      COMPUTE !Var0=!Var1*#r.
      IF (MOD(!Var1,1)<>0) !Var1=TRUNC(!Var1)+1.
      IF (MOD(!Var0,1)<>0) !Var0=TRUNC(!Var0)+1.
      IF (!Var1<30 OR !Var0<30) #Warning=1.
      COMPUTE !Var = !Var1 + !Var0.
   !IFEND.

!ENDDEFINE.

****GetNe: Auxiliary macro to compute Sample Sizes - estimation of proportions.
DEFINE !GetNe( Var = !CHAREND('/')  /Type = !CHAREND('/') /CL = !CHAREND('/') /APRE = !CHAREND('/')).

   COMPUTE #Z=IDF.NORMAL((!CL+100)/200,0,1).
   COMPUTE #APRE=!APRE.
   !IF (!Type='CI1P' !OR !Type='CI1M') !THEN.
      !IF (!Type='CI1P') !THEN.
         COMPUTE !Var=((#Z**2)*(#P0/100)*(1-(#P0/100)))/((#APRE/100)**2).
      !ELSE.
         COMPUTE !Var=((#Z*#SD)/#APRE)**2.
      !IFEND.
      IF (NOT SYSMIS(#N)) !Var=!Var/(1+!Var/#N).    /*Population not INFINITE.
      IF (MOD(!Var,1)<>0) !Var=TRUNC(!Var)+1.
   !IFEND.
   !IF (!Type='CI2P' !OR !Type='CI2M') !THEN.
      !LET !Var1=!CONCAT(!Var,1).
      !IF (!Type='CI2P') !THEN.
         COMPUTE !Var1=(#Z/#APRE)**2*((#r*#P0*(100-#P0)+#P1*(100-#P1))/#r).
      !ELSE.
         COMPUTE !Var1=(((#Z*#SD)/#APRE)**2)*((#r+1)/#r).
      !IFEND.
      IF (MOD(!Var1,1)<>0) !Var1=TRUNC(!Var1)+1.
      !LET !Var0=!CONCAT(!Var,0).
      COMPUTE !Var0=#r*!Var1.
      IF (MOD(!Var0,1)<>0) !Var0=TRUNC(!Var0)+1.
      COMPUTE !Var = !Var1+!Var0.
   !IFEND.

!ENDDEFINE.

****Gete: Auxiliary macro to compute precission of CI.
DEFINE !Gete( Var = !CHAREND('/')  /Type = !CHAREND('/') /CL = !CHAREND('/')).
   
   COMPUTE #Z=IDF.NORMAL((!CL+100)/200,0,1).
   !IF (!Type='CI1P' !OR !Type='CI1M') !THEN.
      COMPUTE #nscor = #ns.
      IF (NOT SYSMIS(#N)) #nscor=#ns/(1-(#ns/#N)).    /*Population not INFINITE.
      !IF (!Type='CI1P') !THEN.
         COMPUTE !Var=#Z*SQR((#P0/100)*(1-(#P0/100))/#nscor)*100 .
      !ELSE.
         COMPUTE !Var=(#Z*#SD)/SQRT(#nscor).
      !IFEND.
   !IFEND.
   !IF (!Type='CI2P' !OR !Type='CI2M') !THEN.
      !IF (!Type='CI2P') !THEN.
         COMPUTE !Var=#Z*SQR((#r*#P0*(100-#P0)+#P1*(100-#P1))/(#r*#N1)).
      !ELSE.
         COMPUTE !Var=(#Z*#SD)*SQRT((#r+1)/(#r*#N1)).
      !IFEND.
   !IFEND.

!ENDDEFINE.

****GetPowerP: Auxiliary macro to compute Power (Co1P,Co2P).
DEFINE !GetPowerP( Var = !CHAREND('/') /Method = !CHAREND('/') /Type = !CHAREND('/')).

   !IF (!Type<>'C2PE') !THEN.
      COMPUTE #ZAlpha=IDF.NORMAL((100-#Alpha/#I)/100,0,1).
   !ELSE.
      COMPUTE #ZAlpha=IDF.NORMAL((100-#Alpha)/100,0,1).
   !IFEND.

   !IF (!Type='CO1P') !THEN.
      DO IF (!Method='Arcs').
         COMPUTE #DA=4*(ARSIN(SQRT(#P1/100))-ARSIN(SQRT(#P0/100)) )**2.
         COMPUTE !Var=100-((1-CDF.NORMAL(SQR(#N*#DA) - #ZALPHA,0,1))*100).
      ELSE IF (!Method='Norm').
         COMPUTE #N0=SQRT(#P0/100*(1-#P0/100)).
         COMPUTE #N1=SQRT(#P1/100*(1-#P1/100)).
         COMPUTE !Var=100-((1-CDF.NORMAL((SQR(#N*((#EFFECT/100)**2)) - #ZALPHA*#N0)/#N1,0,1))*100).
      ELSE IF (!Method='NormC').
         COMPUTE #N0=SQRT(#P0/100*(1-#P0/100)).
         COMPUTE #N1=SQRT(#P1/100*(1-#P1/100)).
         COMPUTE !Var=100-((1-CDF.NORMAL((SQR((#N-2/ABS(#EFFECT/100))*((#EFFECT/100)**2)) - #ZALPHA*#N0)/#N1,0,1))*100).
      END IF.
   !IFEND.
   !IF (!Type='CO2P') !THEN.
      COMPUTE #r=1.
      DO IF (!Method='Arcs').
         COMPUTE #DA=(4*#r)*(ARSIN(SQRT(#P1/100))-ARSIN(SQRT(#P0/100)) )**2.
         COMPUTE !Var=100-((1-CDF.NORMAL(SQR((#N*#DA)/(#r+1)) - #ZALPHA,0,1))*100).
      ELSE IF (!Method='Norm').
         COMPUTE #Ppond=(#P1/100 + #r*#P0/100)/(#r+1).
         COMPUTE #N0= SQRT((#r+1)*#Ppond*(1-#Ppond)).
         COMPUTE #N1= SQRT( (#P0/100)*(1-#P0/100) + #r*(#P1/100)*(1-#P1/100)).
         COMPUTE !Var=100-((1-CDF.NORMAL((SQR(#N*(#r*(#EFFECT/100)**2)) - #ZALPHA*#N0)/#N1,0,1))*100).
      ELSE IF (!Method='NormC').
         COMPUTE #Ppond=(#P1/100 + #r*#P0/100)/(#r+1).
         COMPUTE #N0= SQRT((#r+1)*#Ppond*(1-#Ppond)).
         COMPUTE #N1= SQRT( (#P0/100)*(1-#P0/100) + #r*(#P1/100)*(1-#P1/100) ).
         COMPUTE !Var=100-((1-CDF.NORMAL((SQR((#N-(#r+1)/(#r*ABS(#EFFECT/100)))*(#r*(#EFFECT/100)**2)) - #ZALPHA*#N0)/#N1,0,1))*100).
      END IF.
   !IFEND.
   !IF (!Type='C2PE') !THEN.
      COMPUTE !Var = (#I*CDF.NORMAL(ABS(#EQLIM)/SQRT(#P0*(1-#P0)*(2/#N)) - #ZAlpha,0,1) - (#I-1))*100.
******ARCOSINUS METHOD DISABLED.
*     COMPUTE #temp = IDF.NORMAL((100-#ALPHA/#I)/100,0,1) - 2*ABS(ARSIN(SQRT(#P0+#EQLIM))-ARSIN(SQRT(#P0)))/SQRT(2/#N).
*     COMPUTE #POWERA = (1 - CDF.NORMAL(#temp,0,1))*100.
   !IFEND.
   
!ENDDEFINE.

****GetPowerM: Auxiliary macro to compute Power (C1M, C2M).
DEFINE !GetPowerM( Var = !CHAREND('/') /Type = !CHAREND('/')).

   COMPUTE #ZAlpha1=IDF.NORMAL((100-#Alpha/1)/100,0,1).
   COMPUTE #ZAlpha2=IDF.NORMAL((100-#Alpha/2)/100,0,1).
   !IF (!Type='CO1M' !OR !Type='CO2M') !THEN.
      !IF (!Type='CO1M') !THEN.
         COMPUTE #temp = (#N*((#Effect)**2))/(#Var).
      !ELSE.
         COMPUTE #temp = (#N1*#r*(#Effect)**2)/((#r+1)*#Var).
      !IFEND.
      COMPUTE #ZBeta1 = SQR(#temp) - #ZAlpha1.
      COMPUTE #Beta1 = (1 - CDF.NORMAL(#ZBeta1,0,1))*100.
      COMPUTE #ZBeta2 = SQR(#temp) - #ZAlpha2.
      COMPUTE #Beta2 = (1 - CDF.NORMAL(#ZBeta2,0,1))*100.
   !ELSE.
      COMPUTE #temp = SQR((#N*((#EQLIM)**2))/(2*#Var)) - #ZAlpha1.
      COMPUTE #Beta1 = (1 - CDF.NORMAL(#temp,0,1))*100.
      COMPUTE #Beta2 = #Beta1*2.
   !IFEND.
   COMPUTE #Power1 = 100 - #Beta1.
   COMPUTE #Power2 = 100 - #Beta2.
!ENDDEFINE.

****TestParameter: Auxiliary macro to test the parameters.
DEFINE !TestParameter( Param = !CHAREND('/') /Type = !CHAREND('/') /ParamName = !CHAREND('/') /Aux = !CHAREND('/')).

   DO IF (#ERROR=0).          /*If there's a previous error, do not execute the test.
      COMPUTE #Type = !Type.
      !LET !TempVar = !CONCAT('#',!ParamName).
      COMPUTE !TempVar = $SYSMIS.
      !IF (!Param<>!NULL) !THEN.
         !IF (!Type<>6 !AND !Type<>9) !THEN.
            COMPUTE !TempVar=!Param.
            DO IF (SYSMIS(!TempVar)).
               COMPUTE #ERROR = 1.
            ELSE.
               IF (#Type=1 AND (!TempVar<=0 OR !TempVar>=100)) #ERROR=1. /*Test Proportion.
               COMPUTE #aux=$SYSMIS.
               !IF (!Type=2) !THEN.
                  COMPUTE #aux=!TempVar + !Aux.
               !IFEND.
               IF (#Type=2 AND (!TempVar=0 OR #aux<=0 OR #aux>=100)) #ERROR=1.   /*Test EFFECT.
               IF (#Type=10 AND !TempVar=0) #ERROR=1.                    /*Test EQLIM.
               IF (#Type=3 AND (!TempVar<=0 OR !TempVar>=50)) #ERROR=1.   /*Test ALPHA or BETA.
               IF (#Type=4 AND (!TempVar<=1)) #ERROR=1.                  /*Test N, N1, N0, ns.
               IF (#Type=4 AND (MOD(!TempVar,1)<>0)) #ERROR=2.           /*Test N, N1, N0, ns (decimal value).
               IF (#Type=5 AND (!TempVar<=0)) #ERROR=1.                  /*Test Var, SD, r.
               DO IF (#Type=7).
                  COMPUTE #aux=1.
                  !IF (!Aux<>!NULL) !THEN.
                     COMPUTE #aux=!Aux.
                  !IFEND.
                  IF (!TempVar<=#aux) #ERROR=1.                          /*Test N (using ns).
                  IF (MOD(!TempVar,1)<>0) #ERROR=2.                      /*Test N, N1, N0 (decimal value).
               END IF.
               IF (#Type=8 AND (!TempVar<50 OR !TempVar>=100)) #ERROR=1. /*Test CL.
               IF (#Type=11 AND (!TempVar<=-1 OR !TempVar>=1)) #ERROR=1. /*Test R0,R1.
               !IF (!Type=12) !THEN.
                  COMPUTE #temp= !TempVar + !Aux.
                  IF (#temp<=-1 OR #temp>=1 OR !TempVar>=1) #ERROR=1.    /*Test Effect correlation.
               !IFEND.
               IF (#Type=13 AND (!TempVar<=3)) #ERROR=1.                  /*Test N1, N0 correlation.
               IF (#Type=13 AND (MOD(!TempVar,1)<>0)) #ERROR=2.           /*Test N1, N0 correlation (decimal value).
               IF (#Type=14 AND !TempVar<=0) #ERROR=1.                    /*Test c.
               IF (#Type=14 AND (MOD(!TempVar,1)<>0)) #ERROR=2.           /*Test c (decimal value).
               IF (#Type=15 AND !TempVar<=1) #ERROR=1.                    /*Test ODR.
               IF (#Type=16 AND (!TempVar<1)) #ERROR=1.                   /*Test r.
               IF (#Type=16 AND (MOD(!TempVar,1)<>0)) #ERROR=2.           /*Test r (decimal value).
               IF (#Type=17 AND (!TempVar<=0 OR !TempVar>50)) #ERROR=1.   /*Test ALPHA or BETA (Type=Co2R, Co2I).
            END IF.
         !ELSE.
   *        Test APRE (using P0).
            COMPUTE #aux=!Aux.
            DO REPEAT APRE=!Param.
               COMPUTE #temp=$SYSMIS.
               COMPUTE #temp=APRE.
               DO IF (SYSMIS(#temp)).
                  COMPUTE #ERROR=1.
               ELSE.
                  IF (#temp<=0) #ERROR=1.
                  IF (#Type=6 AND ((#aux-#temp)<=0 OR (#aux+#temp)>=100)) #ERROR=1.
               END IF.
            END REPEAT.
         !IFEND.
   
      *  Print ERROR messages.
         DO IF (#ERROR=1).
            PRINT /'ERROR: Parameter ' !QUOTE(!ParamName) ' with wrong value. See the HELP.'.
         ELSE IF (#ERROR=2).
            PRINT /'ERROR: Parameter ' !QUOTE(!ParamName) ' with decimal value. See the HELP.'.
         END IF.
      !IFEND.
   END IF.
!ENDDEFINE.

****PrintNST: Auxiliary macro to print the NST.
DEFINE !PrintNST( NST = !CHAREND('/')).
*  Print NST if available.
   !IF (!NST !NE !NULL) !THEN .
      STRING #NST (A131).
      COMPUTE #NST = CONCAT('STUDY: ',!NST).
      PRINT /#NST.
   !IFEND.
!ENDDEFINE.

****PrintHELP: Auxiliary macro to print the different TYPEs HELP.
DEFINE !PrintHELP( Type = !CHAREND('/') /Version = !CHAREND('/') /tested = !CHAREND('/')).
   !IF (!Type='CO1P') !THEN.
      PRINT /'********************************************************************************'
            /'* SAMPLE SIZE & POWER: Comparison of one proportion to a reference (non equal) *'
            /'* Last revised ' !VERSION                                                     '*'80
            /'* (c) JM.Domenech & R.Granero                                                  *'
            /'* Programmer: R.Sesma                                                          *'
            /'*                                                                              *'
            /'* Macro Call ' !tested                                                        '*'80
            /'* !NSize Type = Co1P                                                           *'
            /'*           P = Proportion(%)of events in reference population  (0 < P  < 100) *'
            /'*        {/P1 = Proportion(%)of events in sample                (0 < P1 < 100) *'
            /'*  or /Effect}= Minimum expected effect size(%)                (Effect = P1-P) *'
            /'* ***Parameters for SAMPLE SIZE computations-----------------------------------*'
            /'*     [/Alpha]= Alpha risk(%); by default: 5                   (0< Alpha<= 50) *'
            /'*     [ /Beta]= Beta  risk(%); by default: 20 15 10            (0< Beta <= 50) *'
            /'* ***Parameters for POWER computations-----------------------------------------*'
            /'*          /N = Sample Size                                    (N integer > 1) *'
            /'*     [/Alpha]= Alpha risk(%); by default: 5                   (0< Alpha<= 50) *'
            /'*                                                                              *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements   *'
            /'*                                                                              *'
            /'* Samples of calls:                                                            *'
            /'* !NSize Type=Co1P /HELP.                                                      *'
            /'* !NSize Type=Co1P /P=30 /P1=50.                                               *'
            /'* !NSize Type=Co1P /P=5  /Effect=-1 /Alpha=5 /Beta=15 /NST="Name of the Study".*'
            /'* !NSize Type=Co1P /P=40 /Effect=15 /N=80 /Alpha=5 .                           *'
            /'********************************************************************************'.
   !IFEND.
   !IF (!Type='CO2P') !THEN.
      PRINT /'********************************************************************************'
            /'* SAMPLE SIZE & POWER: Comparison of two proportions (non equal)               *'
            /'* Last revised ' !VERSION                                                     '*'80
            /'* (c) JM.Domenech & R.Granero                                                  *'
            /'* Programmer: R.Sesma                                                          *'
            /'*                                                                              *'
            /'* Macro Call ' !tested                                                        '*'80
            /'* !NSize Type = Co2P                                                           *'  
            /'*          P0 = Proportion(%) of events in reference group      (0 < P0 < 100) *'
            /'*        {/P1 = Proportion(%) of events in new group            (0 < P1 < 100) *'
            /'*  or /Effect}= Minimum expected effect size(%)               (Effect = P1-P0) *'
            /'* ***Parameters for SAMPLE SIZE computations-----------------------------------*'
            /'*     [/Alpha]= Alpha risk(%); by default: 5                   (0< Alpha<= 50) *'
            /'*     [ /Beta]= Beta  risk(%); by default: 20 15 10            (0< Beta <= 50) *'
            /'* ***Parameters for POWER computations-----------------------------------------*'
            /'*          /N = Sample Size                                    (N integer > 1) *'
            /'*     [/Alpha]= Alpha risk(%); by default: 5                   (0< Alpha<= 50) *'
            /'*                                                                              *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements   *'
            /'*                                                                              *'
            /'* Samples of calls:                                                            *'
            /'* !NSize Type=Co2P /HELP.                                                      *'
            /'* !NSize Type=Co2P /P0=30 /Effect=20 .                                         *'
            /'* !NSize Type=Co2P /P0=6 /Effect=2 /Alpha=5 /Beta=15 /NST="Name of the Study". *'
            /'* !NSize Type=Co2P /P0=4 /Effect=3 /N=600 /Alpha=5.                            *'
            /'********************************************************************************'.
   !IFEND.
   !IF (!Type='CO1M') !THEN.
      PRINT /'********************************************************************************'
            /'* SAMPLE SIZE (MEAN) & POWER: Hypothesis testing with Z test for One mean      *'
            /'* Last revised ' !VERSION                                                     '*'80
            /'* (c) JM.Domenech & R.Granero                                                  *'
            /'* Programmer: R.Sesma                                                          *'
            /'*                                                                              *'
            /'* Macro Call ' !tested                                                        '*'80
            /'* !NSize Type = Co1M                                                           *'
            /'*        {/SD = Common standard deviation                  (SD > 0)            *'
            /'*     or /Var}= Expected variance*                         (Var > 0)           *'
            /'*     /Effect = Minimum expected effect size               (Effect <> 0)       *'
            /'* ***Parameters for SAMPLE SIZE computations-----------------------------------*'
            /'*     [/Alpha]= Alpha risk(%); by default: 5               (0 < Alpha <=50)    *'
            /'*      [/Beta]= Beta  risk(%); by default: 20 15 10        (0 < Beta  <=50)    *'
            /'* ***Parameters for POWER computations-----------------------------------------*'
            /'*          /N = Sample Size by group                       (N integer > 1)     *'
            /'*     [/Alpha]= Alpha risk(%); by default: 5               (0 < Alpha <=50)    *'
            /'*                                                                              *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements   *'
            /'*(*)Computation for pooled estimated from 2 samples:                           *'
            /'*   Var= [(n0-1)*Var0 + (n1-1)*Var1]/(n0+n1-2)                                 *'
            /'*                                                                              *'
            /'* Samples of calls:                                                            *'
            /'*  !NSize Type=Co1M /HELP.                                                     *'
            /'*  !NSize Type=Co1M /Var=6 /Effect=2.5.                                        *'
            /'*  !NSize Type=Co1M /Var=100 /Effect=6 /Alpha=5 /Beta=20 /NST="Study Name".    *'
            /'*  !NSize Type=Co1M /SD=10 /Effect=6 /Alpha=5 /N=68.                           *'
            /'********************************************************************************'.
   !IFEND.
   !IF (!Type='CO2M') !THEN.
      PRINT /'********************************************************************************'
            /'* SAMPLE SIZE (MEAN) & POWER: Two-independent samples                          *'
            /'* Last revised ' !VERSION                                                     '*'80
            /'* (c) JM.Domenech                                                              *'
            /'* Programmer: R.Sesma                                                          *'
            /'*                                                                              *'
            /'* Macro Call ' !tested                                                        '*'80
            /'* !NSize Type = Co2M                                                           *'
            /'*        {/SD = Common standard deviation of Groups 0 and 1  (SD > 0)          *'
            /'*     or /Var}= Common variance of Groups 0 and 1            (Var > 0)         *'
            /'*     /Effect = Minimum expected effect size                 (Effect <> 0)     *'
            /'*         [/r]= Ratio N0/N1; by default:1                    (r  > 0 )         *'
            /'* ***Parameters for SAMPLE SIZE computations-----------------------------------*'
            /'*     [/Alpha]= Alpha risk(%); by default: 5                 (0 < Alpha <=50)  *'
            /'*      [/Beta]= Beta  risk(%); by default: 20 15 10          (0 < Beta  <=50)  *'
            /'* ***Parameters for POWER computations-----------------------------------------*'
            /'*     [/Alpha]= Alpha risk(%); by default: 5                 (0 < Alpha <=50)  *'
            /'*         /N1 = Sample Size (Group 1)                        (N1 integer > 0)  *'
            /'*        [/N0]= Sample Size (Group 0);  by default: r*N1     (N0 integer > 0)  *'
            /'*                                                                              *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements   *'
            /'*                                                                              *'
            /'* Samples of calls:                                                            *'
            /'*  !NSize Type=Co2M /HELP.                                                     *'
            /'*  !NSize Type=Co2M /SD=10 /Effect=6 /r=1.5.                                   *'
            /'*  !NSize Type=Co2M /Var=100 /Effect=6 /Alpha=5 /Beta=15 /NST="Study Name".    *'
            /'*  !NSize Type=Co2M /SD=10 /Effect=6 /Alpha=10 /N0=55 /N1=37.                  *'
            /'********************************************************************************'.
   !IFEND.
   !IF (!Type='C2PE') !THEN.
      PRINT /'********************************************************************************'
            /'* SAMPLE SIZE (EQUIVALENCE PROPORTIONS) & POWER: Two-independent samples       *'
            /'* Last revised ' !VERSION                                                     '*'80
            /'* (c) JM.Domenech & R.Granero                                                  *'
            /'* Programmer: R.Sesma                                                          *'
            /'*                                                                              *'
            /'* Macro Call ' !tested                                                        '*'80
            /'* !NSize Type = C2PE                                                           *'
            /'*          P0 = Expected percentage of successes             (0 < P0 < 100)    *'
            /'*      /EQLIM = Equivalence limits*                          (EQLIM <> 0)      *'
            /'* ***Parameters for SAMPLE SIZE computations-----------------------------------*'
            /'*     [/Alpha]= Alpha risk(%); by default: 5                 (0 < Alpha <=50)  *'
            /'*      [/Beta]= Beta  risk(%); by default: 20 15 10          (0 < Beta  <=50)  *'
            /'* ***Parameters for POWER computations-----------------------------------------*'
            /'*     [/Alpha]= Alpha risk(%); by default: 5                 (0 < Alpha <=50)  *'
            /'*          /N = Sample Size (by group)                       (N integer > 0)   *'
            /'*                                                                              *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements   *'
            /'*   (*) If a low percentage of successes corresponds lower efficacy,           *'
            /'*       EQLIM must be negative.                                                *'
            /'*                                                                              *'
            /'* Samples of calls:                                                            *'
            /'* !NSize Type=C2PE /HELP.                                                      *'
            /'* !NSize Type=C2PE /P0=25 /EQLIM=-4.                                           *'
            /'* !NSize Type=C2PE /P0=25 /EQLIM=-4 /ALPHA=5 /BETA=20 /NST="Name of the Study".*'
            /'* !NSize Type=C2PE /P0=25 /EQLIM=-4 /ALPHA=5 /N=60.                            *'
            /'********************************************************************************'.
   !IFEND.
   !IF (!Type='C2ME') !THEN.
      PRINT /'********************************************************************************'
            /'* SAMPLE SIZE (EQUIVALENCE MEANS) & POWER: Two-independent samples             *'
            /'* Last revised ' !VERSION                                                     '*'80
            /'* (c) JM.Domenech & R.Granero                                                  *'
            /'* Programmer: R.Sesma                                                          *'
            /'*                                                                              *'
            /'* Macro Call ' !tested                                                        '*'80
            /'* !NSize Type = C2ME                                                           *'
            /'*         {SD = Common standard deviation                    (SD > 0)          *'
            /'*     or /Var}= Common variance estimated(1)                 (Var > 0)         *'
            /'*      /EQLIM = Equivalence limits                           (EQLIM > 0)       *'
            /'* ***Parameters for SAMPLE SIZE computations-----------------------------------*'
            /'*     [/Alpha]= Alpha risk(%); by default: 5                 (0 < Alpha <=50)  *'
            /'*      [/Beta]= Beta  risk(%); by default: 20 15 10          (0 < Beta  <=50)  *'
            /'* ***Parameters for POWER computations-----------------------------------------*'
            /'*     [/Alpha]= Alpha risk(%); by default: 5                 (0 < Alpha <=50)  *'
            /'*          /N = Sample Size (by group)                       (N integer > 0)   *'
            /'*                                                                              *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements   *'
            /'* (1) Common variance (pooled estimated from 2 samples):                       *'
            /'*     VAR = [(n0-1)*Var0 + (n1-1)*Var1]/(n0+n1-2)                              *'
            /'*                                                                              *'
            /'* Samples of calls:                                                            *'
            /'*  !NSize Type=C2ME /HELP.                                                     *'
            /'*  !NSize Type=C2ME /SD=10 /EQLIM=6.                                           *'
            /'*  !NSize Type=C2ME /Var=100 /EQLIM=6 /Alpha=5 /Beta=20.                       *'
            /'*  !NSize Type=C2ME /SD=100 /EQLIM=6 /Alpha=5 /N=60 /NST="Name of the Study".  *'
            /'********************************************************************************'.
   !IFEND.
   !IF (!Type='CI1P') !THEN.
      PRINT /'********************************************************************************'
            /'* SAMPLE SIZE: Estimation of population proportion                             *'
            /'* Last revised ' !VERSION                                                     '*'80
            /'* (c) JM.Domenech & R.Granero                                                  *'
            /'* Programmer: R.Sesma                                                          *'
            /'*                                                                              *'
            /'* Macro Call ' !tested                                                        '*'80
            /'* !NSize Type = CI1P                                                           *'
            /'*          P0 = Supposed Population Proportion(%)           (0 < P0 < 100)     *'
            /'*         [/N]= Population Size;      by default: INFINITE  (N integer > ns)   *'
            /'*        [/CL]= Confidence level(%);  by default: 90 95 99  (50 <= CL < 100)   *'
            /'* ***Parameter for SAMPLE SIZE computations------------------------------------*'
            /'*       /APRE = List of CI absolute precision values(%)     (0 < P0APRE < 100)*'
            /'* ***Parameter for PRECISION of CI computations--------------------------------*'
            /'*         /ns = Sample Size                                 (ns integer > 1)   *'
            /'*                                                                              *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements   *'
            /'*                                                                              *'
            /'* Samples of calls:                                                            *'
            /'*  !NSize Type=CI1P /HELP.                                                     *'
            /'*  !NSize Type=CI1P /P0=20 /APRE=1 2 3 4 5 /NST="Name of the Study".           *'
            /'*  !NSize Type=CI1P /P0=20 /ns= 300.                                           *'
            /'*  !NSize Type=CI1P /P0=20 /APRE=2 3 4 /N=4000 /CL=99.9 .                      *'
            /'********************************************************************************'.
   !IFEND.
   !IF (!Type='CI2P') !THEN.
      PRINT /'********************************************************************************'
            /'* SAMPLE SIZE: Confidence interval of difference between two proportions       *'
            /'*              (independent samples)                                           *'
            /'* Last revised ' !VERSION                                                     '*'80
            /'* (c) JM.Domenech & R.Granero                                                  *'
            /'* Programmer: R.Sesma                                                          *'
            /'*                                                                              *'
            /'* Macro Call ' !tested                                                        '*'80
            /'* !NSize Type = CI2P                                                           *'
            /'*          P0 = Supposed proportion in Pop.0(%)             (0 < P0 < 100)     *'
            /'*         /P1 = Supposed proportion in Pop.1(%)             (0 < P1 < 100)     *'
            /'*         [/r]= Ratio N0/N1 ; by default: 1                 (r  > 0 )          *'
            /'*        [/CL]= Confidence level(%); by default: 90 95 97.5 99 (50 <= CL < 100)*'
            /'* ***Parameter for SAMPLE SIZE computations------------------------------------*'
            /'*       /APRE = List of CI absolute precision values(%)     (0 < P0APRE < 100)*'
            /'* ***Parameters for PRECISION of CI computations-------------------------------*'
            /'*         /N1 = Sample Size (Group 1)                       (N1 integer > 0)   *'
            /'*        [/N0]= Sample Size (Group 0);  by default: r*N1    (N0 integer > 0)   *'
            /'*                                                                              *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements   *'
            /'*                                                                              *'
            /'* Samples of calls:                                                            *'
            /'*  !NSize Type=CI2P /HELP.                                                     *'
            /'*  !NSize Type=CI2P /P0=40 /P1=32 /APRE=5 /NST="Name of the Study".            *'
            /'*  !NSize Type=CI2P /P0=40 /P1=32 /APRE=2.5 3 4 5 6 /r=2 /CL=99.9.             *'
            /'*  !NSize Type=CI2P /P0=40 /P1=32 /N1=175.                                     *'
            /'********************************************************************************'.
   !IFEND.
   !IF (!Type='CI1M') !THEN.
      PRINT /'********************************************************************************'
            /'* SAMPLE SIZE: Estimation of population mean                                   *'
            /'* Last revised ' !VERSION                                                     '*'80
            /'* (c) JM.Domenech & R.Granero                                                  *'
            /'* Programmer: R.Sesma                                                          *'
            /'*                                                                              *'
            /'* Macro Call ' !tested                                                        '*'80
            /'* !NSize Type = CI1M                                                           *'
            /'*         {SD = Supposed Standard Deviation                 (SD > 0)           *'
            /'*     or /Var}= Supposed Variance                           (Var > 0)          *'
            /'*         [/N]= Population Size;      by default: INFINITE  (N integer > ns)   *'
            /'*        [/CL]= Confidence level(%);  by default: 90 95 99  (50 <= CL < 100)   *'
            /'* ***Parameter for SAMPLE SIZE computations------------------------------------*'
            /'*       /APRE = List of CI absolute precision values(%)     (APRE > 0)         *'
            /'* ***Parameter for PRECISION of CI computations--------------------------------*'
            /'*         /ns = Sample Size                                 (ns integer > 1)   *'
            /'*                                                                              *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements   *'
            /'*                                                                              *'
            /'* Samples of calls:                                                            *'
            /'*  !NSize Type=CI1M /HELP.                                                     *'
            /'*  !NSize Type=CI1M /SD=1.5 /APRE=0.5 0.6 0.8 1.0 /NST="Name of the Study".    *'
            /'*  !NSize Type=CI1M /Var=1 /ns=300.                                            *'
            /'*  !NSize Type=CI1M /SD=1 /APRE= 0.2 /N=4000 /CL=99.9.                         *'
            /'********************************************************************************'.
   !IFEND.
   !IF (!Type='CI2M') !THEN.
      PRINT /'********************************************************************************'
            /'* SAMPLE SIZE: Confidence interval of difference between two means             *'
            /'*              (independent samples)                                           *'
            /'* Last revised ' !VERSION                                                     '*'80
            /'* (c) JM.Domenech & R.Granero                                                  *'
            /'* Programmer: R.Sesma                                                          *'
            /'*                                                                              *'
            /'* Macro Call ' !tested                                                        '*'80
            /'* !NSize Type = CI2M                                                           *'
            /'*         {SD = Supposed Standard Deviation                 (SD > 0)           *'
            /'*     or /Var}= Supposed Variance                           (Var > 0)          *'
            /'*         [/r]= Ratio N0/N1 ; by default: 1                 (r  > 0 )          *'
            /'*        [/CL]= Confidence level(%);  by default: 90 95 99  (50 <= CL < 100)   *'
            /'* ***Parameter for SAMPLE SIZE computations------------------------------------*'
            /'*       /APRE = List of CI absolute precision values(%)     (APRE > 0)         *'
            /'* ***Parameter for PRECISION of CI computations--------------------------------*'
            /'*         /N1 = Sample Size (Group 1)                       (N1 integer > 0)   *'
            /'*        [/N0]= Sample Size (Group 0);  by default: r*N1    (N0 integer > 0)   *'
            /'*                                                                              *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements   *'
            /'*                                                                              *'
            /'* Samples of calls:                                                            *'
            /'*  !NSize Type=CI2M /HELP.                                                     *'
            /'*  !NSize Type=CI2M /APRE=10 2 3 /SD=10 /NST="Name of the Study".              *'
            /'*  !NSize Type=CI2M /APRE=20 /Var=5625 /r=2 /CL=99.9.                          *'
            /'*  !NSize Type=CI2M /SD=75 /N1=175 /N0=240.                                    *'
            /'*  !NSize Type=CI2M /SD=5625 /N1=175 /CL=90.                                   *'
            /'********************************************************************************'.
   !IFEND.
   !IF (!Type='CO1C') !THEN.
      PRINT /'********************************************************************************'
            /'* SAMPLE SIZE: One correlation coefficient                                     *'
            /'* Last revised ' !VERSION                                                     '*'80
            /'* (c) JM.Domenech & R.Granero                                                  *'
            /'* Programmer: R.Sesma                                                          *'
            /'*                                                                              *'
            /'* Macro Call ' !tested                                                        '*'80
            /'* !NSize Type = Co1C                                                           *'
            /'*           R = Correlation in a reference population         (-1 < R  < 1)    *'
            /'*        {/R1 = Correlation in a sample                       (-1 < R1 < 1)    *'
            /'*  or /Effect}= Minimum expected effect size            (Effect = R1-R < 1)    *'
            /'* ***Parameter for SAMPLE SIZE computations------------------------------------*'
            /'*     [/Alpha]= Alpha risk(%); by default: 5               (0 < Alpha <=50)    *'
            /'*      [/Beta]= Beta  risk(%); by default: 20 15 10        (0 < Beta  <=50)    *'
            /'* ***Parameters for POWER computations-----------------------------------------*'
            /'*     [/Alpha]= Alpha risk(%); by default: 5               (0 < Alpha <=50)    *'
            /'*         /N1 = Size of sample 1                           (N1 integer > 3)    *'
            /'*                                                                              *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements   *'
            /'*                                                                              *'
            /'* Samples of calls:                                                            *'
            /'*  !NSize Type=Co1C /HELP.                                                     *'
            /'*  !NSize Type=Co1C /R=0 /R1=0.25 /NST="Name of the Study".                    *'
            /'*  !NSize Type=Co1C /R=0 /Effect=-0.25 /Alpha=5 /Beta=20.                      *'
            /'*  !NSize Type=Co1C /R=0.32 /R1=0.47 /N1=100 /Alpha=5.                         *'
            /'********************************************************************************'.
   !IFEND.
   !IF (!Type='CO2C') !THEN.
      PRINT /'********************************************************************************'
            /'* SAMPLE SIZE: Two correlation coefficients                                    *'
            /'* Last revised ' !VERSION                                                     '*'80
            /'* (c) JM.Domenech & R.Granero                                                  *'
            /'* Programmer: R.Sesma                                                          *'
            /'*                                                                              *'
            /'* Macro Call ' !tested                                                        '*'80
            /'* !NSize Type = Co2C                                                           *'
            /'*          R0 = Correlation in a sample 0                     (-1 < R0 < 1)    *'
            /'*        {/R1 = Correlation in a sample 1                     (-1 < R1 < 1)    *'
            /'*  or /Effect}= Minimum expected effect size          (Effect = R1-R0  < 1)    *'
            /'* ***Parameter for SAMPLE SIZE computations------------------------------------*'
            /'*     [/Alpha]= Alpha risk(%); by default: 5               (0 < Alpha <=50)    *'
            /'*      [/Beta]= Beta  risk(%); by default: 20 15 10        (0 < Beta  <=50)    *'
            /'* ***Parameters for POWER computations-----------------------------------------*'
            /'*     [/Alpha]= Alpha risk(%); by default: 5               (0 < Alpha <=50)    *'
            /'*         /N1 = Size of sample 1                           (N1 integer > 3)    *'
            /'*         /N0 = Size of sample 0                           (N0 integer > 3)    *'
            /'*                                                                              *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements   *'
            /'*                                                                              *'
            /'* Samples of calls:                                                            *'
            /'*  !NSize Type=Co2C /HELP.                                                     *'
            /'*  !NSize Type=Co2C /R0=0.30 /R1=0.50 /NST="Name of the Study".                *'
            /'*  !NSize Type=Co2C /R0=0 /Effect=0.25 /Alpha=5 /Beta=20.                      *'
            /'*  !NSize Type=Co2C /R0=0.32 /R1=0.47 /N1=100 /N0=80 /Alpha=5.                 *'
            /'********************************************************************************'.
   !IFEND.
   !IF (!Type='COKM') !THEN.
      PRINT /'********************************************************************************'
            /'* SAMPLE SIZE (MEAN) & POWER: k-independents samples (ANOVA)                   *'
            /'* Last revised ' !VERSION                                                     '*'80
            /'* (c) JM.Domenech & R.Granero                                                  *'
            /'* Programmer: R.Sesma                                                          *'
            /'*                                                                              *'
            /'* Macro Call ' !tested                                                        '*'80
            /'* !NSize Type = CokM                                                           *'
            /'*        {Var = Common variance estimated                   (Var > 0)          *'
            /'*      or /SD}= Common standard deviation estimated         (SD > 0)           *'
            /'* ***Parameters for k SIMULTANEOUS comparisons --------------------------------*'
            /'*      /Means = List of hypothetical means                                     *'
            /'*               For sample size results, the maximum number of groups is k=12  *'
            /'* ***Parameters for c PAIRWISE comparisons ------------------------------------*'
            /'*     /Effect = Minimum expected effect size                (Effect <> 0)      *'
            /'*          /c = Number of pairwise comparisons  (Integer > 0; c <= k(k-1)/2))  *'
            /'* ***Parameters for POWER computations ----------------------------------------*'
            /'*          /N = Sample size (by group)                      (N integer > 1)    *'
            /'*               If parameter N is present, Power results are calculated        *'
            /'*                                                                              *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements   *'
            /'*                                                                              *'
            /'* Samples of calls:                                                            *'
            /'*  !NSize Type=CokM /HELP.                                                     *'
            /'*  !NSize Type=CokM /SD=3.5 /Means= 8.25 11.75 12.00 13.00 /NST="Study Name".  *'
            /'*  !NSize Type=CokM /Means=  8  8  9 12                                        *'
            /'*                       /N= 10 10 10 20 /Var=12.25 .                           *'
            /'*  !NSize Type=CokM /SD=10 /Effect=6 /c=3.                                     *'
            /'*  !NSize Type=CokM /Var=100 /Effect=6 /c=3 /N=50.                             *'
            /'********************************************************************************'.
   !IFEND.
   !IF (!Type='C2PP') !THEN.
      PRINT /'********************************************************************************'
            /'* SAMPLE SIZE & POWER: Two paired proportions                                  *'
            /'* Last revised ' !VERSION                                                     '*'80
            /'* (c) JM.Domenech & R.Granero                                                  *'
            /'* Programmer: R.Sesma                                                          *'
            /'*                                                                              *'
            /'* Macro Call ' !tested                                                        '*'80
            /'* !NSize Type = C2PP                                                           *'
            /'*        /ODR = Expected Odds Ratio (Change)               (ODR > 1)           *'
            /'*       [{/Pd = Proportion of Discordant pairs(%)          (0 < Pd < 100)      *'
            /'*      or /P0 = Proportion in the Reference group(%)       (0 < P0 < 100)      *'
            /'*   and /ORa}]= Marginal Odds Ratio (Association)          (ORa > 1)           *'
            /'*         [/r]= Paired Ratio;  by default: 1               (r integer >= 1)    *'
            /'* ***Parameter for SAMPLE SIZE computations------------------------------------*'
            /'*     [/Alpha]= Alpha risk(%); by default: 5               (0 < Alpha < 50)    *'
            /'*      [/Beta]= Beta  risk(%); by default: 20 15 10        (0 < Beta  < 50)    *'
            /'* ***Parameters for POWER computations-----------------------------------------*'
            /'*     [/Alpha]= Alpha risk(%); by default: 5               (0 < Alpha < 50)    *'
            /'*          /N = Sample Size (Total number of pairs)        (N integer > 1)     *'
            /'*               or number of cases (for 1:r Matched Case-Control Study)        *'
            /'*                                                                              *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements   *'
            /'*                                                                              *'
            /'* Samples of calls:                                                            *'
            /'*  !NSize Type=C2PP /HELP.                                                     *'
            /'*  !NSize Type=C2PP /ODR=2.0 /r=1 /NST="Name of the Study".                    *'
            /'*  !NSize Type=C2PP /ODR=2.0 /Pd=30.5 /r=1 /Alpha=5 /Beta=10.                  *'
            /'*  !NSize Type=C2PP /ODR=2.5 /P0=42.8 /ORa=3.0 /r=2.                           *'
            /'*  !NSize Type=C2PP /ODR=2.3 /Pd=26.2 /r=1 /N=216 /ALPHA=5.                    *'
            /'********************************************************************************'.
   !IFEND.
   !IF (!Type='CO2R') !THEN.
      PRINT /'********************************************************************************'
            /'* SAMPLE SIZE (RISK) & POWER: Two independent samples                          *'
            /'* Last revised ' !VERSION                                                     '*'80
            /'* (c) JM.Domenech & R.Granero                                                  *'
            /'* Programmer: R.Sesma                                                          *'
            /'*                                                                              *'
            /'* Macro Call ' !tested                                                        '*'80
            /'* !NSize Type = Co2R                                                           *'
            /'*          [r]= Ratio N0/N1  (by default: 1)                   (r > 0 )        *'
            /'* ***Parameters for COHORT Risk studies----------------------------------------*'
            /'*          R0 = Event risk in UnExposed(%)                     (0 < R0 < 100)  *'
            /'*        {/R1 = Event risk in Exposed(%)                       (0 < R1 < 100)  *'
            /'*     or  /RR = Expected Risk Ratio                            (RR > 0 )       *'
            /'*     or  /RD = Expected Risk Difference                       (RD <> 0)       *'
            /'*     or /ODR}= Expected Odds Ratio                            (ODR > 0 )      *'
            /'* ***Parameters for CASE-CONTROL studies---------------------------------------*'
            /'*         PE0 = Proportion of exposed in NonCases(%)           (0 < PE0 < 100) *'
            /'*       {/PE1 = Proportion of exposed in Cases(%)              (0 < PE1 < 100) *'
            /'*     or /ODR}= Expected Odds Ratio                            (ODR > 0 )      *'
            /'* ***Parameters for SAMPLE SIZE computations-----------------------------------*'
            /'*     [/Alpha]= Alpha risk(%); by default: 5                   (0< Alpha <=50) *'
            /'*      [/Beta]= Beta  risk(%); by default: 20 15 10            (0< Beta  <=50) *'
            /'* ***Parameters for POWER computations-----------------------------------------*'
            /'*     [/Alpha]= Alpha risk(%); by default: 5                   (0< Alpha <=50) *'
            /'*         /N0 = Sample Size in group 0                         (N0 integer >1) *'
            /'*         /N1 = Sample Size in group 1                         (N1 integer >1) *'
            /'*              {or /N0 and /r} , {or /N1 and /r}                               *'
            /'*                                                                              *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements   *'
            /'*                                                                              *'
            /'* Samples of calls:                                                            *'
            /'*  !NSize Type=Co2R /HELP.                                                     *'
            /'*  !NSize Type=Co2R /R0=30 /RD=10 /NST="Name of the Study".                    *'
            /'*  !NSize Type=Co2R /PE0=25 /ODR=2.5 /r=2.                                     *'
            /'*  !NSize Type=Co2R /R0=4 /RR=2 /r=5.67 /ALPHA=5 /BETA=15.                     *'
            /'*  !NSize Type=Co2R /R0=4 /RR=2 /r=5.67 /N1=363 /ALPHA=5.                      *'
            /'*  !NSize Type=Co2R /R0=4 /RR=2 /N0=2059 /N1=363 /ALPHA=5.                     *'
            /'********************************************************************************'.
   !IFEND.
   !IF (!Type='CO2I') !THEN.
      PRINT /'********************************************************************************'
            /'* SAMPLE SIZE (RATE) & POWER: Two independent samples                          *'
            /'* Last revised ' !VERSION                                                     '*'80
            /'* (c) JM.Domenech & R.Granero                                                  *'
            /'* Programmer: R.Sesma                                                          *'
            /'*                                                                              *'
            /'* Macro Call ' !tested                                                        '*'80
            /'* !NSize Type = Co2I                                                           *'
            /'*          I0 = Event risk in UnExposed                        (I0 > 0)        *'
            /'*        {/I1 = Event risk in Exposed                          (I1 > 0)        *'
            /'*      or /IR = Expected Risk Ratio                            (IR > 0)        *'
            /'*      or /ID}= Expected Risk Difference                       (ID<> 0)        *'
            /'*          [r]= Ratio n0/n1  (by default: 1)                   (r  > 0)        *'
            /'*          /D = Mean duration of Follow up                     (D  > 0)        *'
            /'* ***Parameters for SAMPLE SIZE computations-----------------------------------*'
            /'*     [/Alpha]= Alpha risk(%); by default: 5                   (0< Alpha <=50) *'
            /'*      [/Beta]= Beta  risk(%); by default: 20 15 10            (0< Beta  <=50) *'
            /'* ***Parameters for POWER computations-----------------------------------------*'
            /'*     [/Alpha]= Alpha risk(%); by default: 5                   (0< Alpha <=50) *'
            /'*         /N0 = Sample Size in group 0                         (N0 integer >1) *'
            /'*         /N1 = Sample Size in group 1                         (N1 integer >1) *'
            /'*              {or /N0 and /r} , {or /N1 and /r}                               *'
            /'*                                                                              *'
            /'* Note: Parameters enclosed in Square Brackets [ ] are optional                *'
            /'*       Parameters enclosed in Braces { } indicate a choice between elements   *'
            /'*                                                                              *'
            /'* Samples of calls:                                                            *'
            /'*  !NSize Type=Co2I /HELP.                                                     *'
            /'*  !NSize Type=Co2I /I0=0.30 /ID=0.10 /D=2 /NST="Study Name".                  *'
            /'*  !NSize Type=Co2I /I0=0.30 /ID=0.10 /D=2 /r=2.                               *'
            /'*  !NSize Type=Co2I /I0=0.4  /IR=2 /D=2 /r=3 /ALPHA=5 /BETA=15.                *'
            /'*  !NSize Type=Co2I /I0=0.4  /IR=2 /D=2 /N0=69 /N1=23 /ALPHA=5.                *'
            /'********************************************************************************'.
   !IFEND.
!ENDDEFINE.
